<?php
include_once( __DIR__ . "/library.php" );

$_POST["file"] = isset( $_POST["file"] ) ? $_POST["file"] : '';

if ( isset( $_GET['set_lang'] ) ) {
	if ( ! isset( $_POST['lang'] ) ) {
		echo 'Language can\'t set';
	} else {
		$response = $Trans->set_language( $_POST['lang'] );
		if ( $response === false ) {
			echo 'Language can\'t set';
		} else {
			echo 'OK';
		}
	}

	exit();
}

header( "Content-Type: application/json" );

if ( ! \Admins\UserInfo::is_loggedin() ) {
	echo json_encode( [ "status" => "You'r not authorized!" ] );
	exit;
}
if ( isset( $_GET["user_info"] ) ) {
	$row                    = \Admins\UserInfo::get_admin();
	$row["photo_url"]       = \Admins\UserInfo::get_photo_url( 0, 30 );
	$row["message_counter"] = \Messages::count_messages_static( "viewed=0" );

	$M                     = new \Messages();
	$messages              = $M->get_messages( "page=1&pagesize=5" );
	$row["messages"]       = $messages;
	$row["count_not_paid"] = \Fee\Fee::count_not_paid();
	$row["is_loggedin"]    = \Admins\UserInfo::is_loggedin();

	$SidebarArray[0] = [
		"icon"   => "home-white.svg",
		"label"  => __( "Dashboard" ),
		"href"   => DOMAIN_URL,
		"active" => "index",
	];
	/*if ( \Admins\UserInfo::is_allowed( "datesheet" ) ) {
		$SidebarArray[5] = [
			"icon"   => "fa fa-newspaper-o",
			"label"  => __( "Datesheet / Schedule" ),
			"href"   => $url->get_url( "datesheet" ),
			"active" => "datesheet",
		];
	}*/

	if ( \Admins\UserInfo::is_allowed( "time_table" ) ) {
		$SidebarArray[10] = [
			"icon"   => "time-table.svg",
			"label"  => __( "Time Table" ),
			"href"   => "",
			"active" => "#",
		];
		/*$SidebarArray[10]["subs"][] = [
			"icon"   => "fa fa-plus",
			"label"  => __( "Add Schedule" ),
			"href"   => $url->get_url( "add_weekly_schedule" ),
			"active" => "add_weekly_schedule",
		];*/
		$SidebarArray[10]["subs"][] = [
			"icon"   => "fa fa-clock-o",
			"label"  => __( "Time Table" ),
			"href"   => "time_table.php",
			"active" => "time_table",
		];
	}

	if ( \Admins\UserInfo::is_allowed( "new_admission" ) ) {
		$SidebarArray[14] = [
			"icon"   => "add-green.svg",
			"label"  => __( "Admission" ),
			"href"   => "admission.php",
			"active" => "admission",
		];
	}
	if ( \Admins\UserInfo::is_allowed( "manage_student_attendance" ) ) {
		$SidebarArray[15]           = [
			"icon"   => "finger-print.svg",
			"label"  => __( "Attendance" ),
			"href"   => "attendance.php",
			"active" => "#",
		];
		$SidebarArray[15]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Attendance Register" ),
			"href"   => "attendance.php",
			"active" => "attendance",
		];
		$SidebarArray[15]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Attendance Report" ),
			"href"   => "report_attendance.php",
			"active" => "report_attendance",
		];
		$SidebarArray[15]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Attendance Sheet" ),
			"href"   => "report_attendance_sheet.php",
			"active" => "report_attendance_sheet",
		];
	}

	$cfd          = \Fee::count_fee_defaulters_static();
	$counter_span = "";
	if ( $cfd > 0 ) {
		$counter_span1 = '<span id="sidebar_defaulters_fee_span1" class="badge badge-warning badge-roundless">' . $cfd . '</span>';
	}
	if ( \Admins\UserInfo::is_allowed( "fee_module" ) ) {
		$SidebarArray[20] = [
			"icon"         => "fee.svg",
			"label"        => __( "Fee" ),
			"href"         => "fee.php",
			"active"       => "#",
			"counter_span" => ( empty( $counter_span1 ) ? "" : $counter_span1 ),
		];

		$cf           = \Fee::count_not_paid_static();
		$counter_span = "";
		if ( $cf > 0 ) {
			$counter_span = '<span id="sidebar_collect_fee_span" class="badge badge-info badge-roundless">' . $cf . '</span>';
		}
		$SidebarArray[20]["subs"][] = [
			"icon"         => "",
			"label"        => __( "Collect/Generate Fee" ),
			"href"         => "collect_fee.php",
			"active"       => "collect_fee",
			"counter_span" => ( empty( $counter_span ) ? "" : $counter_span ),
		];
		$SidebarArray[20]["subs"][] = [
			"icon"         => "",
			"label"        => __( "Fee Defaulters" ),
			"href"         => "fee_defaulters.php",
			"active"       => "fee_defaulters",
			"counter_span" => ( empty( $counter_span1 ) ? "" : $counter_span1 ),
		];
		$SidebarArray[20]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Paid Fee" ),
			"href"   => "paid_fee.php",
			"active" => "paid_fee",
		];
		$SidebarArray[20]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Fee Defaulters Report" ),
			"href"   => "report_students_defaulters.php",
			"active" => "report_students_defaulters",
		];
	}

	if ( \Admins\UserInfo::is_allowed( "allow_students" ) ) {
		$SidebarArray[25]           = [
			"icon"   => "students2.svg",
			"label"  => __( "Students" ),
			"href"   => "students.php",
			"active" => "#",
		];
		$SidebarArray[25]["subs"][] = [
			"icon"   => "fa fa-users",
			"label"  => __( "All Students" ),
			"href"   => "students.php",
			"active" => "students",
		];
		$SidebarArray[25]["subs"][] = [
			"icon"   => "fa fa-plus",
			"label"  => __( "Add New" ),
			"href"   => "admission.php",
			"active" => "admission",
		];
		$cfd                        = $db->get_var( "SELECT COUNT(*) FROM `students` WHERE `deleted`=1" );
		$counter_span               = "";
		if ( $cfd > 0 ) {
			$counter_span = '<span id="sidebar_collect_fee_span" class="badge badge-info badge-roundless">' . $cf . '</span>';
		}
		$SidebarArray[25]["subs"][] = [
			"icon"         => "fa fa-user-times",
			"label"        => __( "Deleted Students" ),
			"href"         => "deleted_students.php",
			"active"       => "deleted_students",
			"counter_span" => ( empty( $counter_span ) ? "" : $counter_span ),
		];
		$AdmissionRequests          = new \Student\AdmissionRequests();
		$cfd                        = $AdmissionRequests->count_pending_requests();
		if ( $cfd > 0 ) {
			$counter_span = '<span class="badge badge-error">' . $AdmissionRequests->count_pending_requests() . '</span>';
		} else {
			$counter_span = '';
		}
		$SidebarArray[25]["subs"][] = [
			"label"        => __( "Admission Requests" ),
			"href"         => "admission_requests.php",
			"active"       => "admission_requests",
			"counter_span" => $counter_span,
		];
		$SidebarArray[25]["subs"][] = [
			"icon"   => "fa fa-external-link-square",
			"label"  => __( "Open Student Panel" ),
			"href"   => get_student_panel_url(),
			"active" => "#",
			"target" => "_blank",
		];
	}

	if ( \Admins\UserInfo::is_allowed( "allow_accounts" ) ) {
		$SidebarArray[30] = [
			"icon"   => "accounting.svg",
			"label"  => __( "Accounts" ),
			"href"   => "",
			"active" => "#",
		];
		if ( \Admins\UserInfo::is_allowed( "manage_daily_expenses" ) ) {
			$SidebarArray[30]["subs"][] = [
				"icon"   => "",
				"label"  => __( "Daily Expenses" ),
				"href"   => "accounts_daily_expenses.php",
				"active" => "accounts_daily_expenses",
			];
		}
		if ( \Admins\UserInfo::is_allowed( "manage_teacher_salary" ) ) {
			$SidebarArray[30]["subs"][] = [
				"icon"      => "",
				"label"     => __( "Teachers Salaries" ),
				"href"      => "accounts_teacher_salary.php",
				"active"    => "accounts_teacher_salary",
				"new_label" => false,
			];
		}
		$SidebarArray[30]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Student Payment Report" ),
			"href"   => "student_payment_report.php",
			"active" => "student_payment_report",
		];
		$SidebarArray[30]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Payment Report" ),
			"href"   => "payment_report.php",
			"active" => "payment_report",
		];
		if ( \Admins\UserInfo::is_allowed( "view_account_transactions" ) ) {
			$SidebarArray[30]["subs"][] = [
				"icon"   => "",
				"label"  => __( "View Transactions" ),
				"href"   => "accounts_transactions.php",
				"active" => "accounts_transactions",
			];
		}
		$SidebarArray[30]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Cash Report" ),
			"href"   => "report_cash.php",
			"active" => "report_cash",
		];
		$SidebarArray[30]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Expense Report" ),
			"href"   => "report_expense.php",
			"active" => "report_expense",
		];
	}

	if ( \Admins\UserInfo::is_allowed( "allow_examination" ) ) {
		$SidebarArray[35] = [
			"icon"   => "exams3.svg",
			"label"  => __( "Examination" ),
			"href"   => "",
			"active" => "#",
		];
		/*$SidebarArray[35]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Add Schedule" ),
			"href"   => "add_schedule.php" ,
			"active" => "add_schedule",
		];*/
		$SidebarArray[35]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Test Schedules" ),
			"href"   => "test_schedules.php",
			"active" => "test_schedules",
		];
	}

	if ( \Admins\UserInfo::is_allowed( "allow_reports" ) ) {
		$SidebarArray[40]           = [
			"icon"   => "statistics.svg",
			"label"  => __( "Reports" ),
			"href"   => "#",
			"active" => "",
		];
		$SidebarArray[40]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Student Reports" ),
			"href"   => "#",
			"active" => "",
			"subs"   => [
				[
					"icon"   => "",
					"label"  => __( "Weekly" ),
					"href"   => "student_weekly_report.php",
					"active" => "student_weekly_report",
				],
				[
					"icon"   => "",
					"label"  => __( "Progress" ),
					"href"   => "student_progress_report.php",
					"active" => "student_progress_report",
				],
				[
					"icon"   => "",
					"label"  => __( "Student List" ),
					"href"   => "report_students_list.php",
					"active" => "report_students_list",
				],
			],
		];
		$SidebarArray[40]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Class Reports" ),
			"href"   => "",
			"active" => "",
			"subs"   => [
				[
					"icon"   => "",
					"label"  => __( "Toppers Report" ),
					"href"   => "toppers_report.php",
					"active" => "toppers_report",
				],
				[
					"icon"   => "",
					"label"  => __( "Weekly Evaluation" ),
					"href"   => "weekly_evaluation_report.php",
					"active" => "weekly_evaluation_report",
				],
			],
		];
		$SidebarArray[40]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Teacher Reports" ),
			"href"   => "",
			"active" => "",
			"subs"   => [
				[
					"icon"   => "",
					"label"  => __( "Teacher Evaluation" ),
					"href"   => "monthly_evaluation_report.php",
					"active" => "monthly_evaluation_report",
				],
			],
		];
	}

	if ( \Admins\UserInfo::is_allowed( "manage_teachers" ) || \Admins\UserInfo::is_allowed( "manage_employees" ) ) {
		$SidebarArray[45]           = [
			"icon"   => "employees2.svg",
			"label"  => __( "Employees" ),
			"href"   => "",
			"active" => "#",
		];
		$SidebarArray[45]["subs"][] = [
			"icon"   => "icon icon-users",
			"label"  => __( "All Teachers" ),
			"href"   => "teachers.php",
			"active" => "teachers",
		];
		$SidebarArray[45]["subs"][] = [
			"icon"   => "fa fa-external-link-square",
			"label"  => __( "Open Teacher Panel" ),
			"href"   => get_teacher_panel_url(),
			"target" => "_blank",
		];
		$SidebarArray[45]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Other Employees" ),
			"href"   => "#",
			"active" => "",
			"subs"   => [
				[
					"icon"   => "fa fa-user-plus",
					"label"  => __( "Add Employee" ),
					"href"   => "otheremployees.php",
					"active" => "otheremployees",
				],
			],
		];
		$SidebarArray[45]["subs"][] = [
			"icon"   => "",
			"label"  => __( "All Employees" ),
			"href"   => "allemployees.php",
			"active" => "allemployees",
		];
	}

	if ( \Admins\UserInfo::is_allowed( "allow_cource_material" ) ) {
		$SidebarArray[50]           = [
			"icon"   => "ebook.svg",
			"label"  => __( "Course Material" ),
			"href"   => "",
			"active" => "#",
		];
		$SidebarArray[50]["subs"][] = [
			"icon"   => "fa fa-plus",
			"label"  => __( "Add Course" ),
			"href"   => "course_material_list.php?add",
			"active" => "",
		];
		$SidebarArray[50]["subs"][] = [
			"icon"   => "",
			"label"  => __( "All Courses" ),
			"href"   => "course_material_list.php",
			"active" => "course_material_list",
		];
	}

	if ( \Admins\UserInfo::is_allowed( "allow_library" ) ) {
		$SidebarArray[52] = [
			"icon"      => "books.svg",
			"label"     => __( "Library" ),
			"href"      => "",
			"new_label" => true,
			"active"    => "",
		];
		if ( \Admins\UserInfo::is_allowed( "manage_library" ) ) {
			$SidebarArray[52]["subs"][] = [
				"icon"   => "",
				"label"  => __( "Manage Library" ),
				"href"   => "library_books.php",
				"active" => "library_books",
			];
		}
		if ( \Admins\UserInfo::is_allowed( "library_assign_books" ) ) {
			$SidebarArray[52]["subs"][] = [
				"icon"   => "",
				"label"  => __( "Issued Books" ),
				"href"   => "library_assign_books.php",
				"active" => "library_assign_books",
			];
		}
	}

	if ( \Admins\UserInfo::is_allowed( "allow_users" ) ) {
		$SidebarArray[55]           = [
			"icon"   => "users.svg",
			"label"  => __( "Users" ),
			"href"   => "",
			"active" => "#",
		];
		$SidebarArray[55]["subs"][] = [
			"icon"   => "fa fa-users",
			"label"  => __( "All Users" ),
			"href"   => "admins.php",
			"active" => "admins",
		];
		$SidebarArray[55]["subs"][] = [
			"icon"   => "fa fa-user-plus",
			"label"  => __( "Add New" ),
			"href"   => "admin.php",
			"active" => "admin",
		];
	}

	if ( \Admins\UserInfo::is_allowed( "allow_parents" ) ) {
		$SidebarArray[60]           = [
			"icon"   => "family.svg",
			"label"  => __( "Parents/Guardians" ),
			"href"   => "",
			"active" => "#",
		];
		$SidebarArray[60]["subs"][] = [
			"icon"   => "fa fa-user-circle",
			"label"  => __( "All Parents/Guardians" ),
			"href"   => "parents.php",
			"active" => "parents",
		];
		$SidebarArray[60]["subs"][] = [
			"icon"   => "fa fa-external-link-square",
			"label"  => __( "Open Guardian Panel" ),
			"href"   => get_guardian_panel_url(),
			"target" => "_blank",
		];
	}

	if ( \Admins\UserInfo::is_allowed( "administrator" ) ) {
		$SidebarArray[65]           = [
			"icon"   => "tools.svg",
			"label"  => __( "Tools" ),
			"href"   => "",
			"active" => "",
		];
		$SidebarArray[65]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Import" ),
			"href"   => "",
			"active" => "",
			"subs"   => [
				[
					"icon"   => "",
					"label"  => __( "Students" ),
					"href"   => "data_import_students.php",
					"active" => "data_import_students",
				],
			],
		];
		$SidebarArray[65]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Export" ),
			"href"   => "",
			"active" => "",
			"subs"   => [
				[
					"icon"   => "",
					"label"  => __( "Students" ),
					"href"   => "data_export_students.php",
					"active" => "data_export_students",
				],
				[
					"icon"   => "",
					"label"  => __( "Classes" ),
					"href"   => "data_export_classes.php",
					"active" => "data_export_classes",
				],
				[
					"icon"   => "",
					"label"  => __( "Translations" ),
					"href"   => "data_export_translations.php",
					"active" => "data_export_translations",
				],
			],
		];

		$SidebarArray[70]           = [
			"icon"   => "settings.svg",
			"label"  => __( "Settings" ),
			"href"   => "",
			"active" => "",
		];
		$SidebarArray[70]["subs"][] = [
			"icon"   => "",
			"label"  => __( "General" ),
			"href"   => "app_settings.php",
			"active" => "app_settings",
		];
		$SidebarArray[70]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Batches/Years/Session" ),
			"href"   => "batches.php",
			"active" => "batches",
		];
		$SidebarArray[70]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Subjects" ),
			"href"   => "subjects.php",
			"active" => "subjects",
		];
		$SidebarArray[70]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Classes" ),
			"href"   => "classes.php",
			"active" => "classes",
		];
		/*$SidebarArray[70]["subs"][] = [
			"icon"   => "",
			"label"  => __( "History" ),
			"href"   => "history.php",
			"active" => "history",
		];*/
		$SidebarArray[70]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Accounts" ),
			"href"   => "settings_accounts.php",
			"active" => "settings_accounts",
		];
		$SidebarArray[70]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Fee" ),
			"href"   => "fee_settings.php",
			"active" => "fee_settings",
		];
		$SidebarArray[70]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Fine" ),
			"href"   => "fine.php",
			"active" => "fine",
		];
		$SidebarArray[70]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Calendar" ),
			"href"   => "cal_settings.php",
			"active" => "cal_settings",
		];
		$SidebarArray[70]["subs"][] = [
			"icon"   => "",
			"label"  => __( "SMS" ),
			"href"   => "settings_sms.php",
			"active" => "settings_sms",
		];
		$SidebarArray[70]["subs"][] = [
			"icon"   => "",
			"label"  => __( "PDF" ),
			"href"   => "settings_pdf.php",
			"active" => "settings_pdf",
		];
		$SidebarArray[70]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Custom Style" ),
			"href"   => "custom_style.php",
			"active" => "custom_style",
		];
		$SidebarArray[70]["subs"][] = [
			"icon"   => "",
			"label"  => __( "Translations" ),
			"href"   => "translations.php",
			"active" => "translations",
		];
	}

	$SidebarArray[75]           = [
		"icon"   => "fa fa-question-circle",
		"label"  => __( "Help" ),
		"href"   => "",
		"active" => "",
	];
	$SidebarArray[75]["subs"][] = [
		"icon"   => "",
		"label"  => __( "How to Start?" ),
		"href"   => "http://docs.fekara.com",
		"active" => "",
		"target" => "_blank",
	];
	$SidebarArray[75]["subs"][] = [
		"icon"   => "",
		"label"  => __( "Report a bug" ),
		"href"   => "report_a_bug.php",
		"active" => "report_a_bug",
	];
	$SidebarArray[75]["subs"][] = [
		"icon"   => "",
		"label"  => __( "What's New?" ),
		"href"   => "whats_new.php",
		"active" => "whats_new",
	];

	$row["sidebar"]["menu"]     = $SidebarArray;
	$row["sidebar"]["filename"] = $_POST["file"];

	echo json_encode( $row );
	exit;
}
if ( isset( $_GET["error_notification"] ) ) {
	header( 'Content-Type: text/event-stream' );
	header( 'Cache-Control: no-cache' );
	if ( ! \General::localhost() ) {
		echo "data: No Error\n\n";
		flush();
		die;
	}
	if ( ! is_file( ROOT_PATH . "errors.txt" ) ) {
		echo "data: No Error\n\n";
		flush();
		die;
	}
	if ( filesize( ROOT_PATH . "errors.txt" ) == 0 ) {
		echo "data: No Error\n\n";
		flush();
		die;
	}
	$last_error_hash = $db->get_option( "admin_error_hash" );
	if ( is_file( ROOT_PATH . "errors.txt" ) && md5_file( ROOT_PATH . "errors.txt" ) <> $last_error_hash ) {
		$db->set_option( "admin_error_hash", md5_file( ROOT_PATH . "errors.txt" ) );
		echo "data: OK\n\n";
		flush();
	} else {
		echo "data: No Error\n\n";
		flush();
	}
	die;
}
if ( isset( $_GET["logs_notification"] ) ) {
	header( 'Content-Type: text/event-stream' );
	header( 'Cache-Control: no-cache' );
	if ( ! \General::localhost() ) {
		echo "data: No Error\n\n";
		flush();
		die;
	}
	if ( ! is_file( ROOT_PATH . "logs.txt" ) ) {
		echo "data: No Error\n\n";
		flush();
		die;
	}
	if ( filesize( ROOT_PATH . "logs.txt" ) == 0 ) {
		echo "data: No Error\n\n";
		flush();
		die;
	}
	$last_hash = $db->get_option( "admin_logs_hash" );
	if ( md5_file( ROOT_PATH . "logs.txt" ) <> $last_hash ) {
		$db->set_option( "admin_logs_hash", md5_file( ROOT_PATH . "logs.txt" ) );
		echo "data: OK\n\n";
		flush();
	} else {
		echo "data: No Error\n\n";
		flush();
	}
	die;
}