<?php
include_once( __DIR__ . "/../library.php" );
if ( ! \Admins\UserInfo::is_loggedin() ) {
	echo "You'r not authorized.";
	exit;
}

extract( $_POST );
$Fee = new Fee();

if ( isset( $_GET['load_data'] ) ) {
	$_POST['pagesize'] = 15;
	$rows              = $Fee->get_not_paid( "", $_POST );

	header( 'Content-Type: application/json' );
	echo json_encode( $rows );
	exit;
}

if ( isset( $_GET['del_fee'] ) ) {
	echo $Fee->delete_generated_fee( $id );
	exit;
}

if ( isset( $_GET['pay_fee'] ) ) {
	echo $Fee->pay_fee( $id, $fee_date, $receipt_number, $amount );
	exit;
}

if ( isset( $_GET['updatePiadFee'] ) ) {
	$response = $db->update( "fee_paid", [
		"fine"        => $fine,
		"amount"      => $amount,
		"description" => $description,
	], [ "id" => $id ] );
	echo $response === false ? $db->last_error : "OK";
	exit;
}

if ( isset( $_GET['getFee'] ) ) {
	if ( ! isset( $id ) ) {
		$id = 0;
	}
	$row = $Fee->get_fee( $id );
	if ( is_array( $row ) && isset( $row["id"] ) ) {
		$row["status"]             = "OK";
		$row["last_payment_date2"] = \Dates::my_date( $row["last_payment_date"] );
	} else {
		$row["status"] = "Can't get fee data";
	}
	header( 'Content-Type: application/json' );
	echo json_encode( $row );
	exit;
}
if ( isset( $_GET['getFeeList'] ) ) {
	$Cols       = [
		"student_id",
		"",
		"amount",
		"fine",
		"due_date",
		"last_payment_date",
		"",
	];
	$Fee        = new \Fee();
	$iSortCol_0 = empty( $iSortCol_0 ) ? "0" : $iSortCol_0;
	$orderby    = $Cols[ $iSortCol_0 ];
	$sSortDir_0 = empty( $sSortDir_0 ) ? "DESC" : $sSortDir_0;
	$order      = $sSortDir_0;

	$_GET['iDisplayLength'] = isset($_GET['iDisplayLength'])?$_GET['iDisplayLength']:0;
	$_GET['iDisplayStart'] = isset($_GET['iDisplayStart'])?$_GET['iDisplayStart']:0;

	$iDisplayLength = intval( $_GET['iDisplayLength'] );
	$iDisplayStart  = intval( $_GET['iDisplayStart'] );
	if ( $iDisplayLength == 0 ) {
		$page = 1;
	} else {
		$page = ( $iDisplayStart / $iDisplayLength ) + 1;
	}

	$filter = "&";
	if ( ! empty( $from ) ) {
		$filter .= "due_date={$from},{$to}&";
	}
	if ( ! empty( $class_name ) ) {
		$filter .= "class_name={$class_name}&";
	}
	$filter = urlencode( trim( $filter, "&" ) );

	$query = "page={$page}&pagesize={$iDisplayLength}&search={$sSearch}&orderby={$orderby}&order={$order}&filter={$filter}";
	$rows  = $Fee->get_not_paid( "", $query );

	$records["aaData"] = array();
	foreach ( $rows["rows"] as $row ) {
		$row["profile_url"] = DOMAIN_URL . "student_profile?id=" . $row["student_id"];

		$buttons = "<div style='text-align:center'>";
		if ( \Admins\UserInfo::is_allowed( "pay_fee" ) ) {
			$buttons .= "<button style='width:50px' onclick='OpenInvoice({$row["id"]})' class='btn green btn-xs' title='Pay this fee'>".__("Pay")."</button>";
		}
		$buttons             .= "<button style='width:50px' onclick='Delete({$row["id"]})' class='btn red btn-xs' title='Delete this fee'>".__("Delete")."</button>";
		$buttons             .= "<button style='width:50px' onclick='Edit({$row["id"]})' class='btn blue btn-xs' title='Edit this fee'>".__("Edit")."</button>";
		$buttons             .= "<a style='width:50px' target='_blank' href='print_receipt.php?inline&id={$row["id"]}' class='btn green btn-xs' title='Print Receipt'>".__("Print")."</a>";
		$buttons             .= "</div>";
		$class_url           = DOMAIN_URL . "classes.php?batch_id=" . $row["class_id"];
		$records["aaData"][] = array(
			"R.No: {$row["roll"]}<br>
                    <a href='{$row["profile_url"]}'><b>{$row["student_name"]}</b></a><br />
                    Class: <i><a href='{$class_url}'>{$row["class_name"]} - {$row["batch_name"]}</a>",
			"<b>{$row["fee_title"]}</b><br>" . nl2br( $row["description"] ),
			round( $row["amount"], App::get_currency_decimals() ),
			round( $row["fine"], App::get_currency_decimals() ),
			$row["due_date2"],
			$row["last_payment_date2"],
			$buttons,
		);
	}

	$records["sEcho"]                = empty( $sEcho ) ? 1 : $sEcho;
	$records["iTotalRecords"]        = $rows["total_records"];
	$records["iTotalDisplayRecords"] = $rows["total_records"];

	echo json_encode( $records );
	exit;
}
if ( isset( $_GET['download_invoices'] ) ) {
	//$_GET['mysql_cols'] = 'class_name,gender,father_name,guardian_name,student_name,roll,fee_date,receipt_number,paid,fee_title,description,amount,fine,amount,id,due_date,student_id';
	$url = ASSETS_URL . 'pdf/collect_fee.php?' . http_build_query( $_GET );
	//	Urls::redirect( $url );
	//	echo $url.'<br>';
	$url = \PDF::generate_url( [ 'url' => $url, 'download' => true, 'filename' => 'Invoices' ] );
	//	echo $url.'<br>';
	Urls::redirect( $url );

	exit;
}
if ( isset( $_GET['generate_invoices'] ) ) {
	if (empty($_POST['month'])) {
		echo 'Month name missing!';
		exit;
	}
	$_POST['month'] = '01-' . $_POST['month'];
	\Fee\Invoice::generate_monthy_fee( $_POST['month'] );
	echo 'OK';
	exit;
}