<?php
if ( ! ( isset( $_SERVER['HTTP_X_REQUESTED_WITH'] ) && $_SERVER['HTTP_X_REQUESTED_WITH'] === 'XMLHttpRequest' ) ) {
	header( "HTTP/1.0 404 Not Found" );
	echo "Non ajax requests are not allowed!";
	exit();
}

include_once( __DIR__ . "/../library.php" );

if ( ! \Admins\UserInfo::is_loggedin() ) {
	echo "You'r not authorized.";
	exit;
}

$CM = new CourseMaterial();
header( "Content-Type: application/json" );

if ( isset( $_GET["del"] ) ) {
	if ( ! isset( $_POST["ids"] ) ) {
		_e( "Please select on or more course materials to delete." );
		exit;
	}
	if ( ! is_array( $_POST["ids"] ) ) {
		$_POST["ids"] = \Str::make_array( $_POST["ids"] );
	}

	$result = [];
	foreach ( $_POST["ids"] as $id ) {
		$response      = $CM->delete( $id );
		$result[ $id ] = $response;
	}

	echo json_encode( $result );
	exit;
}
if ( isset( $_GET["save"] ) ) {
	$response = $CM->save_course_material( $_POST, $_FILES );
	echo json_encode( [ "status" => $response ] );
	exit;
}
if ( isset( $_GET["get_data"] ) ) {
	$rows = $CM->get_courses();

	foreach ( $rows as &$row ) {
		$row["files"] = $CM->get_files( $row["id"] );
	}

	echo json_encode( $rows );
	exit;
}