<?php

include_once( __DIR__ . "/../../library.php" );

if ( isset( $_GET['collect_fee'] ) ) {
	$Cols = [
		"student_id",
		"",
		"amount",
		"fine",
		"due_date",
		"last_payment_date",
		"",
	];
	extract( $_GET );
	$Fee = new Fee;

	$filter = "&";
	if ( ! empty( $from ) ) {
		$filter .= "due_date={$from},{$to}&";
	}
	if ( ! empty( $class_name ) ) {
		$filter .= "class_name={$class_name}&";
	}
	$filter = urlencode( trim( $filter, "&" ) );

	if ( isset( $sorts ) && is_array( $sorts ) ) {
		$sorts = explode( ",", $sorts );

		$orderby = $Cols[ $sorts[0] ];
		$order   = $sorts[1];
	}

	$cols = 'id,student_name,description,amount,fine,due_date,last_payment_date,added_time,fee_date,student_id';
	if ( ! isset( $search ) ) {
		$search = '';
	}
	if ( ! isset( $orderby ) ) {
		$orderby = 'id';
	}
	if ( ! isset( $order ) ) {
		$order = 'DESC';
	}

	$query = "search={$search}&orderby={$orderby}&order={$order}&filter={$filter}&page=1&pagesize=99999&mysql_cols={$cols}&deleted=0";
	$rows  = $Fee->get_not_paid( "", $query );

	$Headings = [
		"{num}"              => [ 'name' => "#" ],
		"student_name"       => [ "name" => "Student" ],
		"description"        => [ "name" => "Description" ],
		"amount"             => [ "name" => "Amount" ],
		"fine"               => [ "name" => "Fine" ],
		"due_date2"          => [ "name" => "Due Date", "css" => "min-width:120px" ],
		"last_payment_date2" => [ "name" => "Last Date", "css" => "min-width:120px" ],
	];

	echo \PDF::generate_html( 'Collect Fee', $rows['rows'], $Headings );

	exit;
}

if ( isset( $_GET['download_invoices'] ) ) {
	$Fee = new \Fee();

	if ( ! empty( $_GET['date2'] ) && empty( $_GET['date1'] ) ) {
		$_GET['date1'] = $_GET['date2'];
	} else if ( ! empty( $_GET['date1'] ) && empty( $_GET['date2'] ) ) {
		$_GET['date2'] = $_GET['date1'];
	}

	$data = [];
	if ( ! empty( $_GET['date1'] ) && ! empty( $_GET['date2'] ) ) {
		$data['filter']['due_date'] = $_GET['date1'] . ',' . $_GET['date2'];
	}

	$_GET['pagesize'] = 99999;
	$rows             = \Fee\Fee::get_not_paid( $_GET );

	$title = 'Fee Invoices';
	$HTML  = '<html><head><title>' . $title . '</title>';
	$HTML  .= \PDF::pdf_head_html();
	$HTML  .= '</head><body>';

	foreach ( $rows['rows'] as $row ) {
		$HTML .= \PDF::pdf_header( $title );

		$student_rows = $Fee->get_fees( [ "student_id" => $row["student_id"] ]);

		$HTML .= '
	    <table class="table table-bordered">
	        <tr>
	            <th colspan="4">' . __( 'Payment History' ) . '</th>
	        </tr>
	        <tr>
	            <th width="25%">' . __( 'Date' ) . '</th>
	            <th width="15%">' . __( 'Amount' ) . '</th>
	            <th width="20%">' . __( 'Recpt. Num' ) . '</th>
	            <th width="40%">' . __( 'Desc.' ) . '</th>
	        </tr>';
		foreach ( $student_rows as $row1 ) {
			$HTML .= "<tr>
	            <td>" . $row1["added_time2"] . "</td>
	            <td>" . ( $row1["amount"] + $row1["fine"] ) . "</td>
	            <td>" . $row1["receipt_number"] . "</td>
	            <td>" . $row1["fee_title"] . "
	            <span style=\"color:#666666;font-size:10px\">" . nl2br( substr( $row1["description"], 0, 30 ) ) . " ...</span></td>
	        </tr>";
		}
		$HTML .= '</table><br><br><br>';

		$HTML .= "
		<table class='table table-bordered'>
			<tr>
				<td>
				" . __( "Class" ) . ": <b>" . $row["class_name"] . "</b>
				</td>
				<td align='right'>Invoice ID: {$row['id']}</td>
			</tr>
		    <tr>
		        <td>" . __( 'Name' ) . ": {$row["student_name"]} " . ( ( $row["gender"] == "F" ) ? "D/O " : "S/O " ) . ( empty( $row["father_name"] ) ? $row["guardian_name"] : $row["father_name"] ) . '
		        </td>
		        <td>Roll: ' . $row["roll"] . '
		        <span style="float:right;">Date: ' . \Dates::my_date( $row["due_date"] ) . '</span>
		        </td>
		    </tr>
		    <tr>
		        <td>Receipt Number: ' . $row["receipt_number"] . '</td>
		        <td>
		            Paid: ' . ( ( $row["paid"] == 1 ) ? "Yes" : "No" ) . '
	            </td>
		    </tr>
		    <tr>
		        <td><b>' . $row["fee_title"] . '</b><br>
		        <span style="color:#666666;font-size:10px">' . nl2br( $row["description"] ) . '</span></td>
		        <td style="text-align: right;">' . \App::set_currency( $row["amount"] ) . '
		        </td>
		    </tr>
		    <tr>
		        <td>Fine</td>
		        <td style="text-align: right;">' . \App::set_currency( $row["fine"] ) . '</td>
		    </tr>
		    <tr>
		        <td>Total</td>
		        <td style="font-weight:bold;text-align: right;">' . \App::set_currency( $row["amount"] + $row["fine"] ) . '</td>
		    </tr>
		</table>';


		$HTML .= '<div style="page-break-before: always !important;"></div>';
	}

	$HTML .= '</body></html>';
	echo $HTML;
	//$rows = $Fee->get_not_paid( $_GET );
	exit;
}