<?php
if ( !(isset($_SERVER['HTTP_X_REQUESTED_WITH']) && $_SERVER['HTTP_X_REQUESTED_WITH']==='XMLHttpRequest') ) {
	header("HTTP/1.0 404 Not Found");
	echo "Non ajax requests are not allowed!";
	exit();
}

include_once( __DIR__ . "/../library.php" );

if ( ! \Admins\UserInfo::is_loggedin() ) {
	echo "You'r not authorized.";
	exit;
}

if ( isset( $_GET['load_data'] ) ) {
	$s                   = new \Student();
	$_POST['pagesize']   = 15;
	$_POST['mysql_cols'] = 'id,name,roll,admission_number,guardian_name,guardian_cell,fee,guardian_dob,gender,dob,admission_date,class_id,class_name';

	$rows = $s->get_students( $_POST );

	header( 'Content-Type: application/json' );
	$Fee = new Fee();
	foreach ( $rows['rows'] as &$row ) {
		$fee2 = $Fee->get_not_paid( "", "student_id=" . $row["id"] );
		$t    = 0;
		if ( is_array( $fee2 ) ) {
			foreach ( $fee2 as $fe ) {
				$t += ( $fe["amount"] + $fe["fine"] );
			}
		}
		$row['payable'] = \App::set_currency( $t );
		$row['fee']     = \App::set_currency( $row['fee'] );
	}
	echo json_encode( $rows );
	exit;
}
if ( isset( $_GET["getData"] ) ) {
	extract( $_POST );
	extract( $_GET );

	$_GET["class_id"] = isset($_GET["class_id"])?$_GET["class_id"]:'';

	$s          = new Student;
	$c          = new Classes;
	$f          = new Fee;
	$Cols       = [
		"",
		"id",
		"student_info",
		"dates",
		"class_id",
		"",
	];
	$iSortCol_0 = empty( $iSortCol_0 ) ? "0" : $iSortCol_0;
	$orderby    = $Cols[ $iSortCol_0 ];
	$sSortDir_0 = empty( $sSortDir_0 ) ? "DESC" : $sSortDir_0;
	$order      = $sSortDir_0;

	$_GET['iDisplayLength'] = isset( $_GET['iDisplayLength'] ) ? $_GET['iDisplayLength'] : 0;
	$_GET['iDisplayStart']  = isset( $_GET['iDisplayStart'] ) ? $_GET['iDisplayStart'] : 0;
	$_GET["to"]             = isset( $_GET['to'] ) ? $_GET['to'] : 0;

	$iDisplayLength = intval( $_GET['iDisplayLength'] );
	$iDisplayStart  = intval( $_GET['iDisplayStart'] );

	if ( $iDisplayLength == 0 ) {
		$page = 1;
	} else {
		$page = ( $iDisplayStart / $iDisplayLength ) + 1;
	}

	$filter = "";
	if ( ! empty( $_GET["from"] ) ) {
		$filter .= "&admission_date=" . $_GET["from"] . "," . $_GET["to"];
	}
	if ( is_array( $_GET["class_id"] ) ) {
		$filter .= "&classes=" . implode( ",", $_GET["class_id"] );
	} elseif ( ! empty( $_GET["class_id"] ) && $_GET["class_id"] > 0 ) {
		$filter .= "&class_id=" . $_GET["class_id"];
	}
	$filter = urlencode( trim( $filter, "&" ) );
	if ( ! isset( $sSearch ) ) {
		$sSearch = "";
	}
	$sSearch = trim( $sSearch );

	$query = "page={$page}&pagesize={$iDisplayLength}&orderby={$orderby}&order={$order}&search={$sSearch}&filter={$filter}";
	if ( isset( $deleted ) ) {
		$deleted = (int) $deleted;
		$query   .= "&deleted={$deleted}";
	}
	if ( isset( $subjects ) && $subjects <> "" ) {
		if ( is_array( $subjects ) ) {
			$subjects = implode( ",", $subjects );
		}
		$query .= "&subjects={$subjects}";
	}
	if ( isset( $_GET["batch"] ) ) {
		$query .= "&batch=" . $_GET["batch"];
	}

	$rows              = $s->get_students( $query );
	$records["aaData"] = [];
	$name              = __( "Student Name" );
	$roll              = __( "Roll" );
	$an                = __( "Admission Number" );
	foreach ( $rows["rows"] as $row ) {
		$details = "
			{$name}: <a href='{$row["profile_url"]}' ><b>{$row["name"]}</b></a><br>
			{$roll} # {$row["roll"]}<br>
			{$an}: <b>{$row["admission_number"]}</b>
		 <br>
		 Guardian: {$row["guardian_name"]} <i>({$row["guardian_cell"]})</i>
        ";
		$fee     = $s->get_student_fee( $row["id"] );
		$fee2    = $f->get_not_paid( "", "student_id=" . $row["id"] );
		$t       = 0;
		if ( is_array( $fee2 ) ) {
			foreach ( $fee2 as $fe ) {
				$t += ( $fe["amount"] + $fe["fine"] );
			}
		}
		if ( $t > 0 ) {
			$style = "style='font-weight:bold;background:#FEB535;padding:0 5px;'";
		} else {
			$style = "";
		}
		$dates = __( "Monthly Fee" ) . ": " . App::set_currency( $fee ) . "<br>" . __( "Payables" ) . ": " . App::set_currency( $t );
		if ( $row["deleted"] == "0" ) {
			$btn = "<button title=\"Delete This Student\" onclick=\"Delete({$row["id"]},this)\" class=\"btn red btn-xs\"><i class=\"fa fa-trash-o\"></i></button>";
		} else {
			$btn = "<button title=\"Un-Delete This Student\" onclick=\"UnDelete({$row["id"]},this)\" class=\"btn green btn-xs\"><i class=\"fa fa-trash-o\"></i> Un-Delete</button>";
		}
		$records["aaData"][] = array(
			"<input type='checkbox' class='checkboxes' name='student_ids[]' value='{$row["id"]}'>",
			$row["id"],
			$details,
			$dates,
			$row["class"] . " - " . $row["batch"] . "<br /><span style='color:#999999'>".__("Admission Date") .":</span> {$row["admission_date2"]}",
			//$btn,
		);
	}

	$records["sEcho"]                = empty( $sEcho ) ? 1 : $sEcho;
	$records["iTotalRecords"]        = $rows["total_records"];
	$records["iTotalDisplayRecords"] = $rows["total_records"];

	echo json_encode( $records );
	exit;
}
if ( isset( $_GET['delete'] ) ) {
	$s = new Student;
	$r = $s->delete_student( $id );
	if ( $r === false ) {
		die( "Error when deleting student." );
	}
	echo "OK";
	exit;
}
if ( isset( $_GET['delete_multi'] ) ) {
	if ( ! isset( $_POST["student_ids"] ) ) {
		echo __( "Please select one or more students." );
		die;
	}
	$s = new Student();
	$s->delete_multi_students( $_POST["student_ids"] );
	echo "OK";
	exit;
}
if ( isset( $_GET['change_class'] ) ) {
	if ( empty( $_POST['class_id'] ) ) {
		echo _e( 'Please select class' );
		exit;
	}
	$_POST["student_ids"] = isset($_POST["student_ids"])?$_POST["student_ids"]:'';
	$_POST["student_ids"] = \Str::make_array( $_POST["student_ids"] );

	if ( empty( $_POST['student_ids'] ) ) {
		die( _e( "Please select one or more students" ) );
	}
	$class_id = $_POST["class_id"];

	$Q        = "UPDATE `students` SET `class_id`='$class_id' WHERE `id` IN ('" . implode( "','", $_POST["student_ids"] ) . "')";
	$response = $db->query( $Q );
	if ( $response === false ) {
		echo $db->last_error;
	} else {
		echo "OK";
	}
	exit;
}
if ( isset( $_GET['sms'] ) ) {
	echo $Student->send_sms( $_POST );
	exit;
}
if ( isset( $_GET['reset_password'] ) ) {
	$Student = new \Student();
	echo $Student->change_password_by_admin( $_POST );
	exit();
}