<?php
if ( ! ( isset( $_SERVER['HTTP_X_REQUESTED_WITH'] ) && $_SERVER['HTTP_X_REQUESTED_WITH'] === 'XMLHttpRequest' ) ) {
	header( "HTTP/1.0 404 Not Found" );
	echo "Non ajax requests are not allowed!";
	exit();
}

include_once( __DIR__ . "/../library.php" );

if ( ! \Admins\UserInfo::is_loggedin() ) {
	echo "You'r not authorized.";
	exit;
}

header( 'Content-Type: application/json' );

$Subject = new Subject();

if ( isset( $_GET['load_data'] ) ) {
	$rows = $Subject->get_list( 'orderby=order_by&order=ASC' );

	echo json_encode( $rows );
	exit;
}

if ( isset( $_GET['sort'] ) ) {
	Subject::sort_subjects( $_POST );
	echo json_encode( [ 'status' => 'OK' ] );
	exit;
}

if ( isset( $_GET['save'] ) ) {
	echo json_encode( [ 'status' => $Subject->save( $_POST ) ] );
	exit;
}

if ( isset( $_GET['delete'] ) ) {
	$response = Subject::delete_multi( $_POST );
	echo json_encode( [ 'status' => $response ] );
	exit;
}