<?php
if ( ! ( isset( $_SERVER['HTTP_X_REQUESTED_WITH'] ) && $_SERVER['HTTP_X_REQUESTED_WITH'] === 'XMLHttpRequest' ) ) {
	header( "HTTP/1.0 404 Not Found" );
	echo "Non ajax requests are not allowed!";
	exit();
}

include_once( __DIR__ . "/../library.php" );

if ( ! \Admins\UserInfo::is_loggedin() ) {
	echo "You'r not authorized.";
	exit;
}

$TestSchedule = new TestSchedule();
$Student      = new Student();

if ( isset( $_GET["load_data"] ) ) {
	header( "Content-Type: application/json" );
	$_POST["pagesize"] = 20;
	if (isset($_POST["from"]) && !isset($_POST["from_date"])) {
		$_POST["from_date"] = $_POST["from"];
		unset($_POST["from"]);
	}
	if (isset($_POST["to"]) && !isset($_POST["to_date"])) {
		$_POST["to_date"] = $_POST["to"];
		unset($_POST["to"]);
	}
	$rows              = $TestSchedule->get_list( $_POST );
	foreach ( $rows["rows"] as &$row ) {
		$row["days"]           = \Dates::days_difference( $row["test_date"] );
		$row["students_count"] = $Student->get_students( "count_only=1&class_id={$row["class_id"]}&subjects[]={$row["subject"]}" );
	}
	echo json_encode( $rows );
	exit;
}