<?php
if ( ! ( isset( $_SERVER['HTTP_X_REQUESTED_WITH'] ) && $_SERVER['HTTP_X_REQUESTED_WITH'] === 'XMLHttpRequest' ) ) {
	header( "HTTP/1.0 404 Not Found" );
	echo "Non ajax requests are not allowed!";
	exit();
}

include_once( __DIR__ . "/../library.php" );

if ( ! \Admins\UserInfo::is_loggedin() ) {
	echo "You'r not authorized.";
	exit;
}

$Shifts    = new TimeTable\Shifts();
$TimeTable = new TimeTable\TimeTable();

if ( isset( $_GET["get_shifts"] ) ) {
	header( "Content-Type: application/json" );
	echo json_encode( $Shifts->get_shifts( "pagesize=1000" ) );
	exit;
}
if ( isset( $_GET["save_shift"] ) ) {
	echo $Shifts->save_shift( $_POST );
	exit;
}
if ( isset( $_GET["del_shift"] ) ) {
	$_POST["id"] = isset( $_POST["id"] ) ? $_POST["id"] : 0;
	echo $Shifts->delete_shift( $_POST["id"] );
	exit;
}
if ( isset( $_GET["sort_shifts"] ) ) {
	$Shifts->save_sort_shifts( $_POST["tr"] );
	exit;
}
if ( isset( $_GET["loading_timetable"] ) ) {
	header( "Content-Type: application/json" );
	echo json_encode( $TimeTable->get_time_table( $_POST ) );
	exit;
}
if ( isset( $_GET["save_time_table"] ) ) {
	echo $TimeTable->save( $_POST );
	exit;
}
if ( isset( $_GET["load_data"] ) ) {
	header( "Content-Type: application/json" );

	echo json_encode( $TimeTable->get_time_table_class_names() );
	exit;
}
if ( isset( $_GET["delete_time_table_entry"] ) ) {
	echo $TimeTable->delete_time_table_entry( $_POST );
	exit;
}
if ( isset( $_GET["print"] ) ) {
	$data = $TimeTable->get_complete_time_table( $_POST["class_id"] );

	header( "Content-Type: application/json" );
	echo json_encode( $data );
	exit;
}