$( function() {
	$( document ).on( "click", ".btn_delete", DeleteSalary )
} );

var DeleteSalary = function( event ) {
	event.preventDefault();

	if ( !confirm( "Are you sure you want to delete this salary?" ) ) {
		return false;
	}

	id = $( this ).attr( "data-id" );
	Block();
	$.post( "ajax/accounts_teacher_salary.php?delete_salary", { id: id }, function( data ) {
		UnBlock();
		if ( data=="OK" ) {
			var $dataTable = $( '#sample_11' ).dataTable();
			$dataTable.fnDraw();
		} else {
			Error( data );
		}
	} );
}

var TableAjax = function() {

	return {

		//main function to initiate the module
		init: function() {

			if ( !jQuery().dataTable ) {
				return;
			}

			// begin first table
			var $dataTable = $( '#sample_11' ).dataTable( {
				"sDom": "<'row'<'col-md-6 col-sm-12'l><'col-md-6 col-sm-12'f>r>t<'row'<'col-md-5 col-sm-12'i><'col-md-7 col-sm-12'p>>", //default layout without horizontal scroll(remove this setting to enable horizontal scroll for the table)
				"aLengthMenu": [
					[ 10, 20, 40, 60, 100 ],
					[ 10, 20, 40, 60, 100 ] // change per page values here
				],
				"bProcessing": true,
				"bServerSide": true,
				"sAjaxSource": "ajax/accounts_teacher_salary.php?getList&" + param_list,
				// set the initial value
				"iDisplayLength": 10,
				//                "sPaginationType": "bootstrap_full_number",
				"oLanguage": {
					"sProcessing": '<i class="fa fa-coffee"></i>&nbsp;Please wait...',
					"sLengthMenu": "_MENU_ records",
					"oPaginate": {
						"sPrevious": "Prev",
						"sNext": "Next"
					}
				},
				"oSearch": { "sSearch": oSearch },
				"aoColumns": [
					{ "bSortable": true, "sClass": "right" },
					{ "bSortable": true },
					{ "bSortable": true, "sClass": "right" },
					{ "bSortable": true, "sClass": "right" },
					{ "bSortable": true },
					{ "bSortable": false, "sClass": "right" }
				],
				"aaSorting": [ [ 0, "desc" ] ]
			} );

			$( "#sample_11 tfoot input" ).on( 'keyup change', function() {
				table
					.column( $( this ).parent().index() + ':visible' )
					.search( this.value )
					.draw();
			} );

			jQuery( '#sample_11_wrapper .dataTables_filter input' ).addClass( "form-control input-medium" ); // modify table search input
			jQuery( '#sample_11_wrapper .dataTables_length select' ).addClass( "form-control input-small" ); // modify table per page dropdown
		}
	};

}();
TableAjax.init();

function OpenForm2( id ) {
	Block();
	$.post( "ajax/accounts_teacher_salary.php?getSalary", { id: id }, function( data ) {
		UnBlock();
		var a = data.split( "***" );
		document.deductionForm.reset();
		$( "#deductionDiv" ).modal( "show" );
		$( "#id3" ).val( id );
		$( "#deduction" ).val( a[ 0 ] ).focus();
		$( "#deduction_desc" ).val( a[ 1 ] );
	} );
}

function UpdateDed( form ) {
	Block();
	$.post( "ajax/accounts_teacher_salary.php?update_ded", $( form ).serialize(), function( data ) {
		UnBlock();
		if ( data=="OK" ) {
			$( "#deductionDiv" ).modal( "hide" );
			var $dataTable = $( '#sample_11' ).dataTable();
			$dataTable.fnDraw();
			$( "#pay" ).modal( "hide" );
			Success( "Deduction paid successfully!" );
		} else {
			Error( data );
		}
	} );

	return false;
}

function Pay( id ) {
	$( "#pay" ).modal( "show" );
	document.payForm.reset();
	$( "#id2" ).val( id );
	$( "#deduction" ).val( "0" );
	$( "#head" ).focus();
}

function OpenForm() {
	$( "#salaries" ).modal( "show" );
	document.salariesForm.reset();
}

function Generate( form ) {
	Block();
	$.post( "ajax/accounts_teacher_salary.php?generate", $( form ).serialize(), function( data ) {
		UnBlock();
		if ( data=="OK" ) {
			var $dataTable = $( '#sample_11' ).dataTable();
			$dataTable.fnDraw();
			$( "#salaries" ).modal( "hide" );
			Success( "Salaries generated successfully!" );
		} else {
			Error( data );
		}
	} );

	return false;
}

function PayNow( form ) {
	Block();
	$.post( "ajax/accounts_teacher_salary.php?pay", $( form ).serialize(), function( data ) {
		UnBlock();
		if ( data=="OK" ) {
			var $dataTable = $( '#sample_11' ).dataTable();
			$dataTable.fnDraw();
			$( "#pay" ).modal( "hide" );
			Success( "Salary paid successfully!" );
		} else {
			Error( data );
		}
	} );

	return false;
}