var Page = 1;
var is_loading = false;
var Data = { pages: 1 };

$( function() {
    load_data();
    $( document ).on( "click", ".change_password", function() {
        let id = $( this ).attr( 'data-id' );

        let new_password = window.prompt( 'Type new password', '' );
        if ( new_password ) {
            Block();
            $.ajax( {
                method: 'post',
                url: 'ajax/students.php?reset_password',
                data: { id: id, password: new_password },
                success: function( data ) {
                    UnBlock();
                    if ( data=='OK' ) {
                        Success( 'Password change!' );
                    } else {
                        Error( data );
                    }
                },
                error: function( e1, e2, e3 ) {
                    Error( e3 );
                    UnBlock();
                }
            } );
        }
    } );
    $( document ).on( 'click', '#filter_clear_btn', function( event ) {
        event.preventDefault();
        $( '#filter_form' ).trigger( 'reset' );
        $( '#filter_form select' ).select2( 'val', [] );
        $( '#search_filter' ).val( '' );
        Page = 1;
        Block();
        load_data();
    } );
    $( document ).on( 'change', '.check1', CheckAll );
    $( document ).on( 'change', '.checkbox', ChangeCheckAll );
    //	$( document ).on( 'click', '#filter_link', Filter );
    $( document ).on( 'change', '#search_filter', Search );
    $( document ).on( 'submit', '#change_class_form', ChangeClass );
    $( document ).on( 'submit', '#filter_form', function( event ) {
        event.preventDefault();
        close_filters();
        Page = 1;
        load_data();
    } );
    $( document ).on( 'change', '#filter_form input[name=from]', function() {
        if ( $( '#filter_form input[name=to]' ).val()=='' ) {
            $( '#filter_form input[name=to]' ).val( $( this ).val() );
        }
    } );
    $( document ).on( 'change', '#filter_form input[name=to]', function() {
        if ( $( '#filter_form input[name=from]' ).val()=='' ) {
            $( '#filter_form input[name=from]' ).val( $( this ).val() );
        }
    } );

    $( document ).on( 'scroll', function() {
        if ( !is_loading && isInViewport( '#tfoot1' ) ) {
            Page++;
            load_data();
        }
    } );
} );

var Search = function() {
    Page = 1;
    load_data();
};

var CounterUpdate = function() {
    if ( $( '.checkbox:checked' ).length==1 ) {
        $( 'span#selected_students' ).html( " - <b>" + $( '.checkbox:checked' ).length + '</b> Student Selected' );
    } else if ( $( '.checkbox:checked' ).length>0 ) {
        $( 'span#selected_students' ).html( " - <b>" + $( '.checkbox:checked' ).length + '</b> Students Selected' );
    } else {
        $( 'span#selected_students' ).html( '' );
    }
};

var ChangeCheckAll = function( event ) {
    $( '.check1' ).prop( 'checked', $( '.checkbox' ).length==$( '.checkbox:checked' ).length ).uniform();
    CounterUpdate();
};

var CheckAll = function( event ) {
    console.log( $( '.check1' ).is( ':checked' ) );
    $( '.checkbox' ).prop( 'checked', $( this ).is( ':checked' ) ).uniform();
    CounterUpdate();
};

var load_data = function() {
    if ( Page>Data.pages ) {
        return false;
    }

    if ( Page>1 ) {
        $( '#tbody1' ).append( '<tr id="temp_row"><td colspan="4" style="text-align: center"><i class="fa fa-spin fa-spinner"></i> ' + loading_text + ' ...</td></tr>' );
    } else {
        $( 'span#selected_students' ).html( '' );
    }

    close_filters();

    is_loading = true;
    $( '#loader1' ).show();

    $.ajax( {
        url: 'ajax/students.php?load_data',
        method: 'post',
        data: 'page=' + Page + "&" + $( "#filter_form" ).serialize() + "&search=" + $( '#search_filter' ).val(),
        success: function( data ) {
            UnBlock();
            $( '#loader1' ).hide();
            Data = data;
            is_loading = false;

            $( '.check1' ).prop( 'checked', false ).uniform();

            $( '#total_records' ).html( data.total_records );
            let html = tmpl( 'tbody1_template', data );
            if ( data.total_records==0 ) {
                $( '#tbody1' ).html( "<tr><td colspan='4' style='text-align: center;font-style: italic'>-- No data found --</td></tr>" );
            } else if ( Page==1 ) {
                $( '#tbody1' ).html( html );
            } else {
                $( 'tr#temp_row' ).remove();
                $( '#tbody1' ).append( html );
            }
            if ( $.trim( $( '#search_filter' ).val() )!='' ) {
                $( '#tbody1' ).mark( $( '#search_filter' ).val(), markjs_options );
            }

            $( 'input.checkbox' ).uniform();
        },
        error: function( e1, e2, e3 ) {
            is_loading = false;
            $( '#loader1' ).hide();

            alert( e2 + ': ' + e3 );
        }
    } );
};

// function Delete( id, t ) {
// 	bootbox.confirm( "Are you sure you want to delete this student?", function( result ) {
// 		if ( result==false ) {
// 			return;
// 		}
// 		Block();
// 		//var id = $(t).parent().parent().find("td:first-child").html();
// 		$.post( 'ajax/students.php?delete', { id: id }, function( data ) {
// 			UnBlock();
// 			if ( data=="OK" ) {
// 				var $dataTable = $( '#sample_11' ).dataTable();
// 				$dataTable.fnDraw();
// 				var fig = $( "#del_students_span" ).html();
// 				fig = parseFloat( fig ) + 1;
// 				$( "#del_students_span" ).html( fig );
// 				Success( "Student removed successfully!" );
// 			} else {
// 				alert( data );
// 			}
// 		} );
// 	} );
// }

function SubmitSMS() {
    $( "#sms_submit" ).click();
}

function ChangeClass( event ) {
    event.preventDefault();

    if ( $( '.checkbox:checked' ).length==0 ) {
        alert( 'Please select one ore more students to change class' );
        return false;
    }

    $( '#change_class_form_students' ).html( '' );
    $( '.checkbox:checked' ).each( function() {
        $( '#change_class_form_students' ).append( '<input type="hidden" name="student_ids[]" value="' + $( this ).val() + '">' );
    } );

    $( '#change_class_form' ).ajaxSubmit( {
        beforeSubmit: function() {
            Block();
        },
        success: function( data ) {
            UnBlock();
            $( "#class_modal" ).modal( "hide" );
            if ( data=='OK' ) {
                Page = 1;
                load_data();
                Success( 'Class changed successfully!' );
            } else {
                Error( data );
            }
        },
        error: function( e1, e2, e3 ) {
            UnBlock();
            $( "#class_modal" ).modal( "hide" );
            Error( e2 + ": " + e3 );
        }
    } );

    /*$.post( "ajax/students.php?change_class", query, function( data ) {

        if ( data=="OK" ) {
            Success( "Class changed successfully!" );
            $( "#class_modal" ).modal( "hide" );
            var oTable = $( '#sample_11' ).dataTable();
            oTable.fnDraw();
        } else {
            Error( data );
        }
    } );*/
}

$( function() {
    $( document ).on( "submit", "#sms_form", SMS );
    $( document ).on( "click", "#open_sms_modal", function( event ) {
        event.preventDefault();
        if ( $( ".checkbox:checked" ).length==0 ) {
            Error( "Please select one ore more students." );
            return false;
        }

        $( "#selected_students" ).html( $( ".checkbox:checked" ).length + " selected" );

        $( "#sms_modal" ).modal( "show" );
    } );
    $( document ).on( 'click', '#download_pdf_btn', DownloadPDF );
} );

function SMS( event ) {
    event.preventDefault();
    form = (this);
    if ( $( ".checkbox:checked" ).length==0 ) {
        Error( "Please select one ore more students." );
        return false;
    }

    var query = $( "#sms_form" ).serialize();
    query += '&' + $( ".checkbox:checked" ).serialize();
    /*query += "&search=" + jQuery( '#sample_11_wrapper .dataTables_filter input' ).val();
    query += "&_data=students&is_sms=1";
    var oTable = $( '#sample_11' ).dataTable();
    var Sort = oTable.fnSettings().aaSorting;
    query = query + "&sorts=" + Sort;
    query += "&" + $( form ).serialize();
    query += "&" + $( ".checkbox:checked" ).serialize();*/
    $( '#sms_modal' ).modal( 'hide' );
    Block();
    $.ajax( {
        url: "ajax/students.php?sms",
        method: "post",
        data: query,
        success: function( data ) {
            UnBlock();
            if ( data=='OK' ) {
                Success( 'SMS sent successfully!' );
            } else {
                Error( data );
            }
        },
        error: function( e1, e2, e3 ) {
            UnBlock();
            alert( e3 )
        }
    } );
    return false;
}

function DownloadPDF( event ) {
    event.preventDefault();
    var query = $( "#form1" ).serialize();
    query += "download_students&search=" + jQuery( '#search_filter' ).val();

    //var oTable = $( '#sample_11' ).dataTable();
    /*var oData = oTable.fnPagingInfo();
     $.each(oData, function(k,v){
     alert(k + " = " + v);
     });*/
    //var Sort = oTable.fnSettings().aaSorting;

    //window.open(root_url + 'ajax/pdf/students.php?' + query);
    download_pdf( root_url + 'ajax/pdf/students.php?' + query, 'Students_' + date( 'd-m-Y-H-i' ) );
    //window.location.href = "download_pdf.php?" + query;
}

$( function() {
    jQuery( '#sample_11 .group-checkable' ).change( function() {
        var set = jQuery( this ).attr( "data-set" );
        var checked = jQuery( this ).is( ":checked" );
        jQuery( set ).each( function() {
            if ( checked ) {
                $( this ).prop( "checked", true ).uniform();
                $( this ).parents( 'tr' ).addClass( "active" );
            } else {
                $( this ).prop( "checked", false ).uniform();
                $( this ).parents( 'tr' ).removeClass( "active" );
            }
        } );
        //jQuery.uniform.update( set );
    } );
    $( document ).on( "click", "#del_selected_btn", function( event ) {
        event.preventDefault();

        if ( $( ".checkbox:checked" ).length==0 ) {
            alert( "Please select one or more students to delete." );
            return;
        }

        if ( !confirm( "Are you sure you want to delete selected students?" ) ) {
            return;
        }

        Block();
        $.post( 'ajax/students.php?delete_multi', $( ".checkbox:checked" ).serialize(), function( data ) {
            UnBlock();
            if ( data=="OK" ) {
                var fig = $( "#del_students_span" ).html();
                fig = parseFloat( fig ) + $( ".checkbox:checked" ).length;
                $( "#del_students_span" ).html( fig );

                $( ".checkbox:checked" ).each( function() {
                    t = ($( '#total_records' ).text());
                    $( '#total_records' ).text( parseInt( t ) - 1 );
                    $( '#tr_' + $( this ).val() ).remove();
                } );
                CounterUpdate();
            } else {
                alert( data );
            }
        } );
    } );
    $( document ).on( "change", "#current_batch_id", function( event ) {
        event.preventDefault();

        window.location.href = "students.php?batch=" + $( this ).val();
    } )
} );

var Filter = function Filter( event ) {
    event.preventDefault();

    if ( $( this ).html()=="⇑ Hide Filter" ) {
        $( "#form1" ).slideUp( "slow" );
        $( this ).html( "&dArr; Filter Result" );
    } else {
        $( "#form1" ).slideDown( "slow" );
        $( this ).html( "&uArr; Hide Filter" );
    }

    return false;
}