var Data;
$( function() {
	load_data();

	$( document ).on( 'click', '#add_subject_btn', AddNew );
	$( document ).on( 'submit', '#form1', Save );
	$( document ).on( 'click', '.edit_btn', Edit );
	$( document ).on( 'change', '#checkbox', CheckAll );
	$( document ).on( 'change', '.checkbox', CheckAllCross );
	$( document ).on( 'click', '#del_multi_btn', Del );

	$( document ).on( 'scroll', function() {
		if ( isInViewport( 'div.header' ) ) {
			stickybits( '#topline', {
				stickyBitStickyOffset: $('div.header').height()
			} );
		} else {
			stickybits( '#topline', {
				stickyBitStickyOffset: 0
			} );
		}
	} );
} );

var CheckAllCross = function( event ) {
	event.preventDefault();

	$( '#checkbox' ).prop( 'checked', $( '.checkbox:checked' ).length==$( '.checkbox' ).length ).uniform();
};

var CheckAll = function( event ) {
	event.preventDefault();
	$( '.checkbox' ).prop( 'checked', $( this ).is( ':checked' ) ).uniform();

};

var load_data = function() {
	Block();

	$.ajax( {
		url: 'ajax/subjects.php?load_data',
		method: 'post',
		success: function( data ) {
			Data = data;
			UnBlock();
			html = tmpl( 'tbody1_template', data );
			$( '#tbody1' ).html( html );
			$( '.checkbox' ).uniform();
			$( '#tbody1' ).sortable( {
				forcePlaceholderSize: true,
				opacity: 0.5,
				placeholder: "sortable-placeholder",
				revert: true,
				update: function( event, ui ) {
					// sortable() - Creates an array of the elements based on the element's id.
					// The element id must be a word separated by a hyphen, underscore, or equal sign. For example, <tr id='item-1'>
					var data = $( this ).sortable( 'serialize', { key: "sort[]" } );

					//alert(data); <- Uncomment this to see what data will be sent to the server

					// AJAX POST to server
					$.ajax( {
						data: data,
						type: 'POST',
						url: 'ajax/subjects.php?sort',
						success: function( response ) {

						},
						error: function( p1, p2, p3 ) {
							alert( p3 );
						}
					} );
				}
			} );
		},
		error: function( jqXHR, textStatus, errorThrown ) {
			UnBlock();
			alert( textStatus + ': ' + errorThrown );
		}
	} );

	$( '#tbody1' ).html();
};

var AddNew = function( event ) {
	event.preventDefault();
	$( '#subjects-modal' ).modal( 'show' );
};

function Edit( event ) {
	event.preventDefault();

	id = $( this ).attr( 'data-id' );

	$.each( Data, function( i, row ) {
		if ( row.id==id ) {
			$( '#id' ).val( row.id );
			$( '#subject' ).val( row.subject );
			$( '#short_name' ).val( row.short_name );
			$( '#subjects-modal' ).modal( 'show' );
			return false;
		}
	} );

	return false;
}

function SubmitForm1() {
	$( '#form1submit' ).click();
}

function SaveShortName( t, id ) {
	Block();
	$.post( "includes/old_ajax.php?action=saveSubjectShortName", {
		id: id,
		short_name: $( t ).val()
	}, function( data ) {
		UnBlock();
		if ( data=="OK" ) {
			Success( "New subject added successfully!" );
		} else {
			Error( data );
		}
	} );
	return false;
}

function SaveOrder( t, id ) {
	Block();
	$.post( "includes/old_ajax?action=saveSubjectOrder", {
		id: id,
		newOrder: $( t ).val()
	}, function( data ) {
		UnBlock();
		if ( data=="OK" ) {
			Success( "Order saved successfully!" );
		} else {
			Error( data );
		}
	} );
	return false;
}

function Save( event ) {
	event.preventDefault();

	if ( !$( '#form1' ).validate().form() ) {
		return false;
	}

	if ( $( "#subject" ).val()=="" ) {
		$( "#subject" ).select();
		bootbox.alert( "Please type subject." );
		return false;
	}

	Block();

	$( '#form1' ).ajaxSubmit( {
		success: function( data ) {
			UnBlock();
			if ( data.status.substr( 0, 2 )=='OK' ) {
				$( '#subjects-modal' ).modal( 'hide' );
				load_data();
			} else {
				Error( data.status );
			}
		},
		error: function( e1, e2, e3 ) {
			UnBlock();
			Error( e3 );
		}
	} );

	return false;
}

function Del( event ) {
	event.preventDefault();

	if ( $( '.checkbox:checked' ).length==0 ) {
		alert( 'Please select one or more subject to delete' );
		return false;
	}

	if ( !confirm( 'Are you sure you want to delete selected subjects?' ) ) {
		return false;
	}

	$.ajax( {
		url: 'ajax/subjects.php?delete',
		method: 'post',
		data: $( '.checkbox:checked' ).serialize(),
		success: function( data ) {
			if ( data.status=='OK' ) {
				$.each( $( '.checkbox:checked' ), function( i, val ) {
					$( '#tr_' + $( this ).val() ).remove();
				} );
			} else {
				Error( data.status );
			}
		},
		error: function( p1, p2, p3 ) {
			alert( p3 );
		}
	} );

	/*bootbox.confirm( "Are you sure you want to delete this subject?", function( result ) {
		if ( result==false ) {
			return;
		}
		Block();
		var id = $( t ).parent().parent().find( "td:first-child" ).html();
		$.post( 'includes/old_ajax?action=delSubject', { id: id }, function( result ) {
			UnBlock();
			if ( result=="OK" ) {
				var row = $( t ).parent().parent();
				var row_id = dataTable.fnGetPosition( row[ 0 ] );
				dataTable.fnDeleteRow( row_id );
				Success( "Subject removed successfully!" );
			} else {
				//bootbox.alert(result);
				Error( result );
			}
		} );
	} );*/
}