$( function() {
	$( document ).on( "change", "#class_id", LoadingTimeTable );
	$( document ).on( "click", ".print_btn", Print );
	$( document ).on( "click", ".download_btn", Download );
	$( document ).on( "change", ".teacher_id", ChangeTeacher );
	$( document ).on( "click", ".add_time_table_btn", AddTimeTable );
	$( document ).on( "click", "#manage_shifts_btn", function( event ) {
		event.preventDefault();
		Block();
		$.post( ajax_url + "?get_shifts", function( data ) {
			shifts_count = data.total_records;
			UnBlock();
			$.fancybox( {
				title: "Manage Shifts",
				content: tmpl( "shifts_template", data ),
				modal: true,
				minWidth: '90%',
				afterShow: function() {
					$( "#shifts_table" ).tablesaw();
					sort_shifts_table();
				}
			} )
		} );
	} );
	$( document ).on( "change", ".subject_id", SaveTimeTable );
	$( document ).on( "submit", "#add_shift_form", function( event ) {
		event.preventDefault();

		k = $( "#add_shift_form" ).serialize();

		disable_shift_form( 1 );
		$( "#shift_save_loader" ).removeClass( "hidden" );

		$.post( ajax_url + "?save_shift", k, function( data ) {
			if ( data=="OK" ) {
				$.post( ajax_url + "?get_shifts", function( data1 ) {
					$( ".fancybox-inner" ).html( tmpl( "shifts_template", data1 ) );
					sort_shifts_table();
					$( "#shifts_table" ).tablesaw();
				} );
			} else {
				disable_shift_form( 0 );
				$( "#shift_save_loader" ).addClass( "hidden" );
				alert( data );
			}
		} );
	} );
	$( document ).on( "click", ".del_shift_btn", function( event ) {
		event.preventDefault();

		id = $( this ).attr( "data-id" );
		if ( !confirm( "Are you sure you want to delete this shift?" ) ) {
			return false;
		}

		$( "#tr_" + id ).remove();
		n = Number( $( "#total_shifts" ).text() );
		$( "#total_shifts" ).text( --n );
		$.post( ajax_url + "?del_shift", { id: id }, function( data ) {
			if ( data=="OK" ) {

			} else {
				alert( data );
			}
		} );
	} );
	load_data();
} );

function disable_shift_form( disable ) {
	$( "#add_shift_form" ).find( "input" ).each( function() {
		$( this ).prop( "disabled", disable==1 );
	} );
	$( "#add_shift_form" ).find( "button" ).each( function() {
		$( this ).prop( "disabled", disable==1 );
	} );
}

function sort_shifts_table() {
	/*
	Sort from
	https://stackoverflow.com/questions/36551105/applying-containment-to-jquery-ui-sortable-table-prevents-moving-tall-rows-to-th
	 */
	$( "#shifts_table tbody" ).sortable( {
		items: '> tr',
		handle: ".handle",
		containment: "#shifts_table",
		forceHelperSize: true,
		forcePlaceholderSize: true,
		opacity: 0.6,
		update: function() {
			var ids1 = $( this ).sortable( "serialize" );
			$.post( ajax_url + "?sort_shifts", ids1, function( data ) {

			} );
		},
		classes: {
			"ui-sortable": "bg-red"
		}
	} );
}

function AddTimeTable( event ) {
	event.preventDefault();

	class_id = $( this ).attr( "data-class_id" );

	if ( shifts_count==0 ) {
		if ( confirm( noshift_string ) ) {
			$( "#manage_shifts_btn" ).click();
		}
		return false;
	}

	Block();
	$.post( ajax_url + "?get_shifts", function( data ) {
		UnBlock();
		shifts_count = data.total_records;

		$.fancybox( {
			content: tmpl( "save_time_table_template", data ),
			minWidth: '95%',
			//title: 'Save Time Table',
			//modal: true,
			afterShow: function() {
				$( "#add_shifts_table" ).tablesaw();
				set_class_colors();
				if ( class_id ) {
					$( "#class_id" ).val( class_id ).trigger( "change" );
				}
			},
			afterClose: function() {
				load_data();
			}
		} );
	} );
}

SaveTimeTable = function( event ) {
	event.preventDefault();

	$this = $( this );

	day = $( this ).attr( "data-day" );
	shift_id = $( this ).closest( "tr" ).attr( "data-id" );
	class_id = $( "#class_id" ).val();
	teacher_id = $( this ).prev().val();
	subject = $( this ).val();

	if ( teacher_id==0 ) {
		$( this ).next().val( '0' );
	} else {
		//alert (teacher_id);
	}

	set_class_colors();

	$( "#saving_span span" ).html( "Saving" );
	$( "#saving_span" ).show();
	$.post( ajax_url + "?save_time_table",
		{ day: day, shift_id: shift_id, class_id: class_id, teacher_id: teacher_id, subject: subject },
		function( data ) {
			$( "#saving_span" ).hide();
			if ( data!="OK" ) {
				$this.val( '0' );
				Error( data );
			} else {
				Success(saved_sring);
			}
		} );
}

function set_class_colors() {
	$( ".teacher_id" ).each( function() {
		if ( $( this ).val()=="0" ) {
			$( this ).next().prop( "disabled", true );
			$( this ).closest( "td" ).removeClass( "success" ).addClass( "danger" );
		} else {
			$( this ).next().prop( "disabled", false );
			$( this ).closest( "td" ).removeClass( "danger" ).addClass( "success" );
		}
	} );
}

load_data = function() {
	$.post( ajax_url + "?load_data", function( data ) {
		$( "#tbody1" ).html( tmpl( 'tbody1_template', data ) );
	} );
}
Download = function() {
	alert( "Under construction!" );
}
LoadingTimeTable = function( event ) {
	event.preventDefault();

	val = $( this ).val();
	$( ".teacher_id, .subject_id" ).val( '0' ).prop( "disabled", true );
	if ( val=="0" ) {
		$( ".teacher_id, .subject_id" ).prop( "disabled", true );
		$( "#teacher_blink" ).show();
		set_class_colors();
	} else {
		$( ".teacher_id" ).prop( "disabled", false );
		$( "#saving_span span" ).html( "Loading" );
		$( "#saving_span" ).show();
		$( "#teacher_blink" ).hide();

		$.post( ajax_url + "?loading_timetable", { class_id: val }, function( data ) {
			$( "#saving_span" ).hide();

			$.each( data, function( i, row ) {
				$( '#teacher_id_' + row.day + '_' + row.shift_id ).val( row.teacher_id );
				$( '#subject_id_' + row.day + '_' + row.shift_id ).val( row.subject );
			} );

			set_class_colors();
		} );
	}
};
ChangeTeacher = function( event ) {
	event.preventDefault();

	val = $( this ).val();
	shift_id = $( this ).closest( "tr" ).attr( "data-id" );
	class_id = $( "#class_id" ).val();
	day = $( this ).attr( "data-day" );

	if ( val=="0" ) {
		$( this ).next().val( '0' ).prop( "disabled", true );
		$.post( ajax_url + "?delete_time_table_entry", {
			shift_id: shift_id,
			class_id: class_id,
			day: day
		}, function( data ) {
			set_class_colors();
		} );
	} else {
		$( this ).next().prop( "disabled", false );
	}
};
Print = function(event) {
	event.preventDefault();
	id = $(this).attr("data-class_id");
	Block();

	$.post(ajax_url + "?print", {class_id:id}, function( data ) {
		UnBlock();
		//alert ( tmpl('print_template', data) );
		$("#print_div div").html( tmpl('print_template', data) ).print({
			title: "TIME TABLE",
			//prepend: '<style>@page {size: landscape; margin:0;} body {margin:1.6cm;}</style>'
		});
	})
};
