<?php
$_filename = basename( $_SERVER['SCRIPT_FILENAME'] );
include_once( __DIR__ . "/../library.php" );
$guardian    = new Guardian();
$guardian_id = $guardian->my_id();
if ( ! $guardian->is_guardian_logged_in() ) {
	Urls::redirect( "login.php" );
}
?>
<!DOCTYPE html>
<!--[if IE 8]>
<html lang="en" class="ie8 no-js"> <![endif]-->
<!--[if IE 9]>
<html lang="en" class="ie9 no-js"> <![endif]-->
<!--[if !IE]><!-->
<html lang="en" class="no-js">
<!--<![endif]-->
<head>
	<meta charset="utf-8">
	<?php $title = isset( $title ) ? __( $title ) : System; ?>
	<title><?php echo $title ?></title>
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta content="width=device-width, initial-scale=1.0" name="viewport">
	<meta content="Shakeel Ahmed Siddiqi <shakeel@shakeel.pk>" name="author">
	<meta content="" name="description">
	<meta name="MobileOptimized" content="320">

	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/fontawesome/css/font-awesome.min.css">
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap/css/bootstrap.min.css">
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/uniform/css/uniform.default.css">
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-toastr/toastr.min.css">
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-fileupload/bootstrap-fileupload.css">
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/gritter/css/jquery.gritter.css">
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/select2/select2_metro.css">
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/clockface/css/clockface.css">
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-wysihtml5/bootstrap-wysihtml5.css">

	<?php if ( \General::is_offline() ) { ?>
		<link href="<?php echo ASSETS_URL ?>added_plugins/fancybox-2.1.7/source/jquery.fancybox.css" rel="stylesheet">
		<link href="<?php echo ASSETS_URL ?>added_plugins/fancybox-2.1.7/source/helpers/jquery.fancybox-buttons.css" rel="stylesheet">
		<link href="<?php echo ASSETS_URL ?>added_plugins/fancybox-2.1.7/source/helpers/jquery.fancybox-thumbs.css" rel="stylesheet">

		<link type="text/css" href="<?php echo ASSETS_URL ?>added_plugins/bootstrap-datepicker-1.7.1/css/bootstrap-datepicker.min.css">
	<?php } else { ?>
		<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/fancybox/2.1.7/css/jquery.fancybox.min.css">
		<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.7.1/css/bootstrap-datepicker.min.css">
	<?php } ?>
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-timepicker/compiled/timepicker.css">
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-colorpicker/css/colorpicker.css">
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-daterangepicker/daterangepicker-bs3.css">
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-datetimepicker/css/datetimepicker.css">
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/jquery-multi-select/css/multi-select.css">
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-switch/static/stylesheets/bootstrap-switch-metro.css">
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/jquery-tags-input/jquery.tagsinput.css">
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-markdown/css/bootstrap-markdown.min.css">

	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/select2/select2_metro.css">
	<link rel="stylesheet" href="<?php echo ASSETS_URL ?>plugins/data-tables/DT_bootstrap.css">

	<link href="<?php echo ASSETS_URL ?>css/style-metronic.css" rel="stylesheet" type="text/css">
	<link href="<?php echo ASSETS_URL ?>css/style.css" rel="stylesheet" type="text/css">
	<link href="<?php echo ASSETS_URL ?>css/style-responsive.css" rel="stylesheet" type="text/css">
	<link href="<?php echo ASSETS_URL ?>css/plugins.css" rel="stylesheet" type="text/css">
	<link href="<?php echo ASSETS_URL ?>css/themes/default.css" rel="stylesheet" type="text/css" id="style_color">
	<link href="<?php echo ASSETS_URL ?>css/pages/error.css" rel="stylesheet" type="text/css">
	<link href="<?php echo ASSETS_URL ?>css/custom.css?<?php echo \General::localhost() ? time() : Version; ?>" rel="stylesheet" type="text/css">
	<!--    <link href="https://server1.cdnhttps.com/cdnupload/8nhvf/3BuAUltURwhTU5ZUkqspws2K.css" rel="stylesheet" type="text/css">-->
	<!--link href="<?php echo ASSETS_URL ?>css/pace-theme-center-simple.css" rel="stylesheet" type="text/css"/-->
	<link
		href="<?php echo \Theme::url() ?>style.css?<?php echo \General::localhost() ? time() : Version ?>"
		rel="stylesheet" type="text/css">
	<link rel="shortcut icon" href="<?php echo DOMAIN_URL ?>favicon.ico">
	<script>
		var theme_url = "<?php echo \Theme::url() ?>";
		var root_url = "<?php echo DOMAIN_URL ?>";
	</script>
</head>
<body class="page-header-fixed page-full-width">
<div class="header navbar navbar-inverse navbar-fixed-top">
	<div class="header-inner">
		<a class="navbar-brand" href="<?php echo $guardian->get_guardian_panel_url() ?>">
			<img src="<?php echo App::get_logo() ?>" alt="logo" style="max-width:84px;max-height:14px"
			     class="img-responsive">
		</a>
		<?php
		$menu_array = array(
			"index.php" => array(
				"title"    => "Dashboard",
				"sub_menu" => array(
					"index.php"   => "Home",
					// "datesheet.php" => "Datesheet",
					"profile.php" => "Profile",
				),
				"new_menu" => array(
					"profile.php",
				),
			),
		);
		?>

		<div class="hor-menu hidden-sm hidden-xs">
			<ul class="nav navbar-nav">
				<?php
				foreach ( $menu_array as $k => $sub_menu ) {
					if ( ! is_array( $sub_menu ) ) { ?>
						<li class="<?php echo $_filename == $k ? "active" : ""; ?>">
							<a href="index.php"><?php echo $sub_menu ?></a>
						</li>
					<?php } else { ?>
						<li class="<?php echo array_key_exists( $_filename, $sub_menu["sub_menu"] ) ? "active" : ""; ?>">
							<a data-toggle="dropdown" data-hover="dropdown" data-close-others="true"
							   class="dropdown-toggle"
							   href="javascript:;">
								<?php if ( array_key_exists( $_filename, $sub_menu["sub_menu"] ) ) { ?>
									<span class="selected"></span>
								<?php } ?>
								<?php echo $sub_menu["title"] ?> <i class="fa fa-angle-down"></i>
							</a>
							<ul class="dropdown-menu">
								<?php foreach ( $sub_menu["sub_menu"] as $k2 => $v ) { ?>
									<li class="<?php echo $_filename == $k2 ? "active" : ""; ?>">
										<a href="<?php echo $k2; ?>">
											<?php if ( in_array( $k2, $sub_menu["new_menu"] ) ) { ?>
												<span class="badge badge-roundless badge-important">new</span>
											<?php } ?>
											<?php echo $v; ?>
										</a>
									</li>
								<?php } ?>
							</ul>
						</li>
					<?php }
				}
				?>

				<li <?php if ( $_SERVER['REQUEST_URI'] == '/fekara/teacher/student_weekly_report.php' || $_SERVER['REQUEST_URI'] == '/fekara/teacher/student_progress_report.php' ) { ?> class="active" <?php } ?>>
					<a data-toggle="dropdown" data-hover="dropdown" data-close-others="true" class="dropdown-toggle" href="javascript:;">
						<span class="selected"></span>Report <i class="fa fa-angle-down"></i>
					</a>
					<ul class="dropdown-menu">
						<li <?php if ( $_SERVER['REQUEST_URI'] == '/fekara/teacher/student_weekly_report.php' ) { ?> class="active" <?php } ?>>
							<a href="student_weekly_report.php">Student weekly report</a>
						</li>
						<li <?php if ( $_SERVER['REQUEST_URI'] == '/fekara/teacher/student_progress_report.php' ) { ?> class="active" <?php } ?>>
							<a href="student_progress_report.php">Student Progress Report</a>
						</li>
					</ul>
				</li>

			</ul>
		</div>

		<a href="javascript:;" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
			<img src="<?php echo ASSETS_URL ?>img/menu-toggler.png" alt="" />
		</a>

		<ul class="nav navbar-nav pull-right">
			<li class="dropdown user">
				<a href="#" class="dropdown-toggle" data-toggle="dropdown" data-hover="dropdown"
				   data-close-others="true">
					<img alt="" src="<?php echo ASSETS_URL ?>img/avatar1_small.jpg" />
					<span class="username">
					<?php echo $_SESSION[ $guardian->get_session_var() ]["email"]; ?>
				    </span>
					<i class="fa fa-angle-down"></i>
				</a>
				<ul class="dropdown-menu">
					<li>
						<a href="profile.php"><i class="fa fa-user"></i> My Profile</a>
					</li>
					<li class="divider"></li>
					<li>
						<a href="logout.php"><i class="fa fa-key"></i> Log Out</a>
					</li>
				</ul>
			</li>
		</ul>
	</div>
</div>
<div class="clearfix"></div>