<?php
$title = "Student Weekly Report";

$_GET["student_id"] = isset( $_GET["student_id"] ) ? $_GET["student_id"] : 0;

include_once( __DIR__ . "/header.php" );
$BatchClass = new BatchClass;
$C          = $BatchClass->get_list();
$Subject    = new Subject;
$S          = $Subject->get_list( "orderby=subject" );
//$g          = $guardian->get_guardiandata( $guardian_id );
$students = $guardian->get_attached_students( "guardian_id={$guardian_id}&mysql_cols=name,id&pagesize=500" );
?>

<div class="page-container">
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( "Student Weekly Report" ) ?>
						<small><?php _e( "Generate report" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>">Home</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#">Reporting</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#">Student Weekly Report</a>
						</li>
					</ul>
				</div>
			</div>

			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i>Generate Report
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<a href="#portlet-config" data-toggle="modal" class="config"></a>
								<a href="javascript:;" class="reload"></a>
								<a href="javascript:;" class="remove"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form id="report_form" action="<?php echo DOMAIN_URL ?>download_student_weekly_report.php" class="form-horizontal form-bordered" onsubmit="return Form(1);">
								<div class="form-group">
									<label class="control-label col-md-3">Select Student</label>
									<div class="col-md-4">
										<!--										<input autocomplete="off" value="--><?php //echo $_GET["student_id"] ?><!--" required="required" type="text" class="form-control input-xlarge" name="student_id" id="student_id" />-->
										<!--										-->
										<select class="form-control select2" name="student_id" id="student_id">
											<?php foreach ( $students["rows"] as $student ) { ?>
												<option value="<?php echo $student["id"] ?>"><?php echo $student["name"] ?></option>
											<?php } ?>
										</select>

										<p class="help-block">
											<?php _e( "Select student" ) ?>
										</p>
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-md-3">Test/Exam Schedule Date Range</label>
									<div class="col-md-4">
										<div class="input-group input-xlarge date-picker input-daterange" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>">
											<input value="<?php echo date( "01-m-Y" ) ?>" required="required" type="text" class="form-control" name="from" placeholder="From Date">
											<span class="input-group-addon">
												to
											</span>
											<input value="<?php echo \Dates::my_date() ?>" required="required" type="text" class="form-control" name="to" placeholder="<?php echo __("To Date") ?>">
										</div>
										<!-- /input-group -->
										<span class="help-block">
											<?php _e( "Select date range" ) ?>
										</span>
									</div>
								</div>
								<div id="moresubjects"></div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<div class="btn-group">
											<button type="button" onclick="Form(1)" class="btn green"><?php _e( "View Report" ) ?></button>
											<button type="button" onclick="Form(2)" name="smsBtn" class="btn yellow"><?php _e( "Send SMS" ) ?></button>
											<button type="button" onclick="Form(3)" name="downBtn" class="btn blue"><?php _e( "Download Report" ) ?></button>
										</div>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>
<script src="<?php echo ASSETS_URL ?>plugins/bootstrap/js/bootstrap2-typeahead.min.js" type="text/javascript"></script>
<script type="text/javascript" src="<?php echo DOMAIN_URL ?>?students_js"></script>

<script type="text/javascript">
	function Sub1( form ) {
		alert( $( form ).serialize() );
		return false;
	}

	$( function() {
		$( "#student_id" ).typeahead( {
			source: Students
		} );
	} );

	function Form( btn ) {
		if ( btn==1 ) {
			u = $( "#report_form" ).serialize() + "&viewBtn";
		} else if ( btn==2 ) {
			u = $( "#report_form" ).serialize() + "&smsBtn";
		} else {
			u = $( "#report_form" ).serialize();
			window.location.href = $( "#report_form" ).attr( "action" ) + "?" + u;
			return false;
		}

		u = $( "#report_form" ).attr( "action" ) + "?" + u;

		$.fancybox( {
			'title': "Weekly Report",
			'href': u,
			'type': 'iframe',
			'width': '90%',
			'height': '90%',
		} );

		return false;
	}
</script>
</body>
<!-- END BODY -->
</html>