<?php
include_once( __DIR__ . '/../library.php' );

if ( ! empty( $_GET["type"] ) ) {
	if ( $_GET["type"] == "assignment_file" && ! empty( $_GET["teacher_id"] ) && ! empty( $_GET["student_id"] ) && ! empty( $_GET["filename"] ) ) {
		$Student = new Student();
		$Teacher = new Teacher();
		if ( ! $Student->is_student_logged_in() && ! $Teacher->is_teacher_logged_in() ) {
			echo __( "You'r not allowed to access this file." );
			exit;
		}

		$checked = false;
		if ( $Student->is_student_logged_in() && $_GET["student_id"] <> $Student->my_id() ) {
			echo __( "You'r not allowed to access this file." );
			exit;
		} else if ( $Student->is_student_logged_in() && $_GET["student_id"] == $Student->my_id() ) {
			$checked = true;
		}

		if ( ! $checked && $Teacher->is_teacher_logged_in() && $_GET["teacher_id"] <> $Teacher->my_id() ) {
			echo __( "You'r not allowed to access this file." );
			exit;
		}

		$_GET["path"] = basename( STUDENT_FILES ) . "/" . $_GET["student_id"] . "/assignments/" . $_GET["teacher_id"] . "/" . $_GET["filename"];
	}
}

## Break execution if file path missing in query string.
if ( ! isset( $_GET['path'] ) ) {
	echo __( "File path missing." );
	exit;
}
## Break if path doesn't exists.
$path = ROOT_PATH . "contents/" . $_GET['path'];
if ( ! is_readable( $path ) ) {
	echo __( "File not found on server." );
	exit;
}
$mime_type = mime_content_type( $path );

## Setting headers for file download using feFara downloader.
header( 'Content-Description: File Transfer' );
header( 'Content-Type: ' . $mime_type );
//header( 'Content-Disposition: attachment; filename="' . basename( $path ) . '";' );
header( 'Content-Transfer-Encoding: binary' );
header( 'Expires: 0' );
//header( 'Cache-Control: must-revalidate, max-age=0' );
header( 'Cache-Control: private' );
header( 'Pragma: public' );
header( 'Content-Length: ' . filesize( $path ) );

if ( ob_get_contents() ) {
	ob_clean();
	flush();
}
readfile( $path );