<?php
if ( isset( $_SERVER['PATH_INFO'] ) ) {
	$pathinfo = $_SERVER['PATH_INFO'];
} else {
	$pathinfo = '';
}

$pathinfo_array = explode( '?', $pathinfo );
$pathinfo       = str_replace( "%", "%25", $pathinfo_array[0] );
$req_uri        = $_SERVER['REQUEST_URI'];
$req_uri_array  = explode( '?', $req_uri );
$req_uri        = $req_uri_array[0];
$self           = $_SERVER['PHP_SELF'];
$home_path      = ROOT_URL;
$home_path      = trim( $home_path, '/' );

$req_uri  = str_replace( $pathinfo, '', rawurldecode( $req_uri ) );
$req_uri  = trim( $req_uri, '/' );
$req_uri  = preg_replace( "|^$home_path|", '', $req_uri );
$req_uri  = trim( $req_uri, '/' );
$pathinfo = trim( $pathinfo, '/' );
$pathinfo = preg_replace( "|^$home_path|", '', $pathinfo );
$pathinfo = trim( $pathinfo, '/' );
$self     = trim( $self, '/' );
$self     = preg_replace( "|^$home_path|", '', $self );
$self     = trim( $self, '/' );

if ( ! empty( $pathinfo ) && ! preg_match( '|^.*index.php$|', $pathinfo ) ) {
	$request = $pathinfo;
} else {
	// If the request uri is the index, blank it out so that we don't try to match it against a rule.
	if ( $req_uri == 'index.php' ) {
		$req_uri = '';
	}
	$request = $req_uri;
}
#$request = strtolower($request);
$includeMe = "";

$parts = explode( "/", $request );
if ( ! empty( $includeMe ) && ! file_exists( \Theme::path() . $includeMe ) ) {
	$includeMe = "";
}

if ( empty( $includeMe ) )
	switch ( $request ) {
		case "":
			$includeMe = "index.php";
			break;
		case "index.html":
		case "index.htm":
		case "index.php":
		case "home.htm":
		case "home.php":
		case "default.html":
		case "default.htm":
			Urls::redirect( DOMAIN_URL );
			break;
		case "ajax.html":
			include_once( ROOT_PATH . 'includes/old_ajax.php' );
			exit;
		case "php":
		case "phpinfo":
			echo "<h1>Server Info</h1>";
			@phpinfo();
			die;
		case "new/admission";
			$includeMe = "admission.php";
			break;
		case "app/settings":
			$includeMe = "app_settings.php";
			break;
		case "students.js";
			include_once( __DIR__ . "/../themes/_common/students.js.php" );
			exit;
			break;
		case "27_12_1973__06_11_1977.html":
			include_once( __DIR__ . "/app_api.php" );
			exit;
			break;
		case "update_me":
			echo "<b>Fekara Software update is in progress:</b><br>";
			echo "<br><a href='" . DOMAIN_URL . "'>Back to FeKara</a><br><br>";
			include_once( __DIR__ . "/update.php" );
			die;
			break;
		case "authenticate_api.html":
			include_once( __DIR__ . "/authenticate_api.php" );
			exit;
			break;
		default:
			$_url     = str_replace( ".html", "", $request );
			$parts[0] = isset( $parts[0] ) ? $parts[0] : '';
			if ( $parts[0] == "6111977" ) {
				include_once( __DIR__ . "/6111977.php" );
				exit( 0 );
			} else if ( in_array( $_url, Urls::CommonURLArray ) ) {
				include_once( ROOT_PATH . "themes/_common/" . $_url . ".php" );
				exit( 0 );
			} else if ( in_array( $_url, Urls::URLArray ) ) {
				$includeMe = $_url . ".php";
			} else if ( in_array( "*" . $_url, Urls::URLArray ) ) {
				$_url      = str_replace( "/", "_", $_url );
				$includeMe = $_url . ".php";
			} else if ( sizeof( $parts ) == 3 && $parts[0] == "student" && $parts[1] == "profile" && is_numeric( $parts[2] ) ) {
				$student_id = $parts[2];
				$_student   = new Student;
				if ( $_student->is_valid_student( "id=$student_id&deleted=-1" ) ) {
					$includeMe = "student_profile.php";
				} else {
					$includeMe = "404.php";
				}
			} else if ( sizeof( $parts ) == 2 && $parts[0] == "admin" && is_numeric( $parts[1] ) ) {
				$admin_id = $parts[1];
				$admins   = new Admins;
				if ( $admin_id == 0 || $admins->is_valid_admin( "id=$admin_id" ) ) {
					$includeMe = "manage_admin.php";
				} else {
					$includeMe = "404.php";
				}
			} else if ( sizeof( $parts ) == 2 && $parts[0] == "new" && $parts[1] == "batch" ) {
				$batch_id  = 0;
				$includeMe = "batch.php";
				break;
			} else if ( sizeof( $parts ) == 2 && $parts[0] == "new" && $parts[1] == "class" ) {
				$class_id  = 0;
				$includeMe = "class.php";
				break;
			} else if ( sizeof( $parts ) == 2 && $parts[0] == "batch" && is_numeric( $parts[1] ) ) {
				$batch = new Batch;
				$data  = $batch->get_list( "id={$parts[1]}&limit=1" );
				if ( is_array( $data ) && isset( $data["id"] ) ) {
					$batch_id  = $parts[1];
					$includeMe = "batch.php";
				} else {
					$includeMe = "404.php";
				}
				break;
			} else if ( sizeof( $parts ) == 2 && $parts[0] == "class" && is_numeric( $parts[1] ) ) {
				$batch = new BatchClass;
				$data  = $batch->get_list( "id={$parts[1]}&limit=1" );
				if ( is_array( $data ) && isset( $data["id"] ) ) {
					$class_id  = $parts[1];
					$includeMe = "class.php";
				} else {
					$includeMe = "404.php";
				}
				break;
			} else {
				if ( sizeof( $parts ) == 1 && substr( $parts[0], - 5 ) == ".html" ) {
					$includeMe = substr( $parts[0], 0, - 5 ) . ".php";
				} elseif ( sizeof( $parts ) > 1 ) {
					if ( substr( $parts[0], - 4 ) == ".php" ) {
						$includeMe = $parts[0];
					} else {
						$includeMe = $parts[0] . ".php";
					}

					for ( $x = 1; $x < sizeof( $parts ); $x += 2 ) {
						$parts[ $x + 1 ]      = isset( $parts[ $x + 1 ] ) ? $parts[ $x + 1 ] : '';
						$_GET[ $parts[ $x ] ] = $parts[ $x + 1 ];
					}
				}
			}
	}

if ( ! file_exists( \Theme::path() . $includeMe ) || empty( $includeMe ) ) {
	//die("File [".$_theme->path().$includeMe."] doesn't exists");
	include_once( \Theme::path() . "404.php" );
} else {
	include_once( \Theme::path() . $includeMe );
}