<?php
if ( ! is_file( __DIR__ . "/config.php" ) ) {
	header( "location: requirements.php" );
	exit;
}
defined( 'ROOT_PATH' ) or define( 'ROOT_PATH', __DIR__ . "/" );
if ( ! function_exists( "is_fekara_server" ) ) {
	function is_fekara_server() {
		if ( ! isset( $_SERVER["HTTP_HOST"] ) ) {
			return false;
		}

		$server = $_SERVER["HTTP_HOST"];

		return substr( $server, - 11 ) == ".fekara.com";
	}
}
if ( isset( $_GET["db_test"] ) ) {
	$confile = __DIR__ . "/config.php";

	if ( ! is_file( $confile ) ) {
		echo "File config.php not exists, Please create config.php";
		exit;
	}

	if ( ! is_writable( $confile ) ) {
		echo "System can't create config.php, Check permissions2";
		exit;
	}

	if ( empty( $_POST["DBSERVER"] ) ) {
		echo "MySQL DB Server/Host missing";
		exit;
	}

	if ( empty( $_POST["DBUSER"] ) ) {
		echo "MySQL DB user missing";
		exit;
	}

	if ( empty( $_POST["DBNAME"] ) ) {
		echo "MySQL DB name missing";
		exit;
	}

	//	function my_autoloader( $class ) {
	//		$class   = trim( $class, "/" );
	//		$class   = trim( $class, '\\' );
	//		$replace = [
	//			"()" => "",
	//			'\\' => "/",
	//		];
	//		$class   = strtr( $class, $replace );
	//		//str_replace( array_keys( $replace ), array_values( $replace ), $class );
	//		//die(LIBRARY_PATH . 'classes/' . $class . '.php');
	//		if ( is_file( LIBRARY_PATH . 'classes' . DIRECTORY_SEPARATOR . $class . '.php' ) ) {
	//			include_once( LIBRARY_PATH . 'classes' . DIRECTORY_SEPARATOR . $class . '.php' );
	//		}
	//	}
	//
	//	spl_autoload_register( 'my_autoloader' );

	$require = require __DIR__ . "/vendor/autoload.php";

	if ( is_file( __DIR__ . '/source/library/classes/Student.php' ) ) {
		$require->addPsr4( '', __DIR__ . '/source/library/classes' );
	} else {
		$require->addPsr4( '', __DIR__ . '/library/classes' );
	}

	//	include_once( __DIR__ . "/library/classes/DB.php" );
	//	$DB = new DB( $_POST["DBUSER"], $_POST["DBPASS"], $_POST["DBNAME"], $_POST["DBSERVER"] );

	$content = <<<TAG
<?php
define('ALLOK', true);

define('DBSERVER', '{$_POST["DBSERVER"]}');
define('DBNAME', '{$_POST["DBNAME"]}');
define('DBUSER', '{$_POST["DBUSER"]}');
define('DBPASS', '{$_POST["DBPASS"]}');

TAG;

	if ( isset( $_POST["paid"] ) ) {
		$content .= "\n\n";
		$content .= "define('PAID', true);";
	}

	@file_put_contents( $confile, $content );
	if ( ! is_file( $confile ) ) {
		echo "System can't create config.php, Check permissions";
		exit;
	}

	echo "OK";
	exit;
}
if ( isset( $_GET["add_user"] ) ) {
	if ( empty( $_POST["username"] ) || empty( $_POST["password"] ) ) {
		echo "Please provide username and password, Both fields";
		exit;
	}
	$API_CALL = true;
	include_once "library.php";
	new MySQL();

	$data = [
		"username" => $_POST["username"],
		"password" => password_hash( $_POST["password"], PASSWORD_BCRYPT ),
		"is_admin" => 1,
		"name"     => "Administrator",
		"active"   => 1,
		"email"    => "change@me.com",
	];

	$response = $db->insert( "admins", $data );
	if ( $response === false ) {
		echo $db->last_error;
	} else {
		echo "OK";
	}
	exit;
}
if ( isset( $_GET["add_admin_user"] ) && ! is_file( __DIR__ . "/config.php" ) ) {
	$API_CALL = true;
	include_once( __DIR__ . "/library.php" );
	header( "location: install.php" );
	exit;
}
/*if ( ! isset( $_GET["add_admin_user"] ) && is_file( __DIR__ . "/config.php" ) ) {
	$API_CALL = true;
	include_once( __DIR__ . "/library.php" );
	header( "location: index.php" );
	exit;
}*/
?><!DOCTYPE html>
<!--[if IE 8]>
<html lang="en" class="ie8 no-js"> <![endif]-->
<!--[if IE 9]>
<html lang="en" class="ie9 no-js"> <![endif]-->
<!--[if !IE]><!-->
<html lang="en" class="no-js">
<!--<![endif]-->
<!-- BEGIN HEAD -->
<head>
	<meta charset="utf-8" />
	<title>Install Fekara</title>
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta content="width=device-width, initial-scale=1.0" name="viewport" />
	<meta content="" name="description" />
	<meta content="" name="author" />
	<meta name="MobileOptimized" content="320">
	<!-- BEGIN GLOBAL MANDATORY STYLES -->
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.8.1/css/all.min.css" />
	<link href="assets/plugins/bootstrap/css/bootstrap.min.css" rel="stylesheet" type="text/css" />
	<link href="assets/plugins/uniform/css/uniform.default.css" rel="stylesheet" type="text/css" />
	<!-- END GLOBAL MANDATORY STYLES -->
	<!-- BEGIN THEME STYLES -->
	<link href="assets/css/style-metronic.css" rel="stylesheet" type="text/css" />
	<link href="assets/css/style.css" rel="stylesheet" type="text/css" />
	<link href="assets/css/style-responsive.css" rel="stylesheet" type="text/css" />
	<link href="assets/css/plugins.css" rel="stylesheet" type="text/css" />
	<link href="assets/css/themes/default.css" rel="stylesheet" type="text/css" id="style_color" />
	<link href="assets/css/pages/error.css" rel="stylesheet" type="text/css" />
	<link href="assets/css/custom.css" rel="stylesheet" type="text/css" />
	<!-- END THEME STYLES -->
	<link rel="shortcut icon" href="favicon.ico" />
</head>
<!-- END HEAD -->
<!-- BEGIN BODY -->
<body class="page-500-full-page">
<div class="row">
	<div class="col-md-12 page-500">
		<div class=" details">
			<?php if ( isset( $_GET["add_admin_user"] ) ) { ?>
				<h3>Add Administrator Account</h3>
				<form role="form" lpformnum="1" id="user_form">
					<div class="form-body">
						<div class="form-group">
							<label for="username">Username</label>
							<div class="input-icon">
								<i class="fa fa-user"></i>
								<input type="text" class="form-control" placeholder="Example: manage or admin" name="username" id="username">
							</div>
							<span class="help-block">
							Provide new admin username.
						</span>
						</div>
						<div class="form-group">
							<label for="DBNAME">Password</label>
							<div class="input-icon">
								<i class="fa fa-database"></i>
								<input type="text" class="form-control" placeholder="admin password" name="password" id="password">
							</div>
							<span class="help-block">
							Provide admin user password.
						</span>
						</div>
						<div style="text-align: center">
							<button type="submit" class="btn blue">Add Admin Account</button>
						</div>
					</div>
				</form>
			<?php } else { ?>
				<h3>Provide DB information</h3>
				<form role="form" lpformnum="1" id="db_form">
					<div class="form-body">
						<div class="form-group">
							<label for="DBSERVER">MySQL Database Server</label>
							<div class="input-icon">
								<i class="fa fa-server"></i>
								<input type="text" class="form-control" placeholder="localhost" name="DBSERVER"
								       id="DBSERVER" required="required">
							</div>
							<span class="help-block">
							Provide database server address or IP. Example: localhost
						</span>
						</div>
						<div class="form-group">
							<label for="DBNAME">MySQL Database Name</label>
							<div class="input-icon">
								<i class="fa fa-database"></i>
								<input type="text" class="form-control" placeholder="db1" name="DBNAME" id="DBNAME"
								       required="required">
							</div>
							<span class="help-block">
							Provide database name. Example: db1
							</span>
						</div>
						<div class="form-group">
							<label for="DBUSER">MySQL Database UserName</label>
							<div class="input-icon">
								<i class="fa fa-user"></i>
								<input type="text" class="form-control" placeholder="db1_user" name="DBUSER" id="DBUSER"
								       required="required">
							</div>
							<span class="help-block">
							Provide database name. Example: db1_user
							</span>
						</div>
						<div class="form-group">
							<label for="DBPASS">MySQL Database Password</label>
							<div class="input-icon">
								<i class="fa fa-key"></i>
								<input type="text" class="form-control" placeholder="password" name="DBPASS" id="DBPASS">
							</div>
							<span class="help-block">
							Provide database password.
							</span>
						</div>
						<div style="text-align: center">
							<button type="submit" class="btn blue">Install Fekara</button>
						</div>
					</div>
				</form>
				<div id="div1"></div>
			<?php } ?>
		</div>
	</div>
</div>
<!-- BEGIN JAVASCRIPTS(Load javascripts at bottom, this will reduce page load time) -->
<!-- BEGIN CORE PLUGINS -->
<!--[if lt IE 9]>
<script src="assets/plugins/respond.min.js"></script>
<script src = "assets/plugins/excanvas.min.js"></script>
<![endif]-->
<script src="assets/plugins/jquery-1.10.2.min.js" type="text/javascript"></script>
<script src="assets/plugins/jquery-migrate-1.2.1.min.js" type="text/javascript"></script>
<script src="assets/plugins/bootstrap/js/bootstrap.min.js" type="text/javascript"></script>
<script src="assets/plugins/bootstrap-hover-dropdown/twitter-bootstrap-hover-dropdown.min.js" type="text/javascript"></script>
<script src="assets/plugins/jquery-slimscroll/jquery.slimscroll.min.js" type="text/javascript"></script>
<script src="assets/plugins/jquery.blockui.min.js" type="text/javascript"></script>
<script src="assets/plugins/jquery.cokie.min.js" type="text/javascript"></script>
<script src="assets/plugins/uniform/jquery.uniform.min.js" type="text/javascript"></script>
<!-- END CORE PLUGINS -->
<script src="assets/scripts/app.js"></script>
<script>
	jQuery( document ).ready( function() {
		App.init();

		$( document ).on( "submit", "#db_form", function( event ) {
			event.preventDefault();
			$( "#db_form button" ).html( "Checking ..." ).prop( "disabled", true );

			$.post( "install.php?db_test", $( "#db_form" ).serialize(), function( data ) {
				if ( data=="OK" ) {
					window.location.href = "index.php";
				} else {
					$( "#db_form button" ).html( "Install Fekara" ).prop( "disabled", false );
					alert( data );
				}
			} );
		} );

		$( document ).on( "submit", "#user_form", function( event ) {
			event.preventDefault();
			$( "#user_form button" ).html( "Checking ..." ).prop( "disabled", true );
			$.post( "install.php?add_user", $( "#user_form" ).serialize(), function( data ) {
				if ( data=="OK" ) {
					window.location.href = "index.php";
				} else {
					$( "#user_form button" ).html( "Add Admin Account" ).prop( "disabled", false );
					alert( data );
				}
			} )
		} );
	} );
</script>
<!-- END JAVASCRIPTS -->
</body>
<!-- END BODY -->
</html>