<?php

// Only for current project.
class App {

	public static function url( $page = "root", $surl = "", $force = false ) {
		# $surl is query string, mostly used for image.html (timthumb)
		global $db;
		$page = strtolower( $page );
		$U    = new Urls();
		switch ( $page ) {
			case "root":
				return DOMAIN_URL;
				break;
			case "home":
			case "index":
				return DOMAIN_URL;
				break;
			case "ajax":
				if ( $us == "0" ) {
					return DOMAIN_URL . "?ajax&action=";
				} else if ( $us == "1" ) {
					return DOMAIN_URL . "includes/old_ajax.php?action=";
				}
				break;
			case "image":
				if ( $us == "0" ) {
					return DOMAIN_URL . "?image&src=" . urlencode( $surl );
				} else if ( $us == "1" ) {
					return DOMAIN_URL . "image.html?";
				}
				break;
			case "logout":
				if ( $us == "0" ) {
					return DOMAIN_URL . "?logout";
				} else if ( $us == "1" ) {
					return DOMAIN_URL . "logout.php";
				}
				break;
			case "search":
				if ( $us == "0" ) {
					return DOMAIN_URL . "?search";
				} else if ( $us == "1" ) {
					return \Urls::get_url( "search" );
				}
				break;
			case "unsub":
				if ( $us == "0" ) {
					//$l = "http".((!empty($_SERVER['HTTPS']))?"s":"")."://".$_SERVER['SERVER_NAME'].ROOT_URL."?un-subscribe&";
					$l = "http://" . $_SERVER['SERVER_NAME'] . ROOT_URL . "?un-subscribe&";
				} else {
					//$l = "http".((!empty($_SERVER['HTTPS']))?"s":"")."://".$_SERVER['SERVER_NAME'].ROOT_URL."un-subscribe.html?";
					$l = "http://" . $_SERVER['SERVER_NAME'] . ROOT_URL . "un-subscribe.html?";
				}

				return $l;
				break;
			default:
				return "#";
		}
	}

	# Check that SMS notifications are on or off
	public static function is_sms_active() {
		if ( ! defined( "SMS_NOTIFICATIONS" ) ) {
			return false;
		} else {
			return ( SMS_NOTIFICATIONS == "1" );
		}
	}

	# Check that EMAIL notifications are on or off
	public static function is_email_active() {
		if ( ! defined( "EMAIL_NOTIFICATIONS" ) ) {
			return false;
		} else {
			return ( EMAIL_NOTIFICATIONS == "1" );
		}
	}

	public static function set_currency( $amount ) {
		$amount = (float) $amount;

		return self::get_currency_symbol() . ' ' . number_format( $amount, self::get_currency_decimals() );
	}

	public static function get_currency_symbol() {
		global $db;
		$c = $db->get_option( "currency" );
		if ( empty( $c ) ) {
			$c = CURRENCY;
		}

		return $c;
	}

	public static function get_currency_decimals() {
		global $db;
		$c = $db->get_option( "currency_dec" );
		if ( empty( $c ) && $c <> "0" ) {
			$c = CURRENCY_DEC;
		}

		return $c;
	}

	public static function get_marks_decimals() {
		global $db;
		$c = $db->get_option( "marks_dec" );
		if ( empty( $c ) && $c <> "0" ) {
			$c = CURRENCY_DEC;
		}

		return $c;
	}

	public static function get_logo( $type = 1, $return_path = false ) {
		global $db;
		if ( $type == 1 ) {
			$logo = $db->get_option( "logo1" );
			if ( empty( $logo ) ) {
				if ( $return_path ) {
					$logo = ASSETS_PATH . "img/logo-big.png";
				} else {
					$logo = ASSETS_URL . "img/logo-big.png";
				}
			}
		} else if ( $type == 2 ) {
			$logo = $db->get_option( "logo2" );
			if ( empty( $logo ) ) {
				if ( $return_path ) {
					$logo = ASSETS_PATH . "img/logo-big.png";
				} else {
					$logo = ASSETS_URL . "img/logo-big.png";
				}
			}
		} else {
			$logo = $db->get_option( "logo3" );
			if ( empty( $logo ) ) {
				if ( $return_path ) {
					$logo = ROOT_PATH . "themes/_common/images/pdf-logo.jpg";
				} else {
					$logo = DOMAIN_URL . "themes/_common/images/pdf-logo.jpg";
				}
			}
		}

		if ( $return_path && substr( $logo, 0, 4 ) == 'http' ) {
			$scheme1 = parse_url( $logo, PHP_URL_SCHEME );
			$scheme2 = parse_url( DOMAIN_URL, PHP_URL_SCHEME );

			if ( $scheme1 <> $scheme2 ) {
				$faraq = str_replace( "http://", "", $logo );
				$faraq = str_replace( "https://", "", $faraq );

				$logo = $scheme2 . "://" . $faraq;
				$logo = str_replace( DOMAIN_URL, ROOT_PATH, $logo );
			}
		}

		return $logo;
	}

	public static function get_logo_static( $type = 1 ) {
		global $db;
		if ( $type == 1 ) {
			$logo = $db->get_option( "logo1" );
			if ( empty( $logo ) ) {
				$logo = ASSETS_URL . "img/logo-big.png";
			}
		} else if ( $type == 2 ) {
			$logo = $db->get_option( "logo2" );
			if ( empty( $logo ) ) {
				$logo = ASSETS_URL . "img/logo-big.png";
			}
		} else {
			$logo = $db->get_option( "logo3" );
			if ( empty( $logo ) ) {
				$logo = DOMAIN_URL . "themes/_common/images/pdf-logo.jpg";
			}
		}

		return $logo;
	}

	public static function get_ajax_image() {
		return DOMAIN_URL . "themes/_common/images/loading.gif";
	}

	public static function date_show( $date = "", $format = "" ) {
		global $db;
		$format = trim((string) $format);
		if ( $format=='' ) {
			global $db;
			$format = $db->get_option( "date_format1" );
		}
		if ($format=='') {
			$format = 'd-M-Y';
		}
		if ( empty( $date ) ) {
			return date( $format );
		} else {
			return date( $format, strtotime( $date ) );
		}
	}

	public static function generate_password( $length = 8 ) {
		$chars = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
		$count = mb_strlen( $chars );

		for ( $i = 0, $result = ''; $i < $length; $i ++ ) {
			$index  = rand( 0, $count - 1 );
			$result .= mb_substr( $chars, $index, 1 );
		}

		return $result;
	}

	public static function process_key( $key, $val ) {
		$val = urlencode( $val );
		$key = urlencode( $key );
		if ( \General::localhost() ) {
			# Old
			//$url = "http://localhost/-/fekara/6111977/?set&key=$key&val=$val&domain=".$_SERVER["HTTP_HOST"]."&domain_url=".DOMAIN_URL."&ver=".VERSION;
			//$url = "http://server.pk/6111977/?set&key=$key&val=$val&domain=".$_SERVER["HTTP_HOST"]."&domain_url=".DOMAIN_URL."&ver=".VERSION;

			# New one
			$url = "http://shakeel.com/fekara_management/api_/6111977.php?set&key=$key&val=$val&domain=" . $_SERVER["HTTP_HOST"] . "&domain_url=" . DOMAIN_URL . "&ver=" . VERSION;
		} else {
			//$url = "http://control.fekara.com/6111977/?set&key=$key&val=$val&domain=".$_SERVER["HTTP_HOST"]."&domain_url=".DOMAIN_URL."&ver=".VERSION;
			$url = "http://app.fekara.com/api_/6111977.php?set&key=$key&val=$val&domain=" . $_SERVER["HTTP_HOST"] . "&domain_url=" . DOMAIN_URL . "&ver=" . VERSION;
		}
		$response = @file_get_contents( $url );
		if ( $key == "pk" && $response == "OK" ) {
			global $db;
			$db->set_option( "aknowledged", "OK" );
			$db->set_option( "process_time", time() );
		}
	}

	public static function get_all_options() {
		global $db;
		$Q    = "SELECT * FROM `options`";
		$rows = $db->get_rows( $Q );

		return json_encode( $rows );
	}

	public static function send_all_options() {

	}
}