<?php

class Attendance {

	var $DB, $DB2;
	var $Table = "attendance";

	function __construct() {
		global $db;
		$this->DB = $db;

		global $db2;
		$this->DB2 = $db2;
	}

	function get_student_attendance( $student_id, $date ) {
		global $db;
		$date = \Dates::mysql_date( $date );
		$Q    = "SELECT `attendance` FROM `attendance` WHERE `student_id`=$student_id AND `date`='$date'";

		return $db->get_var( $Q );
	}

	function get_attendance( $params = "" ) {
		$default = [
			"date"       => "",                 # Blank for current date
			"class_id"   => "0",             # 0 = All classes or 2,3,4,5 for more than one classes
			"subject_id" => "0",
			"return_new" => 1,            # If there is no entry of attendance then return with P if value is 1
			"attendance" => "",
			"batch_id"   => "",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		if ( empty( $params['batch_id'] ) ) {
			$Batch              = new Batch();
			$params['batch_id'] = $Batch->get_active_batch_id();
		}

		$Return = [];
		if ( empty( $date ) ) {
			$date = \Dates::mysql_date();
		} else {
			$date = \Dates::mysql_date( $date );
		}

		global $db;

		$students = (new \Student())->get_students( [
			"batch"           => "-1",
			"class_id"        => $params['class_id'],
			'mysql_cols'      => 'id,name,roll,class_id,class_name,attendance_type',
			'orderby'         => 'name',
			'ignore_subjects' => true,
		] );

		foreach ( $students as $st ) {
			if ( $st["attendance_type"] == "D" ) {
				$F["student_name"] = $st["name"];
				$F["student_id"]   = $st["id"];
				$F['roll']         = $st['roll'];
				$F["date"]         = $date;
				$F["class_id"]     = $st["class_id"];
				$F["class_name"]   = $st["class_name"];

				$Q = "SELECT `attendance` FROM `attendance` WHERE `student_id`='{$st["id"]}' AND `date`='$date' AND `batch_id`='{$params['batch_id']}'";
				if ( ! empty( $_GET["attendance"] ) && is_string( $_GET["attendance"] ) ) {
					$Q .= " AND `attendance`='" . $_GET["attendance"] . "'";
				}
				$Q   .= " ORDER BY `id` DESC LIMIT 1";
				$Att = $db->get_row( $Q );

				if ( ! isset( $Att['attendance'] ) ) {
					if ( $params['return_new'] == 1 ) {
						$F["attendance"] = "P";
						$Return[]        = $F;
					}
				} else {
					$F["attendance"] = $Att["attendance"];
					$Return[]        = $F;
				}
			}
		}

		return $Return;
	}

	function save_attendance( $data, $SMS_to_Absents = false ) {
		$default = [
			"subject_id" => "0",
			"class_id"   => "0",
			"date"       => "",
			"batch_id"   => "",
		];
		$data    = set_args( $data, $default );

		if ( ! isset( $data["subject_id"] ) || empty( $data["class_id"] ) || \Dates::empty_date( $data["date"] ) ) {
			return "Data missing";
		}
		if ( ! isset( $data["attendance"] ) || ! is_array( $data["attendance"] ) ) {
			return "Attendance not valid";
		}
		$data["subject_id"] = (int) $data["subject_id"];
		$data["class_id"]   = (int) $data["class_id"];
		$data["date"]       = \Dates::mysql_date( $data["date"] );

		$SMS = [];
		foreach ( $data["attendance"] as $student_id => $att ) {
			$Q = "SELECT `id` FROM `{$this->Table}` WHERE `student_id`='$student_id' AND `date`='{$data["date"]}'
				AND `subject_id`='{$data["subject_id"]}' AND `class_id`='{$data["class_id"]}' ORDER BY `id` DESC";

			$id = $this->DB->get_var( $Q );

			if ( $att == "A" ) {
				$SMS[] = $student_id;
			}
			$d = [
				"student_id" => $student_id,
				"attendance" => $att,
				"date"       => $data["date"],
				"subject_id" => $data["subject_id"],
				"batch_id"   => $data["batch_id"],
				"class_id"   => $data["class_id"],
			];

			if ( empty( $id ) ) {
				$d["added_ip"]   = \General::myip();
				$d["added_by"]   = \Admins\UserInfo::get_my_id();
				$d["added_time"] = \Dates::mysql_datetime();
				$data["batch_id"] = isset($data["batch_id"])?$data["batch_id"]:0;
				$d["batch_id"]   = $data["batch_id"];
				$response        = $this->DB->insert( "attendance", $d );
			} else {
				$d["edit_by"] = \Admins\UserInfo::get_my_id();
				$response     = $this->DB->update( "attendance", $d, [ "id" => $id ] );
			}
			if ( $response === false ) {
				return "Error: " . $this->DB->last_error;
			}
		}
		if ( $SMS_to_Absents === true ) {
			$_sms = new SMS;
			global $Student;
			$data_array = [];
			foreach ( $SMS as $s ) {
				$stud         = $Student->get_student( $s );
				$G            = $stud["gender"] == "F" ? "daughter" : "son";
				$message      = "Dear Mr. " . $stud["guardian_name"] . "\n" . "Your {$G} {$stud["name"]} is absent from Academy today (" . \Dates::my_date( $data["date"] ) . ").";
				$data_array[] = [ $stud["guardian_cell"], $message ];
			}
			$_sms->add_bulk_to_queue( $data_array );
		}

		return "OK";
	}
}