<?php

class Batch {

	var $Table = "batches";
	const Table = "batches";
	var $TableBatchClass = "batch_classes";
	var $TableStudentsView = "students_view";
	var $DB;

	function __construct() {
		global $db;
		$this->DB = $db;
	}

	function get_list( $params = "" ) {
		$default = [
			"active"  => - 1,
			"limit"   => 0,
			"order"   => "DESC",
			"orderby" => "id",
			"id"      => 0,
		];
		$params  = set_args( $params, $default );
		extract( $params );
		global $db;

		global $db;
		$Q = "SELECT * FROM `$this->Table` WHERE 1";
		if ( $active == 1 || $active == 0 ) {
			$Q .= " AND `active`=$active";
		}

		if ( $id > 0 ) {
			$Q .= " AND `id`=$id";
		}

		$Q .= " ORDER BY `$orderby` $order";
		if ( $limit > 0 ) {
			$Q .= " LIMIT $limit";
		}

		if ( $limit == 1 ) {
			$rows = $this->DB->get_row( $Q );
			if ( ! isset( $rows["id"] ) ) {
				return [];
			}
			$rows["added_time2"]   = \Dates::my_datetime( $rows["added_time"] );
			$rows["added_time3"]   = date( $db->get_option( "date_time_format2" ), strtotime( $rows["added_time"] ) );
			$rows["added_time4"]   = \Dates::human_time_difference( $rows["added_time"] );
			$rows["classes_count"] = $db->get_var( "SELECT COUNT(*) FROM `$this->TableBatchClass`  WHERE `batch_id`=" . $rows["id"] );
			$rows["classes"]       = $db->get_rows( "SELECT * FROM `$this->TableBatchClass` WHERE `batch_id`=" . $rows["id"] );
		} else {
			$rows = $db->get_rows( $Q );
			foreach ( $rows as &$row ) {
				$row["added_time2"]   = \Dates::my_datetime( $row["added_time"] );
				$row["added_time3"]   = date( $db->get_option( "date_time_format2" ), strtotime( $row["added_time"] ) );
				$row["added_time4"]   = \Dates::human_time_difference( $row["added_time"] );
				$row["classes_count"] = $db->get_var( "SELECT COUNT(*) FROM `$this->TableBatchClass` WHERE `batch_id`=" . $row["id"] );
				$row["classes"]       = $db->get_rows( "SELECT * FROM `$this->TableBatchClass` WHERE `batch_id`=" . $row["id"] );
			}
		}

		return $rows;
	}

	/**
	 * @param string|array|csv $batch_id
	 *
	 * @return null|string
	 *
	 * Provide one or more batch ID and get count of classes in Batch.
	 */
	function count_classes( $batch_id = "0" ) {
		$Q = "SELECT COUNT(*) FROM `$this->TableBatchClass` WHERE 1";
		if ( ! empty( $batch_id ) ) {
			$batch_id = \Str::make_array( $batch_id );
			$Q        .= " AND `batch_id` IN ('" . implode( "`,`", $batch_id ) . "')";
		}

		return $this->DB->get_var( $Q );
	}

	function get_active_batch() {
		global $Active_Batch;
		if ( isset( $Active_Batch['id'] ) ) {
			return $Active_Batch;
		}
		$Q = "SELECT * FROM `$this->Table` WHERE `active`='1' ORDER BY `id` DESC LIMIT 1";

		$row = $this->DB->get_row( $Q );
		if ( ! is_array( $row ) ) {
			return false;
		} else {
			return $row;
		}
	}

	public static function get_active_batch_static() {
		global $Active_Batch;
		if ( isset( $Active_Batch['id'] ) ) {
			return $Active_Batch;
		}
		$Q = "SELECT * FROM `" . \MySQL\Tables::table_name( self::Table ) . "` WHERE `active`='1' ORDER BY `id` DESC LIMIT 1";

		global $db;
		$row = $db->get_row( $Q );
		if ( ! is_array( $row ) ) {
			return false;
		} else {
			return $row;
		}
	}

	public static function get_active_batch_name_static() {
		$b = self::get_active_batch_static();

		return $b["batch_name"];
	}

	function get_active_batch_name() {
		$b = $this->get_active_batch();

		return $b["batch_name"];
	}

	function get_active_batch_id() {
		$b = $this->get_active_batch();
		/*global $Active_Batch;
		if ( isset( $Active_Batch['id'] ) ) {
			return $Active_Batch['id'];
		}
		$b = $this->get_active_batch();*/

		return $b["id"];
	}

	public static function get_active_batch_id_static() {
		$b = self::get_active_batch_static();
		/*global $Active_Batch;
		if ( isset( $Active_Batch['id'] ) ) {
			return $Active_Batch['id'];
		}
		$b = $this->get_active_batch();*/

		return $b["id"];
	}

	function save_batch( $data = [] ) {

		extract( $data );

		if ( ! isset( $id ) || ! isset( $active ) ) {
			return "Provide complete data";
		}
		if ( ! isset( $batch_name ) || trim( $batch_name ) == "" ) {
			return "Batch name missing";
		}
		global $db;

		$Q = "SELECT COUNT(*) FROM `batches` WHERE `batch_name`='" . $db->set_string( $batch_name ) . "'";
		if ( $id > 0 ) {
			$Q .= " AND `id`<>$id";
		}
		if ( $db->get_var( $Q ) > 0 ) {
			return ( "Provide different batch name, This name already exists" );
		}

		if ( ( $active == 1 || $active === true ) && $id == 0 ) {
			$ac = $this->get_active_batch();
			if ( $ac !== false ) {
				return "You already have an active batch. So you can't add another active batch";
			}
		} else if ( ( $active == 1 || $active === true ) ) {
			/*$Q = "SELECT COUNT(*) FROM `batches` WHERE `id`<>$id AND `active`=1";
			$ac = $db->get_var($Q);
			if ($ac>0) return "You already have another active batch. So you can't active this batch";*/
			# If you are activating this batch, then all other batches will deactivate
			$Q = "UPDATE `batches` SET `active`=0";
			$db->query( $Q );
		}

		unset( $data["id"] );
		$data["start_date"] = \Dates::mysql_date( $start_date );
		$data["end_date"]   = \Dates::mysql_date( $end_date );
		if ( $id == 0 ) {
			$data["added_by"]   = \Admins\UserInfo::get_my_id();
			$data["added_time"] = \Dates::mysql_datetime();
			$data["added_ip"]   = \General::myip();
			$r                  = $this->DB->insert( "batches", $data );
		} else {
			$r = $this->DB->update( "batches", $data, [ "id" => $id ] );
		}

		if ( $r === false ) {
			return $this->DB->last_error;
		} else {
			return "OK";
		}
	}


	function get_batch_name( $id = 0 ) {
		if ( $id == 0 ) {
			$id = $this->DB->get_var( "SELECT `id` FROM `batches` WHERE `active`='1' ORDER BY `id` DESC LIMIT 1" );
		}
		$Q = "SELECT `batch_name` FROM `$this->Table` WHERE `id`='$id'";

		return $this->DB->get_var( $Q );
	}

	function count_students( $params = "" ) {
		$default = [
			"batch"          => "-1",
			# negative number=current batch,0=all batches,greaten than zero=specific batch id
			"student_active" => "",
			"deleted"        => "0",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		$Q = "SELECT COUNT(*) FROM `$this->TableStudentsView` WHERE 1";

		if ( $student_active == "1" || $student_active == "0" ) {
			$Q .= " AND `active`='$student_active'";
		}

		$batch_id = 0;

		if ( $batch == "-1" ) {
			$batch_id = $this->get_active_batch_id();
		} elseif ( $batch > 0 ) {
			$batch_id = $batch;
		}

		if ( $batch_id > 0 ) {
			$Q2 = "(SELECT `id` class_id FROM `batch_classes` WHERE `batch_id`='$batch_id')";

			//$Q .= " AND `batch_id`='$batch_id'";
			$Q .= " AND `class_id` IN $Q2";
		}

		if ( $deleted == "0" ) {
			$Q .= " AND (`deleted`='0' OR `deleted` IS NULL)";
		} else if ( $deleted == "1" ) {
			$Q .= " AND `deleted`='1'";
		}

		return $this->DB->get_var( $Q );
	}


	function get_all_batches() {
		global $All_Batches;
		if (is_null( $All_Batches)) {
			$Q    = "SELECT * FROM `batches`";
			$rows = $this->DB->get_rows( $Q );

			return $rows;
		} else {
			return $All_Batches;
		}
	}


}