<?php

class BatchClass {

	var $table = "batch_classes";
	const table = "batch_classes";
	var $TableSubjects = "batch_classes_x_subjects";
	var $TableBatches = "batches";
	const TableBatches = "batches";
	var $DB;

	function __construct() {
		global $db;
		$this->DB = $db;
	}

	function get_class( $id ) {
		$Q   = "SELECT * FROM `$this->table` WHERE `id`='$id'";
		$row = $this->DB->get_row( $Q );

		return $row;
	}

	function get_class_data( $id ) {
		$Q   = "SELECT * FROM `$this->table` WHERE `id`='$id'";
		$row = $this->DB->get_row( $Q );

		if ( $row === false ) {
			return [];
		}

		$row["subjects"] = $this->get_subjects( $id );

		return $row;
	}

	public static function get_list_static($params = '') {
		$default = [
			"active"     => - 1,
			"limit"      => 0,
			"order"      => "ASC",
			"orderby"    => "class_name",
			"id"         => 0,
			"exclude"    => 0,              # It can be a array
			"batch_id"   => - 1,            # -1=Current Batch, 0=No Batch, Greator than 0 is batch ID
			"teacher_id" => "0",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		if ( $orderby == "name" ) {
			$orderby = "class_name";
		}

		$Q = "SELECT bc.*, b.batch_name, b.active batch_active,
 		(SELECT COUNT(*) FROM `students` WHERE `class_id`=bc.id AND `active`='1' AND (`deleted`='0' OR `deleted` IS NULL)) students_count
 		FROM `".self::table."` bc, `".self::TableBatches."` b WHERE b.id=bc.batch_id";

		/*$Q = "SELECT bc.*, b.batch_name, b.active batch_active
 		FROM `$this->table` bc, `$this->TableBatches` b WHERE b.id=bc.batch_id";*/

		if ( ! empty( $teacher_id ) ) {
			$Q .= " AND bc.`id` IN (SELECT `class_id` id FROM `teachers_x_classes` WHERE `teacher_id`='$teacher_id')";
		}

		if ( $active == 1 || $active == 0 ) {
			$Q .= " AND bc.`active`=$active";
		}

		if ( $exclude <> "0" ) {
			$exclude = make_param_array( $exclude );
			$Q       .= implode( " `id`<>", $exclude );
		}

		if ( $id > 0 ) {
			$Q .= " AND `id`=$id";
		}
		if ( $batch_id < 0 ) {
			$b        = self::get_active_batch_static();
			$batch_id = $b["id"];
		}
		if ( $batch_id > 0 ) {
			$Q .= " AND `batch_id`=$batch_id";
		}

		$Q .= " ORDER BY $orderby $order";
		if ( $limit > 0 ) {
			$Q .= " LIMIT $limit";
		}

		global $db;

		if ( $limit == 1 ) {
			$rows = $db->get_row( $Q );
			if ( isset( $rows["id"] ) ) {
				$rows["added_time"] = isset($rows["added_time"])?$rows["added_time"]:'';
				$rows["added_time2"]    = \Dates::my_datetime( $rows["added_time"] );
				$rows["added_time3"]    = date( $db->get_option( "date_time_format2" ), strtotime( $rows["added_time"] ) );
				$rows["added_time4"]    = \Dates::human_time_difference( $rows["added_time"] );
				$rows["added_by2"]      = $db->get_var( "SELECT `username` FROM `admins` WHERE `id`=" . $rows["added_by"] );
				$rows["subjects"]       = self::get_subjects_static( $rows["id"] );
				$rows["subjects_count"] = count( $rows["subjects"] );
				$rows["tution_fee"]     = \Fee::get_tution_fee_schedule( $rows["id"] );
				$rows["students_count"] = $db->get_var( "SELECT COUNT(*) FROM `students` WHERE `class_id`='{$rows["id"]}' AND `active`='1' AND (`deleted`='0' OR `deleted` IS NULL)" );
			}
		} else {
			$rows = $db->get_rows( $Q );

			foreach ( $rows as &$row ) {
				$row["added_time2"]    = ( $row["added_time"] );
				$row["added_time3"]    = date( $db->get_option( "date_time_format2" ), strtotime( $row["added_time"] ) );
				$row["added_time4"]    = \Dates::human_time_difference( $row["added_time"] );
				$row["added_by2"]      = $db->get_var( "SELECT `username` FROM `admins` WHERE `id`=" . $row["added_by"] );
				$row["subjects"]       = self::get_subjects_static( $row["id"] );
				$row["subjects_count"] = count( $row["subjects"] );
				//$row["tution_fee"]     = $_fee->get_tution_fee_schedule( $row["id"] );
				$row["students_count"] = $db->get_var( "SELECT COUNT(*) FROM `students` WHERE `class_id`='{$row["id"]}' AND `active`='1' AND (`deleted`='0' OR `deleted` IS NULL)" );
			}
		}

		return $rows;
	}

	function get_list( $params = "" ) {
		$default = [
			"active"     => - 1,
			"limit"      => 0,
			"order"      => "ASC",
			"orderby"    => "class_name",
			"id"         => 0,
			"exclude"    => 0,              # It can be a array
			"batch_id"   => - 1,            # -1=Current Batch, 0=No Batch, Greator than 0 is batch ID
			"teacher_id" => "0",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		if ( $orderby == "name" ) {
			$orderby = "class_name";
		}

		$Q = "SELECT bc.*, b.batch_name, b.active batch_active,
 		(SELECT COUNT(*) FROM `students` WHERE `class_id`=bc.id AND `active`='1' AND (`deleted`='0' OR `deleted` IS NULL)) students_count
 		FROM `$this->table` bc, `$this->TableBatches` b WHERE b.id=bc.batch_id";

		/*$Q = "SELECT bc.*, b.batch_name, b.active batch_active
 		FROM `$this->table` bc, `$this->TableBatches` b WHERE b.id=bc.batch_id";*/

		if ( ! empty( $teacher_id ) ) {
			$Q .= " AND bc.`id` IN (SELECT `class_id` id FROM `teachers_x_classes` WHERE `teacher_id`='$teacher_id')";
		}

		if ( $active == 1 || $active == 0 ) {
			$Q .= " AND bc.`active`=$active";
		}

		if ( $exclude <> "0" ) {
			$exclude = make_param_array( $exclude );
			$Q       .= implode( " `id`<>", $exclude );
		}

		if ( $id > 0 ) {
			$Q .= " AND `id`=$id";
		}
		if ( $batch_id < 0 ) {
			$batch_id = (int) Batch::get_active_batch_id_static();
		}
		if ( $batch_id > 0 ) {
			$Q .= " AND `batch_id`='$batch_id'";
		}

		$Q .= " ORDER BY $orderby $order";
		if ( $limit > 0 ) {
			$Q .= " LIMIT $limit";
		}

		if ( $limit == 1 ) {
			$rows = $this->DB->get_row( $Q );
			if ( isset( $rows["id"] ) ) {
				$rows["added_time"] = isset($rows["added_time"])?$rows["added_time"]:'';
				$rows["added_time2"]    = \Dates::my_datetime( $rows["added_time"] );
				$rows["added_time3"]    = date( $this->DB->get_option( "date_time_format2" ), strtotime( $rows["added_time"] ) );
				$rows["added_time4"]    = \Dates::human_time_difference( $rows["added_time"] );
				$rows["added_by2"]      = $this->DB->get_var( "SELECT `username` FROM `admins` WHERE `id`=" . $rows["added_by"] );
				$rows["subjects"]       = $this->get_subjects( $rows["id"] );
				$rows["subjects_count"] = count( $rows["subjects"] );
				$rows["tution_fee"]     = \Fee::get_tution_fee_schedule( $rows["id"] );
				$rows["students_count"] = $this->DB->get_var( "SELECT COUNT(*) FROM `students` WHERE `class_id`='{$rows["id"]}' AND `active`='1' AND (`deleted`='0' OR `deleted` IS NULL)" );
			}
		} else {
			$rows = $this->DB->get_rows( $Q );

			foreach ( $rows as &$row ) {
				$row["added_time2"]    = ( $row["added_time"] );
				$row["added_time3"]    = date( $this->DB->get_option( "date_time_format2" ), strtotime( $row["added_time"] ) );
				$row["added_time4"]    = \Dates::human_time_difference( $row["added_time"] );
				$row["added_by2"]      = $this->DB->get_var( "SELECT `username` FROM `admins` WHERE `id`=" . $row["added_by"] );
				$row["subjects"]       = $this->get_subjects( $row["id"] );
				$row["subjects_count"] = count( $row["subjects"] );
				//$row["tution_fee"]     = $_fee->get_tution_fee_schedule( $row["id"] );
				$row["students_count"] = $this->DB->get_var( "SELECT COUNT(*) FROM `students` WHERE `class_id`='{$row["id"]}' AND `active`='1' AND (`deleted`='0' OR `deleted` IS NULL)" );
			}
		}

		return $rows;
	}

	function get_class_name( $class_id ) {
		return $this->DB->get_var( "SELECT `class_name` FROM `batch_classes` WHERE `id`=$class_id" );
	}

	public static function get_active_batch_static() {
		$Q = "SELECT * FROM `".self::TableBatches."` WHERE `active`='1' ORDER BY `id` DESC LIMIT 1";
		global $db;

		$row = $db->get_row( $Q );
		if ( is_array( $row ) && isset( $row["id"] ) ) {
			return $row;
		} else {
			return false;
		}
	}

	function get_active_batch() {
		$Q = "SELECT * FROM `{$this->TableBatches}` WHERE `active`='1' ORDER BY `id` DESC LIMIT 1";

		$row = $this->DB->get_row( $Q );
		if ( is_array( $row ) && isset( $row["id"] ) ) {
			return $row;
		} else {
			return false;
		}
	}

	function get_active_batch_name() {
		$b = $this->get_active_batch();

		return $b["batch_name"];
	}

	function get_active_batch_id() {
		$b = $this->get_active_batch();

		return $b["id"];
	}

	function get_batch_name( $id = 0 ) {
		if ( $id == 0 ) {
			$id = $this->DB->get_var( "SELECT `id` FROM `batches` WHERE `active`=1 ORDER BY `id` DESC LIMIT 1" );
		}
		$Q = "SELECT `batch_name` FROM `batches` WHERE `id`=$id";

		return $this->DB->get_var( $Q );
	}

	function save_batchclass( $data = [] ) {
		$default = [
			"id"              => "0",
			"class_name"      => "",
			"batch_id"        => "",
			"active"          => "1",
			"fee"             => "0",
			"admission_fee"   => "0",
			"attendance_type" => "D",
			"subjects"        => [],
		];
		$data    = set_args( $data, $default );
		extract( $data );

		if ( empty( $batch_id ) ) {
			$batch_id = $this->get_active_batch_id();
		}

		if ( empty( $class_name ) ) {
			return __( "Class name missing" );
		}

		# Checking FEE value
		if ( ! empty( $fee ) && ! is_numeric( $fee ) ) {
			return __( "FEE value must be a number" );
		}
		if ( isset( $admission_fee ) && ! is_numeric( $admission_fee ) ) {
			return __( "Admission Fee value must be a number" );
		}

		$Q = "SELECT COUNT(*) FROM `{$this->table}` WHERE `class_name`='$class_name' AND `batch_id`='$batch_id' AND `id`<>'$id'";
		if ( $this->DB->get_var( $Q ) > 0 ) {
			return __( "Class '$class_name' already exists in this session" );
		}

		#$general = new General();

		$subjects = \Str::make_array( $subjects );

		unset( $data["id"] );
		unset( $data["subjects"] );
		/*if ( ! empty( $data["subjects"] ) ) {
			$data["subjects"] = make_array( $data["subjects"] );
			$data["subjects"] = implode( ",", $data["subjects"] );
		} else {
			$data["subjects"] = [];
		}*/
		if ( empty( $id ) ) {
			$data["added_by"]   = \Admins\UserInfo::get_my_id();
			$data["added_time"] = \Dates::mysql_datetime();
			$data["added_ip"]   = \General::myip();

			$response = $this->DB->insert( $this->table, $data );
			if ( $response !== false ) {
				$id = $this->DB->insert_id;
			}
		} else {
			$response = $this->DB->update( $this->table, $data, [ "id" => $id ] );
		}

		if ( $response === false ) {
			return __( $this->DB->last_error );
		}

		## Updating student's batch ID
		$data = [
			"batch_id" => $batch_id,
		];
		$this->DB->update( "students", $data, [ "class_id" => $id ] );

		$this->DB->delete( $this->TableSubjects, [ "class_id" => $id ] );
		foreach ( $subjects as $subject ) {
			$RRR = $this->DB->insert( $this->TableSubjects, [ "class_id" => $id, "subject_id" => $subject ] );
		}

		return "OK" . $id;

		/*global $_admins, $_dates;

		if ( isset( $class_name2 ) && trim( $class_name2 ) <> "" ) {
			$data["class_name"] = $class_name = $class_name2;
			$Q                  = "INSERT INTO `classes` SET `name`='" . $this->DB->set_string( $class_name ) . "',`added_by`=" . \Admins\UserInfo::get_admin() . ",`added_time`=NOW(),`added_ip`='" . $general->myip() . "'";
			@mysqli_query( $Q );
		}
		unset( $data["class_name2"] );

		$Q = "SELECT COUNT(*) FROM `$this->table` WHERE `class_name`='" . $this->DB->set_string( $class_name ) . "' AND `batch_id`=$batch_id";
		if ( $id > 0 ) {
			$Q .= " AND `id`<>'$id'";
		}
		if ( $this->DB->get_var( $Q ) > 0 ) {
			return ( "Provide different class name, This name already exists" );
		}

		unset( $data["fine_id"], $data["type"], $data["id"], $data["subjects"], $data["from_date"], $data["to_date"], $data["due_date"], $data["last_payment"], $data["slab_name"], $data["fee_amount"] );

		if ( empty($id) ) {
			$data["added_by"]   = \Admins\UserInfo::get_my_id();
			$data["added_time"] = mysql_datetime();
			$data["added_ip"]   = $general->myip();
			$r                  = $this->DB->insert( "batch_classes", $data );
			if ( $r !== false ) {
				$id = get_var( "SELECT MAX(`id`) FROM `batch_classes`" );
			}
		} else {
			$r = update( "batch_classes", $data, [], [ "id" => $id ] );
		}
		if ( $r["status"] <> "OK" ) {
			return "Error: " . $r["status"];
		} else {
			# Remove already saved subjects
			$Q = "DELETE FROM `batch_classes_x_subjects` WHERE `class_id`=$id";
			$this->DB->query( $Q );

			# If subjects selected then save new subjects
			if ( isset( $subjects ) && is_array( $subjects ) ):
				$subjects = array_unique( $subjects );
				foreach ( $subjects as $s ) {
					$this->DB->insert( "batch_classes_x_subjects", [ "class_id" => $id, "subject" => $s ] );
				}
			endif;

			# Removing already saved fee schedules
			$Q = "DELETE FROM `batch_classes_x_tution_fee` WHERE `class_id`=$id AND `payable_done`=0";
			$this->DB->query( $Q );

			if ( isset( $from_date ) && is_array( $from_date ) ):
				for ( $x = 0; $x < sizeof( $from_date ); $x ++ ) {
					if ( $_dates->is_date( $from_date[ $x ] ) && $_dates->is_date( $to_date[ $x ] ) && $_dates->is_date( $due_date[ $x ] ) && $_dates->is_date( $last_payment[ $x ] ) ) {  // && strtotime(date("d-m-Y"))<=strtotime($due_date[$x])
						$fee_amount[ $x ] = (float) $fee_amount[ $x ];
						if ( $fee_amount[ $x ] <= 0 ) {
							$fee_amount[ $x ] = $data["fee"];
						}
						$type[ $x ] = ! isset( $type[ $x ] ) ? "Tution" : $type[ $x ];
						$data2      = [
							'from_date'    => $_dates->mysql_date( $from_date[ $x ] ),
							'to_date'      => $_dates->mysql_date( $to_date[ $x ] ),
							'due_date'     => $_dates->mysql_date( $due_date[ $x ] ),
							'last_payment' => $_dates->mysql_date( $last_payment[ $x ] ),
							'added_by'     => \Admins\UserInfo::get_my_id(),
							'added_time'   => $_dates->mysql_datetime(),
							'added_ip'     => $general->myip(),
							'slab_name'    => $slab_name[ $x ],
							'class_id'     => $id,
							'fee_amount'   => $fee_amount[ $x ],
							"type"         => $type[ $x ],
							"payable_done" => 0,
							"fine_id"      => $fine_id[ $x ],
						];
						if ( strtotime( $data2["due_date"] ) > strtotime( $data2["last_payment"] ) ) {
							$data2["last_payment"] = $data2["due_date"];
						}
						if ( empty( $data2["slab_name"] ) ) {
							$data2["slab_name"] = date( "M-Y", strtotime( $data2["due_date"] ) ) . " Fee # " . rand();
						}
						$this->DB->insert( "batch_classes_x_tution_fee", $data2 );
					}
				}
			endif;

			return "OK" . $id;*/
	}

	function get_admission_fee( $batch_class_id ) {
		$Q = "SELECT `admission_fee` FROM `batch_classes` WHERE `id`=$batch_class_id";

		return $this->DB->get_var( $Q );
	}

	function get_tution_fee( $batch_class_id ) {
		$Q = "SELECT `fee` FROM `batch_classes` WHERE `id`=$batch_class_id";

		return $this->DB->get_var( $Q );
	}

	function get_subjects( $class_id = 0 ) {
		$Q = "SELECT s.* FROM `batch_classes_x_subjects` x, `subjects` s  WHERE 1";
		if ( $class_id > 0 ) {
			$Q .= " AND x.`class_id`='$class_id'"; // AND `subject_id` IS NOT NULL";
		}
		$Q .= " AND s.`id`=x.`subject_id`";

		$rows = $this->DB->get_rows( $Q );

		if ( sizeof( $rows ) == 0 ) {
			$subjects = $this->DB->get_var( "SELECT c.`subjects` FROM `batch_classes` bc, `classes` c WHERE bc.class_name=c.name AND bc.id='$class_id'" );
			if ( ! empty( $subjects ) ) {
				$subjects = explode( ",", trim( $subjects ) );
			} else {
				$subjects = [];
			}
			$rows = [];
			foreach ( $subjects as $subject ) {
				$rows[] = [ "class_id" => $class_id, "subject" => $subject ];
			}
		}
		$Out = [];
		foreach ( $rows as $row ) {
			if ( isset( $row["id"] ) ) {
				$Out[ $row["id"] ] = $row["subject"];
			}
		}

		return $Out;
	}

	function get_subjects_static( $class_id = 0 ) {
		$class_id = (int) $class_id;
		$Q = "SELECT s.* FROM `batch_classes_x_subjects` x, `subjects` s  WHERE 1";
		if ( $class_id > 0 ) {
			$Q .= " AND x.`class_id`='$class_id'"; // AND `subject_id` IS NOT NULL";
		}
		$Q .= " AND s.`id`=x.`subject_id`";

		global $db;

		$rows = $db->get_rows( $Q );

		if ( sizeof( $rows ) == 0 ) {
			$subjects = $db->get_var( "SELECT c.`subjects` FROM `batch_classes` bc, `classes` c WHERE bc.class_name=c.name AND bc.id='$class_id'" );
			if ( ! empty( $subjects ) ) {
				$subjects = explode( ",", trim( $subjects ) );
			} else {
				$subjects = [];
			}
			$rows = [];
			foreach ( $subjects as $subject ) {
				$rows[] = [ "class_id" => $class_id, "subject" => $subject ];
			}
		}
		$Out = [];
		foreach ( $rows as $row ) {
			if ( isset( $row["id"] ) ) {
				$Out[ $row["id"] ] = $row["subject"];
			}
		}

		return $Out;
	}

	function get_class_batch( $batch_class_id ) {
		$Q = "SELECT `batch_name` FROM `batches` b, `batch_classes` bc WHERE bc.id=$batch_class_id AND bc.batch_id=b.id";

		return $this->DB->get_var( $Q );
	}

	function count_students( $class_id ) {
		$Q = "SELECT COUNT(*) FROM `students` WHERE `class_id`='$class_id' AND `active`='1' AND (`deleted`='0' OR `deleted` IS NULL)";

		return $this->DB->get_var( $Q );
	}
}