<?php

class CSV {

	var $Fdelimiter;
	var $Fenclosure;
	var $Fescape;
	var $Ffilename;
	var $isHeader;

	public function __construct( $filename = '', $delimiter = ',', $enclosure = '"', $escape = '\\' ) {
		$this->Fdelimiter = $delimiter;
		$this->Fenclosure = $enclosure;
		$this->Fescape    = $escape;
		$this->Ffilename  = str_replace( chr( 92 ), "/", $filename );
		$this->isHeader   = true;
		//if (!file_exists($filename)) trigger_error("CSV File doesn't exists.",E_USER_ERROR);
	}

	public function toArray() {
		if ( ! file_exists( $this->Ffilename ) ) {
			return [];
		}
		$ar  = file( $this->Ffilename );
		$Out = [];
		if ( $this->isHeader && count( $ar ) > 1 ) {
			$arr = str_getcsv( $ar[0], $this->Fdelimiter, $this->Fenclosure, $this->Fescape );
			$arr = array_map('strtolower', $arr);
			foreach ( $arr as $v ) {
				$Header[] = str_replace( " ", "_", $v );
			}

			$Header = Arrays::replace_array( $Header, "first_name", "name" );
		} else {
			$Header = [];
		}

		if ( $this->isHeader ) {
			$start = 1;
		} else {
			$start = 0;
		}
		for ( $x = $start; $x < count( $ar ); $x ++ ) {
			$arr = str_getcsv( $ar[ $x ], $this->Fdelimiter, $this->Fenclosure, $this->Fescape );
			if ( $start == "0" ) {
				$Out[] = $arr;
			} else {
				$ar2 = [];
				for ( $y = 0; $y < count( $arr ); $y ++ ) {
					$arr[ $y ] = isset($arr[ $y ])?$arr[ $y ]:'';
					if ( isset( $Header[ $y ] ) ) {
						$f         = \Str::xtrim( $Header[ $y ] );
						$ar2[ $f ] = \Str::xtrim( $arr[ $y ] );
					} else {
						$ar2[] = \Str::xtrim( $arr[ $y ] );
					}
				}
				$Out[] = $ar2;
			}
		}

		return $Out;
	}

	function File( array &$fields, $filename ) {
		$delimiter    = $this->Fdelimiter;
		$enclosure    = $this->Fenclosure;
		$outputBuffer = fopen( $filename, 'w' );

		foreach ( $fields as $f ) {
			fputcsv( $outputBuffer, $f, $delimiter, $enclosure );
		}
		fclose( $outputBuffer );
	}

	function array_to_file( $ar, $filename, $is_header = true ) {
		$x = 1;
		if ( ! $fp = fopen( $filename, 'w' ) ) {
			return false;
		}
		foreach ( $ar as $row ) {
			if ( $x == 1 && $is_header ) {
				$a = [];
				foreach ( $row as $k => $v ) {
					$a[] = $k;
				}
				$a[] = basename( $filename );
				fputcsv( $fp, $a, $this->Fdelimiter, $this->Fenclosure );
			}
			fputcsv( $fp, $row );
			$x ++;
		}
		fclose( $fp );

		return true;
	}
}