<?php

class Classes {

	var $table = "classes";
	var $TableBatchClasses = "batch_classes";
	var $TableTeacherClasses = "teachers_x_classes";
	var $DB;

	function __construct() {
		register_shutdown_function( [ &$this, '__destruct' ] );
		global $db;
		$this->DB = $db;
	}

	function __destruct() {
		return true;
	}

	function get_list( $params = "" ) {
		$default = [
			"cols"       => "*",
//			"teacher_id" => "",
			"orderby"    => "id",
			"order"      => "DESC",
			"where"      => "",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		if ( $cols == "*" ) {
			$Q = "SELECT * FROM `{$this->table}` c WHERE 1";
		} else {
			/*$cols = explode( ",", $cols );
			foreach ( $cols as &$col ) {
				$col = "`" . $col . "`";
			}
			$cols = implode( ",", $cols );*/
			$Q = "SELECT {$cols} FROM `{$this->table}` c WHERE 1";
		}
		if ( ! empty( $where ) ) {
			$Q .= " AND {$where}";
		}

		/*if ( ! empty( $teacher_id ) ) {
			$teacher_id  = make_array( $teacher_id );
			$teacher_ids = $this->DB->get_var( "SELECT GROUP_CONCAT(`class_id`) FROM `{$this->TableTeacherClasses}` WHERE `teacher_id` IN ('" . implode( "','", $teacher_id ) . "')" );
			if ( ! empty( $teacher_ids ) ) {
				$Q .= " AND `id` IN ({$teacher_ids})";
			}
		}*/

		$Q    .= " ORDER BY `{$orderby}` {$order}";

		$rows = $this->DB->get_rows( $Q );
		foreach ( $rows as &$row ) {
			if ( empty( $row["subjects"] ) ) {
				$row["subjects"] = [];
			} else {
				$row["subjects"] = explode( ",", trim( $row["subjects"] ) );
			}
			$row["subjects_count"] = sizeof( $row["subjects"] );
		}

		return $rows;
	}

	function get_array( $cols = "*", $orderby = "id", $order = "DESC", $where = "" ) {
		if ( $cols == "*" ) {
			$Q = "SELECT * FROM `$this->table` WHERE 1";
		} else {
			$cols = explode( ",", $cols );
			foreach ( $cols as &$col ) {
				$col = "`" . $col . "`";
			}
			$cols = implode( ",", $cols );
			$Q    = "SELECT $cols FROM `$this->table` WHERE 1";
		}
		if ( trim( $where ) <> "" ) {
			$Q .= " AND " . $where;
		}
		$Q    .= " ORDER BY `$orderby` $order";
		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	function get_array2( $cols = "*", $page = 1, $pagesize = 50, $orderby = "id", $order = "DESC", $where = "" ) {
		if ( $cols == "*" ) {
			$Q = "SELECT * FROM `$this->table` WHERE 1";
		} else {
			$cols = explode( ",", $cols );
			foreach ( $cols as &$col ) {
				$col = "`" . $col . "`";
			}
			$cols = implode( ",", $cols );
			$Q    = "SELECT $cols FROM `$this->table` WHERE 1";
		}
		if ( trim( $where ) <> "" ) {
			$Q .= " AND " . $where;
		}
		$Q    .= " ORDER BY `$orderby` $order";
		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	public function count( $params = "" ) {
		$default = [];
		$params  = set_args( $params, $default );
		extract( $params );

		$Q = "SELECT COUNT(*) FROM `classes` WHERE 1";

		return $this->DB->get_var( $Q );
	}

	function get_class_name( $class_id ) {
		return $this->DB->get_var( "SELECT `name` FROM `classes` WHERE `id`=$class_id" );
	}

	function get_class( $params = "" ) {
		$default = [
			"id" => "0",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		$Q = "SELECT * FROM `classes` WHERE 1";
		if ( $id > 0 ) {
			$Q .= " AND `id`='$id'";
		}

		$row = $this->DB->get_row( $Q );
		if ( $row === false ) {
			return [];
		}
		if ( $row["subjects"] == "" ) {
			$row["Subjects"] = [];
		} else {
			$row["Subjects"] = explode( ",", trim( $row["subjects"] ) );
		}

		$row["subjects_count"] = sizeof( $row["Subjects"] );

		return $row;

	}

	function get_class_data( $id ) {
		$Q   = "SELECT * FROM `classes` WHERE `id`='$id'";
		$row = $this->DB->get_row( $Q );
		if ( $row === false ) {
			return [];
		}
		if ( $row["subjects"] == "" ) {
			$row["Subjects"] = [];
		} else {
			$row["Subjects"] = explode( ",", trim( $row["subjects"] ) );
		}

		$Q = "SELECT * FROM `batch_classes` WHERE `id`='$id'";
		$b = $this->DB->get_row( $Q );
		if ( $b["batch_id"] == "" ) {
			$row["batch_id"] = 0;
		} else {
			$row["batch_id"] = $b["batch_id"];
		}

		//        $Q = "SELECT * FROM `sessions_classes` WHERE `classid`='$id'";
		//        $result = $this->DB->get_rows($Q);
		//        $ids = "";
		//        $result = array_filter($result);
		//        if (!empty($result)) {
		//            foreach ($result as $v) {
		//                $ids[] = $v["sessionid"];
		//            }
		//            if ($ids == "") {
		//                $row["sessions_classes"] = [];
		//            } else {
		//                $row["sessions_classes"] = $ids;
		//            }
		//        } else {
		//            $row["sessions_classes"] = [];
		//        }

		$row["subjects_count"] = sizeof( $row["Subjects"] );

		return $row;

	}

	function get_active_batch() {
		$Q   = "SELECT * FROM `batches` WHERE `active`=1 ORDER BY `id` DESC LIMIT 1";
		$row = $this->DB->get_row( $Q );
		if ( is_array( $row ) && isset( $row["id"] ) ) {
			return $row;
		} else {
			return false;
		}
	}

	function get_active_batch_name() {
		$b = $this->get_active_batch();

		return $b["batch_name"];
	}


	function save( $array = [] ) {
		$default = [
			"id"              => "0",
			"name"            => "",
			"batch_id"        => [],
			"active"          => "1",
			"fee"             => "0",
			"admission_fee"   => "0",
			"attendance_type" => "D",
		];
		$array   = set_args( $array, $default );
		extract( $array );

		// check class name
		if ( ! isset( $name ) || trim( $name ) == "" ) {
			return ( "Class name missing." );
		}
		// check duplicate class name

		$Q = "SELECT COUNT(*) FROM `{$this->table}` WHERE `name`='" . $this->DB->_escape( $name ) . "' AND `id`<>'$id'";

		if ( $this->DB->get_var( $Q ) > 0 ) {
			return ( "This class already exists. (" . $name . ")" );
		}
		// subjects name
		if ( isset( $array["subjects"] ) && ! empty( $array["subjects"] ) ) {
			$subjects = implode( ",", $array["subjects"] );
		} else {
			$subjects = "";
		}

		if ( empty( $id ) ) {
			$data["added_by"]   = \Admins\UserInfo::get_my_id();
			$data["added_time"] = \Dates::mysql_datetime();
			$data["added_ip"]   = \General::myip();
			$data["name"]       = $name;
			$r                  = $this->DB->insert( $this->table, $data );

			if ( $r === false ) {
				return $this->DB->last_error;
			}

			$id = $this->DB->insert_id;
		} else {
			$r = $this->DB->update( $this->table, $data, [ "id" => $id ] );

			if ( $r === false ) {
				return $this->DB->last_error;
			}
		}

		if ( ! empty( $batch_id ) ) {
			$batch_id = \Str::make_array( $batch_id );
			foreach ( $batch_id as $batch ) {
				if ( $this->DB->get_var( "SELECT COUNT(*) FROM `{$this->TableBatchClasses}` WHERE `class_id`='$id' AND `batch_id`='$batch'" ) == 0 ) {
					$data = [
						"class_id"        => $id,
						"batch_id"        => $batch,
						"active"          => $active,
						"added_by"        => \Admins\UserInfo::get_my_id(),
						"added_time"      => \Dates::mysql_datetime(),
						"added_ip"        => \General::myip(),
						"fee"             => $fee,
						"admission_fee"   => $admission_fee,
						"attendance_type" => $attendance_type,
					];
					$r    = $this->DB->insert( $this->TableBatchClasses, $data );
				} else {

				}
			}
		}

		/*$data = [
			"class_name" => $name,
			"batch_id"   => $batch_id,
			"class_id"   => $id,
			"subjects"   => $subjects,
			"active"     => "1",
			"added_by"   => get_my_id(),
			"added_time" => mysql_datetime(),
			"added_ip"   => myip(),
		];
		$this->DB->insert( "batch_classes", $data );

		$batch_class["class_name"] = $array["name"];
		$batch_class["subjects"]   = $subjects;
		$batch_class["batch_id"]   = $batch_id;
		$r                         = $this->DB->update( "batch_classes", $batch_class, [ "id" => $id ] );

		unset( $array["batch_id"], $array["current_batchid"] );
		$array["subjects"] = $subjects;
		$r                 = $this->DB->update( "classes", $array, [ "id" => $id ] );
		$sid               = "";

		if ( isset( $current_batchid ) && $current_batchid != $batch_id ) {
			$Q    = "SELECT * FROM `students_view` WHERE `batch_id`='$current_batchid'";
			$rows = $this->DB->get_rows( $Q );
			if ( ! empty( $rows ) ) {
				foreach ( $rows as $row ) {
					$studentid = $row["id"];
					$classid   = $row["class_id"];

					$Q          = "SELECT * FROM `students_clone` WHERE `student_id`!='$studentid' AND `batch_id`!='$current_batchid'";
					$rows_clone = $this->DB->get_rows( $Q );
					if ( isset( $rows_clone ) && count( $rows_clone ) == 0 ) {

						$row["student_id"] = $studentid;
						$row["batch_id"]   = $current_batchid;
						insert( "students_clone", $row );

						$students_view["batch_id"] = $batch_id;
						update( "students", $students_view, array(), array( "class_id" => $classid ) );

					}

				}

			}
		}*/


		return "OK";
	}


	function delete( $data = "" ) {
		extract( $data );
		$Q = "DELETE FROM `batch_classes` WHERE `class_id`='$id'";
		$this->DB->query( $Q );
		$Q = "DELETE FROM `classes` WHERE `id`=$id";
		$r = $this->DB->query( $Q );
		if ( $r === false ) {
			return false;
		} else {
			return "OK";
		}
	}


	function get_classdata( $id ) {
		$Q    = "SELECT * FROM `{$this->table}` WHERE `id`='" . $id . "'";
		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	function get_teacherclass_data( $id ) {
		$Q    = "SELECT * FROM `{$this->table}` WHERE `id`='" . $id . "'";
		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

}