<?php

class CourseMaterial {

	var $Table = "course_material";
	public $FilesPath;
	protected $DB;

	function __construct() {
		$this->FilesPath = ROOT_PATH . "contents/courses/";

		if ( ! is_dir( $this->FilesPath ) ) {
			mkdir( $this->FilesPath );
		}

		if ( ! is_file( $this->FilesPath . ".htaccess" ) ) {
			$htaccess_contents = "Order Deny,Allow\nDeny from all\nAllow from 127.0.0.1";
			file_put_contents( $this->FilesPath . ".htaccess", $htaccess_contents );
		}
		global $db;
		$this->DB = $db;

		//      $Q = "ALTER TABLE `$this->Table` ADD `password` VARCHAR(100) NOT NULL AFTER `active`, ADD `login_history` VARCHAR(255) NOT NULL AFTER `password`;";
		//      $db->query($Q);
		//      $Q = "ALTER TABLE `$this->Table` ADD `classassign` TEXT DEFAULT NULL AFTER `login_history` , ADD `courseassign` TEXT DEFAULT NULL AFTER `classassign` , ADD `courseassignClass` TEXT DEFAULT NULL ";
		//      $db->query($Q);
	}

	public function get_courses( $params = "" ) {
		$default = [
			"order"      => "ASC",
			"orderby"    => "name",
			"teacher_id" => "",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		$Q = "SELECT *,
			(SELECT IFNULL(GROUP_CONCAT(`subject` SEPARATOR '@@@@'),'') FROM `subjects` WHERE FIND_IN_SET(`id`,o.`subjects`)>0) subjects_names,
			(SELECT IFNULL(GROUP_CONCAT(`class_name` SEPARATOR '@@@@'),'') FROM `batch_classes` WHERE FIND_IN_SET(`id`,o.`classes`)>0) classes_names,
			(SELECT IFNULL(GROUP_CONCAT(`name` SEPARATOR '@@@@'),'') FROM `teachers` WHERE FIND_IN_SET(`id`,o.`teachers`)>0) teahcers_names
			FROM `{$this->Table}` o WHERE 1";
		// if ($active <> -1) $Q .= " AND `active`=$active";
		// if ($salary <> -1) $Q .= " AND `salary`=$salary";
		// $Q .= " ORDER BY `$orderby` $order";

		if ( ! empty( $teacher_id ) ) {
			$Q .= " AND FIND_IN_SET('{$teacher_id}', `teachers`)>0";
		}

		$Q .= " ORDER BY `$orderby` $order";

		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	function save_course_material( $data, $files ) {
		# Skip $data["id"] or make 0 for new teacher.s
		$id = ( ! isset( $data["id"] ) || empty( $data["id"] ) ) ? 0 : $data["id"];
		$id = (int) $id;
		if ( $id < 0 ) {
			$id = 0;
		}
		unset( $data["id"] );
		global $db;
		$allowed = [
			'pdf',
			'PDF',
			'txt',
			'TXT',
			'xlsx',
			'XLSX',
			'docx',
			'DOCX',
			'ppt',
			'pptx',
			'doc',
			'docx',
			'DOC',
			'png',
			'PNG',
			'jpg',
			'JPG',
			'jpeg',
			'JPEG',
		];

		if ( ! isset( $data["classes"] ) && empty( $data["classes"] ) && empty( $data["subjects"] ) ) {
			return __( "Please select class or subject." );
		}
		if ( ! isset( $data["name"] ) || empty( $data["name"] ) ) {
			return __( "Course name missing" );
		}
		if ( ! isset( $data["description"] ) || empty( $data["description"] ) ) {
			return __( "Description missing" );
		}
		if ( ! empty( $data['classes'] ) ) {
			$cimplode        = implode( ',', $data['classes'] );
			$data['classes'] = $cimplode;
		} else {
			$data['classes'] = '';
		}
		if ( ! empty( $data['subjects'] ) ) {
			$simplode         = implode( ',', $data['subjects'] );
			$data['subjects'] = $simplode;
		} else {
			$data['subjects'] = '';
		}
		if ( ! empty( $data['teachers'] ) ) {
			$simplode         = implode( ',', $data['teachers'] );
			$data['teachers'] = $simplode;
		} else {
			$data['teachers'] = '';
		}
		if ( isset( $files['uploadfile']['name'][0] ) && $files['uploadfile']['name'][0] != '' ) {
			$fileName = [];
			foreach ( $files['uploadfile']['name'] as $name ) {
				$ext = pathinfo( $name, PATHINFO_EXTENSION );
				if ( ! in_array( $ext, $allowed ) ) {
					return 'Invalid file type ' . $name . ' ( .' . $ext . ' )';
				} else {
					$fileName[] = $name;
				}
			}
			if ( ! empty( $fileName ) ) {
				$implode            = implode( '@', $fileName );
				$data['uploadfile'] = $implode;
			}
		}

		$remove_files = [];
		if ( empty( $id ) ) {
			$data["added_by"]   = \Admins\UserInfo::get_my_id();
			$data["added_time"] = \Dates::mysql_datetime();
			$data["added_ip"]   = \General::myip();
			$response           = $this->DB->insert( $this->Table, $data );
			$last_id            = $response["id"];

			if ( ! empty( $files['uploadfile']['name'][0] ) ) {
				$target_dir = $this->FilesPath . $last_id . "/";
				if ( ! is_dir( $target_dir ) ) {
					mkdir( $target_dir );
				}
				foreach ( $files['uploadfile']['name'] as $key => $finsert ) {
					$target_file = $target_dir . $finsert;
					@move_uploaded_file( $files['uploadfile']['tmp_name'][ $key ], $target_file );
				}
			}
		} else {
			if ( isset( $data["remove_files"] ) ) {
				$remove_files = $_POST["remove_files"];
				unset( $data["remove_files"] );
			}

			//            if (!empty($data['classes'])) {
			//                $cimplode = implode(',', $data['classes']);
			//                $data['classes'] = $cimplode;
			//            } else {
			//                $data['classes'] = '';
			//            }
			//            if (!empty($data['subjects']) && $data['subjects']!="") {
			//                $simplode = implode(',', $data['subjects']);
			//                $data['subjects'] = $simplode;
			//            } else {
			//                $data['subjects'] = '';
			//            }
			$Q            = "SELECT * FROM `{$this->Table}` WHERE `id`='$id'";
			$row          = $this->DB->get_row( $Q );
			$previousData = [];
			if ( ! empty( $files['uploadfile']['name'][0] ) ) {
				$previousData[]     = $row['uploadfile'];
				$previousData[]     = $data['uploadfile'];
				$previousData       = implode( "@", $previousData );
				$data['uploadfile'] = $previousData;

				$target_dir = $this->FilesPath . $id . "/";
				if ( ! is_dir( $target_dir ) ) {
					mkdir( $target_dir );
				}
				foreach ( $files['uploadfile']['name'] as $key => $finsert ) {
					$target_file = $target_dir . $finsert;
					move_uploaded_file( $files['uploadfile']['tmp_name'][ $key ], $target_file );
				}
			} else {
				unset( $data['uploadfile'] );
			}
			$response = $this->DB->update( $this->Table, $data, [ "id" => $id ] );
		}

		if ( $response !== false ) {
			foreach ( $remove_files as $file ) {
				$path = $this->FilesPath . $id . "/" . $file;
				if ( is_file( $path ) ) {
					@unlink( $path );
				}
			}

			return "OK";
		} else {
			return $this->DB->last_error;
		}
	}

	public function get_cmData( $id = 0, $fields = "*" ) {
		$Q   = "SELECT * FROM `{$this->Table}` WHERE `id`='$id'";
		$row = $this->DB->get_row( $Q );
		if ( $fields == "*" ) {
			return $row;
		} else {
			$fields = \Str::make_array( $fields );
			$out    = [];
			foreach ( $fields as $field ) {
				if ( isset( $row[ $field ] ) ) {
					$out[ $field ] = $row[ $field ];
				}
			}

			return $out;
		}
	}

	public function file_delete( $data ) {
		$s1          = str_replace( $data['filename'], "", $data['allfile'] );
		$allfile     = explode( "@", $s1 );
		$myArray     = array_filter( $allfile );
		$array_slice = array_slice( $myArray, 0 );
		$implode     = implode( '@', $array_slice );
		$root        = explode( '/', $_SERVER['DOCUMENT_ROOT'] );
		/*if ( in_array( "htdocs", $root ) ) {
			@unlink( ROOT_PATH . "/fekara/contents/courses/" . $data['id'] . "/" . $data['filename'] );
		} else {*/
		@unlink( $this->FilesPath . $data['id'] . "/" . $data['filename'] );
		//}
		$id         = $data['id'];
		$uploadfile = [
			"uploadfile" => $implode,
		];
		$response   = $this->DB->update( $this->Table, $uploadfile, [ "id" => $id ] );

		if ( $response === false ) {
			$this->DB->last_error;
		} else {
			return "OK";
		}
	}

	function get_list( $params = "" ) {
		$default = [ "orderby" => "id", "order" => "DESC", ];
		global $db;
		$params = set_args( $params, $default );
		extract( $params );
		$Q    = "SELECT * FROM `course_material` WHERE 1";
		$Q    .= " ORDER BY `$orderby` $order";
		$rows = $db->get_rows( $Q );

		return $rows;
	}


	function teacher_course_material( $id ) {
		// get teacher classes name
		global $db;
		$Q        = "SELECT * FROM `teachers_x_classes` WHERE `teacherid`='$id'";
		$class    = $db->get_rows( $Q );
		$classids = [];
		if ( ! empty( $class ) and count( $class ) > 0 ) {
			foreach ( $class as $c ) {
				$classids[] = $c["classid"];
			}
		}

		// get teacher subjects name
		$Q             = "SELECT * FROM `teachers_assign_subjects` WHERE `teacherid`='$id'";
		$subjects      = $db->get_rows( $Q );
		$subjectsNames = "";
		if ( ! empty( $subjects ) and count( $subjects ) > 0 ) {
			foreach ( $subjects as $s ) {
				$subjectsNames .= "'" . $s["subjectname"] . "',";
			}
			$subjectsNames = rtrim( $subjectsNames, "," );
		}

		// get subjecct table data
		$Q            = "SELECT * FROM `subjects` WHERE `subject` IN ($subjectsNames)";
		$SubjectTable = $db->get_rows( $Q );
		$subjectids   = [];
		if ( ! empty( $SubjectTable ) and count( $SubjectTable ) > 0 ) {
			foreach ( $SubjectTable as $value ) {
				$subjectids[] = $value["id"];
			}
		}

		// get course material table data
		$Q        = "SELECT * FROM `course_material`";
		$Material = $db->get_rows( $Q );
		$filename = [];
		$material = [];
		if ( ! empty( $Material ) and count( $Material ) > 0 ) {
			foreach ( $Material as $m ) {

				if ( ! empty( $m["classes"] ) ) {
					$class = explode( ",", $m["classes"] );
					if ( ! empty( $class ) ) {
						foreach ( $class as $c ) {
							if ( in_array( $c, $classids ) ) {
								if ( ! empty( $m["uploadfile"] ) ) {
									$ex = explode( '@', $m["uploadfile"] );
									foreach ( $ex as $name ) {
										$filename[] = $name;
										$material[] = DOMAIN_URL . "includes/downloader.php?path=courses/" . $m['id'] . "/" . $name;
									}
								}
							}
						}
					}
				}

				if ( ! empty( $m["subjects"] ) ) {
					$subject = explode( ",", $m["subjects"] );
					if ( ! empty( $subject ) ) {
						foreach ( $subject as $s ) {
							if ( in_array( $s, $classids ) ) {
								if ( ! empty( $m["uploadfile"] ) ) {
									$exs = explode( '@', $m["uploadfile"] );
									foreach ( $exs as $name ) {
										$filename[] = $name;
										$material[] = DOMAIN_URL . "includes/downloader.php?path=courses/" . $m['id'] . "/" . $name;
									}
								}
							}
						}
					}
				}

			}
		}

		/*
			Array
			(
				[0] => HD-Wallpapers-C76.jpg
				[1] => wallpaper-hd-1080p_gdzCfcM.jpg
				[2] => 6768666-1080p-wallpapers.jpg
				[3] => 6768666-1080p-wallpapers.jpg
				[4] => CS201.pdf
				[5] => pier_1080.jpg
				[6] => wallpaper-hd-1080p_gdzCfcM.jpg
			)
		*/

		return array_unique( $material );
	}


	/**
	 * @param $id
	 *
	 * @return string
	 *
	 * Delete one course material using single course ID.
	 */
	function delete( $id ) {
		$response = $this->DB->delete( $this->Table, [ "id" => $id ] );

		if ( $response === false ) {
			return $this->DB->last_error;
		}
		if ( $response === 0 ) {
			return __( "No course material found with ID %1", $id );
		}

		// Removing uploaded files.
		if ( is_dir( $this->FilesPath . $id ) ) {
			\File::rrmdir( $this->FilesPath . $id );
		}

		return "OK";
	}

	function get_files( $id ) {
		$files = $this->FilesPath . $id;
		$files = glob( $files . "/*" );

		return $files;
	}
}