<?php

class Custom {

	var $Table = "meta_data";

	function get_fields( $table_name ) {
		if ( ! is_file( ROOT_PATH . "custom/config.php" ) ) {
			return [];
		}
		include_once ROOT_PATH . "custom/config.php";

		if ( ! isset( $Custom[ $table_name ] ) ) {
			return [];
		}
		$Array = $Custom[ $table_name ];
		foreach ( $Array as $name => &$ar ) {
			if ( ! isset( $ar["label"] ) ) {
				$ar["label"] = ucwords( $name );
			}

			if ( $ar["type"] == "radio" || $ar["type"] == "checkbox" || $ar["type"] == "select" ) {
				if ( ! isset( $ar["data"] ) ) {
					unset( $Array[ $name ] );
					continue;
				}

				$ar["data"] = \Str::make_array( $ar["data"] );
			}

			if ( isset( $ar["required"] ) && ( $ar["required"] === true || $ar["required"] == "1" || strtolower( trim( $ar["required"] ) ) == "true" || strtolower( trim( $ar["required"] ) ) == "yes" ) ) {
				$ar["required"] = "1";
			} else {
				$ar["required"] = "0";
			}
		}

		return $Array;
	}

	function field_to_html( $field_array, $params = "" ) {
		$default = [
			"value"       => "",
			"class"       => "",
			"id"          => "",
			"placeholder" => "",
			"required"    => "0",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		$name            = key( $field_array );
		$field_array     = $field_array[ $name ];
		$output          = [];
		$output["label"] = $field_array["label"];
		$output["html"]  = "";

		$placeholder = strip_tags( $placeholder );
		$required    = $required == "1" ? "required='required'" : "";
		$name        = "custom__" . $name;

		if ( $field_array["type"] == "text" ) {
			$output["html"] = "<input type='text' $required value=\"$value\" class='$class' id='$id' name='$name' placeholder=\"$placeholder\">";
		} else if ( $field_array["type"] == "number" ) {
			$output["html"] = "<input type='number' $required value=\"$value\" class='$class' id='$id' name='$name' placeholder=\"$placeholder\">";
		} else if ( $field_array["type"] == "radio" ) {
			foreach ( $value as $k => $v ) {
				$k = esc_attr( $k );
				$output["html"] .= "<label><input $required type='radio' name='$name' value=\"$k\">" . $v . "</label> ";
			}
		} else if ( $field_array["type"] == "checkbox" ) {
			foreach ( $value as $k => $v ) {
				$k = esc_attr( $k );
				$output["html"] .= "<label><input $required type='checkbox' name='{$name}[]' value=\"$k\">" . $v . "</label> ";
			}
		} else if ( $field_array["type"] == "select" ) {
			$output["html"] = "<select name='{$name}' class='form-control'>";
			foreach ( $value as $k => $v ) {
				$k = esc_attr( $k );
				$output["html"] .= "<option value=\"$k\">" . $v . "</option> ";
			}
			$output["html"] .= "</select>";
		}

		return $output;
	}
}