<?php

class Dates {

	/*function __construct() {
		register_shutdown_function( [ &$this, '__destruct' ] );
	}

	function __destruct() {
		return true;
	}*/

	public static function is_datetime( $datetime ) {
		$response = self::is_date( $datetime );
		if ( $response === false ) {
			return $response;
		}

		$datetime = self::fix_date_string( $datetime );
		$datetime = self::mysql_datetime( $datetime );

		if ( substr( $datetime, - 8 ) == '00:00:00' ) {
			return false;
		}

		return substr( $datetime, 16, 1 ) == ':';
	}

	public static function is_date( $date ) {
		if ( empty( $date ) ) {
			return false;
		}

		$date = self::fix_date_string( $date );

		return (bool) strtotime( $date );
	}

	public static function month_name( $mon, $full = false ) {
		if ( $full ) {
			return date( 'F', mktime( 0, 0, 0, $mon ) );
		} else {
			return date( 'M', mktime( 0, 0, 0, $mon ) );
		}
	}

	public static function GMT_now( $format = "Y-m-d H:i:s" ) {
		return date( $format, time() - date( "Z", time() ) );
	}

	public static function mysql_datetime( $date = '', $format = "Y-m-d H:i:s" ) {
		$date = (string) $date;
		if ( General::xtrim( $date ) == '' ) {
			return date( $format );
		} else {
			$date = self::fix_date_string( $date );

			return date( $format, strtotime( $date ) );
		}
	}

	public static function mysql_date( $date = '', $format = "Y-m-d" ) {
		$date = (string) $date;
		if ( \Str::xtrim( $date ) == '' ) {
			return date( $format );
		} else {
			$date = self::fix_date_string( $date );

			return date( $format, strtotime( $date ) );
		}
	}

	function format( $format = "" ) {
		$DT = new DateTime();

		return $DT->format( $format );
	}

	function getOffset() {
		$DT = new DateTime();

		return $DT->getOffset();
	}

	function getTimezone() {
		$DT = new DateTime();

		return $DT->getTimezone();
	}

	function human_time_difference2( $time1, $time2 = "" ) {
		if ( $time1 == "0000-00-00 00:00:00" || $time2 == "0000-00-00 00:00:00" || $time1 == "" ) {
			return "";
		}
		if ( $time2 == "" ) {
			$time2 = time();
		} else {
			$time2 = strtotime( $time2 );
		}
		$time1 = strtotime( $time1 );

		$diff = $time2 - $time1;
		if ( $diff < 86400 ) {
			return date( "h:i A", $time1 );
		} else {
			return date( "d-M", $time1 );
		}
	}

	public static function human_time_difference( $time1, $time2 = "" ) {
		if ( $time1 == "0000-00-00 00:00:00" || $time2 == "0000-00-00 00:00:00" || $time1 == "" ) {
			return "";
		}
		if ( $time2 == "" ) {
			$time2 = time();
		}
		$time1     = strtotime( $time1 );
		$precision = 6;

		if ( $time1 > $time2 ) {
			$ttime  = $time1;
			$time1  = $time2;
			$time2  = $ttime;
			$prefix = " later";
		} else {
			$prefix = " ago";
		}

		$intervals = [ 'year', 'month', 'day', 'hour', 'minute', 'second' ];
		$diffs     = [];

		foreach ( $intervals as $interval ) {
			// Create temp time from time1 and interval
			$ttime = strtotime( '+1 ' . $interval, $time1 );
			// Set initial values
			$add    = 1;
			$looped = 0;
			// Loop until temp time is smaller than time2
			while ( $time2 >= $ttime ) {
				// Create new temp time from time1 and interval
				$add ++;
				$ttime = strtotime( "+" . $add . " " . $interval, $time1 );
				$looped ++;
			}

			$time1              = strtotime( "+" . $looped . " " . $interval, $time1 );
			$diffs[ $interval ] = $looped;
		}

		$count = 0;
		$times = [];
		// Loop thru all diffs
		foreach ( $diffs as $interval => $value ) {
			// Break if we have needed precission
			if ( $count >= $precision ) {
				break;
			}
			// Add value and interval
			// if value is bigger than 0
			if ( $value > 0 ) {
				// Add s if value is not 1
				if ( $value != 1 ) {
					$interval .= "s";
				}
				// Add value and interval to times array
				$times[] = $value . " " . $interval;
				$count ++;
			}
		}

		// Return string with times
		return implode( " ", $times ) . " " . $prefix;

		$diff = $time2 - $time1;
		if ( $diff <= 60 ) {
			return $diff . " seconds ago";
		} elseif ( $diff <= 3600 ) {
			return round( $diff / 60, 0 ) . " minutes ago";
		} elseif ( $diff <= 86400 ) {
			$h = round( ( $diff / 60 ) / 60, 0 );

			return $h . " hours ago";
		} else {
			return $diff;
		}
	}

	public static function get_week_number( $start_date = "", $date_for_week = "", $end_date = "" ) {  // If $start_date is empty then Year's week number will be counted
		if ( empty( $start_date ) && empty( $date_for_week ) ) {
			return date( "W" );
		}
		if ( empty( $date_for_week ) ) {
			$date_for_week = date( "d-m-Y" );
		}
		if ( empty( $end_date ) ) {
			$end_date = $date_for_week;
		}

		/*$date1 = new DateTime($current_date);

		$start_date = empty($start_date)?date("01-01-Y"):$start_date;
		$date2 = new DateTime($start_date);

		$int = $date2->diff($date1);
		$days = abs($int->format('%R%a'));
		$weeks = $days / 7;
		return ceil($weeks);*/

		//set_time_limit( 0 );
		$loopdate = strtotime( $start_date );
		$to       = strtotime( $end_date );
		$Date     = strtotime( $date_for_week );
		$WeekDay  = 0;
		$OldW     = 0;
		while ( $loopdate <= $to ) {
			$W = date( "W", $loopdate );
			if ( $W <> $OldW ) {
				$WeekDay ++;
				$OldW = $W;
			}
			if ( $Date == $loopdate ) {
				return $WeekDay;
			}
			$loopdate = strtotime( '+1 day', $loopdate );
		}

		return $WeekDay;
	}

	public static function days_difference( $date1, $date2 = "" ) {
		$d1 = new DateTime( $date1 );
		//		$date2 = ( empty( $date2 ) ) ? self::my_date() : $date2;
		$d2 = new DateTime( $date2 );

		$int = $d2->diff( $d1 );

		return $int->days;
	}

	public static function date_array( $first, $last, $step = '+1 day', $format = 'Y-m-d' ) {
		$dates   = [];
		$current = strtotime( $first );
		$last    = strtotime( $last );

		while ( $current <= $last ) {
			$dates[] = date( $format, $current );
			$current = strtotime( $step, $current );
		}

		return $dates;
	}

	public static function weeks_array( $from_date, $to_date ) {
		$all_dates = self::date_array( $from_date, $to_date, "+1 day", "Y-m-d" );
		if ( ! is_array( $all_dates ) ) {
			return [];
		}
		$weeks = [];
		if ( ! isset( $all_dates[0] ) ) {
			return [];
		}
		$day1 = $all_dates[0];
		foreach ( $all_dates as $day ) {
			$d = date( "N", strtotime( $day ) );
			if ( $d == 7 ) {
				$weeks[] = [ "from" => $day1, "to" => $day ];
			}
			if ( $d == 1 ) {
				$day1 = $day;
			}
		}
		if ( ! isset( $day ) ) {
			$day = $day1;
		}
		if ( date( "N", strtotime( $day1 ) ) < 7 ) {
			$weeks[] = [ "from" => $day1, "to" => $day ];
		}

		return $weeks;
	}

	public static function my_date( $date = '', $format = "" ) {
		global $db;
		if ( $format == "" ) {
			$format = $db->get_option( "date_format1" );
		}
		if ( $format == "" ) {
			$format = "d-M-Y";
		}
		$date = (string) $date;
		if ( $date == '' ) {
			return date( $format );
		} else {
			$date = self::fix_date_string( $date );

			return date( $format, strtotime( $date ) );
		}
	}

	public static function fix_date_string( $date ) {
		$date = strtr( $date, [ ',' => '' ] );

		return $date;
	}

	public static function my_datetime( $date = '', $format = "d-M-Y H:i" ) {
		$date = (string) $date;
		if ( $date == '' ) {
			return date( $format );
		} else {
			$date = self::fix_date_string( $date );

			return date( $format, strtotime( $date ) );
		}
	}

	public static function empty_date( $d ) {
		if ( is_null( $d ) || empty( $d ) ) {
			return true;
		}

		if ( $d == "1970-01-01" || $d == "0000-00-00" || $d == "0000-00-00 00:00:00" ) {
			return true;
		}

		return false;
	}

	public static function current_time( $format = 'Y-m-d H:i:s' ) {
		return Date( $format );
	}

	public static function get_time_zone() {
		global $db;
		$tz = $db->get_option( 'time_zone' );
		if ( $tz == "" ) {
			return '5';
		} else {
			return $tz;
		}
	}

	/**
	 * @author Shakeel Ahmed Siddiqi <shakeel@shakeel.pk>
	 *
	 * @param $time
	 *
	 * @return int
	 *
	 * Converts time into seconds.
	 * Example: 15:03 will output to 54180
	 */
	public static function time_to_sec( $time ) {
		$seconds = strtotime( "1970-01-01 $time UTC" );

		return $seconds;
	}

	/**
	 * @return mixed|string
	 *
	 * Set date format for bootstrap date-picker
	 */
	public static function date_format1_for_js() {
		global $db;
		$format = $db->get_option( "date_format1" );

		if ( empty( $format ) ) {
			$format = 'd-M-Y';
		}

		$format_array = [
			'F' => 'MM',
			'j' => 'd',
			'd' => 'dd',
			'Y' => 'yyyy',
			'l' => 'DD',
			'N' => 'w',
			'm' => 'mm',
			'y' => 'yy',
		];
		$format       = strtr( $format, $format_array );

		return $format;
	}
}