<?php

class Datesheet {

	var $Table = "datesheet";
	var $Schedule_Table = "weekly_lecture_schedule";
	var $TableClass = "batch_classes";
	var $DB;

	function __construct() {
		global $db;
		//            $Q = "ALTER TABLE `$this->Table` ADD `class_name` TEXT DEFAULT NULL AFTER `classid`";
		//            $db->query( $Q );
		//            $Q = "ALTER TABLE `$this->Table` ADD `subject_marks` TEXT DEFAULT NULL AFTER `subject_name`";
		//            $db->query( $Q );
		//            $Q = "ALTER TABLE `$this->Table` ADD `subject_time` TEXT DEFAULT NULL AFTER `subject_date`";
		//            $db->query( $Q );
		$Q = "ALTER TABLE `$this->Table` ADD `status` enum('active','deactive') DEFAULT NULL AFTER `added_ip`";
		$db->query( $Q );
		$this->DB = $db;
	}


	function get_datesheet_data( $id, $params = "" ) {
		$default = [
			"order"   => "ASC",
			"orderby" => "class_name",
		];
		$params  = set_args( $params, $default );
		extract( $params );
		$Q = "SELECT * FROM `{$this->Table}` WHERE `id`=$id";
		$Q .= " ORDER BY `$orderby` $order";
		global $db;
		$rows = $db->get_rows( $Q );

		return $rows;
	}


	function get_datesheet( $params = "" ) {
		$default = [
			"order"   => "ASC",
			"orderby" => "class_name",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		$Q = "SELECT d.*, c.class_name FROM `{$this->Table}` d, `{$this->TableClass}` c WHERE d.class_id=c.id";
		$Q .= " ORDER BY `$orderby` $order";

		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	function save( $args = [] ) {
		$default = [
			"id"            => "0",
			"class_id"      => "",
			"subject_name"  => "",
			"subject_marks" => "",
			"subject_time"  => "",
			"subject_date"  => "",
		];
		$array   = set_args( $args, $default );
		extract( $array );

		if ( empty( $class_id ) ) {
			return __( "Please select class" );
		}

		$subject_name = \Str::make_array( $subject_name );
		if ( count( $subject_name ) == 0 ) {
			return __( "Please select one or more subjects" );
		}

		$subject_marks = \Str::make_array( $subject_marks );
		$subject_time  = \Str::make_array( $subject_time );
		$subject_date  = \Str::make_array( $subject_date );

		if ( count( $subject_name ) <> count( $subject_marks ) ) {
			return __( "Please select corrent date sheet data" );
		}
		if ( count( $subject_name ) <> count( $subject_time ) ) {
			return __( "Please select corrent date sheet data" );
		}
		if ( count( $subject_name ) <> count( $subject_date ) ) {
			return __( "Please select corrent date sheet data" );
		}

		// get class name
		$C         = new BatchClass();
		$ClassName = $C->get_class_name( $class_id );

		$data = [];

		$Q = "SELECT COUNT(*) FROM `{$this->Table}` WHERE `class_id`='$class_id' AND `id`<>'$id'";
		if ( $this->DB->get_var( $Q ) > 0 ) {
			return ( "Class \"" . $ClassName . "\" datesheet already exits." );
		}

		if ( empty( $id ) ) {
			foreach ( $subject_name as $k => $v ) {
				$data                  = [];
				$data["class_id"]      = $class_id;
				$data["subject_name"]  = $subject_name[ $k ];
				$data["subject_marks"] = $subject_marks[ $k ];
				$data["subject_date"]  = \Dates::mysql_date( $subject_date[ $k ] );
				$data["subject_time"]  = $subject_time[ $k ];
				$data["added_by"]      = \Admins\UserInfo::get_my_id();
				$data["added_time"]    = \Dates::mysql_datetime();
				$data["added_ip"]      = \General::myip();

				$r = $this->DB->insert( $this->Table, $data );

				if ( $r === false ) {
					return $this->DB->last_error;
				}
			}
		} else {
			$data["subject_name"]  = implode( ",", $subject_name );
			$data["subject_marks"] = implode( ",", $subject_marks );
			$data["subject_date"]  = implode( ",", $subject_date );
			$data["subject_time"]  = implode( ",", $subject_time );
			$r                     = $this->DB->update( $this->Table, $data, [ "id" => $id ] );
		}

		if ( $r === false ) {
			return $this->DB->last_error;
		}

		return "OK";
	}

	public function delete_datesheet() {
		global $db;
		$id = $_POST["id"];
		$Q  = "DELETE FROM `{$this->Table}` WHERE `id`='$id'";
		global $db;
		$response = $db->query( $Q );
		if ( $response === false ) {
			echo "Can't delete record";
		} else {
			echo "OK";
		}
	}


	// weekly_datesheet_schedule area

	public function save_weeklySchedule( $data ) {
		global $db;
		extract( $data );
		if ( isset( $teacherid ) ) {
			if ( $id == "0" ) {
				$Q    = "SELECT * FROM `{$this->Schedule_Table}` WHERE `teacherid`='$teacherid' AND `class_id`='$classid'";
				$rows = $db->get_rows( $Q );
				if ( count( $rows ) > 0 ) {
					return ( "Schedule already assign this teacher (" . $teacher_name . ")" );
				}
			}
		} else {
			return ( "Please Select Teacher Name." );
		}

		if ( ! empty( $time ) ) {
			$time         = implode( ',', $time );
			$data['time'] = $time;
		}
		if ( ! empty( $monday ) ) {
			$monday         = implode( ',', $monday );
			$data['monday'] = $monday;
		}
		if ( ! empty( $tuesday ) ) {
			$tuesday         = implode( ',', $tuesday );
			$data['tuesday'] = $tuesday;
		}
		if ( ! empty( $wednesday ) ) {
			$wednesday         = implode( ',', $wednesday );
			$data['wednesday'] = $wednesday;
		}
		if ( ! empty( $thursday ) ) {
			$thursday         = implode( ',', $thursday );
			$data['thursday'] = $thursday;
		}
		if ( ! empty( $friday ) ) {
			$friday         = implode( ',', $friday );
			$data['friday'] = $friday;
		}
		if ( ! empty( $saturday ) ) {
			$saturday         = implode( ',', $saturday );
			$data['saturday'] = $saturday;
		}

		$id = isset( $id ) ? $id : 0;
		$id = (int) $id;

		if ( $id == "0" ) {
			$data["added_by"]   = \Admins\UserInfo::get_my_id();
			$data["added_time"] = \Dates::mysql_datetime();
			$data["added_ip"]   = \General::myip();
			$r                  = $this->DB->insert( $this->Schedule_Table, $data );
		} else {
			$r = $this->DB->update( $this->Schedule_Table, $data, [ "id" => $id ] );
		}

		if ( $r === false ) {
			return $this->DB->last_error;
		} else {
			return "OK";
		}
	}

	function get_schedule( $params = "" ) {
		$default = [

		];
		$params  = set_args( $params, $default );
		global $db;
		$Q    = "SELECT * FROM `{$this->Schedule_Table}` WHERE 1";
		$Q    .= " ORDER BY `teacher_name` ASC";
		$rows = $db->get_rows( $Q );

		return $rows;
	}

	function get_schedule_row( $id ) {
		global $db;
		$Q    = "SELECT * FROM `{$this->Schedule_Table}` WHERE `teacherid`='{$id}'";
		$rows = $db->get_rows( $Q );

		return $rows;
	}

	function get_lecture_schedule_file( $id ) {
		global $db;
		$Q    = "SELECT * FROM `{$this->Schedule_Table}` WHERE `id`='$id'";
		$rows = $db->get_rows( $Q );

		return $rows;
	}

	public function deleteScheduleRecord( $data ) {
		global $db;
		extract( $data );
		$Q        = "DELETE FROM `{$this->Schedule_Table}` WHERE `id`='$id'";
		$response = $db->query( $Q );
		if ( $response === false ) {
			echo "Can't delete record";
		} else {
			echo "OK";
		}
	}


	function get_Lecture_Schedule_data( $data ) {
		global $db;
		extract( $data );
		$Q    = "SELECT * FROM `weekly_lecture_schedule` WHERE `id`=$id";
		$rows = $db->get_rows( $Q );

		return $rows;
	}


}