<?php

class Export {

	var $DB;

	function __construct() {
		global $db;
		$this->DB = $db;
	}

	function translations_csv( $params = "" ) {
		$table_name = 'translations';
		$query      = 'SELECT DISTINCT `msgstr` FROM ' . $table_name . ' WHERE TRIM(`msgstr`)<>\'\' ORDER BY `msgstr`';
		$rows       = $this->DB->get_rows( $query );

		header( 'Content-Encoding: UTF-8' );
		header( 'Content-Type: text/csv; charset=utf-8' );
		header( 'Content-Disposition: attachment; filename=translations.csv' );

		$output = fopen( 'php://output', 'w' );
		echo "\xEF\xBB\xBF"; // UTF-8 BOM
		fputcsv( $output, array_keys( $rows[0] ) );
		foreach ( $rows as $row ) {
			fputcsv( $output, $row );
		}
		fclose( $output );
	}

	function students_csv( $params = "" ) {
		$default = [
			"pagesize" => 99999,
			"order"    => "ASC",
			"active"   => "1",
			"download" => "0",
			"class_id" => "0",
			"deleted"  => "0",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		$header = [
			"admission_number",
			"class_id",
			"roll",
			"fee",
			"admission_date",
			"name",
			"email",
			"father_name",
			"dob",
			"gender",
			"guardian_name",
			"guardian_relation",
			"cell",
			"guardian_cell",
			"active",
		];

		if ( isset( $_REQUEST["download"] ) ) {
			$Q = "SELECT `" . implode( "`,`", $header ) . "` FROM `" . get_mysql_tablename( "student" ) . "` WHERE 1";
			if ( $class_id > 0 ) {
				$Q .= " AND `class_id`='{$class_id}'";
			}

		} else {
			$Q = "SELECT `" . implode( "`,`", $header ) . "` FROM `" . get_mysql_tablename( "student" ) . "` WHERE 1";
		}

		if ( $active == 0 || $active == 1 ) {
			$Q .= " AND `active`='$active'";
		}

		if ( $deleted == 0 ) {
			$Q .= " AND (`deleted`=0 OR `deleted` IS NULL)";
		}

		$Q .= "  ORDER BY `id` ASC LIMIT {$pagesize}";
		global $db;
		$rows = $db->get_rows( $Q );
		if ( empty( $rows[0] ) ) {
			$rows[0] = [];
		}

		//array_unshift($rows, $header);
		//show_array($rows); die;
		/*$data[] = $header;
		foreach ($rows as $row) {
			$data[] = array(
				"admission_number" => $row['admission_number'],
				"class" => $row['class_id'],
				"roll" => $row['roll'],
				"fee" => $row['fee'],
				"admission_date" => my_date($row['admission_date']),
				"name" => $row['name'],
				"father_name" => $row['father_name'],
				"dob" => my_date($row['dob']),
				"gender" => $row['gender'],
				"guardian_name" => $row['guardian_name'],
				"guardian_relation" => $row['guardian_relation'],
				"cell" => $row['cell'],
			);
		}*/

		header( 'Content-Encoding: UTF-8' );
		header( 'Content-Type: text/csv; charset=utf-8' );
		header( 'Content-Disposition: attachment; filename=students.csv' );

		$output = fopen( 'php://output', 'w' );
		echo "\xEF\xBB\xBF"; // UTF-8 BOM
		fputcsv( $output, array_keys( $rows[0] ) );
		foreach ( $rows as $row ) {
			fputcsv( $output, $row );
		}
		fclose( $output );
	}
}