<?php

class Fee {

	var $DB, $dbconn;
	var $Table = "fee_paid";
	const Table = "fee_paid";
	var $TableCustomFields = "fee_custom_fields";
	var $TableCustomFieldsData = "fee_custom_fields_data";
	var $FeeTypes = [
		"tution_fee"        => "Tution Fee",
		"admission_fee"     => "Admission Fee",
		"annual_funds"      => "Annual Funds",
		"practical_charges" => "Practical Charges",
		"test_session_fee"  => "Test Session Fee",
	];

	function __construct() {
		global $db, $dbconn;
		$this->DB     = $db;
		$this->dbconn = $dbconn;

		\DB\Views::fee_paid_view();

		$Q = "DELETE FROM `{$this->Table}` WHERE description LIKE '%Fee deleted by %'";
		$db->query( $Q );
		$db->add_column( [
			'table_name' => $this->Table,
			'col_name'   => 'partial_paid',
			'type'       => 'tinyint',
			'default'    => 0,
		] );
	}

	public static function get_tution_fee_schedule( $class_id ) {
		$Q = "SELECT * FROM `batch_classes_x_tution_fee` WHERE `class_id`={$class_id}";
		global $db;

		$rows = $db->get_rows( $Q );
		foreach ( $rows as &$row ) {
			$row["from_date2"] = \Dates::my_date( $row["from_date"] );
			$row["from_date3"] = date( $db->get_option( "date_format2" ), strtotime( $row["from_date"] ) );

			$row["to_date2"] = \Dates::my_date( $row["to_date"] );
			$row["to_date3"] = date( $db->get_option( "date_format2" ), strtotime( $row["to_date"] ) );

			$row["due_date2"] = \Dates::my_date( $row["due_date"] );
			$row["due_date3"] = date( $db->get_option( "date_format2" ), strtotime( $row["due_date"] ) );

			$row["last_payment2"] = \Dates::my_date( $row["last_payment"] );
			$row["last_payment3"] = date( $db->get_option( "date_format2" ), strtotime( $row["last_payment"] ) );
			$row["fine_name"]     = $row["fine_id"] == "0" ? "-- No Fine --" : $db->get_var( "SELECT `name` FROM `fine_slabs` WHERE `id`=" . $row["fine_id"] );
		}

		return $rows;
	}

	function get_payable_slabs( $class_id = 0, $before_days = 0 ) {
		$curdate = date( "Y-m-d", strtotime( "+{$before_days} days" ) );
		$Q       = "SELECT * FROM `batch_classes_x_tution_fee` WHERE `payable_done`=0 AND `due_date`<='{$curdate}'";
		if ( $class_id > 0 ) {
			$Q .= " AND `class_id`=$class_id";
		}

		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	function count_fee_defaulters() {
		$Q = "SELECT COUNT(*) FROM `$this->Table` WHERE `paid`=0 AND `last_payment_date`<CURDATE()";

		return $this->DB->get_var( $Q );
	}

	public static function count_fee_defaulters_static() {
		$Q = "SELECT COUNT(*) FROM `" . \MySQL\Tables::table_name( 'fee_paid' ) . "` WHERE `paid`=0 AND `last_payment_date`<CURDATE()";

		global $db;

		return $db->get_var( $Q );
	}

	function count_fee_defaulters_fee() {
		$Q = "SELECT SUM(`amount`)+SUM(`fine`) FROM `$this->Table` WHERE `paid`=0 AND `last_payment_date`<CURDATE()";

		return $this->DB->get_var( $Q );
	}

	function count_not_paid() {
		$Q = "SELECT COUNT(*) FROM `$this->Table` WHERE `paid`=0";

		return $this->DB->get_var( $Q );
	}

	public static function count_not_paid_static() {
		$Q = "SELECT COUNT(*) FROM `" . \MySQL\Tables::table_name( 'fee_paid' ) . "` WHERE `paid`=0";

		global $db;

		return $db->get_var( $Q );
	}

	function count_not_paid_fee() {
		$Q = "SELECT SUM(`amount`)+SUM(`fine`) FROM `$this->Table` WHERE `paid`=0";

		return $this->DB->get_var( $Q );
	}

	function get_not_paid( $filter = "", $params = "" ) {
		$default = [
			"page"          => 0,
			"pagesize"      => 0,
			"orderby"       => "id",
			"order"         => "DESC",
			"paid"          => 0,
			"search"        => "",
			"filter"        => "",
			"student_id"    => 0,
			'mysql_cols'    => '*',
			'classes'       => [],
			'due_date_from' => '',
			'due_date_to'   => '',
			'student_name'  => '',
		];
		$params  = set_args( $params, $default );
		extract( $params );
		$mysql_cols = $params['mysql_cols'];
		global $db;

		if ( $mysql_cols <> '*' ) {
			$mysql_cols .= ',added_time,fee_date,due_date,last_payment_date,student_id';
		}

		global $Student;
		$paid = (int) $params['paid'];
		$Q    = $this->DB->prepare( "SELECT " . $mysql_cols . " FROM `fee_paid_view` WHERE `paid`=%d", $paid );

		$student_name = (string) $student_name;
		if ( trim( $student_name ) <> '' ) {
			$Q .= $db->prepare( ' AND `student_name` LIKE %s', '%' . $student_name . '%' );
		}

		$student_id = (int) $params['student_id'];

		if ( $student_id > 0 ) {
			$Q .= " AND `student_id`='" . $student_id . "'";
		}

		if ( ! empty( $classes ) ) {
			$classes = \Str::make_array( $classes );
			$Q       .= " AND `class_id` IN ('" . implode( "','", $classes ) . "')";
		}

		if ( empty( $due_date_to ) && ! empty( $due_date_from ) ) {
			$due_date_to = $due_date_from;
		}
		if ( empty( $due_date_from ) && ! empty( $due_date_to ) ) {
			$due_date_from = $due_date_to;
		}
		if ( ! empty( $due_date_from ) ) {
			$due_date_from = \Dates::mysql_date( $due_date_from );
			$due_date_to   = \Dates::mysql_date( $due_date_to );
			$Q             .= $db->prepare( ' AND `due_date` BETWEEN %s AND %s', $due_date_from, $due_date_to );
		}

		if ( $filter <> "" ) {
			$filter = urldecode( $filter );
			parse_str( $filter, $filter );

			foreach ( $filter as $key => $val ) {
				if ( $key == "due_date" ) {
					$d = explode( ",", $val );
					if ( empty( $d[1] ) ) {
						$d[1] = $d[0];
					}
					$Q .= " AND (`due_date` BETWEEN '" . \Dates::mysql_date( $d[0] ) . "' AND '" . \Dates::mysql_date( $d[1] ) . "')";
				} elseif ( $key == "fee_date" ) {
					$d = explode( ",", $val );
					if ( empty( $d[1] ) ) {
						$d[1] = $d[0];
					}
					$Q .= " AND (`fee_date` BETWEEN '" . \Dates::mysql_date( $d[0] ) . "' AND '" . \Dates::mysql_date( $d[1] ) . "')";
				} else {
					$val = $this->DB->set_string( $val );
					$Q   .= " AND `$key`='$val'";
				}
			}
		}

		if ( ! empty( $search ) ) {
			$search = $this->DB->set_string( $search );
			if ( trim( strtolower( $search ) ) == 'partial' ) {
				$Q .= ' AND `partial_paid`=1';
			} else if ( \Dates::is_date( $search ) ) {
				$search = \Dates::mysql_date( $search );
				$Q      .= " AND (`last_payment_date`='$search' OR `due_date`='$search' OR `fee_date`='$search')";
			} elseif ( is_numeric( $search ) ) {
				$Q .= " AND (`student_id`=$search OR `id`=$search OR `receipt_number` LIKE '%$search%' OR `guardian_cell` LIKE '%$search%'
                OR `roll` LIKE '%$search%')";
			} elseif ( is_string( $search ) ) {
				$Q .= " AND (`guardian_cell` LIKE '%$search%' OR `guardian_name` LIKE '%$search%' OR `student_name` LIKE '%$search%'
                OR `fee_type` LIKE '%$search%' OR `fee_title` LIKE '%$search%' OR `receipt_number` LIKE '%$search%'
                OR `class_name` LIKE '%$search%' OR `roll` LIKE '%$search%')";
			}
		}
		$Q .= " ORDER BY `$orderby` $order";

		if ( $page == 0 && $pagesize == 0 ) {
			$rows = $this->DB->get_rows( $Q );
			foreach ( $rows as &$row ) {
				$row["added_time2"]        = \Dates::my_datetime( $row["added_time"] );
				$row["added_time3"]        = date( $db->get_option( "date_time_format2" ), strtotime( $row["added_time"] ) );
				$row["fee_date2"]          = \Dates::my_date( $row["fee_date"] );
				$row["due_date2"]          = \Dates::my_date( $row["due_date"] );
				$row["last_payment_date2"] = \Dates::my_date( $row["last_payment_date"] );
				$row["batch_name"]         = $Student->get_student_batch( $row["student_id"] );
			}

			return $rows;
		} else {
			$rows = $this->DB->get_rows2( $Q, $page, $pagesize );
			foreach ( $rows["rows"] as &$row ) {
				$row["added_time2"]        = \Dates::my_datetime( $row["added_time"] );
				$row["added_time3"]        = date( $db->get_option( "date_time_format2" ), strtotime( $row["added_time"] ) );
				$row["fee_date2"]          = \Dates::my_date( $row["fee_date"] );
				$row["due_date2"]          = \Dates::my_date( $row["due_date"] );
				$row["last_payment_date2"] = \Dates::my_date( $row["last_payment_date"] );
				$row["batch_name"]         = $Student->get_student_batch( $row["student_id"] );
			}

			return $rows;
		}
	}

	function get_fee_defaulters( $params = "" ) {
		$default = [
			"orderby"          => "id",
			"order"            => "DESC",
			"fee_slab_id"      => - 1,
			"page"             => 0,
			"pagesize"         => 0,
			"search"           => "",
			"filter"           => "",
			"class_id"         => 0,
			"include_due_date" => 0           // 0 = Show only defaulters, 1 = Show also due date
		];
		$params  = set_args( $params, $default );
		extract( $params );
		global $Student;
		global $db;
		$Q = "SELECT * FROM `fee_paid_view` WHERE `paid`=0";
		if ( $include_due_date ) {
			$Q .= " AND `due_date`<CURDATE()";
		} else {
			$Q .= " AND `last_payment_date`<CURDATE()";
		}

		if ( $fee_slab_id > - 1 ) {
			$Q .= " AND `fee_slab_id`=$fee_slab_id";
		}
		if ( $class_id > 0 ) {
			$Q .= " AND `class_id`=$class_id";
		}

		if ( ! empty( $search ) ) {
			$search = $this->DB->set_string( $search );
			if ( \Dates::is_date( $search ) ) {
				$search = \Dates::mysql_date( $search );
				$Q      .= " AND (`last_payment_date`='$search' OR `due_date`='$search' OR `fee_date`='$search')";
			} elseif ( is_numeric( $search ) ) {
				$Q .= " AND (`student_id`=$search OR `id`=$search OR `receipt_number` LIKE '%$search%' OR `guardian_cell` LIKE '%$search%'
                OR `roll` LIKE '%$search%')";
			} elseif ( is_string( $search ) ) {
				$Q .= " AND (`guardian_cell` LIKE '%$search%' OR `guardian_name` LIKE '%$search%' OR `student_name` LIKE '%$search%'
                OR `fee_type` LIKE '%$search%' OR `fee_title` LIKE '%$search%' OR `receipt_number` LIKE '%$search%'
                OR `class_name` LIKE '%$search%' OR `roll` LIKE '%$search%')";
			}
		}


		if ( ! empty( $filter ) ) {
			$filter = urldecode( $filter );
			parse_str( $filter, $filter );
			foreach ( $filter as $key => $val ) {
				if ( $key == "due_date" ) {
					$d = explode( ",", $val );
					if ( empty( $d[1] ) ) {
						$d[1] = $d[0];
					}
					$Q .= " AND (`due_date` BETWEEN '" . \Dates::mysql_date( $d[0] ) . "' AND '" . \Dates::mysql_date( $d[1] ) . "')";
				} elseif ( $key == "classes" ) {
					$Q .= " AND `class_id` IN ($val)";
				} elseif ( $val <> "" ) {
					$val = $this->DB->set_string( $val );
					$Q   .= " AND `$key`='$val'";
				}
			}
		}

		$Q .= " ORDER BY `$orderby` $order";

		if ( $page == "0" && $pagesize == "0" ) {
			$rows = $this->DB->get_rows( $Q );
			foreach ( $rows as &$row ) {
				$row["added_time2"]        = \Dates::my_datetime( $row["added_time"] );
				$row["added_time3"]        = date( $db->get_option( "date_time_format2" ), strtotime( $row["added_time"] ) );
				$row["fee_date2"]          = \Dates::my_date( $row["fee_date"] );
				$row["due_date2"]          = \Dates::my_date( $row["due_date"] );
				$row["last_payment_date2"] = \Dates::my_date( $row["last_payment_date"] );
				$row["batch_name"]         = $Student->get_student_batch( $row["student_id"] );
			}
		} else {
			$rows = $this->DB->get_rows2( $Q, $page, $pagesize );
			foreach ( $rows["rows"] as &$row ) {
				$row["added_time2"]        = \Dates::my_datetime( $row["added_time"] );
				$row["added_time3"]        = date( $db->get_option( "date_time_format2" ), strtotime( $row["added_time"] ) );
				$row["fee_date2"]          = \Dates::my_date( $row["fee_date"] );
				$row["due_date2"]          = \Dates::my_date( $row["due_date"] );
				$row["last_payment_date2"] = \Dates::my_date( $row["last_payment_date"] );
				$row["batch_name"]         = $Student->get_student_batch( $row["student_id"] );
			}
		}

		return $rows;
	}

	function get_fees( $params = "" ) {
		$default = [
			"student_id" => 0,
			"paid"       => 1,
		];
		$params  = set_args( $params, $default );
		extract( $params );

		$student_id = (int) $params['student_id'];
		$paid       = (int) $params['paid'];

		global $db;

		$Q = "SELECT * FROM `fee_paid_view` WHERE (`amount`+`fine`)>0";
		if ( $student_id > 0 ) {
			$Q .= " AND `student_id`=" . $student_id;
		}

		$Q .= " AND `paid`='" . $paid . "'";
		$Q .= " ORDER BY `id` DESC";

		$rows = $this->DB->get_rows( $Q );
		foreach ( $rows as &$row ) {
			$row["added_time2"]      = \Dates::my_datetime( $row["added_time"] );
			$row["added_time3"]      = date( $db->get_option( "date_time_format2" ), strtotime( $row["added_time"] ) );
			$row["fee_date2"]        = \Dates::my_date( $row["fee_date"] );
			$row["due_date2"]        = \Dates::my_date( $row["due_date"] );
			$Q                       = "SELECT SUM(`amount`) FROM `account_transactions` WHERE `fee_paid_id`=" . $row["id"];
			$am                      = $this->DB->get_var( $Q );
			$row["remaining_amount"] = ( $row["amount"] + $row["fine"] ) - $am;
		}

		return $rows;
	}

	function get_fee( $id ) {
		$Q   = "SELECT * FROM `fee_paid_view` WHERE `id`=$id";
		$row = $this->DB->get_row( $Q );
		global $db;
		if ( isset( $row ) && ! empty( $row ) ) {
			$row["added_time2"]      = \Dates::my_datetime( $row["added_time"] );
			$row["added_time3"]      = date( $db->get_option( "date_time_format2" ), strtotime( $row["added_time"] ) );
			$row["fee_date2"]        = \Dates::my_date( $row["fee_date"] );
			$row["due_date2"]        = \Dates::my_date( $row["due_date"] );
			$Q                       = "SELECT SUM(`amount`) FROM `account_transactions` WHERE `fee_paid_id`=$id";
			$am                      = $this->DB->get_var( $Q );
			$row["remaining_amount"] = ( $row["amount"] + $row["fine"] ) - $am;
		}

		return $row;
	}

	public function create_invoice( $args = [] ) {
		$default = [
			'student_id'     => 0,
			'amount'         => 0,
			'fee_title'      => '',
			'fee_date'       => '',
			'receipt_number' => '',
		];
		$args    = \General::set_args( $args, $default );

		$args['student_id'] = (int) $args['student_id'];
		$args['amount']     = (double) $args['amount'];
		$args['fee_title']  = (string) $args['fee_title'];
		$args['fee_date']   = (string) $args['fee_date'];

		if ( $args['student_id'] < 0 ) {
			return __( "Student ID missing" );
		}
		if ( $args['amount'] < 0 ) {
			return __( "Amount missing" );
		}
		if ( $args['fee_date'] == '' ) {
			return __( "Invalid fee date" );
		}
		$args["fee_date"] = \Dates::mysql_date( $args["fee_date"] );
		$args["paid"]     = 0;
		$args["due_date"] = \Dates::mysql_date( $args["fee_date"] );
		$this->DB->insert( $this->Table, $args );

		return $this->DB->Status;
	}

	function pay_new_fee( $data ) {
		if ( empty( $data["student_id"] ) ) {
			return __( "Student ID missing" );
		}
		if ( empty( $data["amount"] ) ) {
			return __( "Amount missing" );
		}
		if ( empty( $data["fee_date"] ) ) {
			return __( "Fee date missing" );
		}
		if ( ! \Dates::is_date( $data["fee_date"] ) ) {
			return __( "Invalid fee date" );
		}
		$data["fee_date"]          = \Dates::mysql_date( $data["fee_date"] );
		$data["paid"]              = 1;
		$data["paid_system_time"]  = \Dates::mysql_datetime();
		$data["paid_by"]           = \Admins\UserInfo::get_my_id();
		$data["paid_ip"]           = \General::myip();
		$data["due_date"]          = \Dates::mysql_date();
		$data["last_payment_date"] = \Dates::mysql_date();
		$res                       = $this->DB->insert( $this->Table, $data );
		if ( $res !== false ) {
			$id          = $this->DB->insert_id;
			$Accounts    = new Accounts;
			$description = $data["fee_title"] . ", Student Fee, Paid Fee ID: $id";
			if ( ! empty( $data["receipt_number"] ) ) {
				$description .= ", Receipt #: " . $data["receipt_number"];
			}
			$Accounts->add_entry( [
				"amount"      => $data["amount"],
				"description" => $description,
				"student_id"  => $data["student_id"],
				"date"        => $data["fee_date"],
			] );

			return "OK";
		} else {
			return $this->DB->last_error;
		}
	}

	function pay_fee( $id, $fee_date, $receipt_number, $amount ) {
		$receipt_number = isset( $receipt_number ) ? trim( $receipt_number ) : "";
		$F              = $this->get_fee( $id );
		if ( $amount > $F["remaining_amount"] ) {
			return "Remaining amount left " . $F["remaining_amount"];
		}

		$data = [
			"fee_date"         => \Dates::mysql_date( $fee_date ),
			"paid_system_time" => \Dates::mysql_datetime(),
			"paid_by"          => \Admins\UserInfo::get_my_id(),
			"paid_ip"          => \General::myip(),
			"receipt_number"   => $receipt_number,
		];

		if ( $amount >= $F["remaining_amount"] ) {
			$data['paid']         = 1;
			$data['partial_paid'] = 0;

		} else {
			$data['paid']         = 0;
			$data['partial_paid'] = 1;
		}

		$r = $this->DB->update( $this->Table, $data, [ "id" => $id ] );
		if ( $r === false ) {
			return "Error: " . $this->DB->last_error;
		} else {
			$Accounts    = new Accounts;
			$description = $F["fee_title"] . ", Student Fee, Paid Fee ID: $id, Receipt #: " . $receipt_number;
			$Accounts->add_entry( "amount={$amount}&description={$description}&student_id={$F["student_id"]}&date={$data["fee_date"]}&fee_paid_id={$id}&receipt_number={$receipt_number}" );

			return "OK";
		}
	}

	function update_fine( $fee_id, $newFeeAmount ) {
		$Q = "UPDATE `$this->Table` SET `fine`=$newFeeAmount WHERE `id`=$fee_id";
		$this->DB->query( $Q );
	}

	function delete_generated_fee( $id ) {
		$description = $this->DB->get_var( "SELECT `description` FROM `$this->Table` WHERE `id`=$id" );
		$u           = \Admins\UserInfo::get_admin( "username" );
		$uid         = \Admins\UserInfo::get_my_id();
		$description .= "<br><i>Fee deleted by <b>$u ($uid)</b></i>";
		$data        = [
			"amount"           => 0,
			"fine"             => 0,
			"paid"             => 1,
			"description"      => $description,
			"fee_date"         => \Dates::mysql_date(),
			"paid_system_time" => \Dates::mysql_datetime(),
		];
		$response    = $this->DB->update( $this->Table, $data, [ "id" => $id, "paid" => "0" ] );
		if ( $response === false ) {
			return $this->DB->last_error;
		} else {
			return "OK";
		}
	}
}