<?php

namespace Fee;

class Fee {

	public static function count_not_paid() {
		global $db;
		return $db->where('paid',0)->count_result(\MySQL\Tables::table_name( 'fee_paid' ));
	}

	public static function get_not_paid( $args = [] ) {
		$default = [
			'mysql_cols' => '*',
			'id'         => '',
			'due_date'   => '',
			'classes'    => '',

			'page'     => 1,
			'pagesize' => 50,
		];
		$args    = set_args( $args, $default );

		global $db;

		$args['mysql_cols'] = (string) $args['mysql_cols'];
		$db->select_cols($args['mysql_cols'])->where('paid',0)
			->select_from(\MySQL\Tables::table_name( 'fee_paid_view' ) );
		$Q                  = $db->prepare( 'SELECT %w FROM %t WHERE `paid`=%s', $args['mysql_cols'], \MySQL\Tables::table_name( 'fee_paid_view' ), 0 );

		if ( ! empty( $args['id'] ) ) {
			$args['id'] = \Str::make_array( $args['id'] );
			$db->where('id',$args['id']);
			$Q          .= ' AND `id` IN( \'' . implode( "','", $args['id'] ) . '\')';
		}

		if ( empty( $args['due_date'][0] ) && empty( $args['due_date'][1] ) ) {
			$args['due_date'] = '';
		}

		if ( ! empty( $args['due_date'] ) ) {
			$args['due_date'] = \Str::make_array( $args['due_date'] );
			if ( ! isset( $args['due_date'][1] ) ) {
				$args['due_date'][1] = $args['due_date'][0];
			}
			$args['due_date'][0] = \Dates::mysql_date( $args['due_date'][0] );
			$args['due_date'][1] = \Dates::mysql_date( $args['due_date'][1] );
			$Q                   .= $db->prepare( ' AND `due_date` BETWEEN %s AND %s', $args['due_date'][0], $args['due_date'][1] );
			$db->where_between('due_date',$args['due_date'][0],$args['due_date'][1]);
		}

		if ( ! empty( $args['classes'] ) ) {
			$args['classes'] = \Str::make_array( $args['classes'] );
			$Q               .= ' AND `class_id` IN (' . implode( ',', $args['classes'] ) . ')';
			//$Q               .= $db->prepare( ' AND `student_id` IN (SELECT `id` FROM %t WHERE (`class_id` IN (' . implode( ",", $args['classes'] ) . ')))', \MySQL\Tables::table_name( 'students_view' ) );
			$db->where('class_id',$args['classes']);
		}

		$args['page']     = (int) $args['page'];
		$args['pagesize'] = (int) $args['pagesize'];

		//$rows = $db->get_rows2( $Q, $args['page'], $args['pagesize'] );
		$rows = $db->get_rows2($args['page'], $args['pagesize']);

		return $rows;
	}
}