<?php

namespace Fee;

use Admins\UserInfo;

class Invoice {

	public static function generate_monthy_fee( $date = '', $show_counter = false ) {
		set_time_limit( 0 );
		$date = (string) $date;

		global $db;
		if ( $show_counter ) {
			$counter = 0;
		}

		if ( $date == '' ) {
			$datestr = time();
		} else {
			$datestr = strtotime( $date );
		}

		$fee_title = date( 'F Y', $datestr );
		$due_date  = date( 'Y-m-01', $datestr );
		$last_date = date( 'Y-m-10', $datestr );

		$Q = "SELECT `id`,`fee` FROM %t WHERE `id` NOT IN (SELECT `student_id` FROM %t WHERE `fee_title`=%s)
			AND `active`='1' AND `fee`>0 AND `deleted`<>1";

		$Q = $db->prepare( $Q, \MySQL\Tables::table_name( 'students' ), \MySQL\Tables::table_name( 'fee_paid' ), $fee_title );

		$rows = $db->get_rows( $Q );

		$my_id = (int) UserInfo::get_my_id();

		if ( $my_id > 0 ) {
			$desc = "Payable created by " . UserInfo::get_admin( 'name' ) . " at " . \Dates::my_datetime();
		} else {
			$desc = "Payable created by system at " . \Dates::my_datetime();
		}

		foreach ( $rows as $row ) {
			$Q = $db->prepare( 'SELECT COUNT(*) FROM %t WHERE `due_date`=%s AND `student_id`=%d', \MySQL\Tables::table_name( 'fee_paid' ), $due_date, $row['id'] );
			if ( $db->get_var( $Q ) > 0 ) {
				continue;
			}

			$data = [
				"student_id"        => $row["id"],
				"fee_type"          => "Scheduled",
				"amount"            => $row["fee"],
				"description"       => $desc,
				"added_by"          => $my_id,
				"added_time"        => \Dates::mysql_datetime(),
				"fee_title"         => $fee_title,
				"paid"              => 0,
				"due_date"          => $due_date,
				"last_payment_date" => $last_date,
			];

			$db->insert( \MySQL\Tables::table_name( 'fee_paid' ), $data );
			if ( $db->Status == 'OK' && $show_counter ) {
				$counter ++;
			}
		}

		if ( $show_counter ) {
			echo $counter . ' invoices generated';
		}

		return true;
	}
}