<?php

class Fine {

	function get_fine_slabs( $params = "" ) {
		$default = [
			"orderby" => "id",
			"order"   => "DESC",
			"id"      => 0,
		];
		$params  = set_args( $params, $default );
		extract( $params );

		global $db;
		$Q = "SELECT fs.* FROM `fine_slabs` fs, `batch_classes_x_tution_fee` bfs WHERE 1";

		if ( $id > 0 ) {
			$Q .= " AND bfs.`id`=$id AND bfs.fine_id=fs.id";
		}

		$Q    .= " ORDER BY `$orderby` $order";

		$rows = $db->get_rows( $Q );
		foreach ( $rows as &$row ) {
			if ( $row["amount_type"] == "Percentage" ) {
				$row["amount2"] = round( $row["amount"], 2 ) . "%";
			} else {
				$row["amount2"] = App::set_currency( $row["amount"] );
			}
		}

		return $rows;
	}

	function get_list( $params = "" ) {
		$default = [
			"orderby" => "id",
			"order"   => "DESC",
			"id"      => 0,
		];
		$params  = set_args( $params, $default );
		extract( $params );

		global $db;
		$Q = "SELECT fs.* FROM `fine_slabs` fs WHERE 1";

		if ( $id > 0 ) {
			$Q .= " AND fs.`id`=$id";
		}

		$Q    .= " ORDER BY `$orderby` $order";
		$rows = $db->get_rows( $Q );
		foreach ( $rows as &$row ) {
			if ( $row["amount_type"] == "Percentage" ) {
				$row["amount2"] = round( $row["amount"], 2 ) . "%";
			} else {
				$row["amount2"] = App::set_currency( $row["amount"] );
			}
		}

		return $rows;
	}

	function save_fine_slab( $data = [] ) {
		global $db;
		extract( $data );
		$id = isset( $id ) ? $id : "0";
		$id = (int) $id;

		if ( ! isset( $name ) || trim( $name ) == "" ) {
			return __("Fine name missing.");
		}
		if ( ! isset( $amount ) || ! is_numeric( $amount ) ) {
			return __("Fine amount missing.");
		}
		if ( ! isset( $amount_type ) || trim( $amount_type ) == "" ) {
			$amount_type = "Percentage";
		}
		if ( ! isset( $fine_implement ) || trim( $fine_implement ) == "" ) {
			$fine_implement = "Daily";
		}
		$Q = "SELECT COUNT(*) FROM `fine_slabs` WHERE `name`='" . $db->set_string( $name ) . "'";
		if ( $id > 0 ) {
			$Q .= " AND `id`<>$id";
		}
		#echo $db->get_var($Q);
		if ( $db->get_var( $Q ) > 0 ) {
			return __("Please provide unique name for fine");
		}

		$store_data = [
			"name"           => $name,
			"amount"         => $amount,
			"amount_type"    => $amount_type,
			"fine_implement" => $fine_implement,
		];
		global $db;
		if ( $id == "0" ) {
			$store_data["added_by"]   = \Admins\UserInfo::get_my_id();
			$store_data["added_time"] = \Dates::mysql_datetime();
			$store_data["added_ip"]   = \General::myip();
			$r                        = $db->insert( "fine_slabs", $store_data );
			if ( $r !== false ) {
				$id = $db->insert_id;
			}
		} else {
			$r = $db->update( "fine_slabs", $store_data, [ "id" => $id ] );
		}
		if ( $r !== false ) {
			return "OK" . $id;
		} else {
			return $db->last_error;
		}
	}

	function delete( $id = 0 ) {
		global $db;
		$id = (int) $id;
		$Q  = "DELETE FROM `fine_slabs` WHERE `id`='$id'";
		
		$r  = $db->delete( "fine_slabs", [ "id" => $id ] );
		if ( $r === false ) {
			return $db->last_error;
		} else {
			return "OK";
		}
	}

	public static function delete_static( $id = 0 ) {
		global $db;
		$id = (int) $id;
		$Q  = "DELETE FROM `fine_slabs` WHERE `id`='$id'";
		$r  = $db->delete( "fine_slabs", [ "id" => $id ] );
		if ( $r === false ) {
			return $db->last_error;
		} else {
			return "OK";
		}
	}

	function generate_fine() {
		// This function will generate all fines.
		$_fee           = new \Fee();
		$fee_defaulters = $_fee->get_fee_defaulters();
		foreach ( $fee_defaulters as $feed ) {
			if ( $feed["fee_slab_id"] > 0 ) {
				$fines = $this->get_fine_slabs( "id=" . $feed["fee_slab_id"] );
				foreach ( $fines as $fine ) {
					if ( $fine["amount_type"] == "Percentage" ) {
						$newFine = $feed["amount"] * ( $fine["amount"] / 100 );
					} else {
						$newFine = $fine["amount"];
					}
					if ( $fine["fine_implement"] == "Daily" ) {
						$dStart = new DateTime( $feed["last_payment_date"] );
						$dEnd   = new DateTime( date( "Y-m-d" ) );
						$dDiff  = $dStart->diff( $dEnd );
						$days   = $dDiff->format( '%R' ) . $dDiff->days;
						$days   = (int) $days;
						if ( $days > 0 ) {
							$newFine = $newFine * $days;
						}
					}
					$_fee->update_fine( $feed["id"], $newFine );
				}
			}
		}
	}
}