<?php

class Holidays {

	function get_holiday( $id ) {
		$Q = "SELECT * FROM `holidays` WHERE `id`=$id";
		global $db;
		$row = $db->get_row( $Q );

		return $row;
	}

	function get_list( $params = "" ) {
		$default = [
			"from_date" => "",
			"to_date"   => "",

		];
		$params  = set_args( $params, $default );
		extract( $params );
		$from_date = is_numeric( $from_date ) ? date( "Y-m-d", $from_date ) : $from_date;
		$to_date   = is_numeric( $to_date ) ? date( "Y-m-d", $to_date ) : $to_date;
		global $db;
		$Q = "SELECT * FROM `holidays` WHERE 1";
		if ( empty( $from_date ) ) {
			$from_date = date( "Y-m-d" );
		}
		$from_date = date( "Y-m-d", strtotime( $from_date ) );
		if ( empty( $to_date ) ) {
			$to_date = $from_date;
		}
		$to_date = date( "Y-m-d", strtotime( $to_date ) );
		$Q .= " AND `from_date`>='$from_date' AND `to_date`<='$to_date'";
		$rows = $db->get_rows( $Q );
		$json = [];
		foreach ( $rows as $row ) {
			$json[] = [
				"id"    => $row["id"],
				"title" => $row["title"],
				"start" => $row["from_date"],
				"end"   => $row["to_date"],
			];
		}

		return $json;
	}

	function save( $data ) {
		if ( ! isset( $data["title"] ) ) {
			return "Holiday name/title missing.";
		}
		if ( ! isset( $data["from_date"] ) && ! isset( $data["to_date"] ) ) {
			return __("Please select dates.");
		}
		if ( empty( $data["to_date"] ) ) {
			$data["to_date"] = $data["from_date"];
		}
		if ( empty( $data["from_date"] ) ) {
			$data["from_date"] = $data["from_date"];
		}
		$data["from_date"] = \Dates::mysql_date( $data["from_date"] );
		$data["to_date"]   = \Dates::mysql_date( $data["to_date"] );

		global $db;
		if ( empty( $data["id"] ) ) {
			$data["added_by"]   = \Admins\UserInfo::get_my_id();
			$data["added_time"] = \Dates::mysql_datetime();
			$data["added_ip"]   = \General::myip();
			$response           = $db->insert( "holidays", $data );
		} else {
			$response = $db->update( "holidays", $data, [ "id" => $data["id"] ] );
		}

		if ($response===false) {
			return $db->last_error;
		} else {
			return "OK";
		}
	}
}