<?php

class INI {

	/**
	 * @param      $assoc_arr
	 * @param      $path
	 * @param bool $has_sections
	 *
	 * @return bool
	 *
	 * Write INI file from array
	 */
	public static function write_ini_file( $assoc_arr, $path, $has_sections = false ) {
		$content = '';

		if ( ! $handle = fopen( $path, 'w' ) ) {
			return false;
		}

		self::_write_ini_file_r( $content, $assoc_arr, $has_sections );

		if ( ! fwrite( $handle, $content ) ) {
			return false;
		}

		fclose( $handle );

		return true;
	}

	private static function _write_ini_file_r( &$content, $assoc_arr, $has_sections ) {
		foreach ( $assoc_arr as $key => $val ) {
			$key = preg_replace( "/\r|\n/", "", $key );
			$key = str_replace( [ '{', '}', '!', ']', '[' ], [ '', '', '', '', '' ], $key );
			if ( is_array( $val ) ) {
				if ( $has_sections ) {
					$content .= "[$key]\n";
					self::_write_ini_file_r( $content, $val, false );
				} else {
					foreach ( $val as $iKey => $iVal ) {
						$iVal = '"' . addslashes( $iVal ) . '"';

						if ( is_int( $iKey ) ) {
							$content .= $key . "[] = $iVal\n";
						} else {
							$content .= $key . "[$iKey] = $iVal\n";
						}
					}
				}
			} else {
				$val     = '"' . addslashes( $val ) . '"';
				$content .= "$key = $val\n";
			}
		}
	}
}