<?php

class Messages {

	var $Table = "messages";

	function send_message( $params = "" ) {
		$default = [
			"to"   => "",
			"from" => "",
		];
		$params  = set_args( $params, $default );
		global $db;

		if ( $params["to"] == "" ) {
			return "Receipient missing.";
		}

		if ( $params["from"] == "" ) {
			return "From missing.";
		}
		if ( $db->get_var( "SELECT COUNT(*) FROM `admins` WHERE `id`=" . $params["from"] ) == 0 ) {
			return "Invalid sender.";
		}

		if ( ! is_array( $params["to"] ) ) {
			$params["to"] = explode( ",", $params["to"] );
		}
		if ( is_array( $params["to"] ) ) {
			$data["from"] = $params["from"];
		}
		$data["subject"]    = $params["subject"];
		$data["message"]    = $params["message"];
		$data["viewed"]     = 0;
		$data["sending_ip"] = \General::myip();
		$data["status"]     = "inbox";
		$data["deleted"]    = 0;
		$Success            = 0;
		$Failed             = 0;
		foreach ( $params["to"] as $to ) {
			$data["to"]           = $to;
			$data["sending_time"] = \Dates::mysql_datetime();
			$response             = $db->insert( $this->Table, $data );
			if ( $response === false ) {
				$Failed ++;
			} else {
				$Success ++;
			}
		}
		echo "OK,{$Success},{$Failed}," . $this->count_messages( "viewed=0" );

	}

	function count_messages( $params = "" ) {
		$default = [
			"search"  => "",
			"viewed"  => - 1,               # -1 all, 1 or 0
			"from"    => 0,                  # -1 for current user, 0 for all
			"to"      => - 1,                   # -1 for current user, 0 for all
			"deleted" => 0,               # -1 all, 1 or 0
			"status"  => "inbox",          # "inbox","trash","draft","sent"
		];
		$params  = set_args( $params, $default );
		extract( $params );
		global $db;

		$Q = "SELECT COUNT(*) FROM `{$this->Table}` WHERE `status`='$status'";

		if ( $viewed <> - 1 ) {
			$Q .= " AND `viewed`=$viewed";
		}

		if ( $from == - 1 ) {
			$Q .= " AND `from`=" . \Admins\UserInfo::get_my_id();
		} else if ( $from > 0 ) {
			$Q .= " AND `from`=$from";
		}

		if ( $to == - 1 ) {
			$Q .= " AND `to`=" . \Admins\UserInfo::get_my_id();
		} else if ( $to > 0 ) {
			$Q .= " AND `to`=$to";
		}

		$deleted = (int) $deleted;
		if ( $deleted <> - 1 ) {
			$Q .= " AND `deleted`=$deleted";
		}

		if ( $search <> "" ) {
			$search = $db->set_string( $search );
			$Q      .= " AND (`message` LIKE '%$search%' OR `subject` LIKE '%$search%')";
		}

		return $db->get_var( $Q );
	}

	public static function count_messages_static( $params = "" ) {
		$default = [
			"search"  => "",
			"viewed"  => - 1,               # -1 all, 1 or 0
			"from"    => 0,                  # -1 for current user, 0 for all
			"to"      => - 1,                   # -1 for current user, 0 for all
			"deleted" => 0,               # -1 all, 1 or 0
			"status"  => "inbox",          # "inbox","trash","draft","sent"
		];
		$params  = set_args( $params, $default );
		extract( $params );
		global $db;

		$Q = "SELECT COUNT(*) FROM `" . \MySQL\Tables::table_name( "messages" ) . "` WHERE `status`='$status'";

		if ( $viewed <> - 1 ) {
			$Q .= " AND `viewed`=$viewed";
		}

		if ( $from == - 1 ) {
			$Q .= " AND `from`=" . \Admins\UserInfo::get_my_id();
		} else if ( $from > 0 ) {
			$Q .= " AND `from`=$from";
		}

		if ( $to == - 1 ) {
			$Q .= " AND `to`=" . \Admins\UserInfo::get_my_id();
		} else if ( $to > 0 ) {
			$Q .= " AND `to`=$to";
		}

		$deleted = (int) $deleted;
		if ( $deleted <> - 1 ) {
			$Q .= " AND `deleted`='{$deleted}'";
		}

		if ( $search <> "" ) {
			$search = $db->set_string( $search );
			$Q      .= " AND (`message` LIKE '%$search%' OR `subject` LIKE '%$search%')";
		}

		return $db->get_var( $Q );
	}

	function get_messages( $params = "" ) {
		$default = [
			"page"     => 0,                  # 0 = all pages
			"pagesize" => 10,
			"orderby"  => "id",
			"order"    => "DESC",
			"search"   => "",
			"viewed"   => - 1,               # -1 all, 1 or 0
			"from"     => 0,                  # -1 for current user, 0 for all
			"to"       => - 1,                   # -1 for current user, 0 for all
			"deleted"  => 0,               # -1 all, 1 or 0
			"status"   => "inbox",          # "inbox","trash","draft","sent"
		];
		$params  = set_args( $params, $default );
		extract( $params );
		global $db;

		$Q = "SELECT * FROM `{$this->Table}` WHERE `status`='$status'";

		if ( $viewed <> - 1 ) {
			$Q .= " AND `viewed`=$viewed";
		}

		if ( $from == - 1 ) {
			$Q .= " AND `from`=" . \Admins\UserInfo::get_my_id();
		} else if ( $from > 0 ) {
			$Q .= " AND `from`=$from";
		}

		if ( $to == - 1 ) {
			$Q .= " AND `to`=" . \Admins\UserInfo::get_my_id();
		} else if ( $to > 0 ) {
			$Q .= " AND `to`=$to";
		}

		$deleted = (int) $deleted;
		if ( $deleted <> - 1 ) {
			$Q .= " AND `deleted`=$deleted";
		}

		if ( $search <> "" ) {
			$search = $db->set_string( $search );
			$Q      .= " AND (`message` LIKE '%$search%' OR `subject` LIKE '%$search%')";
		}
		$Q .= " ORDER BY `$orderby` $order";
		if ( $page == 0 ) {
			$rows["rows"] = $db->get_rows( $Q );
		} else {
			$rows = $db->get_rows2( $Q, $page, $pagesize );
		}
		foreach ( $rows["rows"] as &$row ) {
			$row["from_name"] = $db->get_var( "SELECT `name` FROM `admins` WHERE `id`=" . $row["from"] );
			$row["to_name"]   = $db->get_var( "SELECT `name` FROM `admins` WHERE `id`=" . $row["to"] );
		}

		return $rows;
	}

	function get_message( $params = "" ) {
		$default = [
			"id"          => "0",
			"mark_unread" => 1,
			"to"          => - 1,
		];
		$params  = set_args( $params, $default );
		extract( $params );
		global $db;

		$Q = "SELECT * FROM `{$this->Table}` WHERE `id`=$id";
		if ( $to == - 1 ) {
			$Q .= " AND `to`=" . \Admins\UserInfo::get_my_id();
		} elseif ( $to > 0 ) {
			$Q .= " AND `to`={$to}";
		}

		$row = $db->get_row( $Q );
		if ( is_array( $row ) && sizeof( $row ) > 0 ) {
			$row["from_name"] = $db->get_var( "SELECT `name` FROM `admins` WHERE `id`=" . $row["from"] );
			$row["to_name"]   = $db->get_var( "SELECT `name` FROM `admins` WHERE `id`=" . $row["to"] );
		}
		$row["viewed"] = isset( $row["viewed"] ) ? $row["viewed"] : '';
		if ( ( $mark_unread == 1 || $mark_unread == true ) && is_array( $row ) && sizeof( $row ) > 0 && $row["viewed"] === "0" ) {
			$data["viewed"]       = 1;
			$data["reading_time"] = \Dates::mysql_datetime();
			$data["reading_ip"]   = \General::myip();

			$Q = "UPDATE `{$this->Table}` SET `viewed`=1 WHERE `id`=$id";
			$db->query( $Q );
		}

		return $row;
	}
}