<?php

// All about newsletter
class MyDatetime {

	function __construct() {
		register_shutdown_function( [ &$this, '__destruct' ] );
	}

	function __destruct() {
		return true;
	}

	function human_time_difference( $time1, $time2 = "" ) {
		if ( $time1 == "0000-00-00 00:00:00" || $time2 == "0000-00-00 00:00:00" || $time1 == "" ) {
			return "";
		}
		if ( $time2 == "" ) {
			$time2 = time();
		}
		$time1     = strtotime( $time1 );
		$precision = 6;

		if ( $time1 > $time2 ) {
			$ttime  = $time1;
			$time1  = $time2;
			$time2  = $ttime;
			$prefix = " later";
		} else {
			$prefix = " ago";
		}

		$intervals = [ 'year', 'month', 'day', 'hour', 'minute', 'second' ];
		$diffs     = [];

		foreach ( $intervals as $interval ) {
			// Create temp time from time1 and interval
			$ttime = strtotime( '+1 ' . $interval, $time1 );
			// Set initial values
			$add    = 1;
			$looped = 0;
			// Loop until temp time is smaller than time2
			while ( $time2 >= $ttime ) {
				// Create new temp time from time1 and interval
				$add ++;
				$ttime = strtotime( "+" . $add . " " . $interval, $time1 );
				$looped ++;
			}

			$time1              = strtotime( "+" . $looped . " " . $interval, $time1 );
			$diffs[ $interval ] = $looped;
		}

		$count = 0;
		$times = [];
		// Loop thru all diffs
		foreach ( $diffs as $interval => $value ) {
			// Break if we have needed precission
			if ( $count >= $precision ) {
				break;
			}
			// Add value and interval
			// if value is bigger than 0
			if ( $value > 0 ) {
				// Add s if value is not 1
				if ( $value != 1 ) {
					$interval .= "s";
				}
				// Add value and interval to times array
				$times[] = $value . " " . $interval;
				$count ++;
			}
		}

		// Return string with times
		return implode( " ", $times ) . " " . $prefix;

		$diff = $time2 - $time1;
		if ( $diff <= 60 ) {
			return $diff . " seconds ago";
		} elseif ( $diff <= 3600 ) {
			return round( $diff / 60, 0 ) . " minutes ago";
		} elseif ( $diff <= 86400 ) {
			$h = round( ( $diff / 60 ) / 60, 0 );

			return $h . " hours ago";
		} else {
			return $diff;
		}
	}
}