<?php

class SMS {

	var $Table = "sms_queue";
	var $DB;
	var $Gateways;

	function __construct() {
		global $db;
		$this->DB = $db;

		$this->Gateways = [
			"0"             => "-- No gateway --",
			"fekara"        => "Fekara Built-in Gateway",
			"webhoster4u"   => "Web Hoster 4 U SMS Gateway",
			"fastsmsalerts" => "Fast SMS Alerts",
			'msmsmarketing' => 'MSMS Marketing',
		];

		$Q = "ALTER TABLE `{$this->Table}` ADD `added_time` DATETIME NOT NULL";
		$this->DB->query( $Q );
	}

	function sms_mask() {
		if ( ! is_paid_fekara() ) {
			return "Not allowed!";
		}

		$sms_api = $this->DB->get_option( "sms_api" );
		if ( empty( $sms_api ) ) {
			return "creativeON";
		}

		$data = "api=" . $sms_api . "&mask";

		$ch = curl_init();
		// Set query data here with the URL
		if ( \General::localhost() ) {
			curl_setopt( $ch, CURLOPT_URL, 'http://localhost/-/smsapi/api?' . $data );
		} else {
			curl_setopt( $ch, CURLOPT_URL, 'http://sms.creativeon.com/api/?' . $data );
		}

		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
		curl_setopt( $ch, CURLOPT_TIMEOUT, '3' );
		$content = trim( curl_exec( $ch ) );
		curl_close( $ch );

		return $content;
	}

	function sms_balance() {
		if ( ! is_paid_fekara() ) {
			return __( "Not allowed" );
		}

		$sms_gateway = $this->DB->get_option( "sms_gateway", "0" );
		if ( $sms_gateway <> "fekara" ) {
			return "*";
		}

		$sms_api = $this->DB->get_option( "sms_api" );
		if ( empty( $sms_api ) ) {
			return "0";
		}

		$data = "api=" . $sms_api . "&balance";

		if ( \General::localhost() ) {
			$url = 'http://localhost/-/smsapi/api?' . $data;
		} else {
			$url = 'http://sms.creativeon.com/api/?' . $data;
		}

		return curl_get_file_contents( $url );

		/*
		$ch = curl_init();
		// Set query data here with the URL
		if ($_SERVER["HTTP_HOST"]=="localhost") {
			curl_setopt($ch, CURLOPT_URL, 'http://localhost/-/smsapi/api?' . $data);
		} else {
			curl_setopt($ch, CURLOPT_URL, 'http://sms.creativeon.com/api/?' . $data);
		}

		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_TIMEOUT, '3');
		$content = trim(curl_exec($ch));
		curl_close($ch);
		return $content;
		*/

		/*$ch = curl_init('http://sms.creativeon.com/api/');
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$result = curl_exec($ch);
		curl_close($ch);
		return $result;*/
	}

	function send_sms( $to, $message, $ip = "", $user_id = "" ) {
		if ( ! is_paid_fekara() ) {
			return __( "SMS Not allowed in Free Version" );
		}
		$sms_gateway = $this->DB->get_option( "sms_gateway", "0" );
		if ( $sms_gateway == "0" ) {
			return __( "Please select SMS gateway from settings / SMS  page" );
		}
		$sms_api = $this->DB->get_option( "sms_api" );
		if ( empty( $sms_api ) ) {
			return __( "Invalid SMS API" );
		}

		$to             = trim( $to );
		$search_replace = [
			"+" => "",
			" " => "",
		];
		$to             = str_replace( array_keys( $search_replace ), array_values( $search_replace ), $to );
		if ( substr( $to, 0, 2 ) == '00' ) {
			$to = "0" . substr( $to, 2 );
		}

		$t = $this->DB->get_option( "sms_header" );
		if ( ! empty( $t ) ) {
			$message = $t . "\n" . $message;
		}
		$t = $this->DB->get_option( "sms_footer" );
		if ( ! empty( $t ) ) {
			$message = $message . "\n" . $t;
		}

		$message = urlencode( $message );
		global $db;

		if ( $sms_gateway == "fekara" ) {
			$data = "api=" . $sms_api . "&to={$to}&message={$message}";

			$ch = curl_init();
			if ( $ch === false ) {
				return __( "Can't communicate with SMS server" );
			}
			// Set query data here with the URL
			if ( \General::localhost() ) {
				curl_setopt( $ch, CURLOPT_URL, 'http://localhost/-/smsapi/api?' . $data );
			} else {
				curl_setopt( $ch, CURLOPT_URL, 'http://sms.creativeon.com/api/?' . $data );
			}
			curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
			curl_setopt( $ch, CURLOPT_TIMEOUT, '3' );
			$content = trim( curl_exec( $ch ) );
			curl_close( $ch );
			if ( $content == "OK" ) {
				$this->log( $to, $message, $ip, $user_id );
			}

			return $content;
		} elseif ( $sms_gateway == "webhoster4u" ) {
			if ( substr( $to, 0, 2 ) == "91" ) {
				$to = substr( $to, 2 );
			}

			$sms_user      = $this->DB->get_option( "sms_user" );
			$sms_sender_id = $this->DB->get_option( "sms_sender_id" );
			$data          = "user={$sms_user}&apikey={$sms_api}&mobile={$to}&message={$message}&senderid={$sms_sender_id}&type=txt";

			$ch = curl_init();
			if ( $ch === false ) {
				return __( "Can't communicate with SMS server" );
			}

			curl_setopt( $ch, CURLOPT_URL, 'http://sms.webhoster4u.com/api/sendsms.php?' . $data );

			curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
			curl_setopt( $ch, CURLOPT_TIMEOUT, '3' );
			$content = trim( curl_exec( $ch ) );
			curl_close( $ch );

			if ( is_numeric( $content ) ) {
				$this->log( $to, $message, $ip, $user_id );

				return "OK";
			} else {
				return __( $content );
			}
		} else if ( $sms_gateway == 'fastsmsalerts' ) {
			$responseType = "json";
			$id           = $db->get_option( "sms_user" );
			$pass         = $db->get_option( "sms_api" );
			$lang         = "English";
			$mask         = $db->get_option( "sms_sender_id" );
			//$message = $message;
			$url = "http://fastsmsalerts.com/api/compose";
			$url .= "?id=" . $id . "&pass=" . $pass . "&msg=" . $message . "&to=" . $to . "&mask=" . $mask . "&lang=" . $lang . "&type=" . $responseType;

			$response_server = \Urls::file_get_contents( $url );
			$response        = json_decode( $response_server );
			if ( isset( $response->type ) && $response->type == 'Success' ) {
				$this->log( $to, $message, $ip, $user_id );

				return 'OK';
			} else if ( isset( $response->response ) ) {
				return $response->response;
			} else {
				return $response_server;
			}
		} else if ( $sms_gateway == 'msmsmarketing' ) {
			$id   = $db->get_option( "sms_user" );
			$pass = $db->get_option( "sms_api" );
			$mask = $db->get_option( "sms_sender_id" );
			//			$url = "http://ab.msmsmarketing.com/sendapi.aspx?id=737&pass=ycms786&mobile=923008258873&brandname=YCMS%20School&msg=testing";
			$url = "http://ab.msmsmarketing.com/sendapi.aspx?";
			$url .= "id=" . $id . '&pass=' . $pass . "&mobile=" . $to . "&brandname=" . rawurlencode( $mask ) . "&msg=" . $message;

			$response = \Urls::file_get_contents( $url );

			if ( trim( $response ) == 'sent' ) {
				$this->log( $to, $message, $ip, $user_id );

				return 'OK';
			} else {
				return $response;
			}

		} else {
			return __( "Invalid SMS gateway selected" );
		}

	}

	function log( $to, $message, $ip = "", $user_id = "" ) {
		// Format >> to *_*_* $message *_*_* time *_*_* IP *_*_* admin_id
		if ( empty( $ip ) ) {
			$ip = \General::myip();
		}
		if ( empty( $user_id ) ) {
			$user_id = \Admins\UserInfo::get_my_id();
		}
		$line     = $to . "*_*_*" . $message . "*_*_*" . date( "d-M-Y H:i:s" ) . "*_*_*" . $ip . "*_*_*" . $user_id . "\n";
		$FilePath = ROOT_PATH . "contents/sms_logs/";
		@mkdir( $FilePath );
		$FilePath .= date( "d-M-Y" ) . ".log";

		return file_put_contents( $FilePath, $line, FILE_APPEND );
	}

	function get_log_files() {
		if ( ! is_paid_fekara() ) {
			return "Not allowed!";
		}
		$Files = [];
		$Path  = ROOT_PATH . "contents/sms_logs/";
		if ( ! is_dir( $Path ) ) {
			return $Files;
		}

		$Files = \File::files_list( $Path . "*.log" );
		$Files = array_reverse( $Files );

		return $Files;
	}

	function file_logs( $log_file_name ) {
		$path = ROOT_PATH . "contents/sms_logs/" . $log_file_name;
		if ( ! file_exists( $path ) ) {
			return [];
		}
		$lines = file( $path );
		$Logs  = [];
		foreach ( $lines as $line ) {
			$l              = explode( "*_*_*", $line );
			$l[0]           = isset( $l[0] ) ? $l[0] : '';
			$l[1]           = isset( $l[1] ) ? $l[1] : '';
			$l[2]           = isset( $l[2] ) ? $l[2] : '';
			$l[3]           = isset( $l[3] ) ? $l[3] : '';
			$l[4]           = isset( $l[4] ) ? $l[4] : '';
			$log["cell"]    = $l[0];
			$log["message"] = $l[1];
			$log["time"]    = $l[2];
			$log["ip"]      = $l[3];
			$log["admin"]   = trim( $l[4] );
			$Logs[]         = $log;
		}

		return $Logs;
	}

	function get_sms_queue( $args = "" ) {
		$default = [
			"limit"   => "5",
			"orderby" => "id",
			"order"   => "DESC",
		];
		$args    = set_args( $args, $default );
		extract( $args );

		$Q    = "SELECT * FROM `$this->Table` ORDER BY {$orderby} $order LIMIT {$limit}";
		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	function count_queued_sms() {
		return $this->DB->get_var( "SELECT COUNT(*) FROM `{$this->Table}`" );
	}

	function add_bulk_to_queue( $data_array = [] ) {
		foreach ( $data_array as $data ) {
			$this->add_to_queue( $data[0], $data[1] );
		}

		if ( count( $data_array ) > 0 ) {
			$message = "Dear Administrator,<br><br>System added new " . count( $data_array ) . " SMS in queue please click on link below<br><br>";
			$message .= DOMAIN_URL . 'sms_queue.php';
			$message .= "<br><br>Regards";
			send_mail( $this->DB->get_option( "admin_email" ), "New SMS added in Queue.", $message );
			//send_mail( "shakeel@shakeel.pk", "New SMS added in Queue.", $message );
		}
	}

	function add_to_queue( $to, $message ) {
		if ( ! is_paid_fekara() ) {
			return "Not allowed!";
		}
		$Admins = new Admins;

		if ( ! empty( $t ) ) {
			$message = $message . "\n" . $t;
		}

		$data = [
			"to"         => $to,
			"message"    => $message,
			"user_id"    => \Admins\UserInfo::get_my_id(),
			"ip"         => \General::myip(),
			"added_time" => \Dates::mysql_datetime(),
		];

		$response = $this->DB->insert( "sms_queue", $data );

		return $response;
	}

	function empty_sms_queue() {
		$Q = "TRUNCATE `{$this->Table}`";

		return $this->DB->query( $Q );
	}

	function proceed_queue() {
		$smslist = $this->get_sms_queue( [
			"orderby" => "RAND()",
		] );

		if ( is_array( $smslist ) ) {
			foreach ( $smslist as $S ) {
				$response = $this->send_sms( $S["to"], $S["message"], $S["ip"], $S["user_id"] );
				if ( $response == "OK" ) {
					$Q = "DELETE FROM `{$this->Table}` WHERE `id`=" . $S["id"];
					$this->DB->query( $Q );
				} else {
					$data = array( "error" => $response );
					$this->DB->update( "sms_queue", $data, [ "id" => $S["id"] ] );
				}
			}
		}
	}
}