<?php

class Sessions {

	var $Table = "sessions";
	var $DB;

	function __construct() {
		global $db;
		$this->DB = $db;
	}

	function get_list( $params = "" ) {
		$default = [
			"active"  => - 1,
			"limit"   => 0,
			"order"   => "DESC",
			"orderby" => "id",
			"id"      => 0,
		];
		$params  = set_args( $params, $default );
		extract( $params );
		global $db;
		$Q    = "SELECT * FROM `{$this->Table}` WHERE 1";
		$rows = $db->get_rows( $Q );

		return $rows;
	}


	function get_list_data( $params = "" ) {
		$default = [
			"active"  => - 1,
			"limit"   => 0,
			"order"   => "DESC",
			"orderby" => "id",
			"id"      => 0,
		];
		$params  = set_args( $params, $default );
		extract( $params );

		global $db;
		$Q = "SELECT * FROM `{$this->Table}` WHERE 1";
		if ( $active == 1 || $active == 0 ) {
			$Q .= " AND `active`=$active";
		}

		if ( $id > 0 ) {
			$Q .= " AND `id`=$id";
		}

		$Q .= " ORDER BY `$orderby` $order";
		if ( $limit > 0 ) {
			$Q .= " LIMIT $limit";
		}

		if ( $limit == 1 ) {
			$rows = $db->get_row( $Q );
			if ( ! isset( $rows["id"] ) ) {
				return [];
			}
			$rows["added_time2"] = \Dates::my_datetime( $rows["added_time"] );
			$rows["added_time3"] = date( $db->get_option( "date_time_format2" ), strtotime( $rows["added_time"] ) );
			$rows["added_time4"] = \Dates::human_time_difference( $rows["added_time"] );
			//$rows["classes_count"] = $db->get_var( "SELECT COUNT(*) FROM `batch_classes` WHERE `batch_id`=" . $rows["id"] );
			//$rows["classes"]       = $db->get_rows( "SELECT * FROM `batch_classes` WHERE `batch_id`=" . $rows["id"] );
		} else {
			$rows = $db->get_rows( $Q );
			foreach ( $rows as &$row ) {
				$row["added_time2"] = \Dates::my_datetime( $row["added_time"] );
				$row["added_time3"] = date( $db->get_option( "date_time_format2" ), strtotime( $row["added_time"] ) );
				$row["added_time4"] = \Dates::human_time_difference( $row["added_time"] );
				//$row["classes_count"] = $db->get_var( "SELECT COUNT(*) FROM `batch_classes` WHERE `batch_id`=" . $row["id"] );
				//$row["classes"]       = $db->get_rows( "SELECT * FROM `batch_classes` WHERE `batch_id`=" . $row["id"] );
			}
		}

		return $rows;
	}


	function get_active_batch() {
		$Q = "SELECT * FROM `batches` WHERE `active` ORDER BY `id` DESC LIMIT 1";
		global $db;
		$row = $db->get_row( $Q );
		if ( ! is_array( $row ) ) {
			return false;
		} else {
			return $row;
		}
	}

	function get_active_batch_name() {
		$b = $this->get_active_batch();

		return $b["batch_name"];
	}


	function save_session( $data = [] ) {
		extract( $data );
		if ( ! isset( $id ) || ! isset( $active ) ) {
			return "Provide complete data";
		}
		if ( ! isset( $session_name ) || trim( $session_name ) == "" ) {
			return "Session name missing";
		}
		if ( empty( $classes ) ) {
			return "Class name missing";
		} else {
			$classes         = implode( ",", $classes );
			$data["classes"] = $classes;
		}
		global $db;

		$Q = "SELECT COUNT(*) FROM `sessions` WHERE `session_name`='" . $db->set_string( $session_name ) . "'";
		if ( $id > 0 ) {
			$Q .= " AND `id`<>$id";
		}
		if ( $db->get_var( $Q ) > 0 ) {
			return ( "Provide different session name, This name already exists" );
		}

		// unset( $data["id"] );
		$data["start_date"] = \Dates::mysql_date( $start_date );
		$data["end_date"]   = \Dates::mysql_date( $end_date );
		if ( $id == 0 ) {
			$data["added_by"]   = \Admins\UserInfo::get_my_id();
			$data["added_time"] = \Dates::mysql_datetime();
			$data["added_ip"]   = \General::myip();
			$r                  = $this->DB->insert( "sessions", $data );
		} else {
			$r = $this->DB->update( "sessions", $data, [ "id" => $id ] );
		}

		if ( $r === false ) {
			return $this->DB->last_error;
		} else {
			return "OK";
		}
	}

	function save_session_teacher( $data = [] ) {
		extract( $data );

		if ( empty( $teachers ) ) {
			$data["teachers"] = "";
		} else {
			$teachers         = implode( ",", $teachers );
			$data["teachers"] = $teachers;
		}

		$id = (int) $id;

		if ( ! empty( $id ) ) {
			$r = $this->DB->update( "sessions", $data, [ "id" => $id ] );
		} else {
			return "Empty ID";
		}

		if ( $r === false ) {
			$this->DB->last_error;
		} else {
			return "OK";
		}
	}

	function get_batch_name( $id = 0 ) {
		global $db;
		if ( $id == 0 ) {
			$id = $db->get_var( "SELECT `id` FROM `batches` WHERE `active`=1 ORDER BY `id` DESC LIMIT 1" );
		}
		$Q = "SELECT `batch_name` FROM `batches` WHERE `id`=$id";

		return $db->get_var( $Q );
	}

	function count_students( $params = "" ) {
		$default = [
			"active" => "-1",     # Negative number=All students, 1=Only active, 0=Not active students
			"batch"  => "-1"       # negative number=current batch,0=all batches,greaten than zero=specific batch id
		];
		$params  = set_args( $params, $default );
		extract( $params );

		global $db;
		$Q = "SELECT `batch_id` FROM `batch_classes` WHERE ";
	}


}