<?php

class Student {

	var $Table = "students";
	const Table = "students";
	var $TableAssignments = "student_assignments";
	var $AllowedFileTypes = [
		".jpg",
		".jpeg",
		".png",
		".gif",
		".doc",
		".docx",
		".xls",
		".xlsx",
		".pdf",
		".txt",
	];
	var $DB;

	var $BloodGroupsArray = [
		"Unknown",
		"A+",
		"A-",
		"B+",
		"B-",
		"O+",
		"O-",
		"AB+",
		"AB-",
	];
	var $RelationArray = [
		"Father",
		"Mother",
		"Uncle",
		"Aunt",
		"Brother",
		"Sister",
		"Neighbour",
		"Other",
	];
	var $active_batch = 0;

	function __construct() {
		global $db;
		$this->DB = $db;

		$query = "CREATE TABLE IF NOT EXISTS `students` (
  `id` int(11) NOT NULL,
  `roll` varchar(15) NOT NULL,
  `name` varchar(100) NOT NULL,
  `father_name` varchar(100) NOT NULL,
  `guardian_name` varchar(100) NOT NULL,
  `phone` varchar(50) NOT NULL,
  `cell` varchar(100) NOT NULL,
  `guardian_cell` varchar(100) NOT NULL,
  `address` varchar(250) NOT NULL,
  `city` varchar(50) NOT NULL,
  `state` varchar(50) NOT NULL,
  `email` varchar(100) NOT NULL,
  `guardian_email` varchar(100) NOT NULL,
  `active` tinyint(1) NOT NULL DEFAULT '1',
  `added_by` int(11) NOT NULL,
  `added_time` datetime NOT NULL,
  `added_ip` varchar(100) NOT NULL,
  `admission_date` date NOT NULL,
  `dob` date NOT NULL,
  `nic` varchar(15) NOT NULL,
  `gender` char(1) NOT NULL DEFAULT 'M',
  `religion` varchar(50) NOT NULL,
  `blood_group` varchar(7) NOT NULL,
  `class_id` int(11) NOT NULL,
  `admission_number` int(15) NOT NULL,
  `nationality` varchar(50) NOT NULL,
  `is_sms` tinyint(1) NOT NULL DEFAULT '0',
  `is_email` tinyint(1) NOT NULL DEFAULT '0',
  `guardian_relation` varchar(20) NOT NULL DEFAULT '0',
  `guardian_dob` date NULL DEFAULT NULL,
  `guardian_education` varchar(30) NOT NULL DEFAULT '0',
  `guardian_occupation` varchar(30) NOT NULL DEFAULT '0',
  `guardian_income` decimal(15,2) NOT NULL DEFAULT '0.00',
  `guardian_address` varchar(200) NOT NULL,
  `guardian_city` varchar(30) NOT NULL,
  `guardian_state` varchar(30) NOT NULL,
  `guardian_phone` varchar(50) NOT NULL,
  `guardian_remarks` text NOT NULL,
  `birth_place` varchar(50) NOT NULL,
  `prev_institute1` varchar(100) NOT NULL,
  `prev_course1` varchar(100) NOT NULL,
  `prev_year1` varchar(4) NOT NULL,
  `prev_marks1` int(11) NOT NULL,
  `fee` decimal(10,2) NOT NULL,
  `admission_fee` decimal(10,2) NOT NULL,
  `deleted` tinyint(1) NOT NULL DEFAULT '0',
  `tution_fee` decimal(10,2) NOT NULL,
  `annual_funds` decimal(10,2) NOT NULL,
  `practical_charges` decimal(10,2) NOT NULL,
  `test_session_fee` decimal(10,2) NOT NULL,
  `admin_notes` text NOT NULL,
  `student_category` varchar(150) NOT NULL DEFAULT 'General'
);";
		$this->DB->query( $query );

		\DB\Views::students_view();
		$this->D = new \DB\Select();

		$this->DB->where( 'deleted IS NULL' )->update_data( 'deleted', 0 )->update( 'students' );

		global $db2;
		$db2->where( 'batch_id IS NULL' )
		    ->where( 'batch_id', 0, '=', 'OR' )
		    ->update( \MySQL\Tables::table_name( 'students' ), [ 'batch_id' => \Batch::get_active_batch_id_static() ] );
		if ( ! $this->DB->is_mysql_view( \MySQL\Tables::table_name( 'students_view' ) ) ) {
			self::create_students_view();
		}

		$this->active_batch = $this->get_active_batch();
	}

	public function get_student( $id, $fields = "*" ) {
		global $db;

		$row = $this->DB->where( 'id', $id )
		                ->start_group()
		                ->where( 'deleted', 0 )
		                ->where_or( 'deleted IS NULL' )
		                ->end_group()
		                ->get_row( \MySQL\Tables::table_name( 'students_view' ) );

		if ( $fields <> "*" ) {
			$fields = explode( ",", $fields );
			$out    = [];
			foreach ( $fields as $field ) {
				if ( isset( $row[ $field ] ) ) {
					$out[ $field ] = $row[ $field ];
				}
			}
			$row = $out;
		}
		if ( isset( $row["id"] ) ) {
			$row["Subjects"] = $this->get_student_subjects( $row["id"] );

			$row["num_subjects"]          = sizeof( $row["Subjects"] );
			$row["Subjects_not_assigned"] = $this->get_student_subjects_not_assigned( $row["id"] );
			$row["photo"]                 = $this->get_student_photo( $row["id"] );
			$row["profile_url"]           = DOMAIN_URL . 'student_profile.php?id=' . $row["id"];
			$row["reports_url"]           = Urls::get_url( "student_reports", $row["id"] );
			$row["sendmail_url"]          = Urls::get_url( "student_sendmail", $row["id"] );
			$batch                        = $this->get_batch( $row["id"] );
			$batch["batch_name"]          = isset( $batch["batch_name"] ) ? $batch["batch_name"] : '';
			$batch["id"]                  = isset( $batch["id"] ) ? $batch["id"] : 0;
			$row["batch"]                 = $batch["batch_name"];
			$row["batch_id"]              = $batch["id"];
		}
		if ( isset( $row["class_id"] ) ) {
			$row["class"] = $this->DB->select_cols( 'class_name' )
			                         ->where( 'id', $row["class_id"] )
			                         ->get_var( 'batch_classes' );
			//			$row["class"] = $this->DB->get_var( "SELECT `class_name` FROM `batch_classes` WHERE `id`=" . $row["class_id"] );
		}
		/*if ( isset($row["batch_id"]) ) {
			$row["batch"] = $this->DB->get_var("SELECT `batch_name` FROM `batches` WHERE `id`=".$row["batch_id"]);
		}*/
		if ( isset( $row["admission_date"] ) ) {
			$row["admission_date2"] = \Dates::my_date( $row["admission_date"] );
			$row["admission_date3"] = date( $this->DB->get_option( "date_format2" ), strtotime( $row["admission_date"] ) );
		}
		if ( isset( $row["dob"] ) ) {
			$row["dob2"] = \Dates::my_date( $row["dob"] );
			$row["dob3"] = date( $this->DB->get_option( "date_format2" ), strtotime( $row["dob"] ) );
		}
		if ( isset( $row["guardian_dob"] ) ) {
			$row["guardian_dob2"] = $row["guardian_dob"] == "0000-00-00" ? "" : \Dates::my_date( $row["guardian_dob"] );
			$row["guardian_dob3"] = $row["guardian_dob"] == "0000-00-00" ? "" : date( $this->DB->get_option( "date_format2" ), strtotime( $row["guardian_dob"] ) );
		}
		if ( isset( $row["gender"] ) ) {
			$row["gender2"] = $row["gender"] == "F" ? "Female" : "Male";
		}

		// echo "<pre>";print_r($row);die();
		return $row;
	}

	public function get_student_row( $id, $fields = "*" ) {
		global $db;
		$row = $this->DB->where( 'id', $id )->where( 'deleted', 0 )->get_rows( 'students_view' );
		//		$Q   = "SELECT * FROM `students_view` WHERE `id`='$id' AND `deleted`='0'";
		//		$row = $this->DB->get_rows( $Q );

		if ( $fields <> "*" ) {
			$fields = explode( ",", $fields );
			$out    = [];
			foreach ( $fields as $field ) {
				if ( isset( $row[ $field ] ) ) {
					$out[ $field ] = $row[ $field ];
				}
			}
			$row = $out;
		}

		if ( isset( $row[0]["id"] ) ) {
			$row[0]["Subjects"] = $this->get_student_subjects( $row[0]["id"] );
			//$this->DB->get_rows("SELECT * FROM `student_classes_subjects` WHERE `student_id`=".$row["id"]." ORDER BY `class_id`");
			$row[0]["num_subjects"]          = sizeof( $row[0]["Subjects"] );
			$row[0]["Subjects_not_assigned"] = $this->get_student_subjects_not_assigned( $row[0]["id"] );
			$row[0]["photo"]                 = $this->get_student_photo( $row[0]["id"] );
			$row[0]["profile_url"]           = Urls::get_url( "student_profile", $row[0]["id"] );
			$row[0]["reports_url"]           = Urls::get_url( "student_reports", $row[0]["id"] );
			$row[0]["sendmail_url"]          = Urls::get_url( "student_sendmail", $row[0]["id"] );
			$batch                           = $this->get_batch( $row[0]["id"] );
			$batch["batch_name"]             = isset( $batch["batch_name"] ) ? $batch["batch_name"] : '';
			$batch["id"]                     = isset( $batch["id"] ) ? $batch["id"] : 0;
			$row[0]["batch"]                 = $batch["batch_name"];
			$row[0]["batch_id"]              = $batch["id"];
		}
		if ( isset( $row[0]["class_id"] ) ) {
			$row[0]["class"] = $this->DB->select_cols( 'class_name' )
			                            ->where( 'id', $row[0]["class_id"] )
			                            ->get_var( 'class_name' );
			//			$row[0]["class"] = $this->DB->get_var( "SELECT `class_name` FROM `batch_classes` WHERE `id`=" . $row[0]["class_id"] );
		}
		/*if ( isset($row["batch_id"]) ) {
			$row["batch"] = $this->DB->get_var("SELECT `batch_name` FROM `batches` WHERE `id`=".$row["batch_id"]);
		}*/
		if ( isset( $row[0]["admission_date"] ) ) {
			$row[0]["admission_date2"] = \Dates::my_date( $row[0]["admission_date"] );
			$row[0]["admission_date3"] = date( $this->DB->get_option( "date_format2" ), strtotime( $row[0]["admission_date"] ) );
		}
		if ( isset( $row[0]["dob"] ) ) {
			$row[0]["dob2"] = \Dates::my_date( $row[0]["dob"] );
			$row[0]["dob3"] = date( $this->DB->get_option( "date_format2" ), strtotime( $row[0]["dob"] ) );
		}
		if ( isset( $row[0]["guardian_dob"] ) ) {
			$row[0]["guardian_dob2"] = $row[0]["guardian_dob"] == "0000-00-00" ? "" : \Dates::my_date( $row[0]["guardian_dob"] );
			$row[0]["guardian_dob3"] = $row[0]["guardian_dob"] == "0000-00-00" ? "" : date( $this->DB->get_option( "date_format2" ), strtotime( $row[0]["guardian_dob"] ) );
		}
		if ( isset( $row[0]["gender"] ) ) {
			$row[0]["gender2"] = $row[0]["gender"] == "F" ? "Female" : "Male";
		}

		// echo "<pre>";print_r($row);die();
		return $row;
	}

	public function get_student_photo( $id, $type = "url" ) {
		$type = strtolower( $type );
		$File = new File();
		if ( $type <> "url" && $type <> "path" ) {
			$type = "url";
		}
		if ( ! is_dir( STUDENT_FILES . "$id" ) && $type == "url" ) {
			return "http://www.placehold.it/165x200/EFEFEF/000000&text=No+Student+Photo";
		}
		if ( ! is_dir( STUDENT_FILES . "$id" ) ) {
			return "";
		}
		if ( ! is_dir( STUDENT_FILES . "$id/photo/" ) && $type == "url" ) {
			return "http://www.placehold.it/150x150/EFEFEF/000000&text=No+Student+Photo";
		}
		if ( ! is_dir( STUDENT_FILES . "$id/photo/" ) ) {
			return "";
		}
		$photos = glob( STUDENT_FILES . "$id/photo/" . $File->globistr( "*.jpg" ) );
		if ( sizeof( $photos ) == "0" ) {
			$photos = glob( STUDENT_FILES . "$id/photo/" . $File->globistr( "*.jpeg" ) );
		}
		if ( sizeof( $photos ) == "0" ) {
			$photos = glob( STUDENT_FILES . "$id/photo/" . $File->globistr( "*.gif" ) );
		}
		if ( sizeof( $photos ) == "0" ) {
			$photos = glob( STUDENT_FILES . "$id/photo/" . $File->globistr( "*.png" ) );
		}
		if ( sizeof( $photos ) == "0" && $type == "url" ) {
			return "http://www.placehold.it/150x150/EFEFEF/000000&text=No+Student+Photo";
		} else if ( sizeof( $photos ) == "0" && $type == "path" ) {
			return "";
		} else if ( $type == "path" ) {
			return $photos[0];
		} else {
			return str_replace( ROOT_PATH, DOMAIN_URL, $photos[0] );
		}
	}

	public function save_photo( $fileArray, $id ) {
		if ( ! is_array( $fileArray ) ) {
			return "Invalid data provided";
		}

		$path = STUDENT_FILES . "$id";
		@mkdir( $path );
		$path .= "/photo";
		\File::rrmdir( $path );
		@mkdir( $path );
		$fileArray["name"] = isset( $fileArray["name"] ) ? $fileArray["name"] : '';
		$path              .= "/" . $fileArray["name"];
		if ( ! move_uploaded_file( $fileArray["tmp_name"], $path ) ) {
			return "Uploading file error";
		} else {
			return "OK";
		}
	}

	function delete_multi_students( $ids ) {
		if ( ! is_array( $ids ) ) {
			$ids = \Str::make_array( $ids );
		}
		foreach ( $ids as $id ) {
			$this->delete_student( $id );
		}
	}

	public function delete_student( $id ) {
		// Use this function very carefully, All data attached with student like Attendance, Fee Records, Subjects etc will also be removed.

		$r = $this->DB->update( "students", [ "deleted" => 1 ], [ "id" => $id ] );
		if ( $r === false ) {
			return false;
		} else {
			return true;
		}
	}

	public function un_delete_student( $id ) {

		$r = $this->DB->update( "students", [ "deleted" => 0 ], [ "id" => $id ] );
		if ( $r === false ) {
			return false;
		} else {
			return true;
		}
	}

	public function get_students( $params = "" ) {
		$default = [
			"orderby"            => "id",
			"order"              => "DESC",
			"active"             => "1",
			"mysql_cols"         => "*",
			# -1 for all
			"batch"              => "-1",
			# negative number=current batch,0=all batches,greater than zero=specific batch id
			"class_id"           => 0,
			# 0=All, 1,2,3,4 for multiple classes
			"active_class"       => 1,
			# -1 for all
			"deleted"            => 0,
			# -1=All, 0=Not Deleted (Default), 1=Deleted
			"page"               => 0,
			"pagesize"           => 0,
			"search"             => "",
			"filter"             => "",
			"subjects"           => "",
			"active_batch"       => "",
			# -1 for all
			"classes"            => "",
			"count_only"         => "0",
			"from"               => "",
			"to"                 => "",
			'subjects_in_string' => false,
			'name'               => '',
			'return_query'       => false,
			'ignore_subjects'    => false,
		];
		$params  = \General::set_args( $params, $default );
		extract( $params );

		$params['return_query'] = (bool) $params['return_query'];

		if ( ! $params['return_query'] && $params['mysql_cols'] <> '*' ) {
			$params['mysql_cols'] = \Str::make_array( $params['mysql_cols'] );
			if ( ! in_array( 'class_id', $params['mysql_cols'] ) ) {
				$params['mysql_cols'][] = 'class_id';
			}
			if ( ! in_array( 'admission_date', $params['mysql_cols'] ) ) {
				$params['mysql_cols'][] = 'admission_date';
			}
			if ( ! in_array( 'dob', $params['mysql_cols'] ) ) {
				$params['mysql_cols'][] = 'dob';
			}
			if ( ! in_array( 'gender', $params['mysql_cols'] ) ) {
				$params['mysql_cols'][] = 'gender';
			}
			if ( ! in_array( 'guardian_dob', $params['mysql_cols'] ) ) {
				$params['mysql_cols'][] = 'guardian_dob';
			}
			$params['mysql_cols'] = implode( ',', $params['mysql_cols'] );
		}

		$this->DB->select_from( 'students_view' )->select_cols( $params['mysql_cols'] );

		if ( ! empty( $from ) && empty( $to ) ) {
			$to = $from;
		}
		if ( ! empty( $to ) && empty( $from ) ) {
			$from = $to;
		}
		if ( ! empty( $from ) && ! empty( $to ) ) {
			$from = \Dates::mysql_date( $from );
			$to   = \Dates::mysql_date( $to );
			$this->DB->where_between( '`admission_date`', $from, $to );
		}

		$params['name'] = (string) $params['name'];
		if ( $params['name'] <> '' ) {
			$this->DB->where( 'name', '%' . $params['name'] . '%' );
		}

		if ( $params['active_class'] > - 1 ) {
			$this->DB->where( 'class_active', $params['active_class'] );
		}

		if ( $params['active_batch'] > - 1 && $params['active_batch'] <> "" ) {
			$this->DB->where( 'batch_active', $params['active_batch'] );
		}

		$deleted = (int) $params['deleted'];
		if ( $deleted == 0 ) {
			$this->DB->start_group()->where( 'deleted', 0 )->where_or( 'deleted IS NULL' )->end_group();
		} else if ( $deleted == 1 ) {
			$this->DB->where( 'deleted', 1 );
		}

		if ( $params['batch'] < 0 ) {
			$batch_ID = $this->get_active_batch_id();
			$Q2       = "(SELECT `id` class_id FROM `batch_classes` WHERE `batch_id`='{$batch_ID}')";
			$this->DB->where( '`class_id` IN ' . $Q2 );
		} else if ( $params['batch'] > 0 ) {
			$Q2 = "(SELECT `id` class_id FROM `batch_classes` WHERE `batch_id`='{$params['batch']}')";
			$this->DB->where( '`class_id` IN ' . $Q2 );
		}

		if ( ! empty( $filter ) ) {
			parse_str( urldecode( $filter ), $filter );
			foreach ( $filter as $key => $val ) {
				if ( $key == "admission_date" ) {
					$d = explode( ",", $val );
					if ( empty( $d[1] ) ) {
						$d[1] = $d[0];
					}
					$this->DB->where_between( 'admission_date', \Dates::mysql_date( $d[0] ), \Dates::mysql_date( $d[1] ) );
				}

				if ( $key == "classes" ) {
					$this->DB->where( 'class_id IN ' . $val );
				} else {
					$this->DB->where( $key, $val );
				}
			}
		}

		// Searching in specific classes. Classes IDs provided in comma separated values
		$class_id = \Str::make_array( $params['class_id'] );
		if ( ! empty( $class_id ) ) {
			$this->DB->where( 'class_id', $class_id );
		}

		if ( ! empty( $search ) ) {
			$search = $this->DB->set_string( $search );
			$S[]    = "`roll` LIKE '%$search%'";
			$S[]    = "`name` RLIKE '" . str_replace( ' ', '|', $search ) . "'";
			$S[]    = "`guardian_name` RLIKE '" . str_replace( ' ', '|', $search ) . "'";
			$S[]    = "`phone` LIKE '%$search%'";
			$S[]    = "`cell` LIKE '%$search%'";
			$S[]    = "`guardian_cell` LIKE '%$search%'";
			$S[]    = "`address` LIKE '%$search%'";
			$S[]    = "`city` LIKE '%$search%'";
			$S[]    = "`state` LIKE '%$search%'";
			$S[]    = "`email` LIKE '%$search%'";
			$S[]    = "`guardian_email` LIKE '%$search%'";
			$S[]    = "`nic` LIKE '%$search%'";
			$S[]    = "`religion` LIKE '%$search%'";
			$S[]    = "`blood_group` LIKE '%$search%'";
			$S[]    = "`admission_number`='$search'";
			$S[]    = "`nationality` LIKE '%$search%'";
			$S[]    = "`guardian_relation` LIKE '%$search%'";
			$S[]    = "`guardian_education` LIKE '%$search%'";
			$S[]    = "`guardian_occupation` LIKE '%$search%'";
			$S[]    = "`guardian_address` LIKE '%$search%'";
			$S[]    = "`guardian_city` LIKE '%$search%'";
			$S[]    = "`guardian_state` LIKE '%$search%'";
			$S[]    = "`guardian_phone` LIKE '%$search%'";
			$S[]    = "`birth_place` LIKE '%$search%'";
			$S[]    = "`prev_institute1` LIKE '%$search%'";
			$S[]    = "`prev_course1` LIKE '%$search%'";
			$S[]    = "`prev_year1` LIKE '%$search%'";
			$ids    = \Str::make_array( $search );
			$S[]    = "`id` IN ('" . implode( "','", $ids ) . "')";
			$this->DB->start_group()->where( implode( " OR ", $S ) )->end_group();
		}

		if ( $params['active'] >= 0 ) {
			$this->DB->where( 'active', $params['active'] );
		}

		if ( ! is_array( $params['subjects'] ) ) {
			$params['subjects'] = (string) $params['subjects'];
		}

		if ( ! empty( $params['subjects'] ) ) {
			if ( is_array( $class_id ) ) {
				foreach ( $class_id as $c_id ) {
					$this->set_all_student_subjects( $c_id );
				}
			} else if ( $class_id == 0 ) {
				$this->set_all_student_subjects();
			} else {
				$classes = explode( ",", $params['class_id'] );
				foreach ( $classes as $c_id ) {
					$this->set_all_student_subjects( $c_id );
				}
			}

			if ( ! is_array( $params['subjects'] ) ) {
				$params['subjects'] = explode( ",", $params['subjects'] );
			}

			$this->DB->start_group();
			foreach ( $params['subjects'] as $sid ) {
				if ( is_numeric( $sid ) ) {
					$subject = $this->DB->get_var( "SELECT `subject` FROM `subjects` WHERE `id`=" . $sid );
					if ( empty( $subject ) ) {
						$subject = $sid;
					}
				} else {
					$subject = $sid;
				}
				$this->DB->where_or( "`id` IN (SELECT `student_id` id FROM `student_x_subject` WHERE `subject`='" . $this->DB->set_string( $subject ) . "')" );
			}
			$this->DB->end_group();
		}

		if ( empty( $params['orderby'] ) ) {
			$params['orderby'] = "id";
			$params['order']   = "DESC";
		}

		if ( $params['orderby'] != 'DBNULL' ) {
			$this->DB->order( $params['orderby'], $params['order'] );
		}

		if ( $params['return_query'] ) {
			return $this->DB->generate_query();
		}

		$subjects_in_string        = (bool) $params['subjects_in_string'];
		$params['ignore_subjects'] = (bool) $params['ignore_subjects'];

		# Count only.
		$params['count_only'] = (bool) $params['count_only'];
		if ( $params['count_only'] ) {
			return $this->DB->count_result();
			//return $this->DB->get_var( 'students_view' );
		} else if ( $params['page'] > 0 && $params['pagesize'] > 0 ) {
			//			$rows = $this->DB->get_rows2( $Q, $page, $pagesize );
			$rows = $this->DB->get_rows2( $params['page'], $params['pagesize'] );

			if ( $params['ignore_subjects'] ) {
				return $rows;
			}

			foreach ( $rows["rows"] as $key => &$row ) {
				$subjects = $this->get_student_subjects( $row["id"] );
				if ( $subjects_in_string ) {
					$subjects = implode( ', ', $subjects );
				}

				//$row["Subjects"] = $this->DB->get_rows("SELECT * FROM `student_classes_subjects` WHERE `student_id`=".$row["id"]." ORDER BY `class_id`");
				$row["Subjects"]        = $subjects;
				$row["num_subjects"]    = sizeof( $row["Subjects"] );
				$row["photo"]           = $this->get_student_photo( $row["id"] );
				$row["class"]           = $this->DB->get_var( "SELECT `class_name` FROM `batch_classes` WHERE `id`=" . $row["class_id"] );
				$row["admission_date2"] = \Dates::my_date( $row["admission_date"] );
				$row["admission_date3"] = date( $this->DB->get_option( "date_format2" ), strtotime( $row["admission_date"] ) );
				$row["dob2"]            = \Dates::my_date( $row["dob"] );
				$row["dob3"]            = date( $this->DB->get_option( "date_format2" ), strtotime( $row["dob"] ) );
				$row["gender2"]         = $row["gender"] == "F" ? "Female" : "Male";
				$row["guardian_dob2"]   = $row["guardian_dob"] == "0000-00-00" ? "" : \Dates::my_date( $row["guardian_dob"] );
				$row["guardian_dob3"]   = $row["guardian_dob"] == "0000-00-00" ? "" : date( $this->DB->get_option( "date_format2" ), strtotime( $row["guardian_dob"] ) );
				//$row["batch"] = $this->DB->get_var("SELECT `batch_name` FROM `batches` WHERE `id`=".$row["batch_id"]);
				$row["profile_url"]  = Urls::get_url( "student_profile", $row["id"] );
				$row["reports_url"]  = Urls::get_url( "student_reports", $row["id"] );
				$row["sendmail_url"] = Urls::get_url( "student_sendmail", $row["id"] );
				$batch               = $this->get_batch( $row["id"] );
				$batch["batch_name"] = isset( $batch["batch_name"] ) ? $batch["batch_name"] : '';
				$batch["id"]         = isset( $batch["id"] ) ? $batch["id"] : 0;
				$row["batch"]        = $batch["batch_name"];
				$row["batch_id"]     = $batch["id"];
			}
		} else {
			$rows = $this->DB->get_rows();
			if ( $params['ignore_subjects'] ) {
				return $rows;
			}
			foreach ( $rows as $key => &$row ) {
				$subjects = $this->get_student_subjects( $row["id"] );
				if ( $subjects_in_string ) {
					$subjects = implode( ', ', $subjects );
				}

				//$row["Subjects"] = $this->DB->get_rows("SELECT * FROM `student_classes_subjects` WHERE `student_id`=".$row["id"]." ORDER BY `class_id`");
				$row["Subjects"]        = $subjects;
				$row["num_subjects"]    = sizeof( $row["Subjects"] );
				$row["photo"]           = $this->get_student_photo( $row["id"] );
				$row["class"]           = $this->DB->get_var( "SELECT `class_name` FROM `batch_classes` WHERE `id`=" . $row["class_id"] );
				$row["admission_date2"] = date( $this->DB->get_option( "date_format1" ), strtotime( $row["admission_date"] ) );
				$row["admission_date3"] = date( $this->DB->get_option( "date_format2" ), strtotime( $row["admission_date"] ) );
				$row["dob2"]            = date( $this->DB->get_option( "date_format1" ), strtotime( $row["dob"] ) );
				$row["dob3"]            = date( $this->DB->get_option( "date_format2" ), strtotime( $row["dob"] ) );
				$row["gender2"]         = $row["gender"] == "F" ? "Female" : "Male";
				$row["guardian_dob2"]   = $row["guardian_dob"] == "0000-00-00" ? "" : date( $this->DB->get_option( "date_format1" ), strtotime( $row["guardian_dob"] ) );
				$row["guardian_dob3"]   = $row["guardian_dob"] == "0000-00-00" ? "" : date( $this->DB->get_option( "date_format2" ), strtotime( $row["guardian_dob"] ) );
				//$row["batch"] = $this->DB->get_var("SELECT `batch_name` FROM `batches` WHERE `id`=".$row["batch_id"]);
				$row["profile_url"]  = Urls::get_url( "student_profile", $row["id"] );
				$row["reports_url"]  = Urls::get_url( "student_reports", $row["id"] );
				$row["sendmail_url"] = Urls::get_url( "student_sendmail", $row["id"] );
				$batch               = $this->get_batch( $row["id"] );
				$batch["batch_name"] = isset( $batch["batch_name"] ) ? $batch["batch_name"] : '';
				$batch["id"]         = isset( $batch["id"] ) ? $batch["id"] : 0;
				$row["batch"]        = $batch["batch_name"];
				$row["batch_id"]     = $batch["id"];
			}
		}

		return $rows;
	}

	public function count_students( $params = "" ) {
		$default = [
			"orderby"      => "id",
			"order"        => "DESC",
			"active"       => "1",
			"batch"        => "-1",  # negative number=current batch,0=all batches, greater than zero=specific batch id
			"class_id"     => 0,
			"active_class" => 1,
			"deleted"      => 0,    # -1=All, 0=Not Deleted (Default), 1=Deleted
			"page"         => 0,
			"pagesize"     => 0,
			"search"       => "",
			"filter"       => "",
			"subjects"     => "",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		$Q = "SELECT COUNT(*) FROM `students` WHERE 1";

		$deleted = (int) $params['deleted'];
		if ( $deleted == 0 ) {
			$Q .= " AND (`deleted`='0' OR `deleted` IS NULL)";
		} elseif ( $deleted == 1 ) {
			$Q .= " AND `deleted`='1'";
		}

		if ( $params['batch'] < 0 ) {
			$b        = $this->active_batch;
			$batch_id = $b["id"];
			$Q        .= " AND `class_id` IN (SELECT `id` class_id FROM `batch_classes` WHERE `batch_id`=$batch_id AND `active`={$params['active_class']})";
		} else if ( $params['batch'] > 0 ) {
			$Q .= " AND `class_id` IN (SELECT `id` class_id FROM `batch_classes` WHERE `batch_id`={$params['batch']} AND `active`={$params['active_class']})";
		}

		if ( ! empty( $filter ) ) {
			parse_str( urldecode( $filter ), $filter );
			foreach ( $filter as $key => $val ) {
				if ( $key == "admission_date" ) {
					$d = explode( ",", $val );
					if ( empty( $d[1] ) ) {
						$d[1] = $d[0];
					}
					$Q .= " AND (`admission_date` BETWEEN '" . \Dates::mysql_date( $d[0] ) . "' AND '" . \Dates::mysql_date( $d[1] ) . "')";
				} else {
					$val = $this->DB->set_string( $val );
					$Q   .= " AND `$key`='$val'";
				}
			}
		}

		if ( ! empty( $search ) ) {
			$search = $this->DB->set_string( $search );
			if ( is_numeric( $search ) ) {
				$Q .= " AND (`id`=$search)";
			} else {
				$Q .= " AND (`roll` LIKE '%$search%' OR `name` LIKE '%$search%' OR `guardian_name` LIKE '%$search%' OR `phone` LIKE '%$search%'
                OR `cell` LIKE '%$search%' OR `guardian_cell` LIKE '%$search%' OR `address` LIKE '%$search%' OR `city` LIKE '%$search%'
                OR `state` LIKE '%$search%' OR `email` LIKE '%$search%' OR `guardian_email` LIKE '%$search%' OR `nic` LIKE '%$search%'
                OR `religion` LIKE '%$search%' OR `blood_group` LIKE '%$search%' OR `admission_number` LIKE '%$search%' OR `nationality` LIKE '%$search%'
                OR `guardian_relation` LIKE '%$search%' OR `guardian_education` LIKE '%$search%' OR `guardian_occupation` LIKE '%$search%'
                OR `guardian_address` LIKE '%$search%' OR `guardian_city` LIKE '%$search%' OR `guardian_state` LIKE '%$search%'
                OR `guardian_phone` LIKE '%$search%' OR `birth_place` LIKE '%$search%' OR `prev_institute1` LIKE '%$search%'
                OR `prev_course1` LIKE '%$search%' OR `prev_year1` LIKE '%$search%')";
			}
		}

		if ( $params['class_id'] > 0 ) {
			$Q .= " AND `class_id`={$params['class_id']}";
		}

		if ( $params['active'] >= 0 ) {
			$Q .= " AND `active`={$params['active']}";
		}

		if ( $params['subjects'] <> "" ) {
			if ( $params['class_id'] > 0 ) {
				$this->set_all_student_subjects( $params['class_id'] );
			} else {
				$this->set_all_student_subjects();
			}
			if ( ! is_array( $params['subjects'] ) ) {
				$params['subjects'] = explode( ",", $params['subjects'] );
			}
			$Q .= " AND (";
			foreach ( $params['subjects'] as $sid ) {
				if ( is_numeric( $sid ) ) {
					$subject = $this->DB->get_var( "SELECT `subject` FROM `subjects` WHERE `id`=" . $sid );
					if ( empty( $subject ) ) {
						$subject = $sid;
					}
				} else {
					$subject = $sid;
				}
				$Q .= "`id` IN (SELECT `student_id` id FROM `student_x_subject` WHERE `subject`='" . $this->DB->set_string( $subject ) . "') OR ";
			}
			$Q = rtrim( $Q, " OR " ) . ")";
		}
		if ( ! empty( $params['orderby'] ) ) {
			$Q .= " ORDER BY `{$params['orderby']}` {$params['order']}";
		}

		return $cnt = $this->DB->get_var( $Q );
	}

	function next_id() {
		$Q = "SELECT auto_increment FROM information_schema.TABLES WHERE TABLE_NAME='students' AND TABLE_SCHEMA='" . DBNAME . "'";

		return $this->DB->get_var( $Q );
	}

	function available_admission_number() {
		$id = $this->next_id();

		$OK = false;
		while ( ! $OK ) {
			$Q = "SELECT COUNT(*) FROM `students_view` WHERE `admission_number`='$id'";
			if ( $this->DB->get_var( $Q ) > 0 ) {
				$id ++;
			} else {
				$OK = true;
			}
		}

		return $id;
	}

	function save( $data = [], $params = "" ) {

		$default = [];
		$params  = set_args( $params, $default );
		extract( $params );
		if ( isset( $data['username2'] ) ) {
			unset( $data['username2'] );
		}

		global $db;

		//  Please specify a message
		//  echo "<pre>";
		//  print_r($data);
		//  die();

		if ( ! \Admins\UserInfo::is_allowed( "new_admission" ) ) {
			return __( "You'r not allowed to update student" );
		}
		if ( ! isset( $data["id"] ) ) {
			$data["id"] = 0;
		}
		if ( empty( $data["id"] ) && ! is_paid_fekara() && $this->DB->get_var( "SELECT COUNT(*) FROM `{$this->Table}`" ) >= 50 ) {
			## More than 50 students  not allowed on free fekara version when adding new student.
			return __( "Free FeKara can contain maximum 50 students only." );
		}

		if ( empty( $data["id"] ) && is_paid_fekara() ) {
			## If paid fekara and students are maximum allowed students, then do not add new student.
			global $__decoded_key;
			$max_students = empty( $__decoded_key["max_students"] ) ? 0 : $__decoded_key["max_students"];
			if ( ! empty( $max_students ) && $this->DB->get_var( "SELECT COUNT(*) FROM `{$this->Table}`" ) >= $max_students ) {
				return __( "Your license do not allowed more than %1 students", $max_students );
			}
		}

		$data["id"] = (int) $data["id"];
		if ( $data["id"] < 0 ) {
			$data["id"] = 0;
		}
		if ( $data["id"] > 0 && $this->DB->get_var( "SELECT COUNT(*) FROM `{$this->Table}` WHERE `id`='{$data["id"]}'" ) == 0 ) {
			return "Student ID '" . $data["id"] . "' doesn't exists to update";
		}
		# Checking admission number
		if ( ! key_exists( "admission_number", $data ) ) {
			return "Key not found.";
		}
		if ( ! isset( $data["admission_number"] ) ) {
			return "Please provide admission number ...";
		}
		if ( empty( $data["id"] ) ) {
			$Q = "SELECT COUNT(*) FROM `{$this->Table}` WHERE `admission_number`='" . $this->DB->set_string( $data["admission_number"] ) . "'";
		} else {
			$Q = "SELECT COUNT(*) FROM `{$this->Table}` WHERE `admission_number`='" . $this->DB->set_string( $data["admission_number"] ) . "' AND `id`<>" . $data["id"];
		}
		if ( $this->DB->get_var( $Q ) > 0 ) {
			return "Please provide different admission number, Admission number '" . $data["admission_number"] . "' is already in use.";
		}

		# Checking admission date
		if ( ! isset( $data["admission_date"] ) || trim( $data["admission_date"] ) == "" ) {
			return "Please provide admission date";
		}
		if ( ! \Dates::is_date( $data["admission_date"] ) ) {
			return "Please provide valid date on admission date";
		}
		$data["admission_date"] = \Dates::mysql_date( $data["admission_date"] );

		# Checking student Name
		if ( ! isset( $data["name"] ) || trim( $data["name"] ) == "" ) {
			return "Please provide student name";
		}
		$data["name"] = trim( $data["name"] );

		# Checking date of birth
		if ( ! isset( $data["dob"] ) || trim( $data["dob"] ) == "" ) {
			return "Please provide student date of birth";
		}
		if ( ! \Dates::is_date( $data["dob"] ) ) {
			return "Please provide valid date on date of birth";
		}
		$data["dob"] = \Dates::mysql_date( $data["dob"] );

		# Checking valid class
		if ( ! isset( $data["class_id"] ) ) {
			return "Please provide class for student";
		}
		$data["class_id"] = (int) $data["class_id"];
		if ( $this->DB->get_var( "SELECT COUNT(*) FROM `batch_classes` WHERE `id`=" . $data["class_id"] ) == 0 ) {
			return "Please provide valid class";
		}

		# Checking valid batch
		/*if (!isset($data["batch_id"])) return "Please provide batch for student";
		$data["batch_id"] = (int) $data["batch_id"];
		if ($this->DB->get_var("SELECT COUNT(*) FROM `batches` WHERE `id`=".$data["batch_id"])==0) return "Please provide valid class";*/

		# Check If roll number is already assigned to someone else.
		$data["roll"] = isset( $data["roll"] ) ? $data["roll"] : "";
		if ( $data["roll"] <> "" ):
			$data["roll"] = str_replace( "'", "''", $data["roll"] );
			if ( $data["id"] == 0 ) {
				$Q = "SELECT COUNT(*) FROM `students` WHERE `roll`='{$data["roll"]}' AND `class_id`={$data["class_id"]}";
			} elseif ( $data["id"] == 0 ) {
				$Q = "SELECT COUNT(*) FROM `students` WHERE `roll`='{$data["roll"]}' AND `class_id`={$data["class_id"]} AND `id`={$data["id"]}";
			}
			if ( $this->DB->get_var( $Q ) > 0 ) {
				return "Please provide different roll number. Roll '" . $data["roll"] . "' already in use.";
			}
		endif;

		# Checking gender
		if ( ! isset( $data["gender"] ) || trim( $data["gender"] ) == "" ) {
			return "Please provide student gender";
		}
		if ( $data["gender"] <> "F" && $data["gender"] <> "M" ) {
			$data["gender"] = "M";
		}

		# Checking mobile numbers
		//if (isset($data["cell"]) && $data["cell"]<>"" && !$general->is_cell($data["cell"])) return "Please provide valid student mobile number";
		//		if ( ! isset( $data["cell"] ) || trim( $data["cell"] ) == "" ) {
		//			return "Provide guardian mobile number";
		//		}

		if ( ! isset( $data["cell"] ) || trim( $data["cell"] ) == "" ) {
			$data["cell"] = "";
		}
		//if (!$general->is_cell($data["guardian_cell"])) return "Please provide valid guardian mobile number";

		# Checking if SMS and email notifications are selected
		if ( \App::is_sms_active() && ! isset( $data["is_sms"] ) ) {
			$data["is_sms"] = "0";
		}
		if ( \App::is_email_active() && ! isset( $data["is_email"] ) ) {
			$data["is_email"] = "0";
		}

		# Checking guardian name
		if ( ! isset( $data["guardian_name"] ) || trim( $data["guardian_name"] ) == "" ) {
			return "Please provide guardian name";
		}

		# Checking emails
		if ( isset( $data["email"] ) && $data["email"] <> "" && ! \Str::is_email( $data["email"] ) ) {
			return "Please provide valid student email address - " . $data["email"];
		}
		if ( isset( $data["guardian_email"] ) && $data["guardian_email"] <> "" && ! \Str::is_email( $data["guardian_email"] ) ) {
			return "Please provide valid guardian email address - " . $data["guardian_email"];
		}

		# Checking guardian relation
		if ( ! isset( $data["guardian_relation"] ) || trim( $data["guardian_relation"] ) == "" ) {
			return "Please provide relation with guardian";
		}

		# Checking guardian date of birth
		if ( isset( $data["guardian_dob"] ) && $data["guardian_dob"] <> "" && ! \Dates::is_date( $data["guardian_dob"] ) ) {
			return "Please provide valid date of birth for guardian";
		}

		# Checking guardian NIC
		if ( isset( $data["nic"] ) && $data["nic"] <> "" ) {
			return "Please provide valid guardian NIC number";
		}

		$id = $data["id"];
		if ( isset( $data["subjects"] ) ) {
			$subjects = $data["subjects"];
		} else {
			$subjects = [];
		}
		unset( $data["id"], $data["subjects"] );

		if ( empty( $data["fee"] ) ) {
			$data["fee"] = 0;
		}
		if ( empty( $data["admission_fee"] ) ) {
			$data["admission_fee"] = 0;
		}
		if ( empty( $data["prev_marks1"] ) ) {
			$data["prev_marks1"] = 0;
		}
		if ( empty( $data["guardian_income"] ) ) {
			$data["guardian_income"] = 0;
		}
		if ( \Dates::empty_date( $data["guardian_dob"] ) ) {
			$data["guardian_dob"] = "0000-00-00";
		}

		if ( empty( $id ) ) {
			$data["added_by"]   = \Admins\UserInfo::get_my_id();
			$data["added_ip"]   = \General::myip();
			$data["added_time"] = \Dates::mysql_date();

			$this->DB->query("SET sql_mode=''");
			$r = $this->DB->insert( $this->Table, $data );
			if ( $r === false ) {
				return $this->DB->last_error;
			}
			$id = $this->DB->insert_id;

			$data["tution_fee"]        = isset( $data["tution_fee"] ) ? $data["tution_fee"] : 0;
			$data["admission_fee"]     = isset( $data["admission_fee"] ) ? $data["admission_fee"] : 0;
			$data["annual_funds"]      = isset( $data["annual_funds"] ) ? $data["annual_funds"] : 0;
			$data["practical_charges"] = isset( $data["practical_charges"] ) ? $data["practical_charges"] : 0;
			$data["test_session_fee"]  = isset( $data["test_session_fee"] ) ? $data["test_session_fee"] : 0;
			$TotalFee                  = $data["tution_fee"] + $data["admission_fee"] + $data["annual_funds"] + $data["practical_charges"] + $data["test_session_fee"];
			$description               = "Payable created at admission time (" . date( $this->DB->get_option( "date_time_format2" ) ) . ")
            Current Month Tution Fee: " . App::set_currency( $data["tution_fee"] ) . "
            Admission Fee: " . App::set_currency( $data["admission_fee"] ) . "
            Annual Funds: " . App::set_currency( $data["annual_funds"] ) . "
            Practical Charges: " . App::set_currency( $data["practical_charges"] ) . "
            Test Session Fee: " . App::set_currency( $data["test_session_fee"] );

			$data = [
				"student_id"        => $id,
				"fee_type"          => "Admission",
				"amount"            => $TotalFee,
				"description"       => $description,
				"added_by"          => \Admins\UserInfo::get_my_id(),
				"added_time"        => \Dates::mysql_datetime(),
				"fee_title"         => "Admission Fee",
				"fee_date"          => \Dates::mysql_date(),
				"paid"              => 0,
				"due_date"          => \Dates::mysql_date(),
				"last_payment_date" => \Dates::mysql_date(),
			];

			$this->DB->query("SET sql_mode=''");
			$this->DB->insert( "fee_paid", $data );
		} else {
			$this->DB->query("SET sql_mode=''");
			$this->DB->update( "students", $data, [ "id" => $id ] );
		}

		if ( $this->DB->Status <> 'OK' ) {
			return $this->DB->Status;
		}

		$Q = "DELETE FROM `student_x_subject` WHERE `student_id`=$id";
		$this->DB->query( $Q );
		if ( isset( $subjects ) && is_array( $subjects ) ) {
			foreach ( $subjects as $subject ) {
				$Q = "INSERT INTO `student_x_subject` SET `student_id`=$id, `subject`='" . $this->DB->set_string( $subject ) . "'";
				$this->DB->query( $Q );
			}
		}

		if ( isset( $removePhoto ) && $removePhoto == "1" ) {
			$path = STUDENT_FILES . "$id/photo";
			\File::rrmdir( $path );
		}

		return "OK" . json_encode( [ "id" => $id, "profile_url" => Urls::get_url( "student_profile", $id ) ] );
	}

	function is_valid_student( $params = "" ) {
		$default = [
			"active"  => "-1",
			"id"      => 0,
			"deleted" => 0        # 0=Not deleted (Default),1=Deleted, -1=All
		];
		$params  = set_args( $params, $default );

		$params['id'] = (int) $params['id'];
		$Q            = "SELECT COUNT(*) FROM `students` WHERE `id`=" . $params['id'];

		if ( $params['active'] == "1" || $params['active'] == "0" ) {
			$Q .= " AND `active`=" . $params['active'];
		}

		$deleted = (int) $params['deleted'];
		if ( $deleted == 1 || $deleted == 0 ) {
			$Q .= " AND `deleted`=$deleted";
		}

		return $this->DB->get_var( $Q ) > 0;
	}

	function updateStudentField( $params = "" ) {
		$default = [
			"field" => "",
			"id"    => 0,
			"value" => "",
		];
		$params  = set_args( $params, $default );

		if ( $params['field'] == "" || $params['id'] == 0 ) {
			return "Please provide complete set of data";
		}

		switch ( $params['field'] ) {
			case "roll":
				$params['id'] = (int) $params['id'];
				$Q            = "SELECT `class_id` FROM `students` WHERE `id`=" . $params['id'];
				$row          = $this->DB->get_row( $Q );
				if ( ! is_array( $row ) || sizeof( $row ) == 0 ) {
					return "Invalid student record";
				}
				if ( $params['value'] <> "" ):
					$Q = "SELECT COUNT(*) FROM `students` WHERE `roll`='" . $this->DB->set_string( $params['value'] ) . "' AND `id`<>{$params['id']} AND `class_id`=" . $row["class_id"];
					if ( $this->DB->get_var( $Q ) > 0 ) {
						return "Please provide different roll number. Roll '{$params['value']}' already in use.";
					}
				endif;
				$data = [
					"roll" => $params['value'],
				];
				break;
			case "admission_date":
				$data = [
					"admission_date" => \Dates::mysql_date( $params['value'] ),
				];
				break;
			case "name":
				if ( trim( $params['value'] ) == "" ) {
					return "Provide student name";
				}
				$data = [
					"name" => $params['value'],
				];
				break;
			case "class_batch":
				if ( trim( $params['value'] ) == "" ) {
					return "Select class";
				}
				if ( ! is_numeric( $params['value'] ) ) {
					return "Select valid class";
				}
				$data = [
					"class_id" => $params['value'],
				];
				break;
			case "dob":
				if ( trim( $params['value'] ) == "" ) {
					return "Select date of birth";
				}
				if ( ! \Dates::is_date( $params['value'] ) ) {
					return "Select valid date of birth";
				}
				$data = [
					"dob" => \Dates::mysql_date( $params['value'] ),
				];
				break;
			case "blood_group":
				if ( trim( $params['value'] ) == "" ) {
					return "Select date of birth";
				}
				$data = [
					"blood_group" => str_replace( "ppp", "+", $params['value'] ),
				];
				break;
			case "cell":
				if ( trim( $params['value'] ) <> "" ) {
					return "Please provide valid cell number like 03217425335";
				}
				$data = [
					"cell" => $params['value'],
				];
				break;
			case "email":
				if ( trim( $params['value'] ) <> "" && ! \Str::is_email( $params['value'] ) ) {
					return "Please provide valid email address";
				}
				$data = [
					"email" => $params['value'],
				];
				break;
			case "guardian_dob":
				if ( ! \Dates::is_date( $params['value'] ) ) {
					return "Select valid date of birth";
				}
				$data = [
					"guardian_dob" => \Dates::mysql_date( $params['value'] ),
				];
				break;
			default:
				//return $params['value'];
				if ( $params['field'] == "guardian_cell" && $params['value'] == '' ) {
					return "Please provide valid cell number like 03217425335";
				}
				if ( $params['field'] == "nic" && $params['value'] <> "" ) {
					return "Please provide valid NIC number like 12345-1234567-1";
				}
				if ( $params['field'] == "guardian_income" && $params['value'] <> "" && ! is_numeric( $params['value'] ) ) {
					return "Please provide valid amount";
				}
				if ( $params['field'] == "guardian_income" && $params['value'] <> "" && $params['value'] < 0 ) {
					return "Negative value is not acceptable";
				}
				if ( $params['field'] == "guardian_email" && trim( $params['value'] ) <> "" && ! \Str::is_email( $params['value'] ) ) {
					return "Please provide valid email address";
				}
				if ( $params['field'] == "prev_year1" && trim( $params['value'] ) <> "" && ! is_numeric( $params['value'] ) ) {
					return "Please provide valid year";
				}
				if ( $params['field'] == "prev_year1" && trim( $params['value'] ) <> "" && ( $params['value'] < 1900 || $params['value'] > date( "Y" ) ) ) {
					return "Please provide valid year";
				}
				if ( $params['field'] == "prev_marks1" && trim( $params['value'] ) <> "" && ! is_numeric( $params['value'] ) ) {
					return "Please provide valid marks";
				}
				if ( $params['field'] == "prev_marks1" && trim( $params['value'] ) <> "" ) {
					$params['value'] = intval( $params['value'] );
				}
				$data = [
					$params['field'] => $params['value'],
				];
		}
		$this->DB->update( "students", $data, [ "id" => $params['id'] ] );

		return $this->DB->Status;
	}

	function get_batch( $student_id ) {

		$Q = "SELECT b.* FROM `batches` b,`students` s, `batch_classes` bc WHERE s.id=$student_id AND s.class_id=bc.id AND bc.batch_id=b.id";

		return $this->DB->get_row( $Q );
	}

	function is_current_batch( $student_id ) {

		$Q = "SELECT COUNT(*) FROM `batches` b, (SELECT `batch_id` FROM `batch_classes` bc,`students` s WHERE s.id=$student_id AND s.class_id=bc.id) q WHERE q.batch_id=b.id AND `active` ORDER BY `id` DESC LIMIT 1";

		return ( $this->DB->get_var( $Q ) == 1 );
	}

	function get_active_batch() {

		$Q = "SELECT * FROM `batches` WHERE `active`=1 ORDER BY `id` DESC LIMIT 1";

		return $this->DB->get_row( $Q );
	}

	public function get_active_batch_id() {
		return isset( $this->active_batch['id'] ) ? $this->active_batch['id'] : 0;
	}

	public function get_active_batch_name() {
		return isset( $this->active_batch['batch_name'] ) ? $this->active_batch['batch_name'] : '';
	}

	function get_class_name( $student_id ) {
		$class = $this->DB->get_var( "SELECT `class_name` FROM `batch_classes` bc, `students` s WHERE bc.id=s.class_id AND s.id=$student_id" );

		return $class;
	}

	function get_student_batch( $student_id ) {
		$batch = $this->DB->get_var( "SELECT `batch_name` FROM `batch_classes` bc, `students` s, `batches` b WHERE bc.id=s.class_id AND s.id=$student_id AND b.id=bc.batch_id" );

		return $batch;
	}

	function set_all_student_subjects( $class_id = "" ) {
		if ( empty( $class_id ) ) {
			$Q = "SELECT `id` FROM `students` s WHERE NOT `id` IN (SELECT COUNT(*) FROM `student_x_subject` WHERE `student_id`=s.id)";
		} else {
			$class_id = (int) $class_id;
			$Q        = "SELECT `id` FROM `students` s WHERE `class_id`=$class_id";
		}
		$rows = $this->DB->get_rows( $Q );
		foreach ( $rows as $row ) {
			$this->set_student_subjects( $row["id"] );
		}
	}

	function set_student_subjects( $student_id ) {
		$Q    = "SELECT `subject` FROM `student_x_subject` WHERE `student_id`=$student_id";
		$rows = $this->DB->get_rows( $Q );
		if ( count( $rows ) == 0 ) {
			global $BatchClass;
			$class_id = $this->DB->get_var( "SELECT `class_id` FROM `students` WHERE `id`=$student_id" );
			$Out      = $BatchClass->get_subjects( $class_id );
			foreach ( $Out as $O ) {
				$Q = "INSERT INTO `student_x_subject` SET `student_id`=$student_id, `subject`='" . $this->DB->set_string( $O ) . "'";
				$this->DB->query( $Q );
			}

			$Q    = "SELECT `subject` FROM `student_x_subject` WHERE `student_id`=$student_id";
			$rows = $this->DB->get_rows( $Q );
		}

		return $rows;
	}

	function get_student_subjects( $student_id ) {
		$Q    = "SELECT `subject` FROM `student_x_subject` WHERE `student_id`=$student_id";
		$rows = $this->DB->get_rows( $Q );
		$Out  = [];
		foreach ( $rows as $row ) {
			$Out[] = $row["subject"];
		}
		if ( count( $Out ) == 0 ) {
			global $BatchClass;
			$class_id = $this->DB->get_var( "SELECT `class_id` FROM `students` WHERE `id`=$student_id" );
			$Out      = $BatchClass->get_subjects( $class_id );
		}

		return $Out;
	}

	function get_student_subjects_not_assigned( $student_id ) {
		$class_id       = $this->DB->get_var( "SELECT `class_id` FROM `students` WHERE `id`=$student_id" );
		$class_subjects = $this->DB->get_rows( "SELECT `subject` FROM `batch_classes_x_subjects` WHERE `class_id`=$class_id" );
		$subjects       = $this->get_student_subjects( $student_id );
		$Out            = [];
		foreach ( $class_subjects as $s ) {
			if ( in_array( $s["subject"], $subjects ) === false ) {
				$Out[] = $s["subject"];
			}
		}

		return $Out;
	}

	function get_mark_sheet( $schedule_id = 0, $absent = "-1", $failed = "-1" ) {
		$Q = "SELECT COUNT(*) FROM `test_schedules` WHERE `id`=$schedule_id";
		if ( $this->DB->get_var( $Q ) == 0 ) {
			return false;
		}

		$data = $this->DB->get_row( "SELECT * FROM `test_schedules` WHERE `id`='$schedule_id'" );

		$Q             = "SELECT COUNT(*) FROM `mark_sheets` WHERE `schedule_id`='$schedule_id'";
		$passing_marks = $this->DB->get_var( "SELECT `passing_marks` FROM `mark_sheets` WHERE `schedule_id`='$schedule_id'" );
		if ( $this->DB->get_var( $Q ) == 0 ) {
			$new   = true;
			$batch = $this->active_batch;
			if ( empty( $data["start_date"] ) || $data["start_date"] == "0000-00-00" ) {
				$D = $batch["start_date"];
			} else {
				$D = $data["start_date"];
			}
			$d = [
				"schedule_id" => $schedule_id,
				"week"        => \Str::number_with_suffix( \Dates::get_week_number( $D, $data["test_date"] ) ) . " Week",
				"total_marks" => "0.00",
			];
			$this->DB->insert( "mark_sheets", $d );
			$data     = array_merge( $data, $d );
			$students = $this->DB->get_rows( "SELECT `id` FROM `students` WHERE `deleted`=0 AND `class_id`='{$data["class_id"]}'" );

			foreach ( $students as $student ):
				if ( $this->is_student_subject( $student["id"], $data["subject"] ) ) {
					$Q = "INSERT INTO `mark_sheets_data` SET `schedule_id`='$schedule_id', `student_id`='{$student["id"]}', `marks`='0'";
					$this->DB->query( $Q );
				}
			endforeach;
		} else {
			$new  = false;
			$row  = $this->DB->get_row( "SELECT * FROM `mark_sheets` WHERE `schedule_id`=$schedule_id" );
			$data = array_merge( $data, $row );
		}

		$data["class_name"] = $this->DB->get_var( "SELECT `class_name` FROM `batch_classes` WHERE `id`={$data["class_id"]}" );

		$Q = "SELECT * FROM `mark_sheets_data` WHERE `schedule_id`='$schedule_id' ORDER BY `student_id` ASC ";

		if ( $failed == "0" ) {
			$Q .= " AND `marks`<$passing_marks";
		} elseif ( $failed == "1" ) {
			$Q .= " AND `marks`>='$passing_marks'";
		}
		if ( $absent == "0" || $absent == "1" ) {
			$Q .= " AND `attendance`='$absent'";
		}
		$rows = $this->DB->get_rows( $Q );

		foreach ( $rows as &$row ) {
			$row["student_name"] = $this->get_student_name( $row["student_id"] );
			if ( $new ) {
				$row["marks"] = "";
			}
			if ( $row["attendance"] == 0 ) {
				$row["marks"] = "";
			}
		}
		$ar["students"] = $rows;
		//		echo "<pre>";
		//		print_r($ar);
		//		die();
		$data = array_merge( $data, $ar );

		return $data;
	}

	function get_student_name( $student_id ) {
		return $this->DB->get_var( "SELECT `name` FROM `$this->Table` WHERE `id`='{$student_id}' ORDER BY `id` ASC " );
	}

	function get_student_roll( $student_id ) {
		return $this->DB->get_var( "SELECT `roll` FROM `$this->Table` WHERE `id`='{$student_id}' ORDER BY `id` ASC " );
	}

	function is_student_subject( $student_id = 0, $subject = "" ) {
		$Q = "SELECT COUNT(*) FROM `student_x_subject` WHERE `student_id`=$student_id AND `subject`='" . $this->DB->set_string( $subject ) . "'";

		return ( $this->DB->get_var( $Q ) > 0 );
	}

	function get_student_fee( $id ) {
		$Q   = "SELECT `fee`, `class_id` FROM `students` WHERE `id`=$id";
		$row = $this->DB->get_row( $Q );
		if ( empty( $row["fee"] ) || $row["fee"] == 0 ) {
			$Q   = "SELECT `fee` FROM `batch_classes` WHERE `id`=" . $row["class_id"];
			$fee = $this->DB->get_var( $Q );

			return $fee;
		} else {
			return $row["fee"];
		}
	}

	function get_student_attendance( $id, $date = "today" ) {
		if ( strtolower( $date ) == "today" ) {
			$date = \Dates::mysql_date();
		}
		$Q = "SELECT * FROM `attendance` WHERE `student_id`=$id";
		if ( $date <> "" ) {
			$Q .= " AND `date`='$date'";
		}

		return $this->DB->get_rows( $Q );
	}

	function get_student_panel_url() {
		return DOMAIN_URL . "students/";
	}

	function is_student_logged_in() {
		if ( ! isset( $_SESSION[ \Admins\UserInfo::get_system_var() . "_student" ] ) && isset( $_COOKIE[ \Admins\UserInfo::get_system_var() . "_student" ] ) ) {
			$id  = $_COOKIE[ \Admins\UserInfo::get_system_var() . "_student" ];
			$row = $this->DB->get_row( "SELECT * FROM `$this->Table` WHERE `id`='$id' AND `active`='1'" );
			if ( isset( $row['id'] ) ) {
				$_SESSION[ \Admins\UserInfo::get_system_var() . "_student" ] = $row;
				set_cookie( \Admins\UserInfo::get_system_var() . "_student", $row['id'] );
			}
		}

		return isset( $_SESSION[ \Admins\UserInfo::get_system_var() . "_student" ] );
	}

	function login( $params = "" ) {
		$default = [
			"admission_number" => "",
			"password"         => "",
			"remember_me"      => "0",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		$this->DB->add_column( [
			'table_name' => 'students',
			'col_name'   => 'password',
			'type'       => 'varchar',
			'length'     => 100,
		] );

		//echo "<pre>";print_r($params);

		if ( empty( $admission_number ) ) {
			return ( "Please provide admission number as username" );
		}
		if ( empty( $password ) ) {
			return ( "Password missing." );
		}

		//$Q   = "SELECT * FROM `$this->Table` WHERE `admission_number`='$admission_number' AND `active`='1'";
		$Q   = "SELECT COUNT(*) FROM `{$this->Table}` WHERE `admission_number`='" . $admission_number . "'";
		$cnt = $this->DB->get_var( $Q );
		if ( $cnt == 0 ) {
			return __( "Student data not found." );
		}

		if ( $cnt > 1 ) {
			return __( "More than one students have this admission number, Can't login." );
		}

		$Q   = "SELECT * FROM `$this->Table` WHERE `admission_number`='$admission_number' AND `active`='1'";
		$row = $this->DB->get_row( $Q );

		if ( $row['password'] == '' ) {
			$new_password = password_hash( $row['admission_number'], PASSWORD_BCRYPT );
			$r            = $this->DB->update( $this->Table, [ "password" => $new_password ], [ "id" => $row['id'] ] );
			if ( $r !== false ) {
				$row['password'] = $new_password;
			}
		}

		if ( ! password_verify( $password, $row['password'] ) ) {
			return __( "Invalid password." );
		}

		# Updating login_history
		$history = [ "login_time" => \Dates::my_datetime(), "login_ip" => \General::myip() ];
		$this->DB->update( $this->Table, [ "login_history" => json_encode( $history ) ], [ "id" => $row["id"] ] );

		$_SESSION[ \Admins\UserInfo::get_system_var() . "_student" ] = $row;
		if ( $params['remember_me'] == '1' ) {
			set_cookie( \Admins\UserInfo::get_system_var() . "_student", $row['id'] );
		}

		return "OK";
	}

	function logout() {
		unset( $_SESSION[ \Admins\UserInfo::get_system_var() . "_student" ] );
		if ( isset( $_COOKIE[ \Admins\UserInfo::get_system_var() . "_student" ] ) ) {
			set_cookie( \Admins\UserInfo::get_system_var() . "_student", "", strtotime( "-1 day" ) );
		}
	}

	function my_id() {
		if ( ! $this->is_student_logged_in() ) {
			return "0";
		}

		if ( ! isset( $_SESSION[ \Admins\UserInfo::get_system_var() . "_student" ]["id"] ) ) {
			return "0";
		}

		return $_SESSION[ \Admins\UserInfo::get_system_var() . "_student" ]["id"];
	}

	function change_password( $params = "" ) {
		//echo "<pre>";print_r($_POST);die();
		$default = [
			"current_password" => "",
			"password1"        => "",
			"password2"        => "",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		if ( empty( $params['current_password'] ) || empty( $params['password1'] ) || empty( $params['password2'] ) ) {
			return __( "Please provide all passwords." );
		}
		if ( $params['password1'] <> $params['password2'] ) {
			return __( "Password verification is not correct." );
		}
		if ( ! is_password_strong( $params['password1'] ) ) {
			return __( "Password is weak, Required small letters, capital letters and digits with at least 6 characters." );
		}
		if ( ! $this->is_student_logged_in() ) {
			return __( "You'r not logged in" );
		}
		$id       = $this->my_id();
		$Q        = "SELECT `password` FROM `$this->Table` WHERE `id`='$id'";
		$password = $this->DB->get_var( $Q );
		if ( ! password_verify( $params['current_password'], $password ) ) {
			return __( "You've provided invalid current password." );
		}
		$new_password = password_hash( $params['password1'], PASSWORD_BCRYPT );
		$this->DB->update( $this->Table, [ "password" => $new_password ], [ "id" => $id ] );

		return $this->DB->Status;
	}

	// get all student
	function get_allStudent( $params = "" ) {
		$default = [
			"order"   => "ASC",
			"orderby" => "name",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		$Q = "SELECT * FROM `{$this->Table}` WHERE 1";
		$Q .= " ORDER BY `{$params['orderby']}` {$params['order']}";

		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	// get all student
	function get_all_Student( $params = "" ) {
		$rows = 0;
		if ( ! $params == 0 ) {
			$val = explode( ",", $params );
			implode( "", $val );
			$tmp = "";
			foreach ( $val as $r ) {
				$tmp .= "'" . $r . "',";
			}
			$ids  = rtrim( $tmp, ',' );
			$Q    = "SELECT * FROM `{$this->Table}` WHERE `class_id` IN ($ids)";
			$rows = $this->DB->get_rows( $Q );
		}

		return $rows;
	}


	// get student related classes
	function get_Student_related_class( $ids = "" ) {
		if ( isset( $ids ) && $ids != "" ) {
			$ids = rtrim( $ids, ',' );

			$Q    = "SELECT * FROM `{$this->Table}` WHERE `class_id` IN ($ids)";
			$rows = $this->DB->get_rows( $Q );

			return $rows;
		}

		return "";
	}

	// get total students
	function get_Total_Students_count( $ids = "" ) {
		if ( isset( $ids ) && $ids != "" ) {

			$Q    = "SELECT * FROM `{$this->Table}` WHERE `class_id`='$ids'";
			$rows = $this->DB->get_rows( $Q );

			return $rows;
		}

		return 0;
	}

	// get student data value
	function get_Students_Data( $id = "" ) {
		if ( isset( $id ) && $id != "" ) {
			$Q    = "SELECT * FROM `{$this->Table}` WHERE `id`='$id'";
			$rows = $this->DB->get_rows( $Q );

			return $rows;
		}

		return 0;
	}

	function get_student_cell( $id ) {
		return $this->DB->get_var( "SELECT `cell` FROM `$this->Table` WHERE `id`='$id'" );
	}

	function get_guardian_cell( $id ) {
		return $this->DB->get_var( "SELECT `guardian_cell` FROM `$this->Table` WHERE `id`='$id'" );
	}

	function send_sms( $args = "" ) {
		$default = [
			"student_ids" => [],
			"sms_message" => "",
		];
		$args    = set_args( $args, $default );
		extract( $args );

		if ( empty( $student_ids ) ) {
			return __( "Please select one ore more students." );
		}

		if ( empty( $sms_message ) ) {
			return __( "Please type SMS message." );
		}

		$student_ids = \Str::make_array( $student_ids );
		$SMS         = new SMS();
		foreach ( $student_ids as $id ) {
			$SMS->add_to_queue( $this->get_guardian_cell( $id ), $sms_message );
		}

		return "OK";
	}

	function update_student_class( $student_id, $class_id ) {
		$Q        = "SELECT `batch_id` FROM `batch_classes` WHERE `id`='$class_id'";
		$batch_id = $this->DB->get_var( $Q );

		$data = [
			"batch_id" => $batch_id,
			"class_id" => $class_id,
		];

		$response = $this->DB->update( "students", $data, [ "id" => $student_id ] );

		if ( $response === false ) {
			return $this->DB->last_error;
		} else {
			return "OK";
		}
	}

	function get_teachers( $student_id ) {
		$Q = "SELECT t.* FROM `teachers` t, `{$this->Table}` s, `teachers_x_classes` tc WHERE 1 ";
		$Q .= " AND tc.class_id=s.class_id AND tc.teacher_id=t.id AND s.id='$student_id'";

		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	function get_assignments( $student_id, $teacher_id ) {
		$path = STUDENT_FILES . $student_id . "/assignments/" . $teacher_id . "/";
		if ( ! is_dir( $path ) ) {
			return [];
		}
		$path .= "*";

		return glob( $path );
	}

	function upload_student_assignments( $teacher_id, $files, $student_id = "" ) {
		if ( ! is_paid_fekara() ) {
			return __( "Assignment upload not allowed in free version." );
		}

		if ( ! isset( $files["file"]["name"][0] ) ) {
			return __( "No file uploaded" );
		}

		if ( empty( $student_id ) ) {
			$student_id = $this->my_id();
		}
		$path = STUDENT_FILES . $student_id;
		if ( ! is_dir( $path ) ) {
			@mkdir( $path );
		}

		$path .= "/assignments";
		if ( ! is_dir( $path ) ) {
			@mkdir( $path );
		}
		$path .= "/$teacher_id";
		if ( ! is_dir( $path ) ) {
			@mkdir( $path );
		}
		if ( ! is_dir( $path ) ) {
			return __( "System can't create assignment folders." );
		}

		$F            = new File();
		$attach_files = [];
		for ( $x = 0; $x < count( $files["file"]["name"] ); $x ++ ) {
			if ( $files["file"]["error"][ $x ] > 0 ) {
				continue;
			}

			$ext = "." . $F->extension( $files["file"]["name"][ $x ] );

			if ( ! in_arrayi( $ext, $this->AllowedFileTypes ) ) {
				continue;
			}

			$path2 = $path . "/" . $files["file"]["name"][ $x ];
			$r     = move_uploaded_file( $files["file"]["tmp_name"][ $x ], $path2 );
			if ( $r ) {
				$attach_files[] = $path2;
			}
		}

		$E     = new EmailTemplates();
		$email = $E->get_email_template( "assignment_id=assign_email_to_teacher" );

		if ( isset( $email["subject"] ) ) {
			$data_array["student_name"] = $this->get_student_name( $student_id );
			$data_array["student_roll"] = $this->get_student_roll( $student_id );

			$data_array["teacher_name"] = ( new \Teacher )->get_techer_name( $teacher_id );
			$data_array["teacher_link"] = get_teacher_panel_url();

			$Fields = $E->get_template_fields( "assign_email_to_teacher", $data_array );

			$email["subject"] = str_ireplace( array_keys( $Fields ), array_values( $Fields ), $email["subject"] );
			$email["message"] = str_ireplace( array_keys( $Fields ), array_values( $Fields ), $email["message"] );

			send_mail( "shakeel@fekara.com", $email["subject"], $email["message"], "", "System", $attach_files );
		}

		return "OK";
	}

	function get_assignment_file_url( $student_id, $teacher_id, $filename ) {
		$path = STUDENT_FILES . "/" . $student_id . "/assignments/" . $teacher_id . "/" . $filename;
		if ( is_file( $path ) ) {
			return DOMAIN_URL . "includes/downloader.php?type=assignment_file&teacher_id={$teacher_id}&student_id={$student_id}&filename={$filename}";
		} else {
			return "#";
		}
	}

	function delete_assignment_file( $student_id, $teacher_id, $filename ) {
		if ( ! is_paid_fekara() ) {
			return __( "Not allowed in free version." );
		}

		$checked = false;
		if ( $this->is_student_logged_in() && $student_id <> $this->my_id() ) {
			return __( "You'r not authorized to delete assignment file." );
		} else if ( $this->is_student_logged_in() && $student_id == $this->my_id() ) {
			$checked = true;
		}

		$Teacher = new Teacher();
		if ( ! $checked && $Teacher->is_teacher_logged_in() && $Teacher->my_id() <> $teacher_id ) {
			return __( "You'r not authorized to delete assignment file. This is not your student's assignment file" );
		}

		$path = STUDENT_FILES . $student_id . "/assignments/" . $teacher_id . "/" . $filename;

		if ( ! is_file( $path ) ) {
			return __( "File not found on server." );
		}

		return @unlink( $path ) ? "OK" : __( "Can't delete file." );
	}

	function is_active_student( $student_id ) {
		$active = $this->DB->get_var( "SELECT `active` FROM `students` WHERE `id`='{$student_id}'" );

		return $active == 1;
	}

	public static function create_students_view() {
		global $db;
		$db->query( 'DROP VIEW IF EXISTS `students_view`' );
		$db->query( "CREATE VIEW `students_view` AS
		(SELECT s.*,bc.class_name,bc.active class_active,bc.attendance_type,b.batch_name,b.active batch_active FROM `students` s, `batch_classes` bc, `batches` b WHERE bc.id=s.class_id AND b.id=bc.batch_id)" );
	}


	public function change_password_by_admin( $args = [] ) {
		$default = [
			'id'       => 0,
			'password' => '',
		];
		$args    = set_args( $args, $default );

		$this->DB->update( $this->Table, [
			'password' => password_hash( $args['password'], PASSWORD_BCRYPT ),
		], [ 'id' => $args['id'] ] );

		return $this->DB->Status;
	}
}