<?php
/*
 * This class will generate challan form for student.
 */

namespace Student;

class Chalan {

	var $fee_id;

	function __construct( $fee_id = 0 ) {
		$this->fee_id = (int) $fee_id;
	}

	function get_fee( $fee_id = 0 ) {
		$fee_id = (int) $fee_id;
		if ( $fee_id < 1 ) {
			$fee_id = $this->fee_id;
		}

		$Fee = new \Fee();
		$row = $Fee->get_fee( $fee_id );

		if ( $row["student_id"] > 0 ) {
			$fees = $Fee->get_fees( "student_id={$row["student_id"]}" );
		} else {
			$fees = [];
		}

		return $fees;
	}

	/**
	 * @param int  $fee_id
	 * @param bool $print
	 *
	 * @return string
	 */
	function generate_html( $fee_id = 0, $print = true, $args = [] ) {
		$default = [
			'include_headers' => true,
		];
		$args    = set_args( $args, $default );

		$fee_id = (int) $fee_id;
		if ( $fee_id < 1 ) {
			$fee_id = $this->fee_id;
		}

		global $db;
		$title                   = 'Fee Receipt';
		$args['include_headers'] = (bool) $args['include_headers'];

		$html = '';
		if ( $args['include_headers'] ) {
			$html .= '<html><head><title>' . __( $title ) . '</title>';
			$html .= '<style>table#table1 .td{border-right:1px solid black;height:100%;padding:5px;}
				table#table1 .td:last-child{border-right:0}
				</style>';
			$html .= \PDF::pdf_head_html();
			$html .= '</head><body><table border="0" width="100%" id="table1"><tr>';
		}

		if ( $print ) {
			$html .= '<script>print();</script>';
			$html .= '<style type="text/css" media="print">@page { size: landscape; margin:0.3cm 0.3cm; }</style>';
		}

		$headings = [
			"{num}"        => [ 'name' => "#" ],
			"student_name" => [ "name" => "Student" ],
			"description"  => [ "name" => "Description" ],
			"amount"       => [ "name" => "Amount" ],
			"fine"         => [ "name" => "Fine" ],
			"due_date2"    => [ "name" => "Due Date", "css" => "min-width:120px" ],
			//"last_payment_date2" => [ "name" => "Last Date", "css" => "min-width:120px" ],
		];

		$Fee = new \Fee();
		$row = $Fee->get_fee( $fee_id );

		for ( $x = 0; $x < 3; $x ++ ) {
			$html .= '<td class="td"><div style="text-align: center">
				<img style="max-height:50px;max-width:50px;" src="' . \App::get_logo( "3" ) . '"> <b>' . System . '</b><br>
				<span style="font-size: 10px">' . $db->get_option( "inst_address" ) . '<br>
				' . $db->get_option( "inst_contacts" ) . '
				</span><hr><h4>' . $title . '</h4>
			</div>';


			$string = <<<HTML
				<table class="my_table table-bordered" style="font-size:12px">
					<tr>
						<td>{class}: <b>{class_name}</b></td>
						<td align='right'>Invoice ID: {invoice_id}</td>
					</tr>
					<tr>
						<td colspan="2" style="text-align: center;font-size:130%"><b>{student_name}</b> {sdo} <b>{father_name}</b></td>
					</tr>
					<tr>
						<td>{roll_text}: {roll}</td>
						<td style="text-align: right">{date_text}: {date}</td>
					</tr>
					<tr>
						<td>{recpt_text}: {recpt_number}</td>
						<td style="text-align: right">{paid_text}: {paid}</td>
					</tr>
					<tr>
						<td><b>{fee_title}</b>:<br><span style="color:#adadad">{description}</span></td>
						<td style="text-align: right;vertical-align: top">{amount}</td>
					</tr>
					<tr>
						<td>{fine_text}</td>
						<td style="text-align: right;">{fine}</td>
					</tr>
					<tr style="background-color: #c9c9c9">
						<td><b>{total_text}</b></td>
						<td style="text-align: right;font-weight:bold">{total}</td>
					</tr>
				</table>				
HTML;

			$html .= strtr( $string, [
				'perperper'      => '%',
				'{description}'  => nl2br( $row["description"] ),
				'{class}'        => __( "Class" ),
				'{class_name}'   => $row["class_name"],
				'{invoice_id}'   => $row['id'],
				'{student_name}' => $row["student_name"],
				'{sdo}'          => ( ( $row["gender"] == "F" ) ? "D/O " : "S/O " ),
				'{father_name}'  => ( empty( $row["father_name"] ) ? $row["guardian_name"] : $row["father_name"] ),
				'{roll_text}'    => __( 'Roll' ),
				'{roll}'         => $row["roll"],
				'{date_text}'    => __( 'Date' ),
				'{date}'         => \Dates::my_date( $row["due_date"] ),
				'{recpt_text}'   => __( 'Receipt Number' ),
				'{recpt_number}' => $row["receipt_number"],
				'{paid_text}'    => __( 'Paid' ),
				'{paid}'         => ( ( $row["paid"] == 1 ) ? "Yes" : "No" ),
				'{fee_title}'    => $row["fee_title"],
				'{amount}'       => \App::set_currency( $row["amount"] ),
				'{fine_text}'    => __( 'Fine' ),
				'{fine}'         => \App::set_currency( $row["fine"] ),
				'{total_text}'   => __( 'Total' ),
				'{total}'        => \App::set_currency( $row["amount"] + $row["fine"] ),
			] );

			$html .= '<br><br><br><br><br><br><br><br><br><table style="width:100%"><tr><td valign="top">';

			$challan_bank_name = trim( (string) $db->get_option( 'challan_bank_name' ) );
			$bank_string       = '';
			if ( $challan_bank_name <> '' ) {
				$bank_string .= '<span style="font-size:10px">' . $challan_bank_name . '</span><br>';
			}
			$challan_bank_account_title = trim( (string) $db->get_option( 'challan_bank_account_title' ) );
			if ( $challan_bank_account_title <> '' ) {
				$bank_string .= '<span style="font-size:10px">' . __( 'Account title:' ) . ' ' . $challan_bank_account_title . '</span><br>';
			}
			$challan_bank_account_number = trim( (string) $db->get_option( 'challan_bank_account_number' ) );
			if ( $challan_bank_account_number <> '' ) {
				$bank_string .= '<span style="font-size:10px">' . __( 'Account number:' ) . ' ' . $challan_bank_account_number . '</span><br>';
			}

			if ( $bank_string <> '' ) {
				$bank_string = '<b style="font-size: 12px">' . __( 'Bank Details' ) . '</b><br>' . $bank_string;
			}

			$html .= $bank_string . '</td><td style="text-align: right;font-size:10px" valign="top">';

			$html                .= __( 'Due date:' ) . ' ' . \Dates::my_date( $row['due_date'] );
			$challan_bottom_note = trim( (string) $db->get_option( 'challan_bottom_note' ) );
			if ( $challan_bottom_note <> '' ) {
				$html .= '<br><b>' . __( 'Note' ) . '</b><br>';
				$html .= nl2br( $challan_bottom_note );
			}


			$html .= '</td></tr></table><br><br>';

			if ( $x == 0 ) {
				$html .= '<div style="text-align: center;font-size:10px"><i>-- Bank Copy --</i></div>';
			} else if ( $x == 1 ) {
				$html .= '<div style="text-align: center;font-size:10px"><i>-- School Copy --</i></div>';
			} else {
				$html .= '<div style="text-align: center;font-size:10px"><i>-- Parent Copy --</i></div>';
			}

			$html .= '</td>';
		}

		if ( $args['include_headers'] ) {
			$html .= '</tr></table>';
			$html .= '<div style="page-break-before: always !important;"></div>';
			$html .= '</body>';
		}

		return $html;
	}
}