<?php

class Subject {

	var $Table = "subjects";
	const Table = "subjects";
	var $TableSubjects = "batch_classes_x_subjects";
	var $DB;

	function __construct() {
		global $db;
		$this->DB = $db;
	}

	public function count( $params = "" ) {
		$default = [];
		$params  = set_args( $params, $default );
		extract( $params );
		$Q = "SELECT COUNT(*) FROM `{$this->Table}` WHERE 1";

		return $this->DB->get_var( $Q );
	}

	function get_list( $params = "" ) {
		$default = [
			"id"         => "0",
			"class_id"   => "0",
			"orderby"    => "id",
			"order"      => "DESC",
			"mysql_cols" => "*",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		$Q = "SELECT $mysql_cols FROM `subjects` WHERE 1";
		if ( ! empty( $id ) ) {
			$id = \Str::make_array( $id );
			$Q  .= " AND `id` IN ('" . implode( "','", $id ) . "')";
		}
		if ( ! empty( $class_id ) ) {
			$Q .= " AND `id` IN (SELECT `subject_id` id FROM `{$this->TableSubjects}` WHERE `class_id`='$class_id')";
		}
		$Q .= " ORDER BY `$orderby` $order, `subject`";

		$rows = $this->DB->get_rows( $Q );

		/*foreach($rows as &$row) {
			//$row["classes_count"] = $this->DB->get_var("SELECT COUNT(*) FROM `classes_x_subjects` WHERE `subject_id`=".$row["id"]);
		}*/

		return $rows;
	}

	function get_list_by_class( $params ) {
		// It will be batch class.
		$default = [
			"orderby"  => "subject",
			"order"    => "ASC",
			"class_id" => 0,
		];
		$params  = set_args( $params, $default );
		extract( $params );

		$Q = "SELECT * FROM `{$this->TableSubjects}` WHERE 1";
		if ( $class_id > 0 ) {
			$Q .= " AND `class_id`='$class_id'";
		}

		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	function get_subject( $params = "" ) {
		$default = [
			"id" => "0",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		$Q = "SELECT * FROM `subjects` WHERE 1";
		if ( $id > 0 ) {
			$Q .= " AND `id`=$id";
		}
		$row            = $this->DB->get_row( $Q );
		$row["Classes"] = $this->DB->get_rows( "SELECT * FROM `classes_x_subjects` WHERE `subject_id`=" . $row["id"] );

		return $row;
	}

	function save( $data = [] ) {
		$default = [
			"id"         => "0",
			"subject"    => "",
			"short_name" => "",
		];
		$data    = set_args( $data, $default );

		$_users = new Users();
		if ( ! \Admins\UserInfo::is_allowed( "subjects_management" ) ) {
			return __( "You'r not allowed to perform this action" );
		}
		extract( $data );
		if ( trim( $subject ) == "" ) {
			return __( "Please type subject" );
		}

		$id = (int) $id;

		$Q = $this->DB->prepare( "SELECT COUNT(*) FROM `subjects` WHERE `subject`=%s", $subject );
		if ( $id > 0 ) {
			$Q .= " AND `id`<>$id";
		}
		if ( $this->DB->get_var( $Q ) > 0 ) {
			return __( "Please type different subject name. Already in use" );
		}
		unset( $data["id"] );
		if ( $id == "0" ) {
			$data["added_by"]   = \Admins\UserInfo::get_my_id();
			$data["added_time"] = \Dates::mysql_datetime();
			$data["added_ip"]   = \General::myip();
			$r                  = $this->DB->insert( self::Table, $data );
			if ( $r !== false ) {
				$id = $this->DB->insert_id;
			}
		} else {
			$r = $this->DB->update( self::Table, $data, [ "id" => $id ] );
		}
		if ( $r === false ) {
			return $this->DB->last_error;
		} else {
			return "OK" . $id;
		}
	}

	function delete( $id ) {
		$Q = "DELETE FROM `subjects` WHERE `id`=$id";
		$r = $this->DB->query( $Q );
		if ( $r === false ) {
			return "Error: " . $this->DB->last_error;
		} else {
			return "OK";
		}
	}

	public static function delete_multi( $args = [] ) {
		$default = [ 'ids' => [] ];
		$args    = set_args( $args, $default );

		if ( ! is_array( $args['ids'] ) ) {
			$args['ids'] = (array) $args['ids'];
		}
		$Q = 'DELETE FROM `' . self::Table . '` WHERE `id` IN (\'' . implode( "','", $args['ids'] ) . "')";

		global $db;
		$response = $db->query( $Q );
		if ( $response === false ) {
			return $db->last_error;
		} else {
			return "OK";
		}
	}

	function get_shortname( $subject ) {
		$subject    = $this->DB->set_string( $subject );
		$short_name = $this->DB->get_var( "SELECT `short_name` FROM `subjects` WHERE `subject`='$subject'" );
		if ( empty( $short_name ) ) {
			$short_name = substr( $subject, 0, 4 );
		}

		return $short_name;
	}

	public static function sort_subjects( $args = [] ) {
		$default = [
			'sort' => [],
		];
		$args    = set_args( $args, $default );

		global $db;
		foreach ( $args['sort'] as $key => $id ) {
			$db->update( self::Table, [ 'order_by' => $key ], [ 'id' => $id ] );
		}
	}
}