<?php

class Teacher {

	var $Table = "teachers";
	var $table_name = "teacher_upload_file";
	var $TableTeacherClasses = "teachers_x_classes";
	var $TableClasses = "batch_classes";
	var $DB;

	function __construct() {
		$this->FilesPath = ROOT_PATH . "contents/teacher/";
		if ( ! is_dir( $this->FilesPath ) ) {
			@mkdir( $this->FilesPath );
		}
		if ( ! is_file( $this->FilesPath . ".htaccess" ) ) {
			$htaccess_contents = "Order Deny,Allow\nDeny from all\nAllow from 127.0.0.1";
			file_put_contents( $this->FilesPath . ".htaccess", $htaccess_contents );
		}

		global $db;
		$this->DB = $db;

		$this->DB->drop_table( "teachers_assign_classes", true );
		//$Q = "ALTER TABLE `$this->Table` ADD `password` VARCHAR(100) NOT NULL AFTER `active`, ADD `login_history` VARCHAR(255) NOT NULL AFTER `password`;";
		//$db->query( $Q );
		//$Q = "ALTER TABLE `$this->Table` ADD `classassign` TEXT DEFAULT NULL AFTER `login_history` , ADD `courseassign` TEXT DEFAULT NULL AFTER `classassign` , ADD `courseassignClass` TEXT DEFAULT NULL ";
		//$db->query( $Q );
		// file table
		//		$Q = "ALTER TABLE `$this->table_name` ADD `file_name` TEXT DEFAULT NULL AFTER `file` ";
		//		$db->query( $Q );

	}

	public function get_teachers( $params = "" ) {
		$default = [
			"order"      => "ASC",
			"orderby"    => "name",
			"active"     => - 1,       # -1 for all, 1 or 0
			"salary"     => - 1,       # -1 for all, 1 or 0
			"mysql_cols" => "*",
		];
		$params  = set_args( $params, $default );
		extract( $params );
		$Q = "SELECT {$mysql_cols} FROM `{$this->Table}` WHERE 1";
		if ( $active <> - 1 ) {
			$Q .= " AND `active`=$active";
		}
		if ( $salary <> - 1 ) {
			$Q .= " AND `salary`=$salary";
		}
		$Q .= " ORDER BY `$orderby` $order";

		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	function get_session_var() {
		return \Admins\UserInfo::get_system_var() . "_teacher";
	}

	/**
	 * @return int
	 *
	 * This method returns logged in teacher's ID.
	 */
	public function get_teacher_id() {
		if ( isset( $_SESSION[ $this->get_session_var() ]["id"] ) ) {
			$id = $_SESSION[ $this->get_session_var() ]["id"];
		} else {
			$id = 0;
		}

		return (int) $id;
	}

	public function get_teacher( $id = 0, $fields = "*" ) {
		if ( empty( $id ) && $this->is_teacher_logged_in() ) {
			if ( isset( $_SESSION[ $this->get_session_var() ]["id"] ) ) {
				$id = $_SESSION[ $this->get_session_var() ]["id"];
			} else {
				$id = 0;
			}
		}

		$Q   = "SELECT * FROM `{$this->Table}` WHERE `id`='$id'";
		$row = $this->DB->get_row( $Q );

		if ( $fields == "*" ) {
			return $row;
		} else {
			$fields = \Str::make_array( $fields );
			$out    = [];
			foreach ( $fields as $field ) {
				if ( isset( $row[ $field ] ) ) {
					$out[ $field ] = $row[ $field ];
				}
			}

			return $out;
		}
	}

	public function get_teacher_photo( $id, $type = "url" ) {
		$type = strtolower( $type );
		if ( $type <> "url" && $type <> "path" ) {
			$type = "url";
		}
		if ( ! is_dir( TEACHER_FILES . "$id" ) && $type == "url" ) {
			return DOMAIN_URL . "images/no-image.png";
		}
		if ( ! is_dir( TEACHER_FILES . "$id" ) ) {
			return "";
		}
		if ( ! is_dir( TEACHER_FILES . "$id/photo/" ) && $type == "url" ) {
			return DOMAIN_URL . "images/no-image.png";
		}
		if ( ! is_dir( TEACHER_FILES . "$id/photo/" ) ) {
			return "";
		}
		$File   = new File();
		$photos = glob( TEACHER_FILES . "$id/photo/" . $File->globistr( "*.jpg" ) );
		if ( sizeof( $photos ) == "0" ) {
			$photos = glob( TEACHER_FILES . "$id/photo/" . $File->globistr( "*.jpeg" ) );
		}
		if ( sizeof( $photos ) == "0" ) {
			$photos = glob( TEACHER_FILES . "$id/photo/" . $File->globistr( "*.gif" ) );
		}
		if ( sizeof( $photos ) == "0" ) {
			$photos = glob( TEACHER_FILES . "$id/photo/" . $File->globistr( "*.png" ) );
		}
		if ( sizeof( $photos ) == "0" && $type == "url" ) {
			return DOMAIN_URL . "images/no-image.png";
		} else if ( sizeof( $photos ) == "0" && type == "path" ) {
			return "";
		} else if ( $type == "path" ) {
			return $photos[0];
		} else {
			return str_replace( ROOT_PATH, DOMAIN_URL, $photos[0] );
		}
	}

	public function count( $params = "" ) {
		$default = [];
		$params  = set_args( $params, $default );
		extract( $params );
		global $db;
		$Q = "SELECT COUNT(*) FROM `{$this->Table}` WHERE 1";

		return $db->get_var( $Q );
	}


	public function save_teacher( $data = "" ) {
		$default = [
			"id"                => "0",
			"name"              => "",
			"short_name"        => "",
			"email"             => "",
			"date_of_joining"   => "",
			"ignore_class_save" => "0",
		];
		$data    = set_args( $data, $default );

		extract( $data );
		$subject_assign = array();
		$id             = ( ! isset( $id ) || empty( $id ) ) ? 0 : $id;
		$id             = (int) $id;
		if ( $id < 0 ) {
			$id = 0;
		}

		if ( ! isset( $name ) || empty( $name ) ) {
			return "Teacher name missing";
		}

		if ( ! isset( $email ) || empty( $email ) || ! \Str::is_email( $email ) ) {
			return "Teacher email missing or invalid";
		}

		//if (!isset($data["cell"]) || empty($data["cell"]) || !$general->is_cell($data["cell"])) return "Please provide valid cell number";
		if ( ! isset( $date_of_joining ) || empty( $date_of_joining ) || ! \Dates::is_date( $date_of_joining ) ) {
			return __( "Invalid date of joining" );
		}

		$data["email"] = strtolower( \Str::xtrim( $data["email"] ) );
		$email         = strtolower( \Str::xtrim( $email ) );
		if ( $this->DB->get_var( "SELECT COUNT(*) FROM `{$this->Table}` WHERE `email`='$email' AND `id`<>'$id'" ) > 0 ) {
			return __( "Email address '$email' already assigned to other teacher, Please select any other email address" );
		}

		$data["date_of_joining"] = \Dates::mysql_date( $date_of_joining );
		unset( $data["ignore_class_save"] );

		if ( empty( $id ) ) {
			unset( $data["id"] );
			$data["added_by"]   = \Admins\UserInfo::get_my_id();
			$data["added_time"] = \Dates::mysql_datetime();
			$data["added_ip"]   = \General::myip();
			$response           = $this->DB->insert( $this->Table, $data );
			if ( $response === false ) {
				return $this->DB->last_error;
			}
			$id = $this->DB->insert_id;
		} else {
			unset( $data["classes"] );
			unset( $data["class_assign_subject"] );
			unset( $data["subject_assign"] );

			$response = $this->DB->update( $this->Table, $data, [ "id" => $id ] );
			if ( $response === false ) {
				return $this->DB->last_error;
			}
		}

		/*Saving Classes*/
		if ( $ignore_class_save == "0" ) {
			$this->DB->delete( $this->TableTeacherClasses, [ "teacher_id" => $id ] );
			if ( isset( $classes ) && is_array( $classes ) ) {
				foreach ( $classes as $cid ) {
					$data = [
						"teacher_id" => $id,
						"class_id"   => $cid,
					];
					$this->DB->insert( $this->TableTeacherClasses, $data );
				}
			}
		}
		/*End Saving Classes*/


		if ( ! empty( $class_assign_subject ) ) {
			$class_assign_subject = array_filter( $class_assign_subject );
			$subject_assign       = array_filter( $subject_assign );

			$sub                = [];
			$sub["teacherid"]   = $id;
			$sub["teachername"] = $name;
			$sub["added_by"]    = \Admins\UserInfo::get_my_id();
			$sub["added_time"]  = \Dates::mysql_datetime();
			$sub["added_ip"]    = \General::myip();
			$Q                  = "DELETE FROM `teachers_assign_subjects` WHERE `teacherid`='$id'";
			$this->DB->query( $Q );
			foreach ( $class_assign_subject as $k => $name ) {
				$sub["classname"] = $name;
				if ( ! empty( $subject_assign[ $k ] ) ) {
					$sub["subjectname"] = $subject_assign[ $k ];
				} else {
					unset( $sub["subjectname"] );
				}
				$this->DB->insert( "teachers_assign_subjects", $sub );
			}
		} else {
			$Q = "DELETE FROM `teachers_assign_subjects` WHERE `teacherid`='$id'";
			$this->DB->query( $Q );
		}

		return "OK";
	}

	/**
	 * @author Shakeel Ahmed Siddiqi
	 *
	 * @param $teacher_id
	 *
	 * @return integer
	 *
	 * This function counts assigned classes for a teacher.
	 */
	public function count_teahcers_assign_classes( $teacher_id ) {
		$Q = "SELECT COUNT(*) FROM `{$this->TableClasses}` c, `{$this->TableTeacherClasses}` tc
		WHERE tc.`class_id`=c.`id` AND tc.`teacher_id`='$teacher_id'";

		return $this->DB->get_var( $Q );
	}

	// get teachers_assign_classes data
	function get_teachers_assign_classes( $id = 0 ) {
		$Q    = "SELECT c.* FROM `{$this->TableClasses}` c, `{$this->TableTeacherClasses}` tc
		WHERE tc.`class_id`=c.`id` AND tc.`teacher_id`='$id'";
		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	function get_students_by_teacher( $teacher_id ) {
		$Q = "SELECT c.`id` FROM `{$this->TableClasses}` c, `{$this->TableTeacherClasses}` tc
		WHERE tc.`class_id`=c.`id` AND tc.`teacher_id`='$teacher_id'";

		$classes   = $this->DB->get_rows( $Q );
		$class_ids = [];
		foreach ( $classes as $class ) {
			$class_ids[] = $class["id"];
		}

		$Q    = "SELECT * FROM `students_view` WHERE `class_id` IN ('" . implode( "','", $class_ids ) . "')
			AND `active`='1'";
		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	function get_teachers_assign_classes_students( $id = 0 ) {
		$v    = "id,name,class_id";
		$id   = \Str::make_array( $id );
		$Q    = "SELECT $v FROM `students` WHERE `class_id` IN ('" . implode( "','", $id ) . "')";
		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	// get teachers_assign_classes data array
	function get_teachers_assign_classes_result( $id, $classid ) {
		$Q    = "SELECT * FROM `{$this->TableTeacherClasses}` WHERE `teacher_id`='$id' AND `class_id`='$classid'";
		$rows = $this->DB->get_rows( $Q );
		if ( isset( $rows ) && ! empty( $rows ) ) {
			$Q = "SELECT * FROM `classes` WHERE `id`='$classid'";
			$r = $this->DB->get_rows( $Q );

			return $r;
		}

		return "";
	}

	// get teachers_assign_classes all info
	function get_teachers_assign_classes_data( $teacher_id = 0 ) {
		$Q    = "SELECT tc.*, c.* FROM `{$this->TableTeacherClasses}` tc, `{$this->TableClasses}` c WHERE tc.`teacher_id`='$teacher_id'
				AND tc.`class_id`=c.`id`";
		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	//
	function get_teachers_assign_subjects( $id = 0 ) {
		$Q    = "SELECT * FROM `teachers_assign_subjects` WHERE `teacherid`='$id'";
		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	function generate_salaries( $month, $year ) {
		global $db;
		$Teachers = $this->get_teachers( "active=1" );
		foreach ( $Teachers as $teacher ) {
			if ( $teacher["salary"] > 0 ) {
				$data["salary"]       = $teacher["salary"];
				$data["teacher_id"]   = $teacher["id"];
				$data["salary_month"] = "{$year}-{$month}-01";
				$data["added_by"]     = \Admins\UserInfo::get_my_id();
				$data["added_time"]   = \Dates::mysql_datetime();
				$data["added_ip"]     = \General::myip();

				$response = $db->insert( "salaries", $data );
				if ( $response === false ) {
					return "Can't generate salaries for all teachers";
				}
			}
		}

		return "OK";
	}

	function get_salaries( $params = "" ) {
		$default = [
			"paid"     => - 1,     # -1 for all, 1 or 0
			"page"     => 0,                  # 0 = all pages
			"pagesize" => 10,
			"orderby"  => "id",
			"order"    => "DESC",
			"search"   => "",
		];
		$params  = set_args( $params, $default );
		extract( $params );
		global $db;

		$Q = "SELECT * FROM `salaries` WHERE 1";
		if ( $paid <> - 1 ) {
			$Q .= " AND `paid`=$paid";
		}
		if ( $search <> "" ) {

		}
		$Q .= " ORDER BY `$orderby` $order";

		if ( $page == 0 ) {
			$rows["rows"] = $db->get_rows( $Q );
		} else {
			$rows = $db->get_rows2( $Q, $page, $pagesize );
		}

		return $rows;
	}

	function pay_salary( $salary_id ) {
		global $db;
		$row          = $db->get_row( "SELECT `teacher_id`, `salary_month`, `deduction`, `salary` FROM `salaries` WHERE `id`=$salary_id" );
		$teacher_id   = $row["teacher_id"];
		$salary_month = $row["salary_month"];
		$Teacher      = $this->get_teacher( $teacher_id, "salary" );
		$amount_out   = $row["salary"] - $row["deduction"];
		$Q            = "amount_out={$amount_out}&teacher_id={$teacher_id}&date={$salary_month}&description=Salary: " . date( "F, Y", strtotime( $salary_month ) );
		$Q            .= "&head=Salary";
		$A            = new Accounts;
		$res          = $A->add_entry( $Q );
		if ( substr( $res, 0, 2 ) == "OK" ) {
			$Q = "UPDATE `salaries` SET `paid`=1 WHERE `id`=$salary_id";
			$db->query( $Q );

			return "OK";
		} else {
			return $res;
		}
	}

	function login( $params = "" ) {
		$default = [
			"email"       => "",
			"password"    => "",
			"remember_me" => "0",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		if ( empty( $email ) ) {
			return __( "Please provide email as username" );
		}
		if ( ! \Str::is_email( $email ) ) {
			return __( "Please provide email as username" );
		}
		if ( empty( $password ) ) {
			return __( "Password missing" );
		}

		$Q = "SELECT COUNT(*) FROM `{$this->Table}` WHERE `email`='$email' AND `active`='1'";
		if ( $this->DB->get_var( $Q ) > 1 ) {
			return __( "More than one teachers have email address '%1', Teacher login required unique email address.", $email );
		}

		$Q   = "SELECT * FROM `$this->Table` WHERE `email`='$email' AND `active`='1'";
		$row = $this->DB->get_row( $Q );
		if ( ! isset( $row['id'] ) ) {
			return __( "Teacher data not found" );
		}
		if ( $row['password'] == '' ) {
			$new_password = password_hash( $row['email'], PASSWORD_BCRYPT );
			$r            = $this->DB->update( $this->Table, [ "password" => $new_password ], [ "id" => $row['id'] ] );
			if ( $r !== false ) {
				$row['password'] = $new_password;
			}
		}
		if ( ! password_verify( $password, $row['password'] ) ) {
			return "Invalid password.";
		}
		# Updating login_history
		$history = [ "login_time" => \Dates::my_datetime(), "login_ip" => \General::myip() ];
		$r       = $this->DB->update( $this->Table, [ "login_history" => json_encode( $history ) ], [ "id" => $row["id"] ] );

		$_SESSION[ $this->get_session_var() ] = $row;
		$remember_me                          = (int) $remember_me;
		if ( $remember_me == 1 ) {
			set_cookie( $this->get_session_var(), $row['id'] );
		}

		return "OK";
	}

	function logout() {
		unset( $_SESSION[ $this->get_session_var() ] );
		if ( isset( $_COOKIE[ $this->get_session_var() ] ) ) {
			set_cookie( $this->get_session_var(), "", strtotime( "-1 day" ) );
		}
	}

	function is_teacher_logged_in() {
		if ( ! isset( $_SESSION[ $this->get_session_var() ] ) && isset( $_COOKIE[ $this->get_session_var() ] ) ) {
			$id  = $_COOKIE[ $this->get_session_var() ];
			$row = $this->DB->get_row( "SELECT * FROM `$this->Table` WHERE `id`='$id' AND `active`='1'" );
			if ( isset( $row['id'] ) ) {
				$_SESSION[ $this->get_session_var() ] = $row;
				set_cookie( $this->get_session_var(), $row['id'] );
			}
		}

		return isset( $_SESSION[ $this->get_session_var() ] );
	}

	function get_teacher_panel_url() {
		return DOMAIN_URL . "teacher/";
	}

	function my_id() {
		if ( ! $this->is_teacher_logged_in() ) {
			return "0";
		}
		if ( ! isset( $_SESSION[ $this->get_session_var() ]["id"] ) ) {
			return "0";
		}

		return $_SESSION[ $this->get_session_var() ]["id"];
	}

	function change_password_by_admin( $args = "" ) {
		$default = [
			"id"       => "",
			"password" => "",
		];

		$args = set_args( $args, $default );
		extract( $args );

		if ( empty( $id ) || empty( $password ) ) {
			return __( "Please provide ID and password of teacher to set new password" );
		}

		$response = $this->DB->update( $this->Table, [ "password" => password_hash( $password, PASSWORD_BCRYPT ) ], [ "id" => $id ] );
		if ( $response === false ) {
			return __( $this->DB->last_error );
		} else {
			return "OK";
		}
	}

	function change_password( $params = "" ) {
		$default = [
			"current_password" => "",
			"password1"        => "",
			"password2"        => "",
		];
		$params  = set_args( $params, $default );
		extract( $params );
		if ( empty( $current_password ) || empty( $password1 ) || empty( $password2 ) ) {
			return "Please provide all passwords.";
		}
		if ( $password1 <> $password2 ) {
			return "Password verification is not correct.";
		}
		if ( ! is_password_strong( $password1 ) ) {
			return "Password is weak, Required small letters, capital letters and digits with at least 6 characters.";
		}
		if ( ! $this->is_teacher_logged_in() ) {
			return "You'r not logged in";
		}
		$id       = $this->my_id();
		$Q        = "SELECT `password` FROM `$this->Table` WHERE `id`='$id'";
		$password = $this->DB->get_var( $Q );
		if ( ! password_verify( $current_password, $password ) ) {
			return "You've provided invalid current password.";
		}
		$new_password = password_hash( $password1, PASSWORD_BCRYPT );
		$r            = $this->DB->update( $this->Table, [ "password" => $new_password ], [ "id" => $id ] );

		if ( $r === false ) {
			return $this->DB->last_error;
		} else {
			return "OK";
		}
	}

	function teacher_upload_file( $data, $files ) {
		//echo "<pre>";print_r($data);die();
		$time = time();
		global $db;
		$allowed = [
			'pdf',
			'PDF',
			'txt',
			'TXT',
			'xlsx',
			'XLSX',
			'docx',
			'DOCX',
			'doc',
			'DOC',
			'png',
			'PNG',
			'jpg',
			'JPG',
			'jpeg',
			'JPEG',
		];

		extract( $data );

		if ( $files["uploadfile"]["name"] != '' ) {
			$ext = pathinfo( $files["uploadfile"]["name"], PATHINFO_EXTENSION );
			if ( ! in_array( $ext, $allowed ) ) {
				return 'Invalid file type ' . $files["uploadfile"]["name"] . ' (.' . $ext . ')';
			} else {
				$folder = ROOT_PATH . "contents/teacher/" . $teacherid . "/";
				if ( ! is_dir( $folder ) ) {
					mkdir( $folder );
				}
				$target_dir  = ROOT_PATH . "contents/teacher/" . $teacherid . "/";
				$target_file = $target_dir . $time . '_' . $files["uploadfile"]["name"];
				move_uploaded_file( $files['uploadfile']['tmp_name'], $target_file );
			}
			$data['file']      = $files["uploadfile"]["name"];
			$data['file_name'] = $time . '_' . $files["uploadfile"]["name"];
		} else {
			return "Please select a file.";
		}
		$data["added_by"]   = \Admins\UserInfo::get_my_id();
		$data["added_time"] = \Dates::mysql_datetime();
		$data["added_ip"]   = \General::myip();
		$response           = $this->DB->insert( $this->table_name, $data );

		if ( $response === false ) {
			return $this->DB->last_error;
		} else {
			return "OK";
		}
	}

	//    public function get_teacheruploadfile($id = "")
	//    {
	//        global $db;
	//        $Q = "SELECT * FROM `{$this->table_name}` WHERE `teacherid`='$id'";
	//        $rows = $db->get_rows($Q);
	//        return $rows;
	//    }

	public function teacher_upload_file_delete( $data = "" ) {
		global $db;
		extract( $data );
		$Q        = "DELETE FROM `{$this->table_name}` WHERE `id`='$id'";
		$response = $db->query( $Q );
		if ( $response === false ) {
			return "Can't delete record";
		} else {
			unlink( $path );

			return "OK";
		}
	}

	// get teacher comments
	function get_teacher_comment( $tid, $sid ) {
		global $db;
		$Q    = "SELECT * FROM `teacher_comments_student` WHERE `teacherid`='$tid' AND `studentid`='$sid' ";
		$rows = $db->get_rows( $Q );

		return $rows;
	}

	// teacher comment for student
	function save_teacher_comment( $data = "" ) {
		extract( $data );
		$Q   = "SELECT * FROM `teacher_comments_student` WHERE `teacherid`='$teacherid' AND `studentid`='$studentid' ";
		$row = $this->DB->get_row( $Q );

		return $row;
	}

	// teacher comment for student
	function save_teacher_comment_insert( $data = "" ) {
		global $db;
		$id = ( ! isset( $data["id"] ) || empty( $data["id"] ) ) ? 0 : $data["id"];
		$id = (int) $id;
		if ( $id < 0 ) {
			$id = 0;
		}
		unset( $data["id"] );
		if ( $id == 0 ) {
			$data["added_by"]   = \Admins\UserInfo::get_my_id();
			$data["added_time"] = \Dates::mysql_datetime();
			$data["added_ip"]   = \General::myip();
			$r                  = $this->DB->insert( 'teacher_comments_student', $data );
		} else {
			$r = $this->DB->update( 'teacher_comments_student', $data, array(), array( "id" => $id ) );
		}

		if ( $r === false ) {
			return $this->DB->last_error;
		} else {
			return "OK";
		}
	}

	function upload_course_material_data( $data, $files ) {
		//echo "<pre>";print_r($files);die();
		$time = time();

		extract( $data );
		$allowed = [
			'pdf',
			'PDF',
			'txt',
			'TXT',
			'xlsx',
			'XLSX',
			'docx',
			'DOCX',
			'doc',
			'DOC',
			'png',
			'PNG',
			'jpg',
			'JPG',
			'jpeg',
			'JPEG',
		];

		if ( $files["files"]["name"] != '' ) {
			$ext = pathinfo( $files["files"]["name"], PATHINFO_EXTENSION );
			if ( ! in_array( $ext, $allowed ) ) {
				return 'Invalid file type ' . $files["files"]["name"] . ' (.' . $ext . ')';
			} else {
				$folder = ROOT_PATH . "contents/teacher/" . $teacherid . "/";
				if ( ! is_dir( $folder ) ) {
					mkdir( $folder );
				}
				$target_dir  = ROOT_PATH . "contents/teacher/" . $teacherid . "/";
				$target_file = $target_dir . $time . '_' . $files["files"]["name"];
				move_uploaded_file( $files['files']['tmp_name'], $target_file );
			}
			$data['file']      = $files["files"]["name"];
			$data['file_name'] = $time . '_' . $files["files"]["name"];
		} else {
			return "Please select a file.";
		}
		$data["added_by"]   = \Admins\UserInfo::get_my_id();
		$data["added_time"] = \Dates::mysql_datetime();
		$data["added_ip"]   = \General::myip();
		global $db;
		$response = $db->insert( "teacher_upload_assignment", $data );

		if ( $response === false ) {
			return $db->last_error;
		} else {
			return "OK";
		}
	}


	function get_teachers_assign_subjects_result( $id, $classid ) {
		global $db;
		if ( $id == 0 ) {
			$Q = "SELECT * FROM `teacher_upload_assignment` WHERE `classid`='$classid'";
		} else {
			$Q = "SELECT * FROM `teacher_upload_assignment` WHERE `teacherid`='$id' AND `classid`='$classid'";
		}
		$rows = $db->get_rows( $Q );

		return $rows;
	}

	function delete_assignment( $data = "" ) {
		global $db;
		extract( $data );
		$p        = ROOT_PATH . "contents/teacher/" . $tid . "/" . $file;
		$Q        = "DELETE FROM `teacher_upload_assignment` WHERE `id`='$id'";
		$response = $db->query( $Q );
		if ( $response === false ) {
			return "Can't delete record";
		} else {
			unlink( $p );

			return "OK";
		}
	}


	function getTeacherClasses( $data ) {
		// echo "<pre>";print_r($data);die();
		$classids = "";
		extract( $data );
		$tid  = isset( $tid ) ? $tid : 0;
		$Q    = "SELECT `class_id` FROM `{$this->TableTeacherClasses}` WHERE `teacher_id`='$tid' ";
		$rows = $this->DB->get_rows( $Q );
		if ( isset( $rows ) && ! empty( $rows ) ) {
			foreach ( $rows as $r ) {
				$classids .= "'" . $r["class_id"] . "',";
			}
			$classids        = trim( $classids, "," );
			$Q               = "SELECT * FROM `classes` WHERE `id` IN($classids) ";
			$class           = $this->DB->get_rows( $Q );
			$class["status"] = "OK";

			return $class;
		}
		$rows["status"] = "NULL";

		return $rows;
	}


	function get_TeacherClasses() {
		$Q    = "SELECT * FROM `{$this->TableTeacherClasses}`";
		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}


	function teacherLectureSchedule( $data = "" ) {
		$default = [
			"teacher_id" => "",
			"class_id"   => "",
		];
		$data    = set_args( $data, $default );
		extract( $data );
		$s    = '`id`,`teacher_name`,`time`,`monday`,`tuesday`,`wednesday`,`thursday`,`friday`,`saturday`';
		$Q    = "SELECT * FROM `{$this->TableTeacherClasses}` WHERE `teacher_id`='$teacher_id'";
		$rows = $this->DB->get_rows( $Q );
		$cid  = "";
		if ( ! empty( $rows ) ) {
			foreach ( $rows as $row ) {
				$cid .= "'" . $row["class_id"] . "',";
			}
			$cid  = trim( $cid, "," );
			$v    = '`id`,`name`,`subjects`';
			$C    = "SELECT $v FROM `classes` WHERE `id` IN($cid) ";
			$rows = $this->DB->get_rows( $C );
			// schedule
			$S                = "SELECT $s FROM `weekly_lecture_schedule` WHERE `teacherid`='$teacher_id' AND `classid`='$class_id'";
			$rows["schedule"] = $this->DB->get_rows( $S );
			$rows["status"]   = "OK";
		} else {
			$rows["status"] = "No data available";
		}

		return $rows;
	}

	function getClassForStudentSubject( $id ) {
		$Q    = "SELECT * FROM `teacher_upload_assignment` WHERE `classid`='$id'";
		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	function get_teacher_emails( $ignore_ids = "" ) {
		$Q = "SELECT GROUP_CONCAT(`email`) FROM `teachers` WHERE 1";
		if ( ! empty( $ignore_ids ) ) {
			$ignore_ids = \Str::make_array( $ignore_ids );
			$Q          .= " AND `id` NOT IN ('" . implode( "','", $ignore_ids ) . "')";
		}

		$emails = $this->DB->get_var( $Q );

		return \Str::make_array( $emails );
	}

	public function get_techer_name( $teacher_id ) {
		$Q = "SELECT `name` FROM `{$this->Table}` WHERE `id`='$teacher_id'";

		return $this->DB->get_var( $Q );
	}

	/**
	 * @autho Shakeel Ahmed Siddiqi <shakeel@shakeel.pk>
	 *
	 * @param     $student_id
	 * @param int $teacher_id
	 *
	 * @return array
	 *
	 * This function returns array of files, uploaded by Students from Student panel from Data > Teacher Assignments
	 * page.
	 */
	function get_teacher_x_student_assignment_files( $student_id, $teacher_id = 0 ) {
		$Files = new \Student\Files();

		$files = $Files->get_files( $student_id, false, ['teacher_id'=>$teacher_id]);

		return $files;

		if ( empty( $teacher_id ) && $this->is_teacher_logged_in() ) {
			if ( isset( $_SESSION[ $this->get_session_var() ]["id"] ) ) {
				$teacher_id = $_SESSION[ $this->get_session_var() ]["id"];
			} else {
				$teacher_id = 0;
			}
		}

		$path = ROOT_PATH . "contents/students/{$student_id}/assignments/{$teacher_id}/";

		if ( ! is_dir( $path ) ) {
			return [];
		}
		$files = glob( $path . "*.*" );

		return $files;
	}
}