<?php

class TestSchedule {

	protected $DB;
	protected $Table = "test_schedules";

	function __construct() {
		global $db;
		$this->DB = $db;
		/*$b = new Batch();
		$b->get_active_batch();*/
	}

	function get_list( $params = "" ) {
		$default = [
			"class_id"  => "",    // You can pass an array or values like this 1,2,3,4
			"order_by"  => "test_date",
			"order"     => "ASC",
			"page"      => 0,
			"pagesize"  => 10,
			"search"    => "",
			"from_date" => "",
			"to_date"   => "",
		];
		$params  = set_args( $params, $default );
		extract( $params );

		$Q = "SELECT * FROM `{$this->Table}` WHERE 1";
		if ( ! empty( $class_id ) ) {
			if ( ! is_array( $class_id ) ) {
				$class_id = explode( ",", $class_id );
			}
			$Q .= " AND (`class_id`=" . implode( " OR `class_id`=", $class_id ) . ")";
		}

		if ( ! empty( $search ) ) {
			$search = trim( $search );
			$search = $this->DB->set_string( $search );

			$Q .= " AND (`name` LIKE '%$search%' OR `subject` LIKE '%$search%' OR `teacher` LIKE '%$search%')";
			if ( is_numeric( $search ) ) {
				$Q .= " OR `id`='$search'";
			}
		}

		if ( ! empty( $from_date ) && empty( $to_date ) ) {
			$Q .= " AND `test_date`>='" . \Dates::mysql_date( $from_date ) . "'";
		}
		if ( ! empty( $from_date ) && ! empty( $to_date ) ) {
			$Q .= " AND (`test_date` BETWEEN '" . \Dates::mysql_date( $from_date ) . "' AND '" . \Dates::mysql_date( $to_date ) . "' )";
		}

		//if (isset)

		$Q    .= " ORDER BY `$order_by` $order";

		$rows = $this->DB->get_rows2( $Q, $page, $pagesize );
		foreach ( $rows["rows"] as &$row ) {
			$row["test_date2"] = \Dates::my_date( $row["test_date"] );
			$row["class_name"] = $this->DB->get_var( "SELECT `class_name` FROM `batch_classes` WHERE `id`=" . $row["class_id"] );
		}

		return $rows;
	}

	function delete( $schedule_id ) {
		if ( ! isset( $schedule_id ) || ! is_numeric( $schedule_id ) ) {
			return false;
		}

		$Q = "DELETE FROM `{$this->Table}` WHERE `id`=" . $schedule_id;
		if ( $this->DB->query( $Q ) === false ) {
			return false;
		}

		$Q = "DELETE FROM `mark_sheets` WHERE `schedule_id`=$schedule_id";
		if ( $this->DB->query( $Q ) === false ) {
			return false;
		}

		$Q = "DELETE FROM `mark_sheets_data` WHERE `schedule_id`=$schedule_id";
		if ( $this->DB->query( $Q ) === false ) {
			return false;
		}

		return true;
	}

	function empty_marksheet( $schedule_id ) {
		if ( ! isset( $schedule_id ) || ! is_numeric( $schedule_id ) ) {
			return false;
		}

		$Q = "DELETE FROM `mark_sheets` WHERE `schedule_id`=$schedule_id";
		if ( $this->DB->query( $Q ) === false ) {
			return false;
		}

		$Q = "DELETE FROM `mark_sheets_data` WHERE `schedule_id`=$schedule_id";
		if ( $this->DB->query( $Q ) === false ) {
			return false;
		}

		return true;
	}

	function save_schedule( $params = "" ) {
		$default = [
			"name"     => "",
			"class_id" => "",
			"from"     => "",
			"to"       => "",
			"weekday"  => [],
			"subject"  => [],
			"teacher"  => [],
		];
		$params  = set_args( $params, $default );
		extract( $params );

		if ( empty( $name ) ) {
			return __( "Please type name of schedule" );
		}
		if ( empty( $class_id ) ) {
			return __( "Please select class" );
		}
		if ( \Dates::empty_date( $from ) || \Dates::empty_date( $to ) ) {
			return __( "Please select date range" );
		}
		if ( ! \Dates::is_date( $from ) || ! \Dates::is_date( $to ) ) {
			return __( "Please select valid dates" );
		}
		if ( empty( $weekday ) || empty( $subject ) || empty( $teacher ) ) {
			return __( "Please select weekday, subject and teacher" );
		}

		$from     = strtotime( $from );
		$to       = strtotime( $to );
		$loopdate = $from;

		$subject = \Str::make_array( $subject );
		$teacher = \Str::make_array( $teacher );
		$weekday = \Str::make_array( $weekday );

		$added = 0;
		while ( $loopdate <= $to ) {
			$wday = Date( "N", $loopdate );
			for ( $x = 0; $x < count( $weekday ); $x ++ ) {
				if ( $wday == $weekday[ $x ] && trim( $subject[ $x ] ) <> "" ) {
					$subject[ $x ] = isset($subject[ $x ])?$subject[ $x ]:'';
					$teacher[ $x ] = isset($teacher[ $x ])?$teacher[ $x ]:'';
					$data     = [
						"name"       => $name,
						"class_id"   => $class_id,
						"test_date"  => date( "Y-m-d", $loopdate ),
						"subject"    => $subject[ $x ],
						"teacher"    => $teacher[ $x ],
						"added_by"   => \Admins\UserInfo::get_my_id(),
						"added_time" => \Dates::mysql_datetime(),
						"added_ip"   => \General::myip(),
						"start_date" => date( "Y-m-d", $from ),
					];
					$response = $this->DB->insert( $this->Table, $data );
					if ( $response !== false ) {
						$added ++;
					} else {
						return $this->DB->last_error;
					}
				}
			}
			$loopdate = strtotime( '+1 day', $loopdate );
		}
		if ( $added == 0 ) {
			return __( "No schedule added!, Date range is not selected with select days." );
		}

		return "OK" . $added;
	}
}