<?php

namespace TimeTable;

class TimeTable {

	protected $Table = "time_table";
	protected $TableTeacher = "teachers";
	protected $TableShifts = "time_table_shifts";
	protected $DB;

	public function __construct() {
		global $db;

		$this->DB = $db;
		$this->DB->drop_table( "time_table_details", true );

		$this->DB->delete( $this->Table, [ "class_id" => "0" ] );
		$this->DB->query( "DELETE FROM `{$this->Table}` WHERE `subject` IS NULL OR `class_id` IS NULL" );
	}

	public function get_schedules( $args = "" ) {
		$default = [

		];
		$args    = set_args( $args, $default );

	}

	public function save( $args = "" ) {
		$default = [
			"teacher_id" => 0,
			"day"        => 0,
			"class_id"   => 0,
			"shift_id"   => 0,
			"subject"    => "",
		];
		$args    = set_args( $args, $default );
		extract( $args );

		if ( empty( $class_id ) ) {
			return __( "Class ID missing" );
		}
		if ( empty( $teacher_id ) ) {
			return __( "Teacher ID missing" );
		}
		if ( empty( $day ) ) {
			return __( "Week day missing" );
		}
		if ( empty( $shift_id ) ) {
			return __( "Shift ID missing" );
		}
		if ( empty( $subject ) ) {
			$this->delete_time_table_entry( [
				"class_id" => $class_id,
				"shift_id" => $shift_id,
				"day"      => $day,
			] );
		}
		/*if ( empty( $class_id ) ) {
			return __( "Class ID missing" );
		}*/

		$data ["teacher_id"] = $teacher_id;
		$data ["day"]        = $day;
		$data ["class_id"]   = $class_id;
		$data ["shift_id"]   = $shift_id;
		$data ["subject"]    = $subject;

		if ( $this->DB->get_var( "SELECT COUNT(*) FROM `{$this->Table}` WHERE `teacher_id`='{$teacher_id}' AND `shift_id`='{$shift_id}' AND `day`='{$day}'" ) == 0 ) {
			$data["added_by"]   = \Admins\UserInfo::get_my_id();
			$data["added_time"] = \Dates::mysql_datetime();
			$data["added_ip"]   = \General::myip();

			$response = $this->DB->insert( $this->Table, $data );
		} else {
			$response = $this->DB->update( $this->Table, $data, [
				"teacher_id" => $teacher_id,
				"shift_id"   => $shift_id,
				"day"        => $day,
			] );
		}
		if ( $response === false ) {
			return $this->DB->last_error;
		}

		return "OK";
	}

	public function get_time_table( $args = "" ) {
		$default = [
			"class_id" => "0",
		];
		$args    = set_args( $args, $default );
		extract( $args );

		$Q = "SELECT * FROM `{$this->Table}` WHERE `class_id`='$class_id'";

		return $this->DB->get_rows( $Q );
	}

	public function get_complete_time_table( $class_id ) {
		$Shifts = new Shifts();
		$shifts = $Shifts->get_shifts( "pagesize=9999" );
		$data   = [];
		foreach ( $shifts["rows"] as $shift ) {
			$shift_ready = [
				"shift_id"   => $shift["id"],
				"shift_name" => $shift["shift_name"],
			];
			$all_empty   = true;
			for ( $d = 1; $d <= 7; $d ++ ) {
				$Q = "SELECT tt.`subject`, t.name teacher_name, t.short_name teacher_short_name FROM `{$this->Table}` tt, `teachers` t WHERE
					`shift_id`='{$shift["id"]}' AND `class_id`='$class_id' AND `day`='{$d}' AND `shift_id` AND t.id=tt.teacher_id ORDER BY tt.id DESC";
				//echo $Q."<br>";
				$row = $this->DB->get_row( $Q );
				if ( isset( $row["subject"] ) ) {
					$shift_ready[ "day" . $d ] = $row;
					$all_empty                 = false;
				} else {
					$shift_ready[ "day" . $d ] = [];
				}
			}
			$shift_ready["empty"] = $all_empty ? 1 : 0;
			$data[]               = $shift_ready;
		}

		return $data;
	}

	public function get_time_table_names() {
		$Q = "SELECT tt.`teacher_id`, t.`name` teacher_name, COUNT(tt.`teacher_id`) entries FROM `{$this->Table}` tt, `{$this->TableTeacher}` t
			WHERE t.`id`=tt.`teacher_id` GROUP BY `teacher_id`";

		return $this->DB->get_rows( $Q );
	}

	public function get_time_table_class_names() {
		$Q = "SELECT `class_id`,c.class_name, COUNT(`class_id`) entries, COUNT(DISTINCT teacher_id) teachers,
				c.active active_class,
				COUNT(DISTINCT subject) subjects,
				(SELECT `batch_name` FROM `batches` WHERE `id`=c.batch_id) batch_name,
				(SELECT `active` FROM `batches` WHERE `id`=c.batch_id) batch_active
				FROM `{$this->Table}` tt, `batch_classes` c
				WHERE class_id=c.id GROUP BY `class_id`";

		return $this->DB->get_rows( $Q );
	}

	public function get_teacher_schedule( $teacher_id ) {
		$Q = "SELECT * FROM `{$this->Table}` WHERE `teacher_id`='$teacher_id'";

		return $this->DB->get_rows( $Q );
	}

	public function get_class_schedule( $class_id ) {
		$Q = "SELECT * FROM `{$this->Table}` WHERE `class_id`='$class_id'";

		return $this->DB->get_rows( $Q );
	}

	public function delete_time_table_entry( $args = "" ) {
		$default = [
			"class_id" => "",
			"shift_id" => "",
			"day"      => "",
		];
		$args    = set_args( $args, $default );
		extract( $args );

		$response = $this->DB->delete( $this->Table, [
			"class_id" => $class_id,
			"shift_id" => $shift_id,
			"day"      => $day,
		] );

		if ( $response === false ) {
			return $this->DB->last_error;
		}

		return "OK";
	}

	public function get_time_table_by_teacher( $teacher_id ) {
		$Q    = "SELECT * FROM `{$this->Table}` WHERE `teacher_id`='{$teacher_id}'";
		$rows = $this->DB->get_rows( $Q );

		return $rows;
	}

	public function get_time_table_teacher( $teacher_id ) {
		$Q = "SELECT s.id shift_id, t.id time_table_id, `subject`, `shift_name`, `start_time`, `end_time`,
			te.`name` teacher_name, `day`, `class_id`, (SELECT `class_name` FROM `batch_classes` WHERE `id`=t.class_id) class_name
			FROM `{$this->Table}` t, `{$this->TableShifts}` s, `{$this->TableTeacher}` te
			WHERE t.`shift_id`=s.`id` AND t.`teacher_id`='{$teacher_id}' AND te.`id`=t.`teacher_id`
		
			ORDER BY s.`sort`, t.`day`";

		$rows = $this->DB->get_rows($Q);

		$final_rows = [];
		foreach($rows as $row) {
			$final_rows[$row["shift_id"]][$row["day"]] = $row;
		}
		return $final_rows;
	}
}