<?php
function send_mail( $to, $subject, $message, $replyTo = "", $replyToName = "System", $attachedFiles = "", $fromEmail = "", $fromName = "", $toName = "" ) {
	global $db;
	if ( $db->get_option( "admin_email" ) == "" ) {
		$db->set_option( "admin_email", "shakeel@fekara.com" );
	}
	require_once( LIBRARY_PATH . "phpmailer/class.phpmailer.php" );
	if ( is_array( $to ) ) {
		$t = $to[0];
	} else {
		$t = $to;
	}
	if ( ! \Str::is_email( $t ) ) {
		return ( "Error: Invalid email address To: $t" );
	}
	if ( \General::localhost() ) {
		$_SERVER['HTTP_HOST'] = "fekara.pk";
	}
	if ( $replyTo == "" ) {
		$replyTo = "no-reply@" . str_replace( "www.", "", strtolower( $_SERVER['HTTP_HOST'] ) );
	}

	$mail = new PHPMailer( true );
	//if ($fromEmail=="") $fromEmail = get_option('email_from');
	if ( $fromName == "" ) {
		if (defined('System')) {
			$fromName = System;
		} else {
			$fromName = "UnKnown";
		}
	}
	if ( ! \Str::is_email( $fromEmail ) ) {
		$fromEmail = "no-reply@" . str_replace( "www.", "", strtolower( $_SERVER['HTTP_HOST'] ) );
	}

	try {
		if ( $replyTo <> "no-reply@no-domain.no" AND $replyToName <> "No Name" ) {
			$mail->AddReplyTo( $replyTo, $replyToName );
		}
		if ( is_array( $to ) ) {
			$mail->AddAddress( $to[0], $to[1] );
		} else {
			if ( $toName == "" ) {
				$mail->AddAddress( $to );
			} else {
				$mail->AddAddress( $to, $toName );
			}
		}
		$mail->Subject = $subject;
		$mail->SetFrom( $fromEmail, $fromName );
		$mail->AltBody = 'To view the message, please use an HTML compatible email viewer!'; // optional - MsgHTML will create an alternate automatically
		$mail->MsgHTML( $message );
		if ( is_array( $attachedFiles ) ) {
			foreach ( $attachedFiles as $File ) {
				$mail->AddAttachment( $File );
			}
		} else if ( file_exists( $attachedFiles ) ) {
			$mail->AddAttachment( $attachedFiles );
		}

		if ( $db->get_option( 'use_smtp' ) == "Yes" ) {
			// Send simple SMTP.
			$mail->IsSMTP();
			$mail->SMTPAuth = true;
			if ( $db->get_option( 'is_gmail' ) == "Yes" ) {
				// Send using GMail.
				$mail->Host = 'ssl://smtp.gmail.com:465';
			} else {
				$mail->Host = $db->get_option( 'smtp_server' );
			}
			$mail->Username = $db->get_option( 'smtp_user' );
			$mail->Password = $db->get_option( 'smtp_password' );
		}

		$mail->Send();

		return ( "OK" );
	} catch ( phpmailerException $e ) {
		return ( strip_tags( "Error: " . $e->errorMessage() ) ); //Pretty error messages from PHPMailer
	} catch ( Exception $e ) {
		return ( strip_tags( "Error: " . $e->getMessage() ) ); //Boring error messages from anything else!
	}
}