<?php
/**
 * @param $string
 *
 * @return string
 *
 * Translate string according the current language.
 */

if ( ! function_exists( 'decode_key' ) ) {
	function decode_key( $encrypted_string ) {
		$decoded = openssl_decrypt( $encrypted_string, "AES-128-ECB", "DJd$%Fd)%f6659*##8713" );

		if ( is_json( $decoded ) ) {
			$decoded = json_decode( $decoded, true );
		}

		return $decoded;
	}
}

function __( $string ) {
	global $db2;
	$table_query = "CREATE TABLE IF NOT EXISTS `translation_string` (
		`id` INT(11) NOT NULL AUTO_INCREMENT,
		`string` TEXT NOT NULL COLLATE 'utf8mb4_unicode_ci',
		PRIMARY KEY (`id`),
		UNIQUE INDEX `string` (string(20))
	)
	COMMENT='This table is used for getting all tranlated strings.'
	COLLATE='utf8mb4_unicode_ci'
	ENGINE=MyISAM;";
	$db2->rawQuery( $table_query );

	$db2->insert( 'translation_string', ['string'=>$string]);

	global $translator;
	if ( $translator ) {
		$argv = func_get_args();
		unset( $argv[0] );
		$params = [];
		foreach ( $argv as $x => $arg ) {
			$params[ '%' . $x ] = $arg;
		}

		$string = $translator->trans( $string, $params );
	}

	/*global $Trans;
	if ( $Trans->get_language() == 'ur' ) {
		return '<span style="font-family: \'Noto Nastaliq Urdu Draft\', serif;">' . $string . '</span>';
	}*/

	return $string;

	if ( ! is_file( ROOT_PATH . 'contents/t.ini' ) ) {
		\Translation::write_translation_file();
	}

	global $translations_array;
	if ( is_array( $translations_array ) ) {
		$translations_array = array_change_key_case( $translations_array );
	} else {
		$translations_array = [];
	}

	$argv = func_get_args();

	if ( array_key_exists( strtolower( $string ), $translations_array ) ) {
		$string = $translations_array[ strtolower( $string ) ];
	} else {
		$T = new Translation();

		$string = $T->get( $string );
	}

	if ( count( $argv ) > 1 ) {
		for ( $x = 1; $x < count( $argv ); $x ++ ) {
			$string = str_replace( "%" . $x, $argv[ $x ], $string );
		}
	}

	return $string;
}

function _e( $string ) {
	$args = func_get_args();
	echo call_user_func_array( '__', $args );
}

/**
 * @param $email
 *
 * @return mixed
 * @deprecated - Moved to \Str::is_email()
 */
function is_email( $email ) {
	return filter_var( $email, FILTER_VALIDATE_EMAIL );
}

function GMT_to_UserTime( $datetime = "", $format = "Y-m-d H:i:s" ) {
	if ( $datetime == "" ) {
		$time = time();
	} else {
		$time = strtotime( $datetime );
	}

	return date( $format, $time + date( "Z", $time ) );
}

/**
 * @param string $format
 *
 * @return false|string
 * @deprecated  - Moved to \Dates::current_time()
 */
function current_time( $format = 'Y-m-d H:i:s' ) {
	return Date( $format );
}

function set_tz_by_offset( $offset ) {
	$offset    = $offset * 60 * 60;
	$abbrarray = timezone_abbreviations_list();
	#echo "<pre>";
	#print_r ($abbrarray);
	#echo "</pre>";
	foreach ( $abbrarray as $abbr ) {
		//echo $abbr."<br>";
		foreach ( $abbr as $city ) {
			//echo $city['offset']." $offset<br>";
			if ( $city['offset'] == $offset ) { // remember to multiply $offset by -1 if you're getting it from js
				@date_default_timezone_set( $city['timezone_id'] );

				return true;
			}
		}
	}
	date_default_timezone_set( "ust" );

	return false;
}

/**
 * @return bool|mixed|null|string
 * @deprecated - Moved to \Dates::get_time_zone()
 */
function get_time_zone() {
	global $db;
	$tz = $db->get_option( 'time_zone' );
	if ( $tz == "" ) {
		return '5';
	} else {
		return $tz;
	}
}

function show_array( $var ) {
	if ( is_scalar( $var ) ) {
		echo $var;
	} else {
		echo "<pre>";
		var_dump( $var );
		echo "</pre>";
	}

	//	if ( is_bool( $ar ) && $ar ) {
	//		$ar = "TRUE";
	//	} else if ( is_bool( $ar ) && ! $ar ) {
	//		$ar = "FALSE";
	//	}
	//	echo "<pre>\n";
	//	print_r( $ar );
	//	echo "</pre>\n";
}

/**
 * @param $string
 *
 * @return null|string|string[]
 * @deprecated - Moved to \Str::xtrim()
 */
function xtrim( $string ) {
	/*$string = preg_replace( '/[^[:print:]]/', '',$string);
	//$string = trim($string, " \t\n\r\0\x0B�");
	$string = trim($string);
	return $string;*/

	$s = trim( $string );
	$s = trim( $s, " \t\n\r\0\x0B" );
	//$s = trim($s, chr(239));
	$s = iconv( "UTF-8", "UTF-8//IGNORE", $s ); // drop all non utf-8 characters

	// this is some bad utf-8 byte sequence that makes mysql complain - control and formatting i think
	$s = preg_replace( '/(?>[\x00-\x1F]|\xC2[\x80-\x9F]|\xE2[\x80-\x8F]{2}|\xE2\x80[\xA4-\xA8]|\xE2\x81[\x9F-\xAF])/', ' ', $s );

	$s = preg_replace( '/\s+/', ' ', $s ); // reduce all multiple whitespace to a single space

	return $s;
}

function make_password( $length = 8, $possible = "0123456789" ) {
	// start with a blank password
	$password = "";

	// define possible characters - any character in this string can be
	// picked for use in the password, so if you want to put vowels back in
	// or add special characters such as exclamation marks, this is where
	// you should do it
	//$possible = "2346789bcdfghjkmnpqrtvwxyzBCDFGHJKLMNPQRTVWXYZ!@#$%^&*()-><{}[]=+?";

	// we refer to the length of $possible a few times, so let's grab it now
	$maxlength = strlen( $possible );

	// check for length overflow and truncate if necessary
	if ( $length > $maxlength ) {
		$length = $maxlength;
	}

	// set up a counter for how many characters are in the password so far
	$i = 0;

	// add random characters to $password until $length is reached
	while ( $i < $length ) {

		// pick a random character from the possible ones
		$char = substr( $possible, mt_rand( 0, $maxlength - 1 ), 1 );

		// have we already used this character in $password?
		if ( ! strstr( $password, $char ) ) {
			// no, so it's OK to add it onto the end of whatever we've already got...
			$password .= $char;
			// ... and increase the counter by one
			$i ++;
		}

	}

	// done!
	return $password;

}

function make_username( $U = 'user', $length = 5 ) {
	// start with a blank password
	$user = "";

	// define possible characters - any character in this string can be
	// picked for use in the password, so if you want to put vowels back in
	// or add special characters such as exclamation marks, this is where
	// you should do it
	$possible = "012346789";

	// we refer to the length of $possible a few times, so let's grab it now
	$maxlength = strlen( $possible );

	// check for length overflow and truncate if necessary
	if ( $length > $maxlength ) {
		$length = $maxlength;
	}

	// set up a counter for how many characters are in the password so far
	$i = 0;

	// add random characters to $password until $length is reached
	while ( $i < $length ) {

		// pick a random character from the possible ones
		$char = substr( $possible, mt_rand( 0, $maxlength - 1 ), 1 );

		// have we already used this character in $password?
		if ( ! strstr( $user, $char ) ) {
			// no, so it's OK to add it onto the end of whatever we've already got...
			$user .= $char;
			// ... and increase the counter by one
			$i ++;
		}

	}

	// done!
	return $U . $user;

}

function make_url( $title ) {
	$slug = $title;

	$bad = array(
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'�',
		'"',
		"'",
		'�',
		'�',
		"\n",
		"\r",
	);

	$good = array(
		'S',
		'Z',
		's',
		'z',
		'Y',
		'A',
		'A',
		'A',
		'A',
		'A',
		'A',
		'C',
		'E',
		'E',
		'E',
		'E',
		'I',
		'I',
		'I',
		'I',
		'N',
		'O',
		'O',
		'O',
		'O',
		'O',
		'O',
		'U',
		'U',
		'U',
		'U',
		'Y',
		'a',
		'a',
		'a',
		'a',
		'a',
		'a',
		'c',
		'e',
		'e',
		'e',
		'e',
		'i',
		'i',
		'i',
		'i',
		'n',
		'o',
		'o',
		'o',
		'o',
		'o',
		'o',
		'u',
		'u',
		'u',
		'u',
		'y',
		'y',
		'TH',
		'th',
		'DH',
		'dh',
		'ss',
		'OE',
		'oe',
		'AE',
		'ae',
		'u',
		'',
		'',
		'',
		'',
		'',
		'',
	);

	// replace strange characters with alphanumeric equivalents
	$slug = str_replace( $bad, $good, $slug );
	$slug = str_replace( '---', '-', $slug );
	$slug = str_replace( '--', '-', $slug );

	$slug = trim( $slug );

	// remove any duplicate whitespace, and ensure all characters are alphanumeric
	$bad_reg  = array( '/\s+/', '/[^A-Za-z0-9\-\_]/' );
	$good_reg = array( '-', '' );
	$slug     = preg_replace( $bad_reg, $good_reg, $slug );

	// and lowercase
	$slug = strtolower( $slug );

	return $slug;
}

if ( ! function_exists( 'str_getcsv' ) ) {
	function str_getcsv( $input, $delimiter = ',', $enclosure = '"', $escape = null, $eol = null ) {
		$temp = fopen( "php://memory", "rw" );
		fwrite( $temp, $input );
		fseek( $temp, 0 );
		$r = array();
		while ( ( $data = fgetcsv( $temp, 4096, $delimiter, $enclosure ) ) !== false ) {
			$r[] = $data;
		}
		fclose( $temp );

		return $r;
	}
}
/**
 * @param string $filename
 * @param string $delimiter
 *
 * @return array|bool
 * @deprecated - Moved to CSV->toArray()
 */
function csv_to_array( $filename = '', $delimiter = ',' ) {
	if ( ! file_exists( $filename ) || ! is_readable( $filename ) ) {
		return false;
	}

	$header = null;
	$data   = array();
	//$lines = file($filename);
	if ( ( $handle = fopen( $filename, 'r' ) ) !== false ) {
		while ( ( $row = fgetcsv( $handle, null, $delimiter ) ) !== false ) {
			if ( ! $header ) {
				$row = array_map( "utf8_encode", $row );
				foreach ( $row as $f ) {
					$header[] = preg_replace( "/[^a-zA-Z0-9_]+/", "", $f );
				}
			} else {
				$data[] = array_combine( $header, $row );
			}
		}
		fclose( $handle );
	}

	return $data;
}

/**
 * @param $arr
 *
 * @return bool
 * @deprecated - moved in C class.
 */
function is_indexed_array( $arr ) {
	return array_values( $arr ) === $arr;
}

function in_arrayi( $needle, $haystack ) {
	for ( $h = 0; $h < count( $haystack ); $h ++ ) {
		$haystack[ $h ] = strtolower( $haystack[ $h ] );
	}

	return in_array( strtolower( $needle ), $haystack );
}

/**
 * @param      $mon
 * @param bool $full
 *
 * @return false|string
 * @deprecated - Moved to \Dates::month_name()
 */
function get_month_name( $mon, $full = false ) {
	if ( $full ) {
		return date( 'F', mktime( 0, 0, 0, $mon ) );
	} else {
		return date( 'M', mktime( 0, 0, 0, $mon ) );
	}
}

function in_multiarray( $elem, $array ) {
	$top    = sizeof( $array ) - 1;
	$bottom = 0;
	while ( $bottom <= $top ) {
		if ( $array[ $bottom ] == $elem ) {
			return true;
		} else if ( is_array( $array[ $bottom ] ) ) {
			if ( in_multiarray( $elem, ( $array[ $bottom ] ) ) ) {
				return true;
			}
		}

		$bottom ++;
	}

	return false;
}

function get_system_email( $type = "noreply" ) {
	return $type . "@" . str_ireplace( "www.", "", $_SERVER['HTTP_HOST'] );
}

function make_param_array( $param ) {
	if ( is_array( $param ) ) {
		return $param;
	}
	if ( trim( $param ) == "" || empty( $param ) ) {
		return array();
	}
	$param = explode( ",", $param );

	return $param;
}

function set_args( $args, $default ) {
	if ( ! is_array( $args ) ) {
		$args = stripslashes( $args );
		parse_str( $args, $args );
	}
	if ( ! is_array( $args ) ) {
		return array();
	}
	if ( ! is_array( $default ) ) {
		return $default;
	}
	foreach ( $default as $k => $v ) {
		if ( ! isset( $args[ $k ] ) ) {
			$args[ $k ] = $v;
		}
	}
	if ( get_magic_quotes_gpc() ) {
		$args = array_map_recursive( "stripslashes", $args );
	}

	return $args;
}

function array_map_recursive( $fn, $arr ) {
	$rarr = array();
	foreach ( $arr as $k => $v ) {
		$rarr[ $k ] = is_array( $v ) ? array_map_recursive( $fn, $v ) : $fn( $v ); // or call_user_func($fn, $v)
	}

	return $rarr;
}

/**
 * @param $pwd
 *
 * @return bool
 * Check if given string is a strong password.
 */
function is_password_strong( $pwd ) {
	if ( strlen( $pwd ) < 6 ) {
		return false;
	}

	if ( ! preg_match( "#[0-9]+#", $pwd ) ) {
		return false;
	}

	if ( ! preg_match( "#[a-zA-Z]+#", $pwd ) ) {
		return false;
	}

	return true;
}

function get_gavatar( $email ) {
	$email = \Str::xtrim( $email );
	$email = strtolower( $email );
	$email = md5( $email );
	$email = "http://www.gravatar.com/" . $email . ".php";
	if ( ! $str = @file_get_contents( $email ) ) {
		return ROOT_URL . "includes/images/no_photo.jpg";
	} else {
		$profile = unserialize( $str );
		if ( is_array( $profile ) && isset( $profile['entry'] ) ) {
			return $profile['entry'][0]['thumbnailUrl'];
		} else {
			return ROOT_URL . "includes/images/no_photo.jpg";
		}
	}
}

function show_form( $fields = array(), $args = "" ) {
	$defaults = array(
		"formid"             => "form1",
		"savebutton"         => 1,
		"savebuttontext"     => "Save",
		"savebuttonposition" => "both",   // both, top, bottom
		"method"             => "post",   // post, get, ajax
		"action"             => "",
		"ajaxaction"         => "",
	);
	$args     = set_args( $args, $defaults );
	extract( $args );
	if ( $method == "ajax" ) {
		echo "<script type='text/javascript'>
	function Save$formid() {
		jQuery('#loading').show();
		jQuery.post('ajax.php?action=$action', jQuery('#$formid').serialize(), function(data){
			jQuery('#loading').hide();
			if (substr(data,0,2)=='GO')
				window.location.href=substr(data,2);
			else if (data=='OK')
				jQuery('#success$formid').html('Saved successfully!').slideDown('slow').delay(5000).slideUp('slow');
			else
				jQuery('#error$formid').html(data).slideDown('slow').delay(5000).slideUp('slow');
		});
		return false;
	}
</script>\n";
		$method = "onsubmit='return Save$formid();'";
		$action = "";
		echo "\n<div class='error' id='error$formid' style='display:none'></div>\n";
		echo "<div class='success' id='success$formid' style='display:none'></div>\n";
	} else {
		$method = "method='$method'";
		$action = "action='$action'";
	}

	echo "\n<form id='$formid' name='$formid' $method $action>\n";
	if ( $savebuttonposition == "both" || $savebuttonposition == "top" ) {
		echo "<button class='savebtn'>$savebuttontext</button>\n";
	}
	foreach ( $fields as $F ) {
		$F["id"]    = isset( $F["id"] ) ? $F["id"] : '';
		$F["value"] = isset( $F["value"] ) ? $F["value"] : '';
		$id         = $F["id"];
		$value      = $F["value"];
		if ( isset( $F["label"] ) ) {
			echo "<label for='$id'>" . $F["label"] . "</label>\n";
		}
		switch ( strtolower( $F["type"] ) ) {
			case "ta":
			case "textarea":
				echo "<textarea name='$id' id='$id'>$value</textarea>\n\n";
				break;
			case "h":
			case "hidden":
				echo "<input type='hidden' name='$id' value='$value' />\n\n";
				break;
			default:
				echo "<input type='text' id='$id' name='$id' value=\"$value\" />\n\n";
				break;

		}
	}
	if ( $savebuttonposition == "both" || $savebuttonposition == "bottom" ) {
		echo "<button class='savebtn'>$savebuttontext</button>\n";
	}
	echo "</form>\n";
}

//if ( ! function_exists( 'mime_content_type' ) ):
//	function mime_content_type( $filename ) {
//		$mime_types = array(
//			'txt'  => 'text/plain',
//			'htm'  => 'text/html',
//			'html' => 'text/html',
//			'php'  => 'text/html',
//			'css'  => 'text/css',
//			'js'   => 'application/javascript',
//			'json' => 'application/json',
//			'xml'  => 'application/xml',
//			'swf'  => 'application/x-shockwave-flash',
//			'flv'  => 'video/x-flv',
//
//			// images
//			'png'  => 'image/png',
//			'jpe'  => 'image/jpeg',
//			'jpeg' => 'image/jpeg',
//			'jpg'  => 'image/jpeg',
//			'gif'  => 'image/gif',
//			'bmp'  => 'image/bmp',
//			'ico'  => 'image/vnd.microsoft.icon',
//			'tiff' => 'image/tiff',
//			'tif'  => 'image/tiff',
//			'svg'  => 'image/svg+xml',
//			'svgz' => 'image/svg+xml',
//
//			// archives
//			'zip'  => 'application/zip',
//			'rar'  => 'application/x-rar-compressed',
//			'exe'  => 'application/x-msdownload',
//			'msi'  => 'application/x-msdownload',
//			'cab'  => 'application/vnd.ms-cab-compressed',
//
//			// audio/video
//			'mp3'  => 'audio/mpeg',
//			'qt'   => 'video/quicktime',
//			'mov'  => 'video/quicktime',
//
//			// adobe
//			'pdf'  => 'application/pdf',
//			'psd'  => 'image/vnd.adobe.photoshop',
//			'ai'   => 'application/postscript',
//			'eps'  => 'application/postscript',
//			'ps'   => 'application/postscript',
//
//			// ms office
//			'doc'  => 'application/msword',
//			'rtf'  => 'application/rtf',
//			'xls'  => 'application/vnd.ms-excel',
//			'ppt'  => 'application/vnd.ms-powerpoint',
//
//			// open office
//			'odt'  => 'application/vnd.oasis.opendocument.text',
//			'ods'  => 'application/vnd.oasis.opendocument.spreadsheet',
//		);
//
//		$ext = strtolower( array_pop( explode( '.', $filename ) ) );
//		if ( array_key_exists( $ext, $mime_types ) ) {
//			return $mime_types[ $ext ];
//		} elseif ( function_exists( 'finfo_open' ) ) {
//			$finfo    = finfo_open( FILEINFO_MIME );
//			$mimetype = finfo_file( $finfo, $filename );
//			finfo_close( $finfo );
//
//			return $mimetype;
//		} else {
//			return 'application/octet-stream';
//		}
//	}
//endif;

function set_defaults( $params, $defaults ) {
	if ( ! is_array( $params ) ) {
		$params = explode( ",", $defaults );
	}
	$new = array();
	foreach ( $defaults as $k => $v ) {
		if ( isset( $params[ $k ] ) ) {
			$new[ $k ] = $params[ $k ];
		} else {
			$new[ $k ] = $v;
		}
	}

	return $new;
}

function get_filename() {
	// This function returns current PHP file name.
	return basename( $_SERVER['PHP_SELF'] );
}

function make_price_ok( $p ) {
	$a1 = array( ",", "_" );
	$a2 = array( "", "" );
	$p  = str_replace( $a1, $a2, $p );
	if ( ! is_numeric( $p ) ) {
		return "0";
	}

	return $p;
}

function run_cron() {
	global $db, $app;

	$Class    = new BatchClass;
	$Students = new Student;
	$Fee      = new Fee;
	$classes  = $Class->get_list();
	foreach ( $classes as $class ) {
		$students = $Students->get_students( "class_id=" . $class["id"] );

	}
}

function get_user_browser() {
	$_SERVER['HTTP_USER_AGENT'] = isset( $_SERVER['HTTP_USER_AGENT'] ) ? $_SERVER['HTTP_USER_AGENT'] : '';
	$u_agent                    = $_SERVER['HTTP_USER_AGENT'];
	$ub                         = '';
	if ( preg_match( '/MSIE/i', $u_agent ) ) {
		$ub = "ie";
	} elseif ( preg_match( '/Firefox/i', $u_agent ) ) {
		$ub = "firefox";
	} elseif ( preg_match( '/Safari/i', $u_agent ) ) {
		$ub = "safari";
	} elseif ( preg_match( '/Chrome/i', $u_agent ) ) {
		$ub = "chrome";
	} elseif ( preg_match( '/Flock/i', $u_agent ) ) {
		$ub = "flock";
	} elseif ( preg_match( '/Opera/i', $u_agent ) ) {
		$ub = "opera";
	}

	return $ub;
}

function debug( $message, $append = true ) {
	if ( is_null( $message ) ) {
		$message = "NULL";
	} else if ( is_bool( $message ) && $message ) {
		$message = "TRUE";
	} else if ( is_bool( $message ) && ! $message ) {
		$message = "FALSE";
	}

	$message              = print_r( $message, true );
	$_SERVER['HTTP_HOST'] = isset( $_SERVER['HTTP_HOST'] ) ? $_SERVER['HTTP_HOST'] : '';
	if ( \General::localhost() ) {
		if ( $append ) {
			file_put_contents( ROOT_PATH . "logs.txt", $message . "\n", FILE_APPEND );
		} else {
			file_put_contents( ROOT_PATH . "logs.txt", $message );
		}
	} else if ( $_SERVER['HTTP_HOST'] == 'ems.ecom.pk' || $_SERVER['HTTP_HOST'] == 'demo1.fekara.com' ) {
		$bt   = debug_backtrace();
		$file = $bt[0]["file"];
		$line = $bt[0]["line"];

		$message .= "<br><br>debug function in file<br><b>" . $file;
		$message .= "GET:<pre>" . print_r( $_GET, true ) . "</pre>";
		$message .= "POST:<pre>" . print_r( $_POST, true ) . "</pre>";
		$message .= "</b><br>Line # <b>" . $line . "</b>\nTime: " . \Dates::my_datetime();

		return send_mail( "shakeel@fekara.com", "Fekara Client Debug", $message );
	}
}

/*function _($phrase) {
	return $phrase;
    if (defined("Language")) $lang=Language;
    else $lang="Default";

    $lang_file = ROOT_PATH."includes/languages/$lang";
    if (!file_exists($lang_file)) return $phrase;
    else {
        $ar = parse_ini_file($lang_file);
        if ( array_key_exists($phrase,$ar)) return $ar[$phrase];
        else return $phrase;
    }
}*/
/*function __( $phrase ) {
	return $phrase;
	if ( defined( "Language" ) ) {
		$lang = Language;
	} else {
		$lang = "Default";
	}

	$lang_file = ROOT_PATH . "includes/languages/$lang";
	if ( ! file_exists( $lang_file ) ) {
		return $phrase;
	} else {
		$ar = parse_ini_file( $lang_file );
		if ( array_key_exists( $phrase, $ar ) ) {
			return $ar[ $phrase ];
		} else {
			return $phrase;
		}
	}
}*/

// Parses a string into a DateTime object, optionally forced into the given timezone.
function parseDateTime( $string, $timezone = null ) {
	if ( is_numeric( $string ) ) {
		$string = date( "d-M-Y H:i", $string );
	}
	$date = new DateTime( $string, $timezone ? $timezone : new DateTimeZone( 'UTC' )
	// Used only when the string is ambiguous.
	// Ignored if string has a timezone offset in it.
	);
	if ( $timezone ) {
		// If our timezone was ignored above, force it.
		$date->setTimezone( $timezone );
	}

	return $date;
}


// Takes the year/month/date values of the given DateTime and converts them to a new DateTime,
// but in UTC.
function stripTime( $datetime ) {
	return new DateTime( $datetime->format( 'Y-m-d' ) );
}

/**
 * @return array|false|string
 * @deprecated - Move function into \General::myip
 */
function myip() {
	if ( getenv( 'HTTP_CLIENT_IP' ) ) {
		$ip = getenv( 'HTTP_CLIENT_IP' );
	} elseif ( getenv( 'HTTP_X_FORWARDED_FOR' ) ) {
		$ip = getenv( 'HTTP_X_FORWARDED_FOR' );
	} elseif ( getenv( 'HTTP_X_FORWARDED' ) ) {
		$ip = getenv( 'HTTP_X_FORWARDED' );
	} elseif ( getenv( 'HTTP_FORWARDED_FOR' ) ) {
		$ip = getenv( 'HTTP_FORWARDED_FOR' );
	} elseif ( getenv( 'HTTP_FORWARDED' ) ) {
		$ip = getenv( 'HTTP_FORWARDED' );
	} else {
		$ip = $_SERVER['REMOTE_ADDR'];
	}

	return $ip;
}

/**
 * @param $string
 *
 * @return mixed
 * @deprecated - Use DB->prepare instead.
 */
function set_string( $string ) {
	return str_replace( "'", "''", trim( $string ) );
}

/**
 * @param        $arr
 * @param string $sep
 *
 * @return array
 * @deprecated - Function moved to \Str::make_array
 */
function make_array( $arr, $sep = "," ) {
	if ( is_array( $arr ) ) {
		return $arr;
	}
	$arr = explode( $sep, $arr );
	$arr = array_map( 'trim', $arr );
	$arr = array_filter( $arr );

	return $arr;
}

function esc_attr( $string ) {
	$string = cleanUTF8( $string );
	$string = htmlspecialchars( $string, ENT_COMPAT, 'UTF-8' );

	return $string;
}

function cleanUTF8( $str, $force_php = false ) {
	// UTF-8 validity is checked since PHP 4.3.5
	// This is an optimization: if the string is already valid UTF-8, no
	// need to do PHP stuff. 99% of the time, this will be the case.
	// The regexp matches the XML char production, as well as well as excluding
	// non-SGML codepoints U+007F to U+009F
	if ( ! is_string( $str ) ) {
		return $str;
	}
	if ( preg_match( '/^[\x{9}\x{A}\x{D}\x{20}-\x{7E}\x{A0}-\x{D7FF}\x{E000}-\x{FFFD}\x{10000}-\x{10FFFF}]*$/Du', $str ) ) {
		return $str;
	}

	$mState = 0; // cached expected number of octets after the current octet
	// until the beginning of the next UTF8 character sequence
	$mUcs4  = 0; // cached Unicode character
	$mBytes = 1; // cached expected number of octets in the current sequence

	// original code involved an $out that was an array of Unicode
	// codepoints.  Instead of having to convert back into UTF-8, we've
	// decided to directly append valid UTF-8 characters onto a string
	// $out once they're done.  $char accumulates raw bytes, while $mUcs4
	// turns into the Unicode code point, so there's some redundancy.

	$out  = '';
	$char = '';

	$len = strlen( $str );
	for ( $i = 0; $i < $len; $i ++ ) {
		$in   = ord( $str{$i} );
		$char .= $str[ $i ]; // append byte to char
		if ( 0 == $mState ) {
			// When mState is zero we expect either a US-ASCII character
			// or a multi-octet sequence.
			if ( 0 == ( 0x80 & ( $in ) ) ) {
				// US-ASCII, pass straight through.
				if ( ( $in <= 31 || $in == 127 ) && ! ( $in == 9 || $in == 13 || $in == 10 ) // save \r\t\n
				) {
					// control characters, remove
				} else {
					$out .= $char;
				}
				// reset
				$char   = '';
				$mBytes = 1;
			} elseif ( 0xC0 == ( 0xE0 & ( $in ) ) ) {
				// First octet of 2 octet sequence
				$mUcs4  = ( $in );
				$mUcs4  = ( $mUcs4 & 0x1F ) << 6;
				$mState = 1;
				$mBytes = 2;
			} elseif ( 0xE0 == ( 0xF0 & ( $in ) ) ) {
				// First octet of 3 octet sequence
				$mUcs4  = ( $in );
				$mUcs4  = ( $mUcs4 & 0x0F ) << 12;
				$mState = 2;
				$mBytes = 3;
			} elseif ( 0xF0 == ( 0xF8 & ( $in ) ) ) {
				// First octet of 4 octet sequence
				$mUcs4  = ( $in );
				$mUcs4  = ( $mUcs4 & 0x07 ) << 18;
				$mState = 3;
				$mBytes = 4;
			} elseif ( 0xF8 == ( 0xFC & ( $in ) ) ) {
				// First octet of 5 octet sequence.
				//
				// This is illegal because the encoded codepoint must be
				// either:
				// (a) not the shortest form or
				// (b) outside the Unicode range of 0-0x10FFFF.
				// Rather than trying to resynchronize, we will carry on
				// until the end of the sequence and let the later error
				// handling code catch it.
				$mUcs4  = ( $in );
				$mUcs4  = ( $mUcs4 & 0x03 ) << 24;
				$mState = 4;
				$mBytes = 5;
			} elseif ( 0xFC == ( 0xFE & ( $in ) ) ) {
				// First octet of 6 octet sequence, see comments for 5
				// octet sequence.
				$mUcs4  = ( $in );
				$mUcs4  = ( $mUcs4 & 1 ) << 30;
				$mState = 5;
				$mBytes = 6;
			} else {
				// Current octet is neither in the US-ASCII range nor a
				// legal first octet of a multi-octet sequence.
				$mState = 0;
				$mUcs4  = 0;
				$mBytes = 1;
				$char   = '';
			}
		} else {
			// When mState is non-zero, we expect a continuation of the
			// multi-octet sequence
			if ( 0x80 == ( 0xC0 & ( $in ) ) ) {
				// Legal continuation.
				$shift = ( $mState - 1 ) * 6;
				$tmp   = $in;
				$tmp   = ( $tmp & 0x0000003F ) << $shift;
				$mUcs4 |= $tmp;

				if ( 0 == -- $mState ) {
					// End of the multi-octet sequence. mUcs4 now contains
					// the final Unicode codepoint to be output

					// Check for illegal sequences and codepoints.

					// From Unicode 3.1, non-shortest form is illegal
					if ( ( ( 2 == $mBytes ) && ( $mUcs4 < 0x0080 ) ) || ( ( 3 == $mBytes ) && ( $mUcs4 < 0x0800 ) ) || ( ( 4 == $mBytes ) && ( $mUcs4 < 0x10000 ) ) || ( 4 < $mBytes ) || // From Unicode 3.2, surrogate characters = illegal
					     ( ( $mUcs4 & 0xFFFFF800 ) == 0xD800 ) || // Codepoints outside the Unicode range are illegal
					     ( $mUcs4 > 0x10FFFF ) ) {

					} elseif ( 0xFEFF != $mUcs4 && // omit BOM
					           // check for valid Char unicode codepoints
					           ( 0x9 == $mUcs4 || 0xA == $mUcs4 || 0xD == $mUcs4 || ( 0x20 <= $mUcs4 && 0x7E >= $mUcs4 ) || // 7F-9F is not strictly prohibited by XML,
					             // but it is non-SGML, and thus we don't allow it
					             ( 0xA0 <= $mUcs4 && 0xD7FF >= $mUcs4 ) || ( 0x10000 <= $mUcs4 && 0x10FFFF >= $mUcs4 ) ) ) {
						$out .= $char;
					}
					// initialize UTF8 cache (reset)
					$mState = 0;
					$mUcs4  = 0;
					$mBytes = 1;
					$char   = '';
				}
			} else {
				// ((0xC0 & (*in) != 0x80) && (mState != 0))
				// Incomplete multi-octet sequence.
				// used to result in complete fail, but we'll reset
				$mState = 0;
				$mUcs4  = 0;
				$mBytes = 1;
				$char   = '';
			}
		}
	}

	return $out;
}

function is_paid_fekara() {
	if ( ! is_file( ROOT_PATH . "key" ) ) {
		return false;
	}

	$__key         = file_get_contents( ROOT_PATH . "key" );
	$__decoded_key = decode_key( $__key );

	return ! empty( $__decoded_key["domain"] );
}

function curl_get_file_contents( $URL ) {
	set_time_limit( 0 );

	$c = curl_init();
	curl_setopt( $c, CURLOPT_RETURNTRANSFER, 1 );
	curl_setopt( $c, CURLOPT_URL, $URL );
	curl_setopt( $c, CURLOPT_CONNECTTIMEOUT, 0 );
	curl_setopt( $c, CURLOPT_TIMEOUT, 999999999999 );

	$contents = curl_exec( $c );
	curl_close( $c );

	if ( $contents ) {
		return $contents;
	} else {
		return false;
	}
}

function update_me() {
	global $db;
	$url = DOMAIN_URL . "6111977?update&pk=" . $db->get_option( "process_key" );
	echo $url;
	//file_get_contents()
}

function get_latest_version() {
	if ( \General::localhost() ) {
		$url = "http://shakeel.com/fekara_management/?get_version";
	} else {
		$url = "http://app.fekara.com/?get_version";
	}

	$current_version = curl_get_file_contents( $url );
	$current_version = trim( $current_version );

	return $current_version;
}

function set_cookie( $key, $value, $expire = "" ) {
	if ( $expire == "" ) {
		$expire = strtotime( "+100 Days" );
	}

	$domain = $_SERVER['HTTP_HOST'];
	$domain = str_replace( "www.", "", $domain );

	return @setcookie( $key, $value, $expire, "/", $domain );
}

function remove_cookie( $key ) {
	$domain = $_SERVER['HTTP_HOST'];
	$domain = str_replace( "www.", "", $domain );

	unset( $_COOKIE[ $key ] );

	return @setcookie( $key, null, - 1, "/", $domain );
}

function get_mysql_tablename( $table ) {
	$table = trim( $table );
	switch ( strtolower( $table ) ) {
		case "student":
		case "students":
			return "students";
	}
}

function filename( $full = false ) {
	$bt   = debug_backtrace();
	$file = $bt[0]["file"];
	if ( ! $full ) {
		return basename( $file );
	} else {
		return $file;
	}
}

function globistr( $string = '', $mbEncoding = ''/*optional e.g.'UTF-8'*/ ) {
	//returns a case insensitive Version of the searchPattern for glob();
	// e.g.: globistr('./*.jpg') => './*.[jJ][pP][gG]'
	// e.g.: glob(dirname(__FILE__).'/'.globistr('*.jpg')) => '/.../*.[jJ][pP][gG]'

	// known problems: globistr('./[abc].jpg') => FALSE:'./[[aA][bB][cC]].[jJ][pP][gG]'
	//(Problem: existing Pattern[abc] will be overwritten)
	// known solution: './[abc].'.globistr('jpg') => RIGHT: './[abc].[jJ][pP][gG]'
	//(Solution: globistr() only caseSensitive Part, not everything)
	$return = "";
	if ( $mbEncoding !== '' ) { //multiByte Version
		$string = mb_convert_case( $string, MB_CASE_LOWER, $mbEncoding );
	} else { //standard Version (not multiByte,default)
		$string = strtolower( $string );
	}
	$mystrlen = strlen( $string );
	for ( $i = 0; $i < $mystrlen; $i ++ ) {
		if ( $mbEncoding !== '' ) {//multiByte Version
			$myChar = mb_substr( $string, $i, 1, $mbEncoding );
			//$myUpperChar = mb_strtoupper($myChar,$mbEncoding);
			$myUpperChar = mb_convert_case( $myChar, MB_CASE_UPPER, $mbEncoding );
		} else {
			$myChar      = substr( $string, $i, 1 );
			$myUpperChar = strtoupper( $myChar );
		}
		if ( $myUpperChar !== $myChar ) { //there is a lower- and upperChar, / Char is case sentitive
			$return .= '[' . $myChar . $myUpperChar . ']'; //adding both Versions : [xX]
		} else {//only one case Version / Char is case insentitive
			$return .= $myChar; //adding '1','.','*',...
		}
	}

	return $return;
}

function human_time_difference2( $time1, $time2 = "" ) {
	if ( $time1 == "0000-00-00 00:00:00" || $time2 == "0000-00-00 00:00:00" || $time1 == "" ) {
		return "";
	}
	if ( $time2 == "" ) {
		$time2 = time();
	} else {
		$time2 = strtotime( $time2 );
	}
	$time1 = strtotime( $time1 );

	$diff = $time2 - $time1;
	if ( $diff < 86400 ) {
		return date( "h:i A", $time1 );
	} else {
		return date( "d-M", $time1 );
	}
}

function get_student_panel_url() {
	return DOMAIN_URL . "students/";
}

function get_teacher_panel_url() {
	return DOMAIN_URL . "teacher/";
}

function get_guardian_panel_url() {
	return DOMAIN_URL . "guardians/";
}

function bytes_format( $size ) {
	$filesizename = [ " Bytes", " KB", " MB", " GB", " TB", " PB", " EB", " ZB", " YB" ];

	return $size ? round( $size / pow( 1024, ( $i = floor( log( $size, 1024 ) ) ) ), 2 ) . $filesizename[ $i ] : '0 Bytes';
}

/*function is_404( $url ) {
	$handle = curl_init( $url );
	curl_setopt( $handle, CURLOPT_RETURNTRANSFER, true );

	// Get the HTML or whatever is linked in $url.
	$response = curl_exec( $handle );

	// Check for 404 (file not found).
	$httpCode = curl_getinfo( $handle, CURLINFO_HTTP_CODE );
	curl_close( $handle );

	//If the document has loaded successfully without any redirection or error
	if ( $httpCode >= 200 && $httpCode < 300 ) {
		return false;
	} else {
		return true;
	}
}*/

function show_expire_message() {
	global $soon_expire;
	if ( $soon_expire ) { ?>
		<div style="position: fixed;top:42px;z-index: 9999999999999999;background-color: #c00;color:#fff;width:100%;padding:10px;" id="TTT">
			<i title="Close" onclick="$('#TTT').remove();" class="pull-right fa fa-times href"></i>
			<?php echo __( "Your license will expire on <b>%1</b>, Please renew your license to avoid interruption.", \Dates::my_date( $soon_expire ) ) ?>
		</div>
	<?php }
}

function add_leading_zeros( $number, $zeros = 2 ) {
	if ( strlen( $number ) < $zeros ) {
		return str_repeat( "0", ( $zeros - strlen( $number ) ) ) . $number;
	}

	return $number;
}

function load_css_files() {
	$url = new Urls();
	if ( \General::is_offline() ) { ?>
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/3.0.3/css/bootstrap.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/datatables/1.10.10/css/jquery.dataTables.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/datatables/1.10.10/css/dataTables.bootstrap.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/Uniform.js/4.2.0/css/default.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/2.0.1/css/toastr.min.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-fileupload/bootstrap-fileupload.css">
		<!--<link rel="stylesheet" type="text/css" href="<?php /*echo ASSETS_URL */ ?>plugins/gritter/css/jquery.gritter.css">-->
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/select2/select2_metro.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/clockface/css/clockface.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap3-wysiwyg/0.3.3/bootstrap3-wysihtml5.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/fancybox/2.1.7/css/jquery.fancybox.min.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>added_plugins/summernote/summernote.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>added_plugins/bootstrap-datepicker-1.7.1/css/bootstrap-datepicker.min.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-timepicker/compiled/timepicker.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-colorpicker/css/colorpicker.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-daterangepicker/daterangepicker-bs3.min.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-datetimepicker/css/datetimepicker.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/jquery-multi-select/css/multi-select.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-switch/static/stylesheets/bootstrap-switch-metro.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/jquery-tags-input/jquery.tagsinput.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-markdown/css/bootstrap-markdown.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.28.0/codemirror.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.28.0/addon/hint/show-hint.min.css">
	<?php } else { ?>
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/pace/1.0.2/themes/black/pace-theme-bounce.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/3.0.3/css/bootstrap.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/datatables/1.10.10/css/jquery.dataTables.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/datatables/1.10.10/css/dataTables.bootstrap.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/Uniform.js/4.2.0/css/default.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/2.0.1/css/toastr.min.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-fileupload/bootstrap-fileupload.css">
		<!--<link rel="stylesheet" type="text/css" href="<?php /*echo ASSETS_URL */ ?>plugins/gritter/css/jquery.gritter.css">-->
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/select2/select2_metro.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/clockface/css/clockface.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap3-wysiwyg/0.3.3/bootstrap3-wysihtml5.min.css">
		<!--<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.1.20/jquery.fancybox.min.css">-->
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/fancybox/2.1.7/css/jquery.fancybox.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.7.1/css/bootstrap-datepicker.min.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-timepicker/compiled/timepicker.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-colorpicker/2.0.1/css/bootstrap-colorpicker.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-daterangepicker/1.2/daterangepicker-bs3.min.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-datetimepicker/css/datetimepicker.css">
		<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/jquery-multi-select/css/multi-select.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-switch/1.8/css/bootstrap-switch.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/jquery-tagsinput/1.3.3/jquery.tagsinput.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-markdown/2.1.0/css/bootstrap-markdown.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.28.0/codemirror.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.28.0/addon/hint/show-hint.min.css">
		<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/summernote/0.8.6/summernote.css">
		<?php
		$Trans = new \Translation();
		if ( $Trans->get_language() == 'ur' ) { ?>
			<!--			<link rel="stylesheet" href="//fonts.googleapis.com/earlyaccess/notonastaliqurdudraft.css">-->
			<!--			<link href="https://fonts.googleapis.com/css?family=Markazi+Text:400,500,600,700&amp;subset=arabic,latin-ext,vietnamese" rel="stylesheet">-->
			<!--			<link href="https://fonts.googleapis.com/css?family=Aref+Ruqaa:400,700&amp;subset=arabic" rel="stylesheet">-->
			<link href="https://fonts.googleapis.com/css?family=Mada:200,300,400,500,600,700,900&amp;subset=arabic" rel="stylesheet">
		<?php } ?>
	<?php } ?>
	<link rel="stylesheet" href="<?php echo ASSETS_URL ?>tablesaw/tablesaw.css">
	<link href="<?php echo ASSETS_URL ?>css/style-metronic.css" rel="stylesheet" type="text/css">
	<link href="<?php echo ASSETS_URL ?>css/style.min.css?<?php echo md5_file( ASSETS_PATH . "css/style.css" ) ?>" rel="stylesheet" type="text/css">
	<link href="<?php echo ASSETS_URL ?>css/style-responsive.min.css?<?php echo md5_file( ASSETS_PATH . 'css/style-responsive.min.css' ) ?>" rel="stylesheet" type="text/css">
	<link href="<?php echo ASSETS_URL ?>css/plugins.css" rel="stylesheet" type="text/css">
	<link href="<?php echo ASSETS_URL ?>css/themes/default.css" rel="stylesheet" type="text/css" id="style_color">
	<link href="<?php echo ASSETS_URL ?>css/pages/error.css" rel="stylesheet" type="text/css">

	<link rel="stylesheet" href="<?php echo ASSETS_URL ?>plugins/jquery-ui/jquery-ui-1.10.3.custom.min.css">
	<link rel="stylesheet" href="<?php echo ASSETS_URL ?>plugins/bootstrap-datetimepicker/css/datetimepicker.css">

	<link href="<?php echo ASSETS_URL ?>css/custom.css?<?php echo md5_file( ASSETS_PATH . "css/custom.css" ) ?>" rel="stylesheet" type="text/css">
	<link href="<?php echo \Theme::url(); ?>style.min.css?<?php echo md5_file( \Theme::path() . "style.min.css" ) ?>" rel="stylesheet" type="text/css">
	<?php
}

function load_js_files() {
	global $includeMe;

	$url = new Urls();
	if ( \General::is_offline() ) { ?>
		<!--[if lt IE 9]>
		<script src="<?php echo DOMAIN_URL ?>assets/plugins/respond.min.js"></script>
		<script src="<?php echo DOMAIN_URL ?>assets/plugins/excanvas.min.js"></script>
		<![endif]-->
		<script src="<?php echo ASSETS_URL ?>added_plugins/jquery-3.2.1.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>added_plugins/jquery-migrate.3.0.0.min.js"></script>

		<?php if ( $includeMe == "manage_holidays.php" ): ?>
			<!--<script src="<?php /*echo ASSETS_URL */ ?>plugins/jquery-ui/jquery-ui-1.10.3.custom.js"></script>-->
		<?php endif; ?>

		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap/js/bootstrap.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-hover-dropdown/twitter-bootstrap-hover-dropdown.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/jquery-slimscroll/jquery.slimscroll.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/jquery.blockui.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/jquery.cokie.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/uniform/jquery.uniform.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootbox/bootbox.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/data-tables/jquery.dataTables.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/data-tables/DT_bootstrap.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/fuelux/js/spinner.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/ckeditor/4.2/ckeditor.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-fileupload/bootstrap-fileupload.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/select2/select2.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-wysihtml5/wysihtml5-0.3.0.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-wysihtml5/bootstrap-wysihtml5.js"></script>
		<script src="<?php echo ASSETS_URL ?>added_plugins/bootstrap-datepicker-1.7.1/js/bootstrap-datepicker.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-datetimepicker/js/bootstrap-datetimepicker.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/clockface/js/clockface.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-daterangepicker/moment.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-daterangepicker/daterangepicker.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-colorpicker/js/bootstrap-colorpicker.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-timepicker/js/bootstrap-timepicker.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/jquery-inputmask/jquery.inputmask.bundle.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/jquery.input-ip-address-control-1.0.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/jquery-multi-select/js/jquery.multi-select.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/jquery-multi-select/js/jquery.quicksearch.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/jquery.pwstrength.bootstrap/src/pwstrength.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-switch/static/js/bootstrap-switch.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/jquery-tags-input/jquery.tagsinput.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-markdown/js/bootstrap-markdown.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-markdown/lib/markdown.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-maxlength/bootstrap-maxlength.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-touchspin/bootstrap.touchspin.js"></script>
		<script src="<?php echo ASSETS_URL ?>added_plugins/jquery-validation-1.16.0/dist/jquery.validate.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>added_plugins/jquery-validation-1.16.0/dist/additional-methods.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-wizard/jquery.bootstrap.wizard.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/jquery.mockjax.js"></script>
		<script src="<?php echo ASSETS_URL ?>added_plugins/summernote/summernote.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-editable/bootstrap-editable/js/bootstrap-editable.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/jquery-editable-address/address.js"></script>
		<script src="<?php echo \Theme::url() ?>js/jquery.scrollTo-min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-toastr/toastr.min.js"></script>
		<script src="<?php echo \Theme::url() ?>js/jquery.hotkeys.js"></script>
		<?php if ( $includeMe == "manage_holidays.php" ): ?>
			<script src="<?php echo ASSETS_URL ?>plugins/fullcalendar/fullcalendar/fullcalendar.min.js"></script>
		<?php endif; ?>
		<script src="<?php echo ASSETS_URL ?>plugins/jquery-ui/jquery-ui-1.10.3.custom.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>added_plugins/fancybox-2.1.7/source/jquery.fancybox.pack.js"></script>
		<script src="<?php echo ASSETS_URL ?>added_plugins/fancybox-2.1.7/source/helpers/jquery.fancybox-buttons.js"></script>
		<script src="<?php echo ASSETS_URL ?>added_plugins/fancybox-2.1.7/source/helpers/jquery.fancybox-media.js"></script>
		<script src="<?php echo ASSETS_URL ?>added_plugins/fancybox-2.1.7/source/helpers/jquery.fancybox-thumbs.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/codemirror/codemirror.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/codemirror/mode/css/css.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/codemirror/addon/hint/show-hint.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/codemirror/addon/hint/css-hint.js"></script>
		<script src="<?php echo ASSETS_URL ?>scripts/jquery.are-you-sure.js"></script>
		<script src="<?php echo ASSETS_URL ?>added_plugins/jQuery.print.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>added_plugins/jquery.form.min.js"></script>
	<?php } else { ?>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/pace/1.0.2/pace.min.js"></script>
		<!--[if lt IE 9]>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/respond.js/1.4.2/respond.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/excanvas.min.js"></script>
		<![endif]-->
		<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-migrate/3.0.0/jquery-migrate.min.js"></script>

		<script src="https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.10.3/jquery-ui.min.js"></script>

		<script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/3.0.3/js/bootstrap.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-hover-dropdown/2.2.1/bootstrap-hover-dropdown.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/jQuery-slimScroll/1.3.8/jquery.slimscroll.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.blockUI/2.70/jquery.blockUI.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-cookie/1.4.1/jquery.cookie.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/Uniform.js/4.2.0/js/jquery.uniform.standalone.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/bootbox.js/4.4.0/bootbox.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/datatables/1.10.10/js/jquery.dataTables.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/datatables/1.10.10/js/dataTables.bootstrap.min.js"></script>
		<!--<script src="<?php /*echo DOMAIN_URL */ ?>assets/plugins/data-tables/DT_bootstrap.js"></script>-->
		<!--<script src="https://cdnjs.cloudflare.com/ajax/libs/fuelux/2.3.1/loader.min.js"></script>-->
		<script src="<?php echo ASSETS_URL ?>plugins/fuelux/js/spinner.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/ckeditor/4.2/ckeditor.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-fileupload/bootstrap-fileupload.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/select2/3.4.8/select2.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/wysihtml5/0.3.0/wysihtml5.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap3-wysiwyg/0.3.3/bootstrap3-wysihtml5.all.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.7.1/js/bootstrap-datepicker.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-datetimepicker/js/bootstrap-datetimepicker.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/clockface/js/clockface.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.18.1/moment.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-daterangepicker/1.2/daterangepicker.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-colorpicker/2.0.1/js/bootstrap-colorpicker.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-timepicker/js/bootstrap-timepicker.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.inputmask/2.2.39/jquery.inputmask.bundle.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/jquery.input-ip-address-control-1.0.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/jquery-multi-select/js/jquery.multi-select.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/jquery-multi-select/js/jquery.quicksearch.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/pwstrength-bootstrap/2.1.0/pwstrength-bootstrap.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-switch/1.8/js/bootstrap-switch.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-tagsinput/1.3.3/jquery.tagsinput.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-markdown/2.1.0/js/bootstrap-markdown.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-markdown/lib/markdown.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-maxlength/1.4.2/bootstrap-maxlength.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-touchspin/3.0.0/jquery.bootstrap-touchspin.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.16.0/jquery.validate.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.16.0/additional-methods.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap-wizard/1.0/jquery.bootstrap.wizard.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-mockjax/1.5.0/jquery.mockjax.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-editable/bootstrap-editable/js/bootstrap-editable.min.js"></script>
		<script src="<?php echo ASSETS_URL ?>plugins/jquery-editable-address/address.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/summernote/0.8.6/summernote.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-scrollTo/1.4.11/jquery.scrollTo.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/toastr.js/2.1.3/toastr.min.js"></script>
		<script src="<?php echo \Theme::url() ?>js/jquery.hotkeys.js"></script>
		<?php if ( isset( $_GET["serve_data"] ) && $_GET["serve_data"] == "manage_holidays" ): ?>
			<script src="https://cdnjs.cloudflare.com/ajax/libs/fullcalendar/1.6.1/fullcalendar.min.js"></script>
		<?php endif; ?>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/fancybox/2.1.7/js/jquery.fancybox.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.28.0/codemirror.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.28.0/mode/css/css.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.28.0/addon/hint/show-hint.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.28.0/addon/hint/css-hint.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.AreYouSure/1.9.0/jquery.are-you-sure.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/jQuery.print/1.5.1/jQuery.print.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/stickybits/3.2.4/stickybits.min.js" integrity="sha256-p6iXPtOSxihmWoPYMNg/cyaIVk5mtnrkSY/wI+O+hQo=" crossorigin="anonymous"></script>

		<!-- https://github.com/jquery-form/form -->
		<!-- http://malsup.com/jquery/form/ -->
		<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.form/4.2.2/jquery.form.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/mark.js/8.11.1/jquery.mark.min.js" integrity="sha256-4HLtjeVgH0eIB3aZ9mLYF6E8oU5chNdjU6p6rrXpl9U=" crossorigin="anonymous"></script>
	<?php } ?>
	<script src="<?php echo ASSETS_URL ?>scripts/app.js"></script>
	<script src="<?php echo ASSETS_URL ?>scripts/table-managed.js"></script>
	<script src="<?php echo ASSETS_URL ?>scripts/form-components.js"></script>
	<script src="<?php echo ASSETS_URL ?>scripts/ui-extended-modals.js"></script>
	<script src="<?php echo ASSETS_URL ?>tablesaw/tablesaw.jquery.js"></script>
	<script src="<?php echo ASSETS_URL ?>tablesaw/tablesaw-init.js"></script>
	<script src="<?php echo ASSETS_URL ?>scripts/jquery.are-you-sure.js"></script>
	<script src="<?php echo ASSETS_URL ?>scripts/ays-beforeunload-shim.js"></script>
	<script src="<?php echo ASSETS_URL ?>custom.min.js?<?php echo md5_file( ASSETS_PATH . "custom.js" ) ?>"></script>
	<?php

	global $db;
	if ( $db->get_option( "ignore_new_version" ) <> "1" && $db->get_option( "new_version_available" ) == "1" ) { ?>
		<div id="show_on_top" style="text-align:center">
			<button title="Close" class="btn btn-xs red pull-right" id="close_show_on_top_btn">
				<i class="fa fa-times"></i></button>
			New version available<br><a href="<?php DOMAIN_URL ?>?update_me">Click here to update Fekara</a>
			<br><br>
			<div class="btn-group">
				<button id="ignore_update_btn" class="btn btn-sm red">Ignore this update</button>
			</div>
		</div>
	<?php }
}

function executing_filename() {
	if ( isset( $_SERVER["SCRIPT_FILENAME"] ) ) {
		$filename = basename( $_SERVER["SCRIPT_FILENAME"] );
	} else if ( isset( $_SERVER["PHP_SELF"] ) ) {
		$filename = basename( $_SERVER["PHP_SELF"] );
	} else if ( isset( $_SERVER["SCRIPT_NAME"] ) ) {
		$filename = basename( $_SERVER["SCRIPT_NAME"] );
	} else if ( isset( $_SERVER["REQUEST_URI"] ) ) {
		$filename = basename( $_SERVER["REQUEST_URI"] );
	} else {
		$filename = "";
	}

	return $filename;
}

function get_pagination_string( $start, $end, $selected, $total_page = 0 ) {
	$btn_class     = "btn-sm";
	$output_string = "";

	if ( $selected > 1 ) {
		$p             = $selected - 1;
		$output_string .= "<button title='Goto previous' data-placement='right' style='margin: 0;' id='btn_previous' class='btn $btn_class green'><i class='fa fa-chevron-left'></i></button>";
	}
	if ( $start > 1 ) {
		$output_string .= "<button title='Goto first page' data-placement='right' style='margin: 0;' class='btn_page btn $btn_class green'>1</button> .. ";
	}
	$output_string .= "<div class='btn-group btn-group-solid'>";
	for ( $x = $start; $x <= $end; $x ++ ) {
		if ( $x == $selected ) {
			$class = "active";
		} else {
			$class = "green";
		}
		$output_string .= "<button style='margin: 0;' class='btn_page btn $btn_class $class'>$x</button> ";
	}

	$output_string .= "</div>";
	if ( $total_page > 0 && $end < $total_page ) {
		$output_string .= " .. <button data-placement='left' title='Goto last page' style='margin: 0;' class='btn_page btn $btn_class green'>$total_page</button>";
	}
	if ( $selected < $total_page ) {
		$p             = $selected + 1;
		$output_string .= "<button title='Goto next' data-placement='right' style='margin: 0;' id='btn_next' class='btn $btn_class green'><i class='fa fa-chevron-right'></i></button>";
	}
	$output_string .= " ";

	return $output_string;
}

/**
 * @param $get
 *
 * @return string
 * @deprecated This function is not used anymore.
 */
function http_build_query_x( $get ) {
	if ( isset( $get["serve_data"] ) ) {
		unset( $get["serve_data"] );
	}

	return http_build_query( $get );
}

/**
 * @param     $permission
 * @param int $user_id
 *
 * @return bool
 *
 * Check if specified permission is allowed to this user.
 */
function is_allowed( $permission, $user_id = 0 ) {
	return \Admins\UserInfo::is_allowed( $permission, $user_id );
}

/**
 * @author      Shakeel Ahmed Siddiqi <shakeel@shakeel.pk>
 *
 * @param $time
 *
 * @return int
 *
 * Converts time into seconds.
 * Example: 15:03 will output to 54180
 * @deprecated  - Moved in \Dates::
 */
function time_to_sec( $time ) {
	$seconds = strtotime( "1970-01-01 $time UTC" );

	return $seconds;
}

function formatize_phone_number( $phone_number, $region_code = '' ) {
	if ( empty( $region_code ) ) {
		global $db;
		$region_code = $db->get_option( "default_phone_country" );
		if ( empty( $region_code ) ) {
			$region_code = 'PK';
		}
	}

	$phone_number = filter_var( $phone_number, FILTER_SANITIZE_NUMBER_INT );
	if ( empty( $phone_number ) ) {
		return '';
	}
	$phoneNumberUtil = \libphonenumber\PhoneNumberUtil::getInstance();

	$phoneNumberObject = $phoneNumberUtil->parse( $phone_number, $region_code );

	return $phoneNumberUtil->format( $phoneNumberObject, 1 );
}

/**
 * @param        $phone_number
 * @param string $region_code
 *
 * @return bool
 * @throws \libphonenumber\NumberParseException
 * @deprecated  - Moved in Str::
 */
function is_phone( $phone_number, $region_code = '' ) {
	if ( empty( $region_code ) ) {
		global $db;
		$region_code = $db->get_option( "default_phone_country" );
		if ( empty( $region_code ) ) {
			$region_code = 'PK';
		}
	}
	// https://github.com/giggsey/libphonenumber-for-php
	$phoneNumberUtil = libphonenumber\PhoneNumberUtil::getInstance();

	$phoneNumberObject = $phoneNumberUtil->parse( $phone_number, $region_code );

	return $phoneNumberUtil->isValidNumber( $phoneNumberObject );
}

/**
 * @param $ip_addr
 *
 * @return bool
 * @deprecated  - Moved to \Str::is_ip
 */
function is_ip( $ip_addr ) {
	//first of all the format of the ip address is matched
	if ( preg_match( "/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/", $ip_addr ) ) {
		//now all the intger values are separated
		$parts = explode( ".", $ip_addr );
		//now we need to check each part can range from 0-255
		foreach ( $parts as $ip_parts ) {
			if ( intval( $ip_parts ) > 255 || intval( $ip_parts ) < 0 ) {
				return false;
			} //if number is not within range of 0-255
		}

		return true;
	} else {
		return false;
	} //if format of ip address doesn't matches
}

/**
 * @return bool
 *
 * Check if user is logged in or not.
 * @deprecated - Function moved to \Admins\UserInfo::is_loggedin();
 */
function is_admin() {
	// Is admin user logged in or not.

	if ( ! isset( $_SESSION[ \Admins\UserInfo::get_system_var() ] ) && isset( $_COOKIE[ \Admins\UserInfo::get_system_var() ] ) ) {
		$id = $_COOKIE[ \Admins\UserInfo::get_system_var() ];
		$id = (int) $id;
		if ( ! empty( $id ) ) {
			$row = \Admins\UserInfo::get_admin_row( "id=$id" );
			if ( isset( $row['id'] ) && $row['id'] == $id ) {
				$_SESSION[ \Admins\UserInfo::get_system_var() ] = $row;
				set_cookie( \Admins\UserInfo::get_system_var(), $id );

				global $db;
				$options_table = $db->options_table_array();
			}
		}
	}

	if ( ! isset( $_SESSION[ \Admins\UserInfo::get_system_var() ] ) ) {
		return false;
	} else {
		global $db;
		$v       = \Admins\UserInfo::get_system_var();
		$row     = isset( $_SESSION[ $v ] ) ? $_SESSION[ $v ] : '';
		$rowlive = $db->select_cols( 'password,active' )->where( 'id', $row["id"] )->get_row( 'admins' );

		if ( ! is_array( $rowlive ) || ! isset( $rowlive["password"] ) ) {
			return false;
		} else if ( $rowlive["password"] <> $row["password"] ) {
			return false;
		} else if ( $rowlive["active"] <> "1" ) {
			return false;
		} else {
			return true;
		}
	}
}


/**
 * @param        $field_name
 * @param string $default
 *
 * @return bool|mixed|null|string
 * @deprecated
 */
function get_option( $field_name, $default = "" ) {
	global $db;

	return $db->get_option( $field_name, $default );
}

/**
 * @return bool
 * @deprecated - \General::is_offline()
 */
function is_offline() {
	return is_file( ROOT_PATH . ".offline" );
}

/**
 * @param $Q
 *
 * @return null|string
 * @deprecated - Use DB::get_var instead
 */
function get_var( $Q ) {
	global $db;

	return $db->get_var( $Q );
}

/**
 * @param string $date
 * @param string $format
 *
 * @return false|string
 * @deprecated
 */
function my_datetime( $date = '', $format = "d-M-Y H:i" ) {
	return \Dates::my_datetime( $date, $format );
}