<script type="text/x-tmpl" id="shifts_template">
	<div class="row">
		<div class="col-sm-6">
			<?php _e("Total") ?>: <span id="total_shifts">{%= o.total_records %}</span>
		</div>
		<div class="col-sm-6 right">
			<div class="btn-group">
				<button class="btn btn-xs green" onclick="$('#add_shift_form').show(); $('#add_shift_form').trigger('reset');"><?php _e("Add Shift") ?></button>
				<button class="btn btn-xs red" title="Close" onclick="$.fancybox.close()">X</button>
			</div>
		</div>
	</div><br>

	<form style="margin:auto;display:none" id="add_shift_form">
	<table>
		<tr>
			<td><?php _e("Shift Name") ?></td>
			<td><?php _e("Start Time") ?></td>
			<td><?php _e("End Time") ?></td>
			<td></td>
		</tr>
		<tr>
			<td><input required="required" name="shift_name" placeholder="e.g. Shift1" class="input-sm"></td>
			<td><input required="required" name="start_time" placeholder="Start Time" class="input-sm" type="time"></td>
			<td><input required="required" name="end_time" placeholder="End Time" class="input-sm" type="time"></td>
			<td>
				<div class="btn-group">
					<button type="submit" class="btn btn-primary"><?php _e("Save") ?></button>
					<button type="button" onclick="$('#add_shift_form').hide();" class="btn red"><?php _e("Cancel") ?></button>
				</div>
				<i id="shift_save_loader" class="hidden fa fa-spinner fa-spin"></i>
			</td>
		</tr>
	</table>
	</form>

	<div style="max-height:400px;overflow-y:auto;overflow-x:hidden">
		<table class="table table-bordered table-striped" id="shifts_table">
			<thead><tr class="heading"><th>ID</th><th>Name</th><th>Time</th><th>Used In</th><th></th></tr></thead>
			<tbody>
			{% for (var i=0; i<count(o.rows); i++) { %}
				<tr id="tr_{%=o.rows[i].id%}">
					<td>
						<span title="Drag to set orders for shifts" class="handle"><i class="fa fa-bars"></i></span>
						{%=o.rows[i].id%}
					</td>
					<td>{%=o.rows[i].shift_name%}</td>
					<td>{%=o.rows[i].start_time%} - {%=o.rows[i].end_time%}</td>
					<td>0</td>
					<td style="text-align:right !important;width:10px;">
						<button data-id="{%=o.rows[i].id%}" class="btn btn-xs red del_shift_btn"><i class="fa fa-trash"></i> <?php _e("Delete") ?></button>
					</td>
				</tr>
			{% } %}
			</tbody>
		</table>
	</div>
</script>
<script type="text/x-tmpl" id="save_time_table_template">
    <div class="form-group">
        <div class="row">
            <label class="col-md-4 control-label" style="text-align:right">
                <span class="fa-blink font-red" id="teacher_blink">Select Class <i class="fa fa-long-arrow-right"></i></span>
            </label>
            <div class="col-md-6">
                {% include('classes_template', Classes); %}
            </div>
            <div class="col-md-2">
                <span style="display:none" id="saving_span"><i class="fa fa-spin fa-spinner"></i> <span><?php _e("Saving") ?></span> ...</span>
            </div>
        </div>
    </div>
    <table class="table table-bordered table-striped" id="add_shifts_table">
        <thead>
            <tr class="heading">
                <th><?php _e("Shift") ?></th>
                <th><?php _e("Mon") ?></th>
                <th><?php _e("Tue") ?></th>
                <th><?php _e("Wed") ?></th>
                <th><?php _e("Thu") ?></th>
                <th><?php _e("Fri") ?></th>
                <th><?php _e("Sat") ?></th>
                <th><?php _e("Sun") ?></th>
            </tr>
        </thead>
        {% for(var i=0; i<count(o.rows); i++) { %}
        <tbody>
            <tr id="tr_shift_{%=o.rows[i].id%}" data-id="{%=o.rows[i].id%}">
                <td>
                    <b>{%=o.rows[i].id%}.{%=o.rows[i].shift_name%}</b><br>
                    {%=o.rows[i].start_time%} > {%=o.rows[i].end_time%}
                </td>
                {% for (var day=1; day<=7; day++) { %}
                    {% var T = array_merge({teachers:Teachers}, {shift_id:o.rows[i].id,day:day}); %}
                    {% var S = array_merge({subjects:Subjects}, {shift_id:o.rows[i].id,day:day}); %}
                    <td class="danger">
                        {% include('teachers_template', T); %}
                        {% include('subjects_template', S); %}
                    </td>
                {% } %}
            </tr>
        </tbody>
        {% } %}
    </table>
</script>
<script type="text/x-tmpl" id="classes_template">
    <select id="class_id" class="form-control">
        <option value="0">== <?php _e("Select Class") ?> ==</option>
        {% for (var x=0; x<count(o); x++) { %}
        <option value="{%=o[x].id%}">
            ({% if (o[x].batch_active==1) { %}*{% } %}{%=o[x].batch_name%}) >
            ID: {%=o[x].id%},
            {%=o[x].class_name%}
        </option>
        {% } %}
    </select>
</script>
<script type="text/x-tmpl" id="teachers_template">
    <select class="form-control teacher_id" disabled="disabled"
        id="teacher_id_{%=o.day%}_{%=o.shift_id%}" data-day="{%=o.day%}">
        <option value="0">==Teacher==</option>
        {% for (var x=0; x<count(o.teachers); x++) { %}
        <option value="{%=o.teachers[x].id%}">{%=o.teachers[x].name%}</option>
        {% } %}
    </select>
</script>
<script type="text/x-tmpl" id="subjects_template">
    <select id="subject_id_{%=o.day%}_{%=o.shift_id%}" data-shift_id="{%=o.shift_id%}" disabled="disabled"
        class="form-control subject_id" data-day="{%=o.day%}">
        <option value="0">== <?php _e("Subject") ?>==</option>
        {% for (var x=0; x<count(o.subjects); x++) { %}
        <option>{%=o.subjects[x].subject%}</option>
        {% } %}
    </select>
</script>
<script type="text/x-tmpl" id="tbody1_template">
    {% for(var x=0; x<count(o); x++) { %}
    <tr {% if (o[x].active_class!="1") { %}class="disabled"{% } %}>
        <td>
            {% if (o[x].active_class=="1") { %}
            <a href="" class="add_time_table_btn" data-class_id="{%=o[x].class_id%}" title="<?php _e("Edit") ?>">
            {% } %}
            ({%=o[x].batch_name%}) &gt;
            (ID: {%=o[x].class_id%})
            {%=o[x].class_name%}
            {% if (o[x].active_class=="1") { %}
            </a>
            {% } %}
        </td>
        <td>
            {%=o[x].teachers%}
        </td>
        <td>
            {%=o[x].subjects%}
        </td>
        <td>
            <div class="btn-group">
                <button data-class_id="{%=o[x].class_id%}" title="<?php _e("Print") ?>" class="btn btn-sm blue print_btn"><i class="fa fa-print"></i></button>
                <!--<button title="<?php _e("Download") ?>" class="btn btn-sm green download_btn"><i class="fa fa-download"></i></button>-->
            </div>
        </td>
    </tr>
    {% } %}
</script>
<script type="text/x-tmpl" id="print_template">
<style>
@media print {
  @page {
    size: landscape;
    margin: .5cm;
    }
  body { margin: 1.6cm; }
    td.rotate {
      /* Something you can count on */

      white-space: nowrap;
    }
    td.rotate > div {
      transform:
        /* Magic Numbers */
        translate(25px, 51px)
        /* 45 is really 360 - 45 */
        rotate(315deg);
      width: 30px;
    }
    td.rotate > div > span {
      padding: 5px 10px;
    }
}
@page {  }
</style>
    <div style="text-align:center;font-weight:bold;font-size:larger;">Time Table</div>
    <table class="table table-bordered">
    <tr>
        <th><?php _e("Shift") ?></th>
        <th><?php _e("Mon") ?></th>
        <th><?php _e("Tue") ?></th>
        <th><?php _e("Wed") ?></th>
        <th><?php _e("Thu") ?></th>
        <th><?php _e("Fri") ?></th>
        <th><?php _e("Sat") ?></th>
        <th><?php _e("Sun") ?></th>
    </tr>
    {% for(var x=0; x<count(o); x++) { %}
        {% if (o[x].empty==0) { %}
        <tr>
            <td>{%=o[x].shift_name%}</td>
            {% for(d=1; d<=7; d++) { %}
            <td>
                <div><span>
                {% if (typeof o[x]['day' + d].teacher_name=="string") { %}
                    {%=o[x]['day' + d].teacher_name%}<br>
                    ({%=o[x]['day' + d].subject%})
                {% } else { %}
                    -
                {% } %}
                </span></div>
            </td>
            {% } %}
        </tr>
        {% } %}
    {% } %}
    </table>
</script>