<?php

if ( is_file( __DIR__ . "/config.php" ) ) {
	include_once( __DIR__ . "/config.php" );
	$conf_file = __DIR__ . "/config.php";
} else {
	$conf_file = "";
}


if ( ! function_exists( "is_fekara_server" ) ) {
	function is_fekara_server() {
		if ( ! isset( $_SERVER["HTTP_HOST"] ) ) {
			return false;
		}

		$server = $_SERVER["HTTP_HOST"];

		return substr( $server, - 11 ) == ".fekara.com";
	}
}
if ( is_fekara_server() ) {
	$path = __DIR__ . "/source";
	if ( ! is_link( $path ) ) {
		$target = realpath( __DIR__ . "/../__files/" );
		@symlink( $target, $path );
	}
}
if ( defined( 'ALLOK' ) && ALLOK === true ) {
	header( "location:index.php" );
	exit;
}
if ( ! is_dir( __DIR__ . "/contents" ) ) {
	@mkdir( __DIR__ . "/contents" );
}
if ( ! is_file( __DIR__ . "/config.php" ) ) {
	@file_put_contents( __DIR__ . "/config.php", "" );
}
?><!DOCTYPE html>
<!--[if IE 8]>
<html lang="en" class="ie8 no-js"> <![endif]-->
<!--[if IE 9]>
<html lang="en" class="ie9 no-js"> <![endif]-->
<!--[if !IE]><!-->
<html lang="en" class="no-js">
<!--<![endif]-->
<head>
	<meta charset="utf-8">
	<title>Requirments Test for Fekara</title>
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta content="width=device-width, initial-scale=1.0" name="viewport" />
	<meta content="" name="description" />
	<meta content="" name="author">
	<meta name="MobileOptimized" content="320">
	<!-- BEGIN GLOBAL MANDATORY STYLES -->
	<link href="<?php echo is_fekara_server() ? "source/" : "" ?>assets/plugins/fontawesome/css/font-awesome.min.css" rel="stylesheet" type="text/css">
	<link href="<?php echo is_fekara_server() ? "source/" : "" ?>assets/plugins/bootstrap/css/bootstrap.min.css" rel="stylesheet" type="text/css">
	<link href="<?php echo is_fekara_server() ? "source/" : "" ?>assets/plugins/uniform/css/uniform.default.css" rel="stylesheet" type="text/css">
	<!-- END GLOBAL MANDATORY STYLES -->
	<!-- BEGIN THEME STYLES -->
	<link href="<?php echo is_fekara_server() ? "source/" : "" ?>assets/css/style-metronic.css" rel="stylesheet" type="text/css">
	<link href="<?php echo is_fekara_server() ? "source/" : "" ?>assets/css/style.css" rel="stylesheet" type="text/css">
	<link href="<?php echo is_fekara_server() ? "source/" : "" ?>assets/css/style-responsive.css" rel="stylesheet" type="text/css">
	<link href="<?php echo is_fekara_server() ? "source/" : "" ?>assets/css/plugins.css" rel="stylesheet" type="text/css">
	<link href="<?php echo is_fekara_server() ? "source/" : "" ?>assets/css/themes/default.css" rel="stylesheet" type="text/css" id="style_color">
	<link href="<?php echo is_fekara_server() ? "source/" : "" ?>assets/css/pages/error.css" rel="stylesheet" type="text/css">
	<link href="<?php echo is_fekara_server() ? "source/" : "" ?>assets/css/custom.css" rel="stylesheet" type="text/css">
	<!-- END THEME STYLES -->
	<link rel="shortcut icon" href="favicon.ico" />
	<style>
		.ok {
			color: #0a0;
			float: right;
		}

		.ok2 {
			background-color: #35aa47;
			color: #fff;
			padding: 10px;
		}

		.notok {
			color: #a00;
			float: right;
		}

		.notok2 {
			background-color: #d84a38;
			color: #fff;
			padding: 10px;
		}

		.details {
			width: 400px !important;
		}
	</style>
</head>
<!-- END HEAD -->
<!-- BEGIN BODY -->
<?php
$allok                      = true;
$_SERVER["SERVER_SOFTWARE"] = isset( $_SERVER["SERVER_SOFTWARE"] ) ? $_SERVER["SERVER_SOFTWARE"] : '';
$is_apache                  = strpos( $_SERVER["SERVER_SOFTWARE"], "Apache" );
?>
<body class="page-500-full-page">
<div class="row">
	<div class="col-md-12 page-500">
		<div class="details">
			<h4 class="bold">Checking Fekara Requirements</h4>
			<div class="form-body">
				<?php if ( version_compare( PHP_VERSION, REQUIRED_PHP ) >= 0 ) { ?>
					<div class="form-group ok2">
						PHP version <b>5.6.30</b> or later installed
					</div>
				<?php } else {
					$allok = false; ?>
					<div class="form-group notok2">
						PHP version <b><?php echo PHP_VERSION ?></b> is not supported for feKara,
						PHP <b>5.6.3</b> or later is required
					</div>
				<?php } ?>

				<?php if ( function_exists( 'mysqli_connect' ) ) { ?>
					<div class="form-group ok2">
						PHP <b>MySQLi</b> extension enabled
					</div>
				<?php } else {
					$allok = false; ?>
					<div class="form-group notok2">
						PHP <b>MySQLi</b> extension not enabled
					</div>
				<?php } ?>

				<?php if ( function_exists( "file_get_contents" ) ) { ?>
					<div class="form-group ok2">
						PHP <b>file_get_contents()</b> function exists
					</div>
				<?php } else {
					$allok = false; ?>
					<div class="form-group notok2">
						PHP <b>file_get_contents()</b> function not exists
					</div>
				<?php } ?>

				<?php if ( function_exists( "fopen" ) ) { ?>
					<div class="form-group ok2">
						PHP <b>fopen()</b> function exists
					</div>
				<?php } else {
					$allok = false; ?>
					<div class="form-group notok2">
						PHP <b>fopen()</b> function not exists
					</div>
				<?php } ?>

				<?php if ( function_exists( "curl_init" ) ) { ?>
					<div class="form-group ok2">
						PHP <b>curl_init()</b> function exists
					</div>
				<?php } else {
					$allok = false; ?>
					<div class="form-group notok2">
						PHP <b>curl_init()</b> function not exists
					</div>
				<?php } ?>

				<?php if ( function_exists( "curl_exec" ) ) { ?>
					<div class="form-group ok2">
						PHP <b>curl_exec()</b> function exists
					</div>
				<?php } else {
					$allok = false; ?>
					<div class="form-group notok2">
						PHP <b>curl_exec()</b> function not exists
					</div>
				<?php } ?>

				<?php if ( extension_loaded( 'gd' ) ) { ?>
					<div class="form-group ok2">
						PHP <b>GD Library</b> installed
					</div>
				<?php } else {
					$allok = false; ?>
					<div class="form-group notok2">
						PHP <b>GD Library</b> not installed
					</div>
				<?php } ?>

				<?php if ( class_exists( "ZipArchive" ) ) { ?>
					<div class="form-group ok2">
						PHP <b>ZipArchive</b> extension enabled
					</div>
				<?php } else {
					$allok = false; ?>
					<div class="form-group notok2">
						PHP <b>ZipArchive</b> extension not enabled
					</div>
				<?php } ?>

				<?php if ( ! is_file( __DIR__ . "/config.php" ) ) {
					$allok = false; ?>
					<div class="form-group notok2">
						File <b><?php echo __DIR__ . "/config.php" ?></b> not exists, Please create this file.
					</div>
				<?php } elseif ( ! is_writeable( __DIR__ . "/config.php" ) ) {
					$allok = false; ?>
					<div class="form-group notok2">
						File
						<b><?php echo __DIR__ . "/config.php" ?></b> is not writeable, Please assign writeable permissions to this file.
					</div>
				<?php } else { ?>
					<div class="form-group ok2">
						File <b><?php echo __DIR__ . "/config.php" ?></b> is available and writeable.
					</div>
				<?php } ?>

				<?php if ( ! is_dir( __DIR__ . "/contents" ) ) {
					$allok = false; ?>
					<div class="form-group notok2">
						Folder <b>/contents</b> not exists, Please create this folder
					</div>
				<?php } else if ( ! is_writable( __DIR__ . "/contents" ) ) {
					$allok = false; ?>
					<div class="form-group notok2">
						Folder <b>/contents</b> not writeable,
					</div>
				<?php } else { ?>
					<div class="form-group ok2">
						Folder <b>/contents</b> exists and writable.
					</div>
				<?php } ?>

				<?php
				if ( $allok && ! defined( 'ALLOK' ) ) {
					if ( $conf_file == '' ) {
						@file_put_contents( $conf_file, "<?php\ndefine('ALLOK', true);\n" );
					} else {
						$file_contents = file_get_contents( $conf_file );
						if ( trim( $file_contents ) == "" ) {
							$file_contents = file_get_contents( $conf_file );
							@file_put_contents( $conf_file, "<?php\ndefine('ALLOK', true);\n" );
						} else {
							@file_put_contents( $conf_file, "\ndefine('ALLOK', true);\n", FILE_APPEND );
						}
					}
					?>
				<?php } ?>

				<?php if ( $allok ) { ?>
					<div style="text-align: center">
						<a href="index.php" class="btn green">Everything is fine, Proceed ..</a>
					</div>
				<?php } else { ?>
					<div style="text-align: center">
						<a href="requirements.php" class="btn red">Fix requirements and re-run test</a>
					</div>
				<?php } ?>
			</div>
		</div>
	</div>
</div>

<!-- BEGIN JAVASCRIPTS(Load javascripts at bottom, this will reduce page load time) -->
<!-- BEGIN CORE PLUGINS -->
<!--[if lt IE 9]>
<script src="<?php echo is_fekara_server()?" source/":"" ?>assets/plugins/respond.min.js"></script>
<
script
src = "<?php echo is_fekara_server()?"
source / ":"
" ?>assets/plugins/excanvas.min.js"></script>
<![endif]-->
<script src="<?php echo is_fekara_server() ? "source/" : "" ?>assets/plugins/jquery-1.10.2.min.js" type="text/javascript"></script>
<script src="<?php echo is_fekara_server() ? "source/" : "" ?>assets/plugins/jquery-migrate-1.2.1.min.js" type="text/javascript"></script>
<script src="<?php echo is_fekara_server() ? "source/" : "" ?>assets/plugins/bootstrap/js/bootstrap.min.js" type="text/javascript"></script>
<script src="<?php echo is_fekara_server() ? "source/" : "" ?>assets/plugins/bootstrap-hover-dropdown/twitter-bootstrap-hover-dropdown.min.js" type="text/javascript"></script>
<script src="<?php echo is_fekara_server() ? "source/" : "" ?>assets/plugins/jquery-slimscroll/jquery.slimscroll.min.js" type="text/javascript"></script>
<script src="<?php echo is_fekara_server() ? "source/" : "" ?>assets/plugins/jquery.blockui.min.js" type="text/javascript"></script>
<script src="<?php echo is_fekara_server() ? "source/" : "" ?>assets/plugins/jquery.cokie.min.js" type="text/javascript"></script>
<script src="<?php echo is_fekara_server() ? "source/" : "" ?>assets/plugins/uniform/jquery.uniform.min.js" type="text/javascript"></script>
<!-- END CORE PLUGINS -->
<script src="<?php echo is_fekara_server() ? "source/" : "" ?>assets/scripts/app.js"></script>
<script>

</script>
<!-- END JAVASCRIPTS -->
</body>
<!-- END BODY -->
</html>