<?php

include_once( __DIR__ . "/_init.php" );

if ( ! is_admin() ) {

	redirect( "index.php" );

}

$CPanel = new CPanel();



if ( isset( $_GET["del_domain"] ) ) {

	echo $CPanel->delete_sub_domain( $_POST["domain"] );

	exit;

}



$Range    = 3;

$Page     = isset( $_GET["page"] ) ? $_GET["page"] : 1;

$Page     = (int) $Page;

$PageSize = 20;

$OffSet   = ( $Page - 1 ) * $PageSize;

if ( $Page <= $Range ) {

	$Start = 1;

} else {

	$Start = $Page - $Range;

}



$search  = isset( $_GET["search"] ) ? $_GET["search"] : "";

$__title = "Domains Settings";

include_once( __DIR__ . "/header.php" ); ?>



<style>

	#loading { display: block; }

</style>

<div class="container-fluid">

	<div class="page-content page-content-popup">

		<div class="page-content-fixed-header">

			<!-- BEGIN BREADCRUMBS -->

			<ul class="page-breadcrumb" id="breadcrumb">

				<li>

					<a href="<?php echo DOMAIN_URL ?>">Home</a>

				</li>

				<li>List Domains</li>

			</ul>

			<!-- END BREADCRUMBS -->

			<div class="content-header-menu">

				<!-- BEGIN MENU TOGGLER -->

				<!-- Only for mobile version -->

				<button type="button" class="menu-toggler responsive-toggler" data-toggle="collapse" data-target=".navbar-collapse">

                            <span class="toggle-icon">

                                <span class="icon-bar"></span>

                                <span class="icon-bar"></span>

                                <span class="icon-bar"></span>

                            </span>

				</button>

				<!-- END MENU TOGGLER -->

			</div>

		</div>

		<?php include_once( __DIR__ . "/sidebar.php" ); ?>



		<div class="page-fixed-main-content">

			<div id="main_content">

				<form>

					<input type="hidden" name="page" value="1">

					<input type="search" placeholder="Search in domains" name="search" class="form-control"

					       value="<?php echo esc_attr( $search ) ?>">

				</form>

				<table class="my_responsive" id="table1">

					<tbody>

					<?php

					$domains = $CPanel->list_sub_domains( $search );

					$lastk   = $k = 0;

					if (!is_array($domains)) $domains =[];

					foreach ( $domains as $k => $domain ) {

						if ( $k >= $OffSet && $k < ( $OffSet + $PageSize ) ) {

							$lastk = $k;

							?>

							<tr>

								<td>

									<?php if ( $domain['domain'] <> "*.fekara.com" ) { ?>

										<input id="check<?php echo $domain['domain']; ?>" type="checkbox" class="checkbox css-checkbox" name="domain[]" value="<?php echo $domain['domain']; ?>">

									<?php } else { ?>

										<input disabled="disabled" id="check<?php echo $domain['domain']; ?>" type="checkbox" class="checkbox css-checkbox">

									<?php } ?>

									<label for="check<?php echo $domain['domain']; ?>" class="css-label lite-green-check">

										<?php echo( $k + 1 ) ?>.

										<?php echo $domain['domain'] ?>

									</label>

								</td>

								<td>

									<a target="_blank" href="http://<?php echo $domain['domain'] ?>"><?php echo $domain['domain'] ?></a>

								</td>

								<td>

									<?php

									$installed = get_var( "SELECT `installed` FROM `installations` WHERE `domain`='{$domain['domain']}'" );

									if ( is_null( $installed ) ) {

										echo "No client attached";

									} elseif ( $installed == "-1" ) {

										echo "<i>Not checked</i>";

									} elseif ( $installed == "1" ) {

										echo "Installed";

									} elseif ( $installed == "0" ) {

										echo "Not Installed";

									}

									?>



									<?php if ( $domain['domain'] <> "*.fekara.com" ) { ?>

										<div style="float: right">

											<button data-domain="<?php echo $domain['domain'] ?>" class="del_domain_btn btn btn-xs red">

												<i class="fa fa-trash"></i> Delete

											</button>

										</div>

									<?php } else { ?>

										<div style="float: right">

											<button disabled data-domain="<?php echo $domain['domain'] ?>" class="btn btn-xs red disabled">

												<i class="fa fa-trash"></i> Delete

											</button>

										</div>

									<?php } ?>

								</td>

							</tr>

						<?php }

					}

					$Pages = ceil( ( $k + 1 ) / $PageSize );

					if ( $Pages == 0 ) {

						$Pages = 1;

					}

					$End = $Start + $Range + $Range;

					if ( $Pages < $End ) {

						$End = $Pages;

					}

					?>

					</tbody>

					<thead>

					<tr>

						<th>

							<input type="checkbox" class="css-checkbox" id="checkbox">

							<label for="checkbox" name="checkbox1_lbl" class="css-label lite-green-check"> <b>Domain</b></label>

						</th>

						<th>URL</th>

						<th>FeKara</th>

					</tr>

					<tr>

						<td colspan="3">

							Showing: <?php echo $OffSet + 1 ?> to <?php echo( $lastk + 1 ) ?> of

							<?php echo $k + 1 ?>



							<span style="float: right">

								<?php echo get_pagination_string( $Start, $End, $Page, $Pages ) ?>

							</span>

						</td>

					</tr>

					</thead>

					<tfoot>

					<tr>

						<td colspan="3">

							Showing: <?php echo $OffSet + 1 ?> to <?php echo( $lastk + 1 ) ?> of

							<?php echo $k + 1 ?>



							<span style="float: right">

								<?php echo get_pagination_string( $Start, $End, $Page, $Pages ) ?>

							</span>

						</td>

					</tr>

					</tfoot>

				</table>

			</div>

		</div>



		<?php include_once( __DIR__ . "/footer.php" ); ?>

	</div>

</div>

<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer_scripts.php" ); ?>

<div id="scripts">

	<script>

		$( function() {

			$( "#loading" ).hide();



			/*$( "#table1" ).dataTable( {

				stateSave: true

			} );*/



			$( document ).on( "click", ".del_domain_btn", function( event ) {

				event.preventDefault();



				domain = $( this ).attr( "data-domain" );



				if ( !confirm( "Are you sure you want to delete this domain?" ) ) {

					return false;

				}



				$( this ).closest( "tr" ).remove();



				$.post( "?del_domain", { domain: domain }, function( data ) {

					if ( data!="OK" ) {

						alert( data );

					}

				} );

			} );

			$( document ).on( "click", "#checkbox", function() {

				$( ".checkbox" ).prop( "checked", $( this ).is( ":checked" ) );

			} );

		} );



		function ChangePage( Page ) {

			window.location.href = "?page=" + Page + "&search=<?php echo $search ?>";

		}

	</script>

</div>

</body>

</html>