<?php

@ini_set( 'zlib.output_compression', 0 );

@ini_set( 'implicit_flush', 1 );

@ob_end_clean();



$__title = "Fekara Folders";

include_once( __DIR__ . "/header.php" ); ?>



<script type="text/x-tmpl" id="tbody1_tmpl">

	{% for(x in o) { row = o[x]; %}

		<tr data-folder="{%=btoa(row.folder_name)%}">

			<td>{%=(x+1)%}</td>

			<td>

				<a class="view_files" href="#">

					<i class="fa fa-folder"></i>

					{%=row.folder_name%}

				</a>

			</td>

			<td>

				{% if ( row.config_file == 1 ) { %}

					<i class="fa fa-check font-green"></i>

					<button title="View config.php file" class="btn btn-xs blue view_config" type="button">

						<i class="fa fa-eye"></i>

					</button>

				{% } else { %}

					<i class="fa fa-times font-red"></i>

				{% } %}

			</td>

			<td class="right">

				<button class="btn btn-sm red del_btn" type="button">

					<i class="fa fa-trash"></i> Delete Folder

				</button>

			</td>

		</tr>

	{% } %}



</script>



<!-- BEGIN CONTAINER -->

<div class="container-fluid">

	<div class="page-content page-content-popup">

		<div class="page-content-fixed-header">

			<!-- BEGIN BREADCRUMBS -->

			<ul class="page-breadcrumb">

				<li>

					<a href="<?php echo DOMAIN_URL; ?>">Home</a>

				</li>

				<li>

					<a href="fekara_servers.php">Folders List</a>

				</li>

			</ul>

			<!-- END BREADCRUMBS -->

			<div class="content-header-menu">

				<!-- BEGIN DROPDOWN AJAX MENU -->

				<div class="dropdown-ajax-menu btn-group">

					<button type="button" class="btn dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-close-others="true">

						<i class="fa fa-circle"></i>

						<i class="fa fa-circle"></i>

						<i class="fa fa-circle"></i>

					</button>

					<ul class="dropdown-menu-v2">

						<li>

							<a href="start.html">Application</a>

						</li>

						<li>

							<a href="start.html">Reports</a>

						</li>

						<li>

							<a href="start.html">Templates</a>

						</li>

						<li>

							<a href="start.html">Settings</a>

						</li>

					</ul>

				</div>

				<!-- END DROPDOWN AJAX MENU -->

				<!-- BEGIN MENU TOGGLER -->

				<button type="button" class="menu-toggler responsive-toggler" data-toggle="collapse" data-target=".navbar-collapse">

                            <span class="toggle-icon">

                                <span class="icon-bar"></span>

                                <span class="icon-bar"></span>

                                <span class="icon-bar"></span>

                            </span>

				</button>

				<!-- END MENU TOGGLER -->

			</div>

		</div>

		<?php include_once( __DIR__ . "/sidebar.php" ); ?>

		<div class="page-fixed-main-content">

			<div class="note note-warning" id="show1">

				<p><b>Caution!</b> Please be patient, Folders are still loading ....</p>

			</div>

			<h1>Fekara Server Folders</h1>

			<table class="table table-striped table-hover">

				<thead>

				<tr>

					<th style="width:10px">#</th>

					<th>Folder</th>

					<th>config.php</th>

					<th style="width: 15px;"></th>

				</tr>

				</thead>

				<tbody id="tbody1">

				<?php $folders = Remote::get_folders();

				@flush();

				@ob_flush();

				foreach ( $folders as $key => $folder ) { ?>

					<tr data-folder="<?php echo base64_encode( $folder->folder_name ) ?>">

						<td><?php echo $key + 1 ?></td>

						<td>

							<a title="View Files" href="ajax/fekara_servers.php?files=<?php echo urlencode( base64_encode( $folder->folder_name ) ) ?>" target="_blank">

								<i class="fa fa-folder"></i>

								<?php echo basename( $folder->folder_name ); ?>

							</a>

						</td>

						<td>

							<?php if ( $folder->config_file == 1 ) { ?>

								<i class="fa fa-check font-green"></i>

								<a href="ajax/fekara_servers.php?view_config=<?php echo urlencode( base64_encode( $folder->folder_name ) ) ?>" title="View config.php file" class="btn btn-xs blue view_config" target="_blank">

									<i class="fa fa-eye"></i>

								</a>

							<?php } else { ?>

								<i class="fa fa-times font-red"></i>

							<?php } ?>

						</td>

						<td class="right">

							<a class="btn btn-sm red" onclick="return DelBtn(this)" href="ajax/fekara_servers.php?delfolder=<?php echo urlencode( base64_encode( $folder->folder_name ) ) ?>" target="_blank">

								<i class="fa fa-trash"></i> Delete Folder

							</a>

						</td>

					</tr>

					<?php

					@flush();

					@ob_flush();

				} ?>

				</tbody>

			</table>



		</div>

		<?php include_once( __DIR__ . "/footer.php" ); ?>

	</div>

</div>

<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer_scripts.php" ); ?>

<script>

	//$( "#loading" ).hide();

	$( function() {

		$( '#show1' ).remove();

		$( '.view_config' ).attr( 'disabled', false );



		$( document ).on( 'click', '.view_files', function( e ) {

			e.preventDefault();



			folder = $( this ).closest( 'tr' ).attr( 'data-folder' );

			$.ajax( {

				url: 'ajax/fekara_servers.php?view_files',

				method: 'post',

				data: { folder: folder },

				success: function( data ) {

					alert( data );

				}

			} );

		} );



		//load_data();

	} );



	let DelBtn = function(t){

		if ( !confirm( 'Are you sure you want to delete this folder?' ) ) {

			return false;

		}



		$( t ).closest( 'tr' ).remove();

		return true;

	};



	let load_data = function() {

		//$( "#loading" ).show();

		$.ajax( {

			'method': 'post',

			'url': 'ajax/fekara_servers.php?folders',

			success: function( data ) {

				console.log( 'Data received!' );

				html = tmpl( 'tbody1_tmpl', data );

				$( '#tbody1' ).html( html );

			}

		} );

	}

</script>

</body>



</html>