<?php



class CP {



	// For documentation.

	// https://documentation.cpanel.net/display/DD/cPanel+API+2+Functions+-+Fileman%3A%3Afileop



	//	const host = '136.243.235.181';

	//	const pass = 'O936Ugu3kk9j60X';

	//	const user = 'fekara2';

	const http_scheme = 'https';

	const port = '2083';



	private static function api( $module, $function, $params = [] ) {

		$query = self::http_scheme . '://' . CPANEL_HOST . ':' . self::port . '/json-api/cpanel?cpanel_jsonapi_user=' . CPANEL_USER . '&cpanel_jsonapi_apiversion=2&cpanel_jsonapi_module=' . $module . '&cpanel_jsonapi_func=' . $function;



		if ( ! empty( $params ) ) {

			$query .= '&' . http_build_query( $params );

		}



		$curl = curl_init();                                // Create Curl Object

		curl_setopt( $curl, CURLOPT_SSL_VERIFYPEER, 0 );       // Allow self-signed certs

		curl_setopt( $curl, CURLOPT_SSL_VERIFYHOST, 0 );       // Allow certs that do not match the hostname

		curl_setopt( $curl, CURLOPT_HEADER, 0 );               // Do not include header in output

		curl_setopt( $curl, CURLOPT_RETURNTRANSFER, 1 );       // Return contents of transfer on curl_exec

		$header[0] = "Authorization: Basic " . base64_encode( CPANEL_USER . ":" . CPANEL_PASS ) . "\n\r";

		curl_setopt( $curl, CURLOPT_HTTPHEADER, $header );    // set the username and password

		curl_setopt( $curl, CURLOPT_URL, $query );            // execute the query

		$result = curl_exec( $curl );

		if ( $result == false ) {

			error_log( "curl_exec threw error \"" . curl_error( $curl ) . "\" for $query" );

			// log error if curl exec fails

		}

		curl_close( $curl );



		if ( is_json( $result ) ) {

			$result = json_decode( $result, true );

		}



		return $result;

	}



	public static function get_subdomains( $search = '' ) {

		$result = self::api( 'SubDomain', 'listsubdomains', [ 'regex' => $search ] );



		if ( ! isset( $result['cpanelresult']['data'] ) ) {

			return 'Subdomains not found.!';

		}



		return $result['cpanelresult']['data'];

	}



	public static function create_sub_domain( $args = [] ) {

		$default = [

			'domain'      => '',

			'rootdomain'  => 'fekara.com',

			'canoff'      => 0,

			'dir'         => '',

			'disallowdot' => 0,

		];

		$args    = set_args( $args, $default );

		if ( $args['dir'] == '' ) {

			$args['dir'] = '/public_html/' . $args['domain'];

		}



		$result = self::api( 'SubDomain', 'addsubdomain', $args );



		if ( isset( $result['cpanelresult'] ) ) {

			$result = $result['cpanelresult'];

		}



		if ( isset( $result['error'] ) ) {

			return $result['error'];

		}



		return 'OK';

	}



	public static function delete_subdomain( $domain ) {

		if ( substr( $domain, - 11 ) <> '.fekara.com' ) {

			$domain .= '.fekara.com';

		}



		$result = self::api( 'SubDomain', 'delsubdomain', [ 'domain' => $domain ] );



		if ( isset( $result['cpanelresult']['data'][0]['result'] ) && $result['cpanelresult']['data'][0]['result'] == 1 ) {

			return 'OK';

		}



		if ( isset( $result['cpanelresult']['error'] ) ) {

			return $result['cpanelresult']['error'];

		}

		if ( isset( $result['cpanelresult']['data'][0]['reason'] ) ) {

			return $result['cpanelresult']['data'][0]['reason'];

		}



		return $result;

	}



	public static function get_dbs( $search = '' ) {

		$result = self::api( 'MysqlFE', 'listdbs', [ 'regex' => $search ] );



		if ( ! isset( $result['cpanelresult']['data'] ) ) {

			return 'DBs not found.!';

		}



		return $result['cpanelresult']['data'];

	}



	public static function create_db( $db_name ) {

		if ( CPANEL_USER <> substr( $db_name, 0, strlen( CPANEL_USER ) ) ) {

			$db_name = CPANEL_USER . '_' . $db_name;

		}



		$result = self::api( 'MysqlFE', 'createdb', [ 'db' => $db_name ] );



		if ( isset( $result['cpanelresult']['error'] ) ) {

			return $result['cpanelresult']['error'];

		}



		if ( @$result['cpanelresult']['data']['result'] == 0 && isset( $result['cpanelresult']['data']['reason'] ) ) {

			return $result['cpanelresult']['data']['reason'];

		}



		if ( isset( $result['cpanelresult']['data'][0] ) && $result['cpanelresult']['data'][0] == 1 ) {

			return 'OK';

		}



		return $result;

	}



	public static function delete_db( $db_name ) {

		if ( CPANEL_USER <> substr( $db_name, 0, strlen( CPANEL_USER ) ) ) {

			$db_name = CPANEL_USER . '_' . $db_name;

		}



		$result = self::api( 'MysqlFE', 'deletedb', [ 'db' => $db_name ] );



		if ( isset( $result['cpanelresult']['error'] ) ) {

			return $result['cpanelresult']['error'];

		}



		if ( @$result['cpanelresult']['data']['result'] == 0 && isset( $result['cpanelresult']['data']['reason'] ) ) {

			return $result['cpanelresult']['data']['reason'];

		}



		if ( isset( $result['cpanelresult']['data'][0] ) && $result['cpanelresult']['data'][0] == 1 ) {

			return 'OK';

		}



		return $result;

	}



	public static function create_db_user( $db_user, $db_pass ) {

		if ( CPANEL_USER <> substr( $db_user, 0, strlen( CPANEL_USER ) ) ) {

			$db_user = CPANEL_USER . '_' . $db_user;

		}



		$result = self::api( 'MysqlFE', 'createdbuser', [ 'dbuser' => $db_user, 'password' => $db_pass ] );



		if ( isset( $result['cpanelresult']['error'] ) ) {

			return $result['cpanelresult']['error'];

		}



		if ( @$result['cpanelresult']['data']['result'] == 0 && isset( $result['cpanelresult']['data']['reason'] ) ) {

			return $result['cpanelresult']['data']['reason'];

		}



		if ( isset( $result['cpanelresult']['data'][0] ) && $result['cpanelresult']['data'][0] == 1 ) {

			return 'OK';

		}



		return $result;

	}



	public static function delete_db_user( $db_user ) {

		if ( CPANEL_USER <> substr( $db_user, 0, strlen( CPANEL_USER ) ) ) {

			$db_user = CPANEL_USER . '_' . $db_user;

		}



		$result = self::api( 'MysqlFE', 'deletedbuser', [ 'dbuser' => $db_user ] );



		if ( isset( $result['cpanelresult']['error'] ) ) {

			return $result['cpanelresult']['error'];

		}



		if ( @$result['cpanelresult']['data']['result'] == 0 && isset( $result['cpanelresult']['data']['reason'] ) ) {

			return $result['cpanelresult']['data']['reason'];

		}



		if ( isset( $result['cpanelresult']['data'][0] ) && $result['cpanelresult']['data'][0] == 1 ) {

			return 'OK';

		}



		return $result;

	}



	public static function attach_db_user( $db_name, $db_user, $privileges = 'ALL PRIVILEGES' ) {

		if ( CPANEL_USER <> substr( $db_name, 0, strlen( CPANEL_USER ) ) ) {

			$db_name = CPANEL_USER . '_' . $db_name;

		}

		if ( CPANEL_USER <> substr( $db_user, 0, strlen( CPANEL_USER ) ) ) {

			$db_user = CPANEL_USER . '_' . $db_user;

		}



		$result = self::api( 'MysqlFE', 'setdbuserprivileges', [

			'db'         => $db_name,

			'dbuser'     => $db_user,

			'privileges' => $privileges,

		] );

		

		if ( is_null( $result ) ) {

			return 'Execute API error: ' . __METHOD__;

		}



		if ( isset( $result['cpanelresult'] ) ) {

			$result = $result['cpanelresult'];

		}



		if ( isset( $result['error'] ) ) {

			return $result['error'];

		}



		return 'OK';

	}



	public static function delete_file( $filepath ) {

		if ( strpos( $filepath, "public_html/" ) === false ) {

			$filepath = "/public_html/" . $filepath;

		}



		$result = self::api( 'Fileman', 'fileop', [ 'op' => 'trash', 'sourcefiles' => $filepath ] );



		if ( isset( $result['cpanelresult']['error'] ) ) {

			return $result['cpanelresult']['error'];

		}



		if ( @$result['cpanelresult']['data'][0]['result'] == 1 ) {

			return 'OK';

		}



		return $result;

	}



	public static function set_db_and_user( $string ) {

		$string = strtolower( trim( (string) $string ) );



		$cpuser = CPANEL_USER . '_';

		$string = $cpuser . $string;

		$string = str_replace( $cpuser . $cpuser, $cpuser, $string );



		if ( strlen( $string ) > 10 ) {

			$string = substr( $string, 0, 10 );

			$string .= rand( 1, 999 );

		}



		return $string;

	}

}