<?php



class CPanel {



	var $cpuser;

	var $cppass;

	var $cphost;



	function __construct( $cpuser = "fekara2", $cppass = "O936Ugu3kk9j60X", $cphost = "136.243.235.181" ) {

		if ( $cpuser == '' ) {

			$this->cpuser = CPANEL_USER;

		} else {

			$this->cpuser = $cpuser;

		}

		if ( $cppass == '' ) {

			$this->cppass = CPANEL_PASS;

		} else {

			$this->cppass = $cppass;

		}

		if ( $cphost == '' ) {

			$this->cphost = CPANEL_HOST;

		} else {

			$this->cphost = $cphost;

		}



		set_time_limit( 0 );

	}



	function delete_sub_domain( $subdomain ) {

		$xmlapi = new xmlapi( $this->cphost );

		$xmlapi->set_port( 2083 );

		$xmlapi->password_auth( $this->cpuser, $this->cppass );

		//$xmlapi->set_debug(1);

		$xmlapi->set_output( "json" );



		$response = $xmlapi->api2_query( $subdomain, 'SubDomain', 'delsubdomain', [

			"domain" => $subdomain,

		] );



		$response = json_decode( $response, true );

		if ( isset( $response['cpanelresult'] ) ) {

			$response = $response['cpanelresult'];

		}



		if ( isset( $response["error"] ) ) {

			return $response["error"];

		} else {

			return "OK";

		}

	}



	function create_sub_domain( $subdomain ) {

		$xmlapi = new xmlapi( $this->cphost );

		$xmlapi->set_port( 2083 );

		$xmlapi->password_auth( $this->cpuser, $this->cppass );

		//$xmlapi->set_debug(1);

		$xmlapi->set_output( "json" );



		$response = $xmlapi->api2_query( $subdomain, 'SubDomain', 'addsubdomain', [

			"domain"      => $subdomain,

			"rootdomain"  => 'fekara.com',

			"dir"         => '/public_html/' . $subdomain,

			"disallowdot" => "1",

		] );

		$response = json_decode( $response, true );

		if ( is_null( $response ) ) {

			return "Can't run cPanel API";

		}



		if ( isset( $response['cpanelresult'] ) ) {

			$response = $response['cpanelresult'];

		}



		if ( isset( $response['error'] ) ) {

			return $response['error'];

		}



		return 'OK';



		if ( isset( $response["error"] ) ) {

			return $response["error"];

		} else {

			return "OK";

		}

	}



	function list_sub_domains( $regex = "" ) {

		$xmlapi = new xmlapi( $this->cphost );

		$xmlapi->set_port( 2083 );

		$xmlapi->password_auth( $this->cpuser, $this->cppass );

		//$xmlapi->hash_auth( 'root', 'VH923Z0G6EB3GUQRIP0J4U9FKGTD5MY7');

		$xmlapi->set_output( "json" );



		$args     = [ "regex" => $regex ];

		$response = $xmlapi->api2_query( $this->cpuser, 'SubDomain', 'listsubdomains', $args );

		$response = json_decode( $response, true );



		if ( isset( $response['cpanelresult'] ) ) {

			$response = $response['cpanelresult'];

		}



		if ( isset( $response["error"] ) ) {

			return $response["error"];

		}

		if ( isset( $response["event"]["result"] ) && $response["event"]["result"] == "0" ) {

			return $response["event"]["reason"];

		}



		if ( ! isset( $response["data"] ) ) {

			return "No data found from server.";

		}



		$data = $response["data"];

		if ( ! isset( $data[0] ) ) {

			return array( "0" => $data );

		}



		return $data;

	}



	function create_db_user( $db_user, $db_pass ) {

		$xmlapi = new xmlapi( $this->cphost );

		$xmlapi->set_port( 2083 );

		$xmlapi->password_auth( $this->cpuser, $this->cppass );

		//$xmlapi->set_debug(1);

		$xmlapi->set_output( "json" );



		# Creating User

		if ( $this->cpuser <> substr( $db_user, 0, strlen( $this->cpuser ) ) ) {

			$db_user = $this->cpuser . "_" . $db_user;

		}

		$db_user = strtolower( $db_user );



		$response = $xmlapi->api2_query( $this->cpuser, 'MysqlFE', 'createdbuser', array(

			'dbuser'   => $db_user,

			'password' => $db_pass,

		) );

		$response = json_decode( $response, true );

		if ( is_null( $response ) ) {

			return "Can't create DB user";

		}



		if ( isset( $response['cpanelresult'] ) ) {

			$response = $response['cpanelresult'];

		}



		if ( isset( $response["error"] ) ) {

			return $response["error"];

		}



		return 'OK';

	}



	function attach_db_user( $db_name, $db_user ) {

		$xmlapi = new xmlapi( $this->cphost );

		$xmlapi->set_port( 2083 );

		$xmlapi->password_auth( $this->cpuser, $this->cppass );

		$xmlapi->set_output( "json" );



		if ( $this->cpuser <> substr( $db_name, 0, strlen( $this->cpuser ) ) ) {

			$db_name = $this->cpuser . "_" . $db_name;

		}



		$response = $xmlapi->api2_query( $this->cpuser, 'MysqlFE', 'setdbuserprivileges', [

			'privileges' => 'ALL',

			'db'         => $db_name,

			'dbuser'     => $db_user,

		] );

		$response = json_decode( $response, true );

		if ( is_null( $response ) ) {

			return "Can't attach DB user";

		}

		if ( isset( $response['cpanelresult'] ) ) {

			$response = $response['cpanelresult'];

		}



		if ( isset( $response["error"] ) ) {

			return $response["error"];

		}



		return "OK";

	}



	function extract_file( $filepath, $dest = '' ) {

		$xmlapi = new xmlapi( $this->cphost );

		$xmlapi->set_port( 2083 );

		$xmlapi->password_auth( $this->cpuser, $this->cppass );

		$xmlapi->set_output( "json" );



		if ( strpos( $dest, "public_html/" ) === false ) {

			$dest = "/public_html/" . $dest;

		}



		$response = $xmlapi->api2_query( $this->cpuser, 'Fileman', 'fileop', [

			'op'          => 'extract',

			'sourcefiles' => $filepath,

			'destfiles'   => $dest,

		] );

		$response = json_decode( $response, true );

		if ( is_null( $response ) ) {

			return "Can't execute API " . __METHOD__;

		}



		if ( isset( $response['cpanelresult'] ) ) {

			$response = $response['cpanelresult'];

		}



		if ( isset( $response["error"] ) ) {

			return $response["error"];

		}

		if ( isset( $response['cpanelresult'] ) ) {

			$response = $response['cpanelresult'];

		}



		if ( isset( $response["event"]["result"] ) && $response["event"]["result"] == "0" ) {

			return $response["event"]["reason"];

		}

		if ( ! isset( $response["data"] ) ) {

			return "No data found from server.";

		}

		if ( isset( $response["data"]["output"] ) ) {

			if ( substr( $response["data"]["output"], 0, 8 ) == "Archive:" ) {

				return "OK";

			} else {

				return $response["data"]["output"];

			}

		}



		$data = $response["data"];

		if ( ! isset( $data[0] ) ) {

			return array( "0" => $data );

		}



		return $data;

	}



	function delete_file( $filepath ) {

		$xmlapi = new xmlapi( $this->cphost );

		$xmlapi->set_port( 2083 );

		$xmlapi->password_auth( $this->cpuser, $this->cppass );

		$xmlapi->set_output( "json" );



		if ( strpos( $filepath, "public_html/" ) === false ) {

			$filepath = "/public_html/" . $filepath;

		}



		$response = $xmlapi->api2_query( $this->cpuser, 'Fileman', 'fileop', array(

			'op'          => 'trash',

			'sourcefiles' => $filepath,

		) );



		$response = json_decode( $response, true );

		if ( isset( $response['cpanelresult'] ) ) {

			$response = $response['cpanelresult'];

		}



		if ( isset( $response["error"] ) ) {

			return $response["error"];

		} else {

			return "OK";

		}

	}



	function get_dbs( $regex = "" ) {

		$args = [ "regex" => $regex ];

		/*if ( ! empty( $args["regex"] ) ) {

			$args["regex"] = substr( $this->cpuser, 0, 8 ) . "_" . $args["regex"] . "*";

		}*/



		$xmlapi = new xmlapi( $this->cphost );

		$xmlapi->set_port( 2083 );

		$xmlapi->password_auth( $this->cpuser, $this->cppass );

		$xmlapi->set_output( "json" );



		$response = $xmlapi->api2_query( $this->cpuser, 'MysqlFE', 'listdbs', $args );

		$response = json_decode( $response, true );

		if ( is_null( $response ) ) {

			return [];

		}

		if ( isset( $response['cpanelresult'] ) ) {

			$response = $response['cpanelresult'];

		}

		if ( isset( $response['error'] ) ) {

			$response = $response['error'];

		}

		if ( isset( $response['data'] ) ) {

			$response = $response['data'];

		}



		return $response;

	}



	function create_db( $db_name ) {

		$xmlapi = new xmlapi( $this->cphost );

		$xmlapi->set_port( 2083 );

		$xmlapi->password_auth( $this->cpuser, $this->cppass );

		//$xmlapi->set_debug(1);

		$xmlapi->set_output( "json" );



		# Creating DB

		if ( $this->cpuser <> substr( $db_name, 0, strlen( $this->cpuser ) ) ) {

			$db_name = $this->cpuser . "_" . $db_name;

		}



		$response = $xmlapi->api2_query( $this->cpuser, 'MysqlFE', 'createdb', array(

			'db' => $db_name,

		) );



		$response = json_decode( $response, true );

		if ( is_null( $response ) ) {

			return "Can't create DB";

		}

		if ( isset( $response['cpanelresult'] ) ) {

			$response = $response['cpanelresult'];

		}

		if ( isset( $response['error'] ) ) {

			return $response['error'];

		}



		return 'OK';

	}



	function is_json( $string ) {

		if ( empty( $string ) ) {

			return false;

		}

		json_decode( $string );



		return ( json_last_error() == JSON_ERROR_NONE );

	}



	function upload_file( $upload_file, $upload_path = "" ) {

		set_time_limit( 0 );

		$upload_file2 = $upload_file;

		$upload_file  = realpath( $upload_file );

		if ( $upload_file === false ) {

			return "File '" . $upload_file2 . "' doesn't exists.";

		}

		$request_uri     = "https://" . $this->cphost . ":2083/execute/Fileman/upload_files";

		$destination_dir = "public_html";

		if ( $upload_path <> "" ) {

			$destination_dir = $destination_dir . "/" . $upload_path;

		}



		if ( function_exists( 'curl_file_create' ) ) {

			$cf = curl_file_create( $upload_file );

		} else {

			$cf = "@/" . $upload_file;

		}



		$payload = [

			'dir'    => ( $destination_dir ),

			'file-1' => $cf,

		];



		// Set up the cURL request object.

		$ch = curl_init( $request_uri );

		curl_setopt( $ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC );

		curl_setopt( $ch, CURLOPT_USERPWD, $this->cpuser . ':' . $this->cppass );

		curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, false );

		curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );



		// Set up a POST request with the payload.

		curl_setopt( $ch, CURLOPT_POST, true );

		curl_setopt( $ch, CURLOPT_POSTFIELDS, $payload );

		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );



		// Make the call, and then terminate the cURL caller object.

		$curl_response = curl_exec( $ch );

		curl_close( $ch );



		// Decode and validate output.

		$response = json_decode( $curl_response );



		if ( empty( $response ) ) {

			return "The cURL call did not return valid JSON. Check your username/password.\n";

		} elseif ( ! $response->status ) {

			if ( isset( $response->data->uploads[0]->reason ) ) {

				return $response->data->uploads[0]->reason;

			} else {

				return "The cURL call returned valid JSON, but reported errors:\n" . $response->errors[0];

			}

			//die( $response->errors[0] . "\n" );

		} else {

			return "OK";

		}

		// Print and exit.

		/*if (isset($response->errors) && !empty($response->errors)) return $response->errors;

		if (isset($response->data->succeeded) && $response->data->succeeded=="1") return "OK";

		if (isset($response->data->succeeded) && $response->data->succeeded=="0") {

			if (isset($response->data->uploads[0]->reason)) return $response->data->uploads[0]->reason;

		}

		return "OK";*/

	}



	function is_db_user_exist( $db_user ) {

		$xmlapi = new xmlapi( $this->cphost );

		$xmlapi->set_port( 2083 );

		$xmlapi->password_auth( $this->cpuser, $this->cppass );

		$xmlapi->set_output( "json" );



		if ( $this->cpuser <> substr( $db_user, 0, strlen( $this->cpuser ) ) ) {

			$db_user = $this->cpuser . "_" . $db_user;

		}



		$response = $xmlapi->api2_query( $this->cpuser, 'MysqlFE', 'dbuserexists', array(

			'dbuser' => $db_user,

		) );

		$response = json_decode( $response, true );

		if ( is_null( $response ) ) {

			return false;

		}

		if ( isset( $response['cpanelresult'] ) ) {

			$response = $response['cpanelresult'];

		}

		if ( isset( $response["error"] ) ) {

			return false;

		}

		if ( isset( $response['data'][0] ) ) {

			return $response['data'][0] > 0;

		}



		return false;

	}



	function delete_db( $db_name ) {

		$xmlapi = new xmlapi( $this->cphost );

		$xmlapi->set_port( 2083 );

		$xmlapi->password_auth( $this->cpuser, $this->cppass );

		//$xmlapi->set_debug(1);

		$xmlapi->set_output( "json" );



		# Creating DB

		if ( $this->cpuser <> substr( $db_name, 0, strlen( $this->cpuser ) ) ) {

			$db_name = $this->cpuser . "_" . $db_name;

		}

		$response = $xmlapi->api2_query( $this->cpuser, 'MysqlFE', 'deletedb', [

			'db' => $db_name,

		] );

		$response = json_decode( $response, true );

		if ( is_null( $response ) ) {

			return "Can't delete DB \"$db_name\"";

		}

		if ( isset( $response['cpanelresult'] ) ) {

			$response = $response['cpanelresult'];

		}

		if ( isset( $response["error"] ) ) {

			return $response["error"];

		}



		return 'OK';

	}



	function delete_db_user( $db_user ) {

		$xmlapi = new xmlapi( $this->cphost );

		$xmlapi->set_port( 2083 );

		$xmlapi->password_auth( $this->cpuser, $this->cppass );

		//$xmlapi->set_debug(1);

		$xmlapi->set_output( "json" );



		if ( $this->cpuser <> substr( $db_user, 0, strlen( $this->cpuser ) ) ) {

			$db_user = $this->cpuser . "_" . $db_user;

		}

		$response = $xmlapi->api2_query( $this->cpuser, 'MysqlFE', 'deletedbuser', array(

			'dbuser' => $db_user,

		) );

		$response = json_decode( $response, true );

		if ( isset( $response['cpanelresult'] ) ) {

			$response = $response['cpanelresult'];

		}



		if ( isset( $response["error"] ) ) {

			return $response["error"];

		}



		return 'OK';

	}



	function get_all_dbs() {

		$xmlapi = new xmlapi( $this->cphost );

		$xmlapi->set_port( 2083 );

		$xmlapi->password_auth( $this->cpuser, $this->cppass );

		//$xmlapi->set_debug(1);

		$xmlapi->set_output( "json" );



		$response = $xmlapi->api2_query( $this->cpuser, 'MysqlFE', 'getalldbsinfo' );

		$response = json_decode( $response, true );

		if ( is_null( $response ) ) {

			return [];

		}

		if ( isset( $response['cpanelresult'] ) ) {

			$response = $response['cpanelresult'];

		}

		if ( isset( $response['error'] ) ) {

			return $response['error'];

		}

		if ( isset( $response['data'] ) ) {

			$response = $response['data'];

		}



		return $response;

	}



	function read_ftp_file( $remote_file_path, $local_file_path ) {

		$conn_id      = ftp_connect( $this->cphost );

		$login_result = ftp_login( $conn_id, $this->cpuser, $this->cppass );

		// try to download $server_file and save to $local_file

		if ( ftp_get( $conn_id, $local_file_path, $remote_file_path, FTP_BINARY ) ) {

			ftp_close( $conn_id );



			return "OK";

		} else {

			return "FTP file transfer not succeeded";

		}

	}



	function read_ftp_file_to_variable( $remote_file_path ) {

		$conn_id      = ftp_connect( $this->cphost );

		$login_result = ftp_login( $conn_id, $this->cpuser, $this->cppass );



		ob_start();

		$result = @ftp_get( $conn_id, "php://output", $remote_file_path, FTP_BINARY );



		if ( ! $result ) {

			$data = "";

		} else {

			$data = ob_get_contents();

		}

		ob_end_clean();



		return $data;

	}



	function delete_ssl( $domain ) {

		$xmlapi = new xmlapi( $this->cphost );

		$xmlapi->set_port( 2083 );

		$xmlapi->password_auth( $this->cpuser, $this->cppass );

		$xmlapi->set_output( "json" );



		$response = $xmlapi->api2_query( $this->cpuser, 'SSL', 'delete_ssl', [ "domain" => $domain ] );

		$response = json_decode( $response, true );

		if ( is_null( $response ) ) {

			return "Can not delete SSL";

		}

		if ( isset( $response['cpanelresult'] ) ) {

			$response = $response['cpanelresult'];

		}

		if ( isset( $response['error'] ) ) {

			return $response['error'];

		}



		return 'OK';

	}



	function get_db_users( $db = "" ) {

		$xmlapi = new xmlapi( $this->cphost );

		$xmlapi->set_port( 2083 );

		$xmlapi->password_auth( $this->cpuser, $this->cppass );

		//$xmlapi->set_debug(1);

		$xmlapi->set_output( "json" );



		if ( $db == "" ) {

			$response = $xmlapi->api2_query( $this->cpuser, 'MysqlFE', 'getdbusers' );

		} else {

			$response = $xmlapi->api2_query( $this->cpuser, 'MysqlFE', 'getdbusers', [ "db" => $db ] );

		}

		$response = json_decode( $response, true );

		if ( is_null( $response ) ) {

			return [];

		}

		if ( isset( $response['cpanelresult'] ) ) {

			$response = $response['cpanelresult'];

		}

		if ( isset( $response['error'] ) ) {

			return $response['error'];

		}

		if ( isset( $response['data'] ) ) {

			$response = $response['data'];

		}



		return $response;

	}



	public function set_db_and_user( $string ) {

		$string = strtolower( trim( (string) $string ) );



		$cpuser = $this->cpuser . '_';

		$string = $cpuser . $string;

		$string = str_replace( $cpuser . $cpuser, $cpuser, $string );



		if ( strlen( $string ) > 10 ) {

			$string = substr( $string, 0, 10 );

			$string .= rand( 1, 999 );

		}



		return $string;

	}

}