<?php

/**

 * Library: https://github.com/brick/phonenumber

 */



use Brick\PhoneNumber\PhoneNumber;

use Brick\PhoneNumber\PhoneNumberParseException;





class FixCountries {



	public static function fetch_calling_codes() {

		global $db;

		$rows = $db->get_rows( 'SELECT alpha_2 FROM `countries` WHERE `calling_code` IS NULL OR `calling_code`=\'\' LIMIT 30' );

		echo count($rows);

		foreach ( $rows as $row ) {

			$url  = 'https://restcountries.eu/rest/v1/alpha?codes=' . strtoupper( $row['alpha_2'] );

			$json = file_get_contents( $url );

			if ( is_json( $json ) ) {

				$json         = json_decode( $json, true );

				$calling_code = isset( $json[0]['callingCodes'][0] ) ? $json[0]['callingCodes'][0] : '';

				if ( is_numeric( $calling_code ) ) {

					$db->update( 'countries', [ 'calling_code' => $calling_code ], [ 'alpha_2' => $row['alpha_2'] ] );

				}

			}

		}

	}



	public static function fix( ): void {

		global $db;



		$query = 'SELECT * FROM `apps` WHERE `phone`=REPLACE(`phone`,\' \',\'\') and length(`phone`)>2 and (`phone` is not null or `phone`<>\'\')';



		$rows = $db->get_rows("SELECT `id`,`phone` FROM `apps` WHERE (country IS NULL OR country='') AND `phone`<>'' ORDER BY `id` DESC LIMIT 10");

		foreach($rows as $row) {

			$code = substr($row['phone'], 0, strpos($row['phone'], ' ') );

			$country_name = $db->get_var('SELECT `name` FROM `countries` WHERE `calling_code`=' . $code);

			$db->update('apps', ['country' => $country_name], ['id' => $row['id']]);

		}



	}

}