<?php

function get_folders( $path ) {

	$command = 'ls ' . $path . '/* -d';

	exec( $command, $folders );

	//$folders = explode(PHP_EOL, $folders);

	//print_r ($folders);

	//$folders     = scandir( $path );

	$out_folders = [];

	foreach ( $folders as $folder ) {

		if ( trim( $folder ) == '' || substr( basename( $folder ), 0, 1 ) == '_' ) {

			continue;

		}

		$out_folders[] = [

			'folder_name' => $folder,

			'config_file' => is_file( $folder . '/config.php' ) ? '1' : '0',

		];

	}



	return $out_folders;

}



function get_files( $path ) {

	if ( ! is_dir( $path ) ) {

		return [];

	}



	$path = rtrim( $path, '/' );

	//$files = scandir( $path);

	$files = glob( $path . '/*' );



	$Files = [];

	foreach ( $files as $file ) {

		if ( is_file( $file ) ) {

			$Files[] = [

				'path' => $file,

				'size' => filesize( $file ),

				'type' => 'F',

			];

		} else if ( is_dir( $file ) ) {

			$Files[] = [

				'path' => $file,

				'size' => 0,

				'type' => 'D',

			];

		}

	}



	return $Files;

}



function view_config( $path ) {

	if ( ! is_dir( $path ) ) {

		return '';

	}



	$path = rtrim( $path, '/' ) . '/config.php';

	if ( ! is_file( $path ) ) {

		return '';

	}



	$content = file_get_contents( $path );



	return $content;

}



function delfolder( $path ) {

	if ( ! is_dir( $path ) ) {

		echo 'Folder not found.';

		exit;

	}



	$f = basename( $path );

	if ( $f == '__files' || $f == '__files2' || $f == '__fekara' || $f == '_data' || $f == '_custom' ) {

		echo 'You can not delete this folder';

		exit();

	}



	$command = 'rm -rf ' . $path;

	exec( $command );



	if ( is_dir( $path ) ) {

		echo 'Folder removed!';

	} else {

		echo 'Folder not removed!';

	}

}



function install_zip_file( $folder ) {

	$source_path = __DIR__ . '/../installation/1.zip';

	$source_path = realpath( $source_path );

	if ( ! is_file( $source_path ) ) {

		return 'Source ZIP file missing!';

	}



	$target_path = __DIR__ . ( '/../../' . $folder );

	$target_path = realpath( $target_path );

	if ( ! is_dir( $target_path ) ) {

		die($target_path);

		return 'Target folder not found for ZIP file';

	}



	if ( ! copy( $source_path, $target_path . '/1.zip' ) ) {

		return 'Source ZIP file not copied to traget.';

	}



	$zip = new ZipArchive;

	$res = $zip->open( $target_path . '/1.zip' );

	if ( $res === true ) {

		$zip->extractTo( $target_path );

		$zip->close();

	}



	if ( ! is_file( $target_path . '/app_settings.php' ) ) {

		return "Can't unzip installation files.";

	}



	@unlink( $target_path . '/1.zip' );



	return 'OK';

}



function create_config_file( $folder, $dbname, $dbuser, $dbpass ) {

	$path = __DIR__ . ( '/../../' . $folder );

	$path = realpath( $path ) . '/config.php';



	$content = '<?php

	define(\'DBSERVER\', \'localhost\');

	define(\'DBNAME\', \'{{dbname}}\');

	define(\'DBUSER\', \'{{dbuser}}\');

	define(\'DBPASS\', \'{{dbpass}}\');';



	$replace_array = [

		'{{dbname}}' => $dbname,

		'{{dbuser}}' => $dbuser,

		'{{dbpass}}' => $dbpass,

	];



	$content = str_replace( array_keys( $replace_array ), array_values( $replace_array ), $content );



	@file_put_contents( $path, $content );



	return is_file( $path ) ? 'OK' : "Can't create config file";

}