<?php

include_once "_init.php";

$App    = new Apps();

$CPanel = new CPanel();

if ( ! is_admin() ) {

	echo "You can't view this page";

	exit();

}

if ( isset( $_GET['update_user_pass'] ) ) {

	$data = [

		"table" => "admins",

	    "data" => ["password" => md5($_POST["new_pass"])],

	    "condition" => ["id" => $_GET['update_user_pass']]

	];



	$response = $App->execute_api([

		"id"      => $_POST['id'],

		"command" => 'update_row',

		"data"    => $data,

	]);



	if (is_json($response)) {

		$response = json_decode( $response);

		echo $response->status;

	} else {

		echo $response;

	}



	exit();

}

if ( isset( $_GET['del_admin'] ) ) {

	$response = $App->execute_api([

		"id"      => $_GET['id'],

		"command" => 'query',

		"data"    => "DELETE FROM `admins` WHERE `id`='{$_GET['del_admin']}'",

	]);



	if ($response==1 || $response) {

		echo "OK";

	} else {

		echo "Can't delete this user";

	}

	exit();

}

if ( isset( $_GET['update_password'] ) ) {

	echo $App->update_customer_password( @$_POST['id'], $_POST['new_password'] );

	exit();

}

if ( isset( $_GET["del_installation"] ) ) {

	echo $App->delete_installation( $_POST["installation"] );

	exit();

}

if ( isset( $_GET['install'] ) ) {

	echo $App->update_installation_via_url( $_POST['domain'], @$_POST["pk"] );

	exit();

}

if ( isset( $_GET['add_user'] ) ) {

	echo $App->add_user( @$_POST["installation"], @$_POST["username"], @$_POST["password"], @$_POST["id"] );

	exit();

}

if ( empty( $_GET["id"] ) ) {

	echo "Invalid request!";

	exit();

}

$id  = $_GET["id"];

$app = $App->get_simple_apps( "id=$id" );

if ( $app["total_records"] == 0 ) {

	echo "No data found.!";

	exit();

}

$app           = $app["rows"][0];

$installations = $App->get_installations( "app_id={$id}&pagesize=9999" );

include_once "header_tag.php"; ?>

<body>

<div class="loading display-none" id="loading">Loading&#8230;</div>

<div class="modal fade" id="delDiv" tabindex="-1" role="basic" aria-hidden="true">

	<div class="modal-dialog">

		<div class="modal-content">

			<div class="modal-header">

				<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>

				<h4 class="modal-title">Delete Installation</h4>

			</div>

			<div class="modal-body">

				<form class="form-horizontal" role="form" id="del_form">

					<input type="submit" class="hidden" id="del_submit">

					<div class="form-body">

						<div class="form-group">

							<label class="col-md-3 control-label">Installation</label>

							<div class="col-md-9">

								<select class="form-control" name="installation" id="del_installation">

									<option value="">== Select installation ==</option>

									<?php foreach ( $installations["rows"] as $installation ) { ?>

										<option value="<?php echo $installation["id"] ?>"><?php echo $installation["domain"] ?></option>

									<?php } ?>

								</select>

							</div>

						</div>

					</div>

				</form>

			</div>

			<div class="modal-footer">

				<button type="button" class="btn dark btn-outline" data-dismiss="modal">Close</button>

				<button type="button" onclick="$('#del_submit').click();" class="btn green">Delete</button>

			</div>

		</div>

		<!-- /.modal-content -->

	</div>

	<!-- /.modal-dialog -->

</div>

<div class="modal fade" id="userDiv" tabindex="-1" role="basic" aria-hidden="true">

	<div class="modal-dialog">

		<div class="modal-content">

			<div class="modal-header">

				<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>

				<h4 class="modal-title">Add User</h4>

			</div>

			<div class="modal-body">

				<form class="form-horizontal" role="form" id="user_form">

					<input type="submit" class="hidden" id="user_submit">

					<input type="reset" class="hidden" id="user_reset">

					<input type="hidden" name="id" value="<?php echo $app["id"] ?>" id="id">

					<div class="form-body">

						<div class="form-group">

							<label class="col-md-3 control-label">Installation</label>

							<div class="col-md-9">

								<select class="form-control" name="installation" id="user_installation">

									<option value="">== Select installation ==</option>

									<?php foreach ( $installations["rows"] as $installation ) { ?>

										<option value="<?php echo $installation["id"] ?>"><?php echo $installation["domain"] ?></option>

									<?php } ?>

								</select>

							</div>

						</div>

						<div class="form-group">

							<label class="col-md-3 control-label">Username</label>

							<div class="col-md-9">

								<input type="text" name="username" id="user_username" class="form-control" placeholder="Username" required="required">

							</div>

						</div>

						<div class="form-group">

							<label class="col-md-3 control-label">Password</label>

							<div class="col-md-9">

								<input type="text" name="password" id="user_password" class="form-control" placeholder="Password" required="required">

							</div>

						</div>

					</div>

				</form>

			</div>

			<div class="modal-footer">

				<button type="button" class="btn dark btn-outline" data-dismiss="modal">Close</button>

				<button type="button" onclick="$('#user_submit').click();" class="btn green">Add user</button>

			</div>

		</div>

		<!-- /.modal-content -->

	</div>

	<!-- /.modal-dialog -->

</div>

<div class="container-fluid bg-white">

	<div class="row">

		<div class="col-md-4">

			<h3>User Info</h3>

			<table class="table table-bordered table-hover table-striped" id="user_info_table">

				<tbody>

				<tr>

					<td class="bold">Full name</td>

					<td><?php echo $app["full_name"] ?></td>

					<td class="bold">Email</td>

					<td><?php echo $app["email"] ?></td>

				</tr>

				<tr>

					<td class="bold">Phone</td>

					<td><?php echo $app["phone"] ?></td>

					<td class="bold">Address</td>

					<td><?php echo $app["address"] ?></td>

				</tr>

				<tr>

					<td class="bold">City</td>

					<td><?php echo $app["city"] ?></td>

					<td class="bold">Country</td>

					<td><?php echo $app["country"] ?></td>

				</tr>

				<tr>

					<td class="bold">Password</td>

					<td colspan="3"><input class="form-control" type="text" id="password" placeholder="Change password">

					</td>

				</tr>

				</tbody>

			</table>

			<br><br>

			<button type="button" id="adduser_btn" class="btn btn-md btn-primary"><i class="fa fa-user"></i> Add User

			</button>

			<button type="button" id="deluser_btn" class="btn btn-md btn-danger">

				<i class="fa fa-trash"></i> Delete Installation

			</button>

			<button type="button" class="btn btn-md red" onclick="parent.$.fancybox.close();" class="btn green">

				<i class="fa fa-times"></i> Close

			</button>

			<button data-id="<?php echo $app["id"] ?>" type="button" id="email_btn" class="btn blue"><i class="fa fa-envelope"></i> Email</button>



			<br><br>

		</div>

		<div class="col-md-8">

			<h3>Installations</h3>

			<?php

			$server = "136.243.69.139";

			if ( $installations["total_records"] == 0 ) {

				echo "<i>-- No installation found --</i>";

			} else { ?>

				<table class="table table-bordered table-hover table-striped" id="installations_table">

					<thead>

					<tr class="heading">

						<th>Domain</th>

						<th>Contact</th>

						<th>Address</th>

						<th>Info</th>

					</tr>

					</thead>

					<tbody>

					<?php foreach ( $installations["rows"] as $installation ) {

						$ver = $installation["ver"];

						if ( version_compare( $installation["ver"], $db->get_option( "version" ), "<" ) ) {

							$ver = "<span data-pk='{$installation['pk']}' data-domain='{$installation['domain_url']}' title='Install latest version' class='install label label-warning pointer'>{$installation["ver"]}</span>";

						} else {

							$ver = "<span data-pk='{$installation['pk']}' data-domain='{$installation['domain_url']}' title='Install latest version' class='install label label-success pointer'>{$installation["ver"]}</span>";

						}

						?>

						<tr>

							<td>

								<?php echo $installation["institute"] ?><br><br>

								<?php echo $installation["domain_url"] ?>

							</td>

							<td>

								<?php echo $installation["email"] ?><br><br>

								<?php echo $installation["phone"] ?>

							</td>

							<td>

								<?php echo $installation["address"] ?>

								<br>

								<?php echo $installation["city"] . "/" . $installation["country"]; ?>

							</td>

							<td><?php echo human_time_diff( $installation["added_time"] ); ?><br><br>

								<?php echo $ver ?></td>

						</tr>

						<tr>

							<td colspan="8">

								Students:

								<?php

								$response = $App->execute_api( [

									"id"      => $installation['id'],

									"command" => 'get_var',

									"data"    => "SELECT COUNT(*) FROM `students`",

								] );

								echo "<b>" . $response . "</b>";

								?>

								, Classes:

								<?php

								$response = $App->execute_api( [

									"id"      => $installation['id'],

									"command" => 'get_classes_count',

								] );

								echo "<b>" . $response . "</b>";

								?>

								, Active Classes:

								<?php

								$response = $App->execute_api( [

									"id"      => $installation['id'],

									"command" => 'get_active_classes_count',

								] );

								echo "<b>" . $response . "</b>";

								?>

								, Admin Users:

								<?php

								$admin_users = $App->execute_api( [

									"id"      => $installation['id'],

									"command" => 'get_var',

									"data"    => "SELECT COUNT(*) FROM `admins`",

								] );

								echo "<b>" . $admin_users . "</b>";

								?>

							</td>

						</tr>

						<?php if ( $admin_users > 0 ) { ?>

							<tr>

								<td colspan="4">

									<?php $rows = $App->execute_api([

										"id"      => $installation['id'],

										"command" => 'get_rows',

										"data"    => "SELECT * FROM `admins`",

									]);

									$rows = json_decode( $rows);

									foreach($rows as $row) {

										echo "<div class='btn-group'><button style='margin:0' type='button' class='btn btn-xs'>(".

										     $row->id.") ".

										     $row->username.

										     "</button>".

										     "<a data-id='{$installation['id']}' style='margin:0' title='Update password' class='update_pass btn btn-xs btn-primary' href='?update_user_pass={$row->id}'><i class='fa fa-key'></i></a>".

											 "<a data-id='{$installation['id']}' title='Delete this admin user' class='del_link btn btn-xs red' href='?del_admin={$row->id}'><i class='fa fa-trash'></i></a></div> ";

									}

									?>

								</td>

							</tr>

						<?php } ?>

					<?php } ?>

					</tbody>

				</table>

			<?php } ?>

			<h3>Email History</h3>

			<?php $Q = "SELECT * FROM `email_logs` WHERE `to` LIKE '%{$app['email']}%' ORDER BY `id` DESC";

			$emails  = get_rows( $Q );

			if ( count( $emails ) == 0 ) {

				echo "<i>-- No email history --</i>";

			} else {

				?>

				<table class="table table-bordered table-hover table-striped" id="email_history_table">

					<thead>

					<tr class="heading">

						<th>To</th>

						<th>Subject</th>

						<th>Time</th>

					</tr>

					</thead>

					<tbody>

					<?php foreach ( $emails as $email ) {

						if ( is_json( $email["to"] ) ) {

							$email["to"] = json_decode( $email["to"], true );

							$email["to"] = implode( ", ", $email["to"] );

						}

						?>

						<tr>

							<td><?php echo $email["to"] ?></td>

							<td><?php echo $email["subject"] ?></td>

							<td><?php echo human_time_diff( $email["sent_time"] ) ?></td>

						</tr>

					<?php } ?>

					</tbody>

				</table>

			<?php } ?>

			<br><br>

		</div>

	</div>

</div>

<?php #show_array($app); ?>

<?php include_once "footer_scripts.php"; ?>

<script>

	$( function() {

		$( ".container-fluid" ).linkify();

		$( "#user_info_table, #installations_table, #email_history_table" ).table();

		$( document ).on( "click", ".install", function() {

			domain = $( this ).data( 'domain' );

			pk = $( this ).data( "pk" );

			$( "#loading" ).show();

			$.post( "<?php echo filename() ?>?install", { domain: domain, pk: pk }, function( data ) {

				$( "#loading" ).hide();

				if ( data == "OK" ) {

					Success( "Updated successfully!" );

					window.open( "http://" + domain );

					window.location.reload();

				} else {

					Error2( data );

				}

			} );

		} );

		$( document ).on( "click", "#adduser_btn", function() {

			$( "#userDiv" ).modal( "show" );

		} );

		$( document ).on( "click", "#deluser_btn", function() {

			$( "#delDiv" ).modal( "show" );

		} );

		$( document ).on( "submit", "#user_form", function() {

			if ( $( "#user_installation" ).val() == "" ) {

				Error2( "Select installation!" );

				return false;

			}

			if ( $.trim( $( "#user_username" ).val() ) == "" ) {

				Error2( "Type username" );

				return false;

			}

			if ( $.trim( $( "#user_password" ).val() ) == "" ) {

				Error2( "Type password" );

				return false;

			}



			$( "#userDiv" ).modal( "hide" );

			Block();

			$.post( "<?php echo filename(); ?>?add_user", $( "#user_form" ).serialize(), function( data ) {

				UnBlock();

				if ( data.substr( 0, 2 ) == "OK" ) {

					Success( "New user added!" );

				} else {

					Error2( data );

					$( "#userDiv" ).modal( "show" );

				}

			} );



			return false;

		} );

		$( document ).on( "submit", "#del_form", function() {

			if ( $( "#del_installation" ).val() == "" ) {

				Error2( "Select installation!" );

				return false;

			}

			$( "#delDiv" ).modal( "hide" );

			Block();

			$.post( "<?php echo filename(); ?>?del_installation", $( "#del_form" ).serialize(), function( data ) {

				UnBlock();

				if ( data.substr( 0, 2 ) == "OK" ) {

					Success( "Installation delete successfully!" );

					window.location.reload();

				} else {

					alert( data );

				}

			} );

			return false;

		} );

		$( document ).on( "change", "#password", function() {

			if ( $( "#password" ).val() == "" ) {

				return;

			}

			pwd = $( "#password" ).val();

			$( "#password" ).val( '' );

			$.post( "<?php echo filename(); ?>?update_password", {

				id:<?php echo $id; ?>,

				"new_password": pwd

			}, function( data ) {

				alert( data );

			} );

		} );

		$( document ).on( "keypress", "#password", function( e ) {

			if ( e.which != "13" ) {

				return;

			}

			if ( $( "#password" ).val() == "" ) {

				return;

			}

			pwd = $( "#password" ).val();

			$( "#password" ).val( '' );

			$.post( "<?php echo filename(); ?>?update_password", {

				id:<?php echo $id; ?>,

				"new_password": pwd

			}, function( data ) {

				if ( data == "OK" ) {

					alert( "Password updated successfully!" );

				} else {

					alert( data );

				}

			} );

		} );

		$(document).on("click", ".del_link", function( event ) {

			event.preventDefault();

			if (!confirm("Are you sure you want to delete this admin account?")) return false;

			$this = $(this);

			id = $this.data('id');



			$.post("<?php echo filename() ?>" + $(this).attr('href') + "&id=" + id, function( data ) {

				if (data=="OK") {

					$this.parent().remove();

				} else {

					Error (data);

				}

			} );

		});

		$(document).on("click", ".update_pass", function( event ) {

			event.preventDefault();



			var new_pass = window.prompt("Type new password.", "");



			$this = $(this);

			id = $this.data('id');



			if (new_pass) {

				$.post("<?php echo filename() ?>" + $(this).attr('href'), {id:id,new_pass:new_pass}, function( data ) {

					if (data=="OK") {

						Success("Password changed successfully!");

					} else {

						Error(data);

					}

				} );

			}

		});

		$( document ).on( "click", "#email_btn", function(e) {

			e.preventDefault();

			id = $( this ).attr( "data-id" );

			parent.open_email( id );

		} );

	} );

</script>

</body>

</html>