<?php

include_once "_init.php";

$Apps = new \Apps;



$Apps           = new \User();

$verified_phone = $Apps->get_verified_phone();

$install        = $Apps->get_install(get_my_id());



if (!empty($install)) {

    redirect(DOMAIN_URL."index.php");

    exit();

}



if (empty($verified_phone) && ! empty($_SESSION['phone_for_verification'])) {

    $verified_phone = $_SESSION['phone_for_verification'];

}



$__title = "Installation Wizard";

include_once(__DIR__."/header.php"); ?>

<!-- BEGIN CONTAINER -->



<?php $countries = get_countries(); ?>

<select class="form-control hidden" id="country">

	<option value="">== Select Country ==</option>

    <?php foreach ($countries as $country) { ?>

		<option data-val="<?php echo $country['alpha_2'] ?>"><?php echo $country['name'] ?></option>

    <?php } ?>

</select>



<div class="modal fade" id="numberDiv" data-backdrop="static" tabindex="-1" role="basic" aria-hidden="true">

	<div class="modal-dialog">

		<div class="modal-content">

			<div class="modal-header">

				<!--<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>-->

				<h4 class="modal-title">Verify your number</h4>

			</div>

			<div class="modal-body">

				<form class="form-horizontal" role="form" id="verify_form">

					<input type="submit" id="verify_submit" class="display-none">

					<div class="note note-success" id="message">We've sent you a verification code via SMS/Voice.</div>

					<div class="note note-info">

						Verification SMS/Voice Call can take up to 2 min‌ut‌es, please be patient and do not close this

						window

					</div>

					<div class="form-body">

						<div class="form-group">

							<label for="pin_code" class="col-md-6 control-label">Type received code:</label>

							<div class="col-md-6">

								<input type="text" name="pin_code" id="pin_code" class="form-control"

								       placeholder="Received code" required="required">

							</div>

						</div>

					</div>

					<div class="note note-danger display-none" id="verify_order"></div>

				</form>

			</div>

			<div class="modal-footer">

				<!--<button type="button" class="btn dark btn-outline" data-dismiss="modal">Close</button>-->

				<div class="btn-group">

					<button type="button" id="change_btn" class="btn btn-danger">Change Number</button>

					<button type="button" id="resend_btn" class="btn btn-info">Resend Code</button>

					<button type="button" id="verify_btn" onclick="$('#verify_submit').click();" class="btn green">

						Verify Number

					</button>

				</div>

			</div>

		</div>

		<!-- /.modal-content -->

	</div>

	<!-- /.modal-dialog -->

</div>



<div class="container-fluid">

	<div class="page-content page-content-popup">

		<div class="page-content-fixed-header">

			<!-- BEGIN BREADCRUMBS -->

			<ul class="page-breadcrumb">

				<li>

					<a href="<?php echo DOMAIN_URL; ?>">Home</a>

				</li>

				<li>Installation Wizard</li>

			</ul>



			<div class="content-header-menu">

				<button type="button" class="menu-toggler responsive-toggler" data-toggle="collapse"

				        data-target=".navbar-collapse">

                    <span class="toggle-icon">

                        <span class="icon-bar"></span>

                        <span class="icon-bar"></span>

                        <span class="icon-bar"></span>

                    </span>

				</button>

			</div>

		</div>

        <?php include_once(__DIR__."/sidebar.php"); ?>

		<div class="page-fixed-main-content">

			<!-- BEGIN PAGE BASE CONTENT -->

			<div class="note note-success">

				<p>

					Thank you for signing up with Fekara Lite. Please click the button below to complete your school

					setup.<br>

					<span style="font-size:80%;color: #0260cc;">(We'll verify your number)</span>

					<br><br>

					<button type="button" id="button1" class="btn green">Setup My School/Institute</button>

				</p>

			</div>



			<form class="display-none horizontal-form" id="form1" method="post" action="ajax/wizard.php?install_fekara"

			      autocomplete="off" role="presentation">

				<div class="form-body">

					<div class="row">

						<div class="col-md-4">

							<div class="form-group">

								<label for="institute" class="control-label pointer">Institute Name</label>

								<span class="required">*</span>

								<input value="" type="text" id="institute" name="institute" class="form-control"

								       placeholder="Institute name" data-required="1" required="required">

							</div>

						</div>

						<div class="col-md-4">

							<div class="form-group">

								<label for="phone" class="control-label pointer">Institute Phone</label>

								<span class="required">*</span>

								<input value="<?php echo $verified_phone ?>" type="text" id="phone" name="phone"

								       class="form-control phone" placeholder="Institute phone" data-required="1"

								       required="required">

							</div>

						</div>

						<div class="col-md-3">

							<div class="form-group">

								<label class="control-label" style="display:block">&nbsp;</label>

								<a title="Verify Phone number" href="javascript:;" class="btn red"

								   id="verify_phone_link">

									<i class="fa fa-question"></i> Verify Phone Number

								</a>

							</div>

						</div>

					</div>

					<div class="row">

						<div class="col-md-4">

							<div class="form-group">

								<label for="address" class="control-label pointer">Institute Address</label>

								<span class="required">*</span>

								<input value="" type="text" id="address" name="address" class="form-control"

								       autocomplete="off" data-lpignore="true"

								       placeholder="Address" data-required="1" required="required">

							</div>

						</div>

						<div class="col-md-4">

							<div class="form-group">

								<label for="city" class="control-label pointer">Institute City</label>

								<span class="required">*</span>

								<input value="" type="text" id="city" name="city" class="form-control"

								       data-lpignore="true"

								       placeholder="City" data-required="1" required="required">

							</div>

						</div>

						<div class="col-md-4">

							<div class="form-group">

								<label for="address" class="control-label pointer">Institute Country</label>

								<span id="country_span" readonly="readonly" class="form-control"></span>

							</div>

						</div>

						<!--<div class="col-md-4">

							<div class="form-group">

								<label for="logo" class="control-label pointer">Logo</label>

								<input type="file" id="logo" name="logo" class="form-control" placeholder="Image logo" accept="image/*">

							</div>

						</div>-->

					</div>

					<!--<div class="row">

                        <div class="col-md-12">

                            <div class="form-group">

                                We use PHP date format for setting date/time formats. Please <a href="http://php.net/manual/en/function.date.php#refsect1-function.date-parameters" target="_blank">click here</a> for format help.

                            </div>

                        </div>

                    </div>

                    <div class="row">

                        <div class="col-md-4">

                            <div class="form-group">

                                <label for="date_format" class="control-label pointer">Date format (<small>e.g. d-M-Y for <?php /*echo date("d-M-Y") */ ?></small>)</label>

                                <input value="d-M-Y" type="text" id="date_format" name="date_format" class="form-control" placeholder="Date format" required="required">

                            </div>

                        </div>

                        <div class="col-md-4">

                            <div class="form-group">

                                <label for="time_format" class="control-label pointer">Time format (<small>e.g. h:i A for <?php /*echo date("h:i A") */ ?></small>)</label>

                                <input value="H:i A" type="text" id="time_format" name="time_format" class="form-control" placeholder="Time format" required="required">

                            </div>

                        </div>

                        <div class="col-md-4">

                            <div class="form-group">

                                <label for="datetime_format" class="control-label pointer">Date Time format(<small>e.g. d-M-Y H:i A for <?php /*echo date("d-M-Y H:i A") */ ?></small>)</label>

                                <input value="d-M-Y H:i A" type="text" id="datetime_format" name="datetime_format" class="form-control" placeholder="Date time format" required="required">

                            </div>

                        </div>

                    </div>-->

				</div>

				<div class="form-actions text-right">

					<button disabled class="btn blue disabled" id="main_submit_button" disabled="disabled">

						<i class="fa fa-check"></i> Install feKara App for my School/Institute

					</button>

				</div>

			</form>

			<!-- END PAGE BASE CONTENT -->

			<br><br><br><br><br><br><br><br><br><br><br><br>

		</div>

        <?php include_once(__DIR__."/footer.php"); ?>

	</div>

</div>

<!-- END CONTAINER -->

<?php include_once(__DIR__."/footer_scripts.php"); ?>

<script src="assets/scripts/wizard.js?<?php echo md5_file(__DIR__.'/assets/scripts/wizard.js'); ?>"></script>

<script>

    <?php

    if (isset($_SESSION['phone_verified']) && $_SESSION['phone_verified']) {

        $verified = true;

    } else {

        if ($verified_phone) {

            $verified = true;

        } else {

            $verified = false;

        }

    }

    ?>

	var verified = <?php echo $verified ? 'true' : 'false' ?>;

	var phone = "<?php echo ! empty($verified_phone) ? $verified_phone : get_app("phone"); ?>";

</script>

</body>

</html>