<?php include_once( __DIR__ . "/../library.php" );
include_once( __DIR__ . "/header.php" );
$s        = new \Student\Files();
$T        = new Teacher();
$teachers = $T->get_teachers( 'active=1&mysql_cols=id,name' );
$TT       = [];
?>
<link rel="stylesheet" href="assets/css/pages/files_x_teachers.min.css?<?php echo md5_file( __DIR__ . '/assets/css/pages/files_x_teachers.min.css' ) ?>">
<div class="page-container">
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( "Dashboard" ) ?>
						<small><?php _e( "Share files with teachers" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php"><?php echo _e( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href=""><?php _e( "Upload files" ) ?></a>
						</li>
					</ul>
				</div>
			</div>
			<?php //echo $S['id'];
			//show_array( $s->get_files( 3418, true ) ) ?>

			<div class="row">
				<div class="col-md-12">
					<select id="teacher_id" class="select2" style="max-width: 200px;width:100%">
						<option value="0">-- Select teacher --</option>
						<?php
						foreach ( $teachers as $teacher ) {
							$TT[ $teacher['id'] ] = $teacher['name'];
							?>
							<option value="<?php echo $teacher['id'] ?>"><?php echo $teacher['name'] ?></option>
						<?php } ?>
					</select>
					<i class="fa fa-arrow-left"></i> Submit files to this teacher
					<div id="drop-area">
						<form class="my-form">
							<p>Upload multiple allowed files with the file dialog or by dragging and dropping onto the dashed region</p>
							<p>Note: Select teacher above before upload files</p>
							<input type="file" id="fileElem" multiple accept="<?php echo ALLOWED_FILES ?>" onchange="handleFiles(this.files)">
							<label class="button" for="fileElem"><i class="fa fa-upload"></i> <?php echo __("Select files") ?></label>
						</form>
					</div>

					<div id="upload">

					</div>

					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-users"></i>
								<?php _e( "Uploaded files" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<div id="files">
								<div v-for="teachers, teacher_id in files" id="files_sub_div">
									<div class="heading">Files for teacher "{{Teachers[teacher_id]}}"</div>
									<div class="file-group" v-for="file in teachers" style="margin: 3px;">
										<a target="_blank" :href="file.file_url" class="btn btn-success" :title="file.filename">
											{{file.filename}}
										</a>
										<button type="button" class="btn btn-danger del_btn" :data-id="file.id">
											<i class="fa fa-trash"></i>
										</button>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="clearfix">
			</div>

		</div>
	</div>
	<!-- END CONTENT -->
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>
<script src="https://cdnjs.cloudflare.com/ajax/libs/vue/2.5.21/vue.min.js"></script>
<script>
	var Teachers = <?php echo json_encode( $TT ) ?>;

	var Files = new Vue( {
		el: '#files',
		data: function() {
			return {
				files: {}
			}
		}
	} );

	function teacher_name( teacher_id ) {
		$.each( Teachers, function( i, T ) {
			if ( T.id==teacher_id ) {
				return T.name;
			}
		} )

		//return teacher_id;
	}

	var load_files = function() {
		$.ajax( {
			url: 'ajax/files_x_teachers.php?get_files',
			data: { student_id: <?php echo $S['id'] ?>},
			method: 'post',
			success: function( data ) {
				Files.files = data;
				//console.table(data)

				setTimeout( load_files, 5000 );
			},
			error: function() {
				setTimeout( load_files, 5000 );
			}
		} )
	}

	$( function() {
		load_files()

		$( document ).on( "click", ".del_btn", function( event ) {
			event.preventDefault();
			id = $( this ).attr( 'data-id' )
			if ( !confirm( 'Are you sure you want to delete this file?' ) ) {
				return false;
			}

			$.ajax( {
				url: 'ajax/files_x_teachers.php?delete',
				method: 'post',
				data: { id: id },
				success: function( data ) {
					if ( data.status && data.status=='OK' ) {
						Success( 'File deleted ...' )
					} else if ( data.status ) {
						Error( data.status )
					} else {
						Error( data );
					}
				},
				Error: function( e1, e2, e3 ) {
					Error( e3 );
				}
			} )
		} )
	} );

	var dropArea = document.getElementById( 'drop-area' )
	;[ 'dragenter', 'dragover', 'dragleave', 'drop' ].forEach( eventName=>{
		dropArea.addEventListener( eventName, preventDefaults, false )
	} )
	;[ 'dragenter', 'dragover' ].forEach( eventName=>{
		dropArea.addEventListener( eventName, highlight, false )
	} )
	;[ 'dragleave', 'drop' ].forEach( eventName=>{
		dropArea.addEventListener( eventName, unhighlight, false )
	} )
	dropArea.addEventListener( 'drop', handleDrop, false );

	function highlight( e ) {
		dropArea.classList.add( 'highlight' );
	}

	function unhighlight( e ) {
		dropArea.classList.remove( 'highlight' );
	}

	function preventDefaults( e ) {
		e.preventDefault();
		e.stopPropagation();
	}

	function handleDrop( e ) {
		var dt = e.dataTransfer;
		var files = dt.files;

		handleFiles( files );
	}

	function handleFiles( files ) {
		([ ...files ]).forEach( uploadFile );
	}

	function uploadFile( file ) {
		if ( $( '#teacher_id' ).val()==0 ) {
			alert( 'Please select teacher before upload files' );
			$( '#teacher_id' ).select();
			return false;
		}

		var url = 'ajax/files_x_teachers.php?files';
		var formData = new FormData();
		formData.append( 'file', file );
		formData.append( 'student_id', '<?php echo $S['id'] ?>' );
		formData.append( 'teacher_id', $( '#teacher_id' ).val() );

		var xhr = new XMLHttpRequest();
		xhr.open( 'POST', url, true );
		xhr.addEventListener( 'readystatechange', function( e ) {
			if ( xhr.readyState==4 && xhr.status==200 ) {
				// Done. Inform the user
				// console.log( e );
				object = JSON.parse( e.srcElement.response );
				if ( object.status=='OK' ) {
					Success( 'File uploaded successfully!' );
				} else {
					Error( object.status );
				}
			} else if ( xhr.readyState==4 && xhr.status!=200 ) {
				// Error. Inform the user
				alert( 'Error: ' + e.response );
			}
		} );
		xhr.upload.addEventListener( "progress", function( event ) {
			var percent = (event.loaded / event.total) * 100;
			//**percent** variable can be used for modifying the length of your progress bar.
			console.log( percent );

		} );
		xhr.send( formData );
	}

</script>
</body>
</html>