<?php
include_once( __DIR__ . "/../library.php" );
if (!defined("VERSION")) {
	echo "Invalid installation";
	exit;
}
$_filename = basename( $_SERVER['SCRIPT_FILENAME'] );
$s         = new Student();
if ( ! $s->is_student_logged_in() ) {
	Urls::redirect( "login.php" );
}
$S = $s->get_student( $s->my_id() );
?><!DOCTYPE html>
<!--[if IE 8]>
<html lang="en" class="ie8 no-js"> <![endif]-->
<!--[if IE 9]>
<html lang="en" class="ie9 no-js"> <![endif]-->
<!--[if !IE]><!-->
<html lang="en" class="no-js">
<!--<![endif]-->
<!-- BEGIN HEAD -->
<head>
	<meta charset="utf-8">
	<?php if ( ! isset( $_title ) ) {
		$_title = System;
	} ?>
	<title><?php echo $_title ?> | Student panel</title>
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta content="width=device-width, initial-scale=1.0" name="viewport" />
	<meta content="" name="description" />
	<meta content="" name="author" />
	<meta name="MobileOptimized" content="320">
	<!-- BEGIN GLOBAL MANDATORY STYLES -->
	<?php load_css_files() ?>
	<link href="<?php echo \Theme::url() ?>style.css?<?php echo $_SERVER["HTTP_HOST"] == "localhost" ? time() : Version ?>"
	      rel="stylesheet" type="text/css">
	<!-- END THEME STYLES -->
	<link rel="shortcut icon" href="<?php echo DOMAIN_URL ?>favicon.ico">
	<script>
		var theme_url = "<?php echo \Theme::url() ?>";
		var root_url = "<?php echo DOMAIN_URL ?>";
	</script>
</head>
<!-- END HEAD -->
<!-- BEGIN BODY -->
<body class="page-header-fixed page-full-width">
<!-- BEGIN HEADER -->
<div class="header navbar navbar-inverse navbar-fixed-top">
	<!-- BEGIN TOP NAVIGATION BAR -->
	<div class="header-inner">
		<!-- BEGIN LOGO -->
		<a class="navbar-brand" href="<?php echo $s->get_student_panel_url() ?>">
			<img src="<?php echo App::get_logo() ?>" alt="logo" style="max-width:84px;max-height:14px"
			     class="img-responsive">
		</a>
		<!-- END LOGO -->
		<!-- BEGIN HORIZANTAL MENU -->
		<?php
		$menu_array = array(
			"index.php" => [
				"title"    => __( "Dashboard" ),
				"sub_menu" => [
					"index.php"           => __( "Home" ),
					"profile.php"         => __( "Profile" ),
					"change_password.php" => __( "Change Password" ),
				],
				"new_menu" => [
					"profile.php",
				],
			],
			"data.php"  => [
				"title"    => __( "Data" ),
				"sub_menu" => [
					"teacher_assignments.php" => __( "Teacher Assignments" ),
				],
				"new_menu" => [
					"teacher_assignments.php",
				],
			]
		);
		?>
		<div class="hor-menu hidden-sm hidden-xs">
			<ul class="nav navbar-nav">
				<?php
				foreach ( $menu_array as $k => $sub_menu ) {
					if ( ! is_array( $sub_menu ) ) { ?>
						<li class="<?php echo $_filename == $k ? "active" : ""; ?>">
							<a href="index.php"><?php echo $sub_menu ?></a>
						</li>
					<?php } else { ?>
						<li class="<?php echo array_key_exists( $_filename, $sub_menu["sub_menu"] ) ? "active" : ""; ?>">
							<a data-toggle="dropdown" data-hover="dropdown" data-close-others="true"
							   class="dropdown-toggle"
							   href="javascript:;">
								<?php if ( array_key_exists( $_filename, $sub_menu["sub_menu"] ) ) { ?>
									<span class="selected"></span>
								<?php } ?>
								<?php echo $sub_menu["title"] ?> <i class="fa fa-angle-down"></i>
							</a>
							<ul class="dropdown-menu">
								<?php foreach ( $sub_menu["sub_menu"] as $k2 => $v ) { ?>
									<li class="<?php echo $_filename == $k2 ? "active" : ""; ?>">
										<a href="<?php echo $k2; ?>">
											<?php if ( isset( $sub_menu["new_menu"] ) && in_array( $k2, $sub_menu["new_menu"] ) ) { ?>
												<span class="badge badge-roundless badge-important"><?php _e( "New" ) ?></span>
											<?php } ?>
											<?php echo $v; ?>
										</a>
									</li>
								<?php } ?>
							</ul>
						</li>
					<?php }
				}
				?>
			</ul>
		</div>
		<!-- END HORIZANTAL MENU -->
		<!-- BEGIN RESPONSIVE MENU TOGGLER -->
		<a href="javascript:;" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
			<img src="<?php echo ASSETS_URL ?>img/menu-toggler.png" alt="" />
		</a>
		<!-- END RESPONSIVE MENU TOGGLER -->
		<!-- BEGIN TOP NAVIGATION MENU -->
		<ul class="nav navbar-nav pull-right">
			<!-- BEGIN USER LOGIN DROPDOWN -->
			<li class="dropdown user">
				<a href="#" class="dropdown-toggle" data-toggle="dropdown" data-hover="dropdown"
				   data-close-others="true">
					<img alt="<?php echo $S["name"]; ?>" src="<?php echo $S["photo"] ?>" width="20" />
					<span class="username">
					<?php echo $S["name"]; ?>
				</span>
					<i class="fa fa-angle-down"></i>
				</a>
				<ul class="dropdown-menu">
					<li>
						<a href="profile.php"><i class="fa fa-user"></i> My Profile</a>
					</li>
					<li>
						<a href="change_password.php"><i class="fa fa-pencil"></i> Change Password</a>
					</li>
					<li>
						<a href="logout.php"><i class="fa fa-key"></i> Log Out</a>
					</li>
				</ul>
			</li>
			<!-- END USER LOGIN DROPDOWN -->
		</ul>
		<!-- END TOP NAVIGATION MENU -->
	</div>
	<!-- END TOP NAVIGATION BAR -->
</div>
<!-- END HEADER -->
<div class="clearfix">
</div>