<?php
$_title = "Student Dashboard";
include_once( __DIR__ . "/header.php" );
if ( ! empty( $S["Subjects"] ) ) {
	$subjects = $S["Subjects"];
} else {
	$subjects = [];
}
$t = new Teacher();
$T = $t->getClassForStudentSubject( $S["class_id"] );
$StudentFile = new \Student\Files();
?>
<div class="page-container">
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( "Dashboard" ) ?>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php"><?php _e( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="index.php"><?php _e( "Dashboard" ) ?></a>
						</li>
					</ul>
				</div>
			</div>

			<div class="row">
				<div class="col-lg-3 col-md-3 col-sm-6 col-xs-12">
					<div class="dashboard-stat green">
						<div class="visual">
							<i class="fa fa-upload"></i>
						</div>
						<div class="details">
							<div class="number">
								<?php echo $StudentFile->files_counter($S['id']); ?>
							</div>
							<div class="desc">
								<?php _e('Files for teachers') ?>
							</div>
						</div>
						<a class="more" href="files_x_teachers.php">
							<?php _e('Manage/Upload files') ?> <i class="m-icon-swapright m-icon-white"></i>
						</a>
					</div>
				</div>
			</div>

			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<?php _e( "View Subjects" ); ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form action="#" class="form-horizontal form-bordered" onsubmit="return Save(this)">
								<div class="form-body">
									<table class="table table-bordered table-striped">
										<thead>
										<tr>
											<th style="width:10px">#</th>
											<th><?php _e( "Subject" ) ?></th>
											<th><?php _e( "Assignment" ) ?></th>
										</tr>
										</thead>
										<tbody>
										<?php
										if ( ! empty( $subjects ) ) {
											foreach ( $subjects as $k => $row ) {
												?>
												<tr>
													<td style="text-align: center"><?php echo $k + 1; ?></td>
													<td><?php echo $row ?></td>
													<td>
														<?php foreach ( $T as $r ) {
															if ( $r["subject_name"] == $row ) {
																?>
																<a href="<?php echo DOMAIN_URL . 'includes/downloader.php?path=teacher/' . $r["teacherid"] . '/' . $r["file_name"] ?>">
																	<?php echo $r["file"]; ?>
																</a>
															<?php }
														} ?>
													</td>
												</tr>
											<?php }
										} else { ?>
											<tr>
												<td colspan="3" style="text-align: center">-</td>
											</tr>
										<?php } ?>
										</tbody>
									</table>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<div class="clearfix">
			</div>

		</div>
	</div>
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>
</body>
</html>