<?php include_once( __DIR__ . "/../library.php" );
if ( ! defined( "VERSION" ) ) {
	echo "Invalid installation!";
	exit;
}
$student = new Student();
if ( $student->is_student_logged_in() ) {
	Urls::redirect( "index.php" );
}
if ( isset( $_GET["login"] ) ) {
	echo $student->login( $_POST );
	exit;
}
?><!DOCTYPE html>
<!--[if IE 8]>
<html lang="en" class="ie8 no-js"> <![endif]-->
<!--[if IE 9]>
<html lang="en" class="ie9 no-js"> <![endif]-->
<!--[if !IE]><!-->
<html lang="en" class="no-js">
<!--<![endif]-->
<!-- BEGIN HEAD -->
<head>
	<meta charset="utf-8" />
	<title><?php _e( "Student Panel" ) ?> - <?php echo System ?></title>
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta content="width=device-width, initial-scale=1.0" name="viewport" />
	<meta content="" name="description" />
	<meta content="" name="author" />
	<meta name="MobileOptimized" content="320">
	<!-- BEGIN GLOBAL MANDATORY STYLES -->
	<link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" rel="stylesheet" type="text/css">
	<link href="<?php echo ASSETS_URL ?>plugins/bootstrap/css/bootstrap.min.css" rel="stylesheet" type="text/css">
	<link href="<?php echo ASSETS_URL ?>plugins/uniform/css/uniform.default.css" rel="stylesheet" type="text/css">
	<!-- END GLOBAL MANDATORY STYLES -->
	<!-- BEGIN PAGE LEVEL STYLES -->
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/select2/select2_metro.css" />
	<!-- END PAGE LEVEL SCRIPTS -->
	<!-- BEGIN THEME STYLES -->
	<link href="<?php echo ASSETS_URL ?>css/style-metronic.css" rel="stylesheet" type="text/css" />
	<link href="<?php echo ASSETS_URL ?>css/style.css" rel="stylesheet" type="text/css" />
	<link href="<?php echo ASSETS_URL ?>css/style-responsive.css" rel="stylesheet" type="text/css" />
	<link href="<?php echo ASSETS_URL ?>css/plugins.css" rel="stylesheet" type="text/css" />
	<link href="<?php echo ASSETS_URL ?>css/themes/default.css" rel="stylesheet" type="text/css"
	      id="style_color">
	<link href="<?php echo ASSETS_URL ?>css/pages/login-soft.css" rel="stylesheet" type="text/css">
	<link href="<?php echo ASSETS_URL ?>css/custom.css?<?php echo \General::localhost() ? time() : "2" ?>"
	      rel="stylesheet" type="text/css">
	<!-- END THEME STYLES -->
	<link rel="shortcut icon" href="<?php echo DOMAIN_URL ?>favicon.ico">
</head>
<!-- END HEAD -->
<!-- BEGIN BODY -->
<body class="login">
<div class="loading">Loading&#8230;</div>
<!-- BEGIN LOGO -->
<div class="logo">
	<img src="<?php echo App::get_logo() ?>" alt="" style="max-height:150px;max-width: 150px" />
</div>
<div class="content">
	<!-- BEGIN LOGIN FORM -->
	<form class="login-form" action="index.php" method="post" id="login_form">
		<h3 class="form-title">
			<?php _e( "Login to your account" ) ?>
		</h3>
		<div class="alert alert-danger display-hide">
			<button class="close" data-close="alert"></button>
			<span>
				 <?php _e( "Enter any username and password." ) ?>
			</span>
		</div>
		<div class="form-group">
			<!--ie8, ie9 does not support html5 placeholder, so we just show field title for that-->
			<label class="control-label visible-ie8 visible-ie9">
				<?php echo __( "Admission number" ) ?>
			</label>
			<div class="input-icon">
				<i class="fa fa-user"></i>
				<input class="form-control placeholder-no-fix" type="number" autocomplete="off"
				       placeholder="Admission number" required="required" title="<?php echo __( "Student's admission number required" ) ?>"
				       name="admission_number" id="admission_number">
			</div>
		</div>
		<div class="form-group">
			<label class="control-label visible-ie8 visible-ie9">
				<?php echo __( "Password" ) ?>
			</label>
			<div class="input-icon">
				<i class="fa fa-lock"></i>
				<input class="form-control placeholder-no-fix" type="password" autocomplete="off"
				       placeholder="<?php echo __( "Password" ) ?>" title="<?php echo _e( "Student's password required" ) ?>"
				       name="password" id="password" required="required">
			</div>
		</div>
		<div class="form-actions">
			<label class="checkbox">
				<input type="checkbox" name="remember_me" id="remember_me" value="1"> Remember me </label>
			<button type="submit" class="btn blue pull-right" id="login_btn">
				Login <i class="m-icon-swapright m-icon-white"></i>
			</button>
		</div>
		<!--<div class="forget-password">
			<h4>Forgot your password ?</h4>
			<p>
				no worries, click <a href="javascript:;" id="forget-password">here</a>
				to reset your password.
			</p>
		</div>-->
		<!--<div class="create-account">
			<p>
				Don't have an account yet ?&nbsp; <a href="javascript:;" id="register-btn">Create an account</a>
			</p>
		</div>-->
	</form>
	<!-- END LOGIN FORM -->
	<!-- BEGIN FORGOT PASSWORD FORM -->
	<form class="forget-form" action="#" method="post">
		<h3>Forget Password ?</h3>
		<p>
			Enter your e-mail address below to reset your password.
		</p>
		<div class="form-group">
			<div class="input-icon">
				<i class="fa fa-envelope"></i>
				<input class="form-control placeholder-no-fix" type="text" autocomplete="off" placeholder="Email"
				       name="email" />
			</div>
		</div>
		<div class="form-actions">
			<button type="button" id="back-btn" class="btn">
				<i class="m-icon-swapleft"></i> Back
			</button>
			<button type="submit" class="btn blue pull-right">
				Submit <i class="m-icon-swapright m-icon-white"></i>
			</button>
		</div>
	</form>
	<!-- END FORGOT PASSWORD FORM -->
	<!-- BEGIN REGISTRATION FORM -->
	<form class="register-form" action="index.html" method="post">
		<h3>Sign Up</h3>
		<p>
			Enter your personal details below:
		</p>
		<div class="form-group">
			<label class="control-label visible-ie8 visible-ie9">Full Name</label>
			<div class="input-icon">
				<i class="fa fa-font"></i>
				<input class="form-control placeholder-no-fix" type="text" placeholder="Full Name" name="fullname" />
			</div>
		</div>
		<div class="form-group">
			<!--ie8, ie9 does not support html5 placeholder, so we just show field title for that-->
			<label class="control-label visible-ie8 visible-ie9">Email</label>
			<div class="input-icon">
				<i class="fa fa-envelope"></i>
				<input class="form-control placeholder-no-fix" type="text" placeholder="Email" name="email" />
			</div>
		</div>
		<div class="form-group">
			<label class="control-label visible-ie8 visible-ie9">Address</label>
			<div class="input-icon">
				<i class="fa fa-check"></i>
				<input class="form-control placeholder-no-fix" type="text" placeholder="Address" name="address" />
			</div>
		</div>
		<div class="form-group">
			<label class="control-label visible-ie8 visible-ie9">City/Town</label>
			<div class="input-icon">
				<i class="fa fa-location-arrow"></i>
				<input class="form-control placeholder-no-fix" type="text" placeholder="City/Town" name="city" />
			</div>
		</div>
		<div class="form-group">
			<label class="control-label visible-ie8 visible-ie9">Country</label>
			<select name="country" id="select2_sample4" class="select2 form-control">
				<option value=""></option>
				<option value="AF">Afghanistan</option>
			</select>
		</div>
		<p>
			Enter your account details below:
		</p>
		<div class="form-group">
			<label class="control-label visible-ie8 visible-ie9">Username</label>
			<div class="input-icon">
				<i class="fa fa-user"></i>
				<input class="form-control placeholder-no-fix" type="text" autocomplete="off" placeholder="Username"
				       name="username" />
			</div>
		</div>
		<div class="form-group">
			<label class="control-label visible-ie8 visible-ie9">Password</label>
			<div class="input-icon">
				<i class="fa fa-lock"></i>
				<input class="form-control placeholder-no-fix" type="password" autocomplete="off" id="register_password"
				       placeholder="Password" name="password" />
			</div>
		</div>
		<div class="form-group">
			<label class="control-label visible-ie8 visible-ie9">Re-type Your Password</label>
			<div class="controls">
				<div class="input-icon">
					<i class="fa fa-check"></i>
					<input class="form-control placeholder-no-fix" type="password" autocomplete="off"
					       placeholder="Re-type Your Password" name="rpassword" />
				</div>
			</div>
		</div>
		<div class="form-group">
			<label>
				<input type="checkbox" name="tnc" /> I agree to the <a href="#">Terms of Service</a> and <a href="#">Privacy
					Policy</a>
			</label>
			<div id="register_tnc_error">
			</div>
		</div>
		<div class="form-actions">
			<button id="register-back-btn" type="button" class="btn">
				<i class="m-icon-swapleft"></i> Back
			</button>
			<button type="submit" id="register-submit-btn" class="btn blue pull-right">
				Sign Up <i class="m-icon-swapright m-icon-white"></i>
			</button>
		</div>
	</form>
	<!-- END REGISTRATION FORM -->
</div>
<!-- END LOGIN -->
<!-- BEGIN COPYRIGHT -->
<div class="copyright">
	<?php if ( ! empty( $__decoded_key["reseller_title"] ) ) { ?>
		<?php echo date( "Y" ); ?> &copy; <?php echo $__decoded_key["reseller_title"]; ?> | Version: <?php echo Version ?>
	<?php } else if ( is_file( ROOT_PATH . "branding" ) ) {
		$TT = file( ROOT_PATH . "branding" ); ?>
		<?php echo date( "Y" ); ?> &copy; <?php echo base64_decode( $TT[0] ); ?> | Version: <?php echo Version ?>
	<?php } else { ?>
		2014-<?php echo date( "Y" ); ?> &copy; FeKara | Version: <?php echo Version ?>
	<?php } ?>
</div>
<!-- END COPYRIGHT -->
<!-- BEGIN JAVASCRIPTS(Load javascripts at bottom, this will reduce page load time) -->
<!-- BEGIN CORE PLUGINS -->
<!--[if lt IE 9]>
<script src="<?php echo ASSETS_URL ?>plugins/respond.min.js"></script>
<script src="<?php echo ASSETS_URL ?>plugins/excanvas.min.js"></script>
<![endif]-->
<script src="<?php echo ASSETS_URL ?>/plugins/jquery-1.10.2.min.js" type="text/javascript"></script>
<script src="<?php echo ASSETS_URL ?>plugins/jquery-migrate-1.2.1.min.js" type="text/javascript"></script>
<script src="<?php echo ASSETS_URL ?>plugins/bootstrap/js/bootstrap.min.js" type="text/javascript"></script>
<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-hover-dropdown/twitter-bootstrap-hover-dropdown.min.js"
        type="text/javascript"></script>
<script src="<?php echo ASSETS_URL ?>plugins/jquery-slimscroll/jquery.slimscroll.min.js"
        type="text/javascript"></script>
<script src="<?php echo ASSETS_URL ?>plugins/jquery.blockui.min.js" type="text/javascript"></script>
<script src="<?php echo ASSETS_URL ?>plugins/jquery.cokie.min.js" type="text/javascript"></script>
<script src="<?php echo ASSETS_URL ?>plugins/uniform/jquery.uniform.min.js" type="text/javascript"></script>
<!-- END CORE PLUGINS -->
<!-- BEGIN PAGE LEVEL PLUGINS -->
<script src="<?php echo ASSETS_URL ?>added_plugins/jquery-validation-1.16.0/dist/jquery.validate.min.js"></script>
<!--<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-backstretch/2.0.3/jquery.backstretch.min.js" type="text/javascript"></script>-->
<script src="<?php echo ASSETS_URL ?>plugins/select2/select2.min.js"></script>
<!-- END PAGE LEVEL PLUGINS -->
<!-- BEGIN PAGE LEVEL SCRIPTS -->
<script src="<?php echo ASSETS_URL ?>scripts/app.js" type="text/javascript"></script>
<!--<script src="<?php /*echo DOMAIN_URL; */ ?>assets/scripts/login-soft.js" type="text/javascript"></script>-->
<!-- END PAGE LEVEL SCRIPTS -->
<script>
	var R = "<?php echo isset( $_GET['goto'] ) ? $_GET['goto'] : "index.php"; ?>";
	jQuery( document ).ready( function() {
		App.init();

		$( "#login_form" ).validate();

		$( document ).on( "submit", "#login_form", function() {
			k = $( "#login_form" ).serialize();
			$( "#email, #password, #remember_me, #login_btn" ).attr( "disabled", true );
			$( ".loading" ).show();
			$.post( "login.php?login", k, function( data ) {
				if ( data=="OK" ) {
					window.location.href = R;
				} else {
					$( ".loading" ).hide();
					$( "#email, #password, #remember_me, #login_btn" ).attr( "disabled", false );
					alert( data );
					$( "#email" ).focus();
				}
			} );
			return false;
		} );
		$( document ).on( "keypress", "#email, #password", function( e ) {
			if ( e.which=="13" ) {
				$( "#login_form" ).submit();
			}
		} );
	} );
</script>
<!-- END JAVASCRIPTS -->
</body>
<!-- END BODY -->
</html>