<?php #include_once( __DIR__ . "/../library.php" );
$_title = "Assignments to Teachers";
include_once( __DIR__ . "/header.php" );
?>

<?php if ( is_paid_fekara() ) { ?>
	<form id="file_form" class="hidden">
		<input type="reset" id="file_reset">
		<input type="hidden" name="teacher_id" value="" id="file_id">
		<input type="file" class="file" id="file_file" name="file[]" accept="<?php echo implode( ",", $s->AllowedFileTypes ) ?>" multiple="multiple">
	</form>
<?php } ?>

<div class="page-container">
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( "Teacher Assignments" ) ?>
						<small><?php _e( "Upload assignments to teachers" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php"><?php echo _e( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php _e( "Data" ) ?>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="teacher_assignments.php"><?php _e( "Teacher Assignments" ) ?></a>
						</li>
					</ul>
				</div>
			</div>

			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-users"></i>
								<?php _e( "Teachers" ) ?>

								<small id="file_loader" style="display:none;font-size:12px">&nbsp;&nbsp;&nbsp;<i class="fa fa-spin fa-spinner"></i> Uploading file
								</small>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<?php
							$teachers = $s->get_teachers( $s->my_id() );
							?>

							<table class="table table-bordered" id="table_assign">
								<thead>
								<tr>
									<th style="width: 10px;"><?php _e( "ID" ) ?></th>
									<th style="width:220px"><?php _e( "Teacher Name" ) ?></th>
									<th><?php _e( "Upload Assignments" ) ?></th>
								</tr>
								</thead>
								<tbody id="tbody1"></tbody>
							</table>
						</div>
					</div>
				</div>
			</div>
			<!-- END DASHBOARD STATS -->
			<div class="clearfix">
			</div>

		</div>
	</div>
	<!-- END CONTENT -->
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>
<script>
	$( function() {
		var Rows = <?php $teachers = $s->get_teachers( $s->my_id() );
			foreach ( $teachers as &$teacher ) {
				$teacher["assignments"]     = $s->get_assignments( $s->my_id(), $teacher["id"] );
				$teacher["assignments_url"] = [];
				foreach ( $teacher["assignments"] as &$assignment ) {
					$teacher["assignments_url"][] = $s->get_assignment_file_url( $s->my_id(), $teacher["id"], basename( $assignment ) );
				}
			}
			echo json_encode( $teachers ); ?>;
		$( "#table_assign" ).tablesaw();
		<?php if (is_paid_fekara()) { ?>
		load_rows = function(){
			$.post("ajax/teacher_assignments.php?load_rows", function( data ) {
				Rows = data;
				make_html();
			})
		}
		function make_html() {
			HTML = `
				${Rows.map( row =>`
					<tr>
						<td>${row.id}</td>
						<td>${row.name}</td>
						<td>
							<button style='margin-bottom:5px' class="btn btn-xs red upload_btn" data-id="${row.id}" title="Upload assignment files">
								<i class="fa fa-upload"></i>Upload File
							</button>
							${row.assignments_url.map( (url, index) =>`
								<div class='btn-group' style='margin-bottom:5px' data-tid='${row.id}'>
									<a title="<?php _e( "Delete this file" ) ?>" class="btn btn-xs red del_file">
										<i class='fa fa-trash'></i>
									</a>
									<a target='_blank' href='${url}' class='btn btn-xs blue'>${basename( row.assignments[ index ] )}</a>
								</div>
							`).join('')}
						</td>
					</tr>
				`).join('')}
			`;
			$( "#tbody1" ).html( HTML );
			$( "#file_loader" ).hide();
		}

		make_html();
		$( document ).on( "click", ".upload_btn", function( event ) {
			event.preventDefault();

			var id = $( this ).attr( "data-id" );
			$( "#file_reset" ).click();
			$( "#file_id" ).val( id );
			$( "#file_file" ).click();
		} );
		$( document ).on( "change", "#file_file", function() {
			var file = $( this ).val();
			if ( file ) {
				$( "#file_form" ).trigger( "submit" );
			}
		} );
		$( document ).on( "submit", "#file_form", function( event ) {
			event.preventDefault();

			var form = document.getElementById( "file_form" );
			var formData = new FormData( form );
			$( "#file_loader" ).show();
			$.ajax( {
				url: 'ajax/teacher_assignments.php?upload_assignment',
				type: 'POST',
				xhr: function() {
					var myXhr = $.ajaxSettings.xhr();
					return myXhr;
				},
				success: function( data ) {
					load_rows();
				},
				error: function( data ) {
					$( "#file_loader" ).show();
					Error( data );
				},
				data: formData,
				cache: false,
				contentType: false,
				processData: false
			} );
		} );
		$( document ).on( "click", ".del_file", function( event ) {
			event.preventDefault();

			if ( !confirm( "<?php _e( "Are you sure you want to delete this assignment?" ) ?>" ) ) {
				return false;
			}

			var file = $( this ).next().html();
			var teacher_id = $( this ).parent().attr( "data-tid" );
			var t = $( this );
			t.parent().remove();
			$.post( "ajax/teacher_assignments.php?del_file", {
				filename: file,
				student_id: '<?php echo $s->my_id() ?>',
				teacher_id: teacher_id
			}, function( data ) {
				if ( data=="OK" ) {
					load_rows();
					Success( "<?php _e( "Assignment file deleted successfully!" ) ?>" );
				} else {
					Error( data );
				}
			} );
		} );
		<?php } ?>
	} );

	/*var source = new EventSource( "<?php echo get_student_panel_url() ?>ajax/teacher_assignments.php?table" );
	source.onmessage = function( event ) {
		alert (event.data);
		document.getElementById( "tbody1" ).innerHTML = event.data;
	};*/
</script>
</body>
</html>