<?php
include_once( __DIR__ . "/../library.php" );
$title = __( "Attendance Register" );
include_once( __DIR__ . "/header.php" );

// get teacher classes
$getClass = $teacher->get_teachers_assign_classes( $T["id"] );
$C        = new BatchClass();
$classes_ = $C->get_list( "batch_id=0&teacher_id=" . $T["id"] );

$_GET['class_id']   = isset( $_GET['class_id'] ) ? $_GET['class_id'] : 0;
$_GET['subject_id'] = isset( $_GET['subject_id'] ) ? $_GET['subject_id'] : 0;
$_GET['date']       = isset( $_GET['date'] ) ? $_GET['date'] : '';

?>
<div class="page-container">
	<?php include_once( __DIR__ . "/mobile_menu.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __( "Attendance" ) ?>
						<small><?php echo __( "This is attendance register" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>teachers/">
								<?php echo __( "Teacher Panel" ) ?>
							</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="attendance.php">
								<?php echo __( "Attendance" ) ?>
							</a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<?php if ( empty( $_GET['class_id'] ) ): ?>
						<form class="form-horizontal form-bordered" name="form1" id="form1">
							<div class="form-body">
								<div class="form-group F">
									<label class="control-label col-md-3"><?php echo __( "Attendance Date" ) ?></label>
									<div class="col-md-4">
										<input value="<?php echo date( "d-m-Y" ) ?>" name="date" class="form-control date-picker" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>">
									</div>
								</div>
								<div class="form-group F">
									<label class="control-label col-md-3">
										<?php echo __( "Select Class" ) ?>
									</label>
									<div class="col-md-4">
										<select name="class_id" class="form-control select2" onchange="CheckAttendance(this)">
											<option value="0">== <?php echo __( "Select Class" ) ?> ==</option>
											<?php foreach ( $classes_ as $class ) { ?>
												<option value="<?php echo $class["id"] ?>">
													ID: <?php echo $class["id"]; ?> -
													<?php echo $class["batch_name"]; ?> &raquo;
													<?php echo $class["class_name"]; ?> &raquo;
													(<?php echo $class["students_count"] ?> <?php echo __( "Students" ) ?>)
												</option>
											<?php } ?>
										</select>
									</div>
								</div>

								<div class="form-group" style="display: none;" id="subDiv">
									<div class="col-md-offset-3 col-md-9">
										<button type="submit" class="btn blue"><?php echo __( "Get Attendance Register" ) ?></button>
									</div>
								</div>

							</div>
						</form>
					<?php else: ?>
						<?php if ( ! isset( $_GET["class_id"] ) ) {
							Urls::redirect( "attendance.php" );
						}
						if ( ! isset( $_GET["date"] ) ) {
							Urls::redirect( "attendance.php" );
						}
						$A    = new Attendance();
						$rows = $A->get_attendance( "date={$_GET["date"]}&class_id={$_GET["class_id"]}" );

						?>
						<form onsubmit="return saveAttendance(this)">
							<input type="hidden" name="class_id" value="<?php echo $_GET["class_id"] ?>" />
							<input type="hidden" name="subject_id" value="<?php echo $_GET["subject_id"] ?>" />
							<input type="hidden" name="date" value="<?php echo $_GET["date"] ?>" />
							<h3>Class: <?php echo $BatchClass->get_class_name( $_GET["class_id"] ) ?></h3>
							<h3>Attendance Date: <?php echo \Dates::my_date( $_GET["date"] ) ?></h3>
							<table class="table table-bordered table-hover">
								<thead>
								<tr>
									<th><?php echo __( "Student Name" ) ?></th>
									<th><?php echo __( "Attendance" ) ?></th>
								</tr>
								</thead>
								<?php foreach ( $rows as $row ): $attend = $row["attendance"] == "" ? "P" : $row["attendance"];
									if ( $attend == "A" ) {
										$class = "HighLight1";
									} elseif ( $attend == "L" ) {
										$class = "HighLight2";
									} else {
										$class = "";
									}
									?>
									<tr class="<?php echo $class ?>">
										<td style="text-align: right;font-weight:bold"><?php echo $row["student_name"] ?></td>
										<td>
											<input type="hidden" name="student_id[]" value="<?php echo $row["student_id"] ?>" />
											<div class="btn-group" data-toggle="buttons">
												<label class="btn blue <?php echo $attend == "P" ? "active" : "" ?>" style="cursor: pointer;"><input class="toggle BB" name="attendance[<?php echo $row["student_id"] ?>]" <?php echo $attend == "P" ? "checked=checked" : "" ?> type="radio" value="P" />Present
												</label>
												<label class="btn blue <?php echo $attend == "A" ? "active" : "" ?>" style="cursor: pointer;"><input class="toggle BB" name="attendance[<?php echo $row["student_id"] ?>]" <?php echo $attend == "A" ? "checked=checked" : "" ?> type="radio" value="A" />Absent
												</label>
												<label class="btn blue <?php echo $attend == "L" ? "active" : "" ?>" style="cursor: pointer;"><input class="toggle BB" name="attendance[<?php echo $row["student_id"] ?>]" <?php echo $attend == "L" ? "checked=checked" : "" ?> type="radio" value="L" />Leave
												</label>
											</div>
										</td>
									</tr>
								<?php endforeach; ?>
								<tr>
									<td>&nbsp;</td>
									<td>
										<label><input type="checkbox" name="smsBtn" value="1" /> Send an auto SMS to guardians of absent students</label>
									</td>
								</tr>
								<tr>
									<td>&nbsp;</td>
									<td>
										<button type="submit" class="btn blue">
											<?php echo __( "Save Attendance" ) ?>
										</button>
										<a href="attendance.php" class="btn red">
											<?php echo __( "Do not save" ) ?>
										</a>
									</td>
								</tr>
							</table>
						</form>
					<?php endif; ?>
				</div>
			</div>
		</div>
	</div>
</div>

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script>
	function CheckAttendance( t ) {
		if ( t.value=="0" ) {
			return;
		}
		Block();
		$.post( "<?php echo Urls::get_url( "ajax", 0, "action=checkAttendance" ) ?>", $( "#form1" ).serialize(), function( data ) {
			UnBlock();
			if ( data=="OK" ) {
				$( ".F" ).hide();
				$( "#subDiv" ).show();
			}
		} );
	}

	function saveAttendance( form ) {
		var path = "<?php echo DOMAIN_URL ?>";
		Block();

		$.ajax( {
			url: "<?php echo ROOT_URL ?>includes/old_ajax.php?action=saveAttendance",
			method: 'POST',
			data: $( form ).serialize(),
			error: function( e1, e2, e3 ) {
				UnBlock();
				Error( e3 );
			}
		} ).done( function( data ) {
			if ( data=='OK' ) {
				window.location.href = path + "teacher/attendance.php";
			} else {
				UnBlock();
				Error( data );
			}
		} );

		//$.post( "<?php //echo Urls::get_url( "ajax", 0, "action=saveAttendance" ) ?>//", $( form ).serialize(), function( data ) {
		//	if ( data=="OK" ) {
		//		window.location.href = path + "teacher/attendance.php";
		//	} else {
		//		UnBlock();
		//		Error( data );
		//	}
		//} );
		return false;
	}

	$( function() {
		$( ".BB" ).change( function() {
			val = $( this ).val();
			//alert ($(this).parent().parent().parent().parent().html());
			if ( val=="A" ) {
				$( this ).parent().parent().parent().parent().removeClass( "HighLight2" ).addClass( "HighLight1" );
			} else if ( val=="L" ) {
				$( this ).parent().parent().parent().parent().removeClass( "HighLight1" ).addClass( "HighLight2" );
			} else {
				$( this ).parent().parent().parent().parent().removeClass( "HighLight1 HighLight2" );
			}
		} );
	} );
</script>
</body>
</html>