<?php
include_once( __DIR__ . "/header.php" );
if ( ! $teacher->is_teacher_logged_in() ) {
	Urls::redirect( "login.php" );
}
// get teacher classes
$cids     = [];
$getClass = $teacher->get_teachers_assign_classes( $T["id"] );
foreach ( $getClass as $row ) {
	$cids[] = $row["id"];
}
$C = new BatchClass();
$c = $C->get_list();
?>
<div class="page-container">
	<?php include_once( __DIR__ . "/mobile_menu.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __( "Attendance Report" ) ?>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								<?php echo __( "Actions" ) ?>
							</span>
								<i class="fa fa-angle-down"></i>
							</button>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php echo __( "Attendance Report" ) ?>
						</li>
					</ul>
				</div>
			</div>
			<div class="clearfix"></div>
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i><?php echo __( "Generate Attendance Report" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<!--<a href="#portlet-config" data-toggle="modal" class="config"></a>-->
							</div>
						</div>
						<div class="portlet-body form">
							<form target="_ems" action="<?php echo Urls::get_url( "download_report_attendance" ) ?>" class="form-horizontal form-bordered">
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Select Date" ) ?></label>
										<div class="col-md-9">
											<input required="required" class="form-control date-picker" data-date-format="<?php echo \Dates::date_format1_for_js() ?>" name="date" value="<?php echo date( $db->get_option( "date_format1" ) ) ?>">
										</div>
									</div>
								</div>
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Attendance Status" ) ?></label>
										<div class="col-md-9">
											<select class="form-control select2" name="attendance">
												<option value="">== <?php echo __( "Any" ) ?> ==</option>
												<option value="A"><?php echo __( "Absent" ) ?></option>
												<option value="P"><?php echo __( "Present" ) ?></option>
												<option value="L"><?php echo __( "Leave" ) ?></option>
											</select>
										</div>
									</div>
								</div>
								<div class="form-body">
									<div class="form-group">

										<label class="control-label col-md-3"><?php echo __( "Select Classes" ) ?></label>
										<div class="col-md-9">
											<select class="form-control select2" name="class_id[]" multiple="multiple">
												<?php foreach ( $c as $class ) {
													if ( in_array( $class["id"], $cids ) ) { ?>
														<option value="<?php echo $class["id"] ?>"><?php echo $class["class_name"] ?></option>
													<?php }
												} ?>
											</select>
										</div>
									</div>
								</div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="submit" name="viewBtn" class="btn green"><?php echo __( "View Report" ) ?></button>
										<button type="submit" name="smsBtn" class="btn red"><?php echo __( "SMS Absent Report" ) ?></button>
										<button type="submit" name="downBtn" class="btn blue"><?php echo __( "Download Report" ) ?></button>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>
</body>
</html>