<?php
include_once( __DIR__ . "/header.php" );
if ( ! $teacher->is_teacher_logged_in() ) {
	Urls::redirect( "login.php" );
}
// get teacher classes
$cids     = [];
$getClass = $teacher->get_teachers_assign_classes( $T["id"] );
foreach ( $getClass as $row ) {
	$cids[] = $row["id"];
}
$C = new BatchClass();
$c = $C->get_list();
?>
<div class="page-container">
	<?php include_once( __DIR__ . "/mobile_menu.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __( "Dashboard" ) ?>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
                                    <span>
                                        <?php echo __( "Actions" ) ?>
                                    </span>
								<i class="fa fa-angle-down"></i>
							</button>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php echo __( "Attendance Sheet" ) ?>
						</li>
					</ul>
				</div>
			</div>
			<div class="clearfix"></div>
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php echo __( "Generate Report" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<!--<a href="#portlet-config" data-toggle="modal" class="config"></a>-->
							</div>
						</div>
						<div class="portlet-body form">
							<form id="report_form" action="<?php echo Urls::get_url( "download_report_attendance_sheet" ) ?>" class="form-horizontal form-bordered validate" onsubmit="Form(2)">
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Select Class" ) ?></label>
										<div class="col-md-9">
											<select class="form-control" name="class_id">
												<?php foreach ( $c as $class ) {
													if ( in_array( $class["id"], $cids ) ) { ?>
														<option value="<?php echo $class["id"] ?>"><?php echo $class["class_name"] ?></option>
													<?php }
												} ?>
											</select>
											<span class="help-block">
        										<?php echo __( "Select class" ) ?>
        									</span>
										</div>
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-md-3"><?php echo __( "Test/Exam Schedule Date Range" ) ?></label>
									<div class="col-md-9">
										<div class="input-group date-picker input-daterange" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>">
											<input value="<?php echo date( "01-m-Y" ) ?>" required="required" type="text" class="form-control" name="from" placeholder="From Date">
											<span class="input-group-addon">
												to
											</span>
											<input value="<?php echo date( $db->get_option( "date_format1" ) ) ?>" required="required" type="text" class="form-control" name="to" placeholder="To Date">
										</div>
										<!-- /input-group -->
										<span class="help-block">
											<?php echo __( "Select date range" ) ?>
										</span>
									</div>
								</div>
								<div id="moresubjects"></div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="button" onclick="Form(1)" name="viewBtn" class="btn green"><?php echo __( "View Report" ) ?></button>
										<button type="submit" name="downBtn" class="btn blue"><?php echo __( "Download Report" ) ?></button>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>
<script>
	function Form( btn ) {
		if ( !$( "#report_form" ).validate().form() ) {
			return false;
		}

		if ( btn == "1" ) {
			u = $( "#report_form" ).serialize() + "&viewBtn";
		} else {
			u = $( "#report_form" ).serialize();
			window.location.href = $( "#report_form" ).attr( "action" ) + "&" + u;
			return false;
		}

		u = $( "#report_form" ).attr( "action" ) + "&" + u;
		$.fancybox( {
			'title': "<?php echo __( "Attendance Sheet" ) ?>",
			'href': u,
			'type': 'iframe',
			'width': '90%',
			'height': '90%',
		} );
	}
</script>
</body>
<!-- END BODY -->
</html>