<?php
include_once( __DIR__ . "/../library.php" );
$title = __( "Materials" );
include_once( __DIR__ . "/header.php" );
$teacher = new Teacher();
if ( ! $teacher->is_teacher_logged_in() ) {
	Urls::redirect( "login.php" );
}
$T        = $teacher->get_teacher();
$id       = $T["id"];
$getData  = $teacher->get_teachers_assign_classes( $id );
$classids = [];
if ( ! empty( $getData ) ) {
	foreach ( $getData as $a ) {
		$classids[] = $a["id"];
	}
}
// get course material data
$m = new CourseMaterial();
$M = $m->teacher_course_material( $id );
// get subjects
$s        = new Subject();
$subjects = $s->get_list();
// get all classes
$c        = new Classes();
$students = new Student();
?>
<div class="page-container">
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __( "Dashboard" ) ?>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown"
							        data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								<?php echo __( "Actions" ) ?>
							</span>
								<i class="fa fa-angle-down"></i>
							</button>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php echo __( "Course Material" ) ?>
						</li>
					</ul>
				</div>
			</div>
			<div class="clearfix"></div>
			<div class="row">
				<div class="col-md-6">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php echo __( "Class Assign" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<!--<a href="#portlet-config" data-toggle="modal" class="config"></a>-->
							</div>
						</div>
						<div class="portlet-body">
							<table class="table table-striped table-bordered table-hover datatable">
								<thead>
								<tr>
									<th><?php echo __( "No" ) ?></th>
									<th><?php echo __( "Class Name" ) ?></th>
									<th><?php echo __( "Total Students" ) ?></th>
									<th><?php echo __( "Subjects" ) ?></th>
								</tr>
								</thead>
								<tbody>
								<?php
								if ( isset( $classids ) ) {
									$rows = $c->get_list();
									//									show_array($rows); die;
									$i        = 0;
									$subjects = [];
									foreach ( $rows as $row ) {
										if ( in_array( $row["id"], $classids ) ) {
											if ( $row["subjects"] != "" ) {
												$subjects = explode( ",", $row["subjects"] );
											}
											?>
											<tr>
												<td><?php echo $i + 1; ?></td>
												<td><a href="students_view.php"
												       style="cursor: pointer;"><?php echo $row["name"] ?></a></td>
												<td><a href="students_view.php"
												       style="cursor: pointer;"><?php echo count( $students->get_Total_Students_count( $row["id"] ) ) ?></a>
												</td>
												<td>
													<?php
													if ( ! empty( $subjects ) ) {
														echo "<ul><a href='upload_assignment.php?id={$row["id"]}'>";
														foreach ( $subjects as $s ) {
															echo "<li>{$s}</li>";
														}
														echo "</a></ul>";
													}
													?>
												</td>
											</tr>
											<?php $i ++;
										}
									}
								}
								?>
								</tbody>
							</table>
						</div>

					</div>
				</div>

				<div class="col-md-6">
					<div class="portlet box green">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php echo __( "Subjects Assign" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<!--<a href="#portlet-config" data-toggle="modal" class="config"></a>-->
							</div>
						</div>

						<div class="portlet-body">
							<table class="table table-striped table-bordered table-hover datatable">
								<thead>
								<tr>
									<th><?php echo __( "No" ) ?></th>
									<th><?php echo __( "Class Name" ) ?></th>
									<th><?php echo __( "Subject Name" ) ?></th>
								</tr>
								</thead>
								<tbody>
								<?php $getSubjects = $teacher->get_teachers_assign_subjects( $id );
								if ( isset( $getSubjects ) ) {
									foreach ( $getSubjects as $j => $sub ) {
										?>
										<tr>
											<td><?php echo $j + 1; ?></td>
											<td><?php echo $sub["classname"] ?></td>
											<td><?php echo $sub["subjectname"] ?></td>
										</tr>
									<?php }
								} ?>
								</tbody>
							</table>
						</div>

					</div>
				</div>

				<div class="col-md-6">
					<div class="portlet box green">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php echo __( "Files Assign" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<!--<a href="#portlet-config" data-toggle="modal" class="config"></a>-->
							</div>
						</div>

						<div class="portlet-body">
							<table class="table table-striped table-bordered table-hover datatable">
								<thead>
								<tr>
									<th><?php echo __( "No" ) ?></th>
									<th><?php echo __( "File Name" ) ?></th>
								</tr>
								</thead>
								<tbody>
								<?php if ( isset( $M ) ) {
									foreach ( $M as $k => $name ) {
										?>
										<tr>
											<td><?php echo $k + 1; ?></td>
											<td><a href="<?php echo $name ?>"
											       target="_blank"><?php echo basename( $name ) ?></a></td>
										</tr>
									<?php }
								} ?>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>
</body>
</html>