<?php
include_once( __DIR__ . "/../library.php" );
$teacher   = new Teacher();
$_filename = executing_filename();
if ( ! $teacher->is_teacher_logged_in() ) {
	Urls::redirect( "login.php" );
}
$T = $teacher->get_teacher();
//manifest="ROOT_URL."cache.manifest"
?>
<html>
<!--[if IE 8]>
<html lang="en" class="ie8 no-js"> <![endif]-->
<!--[if IE 9]>
<html lang="en" class="ie9 no-js"> <![endif]-->
<!--[if !IE]><!-->
<html lang="en" class="no-js">
<!--<![endif]-->
<!-- BEGIN HEAD -->
<head>
	<meta charset="utf-8" />
	<?php $title = isset( $title ) ? __( $title ) : System; ?>
	<title><?php echo $title ?></title>
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta content="width=device-width, initial-scale=1.0" name="viewport" />
	<meta content="" name="description" />
	<meta content="" name="author" />
	<meta name="MobileOptimized" content="320">

	<?php load_css_files() ?>

	<link
		href="<?php echo \Theme::url() ?>style.css?<?php echo \General::localhost() ? time() : Version ?>"
		rel="stylesheet" type="text/css" />
	<link rel="shortcut icon" href="<?php echo DOMAIN_URL ?>favicon.ico" />
	<script src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-JavaScript-Templates/3.11.0/js/tmpl.min.js"></script>
	<script>
		var theme_url = "<?php echo \Theme::url() ?>";
		var root_url = "<?php echo DOMAIN_URL ?>";
	</script>
</head>
<body class="page-header-fixed page-full-width">
<div class="loading">Loading&#8230;</div>
<div class="header navbar navbar-inverse navbar-fixed-top">
	<div class="header-inner">
		<a class="navbar-brand" href="<?php echo $teacher->get_teacher_panel_url() ?>">
			<img src="<?php echo App::get_logo() ?>" alt="logo" style="max-width:84px;max-height:14px"
			     class="img-responsive">
		</a>
		<?php
		$menu_array = [
			"index.php"      => [
				"title"    => __( "Home" ),
				"sub_menu" => [
					"index.php"           => __( "Dashboard" ),
					"students_view.php"   => __( "Student View" ),
					//"data_info.php"       => __( "Teacher Data Info" ),
					"course_material.php" => __( "Course Material" ),
					//"uploads.php" => "Upload Files",
					//"upload_assignment.php" => "Upload Assignment",
					//"weekly_lecture.php"  => __( "Weekly Lecture" ),
					"time_table.php"      => __( "Time Table" ),
					"teacher_note.php"    => __( "Teacher Notes" ),
				],
				"new_menu" => [     // Menus with new label will appear here.

				],
			],
			"attendance.php" => [
				"title"    => __( "Attendance" ),
				"sub_menu" => [
					"attendance.php"        => __( "Attendance Register" ),
					"attendance_report.php" => __( "Attendance Report" ),
					"attendance_sheet.php"  => __( "Attendance Sheet" ),
				],
			],
			"reports.php"    => [
				"title"    => __( "Reports" ),
				"sub_menu" => [
					"student_weekly_report.php"   => __( "Student Weekly Report" ),
					"student_progress_report.php" => __( "Student Progress Report" ),
					"student_list_report.php"     => __( "Student List Report" ),
				],
			],
		];
		?>
		<div class="hor-menu hidden-sm hidden-xs">
			<ul class="nav navbar-nav">
				<?php
				foreach ( $menu_array as $k => $sub_menu ) {
					if ( ! is_array( $sub_menu ) ) { ?>
						<li class="<?php echo $_filename == $k ? "active" : ""; ?>">
							<a href="index.php"><?php echo $sub_menu ?></a>
						</li>
					<?php } else { ?>
						<li class="<?php echo array_key_exists( $_filename, $sub_menu["sub_menu"] ) ? "active" : ""; ?>">
							<a data-toggle="dropdown" data-hover="dropdown" data-close-others="true"
							   class="dropdown-toggle"
							   href="javascript:;">
								<?php if ( array_key_exists( $_filename, $sub_menu["sub_menu"] ) ) { ?>
									<span class="selected"></span>
								<?php } ?>
								<?php echo $sub_menu["title"] ?> <i class="fa fa-angle-down"></i>
							</a>
							<ul class="dropdown-menu">
								<?php foreach ( $sub_menu["sub_menu"] as $k2 => $v ) { ?>
									<li class="<?php echo $_filename == $k2 ? "active" : ""; ?>">
										<a href="<?php echo $k2; ?>">
											<?php if ( isset( $sub_menu["new_menu"] ) && is_array( $sub_menu["new_menu"] ) && in_array( $k2, $sub_menu["new_menu"] ) ) { ?>
												<span class="badge badge-roundless badge-important">new</span>
											<?php } ?>
											<?php echo $v; ?>
										</a>
									</li>
								<?php } ?>
							</ul>
						</li>
					<?php }
				}
				?>
			</ul>
		</div>
		<a href="javascript:;" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
			<img src="<?php echo ASSETS_URL ?>img/menu-toggler.png" alt="" />
		</a>
		<ul class="nav navbar-nav pull-right">
			<li class="dropdown user">
				<a href="#" class="dropdown-toggle" data-toggle="dropdown" data-hover="dropdown"
				   data-close-others="true">
					<img alt="" src="<?php echo ASSETS_URL ?>img/avatar1_small.jpg" />
					<span class="username">
					<?php echo $T["name"]; ?>
				</span>
					<i class="fa fa-angle-down"></i>
				</a>
				<ul class="dropdown-menu">
					<li>
						<a href="profile.php"><i class="fa fa-user"></i> <?php echo __( "My Profile" ) ?></a>
					</li>
					<li class="divider"></li>
					<li>
						<a href="logout.php"><i class="fa fa-key"></i> <?php echo __( "Log Out" ) ?></a>
					</li>
				</ul>
			</li>
		</ul>
	</div>
</div>
<div class="clearfix">
</div>