<?php
include_once( __DIR__ . "/../library.php" );
$teacher = new Teacher\Files();
if ( ! $teacher->is_teacher_logged_in() ) {
	Urls::redirect( "login.php" );
}

//$id = $teacher->is_teacher_logged_in();
$T       = $teacher->get_teacher();
$title = 'Teacher Panel';
include_once( __DIR__ . "/header.php" );
$teacher = new Teacher\Files();
$s = new Subject;
$c = new Classes;
?>
<!-- BEGIN CONTAINER -->
<div class="page-container">
	<?php include_once( __DIR__ . "/mobile_menu.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						<?php echo __( "Dashboard" ) ?>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php echo __( "Teacher" ) ?>
						</li>
					</ul>
				</div>
			</div>

			<div class="clearfix"></div>

			<div class="row">
				<div class="col-lg-3 col-md-3 col-sm-6 col-xs-12">
					<div class="dashboard-stat green">
						<div class="visual">
							<i class="fa fa-upload"></i>
						</div>
						<div class="details">
							<div class="number">
								<?php echo $teacher->files_counter($T['id']); ?>
							</div>
							<div class="desc">
								<?php _e('Files for teachers') ?>
							</div>
						</div>
						<a class="more" href="files_x_teachers.php">
							<?php _e('View Files') ?> <i class="m-icon-swapright m-icon-white"></i>
						</a>
					</div>
				</div>
			</div>

			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php _e('View Profile') ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form action="#" class="form-horizontal form-bordered" onsubmit="return Save(this)">
								<!--                                                    <input type="hidden" name="id" value="--><?php //echo $id ?><!--"/>-->
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Teacher Name" ) ?></label>
										<div class="col-md-6">
											<input value="<?php echo $T["name"] ?>" type="text" name="name" title="<?php echo __( "Teacher name required" ) ?>"
											       class="form-control" disabled="disabled">
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Short Name" ) ?></label>
										<div class="col-md-6">
											<input value="<?php echo $T["short_name"] ?>" type="text" name="short_name"
											       title="<?php echo __( "Short name for teacher" ) ?>" class="form-control" disabled="disabled">
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Email address" ) ?></label>
										<div class="col-md-6">
											<input value="<?php echo $T["email"] ?>" type="email" name="email"
											       title="<?php echo __( "Email address required" ) ?>"
											       class="form-control" disabled="disabled">
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Cell Number" ) ?></label>
										<div class="col-md-6">
											<input value="<?php echo $T["cell"] ?>" type="text" name="cell"
											       title="<?php echo __( "Cell number required" ) ?>"
											       class="form-control" disabled="disabled">
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Date of Joining" ) ?></label>
										<div class="col-md-6">
											<input
												value="<?php echo \Dates::my_date( $T["date_of_joining"] ) ?>"
												type="text" name="date_of_joining" title="<?php echo __( "Date of joining" ) ?>"
												data-date-format="<?php echo \Dates::date_format1_for_js(); ?>"
												class="form-control date-picker" disabled="disabled">
										</div>
									</div>

									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Address" ) ?></label>
										<div class="col-md-6">
											<textarea class="form-control" disabled="disabled"><?php echo $T["address"] ?></textarea>
										</div>
									</div>

									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Salary" ) ?></label>
										<div class="col-md-6">
											<input value="<?php echo $T["salary"] ?>" type="number" name="salary"
											       title="<?php echo __( "Salary" ) ?>" class="form-control" disabled="disabled">
										</div>
									</div>

									<div class="form-group">
										<label class="control-label col-md-3"></label>
										<div class="col-md-6">
											<a href="profile.php">Edit Profile</a>
										</div>
									</div>
								</div>

							</form>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->

		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->
<?php include_once( __DIR__ . "/footer.php" ); ?>
<!-- END JAVASCRIPTS -->
</body>
<!-- END BODY -->
</html>

