<?php include_once( __DIR__ . "/../library.php" );
$teacher = new Teacher();
if ( $teacher->is_teacher_logged_in() ) {
	Urls::redirect( "index.php" );
}
if ( isset( $_GET["login"] ) ) {
	echo $teacher->login( $_POST );
	exit;
}
?>
<!DOCTYPE html>
<!--[if IE 8]>
<html lang="en" class="ie8 no-js"> <![endif]-->
<!--[if IE 9]>
<html lang="en" class="ie9 no-js"> <![endif]-->
<!--[if !IE]><!-->
<html lang="en" class="no-js">
<!--<![endif]-->
<!-- BEGIN HEAD -->
<head>
	<meta charset="utf-8" />
	<title>Teacher Panel - <?php echo System ?></title>
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta content="width=device-width, initial-scale=1.0" name="viewport" />
	<meta content="" name="description" />
	<meta content="" name="author" />
	<meta name="MobileOptimized" content="320">
	<!-- BEGIN GLOBAL MANDATORY STYLES -->
	<link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" rel="stylesheet" type="text/css" />
	<link href="<?php echo ASSETS_URL ?>plugins/bootstrap/css/bootstrap.min.css" rel="stylesheet" type="text/css" />
	<link href="<?php echo ASSETS_URL ?>plugins/uniform/css/uniform.default.css" rel="stylesheet" type="text/css" />
	<!-- END GLOBAL MANDATORY STYLES -->
	<!-- BEGIN PAGE LEVEL STYLES -->
	<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/select2/select2_metro.css" />
	<!-- END PAGE LEVEL SCRIPTS -->
	<!-- BEGIN THEME STYLES -->
	<link href="<?php echo ASSETS_URL ?>css/style-metronic.css" rel="stylesheet" type="text/css" />
	<link href="<?php echo ASSETS_URL ?>css/style.css" rel="stylesheet" type="text/css" />
	<link href="<?php echo ASSETS_URL ?>css/style-responsive.css" rel="stylesheet" type="text/css" />
	<link href="<?php echo ASSETS_URL ?>css/plugins.css" rel="stylesheet" type="text/css" />
	<link href="<?php echo ASSETS_URL ?>css/themes/default.css" rel="stylesheet" type="text/css" id="style_color" />
	<link href="<?php echo ASSETS_URL ?>css/pages/login-soft.css" rel="stylesheet" type="text/css" />
	<link href="<?php echo ASSETS_URL ?>css/custom.css?<?php echo md5_file( ASSETS_PATH . "css/custom.css" ) ?>" rel="stylesheet" type="text/css" />
	<!-- END THEME STYLES -->
	<link rel="shortcut icon" href="<?php echo DOMAIN_URL; ?>favicon.ico" />
</head>
<!-- END HEAD -->
<!-- BEGIN BODY -->
<body class="login">
<div class="loading">Loading&#8230;</div>
<!-- BEGIN LOGO -->
<div class="logo">
	<img style="max-width:200px" src="<?php echo App::get_logo() ?>" alt="" />
</div>
<!-- END LOGO -->
<!-- BEGIN LOGIN -->
<div class="content">
	<!-- BEGIN LOGIN FORM -->
	<form class="login-form validate" action="index.php" method="post" id="login_form">
		<h3 class="form-title"><?php echo __("Login to your account") ?></h3>
		<div class="alert alert-danger display-hide">
			<button class="close" data-close="alert"></button>
			<span>
				 <?php echo __( "Enter any username and password." ) ?>
			</span>
		</div>
		<div class="form-group">
			<!--ie8, ie9 does not support html5 placeholder, so we just show field title for that-->
			<label class="control-label visible-ie8 visible-ie9">Username</label>
			<div class="input-icon">
				<i class="fa fa-user"></i>
				<input title="<?php echo __( "Teacher email as username required" ) ?>" required="required"
				       class="form-control placeholder-no-fix" type="email" autocomplete="off"
				       placeholder="<?php echo __( "Email address" ) ?>" name="email" id="email">
			</div>
		</div>
		<div class="form-group">
			<label class="control-label visible-ie8 visible-ie9">Password</label>
			<div class="input-icon">
				<i class="fa fa-lock"></i>
				<input title="<?php echo __( "Teacher password required" ) ?>" required="required" class="form-control placeholder-no-fix" type="password" autocomplete="off" placeholder="Password" name="password" id="password">
			</div>
		</div>
		<div class="form-actions">
			<label class="checkbox">
				<input type="checkbox" name="remember_me" id="remember_me" value="1"> <?php _e("Remember me") ?> </label>
			<button type="submit" class="btn blue pull-right" id="login_btn">
				Login <i class="m-icon-swapright m-icon-white"></i>
			</button>
		</div>
		<div class="forget-password">
			<h4><?php echo __( "Forgot your password ?" ) ?></h4>
			<p>
				No worries, click <a href="javascript:;" id="forget-password">here</a> to reset your password.
			</p>
		</div>
		<!--<div class="create-account">
			<p>
				Don't have an account yet ?&nbsp; <a href="javascript:;" id="register-btn">Create an account</a>
			</p>
		</div>-->
	</form>
	<!-- END LOGIN FORM -->
	<!-- BEGIN FORGOT PASSWORD FORM -->
	<form class="forget-form" action="#" method="post">
		<h3><?php echo __( "Forget Password?" ) ?></h3>
		<p>
			<?php echo __( "Enter your e-mail address below to reset your password." ) ?>
		</p>
		<div class="form-group">
			<div class="input-icon">
				<i class="fa fa-envelope"></i>
				<input class="form-control placeholder-no-fix" type="text" autocomplete="off" placeholder="Email" name="email" />
			</div>
		</div>
		<div class="form-actions">
			<button type="button" id="back-btn" class="btn">
				<i class="m-icon-swapleft"></i> Back
			</button>
			<button type="submit" class="btn blue pull-right">
				Submit <i class="m-icon-swapright m-icon-white"></i>
			</button>
		</div>
	</form>
	<!-- END FORGOT PASSWORD FORM -->
</div>
<!-- END LOGIN -->
<!-- BEGIN COPYRIGHT -->
<div class="copyright">
	<?php if ( ! empty( $__decoded_key["reseller_title"] ) ) { ?>
		<?php echo date( "Y" ); ?> &copy; <?php echo $__decoded_key["reseller_title"]; ?> | <?php _e('Version') ?>: <?php echo Version ?>
	<?php } else if ( is_file( ROOT_PATH . "branding" ) ) {
		$TT = file( ROOT_PATH . "branding" ); ?>
		<?php echo date( "Y" ); ?> &copy; <?php echo base64_decode( $TT[0] ); ?> | <?php _e('Version') ?>: <?php echo Version ?>
	<?php } else { ?>
		2014-<?php echo date( "Y" ); ?> &copy; FeKara | <?php _e('Version') ?>: <?php echo Version ?>
	<?php } ?>
</div>
<!-- END COPYRIGHT -->
<!-- BEGIN JAVASCRIPTS(Load javascripts at bottom, this will reduce page load time) -->
<!-- BEGIN CORE PLUGINS -->
<!--[if lt IE 9]>
<script src="<?php echo ASSETS_URL ?>plugins/respond.min.js"></script>
<script src="<?php echo ASSETS_URL ?>plugins/excanvas.min.js"></script>
<![endif]-->
<script src="<?php echo ASSETS_URL ?>plugins/jquery-1.10.2.min.js" type="text/javascript"></script>
<script src="<?php echo ASSETS_URL ?>plugins/jquery-migrate-1.2.1.min.js" type="text/javascript"></script>
<script src="<?php echo ASSETS_URL ?>plugins/bootstrap/js/bootstrap.min.js" type="text/javascript"></script>
<script src="<?php echo ASSETS_URL ?>plugins/bootstrap-hover-dropdown/twitter-bootstrap-hover-dropdown.min.js" type="text/javascript"></script>
<script src="<?php echo ASSETS_URL ?>plugins/jquery-slimscroll/jquery.slimscroll.min.js" type="text/javascript"></script>
<script src="<?php echo ASSETS_URL ?>plugins/jquery.blockui.min.js" type="text/javascript"></script>
<script src="<?php echo ASSETS_URL ?>plugins/jquery.cokie.min.js" type="text/javascript"></script>
<script src="<?php echo ASSETS_URL ?>plugins/uniform/jquery.uniform.min.js" type="text/javascript"></script>
<?php if ( \General::is_offline() ) { ?>
	<script src="<?php echo ASSETS_URL ?>added_plugins/jquery-validation-1.16.0/dist/jquery.validate.min.js"></script>
	<script src="<?php echo ASSETS_URL ?>added_plugins/jquery-validation-1.16.0/dist/additional-methods.min.js"></script>
<?php } else { ?>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.16.0/jquery.validate.min.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.16.0/additional-methods.min.js"></script>
<?php } ?>
<!--<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-backstretch/2.0.3/jquery.backstretch.min.js" type="text/javascript"></script>-->
<script type="text/javascript" src="<?php echo ASSETS_URL ?>plugins/select2/select2.min.js"></script>
<script src="<?php echo ASSETS_URL ?>scripts/app.js"></script>
<script src="<?php echo ASSETS_URL ?>custom.min.js?<?php echo md5_file( ASSETS_PATH . "custom.js" ) ?>"></script>
<!--<script src="<?php /*echo DOMAIN_URL; */ ?>assets/scripts/login-soft.js" type="text/javascript"></script>-->

<script>
	var R = "<?php echo isset( $_GET['goto'] ) ? $_GET['goto'] : "index.php"; ?>";
	jQuery( document ).ready( function() {
		App.init();
		//Login.init();

		$( document ).on( "submit", "#login_form", function() {
			k = $( "#login_form" ).serialize();
			$( "#email, #password, #remember_me, #login_btn" ).attr( "disabled", true );
			$( ".loading" ).show();
			$.post( "login.php?login", k, function( data ) {
				if ( data=="OK" ) {
					window.location.href = R;
				} else {
					$( ".loading" ).hide();
					$( "#email, #password, #remember_me, #login_btn" ).attr( "disabled", false );
					alert( data );
					$( "#email" ).focus();
				}
			} );
			return false;
		} );
		$( document ).on( "keypress", "#email, #password", function( e ) {
			if ( e.which=="13" ) {
				$( "#login_form" ).submit();
			}
		} );
	} );
</script>
<!-- END JAVASCRIPTS -->
</body>
<!-- END BODY -->
</html>