<?php
include_once( __DIR__ . "/../library.php" );
$teacher = new Teacher();
if ( isset( $_GET['save_profile'] ) ) {
	echo $teacher->save_teacher( $_POST );
	exit;
}
if ( isset( $_GET['change_password'] ) ) {
	echo $teacher->change_password( $_POST );
	exit;
}
if ( ! $teacher->is_teacher_logged_in() ) {
	Urls::redirect( "login.php" );
}
include_once( __DIR__ . "/header.php" );
$emails = $teacher->get_teacher_emails( $T["id"] );
?>
<script>
	var Emails = <?php echo json_encode( $emails ) ?>;
</script>
<div class="page-container">
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __( "Profile" ) ?>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="profile.php"><?php echo __( "Profile" ) ?></a>
						</li>
					</ul>
				</div>
			</div>

			<div class="row">
				<div class="col-md-6">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-user"></i> <?php echo __( "Profile" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<a href="#portlet-config" data-toggle="modal" class="config"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form id="profile_form" class="horizontal-form validate" action="<?php echo Urls::get_url("profile", 0, "save_profile") ?>">
								<input type="hidden" name="id" value="<?php echo $T["id"] ?>">
								<input type="hidden" name="ignore_class_save" value="1">
								<div class="form-body">
									<div class="row">
										<div class="col-md-6">
											<div class="form-group">
												<label class="control-label"><?php echo __( "Teacher Name" ) ?></label>
												<input value="<?php echo $T["name"] ?>" type="text" name="name"
												       title="<?php echo __( "Teacher name required" ) ?>"
												       class="form-control" required="required">
											</div>
										</div>
										<div class="col-md-6">
											<div class="form-group">
												<label class="control-label"><?php echo __( "Short Name" ) ?></label>
												<input value="<?php echo $T["short_name"] ?>" type="text" name="short_name"
												       title="<?php echo __( "Short name for teacher" ) ?>"
												       class="form-control">
											</div>
										</div>
									</div>

									<div class="row">
										<div class="col-md-6">
											<div class="form-group">
												<label class="control-label"><?php echo __( "Email address" ) ?></label>
												<input value="<?php echo $T["email"] ?>" type="email" name="email" required="required"
												       title="<?php echo __( "Email address required" ) ?>"
												       class="form-control" data-rule-validmail="true"
												       data-msg-validmail="<?php echo __( "This email already exists, Please select different email address" ) ?>">
											</div>
										</div>
										<!--/span-->
										<div class="col-md-6">
											<div class="form-group">
												<label class="control-label"><?php echo __( "Cell Number" ) ?></label>
												<input value="<?php echo $T["cell"] ?>" type="text" name="cell"
												       title="<?php echo __( "Cell number required" ) ?>"
												       data-msg-mobile="<?php echo __( "Please provide valid phone number, .e.g. +92 321 1234567" ) ?>"
												       class="form-control mobile" required="required">
											</div>
										</div>
									</div>
									<div class="row">
										<div class="col-md-6">
											<div class="form-group">
												<label class="control-label"><?php echo __( "Date of Joining" ) ?></label>
												<input
													value="<?php echo \Dates::my_date( $T["date_of_joining"] ) ?>"
													type="text" name="date_of_joining" title="<?php echo __( "Date of joining" ) ?>"
													data-date-format="<?php echo \Dates::date_format1_for_js(); ?>" required="required"
													class="form-control date-picker" placeholder="<?php echo __( "Address" ) ?>">
											</div>
										</div>
										<div class="col-md-6">
											<div class="form-group">
												<label class="control-label"><?php echo __( "Address" ) ?></label>
												<input type="text" class="form-control">
											</div>
										</div>
									</div>
								</div>
								<div class="form-actions right">
									<button type="button" class="btn default">Cancel</button>
									<button type="submit" class="btn blue"><i class="fa fa-check"></i> Save</button>
								</div>
							</form>
						</div>
					</div>
				</div>
				<div class="col-md-6">
					<div class="portlet box green">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-password"></i> <?php echo __( "Change password" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form class="form-horizontal validate" id="form1">
								<input type="reset" class="hidden" id="form1_reset">
								<div class="form-body">
									<div class="form-group">
										<label for="current_password" class="col-md-3 control-label"><?php echo __( "Current password" ) ?></label>
										<div class="col-md-4">
											<div class="input-group">
												<input id="current_password" name="current_password" required="required" type="password"
												       class="form-control" placeholder="<?php echo __( "Current password" ) ?>"
												       autocomplete="on" title="<?php echo __( "Current password" ) ?>">
												<span class="input-group-addon">
                                                    <i class="fa fa-lock"></i>
                                                </span>
											</div>
										</div>
									</div>
									<div class="form-group">
										<label for="password1" class="col-md-3 control-label"><?php echo __( "New password" ) ?></label>
										<div class="col-md-4">
											<div class="input-group">
												<input name="password1" required="required" type="password"
												       class="form-control" placeholder="<?php echo __( "New password" ) ?>"
												       id="password1" autocomplete="off" title="<?php echo __( "New password" ) ?>">
												<span class="input-group-addon">
                                                    <i class="fa fa-lock"></i>
                                                </span>
											</div>
										</div>
									</div>
									<div class="form-group">
										<label for="password2" class="col-md-3 control-label"><?php echo __( "New password again" ) ?></label>
										<div class="col-md-4">
											<div class="input-group">
												<input name="password2" required="required" type="password"
												       class="form-control" placeholder="<?php echo __( "New password again" ) ?>"
												       data-rule-equalto="#password1"
												       autocomplete="off" id="password2" title="<?php echo __( "New password again" ) ?>">
												<span class="input-group-addon">
                                                    <i class="fa fa-lock"></i>
                                                </span>
											</div>
										</div>
									</div>
									<!--<div class="form-group">
										<label class="col-md-3 control-label">Input With Spinner</label>
										<div class="col-md-4">
											<input type="password" class="form-control spinner" placeholder="Password" autocomplete="on" style="cursor: auto;">
										</div>
									</div>-->
								</div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="submit" class="btn blue"><?php echo __( "Save" ) ?></button>
										<button type="button" class="btn default"><?php echo __( "Cancel" ) ?></button>
									</div>
								</div>
							</form>
							<!-- END FORM-->
						</div>
					</div>
				</div>
			</div>

			<div class="clearfix">
			</div>
		</div>
	</div>
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>
<script>
	$( function() {
		$( document ).on( "submit", "#form1", function() {
			$( ".loading" ).show();
			$.post( "<?php echo filename() ?>?change_password", $( "#form1" ).serialize(), function( data ) {
				$( ".loading" ).hide();
				$( "#form1_reset" ).click();
				if ( data == "OK" ) {
					alert( "Password changed successfully!" );
				} else {
					alert( "Error: " + data );
				}
			} );
			return false;
		} );
		$( document ).on( "submit", "#profile_form", function( event ) {
			event.preventDefault();
			$( ".loading" ).show();
			$.post( $( this ).attr( "action" ), $( this ).serialize(), function( data ) {
				$( ".loading" ).hide();
				if ( data == "OK" ) {
					Success( "<?php echo __( "Teacher profile saved successfully!" ); ?>" );
				} else {
					Error( data );
				}
			} );
		} );
		$.validator.addMethod(
			"validmail",
			function( value, element ) {
				return ($.inArray( value, Emails ) < 0)
			},
			"<?php echo __( "This email already exists, Please select different email address" ) ?>"
		);
	} );
</script>
</body>
<!-- END BODY -->
</html>

