<?php
include_once( __DIR__ . "/header.php" );
if ( ! $teacher->is_teacher_logged_in() ) {
	Urls::redirect( "login.php" );
}
// get teacher classes
$Students = $teacher = $teacher->get_students_by_teacher( $T["id"] );
?>
<div class="page-container">
	<?php include_once( __DIR__ . "/mobile_menu.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __( "Dashboard" ) ?>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php echo __( "Student Progress Report" ) ?>
						</li>
					</ul>
				</div>
			</div>
			<div class="clearfix"></div>
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php echo __( "Generate Report" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<!--<a href="#portlet-config" data-toggle="modal" class="config"></a>-->
							</div>
						</div>
						<div class="portlet-body form">
							<form target="_ems" action="<?php echo Urls::get_url( "download_student_progress_report" ) ?>"
							      class="form-horizontal form-bordered validate">
								<div class="form-group">
									<label class="control-label col-md-3"><?php echo __( "Select Student" ) ?></label>
									<div class="col-md-9">
										<select class="form-control select2" name="student_id" id="student_id" required="required">
											<?php
											foreach ( $Students as $student ) {
												?>
												<option value="<?php echo $student["id"] ?>">
													<?php echo $student["class_name"] . " > " . $student["name"] ?>
												</option>
											<?php } ?>
										</select>
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-md-3"><?php echo __( "Test/Exam Date Range" ) ?></label>
									<div class="col-md-9">
										<div class="input-group date-picker input-daterange"
										     data-date-format="<?php echo \Dates::date_format1_for_js(); ?>">
											<input value="<?php echo date( "01-m-Y" ) ?>" required="required" type="text"
											       class="form-control" name="from" placeholder="<?php echo __( "From Date" ) ?>">
											<span class="input-group-addon">
												to
											</span>
											<input value="<?php echo \Dates::my_date() ?>" required="required"
											       type="text" class="form-control" name="to" placeholder="<?php echo __( "To Date" ) ?>">
										</div>
										<!-- /input-group -->
										<span class="help-block">
											<?php echo __( "Select date range" ) ?>
										</span>
									</div>
								</div>
								<div id="moresubjects"></div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="submit" name="viewBtn" class="btn green"><?php echo __( "View Report" ) ?></button>
										<button type="submit" name="downBtn" class="btn blue"><?php echo __( "Download Report" ) ?></button>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>
</body>
</html>