<?php
include_once( __DIR__ . "/header.php" );
if ( ! $teacher->is_teacher_logged_in() ) {
	Urls::redirect( "login.php" );
}
// get teacher classes
$cids     = "";
$getClass = $teacher->get_teachers_assign_classes( $T["id"] );
foreach ( $getClass as $row ) {
	$cids .= "'" . $row["id"] . "',";
}
$cids = trim( $cids, "," );
//$S        = $teacher->get_teachers_assign_classes_students( $cids );
$Students = $teacher->get_students_by_teacher( $T["id"] );
?>
<div class="page-container">
	<?php include_once( __DIR__ . "/mobile_menu.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __( "Dashboard" ) ?>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								<?php echo __( "Actions" ) ?>
							</span>
								<i class="fa fa-angle-down"></i>
							</button>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php echo __( "Student Weekly Report" ) ?>
						</li>
					</ul>
				</div>
			</div>
			<div class="clearfix"></div>
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php echo __( "Generate Report" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<!--<a href="#portlet-config" data-toggle="modal" class="config"></a>-->
							</div>
						</div>
						<div class="portlet-body form">
							<form id="report_form" action="<?php echo Urls::get_url( "download_student_weekly_report" ) ?>" class="form-horizontal form-bordered validate" onsubmit="return Form(1);">
								<div class="form-group">
									<label class="control-label col-md-3"><?php echo __( "Select Student" ) ?></label>
									<div class="col-md-9">
										<select class="form-control select2" name="student_id" id="student_id" required="required">
											<?php
											foreach ( $Students as $student ) {
												?>
												<option value="<?php echo $student["id"] ?>">
													<?php echo $student["class_name"] . " > " . $student["name"] ?>
												</option>
											<?php }
											?>
										</select>
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-md-3"><?php echo __( "Test/Exam Schedule Date Range" ) ?></label>
									<div class="col-md-9">
										<div class="input-group date-picker input-daterange" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>">
											<input value="<?php echo date( "01-m-Y" ) ?>" required="required" type="text" class="form-control" name="from" placeholder="From Date">
											<span class="input-group-addon">
												to
											</span>
											<input value="<?php echo \Dates::my_date() ?>" required="required" type="text" class="form-control" name="to" placeholder="<?php echo __("To Date") ?>">
										</div>
										<!-- /input-group -->
										<span class="help-block">
											<?php echo __( "Select date range" ) ?>
										</span>
									</div>
								</div>
								<div id="moresubjects"></div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="button" onclick="Form(1)" class="btn green"><?php echo __( "View Report" ) ?></button>
										<button type="button" onclick="Form(2)" name="smsBtn" class="btn yellow"><?php echo __( "Send SMS" ) ?></button>
										<button type="button" onclick="Form(3)" name="downBtn" class="btn blue"><?php echo __( "Download Report" ) ?></button>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="text/javascript">
	function Sub1( form ) {
		alert( $( form ).serialize() );
		return false;
	}

	$( function() {
		/*$( "#student_id" ).typeahead( {
			source: Students
		} );*/
	} );

	function Form( btn ) {
		if ( !$( '#report_form' ).validate().form() ) {
			return false;
		}

		if ( btn == 1 ) {
			u = $( "#report_form" ).serialize() + "&viewBtn";
		} else if ( btn == 2 ) {
			u = $( "#report_form" ).serialize() + "&smsBtn";
		} else {
			u = $( "#report_form" ).serialize();
			window.location.href = $( "#report_form" ).attr( "action" ) + "&" + u;
			return false;
		}

		u = $( "#report_form" ).attr( "action" ) + "&" + u;
		jQuery.fancybox( {
			'title': "Weekly Report",
			'href': u,
			'type': 'iframe',
			'width': '90%',
			'height': '90%',
		} );
	}
</script>
</body>
</html>