<?php
//include_once( __DIR__ . "/../library.php" );
$title = "Students Views";
include_once( __DIR__ . "/header.php" );
// get teacher
if ( ! $teacher->is_teacher_logged_in() ) {
	Urls::redirect( "login.php" );
}
$id = $T["id"];
$classes = $teacher->get_teachers_assign_classes_data( $id );
$Student = new Student();
?>
<div class="page-container">
	<?php include_once( __DIR__ . "/mobile_menu.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title"><?php echo __( "Student View" ) ?></h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php"><?php _e( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li><a href="students_view.php"><?php echo __( "Students View" ) ?></a></li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<?php
					$Files = [];
					foreach ( $classes as $key => $class ) { ?>
						<div class="portlet box blue">
							<div class="portlet-title">
								<div class="caption">
									<i class="fa fa-reorder"></i> <?php echo __( "Class Name (%1)", $class["class_name"] ) ?>
								</div>
								<div class="tools">
									<a href="javascript:;" class="collapse"></a>
								</div>
							</div>

							<div class="portlet-body">
								<table class="table table-striped table-bordered table-hover">
									<thead>
									<tr>
										<th><?php echo __( "Admission #" ) ?></th>
										<th><?php echo __( "Roll No" ) ?></th>
										<th><?php echo __( "Student Name" ) ?></th>
										<th><?php echo __( "Admission Date" ) ?></th>
										<th><?php echo __( "Date of Birth" ) ?></th>
										<th><?php _e( "Files" ) ?></th>
									</tr>
									</thead>
									<tbody>
									<?php
									$students = $Student->get_students( "class_id=" . $class["id"] );
									if ( count( $students ) == 0 ) { ?>
										<tr>
											<td style="text-align:center !important;" colspan="5"><?php _e( "No students in this class" ) ?></td>
										</tr>
									<?php } else {
										foreach ( $students as $student_key => $student ) { ?>
											<tr>
												<td><?php echo $student["admission_number"] ?></td>
												<td>
													<a href="upload_assignment.php?id=<?php echo $student["id"] ?>"><?php echo $student["roll"] ?></a>
												</td>
												<td>
													<a href="upload_assignment.php?id=<?php echo $student["id"] ?>"><?php echo $student["name"] ?></a>
												</td>
												<td><?php echo \Dates::my_date( $student["admission_date"] ) ?></td>
												<td>
													<?php echo \Dates::my_date( $student["dob"] ) ?>
													(<?php _e( "%1 Years", date( "Y" ) - date( "Y", strtotime( $student["dob"] ) ) ); ?>)
												</td>
												<td>
													<?php
													$assignment_files = $teacher->get_teacher_x_student_assignment_files( $student["id"] );
													foreach ( $assignment_files as $assignment_file ) {
														$Files[ $student["id"] ][ $id ][] = [
															"filename" => basename( $assignment_file ),
															"url"      => $Student->get_assignment_file_url( $student["id"], $id, basename( $assignment_file ) ),
														];
													}
													//$classes[ $key ][$student_key]["files"] = $assignment_files;
													if ( count( $assignment_files ) > 0 ) {
														echo "<a title='View Files' class='btn btn-xs red view_files' href='#' data-studentid='{$student["id"]}'>";
														echo __( "%1 assignment files", "<span id='student_counter_{$student["id"]}'>" . count( $assignment_files ) . "</span>" );
														echo "</a>";
													} else {
														echo "<i style='font-size:small'>" . __( "No file uploaded" ) . "</i>";
													}
													?>
												</td>
											</tr>
										<?php }
									} ?>
									</tbody>
								</table>
							</div>

						</div>
					<?php } ?>
				</div>
			</div>

			<div class="clearfix"></div>
		</div>
	</div>
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="text/javascript">
	var Classes = <?php echo json_encode( $classes ) ?>;
	var Files = <?php echo json_encode( $Files ) ?>;

	function Save( form ) {
		Block();
		var form = document.getElementById( "form1" );
		var formData = new FormData( form );
		$.ajax( {
			url: '<?php echo DOMAIN_URL ?>includes/ajax.php?action=teacherUploadFile',
			type: 'POST',
			xhr: function() {
				var myXhr = $.ajaxSettings.xhr();
				return myXhr;
			},
			success: function( data ) {
				if ( data=="OK" ) {
					UnBlock();
					Success( "File uploaded successfully!" );
					window.location.reload();
				} else {
					UnBlock();
					Error( data );
				}
			},
			error: function( data ) {
				Error( data );
			},
			data: formData,
			cache: false,
			contentType: false,
			processData: false
		} );
		return false;
	}

	$( function() {
		$( document ).on( "click", ".view_files", function( event ) {
			event.preventDefault();

			student_id = $( this ).attr( "data-studentid" );
			attached_files = Files[ student_id ][<?php echo $id ?>];

			HTML = `
				<table class="table table-striped table-bordered table-hover">
					<thead>
						<tr><th>File</th><th></th></tr>
					</thead>
					<tbody>
					${attached_files.map( file =>`
						<tr>
							<td>
								<a title="View File" target="_blank" href="${file.url}">${file.filename}</a>
							</td>
							<td><button data-studentid="${student_id}" data-filename="${file.filename}" class="btn btn-xs red del_file"><i class="fa fa-trash"></i> Delete</button></td>
						</tr>
					`).join('')}
					</tbody>
				</table>
			`;
			$.fancybox( {
				content: HTML
			} );
		} );
		$( document ).on( "click", "#fileDelete", function( e ) {
			e.preventDefault();
			Block();
			var id = $( this ).data( "id" );
			var name = $( this ).data( "name" );
			var path = $( this ).data( "path" );
			$.post( '<?php echo DOMAIN_URL ?>includes/ajax.php?action=teacher_file_delete', {
				id: id,
				filename: name,
				path: path
			}, function( data ) {
				if ( data=="OK" ) {
					Success( "File delete successfully!" );
					window.location.reload();
				} else {
					UnBlock();
					Error( data );
				}
			} );
		} );
		$( document ).on( "click", ".del_file", function( event ) {
			event.preventDefault();

			if ( !confirm( "<?php _e( "Are you sure you want to delete this file?" ) ?>" ) ) {
				return false;
			}

			student_id = $( this ).attr( "data-studentid" );
			filename = $( this ).attr( "data-filename" );

			$( this ).closest( "tr" ).remove();
			cnt = Number( $( "#student_counter_" + student_id ).text() );
			$( "#student_counter_" + student_id ).text( cnt - 1 );

			$.post( "ajax/students_view.php?del_file", {
				student_id: student_id,
				filename: filename,
				teacher_id:<?php echo $id ?>}, function( data ) {
				if ( data!="OK" ) {
					Error( data );
				}
			} );
		} );
	} );
</script>
</body>
</html>

