<?php
$title = 'Files uploaded by students';
include_once( __DIR__ . "/header.php" );
$teacher = new \Teacher\Files();
$students = $teacher->get_students_list();
?>
<link rel="stylesheet" href="css/teachers_x_files.css?<?php echo md5_file( __DIR__ . '/css/teachers_x_files.css' ) ?>">
<div class="page-container">
	<?php include_once( __DIR__ . "/mobile_menu.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __( "Dashboard" ) ?>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php echo __( "Files uploaded by students" ) ?>
						</li>
					</ul>
				</div>

				<ul class="nav nav-tabs">
					<li>
						<a href="files_x_teachers.php"><?php _e( 'Files by students' ) ?></a>
					</li>
					<li class="active">
						<a href="teachers_x_files.php"><?php _e( 'Files for students' ) ?></a>
					</li>
				</ul>

				<select id="student_id" class="select2" style="max-width: 300px;width:100%">
					<option value="0">== Select student ==</option>
					<?php foreach($students as $student) { ?>
						<option value="<?php echo $student['id'] ?>"><?php echo $student['name'] ?> = Class: <?php echo $student['class_name'] ?></option>
					<?php } ?>
				</select>
				<div id="drop-area">
					<form class="my-form">
						<p>Upload multiple allowed files with the file dialog or by dragging and dropping onto the dashed region</p>
						<p>Note: Select teacher above before upload files</p>
						<input type="file" id="fileElem" multiple accept="<?php echo ALLOWED_FILES ?>" onchange="handleFiles(this.files)">
						<label class="button" for="fileElem"><i class="fa fa-upload"></i> Select files</label>
					</form>
				</div>

				<div class="portlet box blue">
					<div class="portlet-title">
						<div class="caption">
							<i class="fa fa-users"></i>
							<?php _e( "Uploaded files" ) ?>
						</div>
						<div class="tools">
							<a href="javascript:;" class="collapse"></a>
						</div>
					</div>
					<div class="portlet-body form">
						<div id="loader">
							Loading, Please wait....
						</div>
						<div id="files" style="display:none">
							<div v-for="students, student_id in files" id="files_sub_div">
								<div class="heading">Files from student "{{students[0].name}}"</div>
								<div class="file-group" v-for="file in students" style="margin: 3px;">
									<a target="_blank" :href="file.file_url" class="btn btn-success" :title="file.filename">
										{{file.filename}}
									</a>
									<button type="button" class="btn btn-danger del_btn" :data-id="file.id">
										<i class="fa fa-trash"></i>
									</button>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->
<?php include_once( __DIR__ . "/footer.php" ); ?>
<script>
	var teacher_id = <?php echo $T['id'] ?>;
</script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/vue/2.5.22/vue.min.js"></script>
<script src="js/teachers_x_files.js?<?php echo md5_file( __DIR__ . '/js/teachers_x_files.js' ) ?>"></script>
<!-- END JAVASCRIPTS -->
</body>
<!-- END BODY -->
</html>