<?php
include_once( __DIR__ . "/header.php" );
$TT     = new TimeTable\TimeTable();
$Shifts = new \TimeTable\Shifts();
?>
<div class="page-container">
	<?php include_once( __DIR__ . "/mobile_menu.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __( "Time Table" ) ?>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="time_table.php">
								<?php echo __( "Time Table" ) ?>
							</a>
						</li>
					</ul>
				</div>
			</div>

			<div class="row">
				<div class="col-md-12">
					<?php $teacher_shifts = $TT->get_time_table_teacher( $T["id"] );
					#show_array( $teacher_shifts );
					$all_shifts = $Shifts->get_shifts( "mysql_cols=`id`,`shift_name`,`start_time`,`end_time`&pagesize=9999" ); ?>
					<label style="cursor: pointer"><input id="show_related_shifts_checkbox" type="checkbox"> Show only related shifts</label>
					<button id="print_btn" class="btn btn-sm green"><i class="fa fa-print"></i> Print</button>
					<div id="table_div">
					<table class="table table-striped table-bordered table-hover">
						<thead>
						<tr class="heading">
							<th><?php _e("Shift Name") ?></th>
							<?php for ( $x = 1; $x <= 7; $x ++ ) {
								echo "<th>" . __( jddayofweek( $x - 1, 2 ) ) . "</th>";
							} ?>
						</tr>
						</thead>
						<?php foreach ( $all_shifts["rows"] as $shift ) {
							$involved = false;
							?>
							<tr>
								<td>
									<b><?php echo $shift["shift_name"] ?></b><br>
									<?php echo $shift["start_time"]." > ".$shift["end_time"]; ?>
								</td>
								<?php for ( $x = 1; $x <= 7; $x ++ ) {
									if ( isset( $teacher_shifts[ $shift["id"] ][$x] ) ) {
										$involved = true;
										?>
										<td class="involved">
											Class: <?php echo $teacher_shifts[ $shift["id"] ][$x]["class_name"] ?><br>
											Subject: <?php echo $teacher_shifts[ $shift["id"] ][$x]["subject"] ?>
											<?php #show_array($teacher_shifts[ $shift["id"] ][$x]); ?>
										</td>
									<?php } else { ?>
										<td style="text-align: center;color:#c9c9c9;vertical-align: middle">X</td>
									<?php }
								} ?>
							</tr>
						<?php } ?>
					</table>
					</div>
					<div style="display: none">
						<table style="width: 100%" border="1" cellspacing="0" id="table2" cellpadding="5">
							<thead>
							<tr class="heading">
								<th><?php _e("Shift Name") ?></th>
								<?php for ( $x = 1; $x <= 7; $x ++ ) {
									echo "<td>" . __( jddayofweek( $x - 1, 2 ) ) . "</td>";
								} ?>
							</tr>
							</thead>
							<tbody></tbody>
						</table>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>
<script src="js/time_table.min.js?<?php echo md5_file( __DIR__."/js/time_table.min.js" ) ?>"></script>
</body>
</html>