<?php
include_once( __DIR__ . "/../library.php" );
$title = __( "Assignment Upload" );
include_once( __DIR__ . "/header.php" );
// get teacher
$classids = "";
if ( isset( $_GET ) && $_GET["id"] != "" ) {
	$classids = $_GET["id"];
} else {
	Urls::redirect( "material.php" );
	die();
}
$teacher = new Teacher();
if ( ! $teacher->is_teacher_logged_in() ) {
	Urls::redirect( "login.php" );
}
$T          = $teacher->get_teacher();
$id         = $T["id"];
$getClasses = $teacher->get_teachers_assign_classes_result( $id, $classids );
if ( isset( $getClasses ) ) {
//	foreach ( $getClasses as $row ) {
//	}
} else {
	Urls::redirect( "material.php" );
	die();
}
// get subject assignment
$getSubjects = $teacher->get_teachers_assign_subjects_result( $id, $classids );
//echo $getSubjects["file"];echo "<pre>";print_r($getSubjects);die();
?>
<div class="page-container">
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title"><?php echo __( "Upload Assignment" ) ?></h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li><a href="#"><?php echo __( "Subjects Assignment" ) ?></a></li>
					</ul>
				</div>
			</div>

			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i><?php echo __( "Class Name (%1)", $row["name"] ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<!--<a href="#portlet-config" data-toggle="modal" class="config"></a>-->
							</div>
						</div>

						<div class="portlet-body">
							<table class="table table-striped table-bordered table-hover datatable">
								<thead>
								<tr>
									<th><?php echo __( "ID" ) ?></th>
									<th><?php echo __( "Class Name" ) ?></th>
									<th><?php echo __( "Subject Name" ) ?></th>
									<th><?php echo __( "Assignment Files" ) ?></th>
									<th><?php echo __( "Upload" ) ?></th>
								</tr>
								</thead>
								<tbody>

								<?php if ( isset( $getClasses ) ) {
									$i        = 1;
									$subjects = [];
									foreach ( $getClasses as $row ) {
										//$subjects = explode( ",", $row["subjects"] );
										$subjects = \Str::make_array( $row["subjects"] );
									}
									foreach ( $subjects as $v ) { ?>
										<tr>
											<td><?php echo $i; ?></td>
											<td><?php echo $row["name"]; ?></td>
											<td><?php echo $v; ?></td>
											<td>
												<?php
												if ( isset( $getSubjects ) ) {
													foreach ( $getSubjects as $s ) {
														if ( $s["subject_name"] == $v ) {
															$rid  = $s["id"];
															$file = $s["file_name"];
															echo "<i style='cursor: pointer' class='fa fa-times removefile' 
                                                                data-removeid='$rid' 
                                                                data-removetid='$id' 
                                                                data-removefile='$file'></i> " . "<a style='cursor: pointer' href='" . DOMAIN_URL . "includes/downloader.php?path=teacher/{$id}/{$s["file_name"]}' target='_blank'>" . $s["file"] . "</a>" . "<br>";
														}
													}
													echo "-";
												} else {
													echo "-";
												}
												?>
											</td>
											<td>
												<input type="file" id="assignment_file<?php echo $i ?>"
												       class="assignment_file"
												       data-file_no="<?php echo $i ?>"
												       data-teacherid="<?php echo $id ?>"
												       data-classid="<?php echo $classids ?>"
												       data-subject_name="<?php echo $v ?>" value="Assignment">
											</td>
										</tr>

										<?php $i ++;
									}
								} else { ?>
									<tr>
										<td>-</td>
										<td>-</td>
										<td>-</td>
										<td>-</td>
										<td>-</td>
									</tr>
								<?php } ?>

								</tbody>
							</table>
						</div>

					</div>
				</div>
			</div>
			<div class="clearfix"></div>
		</div>
	</div>
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="text/javascript">
	$( document ).on( "change", ".assignment_file", function( e ) {
		e.preventDefault();
		Block();
		var no = $( this ).data( "file_no" );
		var formData = new FormData();
		formData.append( 'teacherid', $( this ).data( "teacherid" ) );
		formData.append( 'classid', $( this ).data( "classid" ) );
		formData.append( 'subject_name', $( this ).data( "subject_name" ) );
		formData.append( 'files', $( '#assignment_file' + no )[ 0 ].files[ 0 ] );
		$.ajax( {
			type: 'POST',
			url: "<?php echo DOMAIN_URL ?>includes/ajax.php?action=teacher_uplod_assignment",
			data: formData,
			cache: false,
			//dataType: 'json',
			processData: false,
			contentType: false,
			success: function( data ) {
				console.log( data );
				if ( data=="OK" ) {
					Success( "File uploaded successfully!" );
					window.location.reload();
				} else {
					UnBlock();
					Error( data );
				}
			}
		} );
		return false;
	} );

	$( document ).on( "click", ".removefile", function( e ) {
		e.preventDefault();
		var id = $( this ).data( "removeid" );
		var tid = $( this ).data( "removetid" );
		var file = $( this ).data( "removefile" );
		var path = $( this ).data( "path" );
		Block();
		$.post( '<?php echo DOMAIN_URL ?>includes/ajax.php?action=assignment_delete',
			{ id: id, tid: tid, file: file, path: path }
			, function( data ) {
				if ( data=="OK" ) {
					Success( "<?php echo __( "File has been deleted successfully" ) ?>" );
					window.location.reload();
				} else {
					UnBlock();
					Error( data );
				}
			} );
		return false;
	} );
</script>
</body>
</html>

