<?php
include_once( __DIR__ . "/../library.php" );
$title = __( "Upload Files" );
include_once( __DIR__ . "/header.php" );
// get teacher
$teacher = new Teacher();
if ( ! $teacher->is_teacher_logged_in() ) {
	Urls::redirect( "login.php" );
}
$T        = $teacher->get_teacher();
$id       = $T["id"];
$getClass = $teacher->get_teachers_assign_classes_data( $id );
$classids = [];
if ( ! empty( $getClass ) ) {
	foreach ( $getClass as $a ) {
		$classids[] = $a["classid"];
	}
}
//$getSubject = $teacher->get_teachers_assign_subjects($id);
$getFiles = $teacher->get_teacheruploadfile( $id );
$c        = new BatchClass();
$C        = $c->get_list();
?>
<style type="text/css">
	.tablesaw-cell-label {
		display: none;
	}

	#uploadfile {
		height: 35px;
		padding-bottom: 43px;
	}
</style>
<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- END SIDEBAR -->
	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">Upload File</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php">Home</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li><a href="#">Upload File</a></li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->

			<!-- BEGIN DASHBOARD STATS -->
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box green">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> Upload File
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<!-- BEGIN FORM-->
							<form class="form-horizontal" onsubmit="return Save()" id="form1" enctype="multipart/form-data">
								<div class="form-body">
									<input type="hidden" name="teacherid" id="teacherid" value="<?php echo $id ?>">
									<input type="hidden" name="teacher_name" id="teacher_name" value="<?php echo $T["name"] ?>">
									<div class="form-group">

										<label class="control-label col-md-3">Select Class</label>
										<div class="col-md-4">
											<select name="class" id="class" class="form-control input-xlarge select2" required="required">
												<option value="">== Select Class ==</option>
												<?php
												foreach ( $C as $c ) {
													if ( in_array( $c["id"], $classids ) ) {
														?>
														<option value="<?php echo $c["name"] ?>"><?php echo $c["name"] ?></option>
													<?php }
												} ?>
											</select>
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3">File</label>
										<div class="col-md-4">
											<input type="file" id="uploadfile" name="uploadfile"
											       title="Upload File" class="form-control input-xlarge" accept="application/msword,application/vnd.ms-excel,text/plain,application/pdf,image/*">
										</div>
									</div>
								</div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="submit" class="btn blue">Submit</button>
										<button type="button" class="btn default">Cancel</button>
									</div>
								</div>
							</form>
							<!-- END FORM-->
						</div>
					</div>
				</div>
			</div>

			<div class="row">
				<div class="col-md-12">
					<div class="portlet box green">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> Uploaded File
							</div>
						</div>
						<div class="portlet-body">
							<table class="table table-striped table-bordered table-hover datatable">
								<thead>
								<tr>
									<th>ID</th>
									<th>Teacher Name</th>
									<th>Class Name</th>
									<th>File</th>
									<th>Delete</th>
								</tr>
								</thead>
								<tbody>
								<?php if ( isset( $getFiles ) ) {
									foreach ( $getFiles as $k => $f ) {
										?>
										<tr>
											<td><?php echo $k + 1; ?></td>
											<td><?php echo $f["teacher_name"] ?></td>
											<td><?php echo $f["class"] ?></td>
											<td>
												<a href="<?php echo DOMAIN_URL . "includes/downloader.php?path=teacher/" . $f['teacherid'] . "/" . $f["file_name"]; ?>"><?php echo $f["file"] ?></a>
											</td>
											<td>
												<a style="cursor: pointer" id="fileDelete"
												   data-id="<?php echo $f["id"] ?>"
												   data-name="<?php echo $f["file_name"] ?>"
												   data-path="<?php echo ROOT_PATH . "contents/teacher/" . $f['teacherid'] . "/" . $f["file_name"]; ?>"
												   title="Delete"><i class="fa fa-times"></i>
												</a>
											</td>
										</tr>
									<?php }
								} ?>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>

			<!-- END DASHBOARD STATS -->
			<div class="clearfix"></div>

		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->
<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="text/javascript">

	function Save( form ) {
		Block();
		var form = document.getElementById( "form1" );
		var formData = new FormData( form );
		$.ajax( {
			url: '<?php echo DOMAIN_URL ?>includes/ajax.php?action=teacherUploadFile',
			type: 'POST',
			xhr: function() {
				var myXhr = $.ajaxSettings.xhr();
				return myXhr;
			},
			success: function( data ) {
				if ( data=="OK" ) {
					UnBlock();
					Success( "File uploaded successfully!" );
					window.location.reload();
				} else {
					UnBlock();
					Error( data );
				}
			},
			error: function( data ) {
				Error( data );
			},
			data: formData,
			cache: false,
			contentType: false,
			processData: false
		} );
		return false;
	}

	$( function() {

		$( document ).on( "click", "#fileDelete", function( e ) {
			e.preventDefault();
			Block();
			var id = $( this ).data( "id" );
			var name = $( this ).data( "name" );
			var path = $( this ).data( "path" );
			$.post( '<?php echo DOMAIN_URL ?>includes/ajax.php?action=teacher_file_delete', {
				id: id,
				filename: name,
				path: path
			}, function( data ) {
				if ( data=="OK" ) {
					Success( "File delete successfully!" );
					window.location.reload();
				} else {
					UnBlock();
					Error( data );
				}
			} );
		} );
	} );
</script>

</body>
<!-- END BODY -->
</html>

