<?php
$title = "Weekly Lecture";
include_once( __DIR__ . "/header.php" );
if ( ! $teacher->is_teacher_logged_in() ) {
	Urls::redirect( "login.php" );
}
$T         = $teacher->get_teacher();
$d         = new Datesheet;
$rows      = $d->get_schedule_row( $T["id"] );
$classname = "";
if ( isset( $rows ) && ! empty( $rows ) ) {
	foreach ( $rows as $row ) {
		$classname = $row['classname'];
		$time      = explode( ',', $row['time'] );
		$monday    = explode( ',', $row['monday'] );
		$tuesday   = explode( ',', $row['tuesday'] );
		$wednesday = explode( ',', $row['wednesday'] );
		$thursday  = explode( ',', $row['thursday'] );
		$friday    = explode( ',', $row['friday'] );
		$saturday  = explode( ',', $row['saturday'] );
	}
} else {
	$time = [];
}
?>
<div class="page-container">
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php"><?php _e( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="weekly_lecture.php">
								<?php _e( "Weekly Lectures" ) ?>
							</a>
						</li>
					</ul>
				</div>
			</div>
			<div class="clearfix"></div>
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php _e( "Weekly Lecture Schedule" ) ?> (<?php echo $classname ?>)
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<div class="form-body">
								<div class="form-group">
									<div class="col-md-12">
										<table class="table table-bordered table-striped">
											<thead>
											<tr class="heading">
												<th style="text-align: center;">Time</th>
												<th style="text-align: center;">Monday</th>
												<th style="text-align: center;">Tuesday</th>
												<th style="text-align: center;">Wednesday</th>
												<th style="text-align: center;">Thursday</th>
												<th style="text-align: center;">Friday</th>
												<th style="text-align: center;">Saturday</th>
											</tr>
											</thead>
											<tbody>
											<?php
											if ( ! empty( $rows ) ) {
												foreach ( $time as $j => $a ) { ?>
													<tr>
														<td style="text-align: center;"><?php echo $a ?></td>
														<td style="text-align: center;"><?php if ( $monday[ $j ] ) {
																echo $monday[ $j ];
															} else {
																echo "-";
															} ?></td>
														<td style="text-align: center;"><?php if ( $tuesday[ $j ] ) {
																echo $tuesday[ $j ];
															} else {
																echo "-";
															} ?></td>
														<td style="text-align: center;"><?php if ( $wednesday[ $j ] ) {
																echo $wednesday[ $j ];
															} else {
																echo "-";
															} ?></td>
														<td style="text-align: center;"><?php if ( $thursday[ $j ] ) {
																echo $thursday[ $j ];
															} else {
																echo "-";
															} ?></td>
														<td style="text-align: center;"><?php if ( $friday[ $j ] ) {
																echo $friday[ $j ];
															} else {
																echo "-";
															} ?></td>
														<td style="text-align: center;"><?php if ( $saturday[ $j ] ) {
																echo $saturday[ $j ];
															} else {
																echo "-";
															} ?></td>
													</tr>
												<?php }
											} ?>
											</tbody>
										</table>
									</div>
								</div>
							</div>
							<br>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->

		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->
<?php include_once( __DIR__ . "/footer.php" ); ?>
<!-- END JAVASCRIPTS -->
</body>
<!-- END BODY -->
</html>

