<?php
if ( ! defined( 'ROOT_PATH' ) ) {
	die( 'Direct file access is not allowed!' );
}

echo '<h1>Running Cron Job</h1>';

set_time_limit( 0 );

$Minute = date( 'i' );
$Hour   = date( 'h' );

$db->set_option( '1m_cron', time() );

if ( $Minute % 5 == 0 ) {
	include_once( __DIR__ . "/cron6111977_5minutes.php" );
}
if ( $Minute == 0 && $Hour == 0 ) {
	include_once( __DIR__ . "/cron6111977_24hours.php" );
}

$SMS = new SMS();
$SMS->proceed_queue( [ "orderby" => "RAND()" ] );

if ( $db->get_option( "process_key" ) == "" ) {
	$pk = \Str::generate_api();
	$db->set_option( "process_key", $pk );
	App::process_key( "pk", $pk );
}

$pt = (int) $db->get_option( "process_time" );
if ( ( time() - $pt ) >= 86400 ) {
	if ( isset( $_SERVER["SERVER_ADDR"] ) ) {
		$db->set_option( "server_ip", $_SERVER["SERVER_ADDR"] );
	} else if ( isset( $_SERVER["LOCAL_ADDR"] ) ) {
		$db->set_option( "server_ip", $_SERVER["LOCAL_ADDR"] );
	} else {
		$si = @getenv( 'SERVER_ADDR' );
		if ( ! empty( $si ) ) {
			$db->set_option( "server_ip", $si );
		} else {
			$db->set_option( "server_ip", $_SERVER['HTTP_HOST'] );
		}
	}
	$pk = \Str::generate_api();
	$db->set_option( "process_key", $pk );
	App::process_key( "pk", $pk );
}
