<?php
if ( ! defined( 'ROOT_PATH' ) ) {
	die( 'Direct file access is not allowed!' );
	exit;
}

$Fine = new Fine;
$Fine->generate_fine();
set_time_limit( 0 );

# Regenerating DB views
\DB\Views::all_views();
$_Content = trim( $_Content );
$Lines    = explode( ";", $_Content );
foreach ( $Lines as $line ) {
	if ( ! empty( $line ) ) {
		$db->query( $line );
	}
}

## Generating Monthly Fee
$days_before = (integer) $db->get_option( 'fee_schedule_days_before' );
if ( \Dates::days_difference( date( '01-M-Y', strtotime( '+1 month' ) ) ) <= $days_before ) {
	//send_mail( 'shakeel@shakeel.pk', 'Generating Invoices', 'Generating invoices for this server.');
	\Fee\Invoice::generate_monthy_fee();
}

## Running this script to create payables if due date arrirved.
$Fee         = new Fee;
$before_days = $db->get_option( "fee_schedule_days_before", "0" );
$_slabs      = $Fee->get_payable_slabs( "0", $before_days );
#show_array($_slabs); die;
if ( is_array( $_slabs ) && sizeof( $_slabs ) > 0 ) {
	$Student = new Student;
	foreach ( $_slabs as $_slab ) {
		#$Q = "UPDATE `batch_classes_x_tution_fee` SET `payable_done`=1 WHERE `class_id`='".$_slab["class_id"]." AND `from_date`='".$_slab["from_date"]."' AND `fee_amount`='".$_slab["fee_amount"]."' AND `to_date`='".$_slab["to_date"]."' AND `added_by`='".$_slab["added_by"]."' AND `added_time`='".$_slab["added_time"]."'";
		#echo $Q; die;
		$response = $db->update( "batch_classes_x_tution_fee", [ "payable_done" => 1 ], [
			"class_id"   => $_slab["class_id"],
			"from_date"  => $_slab["from_date"],
			"fee_amount" => $_slab["fee_amount"],
			"to_date"    => $_slab["to_date"],
			"added_by"   => $_slab["added_by"],
			"added_time" => $_slab["added_time"],
		] );

		$_students = $Student->get_students( "class_id=" . $_slab["class_id"] );
		foreach ( $_students as $_student ) {
			// Only Tution Fee slab will get Student's fee.
			if ( $_slab["type"] == "Tution Fee" ) {
				$amount = $Student->get_student_fee( $_student["id"] );
				if ( $amount == 0 || empty( $amount ) ) {
					$amount = $_slab["fee_amount"];
				}
			} else {
				$amount = $_slab["fee_amount"];
			}
			$_data    = [
				"student_id"        => $_student["id"],
				"fee_type"          => "Scheduled",
				"amount"            => $amount,
				"description"       => "Payable created by system at " . \Dates::my_datetime(),
				"added_by"          => 0,
				"added_time"        => \Dates::mysql_datetime(),
				"added_ip"          => \General::myip(),
				"fee_title"         => $_slab["slab_name"],
				"paid"              => 0,
				"due_date"          => $_slab["due_date"],
				"last_payment_date" => $_slab["last_payment"],
				"fee_slab_id"       => $_slab["id"],
			];
			$response = $db->insert( "fee_paid", $_data );
		}
	}
}


$db->query( "ALTER TABLE `" . \MySQL\Tables::table_name( 'translations' ) . "` CONVERT TO CHARACTER SET utf8 COLLATE utf8_unicode_ci" );
$db->query( "ALTER TABLE `" . \MySQL\Tables::table_name( 'langs' ) . "` CONVERT TO CHARACTER SET utf8 COLLATE utf8_unicode_ci" );
## Removing empty strings from translation tables.
$db->delete( \MySQL\Tables::table_name( 'translations' ), [ "msgstr" => "" ] );

## Add languages in database.
foreach ( $Translation->Langs as $key => $lang ) {
	if ( $db->get_var( "SELECT COUNT(1) FROM `" . \MySQL\Tables::table_name( $Translation->TableLangs ) . "` WHERE `code`='$key'" ) == "0" ) {
		$data = [
			"code"    => $key,
			"name"    => $lang,
			"default" => "0",
		];
		if ( $key == "en" ) {
			$data["default"] = 1;
		}
		$db->insert( \MySQL\Tables::table_name( $Translation->TableLangs ), $data );
	}
}


$Q = "DELETE FROM `" . \MySQL\Tables::table_name( 'students' ) . "` WHERE `id` IS NULL OR `id`='' OR `id`=0";
$db->query( $Q );

$Q = "UPDATE `" . \MySQL\Tables::table_name( 'students' ) . "` SET `deleted`='0' WHERE `deleted` IS NULL";
$db->query( $Q );

$db->drop_table( "student_assignments", true );

$active_batch = $BatchClass->get_active_batch();
$Q            = "UPDATE `" . \MySQL\Tables::table_name( 'batch_classes' ) . "` SET `batch_id`='{$active_batch['id']}' WHERE `batch_id`='0'";
$db->query( $Q );

$Q = "UPDATE `" . \MySQL\Tables::table_name( 'admins' ) . "` SET `active`='1' WHERE `active` IS NULL";
$db->query( $Q );

$Q = "DELETE FROM `" . \MySQL\Tables::table_name( 'subjects' ) . "` WHERE `subject_id` IS NULL OR `subject_id`='0'";
$db->query( $Q );

$Q = "SELECT COUNT(*) FROM `" . \MySQL\Tables::table_name( Batch::Table ) . "` WHERE `active`='1'";
if ( $db->get_var( $Q ) == 0 ) {
	$Q = "UPDATE `" . \MySQL\Tables::table_name( Batch::Table ) . "` SET `active`='1' ORDER BY `id` DESC LIMIT 1";
	$db->query( $Q );
}

$batchid = (int) $Batch->get_active_batch_id();
if ( ! empty( $batchid ) ) {
	// check student batch id
	$Q = $db->prepare( "UPDATE `" . \MySQL\Tables::table_name( Student::Table ) . "` SET `batch_id`=%d WHERE `batch_id` IS NULL", $batchid );
	$db->query( $Q );

	// check mark_sheets batch id
	$Q = $db->prepare( "UPDATE `" . \MySQL\Tables::table_name( 'mark_sheets' ) . "` SET `batch_id`=%d WHERE `batch_id` IS NULL OR `batch_id`=0", $batchid );
	$db->query( $Q );

	// check mark_sheets_data batch id
	$Q = $db->prepare( "UPDATE `" . \MySQL\Tables::table_name( 'mark_sheets_data' ) . "` SET `batch_id`=%d WHERE `batch_id` IS NULL OR `batch_id`=0", $batchid );
	$db->query( $Q );
}

$Q = "UPDATE `" . \MySQL\Tables::table_name( Fee::Table ) . "` SET `paid`='0' WHERE `paid`='1' AND (`paid_by`=0 OR `paid_by` IS NULL)";
$db->query( $Q );


if ( is_dir( ASSETS_PATH . "plugins/jquery-file-upload" ) ) {
	\File::rrmdir( ASSETS_PATH . "plugins/jquery-file-upload" );
}

// Taking DB Backup.
include_once( LIBRARY_PATH . "classes/MySQLDump.php" );

use Ifsnop\Mysqldump as IMysqldump;

$filePath = DB_PATH . DBNAME . "--_--" . time() . ".sql.gz";

try {
	$dump = new IMysqldump\Mysqldump( 'mysql:host=' . DBSERVER . ';dbname=' . DBNAME, DBUSER, DBPASS );
	$dump->start( $filePath );
} catch ( \Exception $e ) {
	echo 'mysqldump-php error: ' . $e->getMessage();
}
