<?php
if ( ! \Admins\UserInfo::is_loggedin() ) {
	die( "You'r not authorized to view this report." );
	exit();
}

$_GET["to"] = isset( $_GET["to"] ) ? $_GET["to"] : '';
$_GET["class_id"] = isset( $_GET["class_id"] ) ? $_GET["class_id"] : 0;

$_data = isset( $_GET["_data"] ) ? $_GET["_data"] : '';
unset( $_GET["_data"] );
extract( $_GET );
set_time_limit( 0 );
$_title   = __( "PDF Title" );
$Headings = [ "test" => "Test" ];
$pdfpath  = "Report";

switch ( $_data ) {
	case "students";
		$Cols   = [
			"id",
			"student_info",
			"dates",
			"class_id",
			"",
		];
		$filter = "";
		if ( ! empty( $_GET["from"] ) ) {
			$filter .= "&admission_date=" . $_GET["from"] . "," . $_GET["to"];
		}
		if ( is_array( $_GET["class_id"] ) ) {
			$filter .= "&classes=" . implode( ",", $_GET["class_id"] );
		} elseif ( ! empty( $_GET["class_id"] ) && $_GET["class_id"] > 0 ) {
			$filter .= "&class_id=" . $_GET["class_id"];
		}
		$filter = urlencode( trim( $filter, "&" ) );

		$sorts   = explode( ",", $sorts );
		$orderby = $Cols[ $sorts[0] ];
		$order   = $sorts[1];

		$query = "orderby={$orderby}&order={$order}&search={$search}&filter={$filter}";
		if ( isset( $deleted ) ) {
			$deleted = (int) $deleted;
			$query   .= "&deleted={$deleted}";
		}
		if ( isset( $subjects ) && $subjects <> "" ) {
			if ( is_array( $subjects ) ) {
				$subjects = implode( ",", $subjects );
			}
			$query .= "&subjects={$subjects}";
		}
		//echo http_build_query_x($_GET);
		$rows = $Student->get_students( $query );
		if ( isset( $_GET["is_sms"] ) ) {
			$SMS     = new SMS;
			$success = 0;
			$failed  = 0;
			foreach ( $rows as $row ) {
				$response = $SMS->add_to_queue( $row["guardian_cell"], $sms_message );
				if ( ! $response ) {
					$failed ++;
				} else {
					$success ++;
				}
			}
			echo "OK" . $success;
			exit;
		}
		$Headings = [
			"id"       => [ "name" => "ID", "css" => "width:30px" ],
			"name"     => "Name",
			"class"    => "Class",
			"Subjects" => [ "name" => "Subjects", "css" => "width:290px" ],
		];
		$_title   = "Students List";
		$pdfpath  = "students_list";
		break;
	case "collect_fee":
		$Cols = [
			"student_id",
			"",
			"amount",
			"fine",
			"due_date",
			"last_payment_date",
			"",
		];
		$Fee  = new Fee;

		$filter = "&";
		if ( ! empty( $from ) ) {
			$filter .= "due_date={$from},{$to}&";
		}
		if ( ! empty( $class_name ) ) {
			$filter .= "class_name={$class_name}&";
		}
		$filter = urlencode( trim( $filter, "&" ) );

		$sorts   = explode( ",", $sorts );
		$orderby = $Cols[ $sorts[0] ];
		$order   = $sorts[1];

		$query    = "search={$search}&orderby={$orderby}&order={$order}&filter={$filter}&page=1&pagesize=100";
		$rows     = $Fee->get_not_paid( "", $query );
		$Headings = [
			"student_name"       => [ "name" => "Student", "css" => "width:15%" ],
			"description"        => [ "name" => "Description", "css" => "width:45%" ],
			"amount"             => [ "name" => "Amount", "css" => "width:10%" ],
			"fine"               => [ "name" => "Fine", "css" => "width:6%;" ],
			"due_date2"          => [ "name" => "Due Date", "css" => "width:12%" ],
			"last_payment_date2" => [ "name" => "Last Date", "css" => "width:12%" ],
		];
		$_title   = __( "Collect Fee" );
		$pdfpath  = "collect_fee";
		break;
	case "fee_defaulters":
		$Cols = [
			"student_id",
			"",
			"amount",
			"fine",
			"due_date",
			"last_payment_date",
			"",
		];
		$Fee  = new Fee;

		$filter = "&";
		if ( ! empty( $from ) ) {
			$filter .= "due_date={$from},{$to}&";
		}
		if ( ! empty( $class_name ) ) {
			$filter .= "class_name={$class_name}&";
		}
		$filter = urlencode( trim( $filter, "&" ) );

		$sorts   = explode( ",", $sorts );
		$orderby = $Cols[ $sorts[0] ];
		$order   = $sorts[1];

		$query    = "search={$search}&orderby={$orderby}&order={$order}&filter={$filter}";
		$rows     = $Fee->get_fee_defaulters( $query );
		$Headings = [
			"student_name"       => [ "name" => "Student", "css" => "width:15%" ],
			"description"        => [ "name" => "Description", "css" => "width:45%" ],
			"amount"             => [ "name" => "Amount", "css" => "width:10%" ],
			"fine"               => [ "name" => "Fine", "css" => "width:6%;" ],
			"due_date2"          => [ "name" => "Due Date", "css" => "width:12%" ],
			"last_payment_date2" => [ "name" => "Last Date", "css" => "width:12%" ],
		];
		$_title   = "Fee Defaulters";
		$pdfpath  = "fee_defaulters";
		break;
	case "paid_fee":
		$Cols = [
			"id",
			"fee_title",
			"amount",
			"fine",
			"due_date",
			"last_payment_date",
			"fee_date",
			"receipt_number",
		];
		$Fee  = new Fee;

		$filter = "&";
		if ( ! empty( $from ) ) {
			$filter .= "due_date={$from},{$to}&";
		}
		if ( ! empty( $class_name ) ) {
			$filter .= "class_name={$class_name}&";
		}
		$filter = urlencode( trim( $filter, "&" ) );

		$sorts   = explode( ",", $sorts );
		$orderby = $Cols[ $sorts[0] ];
		$order   = $sorts[1];

		$query    = "search={$search}&orderby={$orderby}&order={$order}&paid=1&filter={$filter}";
		$rows     = $Fee->get_not_paid( "", $query );
		$Headings = [
			"student_name"       => [ "name" => "Student", "css" => "width:15%" ],
			"description"        => [ "name" => "Description", "css" => "width:45%" ],
			"amount"             => [ "name" => "Amount", "css" => "width:10%" ],
			"fine"               => [ "name" => "Fine", "css" => "width:6%;" ],
			"due_date2"          => [ "name" => "Due Date", "css" => "width:12%" ],
			"last_payment_date2" => [ "name" => "Last Date", "css" => "width:12%" ],
		];
		$_title   = __( "Fee Paid" );
		$pdfpath  = "fee_paid";
		break;
	default:
		header( 'Status: 403 Forbidden' );
		header( 'HTTP/1.1 403 Forbidden' );
		exit();
}
$HTML = '
<h3 style="text-align:center">' . $_title . '</h3>
<table cellspacing="0" cellpadding="4" id="table1" style="border: 1px solid #AAAAAA; border-spacing: 0; border-collapse: separate; margin:0 auto;">
<tr>';
foreach ( $Headings as $key => $head ) {
	if ( is_array( $head ) ) {
		$head["name"] = isset($head["name"])?$head["name"]:'';
		$head["css"] = isset($head["css"])?$head["css"]:'';
		$name = $head["name"];
		$css  = $head["css"];
	} else {
		$name = $head;
		$css  = "";
	}
	$HTML .= '<td style="border: 1px solid #AAAAAA;padding:5px;font-weight:bold;' . $css . '">' . $name . '</td>';
}
$HTML .= '</tr>';

foreach ( $rows as $row ) {
	$HTML .= '<tr>';
	foreach ( $Headings as $key => $head ) {
		if ( is_array( $row[ $key ] ) ) {
			$str = implode( ", ", $row[ $key ] );
		} else {
			$str = $row[ $key ];
		}
		$HTML .= '<td style="border: 1px solid #AAAAAA;padding:5px;font-size:10px">' . $str . '</td>';
	}
	$HTML .= '</tr>';
}
$HTML .= "</table>";
include_once( __DIR__ . "/pdf.php" );