<?php
if ( ! \Admins\UserInfo::is_loggedin() ) {
	die( "You'r not authorized to view this report." );
}

$_GET["order"] = isset( $_GET["order"] ) ? $_GET["order"] : '0';

if ( ! isset( $_GET["class_id"] ) ) {
	Urls::redirect( Urls::get_url( "weekly_evaluation_report" ) );
}

$class_id = (int) $_GET["class_id"];

$_GET["from"]  = isset( $_GET["from"] ) ? $_GET["from"] : '';
$_GET["to"]    = isset( $_GET["to"] ) ? $_GET["to"] : '';
$_GET["order"] = isset( $_GET["order"] ) ? $_GET["order"] : '';

if ( ! \Dates::is_date( $_GET["from"] ) ) {
	$from = \Dates::mysql_date();
} else {
	$from = \Dates::mysql_date( $_GET["from"] );
}
if ( ! \Dates::is_date( $_GET["to"] ) ) {
	$to = \Dates::mysql_date();
} else {
	$to = \Dates::mysql_date( $_GET["to"] );
}
$dec     = App::get_marks_decimals();
$b       = new BatchClass;
$Student = new Student;
$Subject = new Subject;

$subs  = $db->get_rows( "SELECT `id`,`name`,`subject`,`total_marks` FROM `test_schedules` ts, `mark_sheets` ms WHERE ms.schedule_id=ts.id AND ts.`class_id`='$class_id' AND (`test_date` BETWEEN '$from' AND '$to') ORDER BY `subject`" );
$Q     = "CREATE TEMPORARY TABLE `tmp_weekly_report`
(`name` VARCHAR(200), `total` DECIMAL(6,2), `total_marks` DECIMAL(6,2), `percentage` DECIMAL(6,2)
";
$_subs = array();
foreach ( $subs as $sub ) {
	//$Q .= ", `".$sub["subject"]."` decimal(6,2)";
	$_subs[] = $sub["subject"];
}

$_subs = array_unique( $_subs );
foreach ( $_subs as $sub ) {
	$Q .= ", `" . $sub . "` decimal(6,2)";
}
$Q        .= ")";
$response = $db->query( $Q );
if ( $response === false ) {
	die( "Error: " . $db->last_error );
}

$totals = array();
foreach ( $subs as $sub ) {
	#$subjects[] = $sub["subject"];
	if ( isset( $totals[ $sub["subject"] ] ) ) {
		$totals[ $sub["subject"] ]["total"] += $sub["total_marks"];
		$totals[ $sub["subject"] ]["count"] ++;
	} else {
		$totals[ $sub["subject"] ]["total"] = $sub["total_marks"];
		$totals[ $sub["subject"] ]["count"] = 1;
	}
	$totals[ $sub["subject"] ]["schedule_ids"][] = $sub["id"];
}
$Q = "class_id=$class_id&orderby=id&order=ASC";
//if ( isset($_GET["orderby"]) && $_GET["orderby"]=="name" ) $Q .= "&orderby=name&order=" . $_GET["order"];
$Students = $Student->get_students( $Q );
$Cols     = sizeof( $totals ) + 4;
$subjects[0] = isset($subjects[0])?$subjects[0]:'';
$start_date = $db->get_var( "SELECT `start_date` FROM `test_schedules` WHERE `class_id`=$class_id AND `subject`='" . $db->set_string( $subjects[0] ) . "'" );
if ( $start_date == "0000-00-00" || empty( $start_date ) ) {
	$week = "-";
} else {
	$week = \Dates::get_week_number( $start_date );
}

$C          = new BatchClass;
$class_name = $C->get_class_name( $class_id );

if ( $Cols % 2 == 0 ) {
	$half1 = $half2 = $Cols / 2;
} else {
	$half1 = intval( $Cols / 2 );
	$half2 = $Cols - $half1;
}

if ( isset( $_GET["smsBtn"] ) ) {
	$SMS = new SMS;
	$x   = 0;
	foreach ( $Students as $student ) {
		$HTML        = "";
		$HTML        .= "Dear " . $student["guardian_name"] . ", Result of " . $student["name"] . " for {$_GET["from"]} to {$_GET["to"]} is as under\n";
		$total       = 0;
		$count       = 0;
		$total_marks = 0;
		foreach ( $totals as $sub => $schedule ) {
			$S    = implode( " OR `schedule_id`=", $schedule["schedule_ids"] );
			$Q    = "SELECT msd.`marks`,msd.`attendance`,ts.test_date FROM `mark_sheets_data` msd, `test_schedules` ts WHERE (`schedule_id`=$S) AND `student_id`={$student["id"]} AND msd.schedule_id=ts.id";
			$rows = $db->get_rows( $Q );
			if ( sizeof( $rows ) > 0 ) {
				$sn    = $Subject->get_shortname( $sub );
				$HTML  .= "{$sn} ";
				$marks = 0;
				if ( $rows[0]["attendance"] == 0 ) {
					$HTML .= "A/";
				} else {
					foreach ( $rows as $row ) {
						//if ($row["attendance"]=="1")
						$marks += $row["marks"];
					}
					$HTML .= "{$marks}/";
				}
				$total       += $marks;
				$total_marks += $schedule["total"];
				$HTML        .= round( $schedule["total"], App::get_marks_decimals() ) . "\n";
			}
		}
		$SMS->add_to_queue( $student["guardian_cell"], $HTML );
		$x ++;
		#$data1["total"] = round($total,$dec);
		#$data1["total_marks"] = $total_marks;
		#$data1["percentage"] = $total>0?round($total / $total_marks * 100,$dec):0;
		#$response = $db->insert("tmp_weekly_report",$data1);
		#if ($response===false) die("Error: ".mysqli_error());
	}

	echo $x . " SMS Queued. <a target='_parent' href='" . Urls::get_url( "sms/queue" ) . "'>See Details</a>";
	exit;
}

$HTML = '
<h3 style="text-align:center">'.__('Weekly Evaluation Report') . '</h3>
<h4 style="text-align:center">'.__('Week').': ' . $week . '</h4>
<table cellspacing="0" cellpadding="4" id="table1" style="border: 1px solid #AAAAAA; border-spacing: 0; border-collapse: separate; margin:0 auto;">
    <tr>
        <td>'.__('Class').': ' . $class_name . '</td>
        <td style="text-align:right">' . $_GET["from"] . ' - to ' . $_GET["to"] . '</td>
    </tr>
</table>
<br><br>
<table cellspacing="0" cellpadding="4" id="table1" style="border: 1px solid #AAAAAA; border-spacing: 0; border-collapse: separate; margin:0 auto;">
    <tr style="font-size:10px">
        <td style="border: 1px solid #AAAAAA;padding:5px;width:25px">Sr.</td>
        <td style="border: 1px solid #AAAAAA;padding:5px;width:140px">Student Name</td>';
foreach ( $totals as $sub => $data ) {
	$sn   = $Subject->get_shortname( $sub );
	$S    = empty( $sn ) ? substr( $sub, 0, 4 ) : $sn;
	$HTML .= '<td style="border: 1px solid #AAAAAA;padding:5px;text-align:center;width:35px;font-size:9px">' . $S . '</td>';
}
$HTML .= '<td style="border: 1px solid #AAAAAA;padding:5px;text-align:center;width:40px">Total</td>';
$HTML .= '<td style="border: 1px solid #AAAAAA;padding:5px;">%</td>
    </tr>';

$HTML .= '<tr style="font-size:10px">
        <td style="border: 1px solid #AAAAAA;padding:5px">&nbsp;</td>
        <td style="border: 1px solid #AAAAAA;padding:5px">&nbsp;</td>';
foreach ( $totals as $sub => $data ) {
	$sub        = $db->set_string( $sub );
	$teacher    = $db->get_var( "SELECT `teacher` FROM `test_schedules` WHERE `class_id`=$class_id AND `subject`='$sub'" );
	$short_name = $db->get_var( "SELECT `short_name` FROM `teachers` WHERE `name`='" . $db->set_string( $teacher ) . "'" );
	if ( ! empty( $short_name ) ) {
		$teacher = $short_name;
	} else {
		$teacher = substr( $teacher, 0, 4 );
	}
	$HTML .= '<td style="border: 1px solid #AAAAAA;padding:5px;text-align:center;width:35px;font-size:9px">' . $teacher . '</td>';
}
$HTML .= '<td style="border: 1px solid #AAAAAA;padding:5px;text-align:center;">&nbsp;</td>';
$HTML .= '<td style="border: 1px solid #AAAAAA;padding:5px;">&nbsp;</td>
    </tr>';

$HTML      .= '<tr style="font-size:10px">
        <td style="border: 1px solid #AAAAAA;padding:5px;">&nbsp;</td>
        <td style="border: 1px solid #AAAAAA;padding:5px">&nbsp;</td>';
$total     = 0;
$schedules = array();
foreach ( $totals as $sub => $data ) {
	$sub   = $db->set_string( $sub );
	$total += $data["total"];
	$HTML  .= '<td style="text-align:center;border: 1px solid #AAAAAA;padding:5px">' . round( $data["total"], $dec ) . '</td>';
}
#show_array($schedules);
//round($total,$dec)
$HTML .= '<td style="text-align:center;border: 1px solid #AAAAAA;padding:5px">&nbsp;</td>
    <td style="border: 1px solid #AAAAAA;padding:5px">&nbsp;</td></tr>';

$x = 1;
foreach ( $Students as $student ) {
	$data1["name"] = $student["name"];
	$total         = 0;
	$count         = 0;
	$total_marks   = 0;
	foreach ( $totals as $sub => $schedule ) {
		$S    = implode( " OR `schedule_id`=", $schedule["schedule_ids"] );
		$Q    = "SELECT msd.`marks`,msd.`attendance`,ts.test_date FROM `mark_sheets_data` msd, `test_schedules` ts WHERE (`schedule_id`=$S) AND `student_id`={$student["id"]} AND msd.schedule_id=ts.id";
		$rows = $db->get_rows( $Q );
		#show_array($rows);
		#echo $Q . "<br />";
		#echo $student["name"]." - ".$sub;
		#
		if ( sizeof( $rows ) > 0 ) {
			$marks = 0;
			/*if ($rows[0]["attendance"]==0) {
				// $data1[$sub] = "-2";
				// It is absent.
				$data1[$sub] = "0";
			} else {*/
			foreach ( $rows as $row ) {
				//if ($row["attendance"]=="1")
				$marks += $row["marks"];
			}
			$data1[ $sub ] = $marks;
			//}
			$total       += $marks;
			$total_marks += $schedule["total"];
		} else {
			$data1[ $sub ] = "-1";
		}
	}
	$data1["total"]       = round( $total, $dec );
	$data1["total_marks"] = $total_marks;
	$data1["percentage"]  = $total > 0 ? round( $total / $total_marks * 100, $dec ) : 0;
	$response             = $db->insert( "tmp_weekly_report", $data1 );
	if ($response===false) {
		die("Error: ".$db->last_error);
	}
}
$Q = "SELECT * FROM `tmp_weekly_report`";
if ( ! empty( $_GET["orderby"] ) ) {
	$Q .= " ORDER BY `" . $_GET["orderby"] . "` " . $_GET["order"];
}
$rows = $db->get_rows( $Q );

$x = 1;
foreach ( $rows as $row ) {
	$HTML .= '<tr style="font-size:10px">
            <td style="border: 1px solid #AAAAAA;padding:5px;text-align:right">' . $x . '</td>';
	$HTML .= '<td style="border: 1px solid #AAAAAA;padding:5px">' . $row["name"] . '</td>';
	foreach ( $row as $key => $val ) {
		if ( isset( $_GET["downBtn2"] ) ) {
			if ( ! ( $key == "name" || $key == "total" || $key == "total_marks" || $key == "percentage" ) ) {
				if ( $val == "-1" ) {
					$HTML .= '<td style="text-align:center;border: 1px solid #AAAAAA;padding:5px">-</td>';
				} elseif ( $val == "-2" ) {
					$HTML .= '<td style="text-align:center;border: 1px solid #AAAAAA;padding:5px;background-color:#EEEE70">A</td>';
				} else {
					$HTML .= '<td style="text-align:center;border: 1px solid #AAAAAA;padding:5px"></td>';
				}
			}
		} else {
			if ( ! ( $key == "name" || $key == "total" || $key == "total_marks" || $key == "percentage" ) ) {
				if ( $val == "-1" ) {
					$HTML .= '<td style="text-align:center;border: 1px solid #AAAAAA;padding:5px">-</td>';
				} elseif ( $val == "-2" ) {
					$HTML .= '<td style="text-align:center;border: 1px solid #AAAAAA;padding:5px;background-color:#EEEE70">A</td>';
				} else {
					$HTML .= '<td style="text-align:center;border: 1px solid #AAAAAA;padding:5px">' . round( $val, $dec ) . '</td>';
				}
			}
		}
	}

	if ( isset( $_GET["downBtn2"] ) ) {
		$HTML .= '<td style="text-align:center;border: 1px solid #AAAAAA;padding:5px"></td>';
		$HTML .= '<td style="border: 1px solid #AAAAAA;padding:5px;text-align:right">%</td>';
	} else {
		$HTML .= '<td style="text-align:center;border: 1px solid #AAAAAA;padding:5px">' . round( $row["total"], $dec ) . '</td>';
		$HTML .= '<td style="border: 1px solid #AAAAAA;padding:5px">' . round( $row["percentage"], $dec ) . '%</td>';
	}

	$HTML .= '</tr>';
	$x ++;
}
/*foreach($Students as $student) {
	$HTML .= '<tr style="font-size:10px">
		<td style="border: 1px solid #AAAAAA;padding:5px;text-align:right">'.$x.'</td>
		<td style="border: 1px solid #AAAAAA;padding:5px">'.$student["name"].'</td>';
		$total = 0; $count=0; $total_marks = 0;
		foreach($totals as $sub=>$schedule) {
			$S = implode(" OR `schedule_id`=",$schedule["schedule_ids"]);
			$Q = "SELECT `marks` FROM `mark_sheets_data` WHERE (`schedule_id`=$S) AND `student_id`={$student["id"]}";
			$rows = $db->get_rows($Q);
			if (sizeof($rows)>0) {
				$marks=0;
				foreach($rows as $row) {
					$marks += $row["marks"];
				}
				$total += $marks;
				$total_marks += $schedule["total"];
				$HTML .= '<td style="text-align:center;border: 1px solid #AAAAAA;padding:5px">'. round($marks,$dec) .'</td>';
			} else {
				$HTML .= '<td style="text-align:center;border: 1px solid #AAAAAA;padding:5px">x</td>';
			}
		}
		$HTML .= '<td style="text-align:center;border: 1px solid #AAAAAA;padding:5px">'.round($total,$dec).'</td>';
		$per = $total>0?$total / $total_marks * 100:0;
		$HTML .= '<td style="text-align:left;border: 1px solid #AAAAAA;padding:5px;">'.round($per,$dec).'%</td></tr>';
	$x++;
}*/

for ( $y = 0; $y < 5; $y ++ ) {
	$HTML .= '<tr>';
	for ( $x = 0; $x < $Cols; $x ++ ) {
		$HTML .= '<td style="border: 1px solid #AAAAAA;padding:5px;text-align:right">&nbsp;</td>';
	}
	$HTML .= '</tr>';
}

$HTML .= '</table>';

if ( isset( $_GET["viewBtn"] ) ) {
	echo "
<style>
body {
    font-family:Verdana;
}
</style>
";
	echo $HTML;
} else {
	$pdfpath = "weekly_evaluation_report";
	include_once( __DIR__ . "/pdf.php" );
}