<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}

$_GET['iDisplayLength']  = isset( $_GET['iDisplayLength'] ) ? $_GET['iDisplayLength'] : 0;
$_GET['iDisplayStart']   = isset( $_GET['iDisplayStart'] ) ? $_GET['iDisplayStart'] : 0;
$_POST["id"]             = isset( $_POST["id"] ) ? $_POST["id"] : 0;
$_POST["description"]    = isset( $_POST["description"] ) ? $_POST["description"] : '';
$_POST["amount_out"]     = isset( $_POST["amount_out"] ) ? $_POST["amount_out"] : 0;
$_POST["date"]           = isset( $_POST["date"] ) ? $_POST["date"] : '';
$_POST["receipt_number"] = isset( $_POST["receipt_number"] ) ? $_POST["receipt_number"] : '';
$_POST["head"]           = isset( $_POST["head"] ) ? $_POST["head"] : '';

if ( ! \Admins\UserInfo::is_allowed( "manage_daily_expenses" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$A = new Accounts;
if ( isset( $_GET["edit"] ) ) {
	if ( ! \Admins\UserInfo::is_allowed( "delete_edit_daily_expenses" ) ) {
		echo "You'r not allowed to perform this action";
	}
	$data = $A->get_transaction( $_POST["id"] );
	if ( is_array( $data ) ) {
		$data["date"] = App::date_show( $data["date"] );
		header( 'Content-Type: application/json' );
		echo json_encode( $data );
	} else {
		echo "Can't get data1";
	}
	exit;
}
if ( isset( $_GET["delete"] ) ) {
	if ( ! \Admins\UserInfo::is_allowed( "delete_edit_daily_expenses" ) ) {
		echo "You'r not allowed to perform this action";
	}
	echo $A->delete( $_POST["id"] );
	exit;
}
if ( isset( $_GET["save"] ) ) {
	if ( $_POST["id"] == 0 ) {
		$Q = "description=" . $_POST["description"];
		$Q .= "&amount_out=" . $_POST["amount_out"];
		$Q .= "&date=" . $_POST["date"];
		$Q .= "&receipt_number=" . $_POST["receipt_number"];
		$Q .= "&daily_expense=1";
		$Q .= "&head=" . $_POST["head"];
		echo $A->add_entry( $Q );
	} else {
		echo $A->save_entry( $_POST["id"], $_POST );
	}
	exit;
}
if ( isset( $_GET["getList"] ) ) {
	extract( $_GET );
	$Cols       = array(
		"id",
		"date",
		"head",
		"description",
		"amount_out",
		"",
	);
	$iSortCol_0 = empty( $iSortCol_0 ) ? "0" : $iSortCol_0;
	$orderby    = $Cols[ $iSortCol_0 ];
	$sSortDir_0 = empty( $sSortDir_0 ) ? "DESC" : $sSortDir_0;
	$order      = $sSortDir_0;

	$iDisplayLength = intval( $_GET['iDisplayLength'] );
	$iDisplayStart  = intval( $_GET['iDisplayStart'] );
	if ( $iDisplayLength == 0 ) {
		$page = 1;
	} else {
		$page = ( $iDisplayStart / $iDisplayLength ) + 1;
	}

	$query = "page={$page}&pagesize={$iDisplayLength}&orderby={$orderby}&order={$order}&search={$sSearch}&daily_expense=1";
	if ( isset( $student_id ) ) {
		$query .= "&student_id=$student_id";
	}
	$rows              = $A->transactions_list( $query );
	$records["aaData"] = array();
	$disabled          = ( \Admins\UserInfo::is_allowed( "delete_edit_daily_expenses" ) ) ? "" : "disabled=disabled";
	foreach ( $rows["rows"] as $row ) {
		$btn                 = "
			<div class='btn-group'>
			<button title=\"Delete this entry\" onclick=\"Delete({$row["id"]},this)\" class=\"tooltips btn red btn-xs\" $disabled><i class=\"fa fa-trash-o\"></i></button>
            <button title=\"Edit this entry\" onclick=\"Edit({$row["id"]},this)\" class=\"tooltips btn blue btn-xs\" $disabled><i class=\"fa fa-edit\"></i></button></div>";
		$records["aaData"][] = array(
			$row["id"],
			\App::date_show( $row["date"] ),
			$row["head"],
			$row["description"],
			$row["amount_out"],
			$btn,
		);
	}

	$records["sEcho"]                = empty( $sEcho ) ? 1 : $sEcho;
	$records["iTotalRecords"]        = $rows["total_records"];
	$records["iTotalDisplayRecords"] = $rows["total_records"];

	echo json_encode( $records );
	exit;
}

$title = __( "Daily Expenses" );
include_once( __DIR__ . "/header.php" );
include_once( LIBRARY_PATH . "templates/panel/accounts_daily_expenses.tpl" );
?>

<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="modal fade" id="expense" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
				<form name="expenseForm" id="expenseForm" onsubmit="return Save(this)">
					<input type="hidden" name="id" id="id" value="0">
					<div class="modal-dialog">
						<div class="modal-content">
							<div class="modal-header">
								<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
								<h4 id="modal-title" class="modal-title">Title</h4>
							</div>
							<div class="modal-body">
								<table class="table">
									<tr>
										<td><?php _e( 'Account Head' ) ?>:</td>
										<td>
											<select class="form-control select2" id="head" name="head">
												<option>General</option>
												<?php $As = $A->get_account_heads( "orderby=head&order=asc&pagesize=500" );
												foreach ( $As["rows"] as $acc ): ?>
													<option><?php echo $acc["head"] ?></option>
												<?php endforeach; ?>
											</select>
										</td>
									</tr>
									<tr>
										<td><?php _e( "Expense Detail" ) ?></td>
										<td>
											<input required="required" type="text" class="form-control" id="description" name="description" placeholder="<?php _e( "Expense Detail" ) ?>">
										</td>
									</tr>
									<tr>
										<td><?php _e( 'Amount' ) ?>:</td>
										<td>
											<input required="required" step="0.01" type="number" class="form-control" id="amount_out" name="amount_out" placeholder="<?php _e( 'Amount' ) ?>">
										</td>
									</tr>
									<tr>
										<td><?php _e( "Expense Date" ) ?></td>
										<td>
											<input value="<?php echo App::date_show() ?>" required="required" type="text" placeholder="<?php _e( "Expense Date" ) ?>"
											       class="form-control date-picker" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>" id="date" name="date">
										</td>
									</tr>
									<tr>
										<td><?php _e( "Receipt Number (If any)" ) ?></td>
										<td>
											<input type="text" class="form-control" id="receipt_number" name="receipt_number" placeholder="<?php _e( "Receipt Number (If any)" ) ?>">
										</td>
									</tr>
								</table>
							</div>
							<div class="modal-footer">
								<div class="btn-group">
									<button type="button" class="btn default" data-dismiss="modal">Close</button>
									<button type="submit" class="btn btn-primary">Save</button>
								</div>
							</div>
						</div>
					</div>
				</form>
			</div>
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __( "Accounts" ) ?>
						<small><?php echo __( "Manage Daily Expenses" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button onclick="OpenForm()" class="btn btn-primary">
								<i class="fa fa-plus"></i> <?php echo __( "Add Expense" ) ?>
							</button>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#"><?php echo __( "Accounts" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="accounts_daily_expenses.php">
								<?php echo __( "Daily Expenses" ) ?>
							</a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<table class="table table-striped table-bordered table-hover" id="sample_11">
						<thead>
						<tr class="heading">
							<th title="Transaction ID"><?php echo __( "ID" ) ?></th>
							<th><?php echo __( "Date" ) ?></th>
							<th><?php echo __( "Head" ) ?></th>
							<th><?php echo __( "Description" ) ?></th>
							<th><?php echo __( "Amount" ) ?></th>
							<th>&nbsp;</th>
						</tr>
						</thead>
						<tbody id="tbody1">
						</tbody>
					</table>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script src="<?php echo ASSETS_URL ?>script_js/accounts_daily_expenses.js?<?php echo md5_file( ASSETS_PATH . "script_js/accounts_daily_expenses.js" ) ?>"></script>

<script type="text/javascript">
	var TableAjax = function() {

		return {

			//main function to initiate the module
			init: function() {
				if ( !jQuery().dataTable ) {
					return;
				}

				// begin first table
				var $dataTable = $( '#sample_11' ).dataTable( {
					"sDom": "<'row'<'col-md-6 col-sm-12'l><'col-md-6 col-sm-12'f>r>t<'row'<'col-md-5 col-sm-12'i><'col-md-7 col-sm-12'p>>", //default layout without horizontal scroll(remove this setting to enable horizontal scroll for the table)
					"aLengthMenu": [
						[ 10, 20, 40, 60, 100 ],
						[ 10, 20, 40, 60, 100 ] // change per page values here
					],
					"bProcessing": true,
					"bServerSide": true,
					"sAjaxSource": "<?php echo Urls::get_url( "accounts/daily_expenses", 0, "getList&" . http_build_query( $_GET ) ) ?>",
					// set the initial value
					"iDisplayLength": 10,
					//                "sPaginationType": "bootstrap_full_number",
					"oLanguage": {
						"sProcessing": '<i class="fa fa-coffee"></i>&nbsp;<?php _e( "Please wait..." ) ?>',
						"sLengthMenu": "_MENU_ records",
						"oPaginate": {
							"sPrevious": "Prev",
							"sNext": "Next"
						}
					},
					"aoColumnDefs": [
						{
							"aTargets": [ 4 ],
							"sClass": "right"
						}
					],
					<?php if (isset( $_POST["q"] )): ?>
					"oSearch": { "sSearch": "<?php echo $_POST["q"] ?>" },
					<?php elseif (isset( $_GET["q"] )): ?>
					"oSearch": { "sSearch": "<?php echo $_GET["q"] ?>" },
					<?php endif; ?>
					"aoColumns": [
						{ "bSortable": true, "sClass": "right" },
						{ "bSortable": true },
						{ "bSortable": true },
						{ "bSortable": true },
						{ "bSortable": true },
						{ "bSortable": false, "sClass": "center" }
					],
					"aaSorting": [ [ 0, "desc" ] ]
				} );

				$( "#sample_11 tfoot input" ).on( 'keyup change', function() {
					table
						.column( $( this ).parent().index() + ':visible' )
						.search( this.value )
						.draw();
				} );

				jQuery( '#sample_11_wrapper .dataTables_filter input' ).addClass( "form-control input-medium" ); // modify table search input
				jQuery( '#sample_11_wrapper .dataTables_length select' ).addClass( "form-control input-small" ); // modify table per page dropdown

				// handle record edit/remove
				/*$('body').on('click', '#sample_11_wrapper .btn-editable', function() {
				 alert('Edit record with id:' + $(this).attr("data-id"));
				 });

				 $('body').on('click', '#sample_11_wrapper .btn-removable', function() {
				 alert('Remove record with id:' + $(this).attr("data-id"));
				 });*/
			}

		};

	}();
	TableAjax.init();

	function OpenForm() {
		$( "#expense" ).modal( "show" );
		document.expenseForm.reset();
		$( "#id" ).val( "0" );
		$( "#modal-title" ).html( "Add Expense" );
		$( "#head" ).focus();
	}

	function Save( form ) {
		Block();
		$.post( "<?php echo Urls::get_url( "accounts/daily_expenses", 0, "save" ) ?>", $( form ).serialize(), function( data ) {
			UnBlock();
			if ( data.substr( 0, 2 )=="OK" ) {
				var $dataTable = $( '#sample_11' ).dataTable();
				$dataTable.fnDraw();
				$( "#expense" ).modal( "hide" );
				Success( "Expense added successfully!" );
			} else {
				Error( data );
			}
		} );
		return false;
	}

	function Delete( id ) {
		bootbox.confirm( "Are you sure you want to delete this entry?", function( result ) {
			if ( result==false ) {
				return;
			}
			Block();
			$.post( "<?php echo Urls::get_url( "accounts/daily_expenses", 0, "delete" ) ?>", { id: id }, function( data ) {
				UnBlock();
				if ( data=="OK" ) {
					var $dataTable = $( '#sample_11' ).dataTable();
					$dataTable.fnDraw();
					Success( "Entry deleted successfully!" );
				} else {
					Error( data );
				}
			} );
		} );
	}

	function Edit( id ) {
		Block();
		$.post( "<?php echo Urls::get_url( "accounts/daily_expenses", 0, "edit" ) ?>", { id: id }, function( data ) {
			UnBlock();
			/*if (is_json(data)) {
			 $("#id").val(data.id);
			 alert(data.id);
			 } else {
			 Error("Can't get data");
			 }*/
			$( "#id" ).val( data.id );
			$( "#description" ).val( data.description );
			$( "#amount_out" ).val( data.amount_out );
			$( "#head" ).val( data.head );
			$( "#date" ).val( data.date );
			$( "#receipt_number" ).val( data.receipt_number );
			$( "#modal-title" ).html( "Edit Expense" );
			$( "#expense" ).modal( "show" );
		} );
	}
</script>
</body>
<!-- END BODY -->
</html>