<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "manage_teacher_salary" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$T = new Teacher;

$title = "Teacher Salaries";
include_once( __DIR__ . "/header.php" );
$Ts = $T->get_teachers( "salary=0&active=1" );
?>

<div class="page-container" dir="<?php echo $Trans->is_rtl() ? "rtl" : "" ?>">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>

	<div class="page-content-wrapper">
		<div class="page-content">
			<?php if ( count( $Ts ) > 0 ): ?>
				<div class="note note-warning">
					<button type="button" class="close" data-dismiss="alert" aria-hidden="true"></button>
					<p>
						<?php
						$link = "<a href='teachers.php'>" . __( "Teachers Module" ) . "</a>";
						echo __( "%1 teachers need to set salaries - Visit %2", count( $Ts ), $link ); ?>
					</p>
				</div>
			<?php endif; ?>

			<div class="modal fade" id="deductionDiv" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
				<form name="deductionForm" id="deductionForm" onsubmit="return UpdateDed(this)">
					<input type="hidden" name="id" id="id3" value="0">
					<div class="modal-dialog">
						<div class="modal-content">
							<div class="modal-header">
								<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
								<h4 id="modal-title" class="modal-title"><?php _e( "Deduct Salary" ) ?></h4>
							</div>
							<div class="modal-body">
								<table class="table" dir="<?php echo $Trans->is_rtl()?'rtl':'' ?>">
									<tr>
										<td><?php _e("Deduction") ?>:</td>
										<td>
											<input type="number" step="0.01" class="form-control" value="0" name="deduction" id="deduction">
										</td>
									</tr>
									<tr>
										<td><?php _e("Description") ?>:</td>
										<td>
											<input type="text" step="0.01" class="form-control" name="deduction_desc" id="deduction_desc">
										</td>
									</tr>
								</table>
							</div>
							<div class="modal-footer">
								<div class="btn-group">
									<button type="submit" class="btn blue"><?php _e( "Set Reduction" ) ?></button>
									<button type="button" class="btn default" data-dismiss="modal"><?php _e( "Close" ) ?></button>
								</div>
							</div>
						</div>
					</div>
				</form>
			</div>
			<div class="modal fade" id="pay" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
				<form name="payForm" id="payForm" onsubmit="return PayNow(this)">
					<input type="hidden" name="id" id="id2" value="0" />
					<div class="modal-dialog">
						<div class="modal-content">
							<div class="modal-header">
								<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
								<h4 id="modal-title" class="modal-title"><?php _e( "Pay Salary" ) ?></h4>
							</div>
							<div class="modal-body">
								<?php _e( "Are you sure you want to pay salary now?" ) ?>
								<br><br>
								<?php _e( "This action is not reversable." ) ?>
							</div>
							<div class="modal-footer">
								<div class="btn-group">
									<button type="submit" class="btn blue"><?php _e("Pay Salary") ?></button>
									<button type="button" class="btn default" data-dismiss="modal"><?php _e("Close") ?></button>
								</div>
							</div>
						</div>
					</div>
				</form>
			</div>
			<div class="modal fade" id="salaries" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
				<form name="salariesForm" id="salariesForm" onsubmit="return Generate(this)">
					<div class="modal-dialog">
						<div class="modal-content">
							<div class="modal-header">
								<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
								<h4 id="modal-title" class="modal-title"><?php _e("Generate Teacher Salaries") ?></h4>
							</div>
							<div class="modal-body">
								<table class="table">
									<tr>
										<td><?php _e("Month") ?>:</td>
										<td>
											<select name="month" class="form-control">
												<?php for ( $x = 1; $x <= 12; $x ++ ): ?>
													<?php $S = $x == date( "m" ) ? "selected=selected" : "" ?>
													<option <?php echo $S ?> value="<?php echo $x ?>"><?php echo \Dates::month_name( $x, true ) ?></option>
												<?php endfor ?>
											</select>
										</td>
									</tr>
									<tr>
										<td><?php _e("Year") ?>:</td>
										<td>
											<select name="year" class="form-control">
												<?php for ( $x = 2014; $x <= Date( "Y" ) + 1; $x ++ ): ?>
													<?php $S = $x == date( "Y" ) ? "selected=selected" : "" ?>
													<option <?php echo $S ?> value="<?php echo $x ?>"><?php echo $x ?></option>
												<?php endfor ?>
											</select>
										</td>
									</tr>
								</table>
							</div>
							<div class="modal-footer">
								<div class="btn-group">
									<button type="submit" class="btn blue"><?php _e( "Generate Salaries" ) ?></button>
									<button type="button" class="btn default" data-dismiss="modal"><?php _e( "Close" ) ?></button>
								</div>
							</div>
						</div>
					</div>
				</form>
			</div>
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __( "Accounts" ) ?>
						<small><?php echo __( "Manage teachers salaries" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button href="javascript:;" onclick="OpenForm()" class="btn btn-primary">
								<i class="fa fa-plus"></i> <?php echo __( "Generate Salaries" ) ?>
							</button>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php echo __( "Accounts" ) ?>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="accounts_teacher_salary.php">
								<?php echo __( "Teachers Salaries" ) ?>
							</a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<table class="table table-striped table-bordered table-hover" id="sample_11">
						<thead>
						<tr>
							<th title="Salary ID"><?php echo __( "ID" ) ?></th>
							<th><?php echo __( "Salary Month" ) ?></th>
							<th><?php echo __( "Salary" ) ?></th>
							<th><?php echo __( "Deduction" ) ?></th>
							<th><?php echo __( "Teacher" ) ?></th>
							<th>&nbsp;</th>
						</tr>
						</thead>
						<tbody></tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="text/javascript">
	var param_list = "<?php echo http_build_query( $_GET ) ?>";
	var oSearch = "<?php if ( isset( $_POST["q"] ) ) {
		echo $_POST["q"];
	} else if ( isset( $_GET["q"] ) ) {
		echo $_GET["q"];
	} else {
		echo "";
	} ?>";

</script>
<script src="<?php echo ASSETS_URL ?>script_js/accounts_teacher_salary.js?<?php echo md5_file( ASSETS_PATH . "script_js/accounts_teacher_salary.js" ) ?>"></script>
</body>
<!-- END BODY -->
</html>