<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "view_account_transactions" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$title = __( "View Transactions" );
include_once( __DIR__ . "/header.php" ); ?>

<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>

	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __("Accounts") ?>
						<small><?php echo __("View account transactions") ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<!--li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
							<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="#">Action</a>
								</li>
								<li>
									<a href="#">Another action</a>
								</li>
								<li>
									<a href="#">Something else here</a>
								</li>
								<li class="divider">
								</li>
								<li>
									<a href="#">Separated link</a>
								</li>
							</ul>
						</li-->
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e("Home") ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php echo __("Accounts") ?>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "accounts/transactions" ) ?>">
								<?php echo __("View Transactions") ?>
							</a>
						</li>
					</ul>
				</div>
			</div>

			<div class="row">
				<div class="col-md-12">
					<table class="table table-striped table-bordered table-hover" id="sample_11">
						<thead>
						<tr>
							<th title="Transaction ID"><?php echo __("ID") ?></th>
							<th><?php echo __("Date") ?></th>
							<th><?php echo __("Description") ?></th>
							<th><?php echo __("Amount In") ?></th>
							<th><?php echo __("Amount Out") ?></th>
							<th>&nbsp;</th>
						</tr>
						</thead>
						<tbody>
						</tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script>
	var TableAjax = function() {
		return {
			//main function to initiate the module
			init: function() {

				if ( !jQuery().dataTable ) {
					return;
				}

				// begin first table
				var $dataTable = $( '#sample_11' ).dataTable( {
					"sDom": "<'row'<'col-md-6 col-sm-12'l><'col-md-6 col-sm-12'f>r>t<'row'<'col-md-5 col-sm-12'i><'col-md-7 col-sm-12'p>>", //default layout without horizontal scroll(remove this setting to enable horizontal scroll for the table)
					"aLengthMenu": [
						[ 10, 20, 40, 60, 100 ],
						[ 10, 20, 40, 60, 100 ] // change per page values here
					],
					"bProcessing": true,
					"bServerSide": true,
					"sAjaxSource": "ajax/accounts_transactions.php?get_list&<?php echo http_build_query( $_GET ); ?>",
					// set the initial value
					"iDisplayLength": 10,
					//                "sPaginationType": "bootstrap_full_number",
					"oLanguage": {
						"sProcessing": '<i class="fa fa-coffee"></i>&nbsp;<?php _e("Please wait...") ?>',
						"sLengthMenu": "_MENU_ records",
						"oPaginate": {
							"sPrevious": "Prev",
							"sNext": "Next"
						}
					},
					<?php if (isset( $_POST["q"] )): ?>
					"oSearch": { "sSearch": "<?php echo $_POST["q"] ?>" },
					<?php elseif (isset( $_GET["q"] )): ?>
					"oSearch": { "sSearch": "<?php echo $_GET["q"] ?>" },
					<?php endif; ?>
					"aoColumns": [
						{ "bSortable": true, "sClass": "right" },
						{ "bSortable": true },
						{ "bSortable": true },
						{ "bSortable": true, "sClass": "right" },
						{ "bSortable": true, "sClass": "right" },
						{ "bSortable": false, "sClass": "center" }
					],
					"aaSorting": [ [ 0, "desc" ] ]
				} );

				$( "#sample_11 tfoot input" ).on( 'keyup change', function() {
					table
						.column( $( this ).parent().index() + ':visible' )
						.search( this.value )
						.draw();
				} );

				jQuery( '#sample_11_wrapper .dataTables_filter input' ).addClass( "form-control input-medium" ); // modify table search input
				jQuery( '#sample_11_wrapper .dataTables_length select' ).addClass( "form-control input-small" ); // modify table per page dropdown

				// handle record edit/remove
				/*$('body').on('click', '#sample_11_wrapper .btn-editable', function() {
				 alert('Edit record with id:' + $(this).attr("data-id"));
				 });

				 $('body').on('click', '#sample_11_wrapper .btn-removable', function() {
				 alert('Remove record with id:' + $(this).attr("data-id"));
				 });*/
			},

			redraw: function(){
				var $dataTable = $( '#sample_11' ).dataTable().fnDraw();
			}

		};

	}();
	TableAjax.init();

	$(function(){
		$(document).on("click", ".del_btn", function( event ) {
			event.preventDefault();

			if (!confirm("<?php _e("Are you sure you want to delete this transaction?"); ?>")) {
				return false;
			}

			id = $(this).attr("data-id");

			$(this).closest("tr").remove();

			Block();
			$.post("ajax/accounts_transactions.php?delete", {id:id}, function( data ) {
				UnBlock();
				if (data=="OK") {
					TableAjax.redraw();
				} else {
					Error(data);
				}
			})
		});
	});
</script>
</body>
</html>