<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "manage_teachers" ) ) {
	include_once (__DIR__."/no_access.php");
}
if (isset($_GET['save_teacher'])) {
	$Teacher = new Teacher();
	echo $Teacher->save_teacher($_POST);
	exit;
}

$title = "Add Teacher";
include_once (__DIR__."/header.php"); ?>

<div class="page-container">
	<?php include_once (__DIR__."/sidebar.php"); ?>

	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __("Students") ?>
						<small><?php echo __("Manage students data here") ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<!--li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
							<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="#">Action</a>
								</li>
								<li>
									<a href="#">Another action</a>
								</li>
								<li>
									<a href="#">Something else here</a>
								</li>
								<li class="divider">
								</li>
								<li>
									<a href="#">Separated link</a>
								</li>
							</ul>
						</li-->
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>">Home</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "teachers" ) ?>">Teachers</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#">Add Teacher</a>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-users"></i>
								<?php echo __( "Add Teacher" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form action="#" class="form-horizontal form-bordered validate check_save" id="teacher_form">
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __("Teacher Name") ?></label>
										<div class="col-md-4">
											<input type="text" name="name" title="<?php echo __("Teacher name required") ?>" required="required" class="form-control">
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __("Short Name") ?></label>
										<div class="col-md-4">
											<input type="text" name="short_name" title="<?php echo __("Short name for teacher") ?>" class="form-control">
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __("Email address") ?></label>
										<div class="col-md-4">
											<input type="email" name="email" title="<?php echo __("Email address required") ?>" required="required" class="form-control">
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __("Cell Number") ?></label>
										<div class="col-md-4">
											<input type="text" name="cell" title="<?php echo __("Cell number required") ?>" required="required" class="form-control mobile">
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __("Date of Joining") ?></label>
										<div class="col-md-4">
											<input type="text" name="date_of_joining" title="<?php echo __("Date of joining") ?>"
											       required="required" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>"
											       class="form-control date-picker">
										</div>
									</div>

									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __("Address") ?></label>
										<div class="col-md-4">
											<input type="text" name="address" title="<?php echo __("Home Address") ?>" class="form-control">
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __("Salary") ?></label>
										<div class="col-md-4">
											<input type="number" name="salary" title="<?php echo __("Salary") ?>" class="form-control">
										</div>
									</div>
								</div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="submit" class="btn blue"><?php echo __("Save") ?></button>
										<a href="<?php echo Urls::get_url( "teachers" ) ?>" class="btn default"><?php echo __("Cancel") ?></a>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once (__DIR__."/footer.php"); ?>

<script type="text/javascript">
	function Save( event ) {
		event.preventDefault();
		Block();
		$.post( 'add_teacher.php?save_teacher', $( "#teacher_form" ).serialize(), function( data ) {
			if ( data == "OK" ) {
				Success( "Teacher saved successfully!" );
				$( '#teacher_form' ).areYouSure( { 'silent': true } );
				window.location.href = "teachers.php";
			} else {
				UnBlock();
				Error( data );
			}
		} );
		return false;
	}
	$( function() {
		$( document ).on( "submit", "#teacher_form", Save );
	} );
</script>
</body>
<!-- END BODY -->
</html>