<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "administrator" ) ) {
	include_once( __DIR__ . "/no_access.php" );
	exit;
}
$title = "Admins | " . System;
include_once( __DIR__ . "/header.php" );
$admins         = new Admins;
$super_admin_id = $admins->get_super_admin( "id" );
?>

<!-- BEGIN CONTAINER -->
<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>

	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( "Administrators" ) ?>
						<small><?php _e( "Manage administrators" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<a id="delete_btn" href="<?php echo Urls::get_url( "admin" ) ?>" class="btn red" style="color:#fff">
								<i class="fa fa-trash"></i> <?php _e( "Delete Selected" ) ?>
							</a>
							<a href="<?php echo Urls::get_url( "admin" ) ?>" class="btn btn-primary" style="color:#fff">
								<i class="fa fa-plus"></i> <?php _e( "Add Admin" ) ?>
							</a>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "admins" ) ?>">
								<?php _e( "All Users" ) ?>
							</a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-user"></i> <?php _e( "Students List" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
							</div>
						</div>
						<div class="portlet-body">
							<table class="table table-striped table-bordered table-hover" id="mytable">
								<thead>
								<tr>
									<th style="width:70px !important;">
										<label class="href noselect">
											<input type="checkbox" id="checkbox">
											<?php _e( "ID" ) ?>
										</label>
									</th>
									<th><?php _e( "Username" ) ?></th>
									<th><?php _e( "Name" ) ?></th>
									<th><?php _e( "Email" ) ?></th>
									<th><?php _e( "Last Login" ) ?></th>
									<th><?php _e( "Is Admin" ) ?></th>
									<th><?php _e( "Active" ) ?></th>
								</tr>
								</thead>
								<tbody>
								<?php
								$rows = $admins->get_array();
								foreach ( $rows as $row ) { ?>
									<tr id="tr_<?php echo $row["id"] ?>" class="odd gradeX" <?php echo $row["active"] == 0 ? "style='color:#999999'" : "" ?>>
										<td>
											<label class="noselect">
												<?php if ( $row["id"] <> $super_admin_id ) { ?>
													<input type="checkbox" class="checkbox" value="<?php echo $row["id"] ?>" name="ids[]">
												<?php } else { ?>
													<input type="checkbox" class="checkbox" disabled="disabled">
												<?php } ?>
												<?php echo $row["id"] ?>
											</label>
										</td>
										<td>
											<a <?php echo $row["active"] == 0 ? "style='color:#999999;font-weight:bold'" : "" ?> href="<?php echo Urls::get_url( "manage_admin", $row["id"] ) ?>"><?php echo $row["username"] ?></a>
										</td>
										<td>
											<?php echo $row["name"] ?>
										</td>
										<td>
											<?php echo $row["email"] ?>
										</td>
										<td>
											<?php echo $row["login_time4"] ?><br />
											<?php echo $row["login_ip"] ?>
										</td>
										<td>
											<?php echo \Str::yesno( $row["is_admin"] ) ?>
											<?php if ( $row["super"] == 1 ) {
												echo " (Super)";
											} ?>
										</td>
										<td>
											<?php echo \Str::yesno( $row["active"] ) ?>
										</td>
									</tr>
								<?php } ?>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="text/javascript">
	$( function() {
		$( document ).on( "change", "#checkbox", function() {
			$( ".checkbox" ).not("[disabled]").each(function(  ) {
				//$( ".checkbox" ).prop( "checked", $( "#checkbox" ).is( ":checked" ) ).uniform();
				$( this ).prop( "checked", $( "#checkbox" ).is( ":checked" ) ).uniform();
			});
		} );
		$( document ).on( "click", "#delete_btn", function( event ) {
			event.preventDefault();

			if ( $( ".checkbox:checked" ).length==0 ) {
				Error( "<?php _e( "Please select one or more users to delete." ) ?>" );
				return false;
			}

			if ( !confirm( "<?php _e( "Are you sure you want to delete selected users" ) ?>" ) ) {
				return false;
			}

			$.post( "<?php echo DOMAIN_URL ?>ajax/admins.php?delete_users", $( ".checkbox" ).serialize(), function( data ) {
				if ( data=="OK" ) {
					$( $( ".checkbox:checked" ).each( function() {
						$( "#tr_" + $( this ).val() ).fadeOut( function() {
							$( this ).remove();
						} );
					} ) );
				}
			} );
		} );
	} );
</script>
</body>
</html>