<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}

if ( ! \Admins\UserInfo::is_allowed( "new_admission" ) ) {
	Urls::redirect( DOMAIN_URL );
}

$title = __( "New Admission" ) . " | " . System;
include_once( __DIR__ . "/header.php" );
$s   = new Student;
$c   = new BatchClass;
$b   = new Batch;
$Fee = new Fee;
// get session
$session      = new Sessions();
$session_name = $session->get_list();
?>

<style>
	.contact_detail, .notification1, .guardian_contact_detail, .previous_education {
		display: none;
	}
</style>

<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<a href="<?php echo Urls::get_url( "admission" ) ?>">
							<?php echo __( "New Admission" ) ?>
						</a>
						<small><?php echo __( "Register new admission" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<!--li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
							<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="#">Action</a>
								</li>
								<li>
									<a href="#">Another action</a>
								</li>
								<li>
									<a href="#">Something else here</a>
								</li>
								<li class="divider">
								</li>
								<li>
									<a href="#">Separated link</a>
								</li>
							</ul>
						</li-->
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "students" ) ?>"><?php echo __( "Students" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "admission" ) ?>"><?php echo __( "New Admission" ) ?></a>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-user"></i> <?php _e( "New Admission" ) ?>
							</div>
							<div class="tools hidden-xs">
								<a href="javascript:;" class="collapse"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form class="form-horizontal form-bordered validate check_save" id="submit_form"
							      name="submit_form">
								<input type="submit" style="display: none;" id="submit1">
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3">
											<?php echo __( "Admission Number" ) ?>
										</label>
										<div class="col-md-9">
											<input type="number" class="form-control" name="admission_number" id="admission_number" value="<?php echo $s->available_admission_number() ?>" placeholder="Unique admission number" required="required">
											<span class="help-block">
												
											</span>
										</div>
									</div>

									<div class="form-group">
										<label class="control-label col-md-3">
											<?php echo __( "Select Class" ) ?>
										</label>
										<?php $classes       = $c->get_list();
										$batch               = $b->get_list( "limit=1&orderby=id&order=DESC" );
										$batch["batch_name"] = isset( $batch["batch_name"] ) ? $batch["batch_name"] : '';
										?>
										<div class="col-md-9">
											<select name="class_id" id="class_id" class="form-control select2" required="required">
												<option selected value="">-- <?php echo __( "Select Class" ) ?> --</option>
												<optgroup label="Batch: <?php echo $batch["batch_name"] ?>">
													<?php
													foreach ( $classes as $class ):
														$batch["batch_name"] = isset( $batch["batch_name"] ) ? $batch["batch_name"] : '';
														?>
														<option value="<?php echo $class["id"] ?>">
															ID: <?php echo add_leading_zeros( $class["id"], 3 ) ?> -
															<?php echo $class["class_name"] ?> - (<?php echo _e( "Batch" ) ?>: <?php echo $batch["batch_name"] ?>)
														</option>
													<?php endforeach;
													$classes[0]["id"] = isset( $classes[0]["id"] ) ? $classes[0]["id"] : 0;
													$class_id         = (int) $classes[0]["id"]; ?>
												</optgroup>
											</select>
											<span class="help-block">
												
											</span>
										</div>
									</div>

									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Subjects for this student" ) ?></label>
										<div class="col-md-9">
											<select class="form-control select2" name="subjects[]" multiple="multiple"
											        id="subjects" data-placeholder="<?php _e( "Select subjects" ) ?>">
											</select>
											<span class="help-block">
                                                <?php echo __( "If you will not select any subject then all subjects will load from selected class" ) ?>
											</span>
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Roll Number" ) ?></label>
										<div class="col-md-9">
											<input type="text" class="form-control" name="roll" placeholder="<?php _e("Roll Number") ?>">
											<span class="help-block"></span>
										</div>
									</div>
									<div class="form-group">
										<?php $fee = $c->get_tution_fee( $class_id ); ?>
										<label class="control-label col-md-3"><?php echo __( "Monthly Tution Fee" ) ?></label>
										<div class="col-md-9">
											<input type="number" min="0" class="form-control" name="fee" id="fee" placeholder="Monthly Tution Fee" value="<?php echo $fee ?>">
											<span class="help-block">
                                                <?php echo __( "This fee will be charged every month" ) ?>
											</span>
										</div>
									</div>
									<h4 class="form-section caption_heading">
										<i class="fa fa-chevron-circle-down"></i>
										<a href="javascript:;" onclick="$('#fee_admission').toggle('slow')">
											<?php echo __( "Fees (These fees will charge only at admission time)" ) ?>
										</a>
									</h4>
									<div id="fee_admission">
										<?php foreach ( $Fee->FeeTypes as $key => $val ):
											#if ($key=="tution_fee") $val .= " - ".date("F, Y");
											if ( $key == "admission_fee" ) {
												$fee = $c->get_admission_fee( $class_id );
											} else {
												$fee = 0;
											}
											?>
											<div class="form-group">
												<label class="control-label col-md-3"><?php echo __( $val ) ?></label>
												<div class="col-md-9">
													<input type="number" min="0" class="form-control" name="<?php echo $key ?>" id="<?php echo $key ?>" placeholder="<?php echo $val ?>" value="<?php echo $fee ?>">
												</div>
											</div>
										<?php endforeach; ?>
									</div>
									<h4 class="form-section caption_heading"><i class="fa fa-chevron-circle-down"></i>
										<a><?php echo __( "Student" ) ?>
											<i class="fa fa-angle-double-right"></i> <?php echo __( "Personal details" ) ?>
										</a></h4>
									<div class="form-group">
										<label class="control-label col-md-3">
											<?php echo __( "Admission Date" ) ?>
										</label>
										<div class="col-md-9">
											<input title="<?php echo __( "Admission Date" ) ?>" required="required" data-date-format="<?php echo \Dates::date_format1_for_js() ?>" type="text" class="form-control form-control-inline date-picker" name="admission_date" placeholder="Admission Date" value="<?php echo Date( $db->get_option( "date_format1" ) ) ?>">
											<span class="help-block">

											</span>
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3">
											<?php echo __( "Student's Full Name" ) ?>
										</label>
										<div class="col-md-9">
											<input title="<?php echo __( "Student's full name required" ) ?>" required="required" type="text" class="form-control" name="name" placeholder="<?php echo __( "Student's Full Name" ) ?>">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3">
											<?php echo __( "Father Name" ) ?>
										</label>
										<div class="col-md-9">
											<input title="<?php echo __( "Father name required" ) ?>" required="required" type="text" class="form-control" id="father_name" name="father_name" placeholder="<?php echo __( "Father Name" ) ?>">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3">
											<?php echo __( "Date of Birth" ) ?>
										</label>
										<div class="col-md-9">
											<input title="<?php echo __( "Date of birth required" ) ?>" required="required" type="text" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>" class="form-control form-control-inline date-picker" name="dob" placeholder="<?php echo __( "Date of Birth" ) ?>">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3">
											<?php echo __( "Gender" ) ?>
										</label>
										<div class="col-md-9">
											<div class="radio-list">
												<label>
													<input checked="checked" title="Select One" type="radio" name="gender" value="M" data-title="Male" required="required">
													<?php echo __( "Male" ) ?>
												</label>
												<label>
													<input title="Select One" type="radio" name="gender" value="F" data-title="Female">
													<?php echo __( "Female" ) ?> </label>
											</div>
											<div id="form_gender_error">
											</div>
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3">
											<?php echo __( "Student Category" ) ?>
										</label>
										<div class="col-md-9">
											<input title="<?php echo __( "Student Category" ) ?>" name="student_category" class="form-control" value="General" required="required">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Blood Group" ) ?></label>
										<div class="col-md-9">
											<select name="blood_group" class="form-control select2">
												<?php foreach ( $s->BloodGroupsArray as $bg ) {
													echo "<option>{$bg}</option>\n";
												} ?>
											</select>
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Birth Place" ) ?></label>
										<div class="col-md-9">
											<input type="text" class="form-control" name="birth_place" placeholder="<?php echo __( "Birth Place" ) ?>">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Nationality" ) ?></label>
										<div class="col-md-9">
											<input type="text" class="form-control" name="nationality" placeholder="<?php echo __( "Nationality" ) ?>" value="">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Religion" ) ?></label>
										<div class="col-md-9">
											<select name="religion" class="form-control select2">
												<option value="Islam"><?php _e("Islam") ?></option>
												<option value="Christian"><?php _e("Christian") ?></option>
												<option value="Sikh"><?php _e("Sikh") ?></option>
												<option value="Hindu"><?php _e("Hindu") ?></option>
												<option value="Other"><?php _e("Other") ?></option>
											</select>
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<h4 class="form-section caption_heading"><i class="fa fa-chevron-circle-down"></i>
										<a href="javascript:;" onclick="$('.contact_detail').toggle('slow')">
											<?php echo __( "Student" ) ?>
											<i class="fa fa-angle-double-right"></i> <?php echo __( "Contact details" ) ?>
										</a></h4>
									<div class="form-group contact_detail">
										<label class="control-label col-md-3">
											<?php echo __( "Address" ) ?>
										</label>
										<div class="col-md-9">
											<input type="text" class="form-control" name="address" placeholder="<?php echo __( "Address" ) ?>">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group contact_detail">
										<label class="control-label col-md-3">
											<?php echo __( "City" ) ?>
										</label>
										<div class="col-md-9">
											<input type="text" class="form-control" name="city" placeholder="<?php echo __( "City" ) ?>">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group contact_detail">
										<label class="control-label col-md-3">
											<?php echo __( "State or Province" ) ?>
										</label>
										<div class="col-md-9">
											<input type="text" class="form-control" name="state" placeholder="<?php echo __( "State or Province" ) ?>">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group contact_detail">
										<label class="control-label col-md-3">
											<?php echo __( "Phone Number" ) ?>
										</label>
										<div class="col-md-9">
											<input type="tel" class="form-control land_line" name="state" placeholder="<?php echo __( "Land line number" ) ?>">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group contact_detail">
										<label class="control-label col-md-3">
											<?php echo __( "Mobile Number" ) ?>
										</label>
										<div class="col-md-9">
											<input type="tel" class="form-control mobile" name="cell" placeholder="<?php echo __( "Mobile Number" ) ?>">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group contact_detail">
										<label class="control-label col-md-3"><?php echo __( "Email Address" ) ?></label>
										<div class="col-md-9">
											<input type="text" class="form-control" name="email" placeholder="<?php echo __( "Email Address" ) ?>">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<h4 class="form-section caption_heading"><i class="fa fa-chevron-circle-down"></i>
										<a><?php echo __( "Guardian Details" ) ?></a></h4>
									<div class="form-group">
										<label class="control-label col-md-3" for="guardian_name">
											<?php echo __( "Full Name" ) ?>
										</label>
										<div class="col-md-9">
											<input title="<?php echo __( "Guardian's Full Name" ) ?>" required="required"
											       type="text" class="form-control" name="guardian_name" id="guardian_name"
											       placeholder="<?php echo __( "Guardian's Full Name" ) ?>">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3" for="guardian_relation">
											<?php echo __( "Relation" ) ?>
										</label>
										<div class="col-md-9">
											<select title="<?php echo __( "Relation" ) ?>" name="guardian_relation"
											        id="guardian_relation"
											        class="form-control select2" required="required">
												<?php foreach ( $s->RelationArray as $relation ) {
													echo "<option>".__($relation)."</option>\n";
												} ?>
											</select>
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3">
											<?php echo __( "Guardian's mobile number" ) ?>
										</label>
										<div class="col-md-9">
											<input title="<?php echo __( "Guardian's mobile number" ) ?>"
											       required="required" type="tel" name="guardian_cell" id="guardian_cell"
											       placeholder="<?php echo __( "Guardian's mobile number" ) ?>" class="form-control mobile">
											<span class="help-block">
													
											</span>
										</div>
									</div>
									<h4 class="form-section caption_heading"><i class="fa fa-chevron-circle-down"></i>
										<a href="javascript:;" onclick="$('.guardian_contact_detail').toggle('slow'); $(this).parent().remove();">
											<?php echo __( "More Guardian Details" ) ?>
										</a>
									</h4>
									<div class="form-group guardian_contact_detail">
										<label class="control-label col-md-3">
											<?php echo __( "National ID Card" ) ?>
										</label>
										<div class="col-md-9">
											<input type="text" class="form-control nic" name="nic" placeholder="<?php echo __( "National ID Card" ) ?>">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group guardian_contact_detail">
										<label class="control-label col-md-3">
											<?php echo __( "Date of Birth" ) ?>
										</label>
										<div class="col-md-9">
											<input data-date-format="<?php echo \Dates::date_format1_for_js(); ?>" type="text" class="form-control form-control-inline date-picker" name="guardian_dob" placeholder="<?php echo __( "Birthday of Guardian" ) ?>">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group guardian_contact_detail">
										<label class="control-label col-md-3"><?php echo __( "Education" ) ?></label>
										<div class="col-md-9">
											<input type="text" class="form-control" name="guardian_education" placeholder="<?php echo __( "Education" ) ?>">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group guardian_contact_detail">
										<label class="control-label col-md-3"><?php echo __( "Income" ) ?></label>
										<div class="col-md-9">
											<input type="text" class="form-control" name="guardian_income" placeholder="<?php echo __( "Income" ) ?>">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group guardian_contact_detail">
										<label class="control-label col-md-3"><?php echo __( "Occupation" ) ?>
										</label>
										<div class="col-md-9">
											<input type="text" class="form-control" name="guardian_occupation" placeholder="<?php echo __( "Occupation" ) ?>">
											<span class="help-block">
												
											</span>
										</div>
									</div>
									<div class="form-group guardian_contact_detail">
										<label class="control-label col-md-3"><?php echo __( "Email Address" ) ?></label>
										<div class="col-md-9">
											<input type="text" name="guardian_email" placeholder="<?php echo __( "Email Address" ) ?>" class="form-control" />
											<span class="help-block">
													
											</span>
										</div>
									</div>
									<div class="form-group guardian_contact_detail">
										<label class="control-label col-md-3"><?php echo __( "Address" ) ?></label>
										<div class="col-md-9">
											<input type="text" name="guardian_address" placeholder="<?php echo __( "Address" ) ?>" class="form-control">
											<span class="help-block">
													
											</span>
										</div>
									</div>
									<div class="form-group guardian_contact_detail">
										<label class="control-label col-md-3"><?php echo __( "City" ) ?></label>
										<div class="col-md-9">
											<input type="text" name="guardian_city" placeholder="<?php echo __( "City" ) ?>" class="form-control">
											<span class="help-block">
													
											</span>
										</div>
									</div>
									<div class="form-group guardian_contact_detail">
										<label class="control-label col-md-3"><?php echo __( "State" ) ?></label>
										<div class="col-md-9">
											<input type="text" name="guardian_state" placeholder="<?php echo __( "State" ) ?>" class="form-control">
											<span class="help-block">
													
											</span>
										</div>
									</div>
									<div class="form-group guardian_contact_detail">
										<label class="control-label col-md-3"><?php echo __( "Phone Number" ) ?></label>
										<div class="col-md-9">
											<input type="tel" name="guardian_phone" placeholder="<?php echo __( "Phone" ) ?>" class="form-control phone">
											<span class="help-block">
													
											</span>
										</div>
									</div>
									<h4 class="form-section caption_heading"><i class="fa fa-chevron-circle-down"></i>
										<a href="javascript:;" onclick="$('.previous_education').toggle('slow')"><?php echo __( "Previous Education" ) ?></a>
									</h4>
									<div class="form-group previous_education">
										<label class="control-label col-md-3"><?php echo __( "Institution Name" ) ?></label>
										<div class="col-md-9">
											<input type="text" class="form-control" name="prev_institute1" placeholder="<?php echo __( "Institution Name" ) ?>">
											<span class="help-block">
                                            
											</span>
										</div>
									</div>
									<div class="form-group previous_education">
										<label class="control-label col-md-3"><?php echo __( "Course/Class" ) ?></label>
										<div class="col-md-9">
											<input type="text" class="form-control" name="prev_course1" placeholder="<?php echo __( "Course/Class" ) ?>">
											<span class="help-block">
                                            
											</span>
										</div>
									</div>
									<div class="form-group previous_education">
										<label class="control-label col-md-3"><?php echo __( "Year" ) ?></label>
										<div class="col-md-9">
											<input type="text" placeholder="<?php echo __( "Year" ) ?>" class="form-control" name="prev_year1">
											<span class="help-block">
                                            
											</span>
										</div>
									</div>
									<div class="form-group previous_education">
										<label class="control-label col-md-3"><?php echo __( "Total Marks" ) ?></label>
										<div class="col-md-9">
											<input type="text" placeholder="<?php echo __( "Total Marks" ) ?>" maxlength="4" class="form-control" name="prev_marks1">
											<span class="help-block">
												
											</span>
										</div>
									</div>

									<h4 class="form-section caption_heading"><i class="fa fa-chevron-circle-down"></i>
										<a href="javascript:;" onclick="$('.advanced_options').toggle('slow')"><?php echo __( "Advanced Options" ) ?></a>
									</h4>
									<?php $Custom = new Custom();
									$fields       = $Custom->get_fields( "students" );
									//show_array($fields);
									foreach ( $fields as $k => $field ) {
										$data = array(
											"class"       => "form-control",
											"placeholder" => $field["label"],
											"required"    => $field["required"],
										);
										if ( isset( $field["data"] ) ) {
											$data["value"] = $field["data"];
										}

										$F = $Custom->field_to_html( array( $k => $field ), $data );
										//if ($field[""]) ?>
										<div class="form-group advanced_options">
											<?php if ( $F["html"] == "" ) { ?>
												<div class="col-md-12"><?php echo $F["label"] ?></div>
											<?php } else if ( $field["type"] == "radio" ) { ?>
												<label class="control-label col-md-3"><?php echo $F["label"] ?>
													<?php if ( $field["required"] == "1" ) { ?>
														<span class="required">
															*
														</span>
													<?php } ?>
												</label>
												<div class="col-md-9">
													<div class="radio-list">
														<?php echo $F["html"] ?>
													</div>
												</div>
											<?php } else if ( $field["type"] == "checkbox" ) { ?>
												<label class="control-label col-md-3"><?php echo $F["label"] ?>
													<?php if ( $field["required"] == "1" ) { ?>
														<span class="required">
															*
														</span>
													<?php } ?>
												</label>
												<div class="col-md-9">
													<div class="checkbox-list">
														<?php echo $F["html"] ?>
													</div>
												</div>
											<?php } else { ?>
												<label class="control-label col-md-3"><?php echo $F["label"] ?>
													<?php if ( $field["required"] == "1" ) { ?>
														<span class="required">
															*
														</span>
													<?php } ?>
												</label>
												<div class="col-md-9">
													<?php echo $F["html"] ?>
													<!--<input type="text" placeholder="Marks" maxlength="4" class="form-control" name="prev_marks1">-->
												</div>
											<?php } ?>
										</div>
									<?php } ?>

									<!--
                                    <?php if ( App::is_email_active() || App::is_sms_active() ): ?>
                                    <h4 class="form-section"><a href="javascript:;" onclick="$('.notification1').toggle('slow')">Notifications</a></h4>
                                    <?php if ( App::is_sms_active() ): ?>
                                    <div class="form-group notification1">
										<label class="control-label col-md-3">
										</label>
										<div class="col-md-9">
											<div class="checkbox-list">
												<label>
												<input type="checkbox" name="is_sms" value="1" data-title="Enable/Disable SMS notifications"/> SMS Notifications </label>
											</div>
										</div>
									</div>
                                    <?php endif; ?>
                                    <?php if ( App::is_email_active() ): ?>
                                    <div class="form-group notification1">
										<label class="control-label col-md-3">
										</label>
										<div class="col-md-9">
											<div class="checkbox-list">
												<label>
												<input type="checkbox" name="is_email" value="1" data-title="Enable/Disable Email notifications"/> Email Notifications </label>
											</div>
										</div>
									</div>
                                    <?php endif; ?>
                                    <?php endif; ?>
                                    -->
								</div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="submit" class="btn blue"><?php echo __( "Save" ) ?></button>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->
<?php include_once( __DIR__ . "/footer.php" ); ?>

<!--script src="<?php echo \Theme::url() ?>js/admission.js"></script-->
<script>
	function ChangeClass() {
		Block();
		//var ids = $(t).val();
		//var id = ids[1];
		var id = $( this ).val();
		$.post( "<?php echo Urls::get_url( "ajax", 0, "action=getClassInfo" ) ?>", { id: id }, function( data ) {
			UnBlock();
			if ( is_json( data ) ) {
				data = json_encode( data );
			}
			$( "#admission_fee" ).val( data.admission_fee );
			$( "#fee" ).val( data.tution_fee );
			$( "#subjects" ).html( data.subjects );
			$( "#subjects" ).select2();
		} );
	}

	jQuery( document ).ready( function() {
		//AdmissionWizard.init();
		$( "#admission_number,#admission_number2,#admission_number3" ).change( function() {
			var v = $( this ).val();
			$( "#admission_number,#admission_number2,#admission_number3" ).val( v );
		} );

		$( "#father_name" ).change( function() {
			var gn = $( "#guardian_name" ).val();
			if ( gn=="" ) {
				$( "#guardian_name" ).val( $( this ).val() );
			}
		} );

		$( document ).on( "change", "#class_id", ChangeClass );
		$( document ).on( "submit", "#submit_form", Save );
	} );

	function Save( event ) {
		event.preventDefault();

		k = $( "#submit_form" ).serialize();
		Block();
		$.post( "<?php echo ROOT_URL ?>includes/old_ajax.php?action=saveStudent", k, function( data ) {
			if ( data.substr( 0, 2 )=="OK" ) {
				var data = data.substr( 2 );
				var obj = jQuery.parseJSON( data );
				$( '#submit_form' ).areYouSure( { 'silent': true } );
				window.location.href = obj.profile_url;
			} else {
				UnBlock();
				bootbox.alert( data );
			}
		} );
		/*$.post("",$("#form_wizard_1").serialize(),function(data){
		 UnBlock();
		 bootbox.alert(data);
		 });*/
		return false;
	}
</script>
</body>
<!-- END BODY -->
</html>