<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "user_management" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$title = __( "Lecture Schedule List" ) . " - " . System;
include_once( __DIR__ . "/header.php" );
$d    = new Datesheet;
$rows = $d->get_schedule();
// time array
$time_array = "9:00 AM@9:15 AM@9:30 AM@9:45 AM@10:00 AM@10:15 AM@10:30 AM@10:45 AM@11:00 AM@11:15 AM@11:30 AM@11:45 AM@12:00 PM@12:15 PM@12:30 PM@12:45 PM@1:00 PM@1:15 PM@1:30 PM@1:45 PM@2:00 PM@2:15 PM@2:30 PM@2:45 PM@3:00 PM@3:15 PM@3:30 PM@3:45 PM@4:00 PM@4:15 PM@4:30 PM@4:45 PM@5:00 PM@5:15 PM@5:30 PM@5:45 PM@6:00 PM@6:15 PM@6:30 PM@6:45 PM@7:00 PM@7:15 PM@7:30 PM@7:45 PM@8:00 PM@8:15 PM@8:30 PM@8:45 PM@9:00 PM";
$time_array = \Str::make_array( $time_array, "@" );
?>
<style>
	.modal-lg {
		width: 100% !important;
	}
</style>

<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title"> <?php echo __( "Lecture Schedule" ) ?>
						<small><?php echo __( "Manage Weekly Lecture Schedule" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "all_schedule_list" ) ?>">
								<?php echo __( "Weekly Lecture Schedule" ) ?>
							</a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php echo __( "All Schedule List" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<!--<a href="#portlet-config" data-toggle="modal" class="config"></a>-->
							</div>
						</div>
					</div>
					<table class="table table-bordered table-striped">
						<thead>
						<tr class="heading">
							<th style="width:35px"><?php echo __( "ID" ) ?></th>
							<th><?php echo __( "Class Name" ) ?></th>
							<th><?php echo __( "Teacher Name" ) ?></th>
							<th style="width:100px"></th>
						</tr>
						</thead>
						<tbody>
						<?php $no = 1;
						foreach ( $rows as $k => $row ) { ?>
							<tr id="rowdata<?php echo $row["id"] ?>">
								<td style="text-align: right;"><?php echo $no; ?></td>
								<td><?php echo $row["classname"] ?></td>
								<td><?php echo $row["teacher_name"] ?></td>
								<td style="text-align:right;">
									<div class="btn-group">
										<a style="cursor: pointer;" class="btn blue btn-xs edit"
										   data-edit="<?php echo $row["id"] ?>"
										   data-teacherid="<?php echo $row["teacherid"] ?>"
										   data-classid="<?php echo $row["classid"] ?>"
										   title="<?php _e( "Edit Datesheet" ) ?>" href="javascript:;">
											<i class="fa fa-edit"></i>
										</a>
										<a onclick="download_pdf('<?php echo $row["id"] ?>')"
										   class="tooltips btn green btn-xs">
											<i class="fa fa-file-pdf-o" aria-hidden="true"></i>
										</a>
										<a data-deleterow="<?php echo $row["id"] ?>"
										   class="btn red btn-xs delete_row">
											<i class="fa fa-trash" aria-hidden="true"></i>
										</a>
									</div>
								</td>
							</tr>
							<?php $no ++;
						} ?>
						</tbody>
					</table>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>

<div class="modal fade" id="edit_row" tabindex="-1" role="dialog" aria-labelledby="myModalLabel"
     aria-hidden="true">
	<div class="modal-dialog modal-lg">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
				<h4 class="modal-title"><?php echo __( "Edit Schedule" ) ?></h4>
			</div>
			<form action="#" class="form-horizontal" id="edit-form">
				<div class="modal-body">
					<div class="form-body">
						<input type="hidden" name="id" id="id" value="0">
						<div class="form-group">
							<label class="control-label col-md-2">Teacher</label>
							<div class="col-md-10">
								<input type="hidden" class="form-control" id="teacherid" name="teacherid" value="">
								<input type="text" class="form-control" id="teacher_name" name="teacher_name" value=""
								       readonly>
							</div>
						</div>
						<div class="form-group">
							<label class="control-label col-md-2">Select Class</label>
							<div class="col-md-10">
								<select id="classid" class="form-control select2" name="classid" required='required'>
									<option value="">-- <?php echo __( "Select class" ) ?> --</option>
								</select>
							</div>
						</div>
						<div class="form-group">
							<div class="col-md-12">
								<table class="table table-bordered table-striped">
									<thead>
									<tr>
										<th><?php echo __( "Time" ) ?></th>
										<th><?php echo __( "Monday" ) ?></th>
										<th><?php echo __( "Tuesday" ) ?></th>
										<th><?php echo __( "Wednesday" ) ?></th>
										<th><?php echo __( "Thursday" ) ?></th>
										<th><?php echo __( "Friday" ) ?></th>
										<th><?php echo __( "Saturday" ) ?></th>
									</tr>
									</thead>
									<tbody>
									<?php for ( $i = 0; $i < 8; $i ++ ) { ?>
										<tr id="rowid" class="rowid<?php echo $i ?>">
											<td>
												<select name="time[]" id="time<?php echo $i ?>"
												        class='form-control select2 time_value'>
													<option value="">Select</option>
													<?php foreach ( $time_array as $t ) { ?>
														<option value="<?php echo $t ?>"><?php echo $t ?></option>
													<?php } ?>
												</select>
											</td>
											<td>
												<select name="monday[]" id="monday"
												        class='form-control select2 monday<?php echo $i ?>'>
													<option value=""><?php echo __( "Select" ) ?></option>
												</select>
											</td>
											<td>
												<select name="tuesday[]" id="tuesday"
												        class='form-control select2 tuesday<?php echo $i ?>'>
													<option value=""><?php echo __( "Select" ) ?></option>
												</select>
											</td>
											<td>
												<select name="wednesday[]" id="wednesday"
												        class='form-control select2 wednesday<?php echo $i ?>'>
													<option value=""><?php echo __( "Select" ) ?></option>
												</select>
											</td>
											<td>
												<select name="thursday[]" id="thursday"
												        class='form-control select2 thursday<?php echo $i ?>'>
													<option value=""><?php echo __( "Select" ) ?></option>
												</select>
											</td>
											<td>
												<select name="friday[]" id="friday"
												        class='form-control select2 friday<?php echo $i ?>'>
													<option value=""><?php echo __( "Select" ) ?></option>
												</select>
											</td>
											<td>
												<select name="saturday[]" id="saturday"
												        class='form-control select2 saturday<?php echo $i ?>'>
													<option value=""><?php echo __( "Select" ) ?></option>
												</select>
											</td>
										</tr>
									<?php } ?>
									</tbody>
								</table>
							</div>
						</div>
					</div>
				</div>
				<div class="modal-footer">
					<div class="btn-group">
						<button id="form1_submit_btn" type="button" class="btn blue editform">
							<?php echo __( "Save changes" ) ?>
						</button>
						<button type="button" class="btn default" data-dismiss="modal"><?php echo __( "Close" ) ?></button>
					</div>
				</div>
			</form>
		</div>
		<!-- /.modal-content -->
	</div>
	<!-- /.modal-dialog -->
</div>

<!-- END CONTAINER -->
<?php include_once( __DIR__ . "/footer.php" ); ?>


<?php foreach ( $rows as $row ): ?>
	<form onsubmit="return download_pdf('<?php echo $row["id"] ?>');"
	      id="download_pdf_file<?php echo $row["id"] ?>"
	      action="<?php echo Urls::get_url( "download_student_weekly_report", 0, "id=" . $row["id"] . "&weekly_lecture=WeeklyLecture" ); ?>"
	      method="get" class="form-horizontal form-bordered">
		<!--<input type="hidden" name="id" id="id" value="<?php /*echo $row["id"] */ ?>">
		<input type="hidden" name="weekly_lecture" id="weekly_lecture" value="WeeklyLecture">-->
	</form>
<?php endforeach; ?>

<script type="application/javascript">
	$( document ).ready( function() {
		// edit view schedule
		$( document ).on( "click", ".edit", function( event ) {
			event.preventDefault();
			var id = $( this ).attr( "data-edit" );
			var teacherid = $( this ).attr( "data-teacherid" );
			var classid = $( this ).attr( "data-classid" );
			Block();
			$.post( '<?php echo DOMAIN_URL ?>includes/ajax.php?action=getTeacherAssignLecture',
				{ id: id, teacher_id: teacherid, class_id: classid }, function( data ) {
					var obj = data;

					if ( obj.status=="OK" ) {
						$( "#edit_row" ).modal( "show" );
						// class name selected
						$( "select#classid" ).select2( "destroy" );
						$( '#classid' ).html( "" );
						var currSelect = $( '#classid' );
						currSelect.append( $( "<option></option>" ).attr( "value", "" ).text( "-- <?php echo __( "Select" ) ?> --" ) );
						$.each( obj, function( k, v ) {
							if ( obj[ k ].id!=undefined ) {
								if ( classid==obj[ k ].id ) {
									currSelect.append( $( "<option data-getClassName='" + obj[ k ].name + "'></option>" ).attr( "value", obj[ k ].id ).text( obj[ k ].name ) );
									$( '#classid option[value="' + obj[ k ].id + '"]' ).attr( "selected", "selected" );
								} else {
									currSelect.append( $( "<option data-getClassName='" + obj[ k ].name + "'></option>" ).attr( "value", obj[ k ].id ).text( obj[ k ].name ) );
								}
							}
						} );
						$( "select#classid" ).select2();

						// edit row id
						$( '#id' ).val( obj.schedule[ 0 ].id );

						// teacher name selected
						$( '#teacherid' ).val( teacherid );
						$( '#teacher_name' ).val( obj.schedule[ 0 ].teacher_name );

						// get load subjects
						$( "#monday,#tuesday,#wednesday,#thursday,#friday,#saturday" ).select2( "destroy" );
						$( '#monday,#tuesday,#wednesday,#thursday,#friday,#saturday' ).html( "" );
						var currSub = $( '#monday,#tuesday,#wednesday,#thursday,#friday,#saturday' );
						currSub.append( $( "<option></option>" ).attr( "value", "" ).text( "-- <?php echo __( "Select" ) ?> --" ) );
						$.each( obj, function( k, v ) {
							if ( obj[ k ].id!=undefined ) {
								if ( classid==obj[ k ].id ) {
									var array = obj[ k ].subjects.split( ',' );
									for ( var i = 0; i<array.length; i++ ) {
										currSub.append( $( "<option></option>" ).attr( "value", array[ i ] ).text( array[ i ] ) );
									}
								}
							}
						} );
						$( "#monday,#tuesday,#wednesday,#thursday,#friday,#saturday" ).select2();
						// time option value
						var time_array = obj.schedule[ 0 ].time.split( ',' );
						for ( var t = 0; t<time_array.length; t++ ) {
							$( "#time" + t ).select2( "destroy" );
							$( "#time" + t ).each( function() {
								$( "#time" + t ).val( time_array[ t ] );
							} );
							$( "#time" + t ).select2();
						}
						// monday option value
						var monday = obj.schedule[ 0 ].monday.split( ',' );
						for ( var m = 0; m<monday.length; m++ ) {
							$( ".monday" + m ).select2( "destroy" );
							$( ".monday" + m ).each( function() {
								$( ".monday" + m ).val( monday[ m ] );
							} );
							$( ".monday" + m ).select2();
						}
						// tuesday option value
						var tuesday = obj.schedule[ 0 ].tuesday.split( ',' );
						for ( var t = 0; t<tuesday.length; t++ ) {
							$( ".tuesday" + t ).select2( "destroy" );
							$( ".tuesday" + t ).each( function() {
								$( ".tuesday" + t ).val( tuesday[ t ] );
							} );
							$( ".tuesday" + t ).select2();
						}
						// wednesday option value
						var wednesday = obj.schedule[ 0 ].wednesday.split( ',' );
						for ( var w = 0; w<wednesday.length; w++ ) {
							$( ".wednesday" + w ).select2( "destroy" );
							$( ".wednesday" + w ).each( function() {
								$( ".wednesday" + w ).val( wednesday[ w ] );
							} );
							$( ".wednesday" + w ).select2();
						}
						// thursday option value
						var thursday = obj.schedule[ 0 ].thursday.split( ',' );
						for ( var th = 0; th<thursday.length; th++ ) {
							$( ".thursday" + th ).select2( "destroy" );
							$( ".thursday" + th ).each( function() {
								$( ".thursday" + th ).val( thursday[ th ] );
							} );
							$( ".thursday" + th ).select2();
						}
						// friday option value
						var friday = obj.schedule[ 0 ].friday.split( ',' );
						for ( var f = 0; f<friday.length; f++ ) {
							$( ".friday" + f ).select2( "destroy" );
							$( ".friday" + f ).each( function() {
								$( ".friday" + f ).val( friday[ f ] );
							} );
							$( ".friday" + f ).select2();
						}
						// saturday option value
						var saturday = obj.schedule[ 0 ].saturday.split( ',' );
						for ( var s = 0; s<saturday.length; s++ ) {
							$( ".saturday" + s ).select2( "destroy" );
							$( ".saturday" + s ).each( function() {
								$( ".saturday" + s ).val( saturday[ s ] );
							} );
							$( ".saturday" + s ).select2();
						}
						UnBlock();
						return;
					} else {
						Error( data );
						UnBlock();
					}

				} );
		} );

		// class change
		$( document ).on( "change", "#classid", function() {
			var classid = $( "#classid" ).val();
			Block();
			$.post( "<?php echo DOMAIN_URL ?>includes/ajax.php?action=getClassSubjects", { classid: $( this ).val() }, function( data ) {
				UnBlock();
				if ( is_json( data ) ) {
					data = jQuery.parseJSON( data );
					$( "#monday,#tuesday,#wednesday,#thursday,#friday,#saturday" ).select2( "destroy" );
					$( '#monday,#tuesday,#wednesday,#thursday,#friday,#saturday' ).html( "" );
					var currSub = $( '#monday,#tuesday,#wednesday,#thursday,#friday,#saturday' );
					currSub.append( $( "<option></option>" ).attr( "value", "" ).text( "-- Select --" ) );
					$.each( data, function( k, v ) {
						currSub.append( $( "<option></option>" ).attr( "value", v ).text( v ) );
					} );
					$( "#monday,#tuesday,#wednesday,#thursday,#friday,#saturday" ).select2();
				}
			} );
		} );

		// edit form
		$( document ).on( "click", ".editform", function() {
			Block();
			$.post( '<?php echo DOMAIN_URL ?>includes/ajax.php?action=saveWeeklySchedule',
				$( "#edit-form" ).serialize(), function( data ) {
					if ( data=="OK" ) {
						Success( "Updated successfully!" );
						window.location.href = "<?php echo Urls::get_url( "all_schedule_list" ) ?>";
					} else {
						Error( data );
						UnBlock();
					}
				} );
		} );

		// delete schedule
		$( document ).on( "click", ".delete_row", function(event) {
			event.preventDefault();
			if (!confirm('<?php echo __( "Are you sure you sure you want to delete this record?" ) ?>')) {
				return false;
			}
			var id = $( this ).attr( "data-deleterow" );
			$("#rowdata" + id).fadeOut("slow", function(){
				$(this).remove();
			});
			$.post( '<?php echo DOMAIN_URL ?>includes/ajax.php?action=deleteSchedule', { id: id }, function( data ) {
				if ( data=="OK" ) {
					Success( "Record Deleted Successfully..." );
				} else {
					Error( data );
				}
			} );
		} );

		// table listing
		/*dataTable2 = $( '.custom_dt' ).dataTable( {
			"aLengthMenu": [
				[ 10, 20, 30, 40, 50, 100, -1 ],
				[ 10, 20, 30, 40, 50, 100, "All" ] // change per page values here
			],
			// set the initial value
			"iDisplayLength": 10,
			//            "sPaginationType": "bootstrap",
			"oLanguage": {
				"sLengthMenu": "_MENU_ records",
				"oPaginate": {
					"sPrevious": "Previous Page",
					"sNext": "Next Page"
				}
			},
			"aaSorting": [ [ 1, "asc" ] ],
			"aoColumns": [
				{ "bSortable": true },
				{ "bSortable": true },
				{ "bSortable": true },
				{ "bSortable": true }
			]
		} );*/

	} );

	function download_pdf( btn ) {
		u = $( "#download_pdf_file" + btn ).serialize();
		window.location.href = $( "#download_pdf_file" + btn ).attr( "action" ) + "&" + u;
		return false;
	}

</script>
</body>
<!-- END BODY -->
</html>