<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "manage_teachers" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$title = __("All Employees");
include_once( __DIR__ . "/header.php" );
$e = new Employess;
$E = $e->get_employess();
?>
<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->
	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						<?php _e("All Employees") ?>
						<small><?php _e("Manage employees data here") ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								<?php _e("Actions") ?>
							</span>
								<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="<?php echo Urls::get_url( "allemployees" ) ?>"><i class="fa fa-plus"></i> <?php _e("Course Material") ?></a>
								</li>
							</ul>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e("Home") ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#"><?php _e("All Employees") ?></a>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<div class="portlet-body">
						<table class="table table-striped table-bordered table-hover datatable">
							<thead>
							<tr>
								<th><?php _e("ID") ?></th>
								<th><?php _e("Name") ?></th>
								<th><?php _e("Cell") ?></th>
								<th><?php _e("Joining Date") ?></th>
							</tr>
							</thead>
							<tbody>
							<?php foreach ( $E as $row ): ?>
								<tr>
									<td><?php echo $row["id"] ?></td>
									<td>
										<a href="<?php echo Urls::get_url( "editemployees", 0, "id=" . $row["id"] ) ?>"><?php echo $row["name"] ?></a>
									</td>
									<td><?php echo $row["cell"] ?></td>
									<td><?php echo $row["date_of_joining"] ?></td>
								</tr>
							<?php endforeach; ?>
							</tbody>
						</table>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->
<?php include_once( __DIR__ . "/footer.php" ); ?>

</body>
<!-- END BODY -->
</html>