<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title = "Attendance Register";
include_once( __DIR__ . "/header.php" );
$b = new Batch();
$B = $b->get_active_batch();
?>

<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __( "Attendance" ) ?>
						<small><?php echo __( "This is attendance register" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb"
					<li>
						<i class="fa fa-home"></i>
						<a href="<?php echo DOMAIN_URL ?>"><?php echo __( "Home" ) ?></a>
						<i class="fa fa-angle-right"></i>
					</li>
					<li>
						<a href="#"><?php echo __( "Data" ) ?></a>
						<i class="fa fa-angle-right"></i>
					</li>
					<li>
						<a href="<?php echo Urls::get_url( "attendance" ) ?>">
							<?php echo __( "Attendance" ) ?>
						</a>
					</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<?php if ( sizeof( $_GET ) == "1" || sizeof( $_GET ) == "0" ) { ?>
						<form class="form-horizontal form-bordered" name="form1" id="form1">
							<div class="form-body">
								<div class="form-group F">
									<label class="control-label col-md-3"><?php echo __( "Attendance Date" ) ?></label>
									<div class="col-md-4">
										<input value="<?php echo date( $db->get_option( "date_format1" ) ) ?>" name="date" class="form-control input-xlarge date-picker" data-date-format="<?php echo \Dates::date_format1_for_js() ?>">
									</div>
								</div>
								<div class="form-group F">
									<label class="control-label col-md-3"><?php echo __( "Select Class" ) ?></label>
									<div class="col-md-4">
										<select name="class_id" class="form-control input-xlarge select2" onchange="CheckAttendance(this)">
											<option value="0">== <?php echo __( "Select Class" ) ?> ==</option>
											<?php
											$C   = new BatchClass();
											$Cls = $C->get_list();
											foreach ( $Cls as $Cl ):
												$_GET["class_id"] = isset( $_GET["class_id"] ) ? $_GET["class_id"] : 0;
												?>
												<option <?php echo $_GET["class_id"] == $Cl["id"] ? "selected=selected" : "" ?> value="<?php echo $Cl["id"] ?>">
													<?php echo $Cl["class_name"] ?> (<?php echo __( "%1 Students", $C->count_students( $Cl["id"] ) ); ?>)
												</option>
											<?php endforeach; ?>
										</select>
									</div>
								</div>
								<div class="form-group" style="display: none;" id="subDiv">
									<div class="col-md-offset-3 col-md-9">
										<div class="btn-group">
											<button type="submit" class="btn blue">
												<?php echo __( "Get Attendance Register" ) ?>
											</button>
											<a class="btn red" href="<?php Urls::get_url( "attendance" ) ?>">
												<?php _e( "Change Date" ) ?>
											</a>
										</div>
									</div>
								</div>
							</div>
						</form>
					<?php } else { ?>
						<?php if ( ! isset( $_GET["class_id"] ) ) {
							Urls::redirect( Urls::get_url( "attendance" ) );
						}
						if ( ! isset( $_GET["date"] ) ) {
							Urls::redirect( Urls::get_url( "attendance" ) );
						}
						$A                  = new \Attendance();
						$rows               = $A->get_attendance( [
							"date"            => $_GET["date"],
							"class_id"        => $_GET["class_id"],
							"batch_id"        => $B["id"],
							"ignore_subjects" => true,
						] );
						$_GET["subject_id"] = isset( $_GET["subject_id"] ) ? $_GET["subject_id"] : 0;
						?>
						<form onsubmit="return saveAttendance(this)">
							<input type="hidden" name="class_id" value="<?php echo $_GET["class_id"] ?>" />
							<input type="hidden" name="subject_id" value="<?php echo $_GET["subject_id"] ?>" />
							<input type="hidden" name="date" value="<?php echo $_GET["date"] ?>" />
							<input type="hidden" name="batch_id" value="<?php echo $B["id"] ?>" />
							<h3>Class: <?php echo $BatchClass->get_class_name( $_GET["class_id"] ) ?></h3>
							<h3>Attendance Date: <?php echo \Dates::my_date( $_GET["date"] ) ?></h3>
							<table class="table table-bordered table-hover">
								<thead>
								<tr>
									<th><?php echo __( "Student Name" ) ?></th>
									<th><?php echo __( "Attendance" ) ?></th>
								</tr>
								</thead>
								<?php foreach ( $rows as $row ):
									$attend = $row["attendance"] == "" ? "P" : $row["attendance"];
									if ( $attend == "A" ) {
										$class = "HighLight1";
									} elseif ( $attend == "L" ) {
										$class = "HighLight2";
									} else {
										$class = "";
									}
									?>
									<tr class="<?php echo $class ?>">
										<td style="text-align: right;font-weight:bold;">
											(<?php _e( 'Roll' ) ?>: <?php echo $row["roll"] ?>) -
											<?php echo $row["student_name"] ?>
										</td>
										<td>
											<input type="hidden" name="student_id[]" value="<?php echo $row["student_id"] ?>" />
											<div class="btn-group" data-toggle="buttons">
												<label class="btn blue <?php echo $attend == "P" ? "active" : "" ?>" style="cursor: pointer;"><input class="toggle BB" name="attendance[<?php echo $row["student_id"] ?>]" <?php echo $attend == "P" ? "checked=checked" : "" ?> type="radio" value="P"> <?php echo __( "Present" ) ?>
												</label>
												<label class="btn blue <?php echo $attend == "A" ? "active" : "" ?>" style="cursor: pointer;"><input class="toggle BB" name="attendance[<?php echo $row["student_id"] ?>]" <?php echo $attend == "A" ? "checked=checked" : "" ?> type="radio" value="A" /> <?php echo __( "Absent" ) ?>
												</label>
												<label class="btn blue <?php echo $attend == "L" ? "active" : "" ?>" style="cursor: pointer;"><input class="toggle BB" name="attendance[<?php echo $row["student_id"] ?>]" <?php echo $attend == "L" ? "checked=checked" : "" ?> type="radio" value="L"> <?php echo __( "Leave" ) ?>
												</label>
											</div>
										</td>
									</tr>
								<?php endforeach; ?>
								<?php if ( is_paid_fekara() ) { ?>
									<tr>
										<td>&nbsp;</td>
										<td>
											<label class="href">
												<input type="checkbox" name="smsBtn" value="1">
												<?php echo __( "Send an auto SMS to guardians of absent students" ) ?>
											</label>
										</td>
									</tr>
								<?php } ?>
								<tr>
									<td>&nbsp;</td>
									<td>
										<div class="btn-group">
											<button type="submit" class="btn btn-primary">
												<?php echo __( "Save Attendance" ) ?>
											</button>
											<a href="<?php echo Urls::get_url( "attendance" ) ?>" class="btn red">
												<?php echo __( "Do not save" ) ?>
											</a>
										</div>
									</td>
								</tr>
							</table>
						</form>
					<?php } ?>
				</div>
			</div>
		</div>
	</div>
</div>

<?php include_once( __DIR__ . "/footer.php" ); ?>
<script src="<?php echo ASSETS_URL ?>script_js/attendance.js?<?php echo md5_file( ASSETS_PATH . DIRECTORY_SEPARATOR . 'script_js' . DIRECTORY_SEPARATOR . 'attendance.js' ) ?>"></script>
</body>
</html>