<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "administrator" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
if ( $batch_id == 0 ) {
	$title = "Add new batch | " . System;
} else {
	$title = "Edit batch | " . System;
}
include_once( __DIR__ . "/header.php" );
if ( $batch_id == 0 ) {
	$batch = new Batch;
	$data  = array(
		"id"         => 0,
		"batch_name" => "",
		"active"     => 0,
		"start_date" => "",
		"end_date"   => ""
	);
}
?>

<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						<?php echo $batch_id == 0 ? "Add Batch <small>Add new batch</small>" : "Edit Batch <small>Edit batch details</small>" ?>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
								<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="#">Action</a>
								</li>
								<li>
									<a href="#">Another action</a>
								</li>
								<li>
									<a href="#">Something else here</a>
								</li>
								<li class="divider">
								</li>
								<li>
									<a href="#">Separated link</a>
								</li>
							</ul>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>">Home</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "batches" ) ?>">Batches</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php echo $batch_id == 0 ? "Adding Batch" : "Editing Batch" ?>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box green">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php echo $batch_id == 0 ? "Add Batch" : "Edit" ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form class="form-horizontal" onsubmit="return Save()" id="form1">
								<input type="hidden" name="id" value="<?php echo $batch_id ?>" />
								<div class="form-body">
									<div class="form-group">
										<label class="col-md-3 control-label">Batch Name</label>
										<div class="col-md-4">
											<input type="text" class="form-control" placeholder="Enter unique batch name" name="batch_name" required="required" value="<?php echo $data["batch_name"] ?>">
										</div>
									</div>
									<div class="form-group">
										<label class="col-md-3 control-label">Starting Date</label>
										<div class="col-md-4">
											<input type="text" data-date-format="<?php echo \Dates::date_format1_for_js() ?>" class="form-control form-control-inline date-picker" placeholder="Select session's starting date" name="start_date" required="required" value="<?php echo \Dates::my_date( $data["start_date"] ) ?>">
										</div>
									</div>
									<div class="form-group">
										<label class="col-md-3 control-label">Ending Date</label>
										<div class="col-md-4">
											<input type="text" data-date-format="<?php echo \Dates::date_format1_for_js() ?>" class="form-control form-control-inline date-picker" placeholder="Select session's ending date" name="end_date" required="required" value="<?php echo \Dates::my_date( $data["start_date"] ) ?>">
										</div>
									</div>
									<div class="form-group">
										<label class="col-md-3 control-label">Active Batch</label>
										<div class="col-md-4">
											<select class="form-control" name="active">
												<option value="0">No</option>
												<option value="1" <?php echo $data["active"] == "1" ? "selected=selected" : "" ?>>Yes</option>
											</select>
										</div>
									</div>
								</div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="submit" class="btn blue">Save Batch</button>
										<button type="button" class="btn default" onclick="Cancel()">Cancel</button>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="text/javascript">
	function Cancel() {
		bootbox.confirm( "Are you sure you want to cancel batch saving?", function( result ) {
			if ( result==true )window.location.href = "<?php echo Urls::get_url( "batches" ) ?>";
		} );
	}

	function Save() {
		Block();
		$.post( "<?php echo Urls::get_url( "ajax", 0, "action=saveBatch" ) ?>", $( "#form1" ).serialize(), function( data ) {
			if ( data=="OK" ) window.location.href = "<?php echo Urls::get_url( "batches" ) ?>";
			else {
				UnBlock();
				bootbox.alert( data );
			}
		} );
		return false;
	}
</script>
</body>
<!-- END BODY -->
</html>