<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title = "Classes in Batch - " . System;
include_once( __DIR__ . "/header.php" );
$b       = new BatchClass;
$classes = $b->get_list();
?>

<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">

			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						Classes in Batch
						<small>Manage classes batch <?php echo $b->get_active_batch_name() ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<a class="btn blue white" href="<?php echo Urls::get_url( "new_class" ) ?>"><i class="fa fa-plus"></i> Add Class</a>
							<!--<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
							<i class="fa fa-angle-down"></i>
							</button>-->
							<!--<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="<?php /*echo $url->get_url("new_class") */ ?>">Add Class</a>
								</li>
								<li>
									<a href="#">Another action</a>
								</li>
								<li>
									<a href="#">Something else here</a>
								</li>
								<li class="divider">
								</li>
								<li>
									<a href="#">Separated link</a>
								</li>
							</ul>-->
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>">Home</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#">Data</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "batch_classes" ) ?>">Classes in Batch <?php echo $b->get_active_batch_name() ?></a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">

					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-user"></i> Classes in batch <?php echo $b->get_active_batch_name() ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
							</div>
						</div>
						<div class="portlet-body">
							<!--div class="table-toolbar">
								<div class="btn-group">
									<a href="<?php echo Urls::get_url( "new_class" ) ?>" class="btn green"><i class="fa fa-plus"></i> Add Class</a>
								</div>
								<div class="btn-group pull-right">
									<button class="btn dropdown-toggle" data-toggle="dropdown">Tools <i class="fa fa-angle-down"></i>
									</button>
									<ul class="dropdown-menu pull-right">
										<li>
											<a href="#">Print</a>
										</li>
										<li>
											<a href="#">Save as PDF</a>
										</li>
										<li>
											<a href="#">Export to Excel</a>
										</li>
									</ul>
								</div>
							</div-->
							<?php $batch = $b->get_active_batch(); ?>
							<h2>Current Batch: <?php echo $batch["batch_name"]; ?></h2>
							<hr />
							<table class="table table-striped table-bordered table-hover datatable">
								<thead>
								<tr>
									<th>ID</th>
									<th>Class</th>
									<th>Tution Fee</th>
									<th>Active</th>
									<th>Students</th>
									<th>Subjects</th>
								</tr>
								</thead>
								<tbody>
								<?php
								foreach ( $classes as $row ): ?>
									<tr class="odd gradeX">
										<td><?php echo $row["id"] ?></td>
										<td>
											<a href="<?php echo Urls::get_url( "batchclass", $row["id"] ) ?>"><?php echo $row["class_name"] ?></a>
										</td>
										<td><?php echo App::set_currency( $row["fee"] ) ?></td>
										<td><?php echo \Str::yesno( $row["active"] ) ?></td>
										<td>
											<a href="<?php echo Urls::get_url( "students", 0, "class_id=" . $row["id"] ) ?>"><?php echo $db->get_var( "SELECT COUNT(*) FROM `students` WHERE `deleted`=0 AND `class_id`=" . $row["id"] ) ?></a>
										</td>
										<td><?php echo $row["subjects_count"] ?></td>
									</tr>
								<?php endforeach; ?>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>

			<?php run_cron() ?>

			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>
<script type="text/javascript">

</script>
</body>
<!-- END BODY -->
</html>