<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "administrator" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$title = "Batches - " . System;
include_once( __DIR__ . "/header.php" );
$b       = new Batch;
$batches = $b->get_list();
?>
<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<div class="modal fade" id="modal1" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
		<div class="modal-dialog">
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
					<h4 class="modal-title"><?php _e("Save Batch") ?></h4>
				</div>
				<div class="modal-body">
					<form class="form-horizontal" id="form1">
						<input type="submit" class="hidden" id="submit1">
						<input type="reset" class="hidden" id="reset1">
						<input type="hidden" name="id" value="0" id="id">
						<div class="form-body">
							<div class="form-group">
								<label class="col-md-3 control-label">Batch Name</label>
								<div class="col-md-9">
									<input type="text" class="form-control" placeholder="<?php _e("Enter unique batch name") ?>" name="batch_name" id="batch_name" required="required">
								</div>
							</div>
							<div class="form-group">
								<label class="col-md-3 control-label"><?php _e("Starting Date") ?></label>
								<div class="col-md-9">
									<input id="start_date" type="text" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>" class="form-control form-control-inline date-picker" placeholder="<?php _e("Select session's starting date") ?>" name="start_date" required="required">
								</div>
							</div>
							<div class="form-group">
								<label class="col-md-3 control-label"><?php _e("Ending Date") ?></label>
								<div class="col-md-9">
									<input id="end_date" type="text" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>" class="form-control form-control-inline date-picker" placeholder="<?php _e("Select session's ending date") ?>" name="end_date" required="required">
								</div>
							</div>
							<div class="form-group">
								<label class="col-md-3 control-label"><?php _e("Active Batch") ?></label>
								<div class="col-md-9">
									<select class="form-control" name="active" id="active">
										<option value="0"><?php _e("No") ?></option>
										<option value="1"><?php _e("Yes") ?></option>
									</select>
								</div>
							</div>
						</div>
					</form>
				</div>
				<div class="modal-footer">
					<div class="btn-group">
						<button type="button" class="btn default" data-dismiss="modal"><?php _e("Close") ?></button>
						<button type="button" class="btn btn-primary" onclick="$('#submit1').click();"><?php _e("Save Batch") ?></button>
					</div>
				</div>
			</div>
		</div>
	</div>

	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( "Batches/Years/Sessions" ) ?>
						<small><?php _e( "Manage batches or years of school" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>">
								<?php _e( "Home" ) ?>
							</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php _e( "Settings" ) ?>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="batches.php">
								<?php _e( 'Batches/Years/Sessions' ) ?>
							</a>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<div class="alert alert-block alert-warning fade in">
						<button type="button" class="close" data-dismiss="alert"></button>
						<h4 class="alert-heading"><?php _e("Warning!") ?></h4>
						<p>
							<?php _e("Only one batch can be active one time. All students and classes functions will perform for active batch.") ?>
						</p>
					</div>
					<?php if ( isset( $_GET['error'] ) ) { ?>
						<div class="alert alert-danger fade in alert-block">
							<button type="button" class="close" data-dismiss="alert"></button>
							<h1><?php _e("No Session/Academic year added yet.") ?></h1>
							<p>
								<b><?php _e("At least 1 session/year must be added and active. Please insert new batch for your institute.") ?></b><br><br>
								<?php _e("Without adding at least 1 batch, FeKara system will not work.") ?></p>
						</div>
					<?php } ?>
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-user"></i> <?php _e("Batches") ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<!--a href="#portlet-config" data-toggle="modal" class="config"></a>
								<a href="javascript:;" class="reload"></a>
								<a href="javascript:;" class="remove"></a-->
							</div>
						</div>
						<div class="portlet-body">
							<div class="table-toolbar">
								<div class="btn-group">
									<!--a class="btn green" href="modal-data.php" data-target="#ajax" data-toggle="modal"-->
									<button type="button" class="btn green btn add">
										<i class="fa fa-plus"></i> <?php _e("Add Session") ?>
									</button>
									<!--a class="tooltips" href="javascript:void()" data-target="#ajax" data-toggle="modal" title="Edit Subject"><i class="fa fa-edit"></i> </a-->
									<!--/a-->
								</div>
								<div class="btn-group pull-right">
									<button class="btn dropdown-toggle" data-toggle="dropdown">
										<?php _e("Tools") ?>
										<i class="fa fa-angle-down"></i>
									</button>
									<ul class="dropdown-menu pull-right">
										<li>
											<a href="#" class="add"><?php _e("Add Session") ?></a>
										</li>
									</ul>
								</div>
							</div>
							<table class="table table-striped table-bordered table-hover datatable">
								<thead>
								<tr>
									<th><?php _e("ID") ?></th>
									<th><?php _e("Batch Name") ?></th>
									<th><?php _e("Session Dates") ?></th>
									<th><?php _e("Students") ?></th>
									<th><?php _e("Active") ?></th>
									<th><?php _e("Classes") ?></th>
									<th><?php _e("History") ?></th>
								</tr>
								</thead>
								<tbody>
								<?php
								foreach ( $batches as $row ): ?>
									<tr class="odd gradeX">
										<td><?php echo $row["id"] ?></td>
										<td>
											<a data-id="<?php echo $row["id"] ?>" class="edit" href="#"><?php echo $row["batch_name"] ?></a>
										</td>
										<td><?php echo \Dates::my_date( $row["start_date"] ) ?> &gt; <?php echo \Dates::my_date( $row["end_date"] ) ?></td>
										<td><?php echo $b->count_students( "batch=" . $row["id"] ) ?></td>
										<td><?php echo \Str::yesno( $row["active"] ) ?></td>
										<td><?php echo $row["classes_count"] ?></td>
										<td><a href="<?php echo Urls::get_url( "history" ); ?>"><?php _e("History") ?></a></td>
									</tr>
								<?php endforeach; ?>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>
<script>
	$( function() {
		$( document ).on( "click", ".add", function( e ) {
			e.preventDefault();
			$( "#reset1" ).click();
			$( "#modal1" ).modal( 'show' );
		} );

		$( document ).on( "submit", "#form1", function( e ) {
			e.preventDefault();
			//alert ($("#form1").serialize()); return;
			$( "#modal1" ).modal( 'hide' );
			Block();
			$.post( "<?php echo DOMAIN_URL ?>includes/ajax.php?action=saveBatch", $( "#form1" ).serialize(), function( data ) {
				if ( data=="OK" ) {
					Success( "<?php _e("Batch saved successfully!") ?>" );
					window.location.href = "<?php echo Urls::get_url( "batches" ); ?>";
				} else {
					UnBlock();
					Error( data );
					$( "#modal1" ).modal( 'show' );
				}
			} );

			return false;
		} );

		$( document ).on( "click", ".edit", function( e ) {
			e.preventDefault();
			id = $( this ).data( 'id' );
			Block();
			$.post( "<?php echo Urls::get_url( "ajax", 0, "action=getBatch" ) ?>", { id: id }, function( data ) {
				UnBlock();
				if ( is_json( data ) ) {
					data = JSON.parse( data );
					$( "#id" ).val( data.id );
					$( "#batch_name" ).val( data.batch_name );
					$( "#start_date" ).val( data.start_date );
					$( "#end_date" ).val( data.end_date );
					$( "#active" ).val( data.active );
					$( "#modal1" ).modal( 'show' );
				} else {
					Error( "<?php _e("Can't get data.") ?>" );
				}
			} );
		} );
	} )
</script>
</body>
</html>