<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "administrator" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
if ( isset( $_GET["add_subject"] ) ) {
	$Subject = new Subject();
	echo $Subject->save( $_POST );
	exit;
}
if ( isset( $_GET["saveClass"] ) ) {
	$Classes = new BatchClass();
	echo $Classes->save_batchclass( $_POST );
	exit;
}
$c = new BatchClass();
if ( isset( $_GET["get_list"] ) ) {
	header( "Content-Type: application/json" );
	echo json_encode( $c->get_list( $_POST ) );
	exit;
}

$title = "Classes | " . System;
include_once( __DIR__ . "/header.php" );


$class   = $c->get_list( $_GET );
$Subject = new Subject;

$s = new Sessions();
$S = $s->get_list();
// get active batech
$b = new Batch();
$B = $b->get_all_batches();

$active_batch_id = $b->get_active_batch_id();
if ( ! isset( $_GET["batch_id"] ) ) {
	$_GET["batch_id"] = $active_batch_id;
}
include_once( LIBRARY_PATH . "templates/panel/classes.tpl" );
?>

<script>
	var Data = <?php echo json_encode( $class ); ?>;
</script>

<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN SAMPLE PORTLET CONFIGURATION MODAL FORM-->

			<!-- END STYLE CUSTOMIZER -->
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						<?php echo __( "Classes" ) ?>
						<small><?php echo __( "Manage classes" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php _e('Settings') ?>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "classes" ) ?>">
								<?php echo __( "Classes" ) ?>
							</a>
						</li>
						<li id="loading_div" class="hidden"><i class="fa fa-spin fa-spinner"></i> Loading Data ...</li>
					</ul>
				</div>
			</div>

			<?php if ( isset( $_GET["error"] ) ) { ?>
				<div class="alert alert-danger" id="error1">
					<h2><?php _e( "No class added yet!" ) ?></h2>
					<p>
						<?php _e( "Please add classes before using FeKara." ) ?>
					</p>
				</div>
			<?php } ?>

			<div class="row">
				<div class="col-md-12">
					<div class="btn-group margin-bottom-10">
						<!--a class="btn green" href="modal-data.php" data-target="#ajax" data-toggle="modal"-->
						<button title="{Ctrl+A} for add class" id="sample_editable_1_new" class="btn green tooltips">
							<i class="fa fa-plus"></i> <?php echo __( "Add New Class" ) ?>
						</button>
						&nbsp;
						<select style="padding:5px" id="batch_id2">
							<?php
							foreach ( $B as $bb ) {
								$S = "";
								if ( ! empty( $_GET["batch_id"] ) && $_GET["batch_id"] == $bb["id"] ) {
									$S = "selected=selected";
								}
								?>
								<option value="<?php echo $bb["id"] ?>" <?php echo $S ?>>
									ID: <?php echo $bb["id"] ?> =
									<?php echo $bb["batch_name"] ?> =
									(<?php echo $b->count_students( "student_active=1&batch=" . $bb["id"] ) ?> Students)
									&nbsp;(<?php echo $b->count_classes( $bb["id"] ) ?> Classes)
									<?php if ( $active_batch_id == $bb["id"] ) {
										echo " ** Active **";
									} ?>
								</option>
							<?php } ?>
						</select>
					</div>

					<div class="table-toolbar">
						Total Records:
						<span id="counter" class="bold"><i class="fa fa-spin fa-spinner"></i></span>
					</div>
					<table class="table table-striped table-bordered table-hover">
						<thead>
						<tr class="heading">
							<th style="width: 30px;" class="nosort">
								<input type="checkbox" id="check">
							</th>
							<th>Name</th>
							<th>Subjects</th>
						</tr>
						</thead>
						<tbody id="tbody1"></tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>

<?php include_once( __DIR__ . "/footer.php" ); ?>

<div class="modal fade" id="class-modal" role="dialog" aria-hidden="true">
	<div class="modal-dialog">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
				<h4 class="modal-title">Class</h4>
			</div>
			<div class="modal-body">
				<form name="form1" id="form1" onsubmit="return Save()" class="form1 horizontal-form">
					<input type="submit" id="form1submit" style="display:none">
					<input type="hidden" name="id" id="id" value="0">

					<div class="form-body">
						<div class="row">
							<div class="col-md-6">
								<div class="form-group">
									<label class="control-label"><?php echo __( "Type class name" ) ?></label>
									<input class="form-control" title="Class Name" type="text" name="class_name" id="class_name" placeholder="Class Name">
								</div>
							</div>
							<div class="col-md-6">
								<div class="form-group">
									<label class="control-label"><?php echo __( "Select Batch" ) ?></label><br>
									<select class="select2 form-control" name="batch_id" id="batch_id"
									        data-placeholder="<?php echo __( "Select one or more batches" ) ?>">
										<?php foreach ( $B as $c ) { ?>
											<option value="<?php echo $c["id"] ?>">
												<?php echo $c["batch_name"] ?>
												<?php echo ( $c["id"] == $active_batch_id ) ? " - **Active**" : ""; ?>
											</option>
										<?php } ?>
									</select>
								</div>
							</div>
						</div>
						<div class="row">
							<div class="col-md-12">
								<div class="form-group">
									<label class="control-label">
										<?php echo __( "Select Subject" ) ?>
										<a id="add_subject_id" class="btn btn-xs btn-primary" href="#">
											<small><i class="fa fa-plus"></i> Add Subject</small>
										</a>
									</label>
									<select class="select2 form-control" multiple="multiple" name="subjects[]" id="subjects"
									        data-placeholder="<?php echo __( "Select one or more subjects" ) ?>">
										<?php $subjects = $Subject->get_list();
										foreach ( $subjects as $sub ) {
											echo "<option value='{$sub["id"]}'>{$sub["subject"]}</option>\n";
										} ?>
									</select>
								</div>
							</div>
						</div>
						<div class="row">
							<div class="col-md-12">
								<div class="form-group">
									<label class="control-label">
										<?php echo __( "Active" ) ?>
									</label>
									<select name="active" id="active" class="form-control">
										<option value="1"><?php echo __( "Yes" ) ?></option>
										<option value="0"><?php echo __( "No" ) ?></option>
									</select>
								</div>
							</div>
						</div>
					</div>

					<!--<input type="hidden" name="batchid" id="current_batchid" value="<?php /*echo $batch["id"] */ ?>" />-->

					<!--                    <label for="description">Select Session</label><br />-->
					<!--                    <select class="select2 form-control" multiple="multiple" name="sessions[]" id="sessions">-->
					<!--                        <option value=""></option>-->
					<!--                        --><?php //foreach($S as $r) : ?>
					<!--                            <option value="--><?php //echo $r["id"]?><!--">--><?php //echo $r["session_name"]?><!--</option>-->
					<!--                        --><?php //endforeach;?>
					<!--                    </select><br />-->

					<!--<label for="description">Description</label><br />
					<textarea class="col-md-12 form-control" title="Class Name" name="description" id="description" placeholder="Description"></textarea>-->

				</form>
			</div>
			<div class="modal-footer">
				<div class="btn-group">
					<button type="button" class="btn default" data-dismiss="modal"><?php _e( "Cancel" ) ?></button>
					<button type="button" class="btn blue" onclick="SubmitForm1()"><?php _e( "Save Changes" ) ?></button>
				</div>
			</div>
		</div>
		<!-- /.modal-content -->
	</div>
	<!-- /.modal-dialog -->
</div>

<script>
	function load_data() {
		$( "#loading_div" ).removeClass( "hidden" );
		$.post( "?get_list", function( data ) {
			Data = data;
			make_html();
		} );
	}

	function Add( event ) {
		event.preventDefault();
		load_data();

		$( "#form1" ).trigger( "reset" );
		$( "#id" ).val( 0 );
		$( "#name" ).val( "" );

		$( "#batch_id" ).select2( "val", "<?php echo $_GET["batch_id"]; ?>" );

		$( ".selectitems > label > input[type=checkbox]" ).removeAttr( "checked" );
		$( ".selectitems label" ).removeClass( "selectedClass" );
		//$(".toggle")
		$( "#class-modal .modal-title" ).html( "Add Class" );
		$( "#class-modal" ).modal( "show" );
		$( "#subjects" ).select2( 'val', '' );
		$( "#class" ).select();
	}

	function Save() {
		if ( $( "#name" ).val()=="" ) {
			alert( "<?php echo __( "Class name missing" ) ?>" );
			$( "#name" ).select();
			return false;
		}

		$( "#class-modal" ).modal( "hide" );
		$( "#loading_div" ).removeClass( "hidden" );

		$.post( "<?php echo Urls::get_url( "classes", 0, "saveClass" ) ?>", $( "#form1" ).serialize(), function( data ) {
			if ( data.substr( 0, 2 )=="OK" ) {
				Success( "Class added new batch successfully!" );
				//window.location.href = "<?php echo Urls::get_url( "classes", 0, "batch_id=" . $_GET["batch_id"] ) ?>";
				load_data();
			} else {
				Error( data );
			}
		} );

		return false;
	}

	function SubmitForm1() {
		$( '#form1submit' ).click();
	}

	$( function() {
		make_html();
		$( document ).on( "click", "#sample_editable_1_new", Add );
		$( document ).on( "click", ".Edit", function( e ) {
			e.preventDefault();
			var id = $( this ).attr( 'data-editid' );

			$.each( Data, function( k, row ) {
				if ( id==row.id ) {
					$( "#id" ).val( id );
					$( "#class_name" ).val( row.class_name );
					$( "#batch_id" ).select2( "val", row.batch_id );
					$( "#active" ).val( row.active );
					$( "#subjects" ).select2( "destroy" );
					ar = Object.keys( row.subjects ).map( function( key ) {
						return key;
					} );
					$( "#subjects" ).val( ar );
					$( "#subjects" ).select2();

					$( "#class-modal .modal-title" ).html( "Edit class" );
					$( "#class-modal" ).modal( "show" );
				}
			} );

			return;
			Block();
			$.post( "<?php echo DOMAIN_URL ?>includes/ajax.php?action=getClass", { id: id },
				function( data ) {
					UnBlock();
					if ( is_json( data ) ) {
						data = JSON.parse( data );

						if ( data.status!="OK" ) {
							bootbox.alert( "Unable to get class data" );
							Error( "Unable to get class data" );
						} else {
							$( "#id" ).val( id );
							$( "#name" ).val( data.class_name );
							//$( "#description" ).val( data.description );

							$( "#batch_id" ).select2( "destroy" );
							$( "#batch_id" ).val( data.batch_id );
							$( "#batch_id" ).select2();
							$( "#save_active" ).val( data.active );

							//                        $("#sessions").select2("val",'');
							//                        var selectedItems = $("#sessions").select2("val");
							//                        $.each(data.sessions_classes,function(k,v){
							//                            selectedItems.push(v);
							//                            $("#sessions").select2("val", selectedItems);
							//                        });

							$( "#subjects" ).select2( "val", '' );
							var selectedItems = $( "#subjects" ).select2( "val" );
							$.each( data.subjects, function( k, v ) {
								selectedItems.push( v );
								$( "#subjects" ).select2( "val", selectedItems );
							} );

							$( "#class-modal .modal-title" ).html( "Edit class" );
							$( "#class-modal" ).modal( "show" );
							$( "#class" ).select();
						}
					} else {
						Error( "Can't get data. " + data );
					}
					return false;
				}
			);
		} );

		$( document ).on( "click", ".removeclass", function( e ) {
			e.preventDefault();

			if ( !confirm( "Are you sure you want to delete/remove this class?" ) ) {
				return;
			}

			Block();
			var id = $( this ).data( "delid" );
			$.post( '<?php echo DOMAIN_URL ?>includes/ajax.php?action=delClass', { id: id }, function( data ) {
				if ( data=="OK" ) {
					Success( "Class removed successfully!" );
					window.location.reload();
				} else {
					UnBlock();
					Error( data );
				}
			} );
			return;
		} );

		$( "#name" ).keypress( function( e ) {
			if ( e.which=="13" ) {
				SubmitForm1();
			}
		} );

		$( document ).bind( "keydown", "Ctrl+A", function() {
			$( "#sample_editable_1_new" ).click();
			return false;
		} );

		$( document ).on( "change", "#batch_id2", function( event ) {
			event.preventDefault();

			window.location.href = "<?php echo Urls::get_url( "classes", 0, "batch_id=" ) ?>" + $( this ).val();
		} );

		$( document ).on( "click", "#add_subject_id", function( event ) {
			event.preventDefault();

			var new_subject = window.prompt( "<?php echo __( "Type new subject" ) ?>" );
			if ( new_subject ) {
				$.post( "<?php echo Urls::get_url( "classes", 0, "add_subject" ) ?>", { subject: new_subject }, function( data ) {
					if ( data.substr( 0, 2 )=="OK" ) {
						newID = data.substr( 2 );

						$( "#subjects" ).select2( "destroy" );
						$( "#subjects" ).append( "<option selected='selected' value='" + newID + "'>" + new_subject + "</option>" );
						$( "#subjects" ).select2();
						//$( '#subjects' ).trigger( 'change' );
						//$("#subjects").select2('data', {id: newID, text: new_subject});
					}
				} );
			}
		} );
	} );

	function make_html() {
		$( "#counter" ).text( Data.length );
		$( "#tbody1" ).html( tmpl( "tbody_template", Data ) );
		$( ".check" ).uniform();
		$( "#loading_div" ).addClass( "hidden" );
	}
</script>

</body>
<!-- END BODY -->
</html>