<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "manage_teachers" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$title = __( "Course Material" );
include_once( __DIR__ . "/header.php" );
// get subject
$s = new Subject;
// get all classes
$c = new BatchClass();
if ( ! isset( $id ) ) {
	$id = 0;
}
?>
<style type="text/css">
	#multipleuploadfile {
		height: 35px;
		padding-bottom: 42px;
	}
</style>
<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __("Course Material") ?>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php echo __("Home") ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "course_material" ) ?>">
								<?php echo __("Course Material") ?>
							</a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<?php echo __("Add Course Material") ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form id="addCourse" class="form-horizontal form-bordered check_save">
								<input type="hidden" name="id" value="<?php echo $id ?>">
								<div class="form-body">

									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __("Select Class") ?></label>
										<div class="col-md-9">
											<select class="form-control select2" id="classes" name="classes[]" multiple="multiple" required="required">
												<?php $rows = $c->get_list("batch_id=0");
												foreach ( $rows as $row ): ?>
													<option value="<?php echo $row["id"] ?>">
														ID: <?php echo add_leading_zeros($row["id"], 3) ?> -
														<?php echo $row["class_name"] ?>
													</option>
												<?php endforeach; ?>
											</select>
										</div>
									</div>

									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __("Select Subject") ?></label>
										<div class="col-md-9">
											<select class="form-control select2" id="subjects" name="subjects[]" multiple="multiple">
												<?php $rows = $s->get_list();
												foreach ( $rows as $row ): ?>
													<option value="<?php echo $row["id"] ?>"><?php echo $row["subject"] ?></option>
												<?php endforeach; ?>
											</select>

										</div>
									</div>

									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __("Course Name") ?></label>
										<div class="col-md-9">
											<input value="" type="text" name="name" required="required"
											       title="Name" class="form-control">
										</div>
									</div>

									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __("Description") ?></label>
										<div class="col-md-9">
                                            <textarea name="description" rows="5" required="required" title="Description" class="form-control"></textarea>
										</div>
									</div>

									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __("Select File(s)") ?></label>
										<div class="col-md-9">
											<input id="multipleuploadfile" type="file" name="uploadfile[]"
											       title="Upload File" class="form-control" accept="application/msword,application/vnd.ms-excel,text/plain,application/pdf,image/*" multiple="multiple">
										</div>
									</div>

								</div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<div class="btn-group">
											<button type="submit" class="btn btn-primary"><?php echo __( "Save" ) ?></button>
											<a href="course_material_list.php"
											   class="btn default"><?php echo __( "Cancel" ) ?>
											</a>
										</div>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>
<script>
	var SuccessMessage = "<?php _e("Course Material saved successfully!") ?>";
</script>
<script src="<?php echo \Theme::url() ?>js/course_material.js?<?php echo md5_file( \Theme::path()."js/course_material.js" ) ?>"></script>
</body>
</html>