<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "manage_teachers" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
if ( ! isset( $_GET["id"] ) ) {
	$_GET["id"] = 0;
}
$id = (int) $_GET["id"];
if ( $db->get_var( "SELECT COUNT(*) FROM `course_material` WHERE `id`=$id" ) == 0 ) {
	Urls::redirect( Urls::get_url( "course_material_list" ) );
}
$title = "Edit Course Material";
include_once( __DIR__ . "/header.php" );
$CM  = new CourseMaterial;
$CMD = $CM->get_cmData( $id );

## get subject
$s = new Subject;

## get all classes
$c    = new BatchClass();
$rows = $c->get_list( "batch_id=0" );
?>
<style type="text/css">
	#multipleuploadfile {
		height: 35px;
		padding-bottom: 42px;
	}
</style>
<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( "Edit Course Material" ) ?>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="course_material_list.php">
								<?php _e( "Course Material List" ) ?>
							</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="javascript:void(0);">
								<?php _e( "Edit Course Material" ) ?>
							</a>
							<i class="fa fa-angle-right"></i>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-edit"></i> <?php _e( "Edit Course Material" ) ?>
							</div>
						</div>
						<div class="portlet-body form">
							<form id="addCourse" class="form-horizontal form-bordered check_save">
								<input type="hidden" name="id" value="<?php echo $id ?>">
								<div class="form-body">
									<?php
									if ( $CMD['classes'] ) {
										$classesValue = explode( ',', $CMD['classes'] );
									} else {
										$classesValue = [];
									}
									?>
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e( "Select Class" ) ?></label>
										<div class="col-md-9">
											<select class="form-control select2" name="classes[]" multiple="multiple" required="required">
												<?php
												$rows = $c->get_list();
												foreach ( $rows as $row ) { ?>
													<option value="<?php echo $row["id"] ?>"
														<?php if ( count( $classesValue ) > 0 && in_array( $row["id"], $classesValue ) ) { ?> selected <?php } ?>
													><?php echo $row["class_name"] ?></option>
												<?php } ?>
											</select>
										</div>
									</div>
									<?php
									if ( $CMD['subjects'] ) {
										$subjectsValue = explode( ',', $CMD['subjects'] );
									} else {
										$subjectsValue = [];
									}
									?>
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e( "Select Subject" ) ?></label>
										<div class="col-md-9">
											<select class="form-control select2" name="subjects[]" multiple="multiple">
												<?php $rows = $s->get_list();
												foreach ( $rows as $row ): ?>
													<option value="<?php echo $row["id"] ?>"
														<?php if ( count( $subjectsValue ) > 0 && in_array( $row["id"], $subjectsValue ) ) { ?> selected <?php } ?>
													><?php echo $row["subject"] ?></option>
												<?php endforeach; ?>
											</select>
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e( "Course Name" ) ?></label>
										<div class="col-md-9">
											<input value="<?php echo $CMD['name']; ?>" type="text" name="name" required="required"
											       title="<?php _e( "Course Name" ) ?>" class="form-control">
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e( "Description" ) ?></label>
										<div class="col-md-9">
                                            <textarea name="description" title="Description" required="required" rows="5 "
                                                      class="form-control"><?php echo $CMD['description']; ?></textarea>
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e( "Assigned Files" ) ?></label>
										<div class="col-md-9 file-ext">
											<?php
											$allname    = $CMD['uploadfile'];
											$path_parts = pathinfo( ROOT_PATH . "/fekara/contents/courses/" . $id . "/" );
											$files_name = explode( '@', $CMD['uploadfile'] );
											$files_name = array_filter( $files_name );
											$files_name = array_slice( $files_name, 0 );
											if ( ! empty( $files_name ) ) {
												foreach ( $files_name as $i => $file ) {
													echo "<div>";
													echo "<a href='" . DOMAIN_URL . "includes/downloader.php?path=courses/{$id}/{$file}' target='_blank'>" . $file . '</a>';
													echo " <i class='btn btn-xs red fa fa-trash file_remove href' data-id='{$id}' data-name='{$file}' data-path='" . DOMAIN_URL . "contents/courses/{$id}/{$file}' data-allfile='{$allname}'></i>";
													echo "</div>";
												}
											} else {
												echo '<div>' . __( "No file found." ) . '</div>';
											}
											?>
										</div>
									</div>

									<div class="form-group">
										<label class="control-label col-md-3"><?php _e( "Select File(s)" ) ?></label>
										<div class="col-md-9">
											<input id="multipleuploadfile" type="file" name="uploadfile[]"
											       title="Upload File" class="form-control"
											       accept="application/msword,application/vnd.ms-excel,text/plain,application/pdf,image/*"
											       multiple="multiple">
										</div>
									</div>

								</div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<div class="btn-group">
											<button type="submit" class="btn blue"><?php _e( "Save" ) ?></button>
											<a href="course_material_list.php" class="btn default" id="cancel_btn">
												<?php _e( "Cancel" ) ?>
											</a>
											<button id="del_btn" class="btn red" type="button">
												<i class="fa fa-trash"></i> <?php _e( "Delete" ) ?></button>
										</div>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>
<script>
	function Save( event ) {
		event.preventDefault();
		Block();
		var form = document.getElementById( "addCourse" );
		var formData = new FormData( form );
		$.ajax( {
			url: root_url + 'includes/ajax.php?action=saveUploadMaterial',
			type: 'POST',
			xhr: function() {
				var myXhr = $.ajaxSettings.xhr();
				return myXhr;
			},
			success: function( data ) {
				if ( data=="OK" ) {
					$( 'form.check_save' ).areYouSure( { 'silent': true } );
					Success( "<?php _e( "Course Material saved successfully!" ) ?>" );
					window.location.href = "course_material_list.php";
				} else {
					UnBlock();
					Error( data );
				}
			},
			error: function( data ) {
				Error( data );
			},
			data: formData,
			cache: false,
			contentType: false,
			processData: false
		} );
		return false;
	}

	$( function() {
		$( document ).on( "submit", "#addCourse", Save )
		$( document ).on( "click", ".file_remove", function( e ) {
			Block();
			var $this = $( this );
			e.preventDefault();
			var filename = $( this ).data( "name" );
			var id = $( this ).data( "id" );
			var path = $( this ).data( "path" );
			var allfile = $( this ).data( "allfile" );
			$.post( '<?php echo Urls::get_url( "ajax", 0, "action=CourseMaterialFileDelete" ) ?>', {
				filename: filename,
				id: id,
				path: path,
				allfile: allfile
			}, function( data ) {
				if ( data=="OK" ) {
					UnBlock();
					$this.parent().fadeOut( "slow", function() {
						$( this ).remove();
					} );
				}
			} );
		} );
		$( document ).on( "click", "#del_btn", function() {
			if ( !confirm( "Are you sure you want to delete this course material?" ) ) {
				return false;
			}

			Block();
			$.post( "ajax/course_material_edit.php?del", { id:<?php echo $id ?> }, function( data ) {
				if ( data=="OK" ) {
					window.location.href = "course_material_list.php";
				} else {
					UnBlock();
					Error( data );
				}
			} );
		} );
	} );
</script>
</body>
</html>