<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "manage_teachers" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$title = "Course Material List";
include_once( __DIR__ . "/header.php" );
include_once( LIBRARY_PATH . "templates/panel/course_material_list.tpl" );
$s = new Subject();
$c = new BatchClass();
$T = new Teacher();
?>

<div class="modal fade" id="course_modal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-keyboard="false" data-backdrop="static">
	<div class="modal-dialog modal-wide">
		<div class="modal-content">
			<div class="modal-header">
				<!--<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>-->
				<h4 class="modal-title">
					<?php _e( "Save Course Material" ) ?>
				</h4>
			</div>
			<div class="modal-body">
				<form id="course_form" class="horizontal-form" method="post" action="ajax/course_material_list.php?save" enctype="multipart/form-data">
					<input type="hidden" name="id" value="0" id="id">
					<div class="form-body">
						<div class="row">
							<div class="col-md-6">
								<div class="form-group">
									<label class="control-label"><?php echo __( "Course Name" ) ?></label>
									<input type="text" name="name" required="required"
									       placeholder="<?php _e( "Course name" ) ?>" title="<?php _e( "Type course name" ) ?>"
									       class="form-control">
								</div>
							</div>
							<div class="col-md-6">
								<div class="form-group">
									<label class="control-label"><?php echo __( "Select Teachers" ) ?></label>
									<select class="form-control select2" id="teachers" name="teachers[]" multiple="multiple"
									        required="required" title="<?php _e( "Select one or more teacher" ) ?>"
									        data-placeholder="<?php _e( "Select one or more teacher" ) ?>">
										<?php $rows = $db->get_rows( "SELECT `id`,`name` FROM `teachers` WHERE 1 ORDER BY `name`" );
										foreach ( $rows as $row ): ?>
											<option value="<?php echo $row["id"] ?>">
												ID: <?php echo add_leading_zeros( $row["id"], 3 ) ?> -
												<?php echo $row["name"] ?>
											</option>
										<?php endforeach; ?>
									</select>
								</div>
							</div>
						</div>
						<div class="row">
							<div class="col-md-6">
								<div class="form-group">
									<label class="control-label"><?php echo __( "Select Class" ) ?></label>
									<select class="form-control select2" id="classes" name="classes[]" multiple="multiple"
									        required="required" title="<?php _e( "Select one or more class" ) ?>"
									        data-placeholder="<?php _e( "Select one or more class" ) ?>">
										<?php $rows = $c->get_list( "batch_id=0" );
										foreach ( $rows as $row ): ?>
											<option value="<?php echo $row["id"] ?>">
												ID: <?php echo add_leading_zeros( $row["id"], 3 ) ?> -
												<?php echo $row["class_name"] ?>
											</option>
										<?php endforeach; ?>
									</select>
								</div>
							</div>
							<div class="col-md-6">
								<div class="form-group">
									<label class="control-label"><?php echo __( "Select subjects" ) ?></label>
									<select class="form-control select2" id="subjects" name="subjects[]" multiple="multiple"
									        data-placeholder="<?php _e( "Select one or more subjects" ) ?>">
										<?php $rows = $s->get_list();
										foreach ( $rows as $row ): ?>
											<option value="<?php echo $row["id"] ?>"><?php echo $row["subject"] ?></option>
										<?php endforeach; ?>
									</select>
								</div>
							</div>
						</div>
						<div class="row">
							<div class="col-md-12">
								<label class="control-label"><?php echo __( "Description" ) ?></label>
								<textarea name="description" rows="5" required="required" title="<?php _e( "Course description" ) ?>"
								          placeholder="<?php _e( "Course description" ) ?>" class="form-control"></textarea>
							</div>
						</div>
						<div class="row">
							<div class="col-md-12">
								<div class="form-group">
									<div id="files"></div>
									<div style="display: none;" id="remove_files_input"></div>
									<!--<label class="control-label"><?php /*echo __( "Select File(s)" ) */?></label>-->
									<input id="multipleuploadfile" type="file" name="uploadfile[]"
									       title="Only images and documents are allowed" class="form-control" accept="<?php echo ALLOWED_FILES ?>" multiple="multiple">
								</div>
								<div class="w3-light-grey">
									<div id="myBar" class="w3-container w3-green w3-center" style="width:0%">0%</div>
								</div>
							</div>
						</div>
					</div>
				</form>
			</div>
			<div class="modal-footer">
				<div class="btn-group">
					<button id="save" type="button" onclick="$('#course_form').trigger('submit');" class="btn blue">
						<?php _e( "Save changes" ) ?>
					</button>
					<button id="cancel" type="button" class="btn default" data-dismiss="modal">
						<?php _e( "Cancel" ) ?>
					</button>
				</div>
			</div>
		</div>
		<!-- /.modal-content -->
	</div>
	<!-- /.modal-dialog -->
</div>

<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<?php
			$cm   = new CourseMaterial;
			$data = $cm->get_courses();
			foreach ( $data as &$row ) {
				$row["files"] = $cm->get_files( $row["id"] );
			}
			?>
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( "Course Material List" ) ?>
						<small>Manage teachers data here</small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button id="del_btn" class="btn red"><i class="fa fa-trash"></i> Delete</button>
							<button id="add_btn" class="btn btn-primary"><i class="fa fa-plus"></i> Add</button>
							<!--<a class="btn btn-primary" href="course_material.php" style="color:#FFF !important;">
								<i class="fa fa-plus"></i> <?php /*_e( "Add Course Material" ) */ ?>
							</a>-->
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="course_material_list.php"><?php _e( "Course Material List" ) ?></a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<div class="portlet-body">
						<table class="table table-striped table-bordered table-hover" id="table1">
							<thead>
							<tr>
								<th style="width:60px">
									<input type="checkbox" id="check">
									<label for="check" style="font-weight: bold; cursor: pointer">ID</label>
								</th>
								<th><?php _e( "Course Name" ) ?></th>
								<th><?php _e( "Teachers" ) ?></th>
								<th><?php _e( "Classes" ) ?></th>
								<th><?php _e( "Subjects" ) ?></th>
							</tr>
							</thead>
							<tbody id="tbody1">
							<tr>
								<td colspan="5" class="text-center"><i class="fa fa-spin fa-spinner"></i> Loading ...
								</td>
							</tr>
							</tbody>
						</table>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>
<script>
	var Data = <?php echo json_encode( $data ); ?>;
	var select_one_or_more_string = "<?php _e( "Select one or more course material to delete." ) ?>";
	var areyousure_string = "<?php _e( "Are you sure you want to delete selected course materials?" ) ?>";
	var selected_delete_success_string = "<?php _e( "Selected course material deleted successfully!" ) ?>";
	var msg_string = "<?php _e( "Deleted: %1, Not deleted: %2" ); ?>";
	var success_string = "<?php _e( "Course material saved successfully!" ); ?>";
</script>
<script src="<?php echo \Theme::url() ?>js/course_material_list.js?<?php echo md5_file( \Theme::path() . "js/course_material_list.js" ) ?>"></script>
</body>
</html>