<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "administrator" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$title = __( "Custom Style" ) . " | " . System;
include_once( __DIR__ . "/header.php" );
?>
<style>
	code {
		font-family: courier, monospace;
		font-size: 80%;
		color: #418A8A;
	}
</style>
<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-css3"></i>Custom CSS Style
								<small style="font-size:11px">{Ctrl+Space} for autocomplete</small>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form id="form1" class="form-horizontal form-bordered">
								<div class="form-body">
									<div class="form-group">
										<div class="col-md-12">
											<textarea class="form-control" name="custom_style" id="custom_style" rows="20" cols="50"><?php echo $db->get_option( "custom_style" ); ?></textarea>
										</div>
									</div>
								</div>

								<div class="form-actions fluid">
									<div class="col-md-offset-1 col-md-10">
										<button type="submit" class="btn btn-primary">
											<i class="fa fa-save"></i> Save Custom Styles
										</button>
										<button type="reset" class="btn default">Cancel</button>
									</div>
								</div>

							</form>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->
<?php include_once( __DIR__ . "/footer.php" ); ?>
<script type="text/javascript">
	$( function() {
		$( document ).on( "submit", "#form1", function( event ) {
			event.preventDefault();

			Block();
			$.post( "<?php echo DOMAIN_URL ?>includes/ajax.php?action=saveStyle", $( this ).serialize(), function( data ) {
				if ( data=="OK" ) {
					Success( "Style updated successfully!" );
					window.location.reload();
				} else {
					UnBlock();
					Error( data );
				}
			} );
		} )
	} );

	var editor = CodeMirror.fromTextArea( document.getElementById( "custom_style" ), {
		extraKeys: { "Ctrl-Space": "autocomplete" },
		lineNumbers: true,
		matchBrackets: true,
		mode: "text/css"
	} );
</script>

</body>
<!-- END BODY -->
</html>