<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "administrator" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$title = "Data Backup";
include_once( __DIR__ . "/header.php" );

?>

<script>
	var FileName = "";
</script>

<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						<?php echo __("DB Backup") ?>
						<small><?php echo __("Manage DB backups here") ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
								<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="javascript:;" onclick="Backup();"><i class="fa fa-database"></i> <?php echo __("Take Fresh Backup") ?></a>
								</li>
								<li>
									<a href="javascript:;" onclick="Delete();"><i class="fa fa-trash"></i> <?php echo __("Delete Selected DB") ?></a>
								</li>
								<li>
									<a href="javascript:;" onclick="Download()"><i class="fa fa-download"></i> <?php echo __("Download Selected DB") ?></a>
								</li>
								<!--li class="divider">
								</li>
								<li>
									<a href="#">Separated link</a>
								</li-->
							</ul>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php echo __("Home") ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="javascript:;"><?php echo __("Tools") ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "data_backup" ) ?>"><?php echo __("Data Backup") ?></a>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<?php if ( ! IS_DB_BACKUP ): ?>
				<div class="alert alert-danger">
					<button type="button" class="close" data-dismiss="alert" aria-hidden="true"></button>
					<?php echo __("<strong>Error!</strong> DB Backup is not enabled.") ?>
				</div>
			<?php endif;
			$files = \File::files_list( DB_PATH . "*.gz" );
			$files = array_reverse( $files );
			?>
			<div class="row">
				<div class="col-md-12">
					<div class="btn-group" style="margin-bottom: 10px;">
						<button type="button" class="btn btn-primary" onclick="Backup();">
							<i class="fa fa-database"></i> <?php echo __("Take Fresh Backup") ?>
						</button>
						<button type="button" class="btn red" onclick="Delete();">
							<i class="fa fa-trash"></i> <?php echo __("Delete Selected DB") ?>
						</button>
						<button type="button" class="btn green" onclick="Download();">
							<i class="fa fa-download"></i> <?php echo __("Download Selected DB") ?>
						</button>
					</div>

					<table class="table table-striped table-bordered table-hover" id="table1">
						<thead>
						<tr>
							<th><?php echo __("DB File") ?></th>
							<th><?php echo __("Backup Time") ?></th>
							<th><?php echo __("File Size") ?></th>
						</tr>
						</thead>
						<tbody>
						<?php $x   = 1;
						foreach ( $files as $file ):
							$filename = substr( basename( $file ), 0, - 7 );
							$parts = explode( "--_--", $filename );
							$parts[1] = isset($parts[1])?$parts[1]:'';
							$time  = \Dates::my_datetime( $db->get_option( "date_time_format1" ), $parts[1] );
							$name  = $parts[0] . ".sql.gz";
							?>
							<tr id="<?php echo $filename ?>">
								<td><?php echo $name; ?></td>
								<td><?php echo $time ?></td>
								<td><?php echo \File::bytes_format( filesize( $file ) ) ?></td>
							</tr>
							<?php $x ++; endforeach; ?>
						</tbody>
					</table>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="text/javascript">
	$( function() {
		$( "#table1 tbody tr" ).each( function() {
			$( this ).css( "cursor", "pointer" );
		} );
		$( "#table1 tbody tr" ).click( function() {
			$( "#table1 tbody tr" ).each( function() {
				$( this ).removeClass( "Borders" );
			} );
			$( this ).addClass( "Borders" );
			FileName = $( this ).attr( "id" );
		} );
	} );

	function Delete() {
		<?php if (! is_paid_fekara()) { ?>
		Error( "You can't delete backup on free FeKara" );
		return false;
		<?php } else { ?>
		if ( FileName=="" ) {
			Error( "Please select a DB file to delete." );
			return;
		}
		bootbox.confirm( "Are you sure you want to delete this DB file?", function( result ) {
			if ( result==false ) {
				return;
			}
			Block();
			$.post( '<?php echo Urls::get_url( "ajax", 0, "action=delDBFile" ) ?>', { file: FileName }, function( data ) {
				UnBlock();
				if ( data=="OK" ) {
					$( "#" + FileName ).remove();
					Success( "File removed successfully!" );
				} else {
					Error( data );
				}
			} );
		} );
		<?php } ?>
	}

	function Backup() {
		<?php if (! is_paid_fekara()) { ?>
		Error( "You can't take backup on free FeKara" );
		return false;
		<?php } else { ?>
		Block();
		$.post( '<?php echo Urls::get_url( "ajax", 0, "action=FreshDBBackup" ) ?>', { file: FileName }, function( data ) {
			UnBlock();
			if ( data.substr( 0, 2 )=="OK" ) {
				$( "#table1 tbody tr:first" ).before( data.substr( 2 ) );
				$( "#table1 tbody tr" ).each( function() {
					$( this ).css( "cursor", "pointer" );
				} );
				$( "#table1 tbody tr" ).click( function() {
					$( "#table1 tbody tr" ).each( function() {
						$( this ).removeClass( "Borders" );
					} );
					$( this ).addClass( "Borders" );
					FileName = $( this ).attr( "id" );
				} );
				Success( "DB backup done successfully!" );
			} else {
				Error( data );
			}
		} );
		<?php } ?>
	}

	function Download() {
		<?php if (! is_paid_fekara()) { ?>
		Error( "You can't download backup on free FeKara" );
		return false;
		<?php } else { ?>
		if ( FileName=="" ) {
			Error( "Please select a DB file to download." );
			return;
		}
		window.location.href = "<?php echo Urls::get_url( "download_db", 0, "file=" ) ?>" + FileName;
		<?php } ?>
	}
</script>
</body>
<!-- END BODY -->
</html>