<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "user_management" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$title = "Date Sheet";

include_once( __DIR__ . "/header.php" );

// get all classes
$c       = new BatchClass();
$classes = $c->get_list( "orderby=class_name&order=ASC" );
// 
$d = new Datesheet();
$D = $d->get_datesheet();
//die( "Full time" );
?>

<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->
	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">Datesheet
						<small>Manage datesheet data here</small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>">Home</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "datesheet" ) ?>">Datesheet</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#">Edit Datesheet</a>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> Add Datesheet
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<a href="#portlet-config" data-toggle="modal" class="config"></a>
								<a href="javascript:;" class="reload"></a>
								<a href="javascript:;" class="remove"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form action="#" class="form-horizontal form-bordered" onsubmit="return Save(this)">
								<input type="hidden" name="id" id="id" value="0">
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3">Select Class</label>
										<div class="col-md-9">
											<select id="class_id" class="form-control" name="class_id" required='required'>
												<option value="" data-getClassName="">-- Select class --</option>
												<?php
												foreach ( $classes as $row ): ?>
													<option value="<?php echo $row["id"] ?>"><?php echo $row["class_name"] ?></option>
												<?php endforeach; ?>
											</select>
										</div>
									</div>

									<div id="subjects" style="display: none;">

										<div class="form-group">
											<label class="control-label col-md-3">Date Sheet</label>
											<div class="col-md-9">
												<table class="teacher-data table table-striped table-bordered table-hover dataTable" border="1" cellpadding="5" cellspacing="10" style="width: 100%;">
													<thead>
													<tr>
														<th style="text-align: center;text-transform: capitalize">#</th>
														<th style="text-align: center;text-transform: capitalize">Subjects</th>
														<th style="text-align: center;text-transform: capitalize">Marks</th>
														<th style="text-align: center;text-transform: capitalize">Date</th>
														<th style="text-align: center;text-transform: capitalize">Time</th>
													</tr>
													</thead>
													<tbody id="appendSub"></tbody>
												</table>
											</div>
										</div>

									</div>

								</div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="submit" class="btn blue">Submit</button>
										<button id="cancel_btn"
										        class="btn default"><?php echo __( "Cancel" ) ?>
										</button>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->

			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i>All Datesheet List
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<a href="#portlet-config" data-toggle="modal" class="config"></a>
								<a href="javascript:;" class="reload"></a>
								<a href="javascript:;" class="remove"></a>
							</div>
						</div>
					</div>
					<?php $Datesheet = new Datesheet;
					$rows            = $Datesheet->get_datesheet(); ?>
					<table class="table table-bordered table-striped custom_dt">
						<thead>
						<tr>
							<th>ID</th>
							<th>Class Name</th>
							<th>Subjects</th>
							<th style="width:100px">Action</th>
						</tr>
						</thead>
						<tbody>
						<?php foreach ( $rows as $row ): ?>
							<tr>
								<td><?php echo $row["id"] ?></td>
								<td>
									<a style="cursor: pointer;" href="edit_datesheet.php?id=<?php echo $row["id"] ?>"><?php echo $row["class_name"] ?></a>
								</td>
								<td><?php echo str_replace( ",", " - ", $row["subject_name"] ); ?></td>
								<td class="right">
									<div class="btn-group">
										<a style="cursor: pointer;" class="tooltips btn blue btn-xs" title="Edit Datesheet" href="edit_datesheet.php?id=<?php echo $row["id"] ?>" data-editdatesheet="<?php echo $row["id"] ?>"><i class="fa fa-pencil-square-o"></i></a>
										<a title="Download PDF" onclick="download_pdf('<?php echo $row["id"] ?>')" class="tooltips btn red btn-xs"><i class="fa fa-file-pdf-o" aria-hidden="true"></i></a>
										<a title="Delete" onclick="return confirm('Are you sure you sure you want to delete this record...?')" id="delete_row" data-deleterow="<?php echo $row["id"] ?>" class="tooltips btn red btn-xs"><i class="fa fa-times" aria-hidden="true"></i></a>
									</div>
								</td>
							</tr>
						<?php endforeach; ?>
						</tbody>
					</table>

				</div>
			</div>
			<!-- END PAGE CONTENT-->

		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php foreach ( $rows as $row ): ?>
	<form onsubmit="return download_pdf('<?php echo $row["id"] ?>');"
	      id="download_pdf_file<?php echo $row["id"] ?>"
	      action="<?php echo Urls::get_url( "download_student_weekly_report", 0, "id={$row["id"]}&date_sheet=Datesheet" ) ?>"
	      method="get" class="form-horizontal form-bordered">
	</form>
<?php endforeach; ?>


<?php
include_once( __DIR__ . "/footer.php" ); ?>

<script type="application/javascript">
	function download_pdf( btn ) {
		u = $( "#download_pdf_file" + btn ).serialize();
		// console.log( $( "#download_pdf_file" + btn ).attr( "action" ) + "?" + u );
		window.location.href = $( "#download_pdf_file" + btn ).attr( "action" ) + "&" + u;
		return false;
	}

	var DateAndYear = "2007:<?php echo date( 'Y' )?>";

	function Save( form ) {
		Block();
		$.post( '<?php echo DOMAIN_URL ?>includes/ajax.php?action=saveClassDatesheet', $( form ).serialize(), function( data ) {
			//UnBlock();
			if ( data=="OK" ) {
				Success( "Datesheet saved successfully!" );
				window.location.href = "<?php echo Urls::get_url( "datesheet" ) ?>";
			} else {
				UnBlock();
				Error( data );
			}
		} );
		return false;
	}

	$( function() {
		$( document ).on( "click", "#cancel_btn", function( event ) {
			event.preventDefault();

			$( "#subjects" ).hide();
			$( "#class_id" ).val( "" );
			$( "#class_id" ).select2( "val", "" );
		} );
		$( document ).on( "change", "#class_id", function() {
			event.preventDefault();
			var class_id = $( this ).val();

			if ( class_id=="" ) {
				$( "#appendSub" ).html( "" );
				return;
			}

			Block();
			$.post( "<?php echo DOMAIN_URL ?>includes/ajax.php?action=getClassSubjects", { class_id: $( this ).val() }, function( data ) {
				if ( is_json( data ) ) {
					UnBlock();
					data = jQuery.parseJSON( data );
					$( "#subjects" ).show();
					$( "#appendSub" ).html( "" );
					var no = 0;
					$.each( data, function( k, v ) {
						no = no + 1;
						$( '#appendSub' ).append( "<tr>" );
						$( '#appendSub' ).append( "<td style='padding:1px; text-align:center'>" + no + "</td>" );
						$( '#appendSub' ).append( "<td style='padding:1px; text-align:center'><input readonly type='text' name='subject_name[]' class='form-control' value=" + v + "></td>" );
						$( '#appendSub' ).append( "<td style='padding:1px; text-align:center'><input type='text' name='subject_marks[]' required='required' class='form-control' placeholder='Marks' value='0'></td>" );
						$( '#appendSub' ).append( "<td style='padding:1px; text-align:center'><input data-date-format='<?php echo \Dates::date_format1_for_js() ?>' type='text' id='subdatepicker" + no + "' name='subject_date[]' placeholder='Date' required='required' class='subdatepicker form-control' value='<?php echo \Dates::my_date();?>'/></td>" );
						$( '#appendSub' ).append( "<td style='padding:1px; text-align:center'><input type='text' name='subject_time[]' required='required' class='form-control timepicker' placeholder='Time' value='9:00 AM'></td>" );
						$( '#appendSub' ).append( "</tr>" );

					} );
					$( ".subdatepicker" ).datepicker( {
						//dateFormat: 'dd-M-yy',
						changeMonth: true,
						changeYear: true,
						yearRange: DateAndYear
					} );
					$( '.timepicker' ).timepicker( {
						timeFormat: 'h:mm p',
						interval: 15,
						minTime: '10',
						maxTime: '8:00pm',
						defaultTime: '9',
						startTime: '08:00',
						dynamic: false,
						dropdown: true,
						scrollbar: true
					} );
				}
			} );
		} );

		$( "#subdatepicker" ).datepicker( {
			dateFormat: 'dd-M-yy',
			changeMonth: true,
			changeYear: true,
			yearRange: DateAndYear
		} );

		$( "select" ).select2( {
			placeholder: "Select an option",
			allowClear: true
		} );

		dataTable2 = $( '.custom_dt' ).dataTable( {
			"aLengthMenu": [
				[ 10, 20, 30, 40, 50, 100, -1 ],
				[ 10, 20, 30, 40, 50, 100, "All" ] // change per page values here
			],
			// set the initial value
			"iDisplayLength": 10,
			//			"sPaginationType": "bootstrap",
			"oLanguage": {
				"sLengthMenu": "_MENU_ records",
				"oPaginate": {
					"sPrevious": "Previous Page",
					"sNext": "Next Page"
				}
			},
			"aaSorting": [ [ 1, "asc" ] ],
			"aoColumns": [
				{ "bSortable": true },
				{ "bSortable": true },
				{ "bSortable": true },
				{ "bSortable": true },
				//{"bSortable": true},
				//{"bSortable": false}
				//{"bSortable": false}
			]
		} );

		// datesheet
		$( document ).on( "click", ".datesheet", function( e ) {
			e.preventDefault();
			var $this = $( this );
			var editid = $( this ).data( "editdatesheet" );
			$( "#class-modal" + editid ).modal( "show" );
		} );

		// datesheet
		$( document ).on( "click", "#delete_row", function( e ) {
			e.preventDefault();
			var $this = $( this );
			var id = $( this ).data( "deleterow" );
			Block();
			$.post( "<?php echo DOMAIN_URL ?>includes/ajax.php?action=deleteDatesheet", { id: id }, function( data ) {
				if ( data=="OK" ) {
					Success( "Datesheet successfully Delete!" );
					window.location.href = "<?php echo Urls::get_url( "datesheet" ) ?>";
				}
			} );
		} );

	} );

</script>

</body>
<!-- END BODY -->
</html>