<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title = "Edit Datesheet";
include_once( __DIR__ . "/header.php" );
if ( ! \Admins\UserInfo::is_allowed( "user_management" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
if ( $_GET["id"] != '' ) {
	$id = $_GET["id"];
} else {
	?>
	<script>
		window.location.href = "<?php echo Urls::get_url( "datesheet" ) ?>";
	</script>
	<?php
}
// get datesheet
$d = new Datesheet();
$D = $d->get_datesheet_data( $id );
?>
<link rel="stylesheet" href="<?php echo ASSETS_URL ?>plugins/jquery-ui/jquery-ui-1.10.3.custom.min.css">
<link rel="stylesheet" href="<?php echo ASSETS_URL ?>plugins/bootstrap-datetimepicker/css/datetimepicker.css">
<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						Datesheet
						<small>Manage datesheet data here</small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">

						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>">Home</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "datesheet" ) ?>">Datesheet</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#">Edit Datesheet</a>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i>Edit Datesheet
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<a href="#portlet-config" data-toggle="modal" class="config"></a>
								<a href="javascript:;" class="reload"></a>
								<a href="javascript:;" class="remove"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form action="#" class="form-horizontal form-bordered" onsubmit="return Save(this)">
								<div class="form-body">
									<input type="hidden" id="id" name="id" value="<?php echo $id ?>">
									<div class="form-group">
										<div class="col-md-12">

											<table class="teacher-data table table-striped table-bordered table-hover dataTable"
											       border="1" cellpadding="5" cellspacing="10" style="width: 100%;">
												<thead>
												<tr>
													<th style="text-align: center;text-transform: capitalize">No.</th>
													<th style="text-align: center;text-transform: capitalize">Subject
													</th>
													<th style="text-align: center;text-transform: capitalize">Marks</th>
													<th style="text-align: center;text-transform: capitalize">Date</th>
													<th style="text-align: center;text-transform: capitalize">Time</th>
												</tr>
												</thead>
												<tbody>

												<?php
												$no = 1;
												foreach ( $D as $row ) { ?>
													<input type="hidden" name="classid"
													       value="<?php echo $row['classid'] ?>">
													<input type="hidden" name="getClassName"
													       value="<?php echo $row['class_name'] ?>">
													<?php
													$subject_name  = explode( ",", $row["subject_name"] );
													$subject_marks = explode( ",", $row["subject_marks"] );
													$subject_date  = explode( ",", $row["subject_date"] );
													$subject_time  = explode( ",", $row["subject_time"] );
													foreach ( $subject_time as $k => $data ):
														?>
														<tr>
															<td style="text-align: center;text-transform: capitalize"><?php echo $no ?></td>
															<td style="text-align: center;text-transform: capitalize">
																<input type="text" name="sub[]" readonly
																       required='required' class='form-control'
																       value="<?php echo $subject_name[ $k ] ?>"></td>
															<td style="text-align: center;text-transform: capitalize">
																<input type="text" name="submarks[]" required='required'
																       class='form-control'
																       value="<?php echo $subject_marks[ $k ] ?>"></td>
															<td style="text-align: center;text-transform: capitalize">
																<input type="text" name="subdate[]" required='required'
																       id="editdatepicker<?php echo $k ?>"
																       class='form-control'
																       value="<?php echo $subject_date[ $k ] ?>"></td>
															<td style="text-align: center;text-transform: capitalize">
																<input type="text" name="subtime[]" required='required'
																       class='form-control timepicker<?php echo $k ?>'
																       placeholder='Time'
																       value="<?php echo $subject_time[ $k ] ?>"></td>
														</tr>

														<?php $no ++;endforeach;
												} ?>

												</tbody>
											</table>

										</div>
									</div>
								</div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="submit" class="btn blue">Update</button>
										<a href="<?php echo Urls::get_url( "datesheet" ) ?>"
										   class="btn default">Back</a>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->

		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->
<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="application/javascript">

	var DateAndYear = "2007:<?php echo date( 'Y' )?>";
	function Save( form ) {
		Block();
			$.post( '<?php echo DOMAIN_URL ?>includes/ajax.php?action=saveClassDatesheet', $( form ).serialize(), function( data ) {
			UnBlock();
			if ( data == "OK" ) {
				Success( "<?php _e("Datesheet updated successfully!") ?>" );
				window.location.href = "<?php echo Urls::get_url("edit_datesheet", 0, "id=". $_GET['id']) ?>";
			} else {
				Error( data );
			}
		} );
		return false;
	}

	$( function() {
		$( "select" ).select2( {
			placeholder: "Select an option",
			allowClear: true
		} );

		dataTable2 = $( '.custom_dt' ).dataTable( {
			"aLengthMenu": [
				[ 10, 20, 30, 40, 50, 100, -1 ],
				[ 10, 20, 30, 40, 50, 100, "All" ] // change per page values here
			],
			// set the initial value
			"iDisplayLength": 10,
			//            "sPaginationType": "bootstrap",
			"oLanguage": {
				"sLengthMenu": "_MENU_ records",
				"oPaginate": {
					"sPrevious": "Previous Page",
					"sNext": "Next Page"
				}
			},
			"aaSorting": [ [ 1, "asc" ] ],
			"aoColumns": [
				{ "bSortable": true },
				{ "bSortable": true },
				{ "bSortable": true },
				{ "bSortable": true },
				//{"bSortable": true},
				//{"bSortable": false}
				//{"bSortable": false}
			]
		} );

		<?php
		if ( isset( $row["subject_time"] ) ) {
			$subject_time = explode( ",", $row["subject_time"] );
		} else {
			$subject_time = [];
		}
		foreach ($subject_time as $k => $data) {
		?>
		var DateAndYear = "2007:<?php echo date( 'Y' )?>";
		$( "#editdatepicker<?php echo $k?>" ).datepicker( {
			dateFormat: 'dd-M-yy',
			changeMonth: true,
			changeYear: true,
			yearRange: DateAndYear
		} );

		$( '.timepicker<?php echo $k?>' ).timepicker( {
			timeFormat: 'h:mm p',
			interval: 15,
			minTime: '10',
			maxTime: '8:00pm',
			defaultTime: '9',
			startTime: '08:00',
			dynamic: false,
			dropdown: true,
			scrollbar: true
		} );
		<?php } ?>
	} );

</script>

</body>
<!-- END BODY -->
</html>