<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$EmailTemplates = new EmailTemplates();
if ( isset( $_GET["save_assigned_templates"] ) ) {
	echo $EmailTemplates->save_template_assignments( $_POST );
	exit;
}
if ( isset( $_GET["save_template"] ) ) {
	echo $EmailTemplates->save( $_POST );
	exit;
}
if ( isset( $_GET["load_data"] ) ) {
	$rows = $EmailTemplates->get_email_templates( $_POST );

	$html = "";
	foreach ( $rows["rows"] as $row ) {
		$html .= "<tr><td style='text-align: right'>{$row["id"]}</td>";
		$html .= "<td><a title='" . __( "Edit email template" ) . "' href='#' class='edit_template' data-id='{$row["id"]}'>" . $row["name"] . "</a></td>";
		$html .= "<td>" . $row["subject"] . "</td></tr>";
	}
	$rows["html"]       = $html;
	$rows["pagination"] = get_pagination_string( $rows["start"], $rows["end"], $rows["page"], $rows["pages"] );
	echo json_encode( $rows );
	exit;
}
if ( isset( $_GET["template_assign"] ) ) {
	$rows = $EmailTemplates->get_email_templates( "pagesize=9999&page=1" );
	//show_array( $rows);
	?>
	<form id="template_assign_form">
		<div class="alert alert-danger" style="margin-bottom: 5px !important;">
			<?php _e( "You can use fields when adding/saving email templates. Example {name}, {id} etc." ) ?>
		</div>
		<div class="right padding-bottom-5">
			<div class="btn-group">
				<input type="submit" class="btn btn-primary" value="<?php _e( "Save" ) ?>">
				<input onclick="javascript:$.fancybox.close();" type="button" class="btn red" value="<?php _e( "Cancel" ) ?>">
			</div>
		</div>
		<div style="clear: both"></div>
		<div style="max-height: 350px;overflow-y: auto">
			<table class="table table-bordered">
				<thead>
				<tr>
					<th><?php _e( "Event" ) ?></th>
					<th><?php _e( "Email Template" ) ?></th>
				</tr>
				</thead>
				<tbody>
				<?php foreach ( $EmailTemplates->AssignedTo as $key => $message ) { ?>
					<input type="hidden" name="assigned_id[]" value="<?php echo $key ?>">
					<tr>
						<td>
							<a href="<?php echo Urls::get_url( "email_template_fields", 0, "assignment_id=" . $key ); ?>"
							   target="_blank" title="<?php _e( "View fields" ) ?>" class="pull-right">
								<i class='fa fa-question-circle'></i>
							</a>
							<?php echo $message ?>
						</td>
						<td>
							<select class="form-control" name="email_id[]">
								<option value="0">== No template ==</option>
								<?php foreach ( $rows["rows"] as $row ) {
									$S = $EmailTemplates->get_template_id_from_assignment( $key ) == $row["id"] ? "selected=selected" : "";
									?>
									<option <?php echo $S ?> value="<?php echo $row["id"] ?>">
										<?php echo $row["id"] . ". " . $row["name"] ?>
										- <?php $EmailTemplates->get_template_id_from_assignment( $row["id"] ) ?>
									</option>
								<?php } ?>
							</select>
						</td>
					</tr>
				<?php } ?>
				</tbody>
			</table>
		</div>
	</form>
	<?php exit;
}
$title = "Email Templates";
include_once( __DIR__ . "/header.php" ); ?>

<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<form id="form1" class="validate">
				<input type="hidden" name="id" value="0" id="id">
				<input type="reset" id="form1_reset" style="display: none;">
				<div class="modal fade" id="modal1" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
					<div class="modal-dialog modal-full">
						<div class="modal-content">
							<div class="modal-header">
								<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
								<h4 class="modal-title"><?php _e( "Email Template" ) ?></h4>
							</div>
							<div class="modal-body">
								<div class="row">
									<div class="col-md-6">
										<label class="control-label href" for="name"><?php _e( "Template Name" ) ?>:</label>
										<input name="name" id="name" type="text" class="form-control" required="required"
										       title="<?php _e( "Template name required" ) ?>"
										       placeholder="<?php _e( "Template Name" ) ?>">
									</div>
									<div class="col-md-6">
										<label class="control-label href" for="subject"><?php _e( "Email subject" ) ?>:</label>
										<input name="subject" id="subject" type="text" class="form-control" required="required"
										       title="<?php _e( "Email subject required" ) ?>"
										       placeholder="<?php _e( "Email Subject" ) ?>">
									</div>
								</div>
								<div class="row">
									<div class="col-md-12">
										<label for="message" class="control-label href">
											<?php _e( "Email message" ) ?>
										</label>
										<textarea class="summernote" name="message" id="message"></textarea>
									</div>
								</div>
							</div>
							<div class="modal-footer">
								<button type="submit" class="btn blue"><?php _e( "Save" ) ?></button>
								<button type="button" class="btn default" data-dismiss="modal"><?php _e( "Close" ) ?></button>
							</div>
						</div>
					</div>
				</div>
			</form>
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( "Email Templates" ) ?>
						<small><?php _e( "Manage email templates here." ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button type="button" class="btn green" id="assign_btn">
								<?php _e( "Assign Templates" ) ?>
							</button>
							<button type="button" class="btn blue" id="add_template">
								<i class="fa fa-plus"></i> <?php _e( "Add" ) ?>
							</button>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>">Home</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#"><?php _e( "Settings" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "email_templates" ) ?>"><?php _e( "Email Templates" ) ?></a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<form style="display: none" id="filter_form">
						<input type="hidden" name="page" value="1" id="filter_page">
					</form>
					<div id="pagination"></div>
					<table class="table table-bordered" id="table1">
						<thead>
						<tr class="heading">
							<th><?php _e( "ID" ) ?></th>
							<th><?php _e( "Name" ) ?></th>
							<th><?php _e( "Subject" ) ?></th>
						</tr>
						</thead>
						<tbody>
						<tr>
							<td colspan="3" class="center">-- <?php _e( "Data will load here" ) ?> --</td>
						</tr>
						</tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="text/javascript">
	var Rows;

	function load_data() {
		Block();
		$.post( "<?php echo Urls::get_url( "email_templates", 0, "load_data" ) ?>", $( "#filter_form" ).serialize(), function( data ) {
			UnBlock();
			if ( is_json( data ) ) {
				Rows = JSON.parse( data );
				$( "#table1 tbody" ).html( Rows.html );
				$( "#pagination" ).html( Rows.pagination + " - Page " + Rows.page + " of " + Rows.pages + " - Total: " + Rows.total_records );
			} else {
				Error( data );
			}
		} );
	}

	$( function() {
		load_data();

		$( document ).on( "click", ".edit_template", function( event ) {
			event.preventDefault();
			var id = $( this ).attr( "data-id" );

			$.each( Rows.rows, function( i, row ) {
				if ( row.id == id ) {
					$( "#id" ).val( id );
					$( "#name" ).val( row.name );
					$( "#subject" ).val( row.subject );
					$( "#message" ).summernote( "code", row.message );
					$( "#modal1" ).modal( "show" );
				}
			} );
		} );
		$( document ).on( "click", "#add_template", function( event ) {
			event.preventDefault();

			$( "#form1_reset" ).click();
			$( "#id" ).val( "0" );
			$( "#message" ).summernote( "code", "" );
			$( "#modal1" ).modal( "show" );
		} );
		$( document ).on( "submit", "#form1", function( event ) {
			event.preventDefault();

			if ( $.trim( $( "#message" ).summernote( "code" ) ) == "" ) {
				Error( "<?php _e( "Email message missing" ) ?>" );
				$( 'div.note-editable' ).trigger( 'focus' );
				return false;
			}

			$( "#modal1" ).modal( "hide" );
			k = $( "#form1" ).serialize();

			Block();
			$.post( "<?php echo Urls::get_url( "email_templates", 0, "save_template" ) ?>", k, function( data ) {
				UnBlock();
				if ( data.substr( 0, 2 ) == "OK" ) {
					load_data();
				} else {
					Error( data );
				}
			} );
		} );

		$( document ).on( "click", "#assign_btn", function( event ) {
			event.preventDefault();
			Block();
			$.post( "<?php echo Urls::get_url("email_templates",0,"template_assign") ?>", function( data ) {
				UnBlock();
				$.fancybox( {
					content: data,
					fitToView: false,
					width: '90%',
					afterShow: function() {
						//$(".fancybox-outer").css("max-height", "300px");
					}
				} );
			} );
		} );
		$( document ).on( "submit", "#template_assign_form", function( event ) {
			event.preventDefault();
			k = $( "#template_assign_form" ).serialize();
			$.fancybox.close();
			$.post( "<?php echo Urls::get_url("email_templates",0,"save_assigned_templates") ?>", k, function( data ) {
				if ( data == "OK" ) {
					Success( "<?php _e( "Template assignment saved." ) ?>" )
				} else {
					Error( data );
				}
			} );
		} );
		$( document ).on( "click", ".btn_page", function( event ) {
			event.preventDefault();
			var page = $( this ).text();

			$( "#filter_page" ).val( page );
			load_data();
		} );
		$( document ).on( "click", "#btn_next, #btn_previous", function( event ) {
			event.preventDefault();

			var page = Number( $( "#filter_page" ).val() );
			if ( $( this ).attr( "id" ) == "btn_next" ) {
				page++;
			} else {
				page--;
			}
			$( "#filter_page" ).val( page );
			load_data();
		} );
	} );
</script>
</body>
</html>