<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title = "List of Fee Defaulters";

$_GET["classes"] = isset( $_GET["classes"] ) ? $_GET["classes"] : [];
$_GET["from"]    = isset( $_GET["from"] ) ? $_GET["from"] : '';
$_GET["to"]      = isset( $_GET["to"] ) ? $_GET["to"] : '';

if ( isset( $_GET["sms"] ) ) {
	unset( $_GET["sms"] );
	$Q = "";
	if ( is_array( $_GET["classes"] ) ) {
		$_GET["classes"] = implode( ",", $_GET["classes"] );
	}
	$Fee  = new Fee;
	$rows = $Fee->get_fee_defaulters( "filter=" . urlencode( http_build_query( $_GET ) ) );
	if ( ! is_array( $rows ) ) {
		die( "Can't get data from server" );
	}
	if ( sizeof( $rows ) == "0" ) {
		die( "Can't get data from server" );
	}
	$SMS     = new SMS;
	$Student = new Student;
	$success = 0;
	$failed  = 0;
	foreach ( $rows as $row ) {
		$student_id = $row["student_id"];
		$cell       = $Student->get_student( $student_id, "guardian_cell" );
		$cell       = $cell["guardian_cell"];
		$response   = $SMS->add_to_queue( $cell, $_POST["sms_message"] );
		if ( $response === false ) {
			$failed ++;
		} else {
			$success ++;
		}
	}
	echo "OK";
	exit;
}

include_once( __DIR__ . "/header.php" );
#show_array($Fee->get_fee(1));
?>

<div class="modal fade" id="sms_modal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
	<div class="modal-dialog">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
				<h4 class="modal-title">SMS Message</h4>
			</div>
			<div class="modal-body">
				<form name="sms_form" id="sms_form" onsubmit="return SMS(this);">
					<input type="submit" id="sms_submit" style="display:none" />
					<table class="table table-bordered">
						<tr>
							<td>
								<code>150 Characters for 1 SMS</code>
								<textarea rows="10" placeholder="SMS Message Here" required="required" class="form-control" name="sms_message"></textarea>
							</td>
						</tr>
					</table>
				</form>
			</div>
			<div class="modal-footer">
				<button type="button" class="btn blue" onclick="$('#sms_submit').click()">Send SMS</button>
				<button type="button" class="btn default" data-dismiss="modal">Close</button>
			</div>
		</div>
		<!-- /.modal-content -->
	</div>
	<!-- /.modal-dialog -->
</div>

<?php if ( \Admins\UserInfo::is_allowed( "pay_fee" ) ): ?>
	<div class="modal fade" id="invoice2" tabindex="-1" role="basic" aria-hidden="true">
		<div class="modal-dialog">
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
					<h4 class="modal-title"><?php _e( 'Edit Fee' ) ?></h4>
				</div>
				<div class="modal-body">
					<form onsubmit="return Save2(this);">
						<input type="hidden" name="id" id="id2" />
						<input type="submit" id="submit2" style="display:none" />
						<table class="table table-bordered">
							<tr>
								<td><?php _e( 'Amount' ) ?>:</td>
								<td>
									<input required="required" type="number" step=".01" min="0" class="form-control" id="amount2" name="amount">
								</td>
							</tr>
							<tr>
								<td><?php _e( 'Fine' ) ?>:</td>
								<td>
									<input required="required" type="number" step=".01" min="0" class="form-control" id="fine2" name="fine">
								</td>
							</tr>
							<tr>
								<td><?php _e( 'Description' ) ?>:</td>
								<td>
									<textarea class="form-control" id="description2" name="description" rows="8"></textarea>
								</td>
							</tr>
						</table>
					</form>
				</div>
				<div class="modal-footer">
					<button type="button" class="btn default" data-dismiss="modal"><?php _e( 'Cancel' ) ?></button>
					<button type="button" onclick="Submit2()" class="btn blue"><?php _e( 'Save' ) ?></button>
				</div>
			</div>
			<!-- /.modal-content -->
		</div>
		<!-- /.modal-dialog -->
	</div>
<?php endif; ?>

<div class="modal fade" id="invoice" tabindex="-1" role="basic" aria-hidden="true">
	<div class="modal-dialog">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
				<h4 class="modal-title">Pay Fee</h4>
			</div>
			<div class="modal-body">
				<form name="form1" id="form1" onsubmit="return Save();">
					<input type="hidden" name="id" id="id" />
					<input type="submit" id="submit1" style="display:none" />
					<table class="table table-bordered">
						<tr>
							<td><?php _e( 'Fee' ) ?>":</td>
							<td><span class="form-control" id="fee_title"></span></td>
						</tr>
						<tr>
							<td>Amount:</td>
							<td>
								<input type="number" required="required" class="form-control" id="amount" name="amount" />
							</td>
						</tr>
						<tr>
							<td>Date:</td>
							<td>
								<input required="required" type="text" class="form-control date-picker" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>" id="fee_date" name="fee_date" value="">
							</td>
						</tr>
						<tr>
							<td>Receipt Number (If Any):</td>
							<td><input type="text" class="form-control" id="receipt_number" name="receipt_number"></td>
						</tr>
					</table>
				</form>
			</div>
			<div class="modal-footer">
				<div class="btn-group">
					<button type="button" class="btn default" data-dismiss="modal">Cancel</button>
					<button type="button" onclick="Print(-1)" class="btn green" title="Print Receipt">Print</button>
					<button type="button" onclick="Submit1()" class="btn blue">Pay</button>
				</div>
			</div>
		</div>
		<!-- /.modal-content -->
	</div>
	<!-- /.modal-dialog -->
</div>

<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						Fee Defaulters
						<small>Students with late fee</small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
								<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a id="download_link"><i class="fa fa-download"></i> Download PDF</a>
								</li>
								<li>
									<a href="#sms_modal" data-toggle="modal"><i class="fa fa-mobile"></i> Send SMS</a>
								</li>
								<!--li>
									<a href="#">Something else here</a>
								</li>
								<li class="divider">
								</li>
								<li>
									<a href="#">Separated link</a>
								</li-->
							</ul>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>">Home</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#">Fee</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "fee_defaulters", 0, http_build_query( $_GET ) ) ?>">
								<?php _e( "Fee Defaulters" ) ?>
							</a>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<a style="float: right;" href="javascript:void()" onclick="Filter(this,'D')">&dArr; Filter Result</a>
					<script>
						function Filter( s, t ) {
							if ( t=='D' ) {
								$( "#filterForm" ).slideDown( "slow" );
								$( s ).html( "&uArr; Hide Filter" );
								$( s ).attr( "onClick", "Filter(this,'U')" );
							} else {
								$( "#filterForm" ).slideUp( "slow" );
								$( s ).html( "&dArr; Filter Result" );
								$( s ).attr( "onClick", "Filter(this,'D')" );
							}
						}
					</script>
					<form class="form-horizontal form-bordered" name="filterForm" id="filterForm" style="display: none;">
						<div class="form-body">
							<div class="form-group">
								<label class="control-label col-md-3">Due Dates</label>
								<div class="col-md-4">
									<div class="input-group input-xlarge date-picker input-daterange" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>">
										<input value="<?php echo $_GET["from"] ?>" type="text" class="form-control" name="from" placeholder="From Date">
										<span class="input-group-addon">
											to
										</span>
										<input value="<?php echo $_GET["to"] ?>" type="text" class="form-control" name="to" placeholder="To Date">
									</div>
									<!-- /input-group -->
									<span class="help-block">
										Select date range
									</span>
								</div>
							</div>
							<div class="form-group">
								<label class="control-label col-md-3">Select Class</label>
								<div class="col-md-4">
									<select name="classes[]" class="form-control input-xlarge select2" multiple="multiple">
										<option value="">All Classes</option>
										<?php
										$C   = new BatchClass;
										$Cls = $C->get_list();
										foreach ( $Cls as $Cl ):
											if ( is_array( $_GET["classes"] ) ) {
												$S = in_array( $Cl["id"], $_GET["classes"] ) ? "selected=selected" : "";
											} else {
												$S = "";
											}
											?>
											<option <?php echo $S ?> value="<?php echo $Cl["id"] ?>"><?php echo $Cl["class_name"] ?></option>
										<?php endforeach; ?>
									</select>
								</div>
							</div>
							<div class="form-group">
								<div class="col-md-offset-3 col-md-9">
									<button type="submit" class="btn blue">Filter Result</button>
									<a class="btn red" href="<?php echo Urls::get_url( "fee_defaulters" ) ?>">Clear Filter</a>
								</div>
							</div>
						</div>
					</form>
					<table class="table table-striped table-bordered table-hover" id="sample_11">
						<thead>
						<tr class="heading">
							<th>Student</th>
							<th>Description</th>
							<th style="width:100px;">Amount</th>
							<th style="width:50px;">Fine</th>
							<th style="width:120px;">Due Date</th>
							<th style="width:120px;">Last Date</th>
							<th style="width:60px;">&nbsp;</th>
						</tr>
						</thead>
						<tbody>
						</tbody>
					</table>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="text/javascript">
	function OpenInvoice( id ) {
		Block();
		$.post( "<?php echo Urls::get_url( "ajax", 0, "action=getFee" ) ?>", { id: id }, function( data ) {
			UnBlock();
			if ( data.status=="OK" ) {
				$( "#amount" ).val( parseFloat( data.remaining_amount ) + parseFloat( data.fine ) );
				$( "#fee_title" ).html( data.fee_title );
				$( "#id" ).val( id );
				$( "#fee_date" ).val( "<?php echo \Dates::my_date() ?>" );
				$( "#receipt_number" ).val( "" );
				$( "#invoice" ).modal( "show" );
			} else {
				Error( data.status );
			}
		} );
	}

	function Edit( id ) {
		Block();
		$.post( "<?php echo Urls::get_url( "ajax", 0, "action=getFee" ) ?>", { id: id }, function( data ) {
			UnBlock();
			if ( data.status=="OK" ) {
				$( "#amount2" ).val( data.amount );
				$( "#fine2" ).val( data.fine );
				$( "#description2" ).val( data.description );
				$( "#id2" ).val( id );
				$( "#invoice2" ).modal( "show" );
			} else {
				Error( data.status );
			}
		} );
	}

	function Submit1() {
		$( "#submit1" ).click();
	}

	function Submit2() {
		$( "#submit2" ).click();
	}

	function Save() {

		$.post( "<?php echo DOMAIN_URL ?>includes/old_ajax.php?action=payFee", $( "#form1" ).serialize(), function( data ) {
			UnBlock();
			if ( data=="OK" ) {
				var $dataTable = $( '#sample_11' ).dataTable();
				$dataTable.fnDraw();
				var fig = $( "#sidebar_defaulters_fee_span1" ).html();
				fig = parseFloat( fig ) - 1;
				$( "#sidebar_defaulters_fee_span1,#sidebar_defaulters_fee_span2" ).html( fig );
				$( "#invoice" ).modal( "hide" );
				Success( "Fee paid successfully!" );
			} else {
				Error( data );
			}
		} );

		return false;
	}

	function Save2( form ) {
		Block();
		$.post( "<?php echo Urls::get_url( "ajax", 0, "action=updatePiadFee" ) ?>", $( form ).serialize(), function( data ) {
			UnBlock();
			if ( data=="OK" ) {
				var $dataTable = $( '#sample_11' ).dataTable();
				$dataTable.fnDraw();
				var fig = $( "#top_collect_fee_span" ).html();
				fig = parseFloat( fig ) - 1;
				$( "#top_collect_fee_span,#sidebar_collect_fee_span" ).html( fig );
				$( "#invoice2" ).modal( "hide" );
				Success( "Fee paid successfully!" );
			} else {
				Error( data );
			}
		} );

		return false;
	}

	var TableAjax = function() {

		return {
			//main function to initiate the module
			init: function() {
				if ( !jQuery().dataTable ) {
					return;
				}

				// begin first table
				var $dataTable = $( '#sample_11' ).dataTable( {
					"sDom": "<'row'<'col-md-6 col-sm-12'l><'col-md-6 col-sm-12'f>r>t<'row'<'col-md-5 col-sm-12'i><'col-md-7 col-sm-12'p>>", //default layout without horizontal scroll(remove this setting to enable horizontal scroll for the table)
					"aLengthMenu": [
						[ 10, 20, 40, 60, 100 ],
						[ 10, 20, 40, 60, 100 ] // change per page values here
					],
					"bProcessing": true,
					"bServerSide": true,
					"sAjaxSource": "<?php echo Urls::get_url( "ajax", 0, "action=getFeeDefaulterList&" . http_build_query( $_GET ) ) ?>",
					// set the initial value
					"iDisplayLength": 10,
					//                "sPaginationType": "bootstrap_full_number",
					"oLanguage": {
						"sProcessing": '<i class="fa fa-coffee"></i>&nbsp;<?php _e( "Please wait..." ) ?>',
						"sLengthMenu": "_MENU_ records",
						"oPaginate": {
							"sPrevious": "Prev",
							"sNext": "Next"
						}
					},
					"aoColumns": [
						{ "bSortable": true },
						{ "bSortable": false },
						{ "bSortable": true },
						{ "bSortable": true },
						{ "bSortable": true },
						{ "bSortable": true },
						{ "bSortable": false }
					]
				} );

				$( "#sample_11 tfoot input" ).on( 'keyup change', function() {
					table
						.column( $( this ).parent().index() + ':visible' )
						.search( this.value )
						.draw();
				} );

				jQuery( '#sample_11_wrapper .dataTables_filter input' ).addClass( "form-control input-medium" ); // modify table search input
				jQuery( '#sample_11_wrapper .dataTables_length select' ).addClass( "form-control input-small" ); // modify table per page dropdown
			}

		};

	}();

	TableAjax.init();

	function Delete( id ) {
		bootbox.confirm( "Are you sure you want to delete this fee?", function( result ) {
			if ( result==false ) {
				return;
			}
			Block();
			$.post( '<?php echo Urls::get_url( "ajax", 0, "action=delFee" ) ?>', { id: id }, function( data ) {
				UnBlock();
				if ( data=="OK" ) {
					var $dataTable = $( '#sample_11' ).dataTable();
					$dataTable.fnDraw();
					Success( "Fee removed successfully!" );
					var fig = $( "#top_collect_fee_span" ).html();
					fig = parseFloat( fig ) - 1;
					$( "#top_collect_fee_span,#sidebar_collect_fee_span" ).html( fig );
				} else {
					Error( data );
				}
			} );
		} );
	}

	$( function() {
		$( document ).on( 'click', '#download_link', function( event ) {
			event.preventDefault();

			var query = $( "#filterForm" ).serialize();
			query += "search=" + jQuery( '#sample_11_wrapper .dataTables_filter input' ).val();
			query += "&_data=fee_defaulters";
			var oTable = $( '#sample_11' ).dataTable();
			/*var oData = oTable.fnPagingInfo();
			$.each(oData, function(k,v){
				alert(k + " = " + v);
			});*/
			var Sort = oTable.fnSettings().aaSorting;
			window.location.href = "download_pdf.php?" + query + "&sorts=" + Sort;
		} );
	} );

	function Print( id ) {
		if ( id=="-1" ) {
			id = $( "#id" ).val();
		}
		window.open( "print_receipt.php?inline&id=" + id, "_blank", "width=300&height=100&location=no&menubar=no&resizable=no&status=no&titlebar=no&toolbar=no&top=200" );
	}

	function SMS( form ) {
		Block();
		var query = $( form ).serialize();
		$.post( "<?php echo Urls::get_url( "fee_defaulters", 0, "sms&" . http_build_query( $_GET ) ) ?>", $( form ).serialize(), function( data ) {
			UnBlock();
			if ( data=="OK" ) {
				$( "#sms_modal" ).modal( "hide" );
				Success( "SMS queued successfully!" );
			} else {
				Error( data );
			}
		} );
		return false;
	}
</script>
</body>
<!-- END BODY -->
</html>