<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "change_fee_settings" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$title = "Fee Settings";
include_once( __DIR__ . "/header.php" ); ?>
<script>
	var ajax_url = "<?php echo Urls::get_url( "ajax", 0, "action=saveInlineSettings" ) ?>";
	var my_id = "1";
</script>

<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-editable/bootstrap-editable/css/bootstrap-editable.css" />
<link rel="stylesheet" type="text/css" href="<?php echo ASSETS_URL ?>plugins/bootstrap-editable/inputs-ext/address/address.css" />

<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						Fee Settings
						<small>Manage fee settings</small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>">Home</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#">Application</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "fee_settings" ) ?>"><?php _e( "Fee Settings" ) ?></a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<table id="user" class="table table-bordered table-striped">
						<tbody>
						<tr>
							<td><?php _e( 'Generate fee invoices before specific days:' ) ?></td>
							<td>
								<a id="fee_schedule_days_before" href="#" data-title="<?php _e('Type days here') ?>" data-inputclass="form-control" data-type="number"><?php echo $db->get_option( "fee_schedule_days_before", "0" ) ?></a>
							</td>
							<td>
                            <span class="text-muted">
                            <?php _e( 'System will generate invoices before specified days from due date.' ) ?>
                            </span>
							</td>
						</tr>
						<tr>
							<th colspan="3"><?php _e('Challan Form Settings') ?></th>
						</tr>
						<tr>
							<td><?php _e( 'Bank name' ) ?></td>
							<td>
								<a id="challan_bank_name" href="#" data-title="<?php _e('Type bank name') ?>"
								   data-inputclass="form-control">
									<?php echo $db->get_option( "challan_bank_name", "" ) ?>
								</a>
							</td>
							<td>
                            <span class="text-muted">
                            <?php _e( 'This bank name will print on challan form' ) ?>
                            </span>
							</td>
						</tr>
						<tr>
							<td><?php _e( 'Bank account title' ) ?></td>
							<td>
								<a id="challan_bank_account_title" href="#" data-title="<?php _e('Type bank account title') ?>"
								   data-inputclass="form-control">
									<?php echo $db->get_option( "challan_bank_account_title", "" ) ?>
								</a>
							</td>
							<td>
                            <span class="text-muted">
                            <?php _e( 'This account title will print on challan form' ) ?>
                            </span>
							</td>
						</tr>
						<tr>
							<td><?php _e( 'Bank account number' ) ?></td>
							<td>
								<a id="challan_bank_account_number" href="#" data-title="<?php _e('Type bank account number') ?>"
								   data-inputclass="form-control">
									<?php echo $db->get_option( "challan_bank_account_number", "" ) ?>
								</a>
							</td>
							<td>
                            <span class="text-muted">
                            <?php _e( 'This account number will print on challan form' ) ?>
                            </span>
							</td>
						</tr>
						<tr>
							<td><?php _e( 'Bottom note on challan' ) ?></td>
							<td>
								<a id="challan_bottom_note" href="#" data-title="<?php _e('Type challan bottom note') ?>"
								   data-inputclass="form-control" data-type="textarea">
									<?php echo $db->get_option( "challan_bottom_note", "" ) ?>
								</a>
							</td>
							<td>
                            <span class="text-muted">
                            <?php _e( 'This note will appear at bottom on challan' ) ?>
                            </span>
							</td>
						</tr>
						</tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>
<script src="<?php echo \Theme::url() ?>js/app_settings.js?<?php echo md5_file(\Theme::path().'js/app_settings.js') ?>"></script>
<script>
	jQuery( document ).ready( function() {
		FormEditable.init();
	} );
</script>

<script type="text/javascript">

</script>
</body>
<!-- END BODY -->
</html>