<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "administrator" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$title = __("Fine Management");
include_once( __DIR__ . "/header.php" );
include_once( LIBRARY_PATH . "templates/panel/fine.tpl" );
$Fine = new Fine();
?>

<script>
	var FineID = "";
</script>

<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>

	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="modal fade" id="fine-modal" tabindex="-1" role="dialog" aria-hidden="true">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
							<h4 class="modal-title"><?php _e("Fine") ?></h4>
						</div>
						<div class="modal-body">
							<form name="form1" id="form1" class="form1" method="post" action="ajax/fine.php?save">
								<input type="hidden" name="id" id="id" value="0">

								<label for="name"><?php _e("Fine name") ?></label><br />
								<input class="col-md-12 form-control" title="<?php _e("Fine Name") ?>" type="text" name="name" id="name" required="required" placeholder="<?php _e("Fine Name") ?>">

								<label for="amount"><?php _e("Amount") ?></label><br />
								<input min="0" class="col-md-12 form-control" title="<?php _e("Fine Amount") ?>" type="number" name="amount" id="amount" required="required" placeholder="<?php _e("Amount") ?>">

								<label for="amount_type"><?php _e("Amount Type") ?></label><br />
								<select class="col-md-12 form-control" title="<?php _e("Amount type") ?>" name="amount_type" id="amount_type">
									<option value="Percentage"><?php _e("Percentage %") ?></option>
									<option value="Amount"><?php _e("Amount - Fix") ?></option>
								</select>

								<label for="fine_implement"><?php _e("Fine Implementation") ?></label><br />
								<select class="col-md-12 form-control" title="<?php _e("Fine Implementation") ?>" name="fine_implement" id="fine_implement">
									<option value="Daily"><?php _e("Daily Apply") ?></option>
									<option value="Once"><?php _e("Once") ?></option>
								</select>
							</form>
						</div>
						<div class="modal-footer">
							<div class="btn-group">
								<button type="button" class="btn default" data-dismiss="modal"><?php _e("Close") ?></button>
								<button type="button" class="btn btn-primary" onclick="$('#form1').trigger('submit')"><?php _e("Save Fine") ?></button>
							</div>
						</div>
					</div>
				</div>
			</div>

			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e('Fine') ?>
						<small><?php _e('Fine management') ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button type="button" class="btn red del_multi_btn"><i class="fa fa-trash"></i> <?php _e('Delete') ?></button>
							<button type="button" onclick="OpenForm()" class="btn btn-primary"><i class="fa fa-plus"></i> <?php _e('Add Fine') ?></button>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e('Home') ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="fine.php">
								<?php _e('Fine Management') ?>
							</a>
						</li>

					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<table class="table table-bordered table-striped" id="table1">
						<thead>
						<tr class="heading">
							<th>
								<label class="href">
									<input type="checkbox" id="checkbox">
									<?php _e('ID') ?>
								</label>
							</th>
							<th><?php _e('Name') ?></th>
							<th><?php _e('Amount') ?></th>
							<th><?php _e('Implementation') ?></th>
							<th style="width:40px;">&nbsp;</th>
						</tr>
						</thead>
						<tbody>
						<?php $rows = $Fine->get_list();
						foreach ( $rows as $row ) { ?>
							<tr data-id='<?php echo $row["id"] ?>' id='TR<?php echo $row["id"] ?>' class="href">
								<td>
									<input name="ids[]" type="checkbox" class="checkbox" value="<?php echo $row["id"] ?>">
									<?php echo $row["id"] ?>
								</td>
								<td><?php echo  $row["name"] ?></td>
								<td><?php echo $row["amount2"] ?></td>
                                <td><?php echo $row["fine_implement"] ?></td>
								<td style="text-align:right">
	                                <a class="btn blue btn-xs edit_btn" href="#" title="<?php _e('Edit Fine') ?>" data-id="<?php echo $row["id"] ?>">
	                                    <i class="fa fa-edit"></i>
	                                </a>
								</td>
							 </tr>
						<?php } ?>
						</tbody>
					</table>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script src="<?php echo ASSETS_URL ?>script_js/fine.js?<?php echo md5_file( ASSETS_PATH . "script_js/fine.js" ) ?>"></script>
</body>
<!-- END BODY -->
</html><?php //debug($sum_time); debug($profiler_array); ?>