var FormEditable = function () {

    $.mockjaxSettings.responseTime = 500;

    var log = function (settings, response) {
        var s = [],
            str;
        s.push(settings.type.toUpperCase() + ' url = "' + settings.url + '"');
        for (var a in settings.data) {
            if (settings.data[a] && typeof settings.data[a] === 'object') {
                str = [];
                for (var j in settings.data[a]) {
                    str.push(j + ': "' + settings.data[a][j] + '"');
                }
                str = '{ ' + str.join(', ') + ' }';
            } else {
                str = '"' + settings.data[a] + '"';
            }
            s.push(a + ' = ' + str);
        }
        s.push('RESPONSE: status = ' + response.status);

        if (response.responseText) {
            if ($.isArray(response.responseText)) {
                s.push('[');
                $.each(response.responseText, function (i, v) {
                    s.push('{value: ' + v.value + ', text: "' + v.text + '"}');
                });
                s.push(']');
            } else {
                s.push($.trim(response.responseText));
            }
        }
        s.push('--------------------------------------\n');
        $('#console').val(s.join('\n') + $('#console').val());
    }

    var initAjaxMock = function () {
        //ajax mocks
        $.mockjax({
            url: '/error',
            status: 400,
            statusText: 'Bad Request',
            response: function (settings) {
                this.responseText = 'Please input correct value';
            }
        });

        $.mockjax({
            url: '/status',
            status: 500,
            response: function (settings) {
                this.responseText = 'Internal Server Error';
                log(settings, this);
            }
        });

        $.mockjax({
            url: '/classes',
            response: function (settings) {
                this.responseText = classes;
                //log(settings, this);
            }
        });

    }

    var initEditables = function () {

        //set editable mode based on URL parameter
        if (App.getURLParameter('mode') == 'inline') {
            $.fn.editable.defaults.mode = 'inline';
            $('#inline').attr("checked", true);
            jQuery.uniform.update('#inline');
        } else {
            $('#inline').attr("checked", false);
            jQuery.uniform.update('#inline');
        }

        //global settings 
        $.fn.editable.defaults.inputclass = 'form-control';
        $.fn.editable.defaults.url = ajax_url;

        //editables element samples
        $('#date_format1,#date_format2,#date_time_format1,#date_time_format2').editable({
            url: ajax_url,
            type: 'text',
            pk: my_id,
            name: $(this).attr("id"),
            title: 'Type new value',
            success: function(response, newValue) {
                if (!response.status) {
                    return "Data saving error";
                }
                if(response.status == 'error') return response.msg; //msg will be shown in editable form
                var newID = $(this).attr("id") + "_span";
                $("#" + newID).html("(Example: " + date(newValue) + ")" );
            },
            validate: function (value) {
                if ($.trim(value) == '') return 'This field is required';
            }
        });
        $('#admin_email').editable({
            url: ajax_url,
            type: 'email',
            pk: my_id,
            name: 'admin_email',
            title: 'Type administrator email',
            success: function(response, newValue) {
                if (!response.status) return "Data saving error";
                if(response.status == 'error') return response.msg; //msg will be shown in editable form
            },
            validate: function (value) {
                if (!is_email(value)) return 'Please provide valid email address';
            },
        });
        $('#sms_api,#system,#inst_address,#inst_contacts').editable({
            url: ajax_url,
            type: 'text',
            pk: my_id,
            name: $(this).attr("id"),
            title: 'Type SMS API key',
            success: function(response, newValue) {
                if (!response.status) return "Data saving error";
                if(response.status == 'error') return response.msg; //msg will be shown in editable form
            }
        });
        $("#fee_schedule_days_before").editable({
            url: ajax_url,
            pk: my_id,
            name: $(this).attr('id'),
            success: function(response, newValue) {
                if (!response.status) return "Data saving error";
                if(response.status == 'error') return response.msg; //msg will be shown in editable form
            }
        });
	    $("#challan_bank_name, #challan_bank_account_title, #challan_bank_account_number, #challan_bottom_note").editable({
		    url: ajax_url,
		    pk: my_id,
		    name: $(this).attr('id'),
		    success: function(response, newValue) {
			    if (!response.status) return "Data saving error";
			    if(response.status == 'error') return response.msg; //msg will be shown in editable form
		    }
	    });
        $('#currency').editable({
            url: ajax_url,
            type: 'text',
            pk: my_id,
            name: 'currency',
            title: 'Type currency name or symbole e.g. Rs.',
            success: function(response, newValue) {
                if (!response.status) return "Data saving error";
                if(response.status == 'error') return response.msg; //msg will be shown in editable form
            },
            validate: function (value) {
                if ($.trim(value) == '') return 'This field is required';
            }
        });
        $('#currency_dec').editable({
            url: ajax_url,
            pk: my_id,
            name: 'currency_dec',
            title: 'Select currency decimals',
            type: 'select',
            success: function(response, newValue) {
                if (!response.status) return "Data saving error";
                if(response.status == 'error') return response.msg; //msg will be shown in editable form
            },
            source: [{
                    value: '0',
                    text: '0'
                }, {
                    value: '1',
                    text: '1'
                }, {
                    value: '2',
                    text: '2'
                }, {
                    value: '3',
                    text: '3'
                }
            ],
        });
        $('#marks_dec').editable({
            url: ajax_url,
            pk: my_id,
            name: 'marks_dec',
            title: 'Select currency decimals',
            type: 'select',
            success: function(response, newValue) {
                if (!response.status) return "Data saving error";
                if(response.status == 'error') return response.msg; //msg will be shown in editable form
            },
            source: [{
                    value: '0',
                    text: '0'
                }, {
                    value: '1',
                    text: '1'
                }, {
                    value: '2',
                    text: '2'
                }, {
                    value: '3',
                    text: '3'
                }
            ],
        });
        $('#is_rtl').editable({
            url: ajax_url,
            type: 'select',
            pk: my_id,
            name: 'is_rtl',
            title: 'Select layout for application',
            success: function(response, newValue) {
                if (!response.status) return "Data saving error";
                if(response.status == 'error') return response.msg; //msg will be shown in editable form
            },
            validate: function (value) {
                if ($.trim(value) == '') return 'This field is required';
            },
            source: [{
                    value: '0',
                    text: 'No'
                }, {
                    value: '1',
                    text: 'Yes'
                }
            ],
        });
        $('#page_size').editable({
            url: ajax_url,
            type: 'select',
            pk: my_id,
            name: 'page_size',
            title: 'Select page size for PDF report file',
            success: function(response, newValue) {
                if (!response.status) return "Data saving error";
                if(response.status == 'error') return response.msg; //msg will be shown in editable form
            },
            validate: function (value) {
                if ($.trim(value) == '') return 'This field is required';
            },
            source: [{
                    value: 'Legal',
                    text: 'Legal (8.5 x 14 in)'
                }, {
                    value: 'Letter',
                    text: 'Letter (8.5 x 11 in)'
                }, {
                    value: 'A4',
                    text: 'A4 (8.3 x 11.7 in)'
                }, {
                    value: 'A5',
                    text: 'A5 (5.8 x 8.2 in)'
                }, {
                    value: 'A6',
                    text: 'A6 (4.1 x 5.8 in)'
                }, {
                    value: 'A7',
                    text: 'A7 (2.9 x 4.1 in)'
                }
            ],
        });
        $('#page_orientation').editable({
            url: ajax_url,
            type: 'select',
            pk: my_id,
            name: 'page_orientation',
            title: 'Select page orientation for PDF report file',
            success: function(response, newValue) {
                if (!response.status) return "Data saving error";
                if(response.status == 'error') return response.msg; //msg will be shown in editable form
            },
            validate: function (value) {
                if ($.trim(value) == '') return 'This field is required';
            },
            source: [{
                    value: 'P',
                    text: 'Portrait'
                }, {
                    value: 'L',
                    text: 'Landscape'
                }
            ],
        });
    }

	$(document).on("change", "#default_phone_country", function(  ) {
		val = $(this).val();
		$.post( theme_url + "ajax/app_settings.php?save_phone_default_country", {default_phone_country: val}, function( data ) {
			if ( data.status && data.status=="OK" ) {
			    Success("Default country code saved successfully!");
            } else if ( data.error ) {
			    Error(data.error);
            } else {
			    Error("Unknown error");
            }
		} );
	});

    return {
        //main function to initiate the module
        init: function () {

            // inii ajax simulation
            initAjaxMock();

            // init editable elements
            initEditables();
            
            // init editable toggler
            $('#enable').click(function () {
                $('#user .editable').editable('toggleDisabled');
            });

            // init 
            /*$('#inline').on('change', function (e) {
                if ($(this).is(':checked')) {
                    window.location.href = 'form_editable.html?mode=inline';
                } else {
                    window.location.href = 'form_editable.html';
                }
            });*/

            // handle editable elements on hidden event fired
            $('#user .editable').on('hidden', function (e, reason) {
                if (reason === 'save' || reason === 'nochange') {
                    var $next = $(this).closest('tr').next().find('.editable');
                    if ($('#autoopen').is(':checked')) {
                        setTimeout(function () {
                            $next.editable('show');
                        }, 300);
                    } else {
                        $next.focus();
                    }
                }
            });
        }
    };
}();