var RemoveFiles = Array();
$( function() {
	make_html();

	$( document ).on( "click", ".edit_link", function( event ) {
		event.preventDefault();
		$( "#course_form" ).resetForm();
		set_percentage( 0 );
		id = $( this ).attr( "data-id" );
		$( "#files, #remove_files_input" ).html( '' );
		RemoveFiles = Array();
		$.each( Data, function( i, data ) {
			if ( id==data.id ) {
				$( "#course_form input[name=id]" ).val( id );
				$( "#course_form input[name=name]" ).val( data.name );
				$( "#course_form textarea[name=description]" ).val( data.description );
				if ( data.classes ) {
					$( "#classes" ).select2( "val", data.classes.split( ',' ) );
				} else {
					$( "#classes" ).select2( "val", '' );
				}
				if (data.subjects) {
					$( "#subjects" ).select2( "val", data.subjects.split( ',' ) );
				} else {
					$( "#subjects" ).select2( "val", '' );
				}

				if (data.teachers) {
					$( "#teachers" ).select2( "val", data.teachers.split( ',' ) );
				} else {
					$( "#teachers" ).select2( "val", '' );
				}

				$.each( data.files, function( i, file ) {
					h = "<div class='btn-group'>" +
					    "<a target='_blank' href='download.php?file=" + urlencode(basename( file )) + "&type=course_material&id=" + id + "' class='btn btn-xs blue file_link'>" + basename( file ) + "</a>" +
					    "<a class='btn btn-xs red file_remove' title='Remove this file'><i class='fa fa-trash'></i></a>" +
					    "</div> ";
					$( "#files" ).append( h );
					//$("#files").append( "<a class='btn btn-xs red fa fa-trash file_remove href'>" + basename(file) + "</a> " );
				} );
				$( "#course_modal" ).modal( "show" );
			}
		} );
	} );
	$( document ).on( "click", "#add_btn", function( event ) {
		event.preventDefault();
		RemoveFiles = Array();
		disable_form( false );
		$( "#remove_files_input" ).html( '' );
		$( "#course_form" ).trigger('reset');
		$('div#files').html('');
		$( "#classes, #subjects, #teachers" ).select2( 'val', '' );
		$( "#id" ).val( "0" );
		$( "#course_modal" ).modal( "show" );
		set_percentage( 0 );
	} );
	$( document ).on( "click", "#del_btn", function( event ) {
		event.preventDefault();
		if ( $( ".check:checked" ).length==0 ) {
			Error( select_one_or_more_string );
			return false;
		}

		if ( !confirm( areyousure_string ) ) {
			return false;
		}

		Block();
		$.post( "ajax/course_material_list.php?del", $( ".check:checked" ).serialize(), function( data ) {
			UnBlock();
			if ( typeof data=="object" ) {
				success = failed = 0;
				$.each( data, function( id, response ) {
					if ( response=="OK" ) {
						success++;
						$( "#tr_" + id ).fadeOut( function() {
							$( this ).remove();
						} );
					} else {
						failed++;
					}
				} );

				if ( failed==0 ) {
					Success( selected_delete_success_string );
				} else {
					msg_string = str_replace( "%1", success, msg_string );
					msg_string = str_replace( "%2", failed, msg_string );
					Warning( msg_string );
				}
			} else {
				Error( data );
			}
		} );
	} );
	$( document ).on( "submit", "#course_form", function( event ) {
		event.preventDefault();

		if ( !$( "#course_form" ).validate().form() ) {
			return false;
		}

		$( "#course_form" ).ajaxSubmit( {
			dataType: 'json',
			beforeSerialize: function() {
				$.each( RemoveFiles, function( i, file ) {
					$( "#remove_files_input" ).append( "<input type='hidden' name='remove_files[]' value='" + file + "'>" );
				} );
			},
			beforeSubmit: function() {
				disable_form( true );
			},
			success: function( responseText, statusText, xhr, $form ) {
				disable_form( false );
				if ( responseText.status=="OK" ) {
					Success( success_string );
					// $( "#course_modal" ).modal( "hide" );
					// $.post( "ajax/course_material_list.php?get_data", function( data ) {
					// 	Data = data;
					// 	make_html();
					// } );
					window.location.href = 'course_material_list.php';
				} else {
					Error( responseText.status );
				}
			},
			error: function( response ) {
				disable_form( false );
				Error( response.responseText );
			},
			uploadProgress: function( event, position, total, percentComplete ) {
				//console.log( position + " of " + total + " " + percentComplete + "%" );
				set_percentage( percentComplete );
			},
			complete: function( xhr ) {
				disable_form( false );
				$( "#course_modal" ).modal( "hide" );
			}
		} );
	} );

	$( document ).on( "click", ".file_remove", function( event ) {
		event.preventDefault();

		file = $( this ).prev().html();
		RemoveFiles.push( file );
		$( this ).closest( 'div' ).remove();
	} );

	if ( get_url_variables().add ) {
		$("#add_btn").trigger("click");
		remove_url_parameter('add');
	}
} );
var make_html = function() {
	html = tmpl( "tbody1_template", Data );
	$( "#tbody1" ).html( html );
	$( ".check" ).uniform();
}
var set_percentage = function( percent ) {
	var elem = document.getElementById( "myBar" );
	elem.style.width = percent + '%';
	elem.innerHTML = percent + '%';
}
var disable_form = function( action ) {
	$( "#course_form input, #course_form select, #course_form textarea, #save, #cancel" ).attr( "disabled", action );
}