<?php
header( 'Content-Type: application/javascript' );
include (__DIR__."/../../../library.php");
##include_once $_theme->path()."js/moment.min.js";
?>
var HolidayID = 0;
var Calendar = function() {
	return {
		//main function to initiate the module
		init: function() {
			Calendar.initCalendar();
		},

		initCalendar: function() {

			if ( !jQuery().fullCalendar ) {
				return;
			}

			var date = new Date();
			var d = date.getDate();
			var m = date.getMonth();
			var y = date.getFullYear();

			var h = {};

			if ( App.isRTL() ) {
				if ( $( '#calendar' ).parents( ".portlet" ).width() <= 720 ) {
					$( '#calendar' ).addClass( "mobile" );
					h = {
						right: 'title, prev, next',
						center: '',
						right: 'agendaDay, agendaWeek, month, today'
					};
				} else {
					$( '#calendar' ).removeClass( "mobile" );
					h = {
						right: 'title',
						center: '',
						left: 'month, today, prev,next'
						//left: 'agendaDay, agendaWeek, month, today, prev,next'
					};
				}
			} else {
				if ( $( '#calendar' ).parents( ".portlet" ).width() <= 720 ) {
					$( '#calendar' ).addClass( "mobile" );
					h = {
						left: 'title, prev, next',
						center: '',
						right: 'today,month,agendaWeek,agendaDay'
					};
				} else {
					$( '#calendar' ).removeClass( "mobile" );
					h = {
						left: 'title',
						center: 'prevYear,nextYear',
						right: 'prev,next,today,month'
						//right: 'prev,next,today,month,agendaWeek,agendaDay'
					};
				}
			}

			var initDrag = function( el ) {
				// create an Event Object (http://arshaw.com/fullcalendar/docs/event_data/Event_Object/)
				// it doesn't need to have a start or end
				var eventObject = {
					title: $.trim( el.text() ) // use the element's text as the event title
				};
				// store the Event Object in the DOM element so we can get to it later
				el.data( 'eventObject', eventObject );
				// make the event draggable using jQuery UI
				el.draggable( {
					zIndex: 999,
					revert: true, // will cause the event to go back to its
					revertDuration: 0 //  original position after the drag
				} );
			}

			var addEvent = function( title ) {
				title = title.length == 0 ? "Untitled Event" : title;
				var html = $( '<div class="external-event label label-default">' + title + '</div>' );
				jQuery( '#event_box' ).append( html );
				initDrag( html );
			}

			$( '#external-events div.external-event' ).each( function() {
				initDrag( $( this ) )
			} );

			$( '#event_add' ).unbind( 'click' ).click( function() {
				var title = $( '#event_title' ).val();
				addEvent( title );
			} );

			//predefined events
			/*$('#event_box').html("");
			addEvent("My Event 1");
			addEvent("My Event 2");
			addEvent("My Event 3");
			addEvent("My Event 4");
			addEvent("My Event 5");
			addEvent("My Event 6");*/

			$( '#calendar' ).fullCalendar( 'destroy' ); // destroy the calendar
			$( '#calendar' ).fullCalendar( { //re-initialize the calendar
				dayClick: function() {
					//alert('a day has been clicked!');
				},
				eventClick: function( calEvent, jsEvent, view ) {
					HolidayID = calEvent.id;
					$( "#holidy_action" ).modal( "show" );
					//alert('ID: ' + calEvent.id);
					//alert('Event: ' + calEvent.title);
					//alert('Coordinates: ' + jsEvent.pageX + ',' + jsEvent.pageY);
					//alert('View: ' + view.name);

					// change the border color just for fun
					//$(this).css('border-color', '#ff0000');
					$( this ).css( 'background-color', '#ff0000' );

				},
				selectable: true,
				unselectAuto: false,
				weekends: true,
				firstDay: 1,
				isRTL: false,
				weekNumbers: true,
				aspectRatio: 1.35,
				header: h,
				slotMinutes: 15,
				editable: false,
				droppable: true, // this allows things to be dropped onto the calendar !!!
				drop: function( date, allDay ) { // this function is called when something is dropped

					// retrieve the dropped element's stored Event Object
					var originalEventObject = $( this ).data( 'eventObject' );
					// we need to copy it, so that multiple events don't have a reference to the same object
					var copiedEventObject = $.extend( {}, originalEventObject );

					// assign it the date that was reported
					copiedEventObject.start = date;
					copiedEventObject.allDay = allDay;
					copiedEventObject.className = $( this ).attr( "data-class" );

					// render the event on the calendar
					// the last `true` argument determines if the event "sticks" (http://arshaw.com/fullcalendar/docs/event_rendering/renderEvent/)
					$( '#calendar' ).fullCalendar( 'renderEvent', copiedEventObject, true );

					// is the "remove after drop" checkbox checked?
					if ( $( '#drop-remove' ).is( ':checked' ) ) {
						// if so, remove the element from the "Draggable Events" list
						$( this ).remove();
					}
				},
				//events : [{"id":"1","title":"My bday","start":"2014-06-11"}]
				/*events: function(start, end, timezone, callback) {
					$.ajax({
						url: '<?php echo Urls::get_url( "ajax", 0, "action=getHolidays" ) ?>',
                        dataType: 'json',
                        type: 'POST',
                        data: {
                            // our hypothetical feed requires UNIX timestamps
                            //start: start.unix(),
                            //end: end.unix()
                            from_date: moment(start).format('l'),
                            to_date: moment(end).format('l')
                        },
                        success: function(doc) {
                            //var events = [];
                            //$(doc).find('event').each(function() {
                            //    events.push({
                            //        title: $(this).attr('title'),
                            //        start: $(this).attr('start') // will be parsed
                            //    });
                            //});
                            callback(doc);
                            //alert(doc);
                        },
                    });
                },*/
				events: {
					url: '<?php echo Urls::get_url( "ajax",0,"action=getHolidays" ) ?>',
					error: function() {
						$( '#script-warning' ).show();
					}
				},
				loading: function( bool ) {
					$( '#loading' ).toggle( bool );
				},
				defaultDate: '<?php echo \Dates::mysql_date() ?>',
			} );

		}

	};

}();