$( function() {
	$( document ).on( 'click', '#chalan_form_btn', function(e) {
		// e.preventDefault();
		// alert ('Clicked!');
	} );
} )

var FormEditable = function() {

	$.mockjaxSettings.responseTime = 500;

	var log = function( settings, response ) {
		var s = [],
			str;
		s.push( settings.type.toUpperCase() + ' url = "' + settings.url + '"' );
		for ( var a in settings.data ) {
			if ( settings.data[ a ] && typeof settings.data[ a ]==='object' ) {
				str = [];
				for ( var j in settings.data[ a ] ) {
					str.push( j + ': "' + settings.data[ a ][ j ] + '"' );
				}
				str = '{ ' + str.join( ', ' ) + ' }';
			} else {
				str = '"' + settings.data[ a ] + '"';
			}
			s.push( a + ' = ' + str );
		}
		s.push( 'RESPONSE: status = ' + response.status );

		if ( response.responseText ) {
			if ( $.isArray( response.responseText ) ) {
				s.push( '[' );
				$.each( response.responseText, function( i, v ) {
					s.push( '{value: ' + v.value + ', text: "' + v.text + '"}' );
				} );
				s.push( ']' );
			} else {
				s.push( $.trim( response.responseText ) );
			}
		}
		s.push( '--------------------------------------\n' );
		$( '#console' ).val( s.join( '\n' ) + $( '#console' ).val() );
	}

	var initAjaxMock = function() {
		//ajax mocks

		$.mockjax( {
			url: '/post',
			response: function( settings ) {
				log( settings, this );
			}
		} );

		$.mockjax( {
			url: '/error',
			status: 400,
			statusText: 'Bad Request',
			response: function( settings ) {
				this.responseText = 'Please input correct value';
				log( settings, this );
			}
		} );

		$.mockjax( {
			url: '/status',
			status: 500,
			response: function( settings ) {
				this.responseText = 'Internal Server Error';
				log( settings, this );
			}
		} );

		$.mockjax( {
			url: '/classes',
			response: function( settings ) {
				this.responseText = classes;
				//log(settings, this);
			}
		} );

	}

	var initEditables = function() {

		//set editable mode based on URL parameter
		if ( App.getURLParameter( 'mode' )=='inline' ) {
			$.fn.editable.defaults.mode = 'inline';
			$( '#inline' ).attr( "checked", true );
			jQuery.uniform.update( '#inline' );
		} else {
			$( '#inline' ).attr( "checked", false );
			jQuery.uniform.update( '#inline' );
		}

		//global settings
		$.fn.editable.defaults.inputclass = 'form-control';
		$.fn.editable.defaults.url = ajax_url;

		//editables element samples
		$( '#roll' ).editable( {
			url: ajax_url,
			type: 'text',
			pk: student_id,
			name: 'roll',
			title: 'Enter roll number',
			success: function( response, newValue ) {
				if ( !response.status ) {
					return "Data saving error";
				}
				if ( response.status=='error' ) {
					return response.msg;
				} //msg will be shown in editable form
				$( "#rollspan" ).html( newValue );
			}
		} );

		$( '#fee' ).editable( {
			url: ajax_url,
			type: 'number',
			pk: student_id,
			name: 'fee',
			title: 'Type stduent fee',
			min: 0,
			success: function( response, newValue ) {
				if ( !response.status ) {
					return "Data saving error";
				}
				if ( response.status=='error' ) {
					return response.msg;
				} //msg will be shown in editable form
			},
			validate: function( value ) {
				if ( !is_numeric( value ) ) {
					return "Provide only valid number as fee";
				}
				if ( value<0 ) {
					return "Negative number is not acceptable";
				}
			},
			display: function( value, sourceData ) {
				$( this ).text( number_format( value, dec ) );
			}
		} );

		$( '#admission_date' ).editable( {
			rtl: App.isRTL(),
			url: ajax_url,
			pk: student_id,
			name: 'admission_date',
			title: 'Select admission date',
			success: function( response, newValue ) {
				if ( !response.status ) {
					return "Data saving error";
				}
				if ( response.status=='error' ) {
					return response.msg;
				} //msg will be shown in editable form
			}
		} );

		$( '#father_name,#name,#guardian_name,#guardian_cell,#admin_notes,#student_category' ).editable( {
			url: ajax_url,
			type: 'text',
			pk: student_id,
			name: $( this ).attr( "id" ),
			inputclass: 'form-control input-xlarge',
			validate: function( value ) {
				if ( $( this ).attr( "id" )!="admin_notes" && $.trim( value )=='' ) {
					return 'This field is required';
				}
			},
			success: function( response, newValue ) {
				if ( !response.status ) {
					return "Data saving error";
				}
				if ( response.status=='error' ) {
					return response.msg;
				} //msg will be shown in editable form
				if ( $( this ).attr( "id" )=="name" ) {
					$( "#nameh2" ).html( newValue );
				} else if ( $( this ).attr( "id" )=="guardian_name" ) {
					$( "#gnamespan" ).html( newValue );
				} else if ( $( this ).attr( "id" )=="guardian_cell" ) {
					$( "#cellspan" ).html( newValue );
				}
			}
		} );

		$( '#class_batch' ).editable( {
			showbuttons: false,
			source: classes,
			url: ajax_url,
			pk: student_id,
			name: 'class_batch',
			title: 'Select class and year/batch',
			validate: function( value ) {
				if ( $.trim( value )=='' ) {
					return 'This field is required';
				}
			},
			success: function( response, newValue ) {
				if ( !response.status ) {
					return "Data saving error";
				}
				if ( response.status=='error' ) {
					return response.msg;
				} //msg will be shown in editable form
				$( "#classspan" ).html( response.showtext );
			}
		} );

		$( '#dob' ).editable( {
			inputclass: 'form-control',
			url: ajax_url,
			pk: student_id,
			name: 'dob',
			type: 'combodate',
			title: 'Select date of birth',
			success: function( response, newValue ) {
				if ( !response.status ) {
					return "Data saving error";
				}
				if ( response.status=='error' ) {
					return response.msg;
				} //msg will be shown in editable form
			}
		} );
		$( '#guardian_dob' ).editable( {
			inputclass: 'form-control',
			url: ajax_url,
			pk: student_id,
			name: 'guardian_dob',
			type: 'combodate',
			title: 'Select guardian date of birth',
			success: function( response, newValue ) {
				if ( !response.status ) {
					return "Data saving error";
				}
				if ( response.status=='error' ) {
					return response.msg;
				} //msg will be shown in editable form
			}
		} );

		$( '#gender' ).editable( {
			inputclass: 'form-control',
			url: ajax_url,
			pk: student_id,
			name: 'gender',
			source: [
				{
					value: 'M',
					text: 'Male'
				}, {
					value: 'F',
					text: 'Female'
				}
			],
			display: function( value, sourceData ) {
				var colors = {
						"": "gray",
						'M': "green",
						'F': "blue"
					},
					elem = $.grep( sourceData, function( o ) {
						return o.value==value;
					} );

				if ( elem.length ) {
					$( this ).text( elem[ 0 ].text ).css( "color", colors[ value ] );
				} else {
					$( this ).empty();
				}
			},
			success: function( response, newValue ) {
				if ( !response.status ) {
					return "Data saving error";
				}
				if ( response.status=='error' ) {
					return response.msg;
				} //msg will be shown in editable form
			}
		} );

		$( "#blood_group" ).editable( {
			inputclass: 'form-control',
			url: ajax_url,
			pk: student_id,
			name: 'blood_group',
			source: bgs,
			success: function( response, newValue ) {
				if ( !response.status ) {
					return "Data saving error";
				}
				if ( response.status=='error' ) {
					return response.msg;
				} //msg will be shown in editable form
			}
		} );

		$( '#birth_place' ).editable( {
			inputclass: 'form-control',
			url: ajax_url,
			pk: student_id,
			name: 'birth_place'
		} );

		$( '#nationality' ).editable( {
			inputclass: 'form-control',
			url: ajax_url,
			pk: student_id,
			name: 'nationality'
		} );

		$( "#religion" ).editable( {
			inputclass: 'form-control',
			url: ajax_url,
			pk: student_id,
			name: 'religion',
			source: [
				{
					value: 'Islam',
					text: 'Islam'
				}, {
					value: "Christian",
					text: "Christian"
				}, {
					value: 'Sikh',
					text: 'Sikh'
				}, {
					value: 'Hindu',
					text: 'Hindu'
				}, {
					value: 'Other',
					text: 'Other'
				}
			],
			success: function( response, newValue ) {
				if ( !response.status ) {
					return "Data saving error";
				}
				if ( response.status=='error' ) {
					return response.msg;
				} //msg will be shown in editable form
			}
		} );
		$( '#prev_course1,#prev_year1,#prev_marks1,#prev_institute1,#guardian_phone,#guardian_city,#guardian_state,#guardian_address,#address,#city,#state,#phone,#cell,#email,#guardian_education,#guardian_income,#guardian_occupation,#guardian_email' ).editable( {
			inputclass: 'form-control input-large',
			pk: student_id,
			name: $( this ).attr( "id" ),
			success: function( response, newValue ) {
				if ( !response.status ) {
					return "Data saving error";
				}
				if ( response.status=='error' ) {
					return response.msg;
				} //msg will be shown in editable form

				if ( $( this ).attr( "id" )=="guardian_address" ) {
					$( "#gaddressspan" ).html( newValue );
				}
				//if ($(this).attr("id")=="prev_marks1") newValue = parseInt(newValue);
			}
		} );
		$( '#is_sms,#is_email' ).editable( {
			inputclass: 'form-control',
			url: ajax_url,
			pk: student_id,
			name: $( this ).attr( "id" ),
			source: [
				{
					value: '0',
					text: 'No'
				}, {
					value: '1',
					text: 'Yes'
				}
			],
			success: function( response, newValue ) {
				if ( !response.status ) {
					return "Data saving error";
				}
				if ( response.status=='error' ) {
					return response.msg;
				} //msg will be shown in editable form
			}
		} );
		$( "#guardian_relation" ).editable( {
			inputclass: 'form-control',
			url: ajax_url,
			pk: student_id,
			name: 'guardian_relation',
			validate: function( value ) {
				if ( $.trim( value )=='' ) {
					return 'This field is required';
				}
			},
			source: relations,
			success: function( response, newValue ) {
				if ( !response.status ) {
					return "Data saving error";
				}
				if ( response.status=='error' ) {
					return response.msg;
				} //msg will be shown in editable form
			}
		} );
		$( '#nic' ).editable( {
			inputclass: 'form-control nic',
			pk: student_id,
			name: $( this ).attr( "id" ),
			success: function( response, newValue ) {
				if ( !response.status ) {
					return "Data saving error";
				}
				if ( response.status=='error' ) {
					return response.msg;
				} //msg will be shown in editable form
			}
		} );
		$( '#subjects' ).editable( {
			inputclass: 'form-control input-xlarge',
			url: ajax_url,
			pk: student_id,
			select2: {
				tags: subjects,
				tokenSeparators: [ ",", " " ]
			},
			name: "subjects",
			success: function( response, newValue ) {
				if ( !response.status ) {
					return "Data saving error";
				}
				if ( response.status=='error' ) {
					return response.msg;
				} //msg will be shown in editable form
			}
		} );
	}

	return {
		//main function to initiate the module
		init: function() {

			// inii ajax simulation
			initAjaxMock();

			// init editable elements
			initEditables();

			// init editable toggler
			$( '#enable' ).click( function() {
				$( '#user .editable' ).editable( 'toggleDisabled' );
			} );

			// init
			/*$('#inline').on('change', function (e) {
				if ($(this).is(':checked')) {
					window.location.href = 'form_editable.html?mode=inline';
				} else {
					window.location.href = 'form_editable.html';
				}
			});*/

			// handle editable elements on hidden event fired
			$( '#user .editable' ).on( 'hidden', function( e, reason ) {
				if ( reason==='save' || reason==='nochange' ) {
					var $next = $( this ).closest( 'tr' ).next().find( '.editable' );
					if ( $( '#autoopen' ).is( ':checked' ) ) {
						setTimeout( function() {
							$next.editable( 'show' );
						}, 300 );
					} else {
						$next.focus();
					}
				}
			} );
		}

	};

}();