<?php
## Direct files access from URL is not allowed.
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}

$_GET["student_id"] = isset( $_GET["student_id"] ) ? $_GET["student_id"] : 0;

include_once( LIBRARY_PATH . "templates/panel/library_assign_books.tpl" );

## Check if this page is allowed
if ( ! \Admins\UserInfo::is_allowed( "library_assign_books" ) || ! \Admins\UserInfo::is_allowed( "manage_library" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$LibraryBooks = new LibraryBooks();
$title        = __( "Issue Books to Students" );
include_once( __DIR__ . "/header.php" ); ?>
<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="modal fade" id="assign_modal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
							<h4 class="modal-title"><?php _e( "Issue Book" ) ?></h4>
						</div>
						<div class="modal-body">
							<form action="#" class="horizontal-form" _lpchecked="1" id="form1">
								<div class="form-body">
									<div class="row">
										<div class="col-md-12">
											<div class="form-group">
												<label class="control-label"><?php _e( "Select Student" ) ?></label>
												<!--<select required="required" data-placeholder="<?php /*_e("Select student") */ ?>" class="form-control" name="student_id" id="student_id">
													<option value="">-- <?php /*_e("Select student") */ ?> --</option>
												</select>-->
												<!--<input type="text" name="student_id" id="student_id" class="form-control">-->
												<input autocomplete="off" value="<?php echo $_GET["student_id"] ?>" required="required"
												       placeholder="<?php _e( "Select Student" ) ?>"
												       type="text" class="form-control" name="student_id" id="student_id">
											</div>
										</div>
									</div>
									<!--/row-->
									<div class="row">
										<div class="col-md-6">
											<div class="form-group">
												<label class="control-label"><?php _e( "Select Book" ) ?></label>
												<select class="form-control select2" name="book_id" id="book_id" required="required">
													<option value=""><?php _e( "Select Book" ) ?></option>
													<?php
													$books = $LibraryBooks->get_book_stocks( "active=1" );
													foreach ( $books["rows"] as $book ) {
														echo "<option value='{$book['id']}'>" . $book["book_name"] . "</option>";
													}
													?>
												</select>
											</div>
										</div>
										<!--/span-->
										<div class="col-md-6">
											<div class="form-group">
												<label class="control-label">
													<?php _e( "How many books to issue?" ) ?>
												</label>
												<input name="assigned_qty" required="required" min="1" type="number"
												       class="form-control" placeholder="<?php _e( "How many books to issue?" ) ?>"
												       value="1">
											</div>
										</div>
									</div>
								</div>
							</form>
						</div>
						<div class="modal-footer">
							<div class="btn-group">
								<button onclick="$('#form1').trigger('submit');" type="button" class="btn blue"><?php _e( "Issue Book" ) ?></button>
								<button type="button" class="btn default" data-dismiss="modal"><?php _e( "Cancel" ) ?></button>
							</div>
						</div>
					</div>
				</div>
			</div>

			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( "Issued Books" ) ?>
						<small><?php _e( "Issued books to students" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<a style="color:#FFF" class="btn green" href="<?php echo Urls::get_url( "library_books" ) ?>">
								<?php _e( "Manage Library" ) ?>
							</a>
							<button id="assign_btn" type="button" class="btn btn-primary">
								<i class="fa fa-plus"></i> <?php _e( "Issue Book" ) ?></button>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#"><?php _e( "Library" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "library_assign_books" ) ?>"><?php _e( "Issued Books" ) ?></a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<div style="max-width: 300px;" class="pull-right">
						<input id="search" type="search" placeholder="<?php _e( "Search" ) ?>" class="form-control">
					</div>
					<?php _e("Total Records") ?>: <span id="total"></span>
					<table class="table table-bordered" id="table1">
						<thead>
						<tr class="heading">
							<th><?php _e("Ref #") ?></th>
							<th><?php _e("Book") ?></th>
							<th><?php _e("Issued") ?></th>
							<th><?php _e("Issued Student") ?></th>
							<th><?php _e("Qty") ?></th>
							<th></th>
						</tr>
						</thead>
						<tbody id="tbody1"></tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>

<?php include_once( __DIR__ . "/footer.php" ); ?>
<script src="<?php echo ASSETS_URL ?>plugins/bootstrap/js/bootstrap2-typeahead.min.js" type="text/javascript"></script>
<script src="<?php echo Urls::get_url( "students.js" ) ?>"></script>
<script>
	var Page = Pages = 1;
	var is_loading = false;

	function load_students() {
		$.each( Students, function( k, student ) {
			$( "#student_id" ).append( '<option>' + student + '</option>' );
		} );
	}

	load_data = function() {
		$.post( "ajax/library_assign_books.php?get_assigned", {
			page: Page,
			search: $( '#search' ).val()
		}, function( obj ) {
			$( "#total" ).text( obj.total_records );
			$( "#temp_row" ).remove();
			if ( Page==1 ) {
				$( "#tbody1" ).html( tmpl( "tbody1_template", obj ) );
			} else {
				$( "#tbody1" ).append( tmpl( "tbody1_template", obj ) );
			}
			Pages = obj.pages;
			is_loading = false;
		} );
	}

	$( function() {
		load_data();

		//load_students();
		$( "#student_id" ).typeahead( {
			source: Students
		} );
		/*$( "#student_id" ).select2( {
			allowClear: true,
			//minimumInputLength: 1,
			placeholder: "Search student name",
			ajax: {
				url: DOMAIN_URL + '?students_js_ajax',
				dataType: 'json',
				data: function( term, page ) {
					return {
						q: term, // search term
					};
				},
				results: function( data, page ) { // parse the results into the format expected by Select2.
					// since we are using custom formatting functions we do not need to alter remote JSON data
					return {
						results: data
					};
				}
			}
		} );*/
		$( document ).on( "click", "#assign_btn", function( event ) {
			$( "#form1" ).trigger( "reset" );
			$( "#assign_modal" ).modal( "show" );
		} );
		$( document ).on( "submit", "#form1", function( event ) {
			event.preventDefault();
			$( "#assign_modal" ).modal( "hide" );
			$.post( "ajax/library_assign_books.php?assign_book", $( "#form1" ).serialize(), function( data ) {
				if ( data=="OK" ) {
					Success( "Book issued to student" );
					load_data();
				} else {
					$( "#assign_modal" ).modal( "show" );
					Error( data );
				}
			} );
		} );
		$( document ).on( "change", "#search", function( event ) {
			event.preventDefault();

			Page = 1;
			load_data();
		} );
		$( window ).scroll( function() {
			if ( Page>=Pages ) {
				return false;
			}
			if ( Page<Pages && !is_loading && $( window ).scrollTop() + $( window ).height()>=$( document ).height() - 400 ) { //if user scrolled to bottom of the page
				is_loading = true;
				Page++;
				if ( Page>1 ) {
					$( "#tbody1" ).append( "<tr id='temp_row'><td colspan='5' style='text-align: center !important;'><i class='fa fa-spin fa-spinner'></i> <?php _e("Loading") ?> ....</td>" );
				}
				load_data();
			}
		} );
		$( document ).on( "click", ".return_btn", function( event ) {
			event.preventDefault();

			if ( !confirm( "<?php _e( "Are you sure you want to return this book from student to library?" ) ?>" ) ) {
				return false;
			}
			id = $( this ).attr( "data-id" );

			$.post( "ajax/library_assign_books.php?return_book", { id: id }, function( data ) {
				if ( data=="OK" ) {
					$( "#tr_" + id ).remove();
					total = $( "#total" ).text();
					$( "#total" ).text( parseInt( total ) - 1 );
				} else {
					Error( data );
				}
			} )
		} );
	} );
</script>
</body>
</html>