<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "allow_library" ) || ! \Admins\UserInfo::is_allowed( "manage_library" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$LibraryBooks = new LibraryBooks();

if ( isset( $_GET["save"] ) ) {
	echo $LibraryBooks->save_book_in_stock( $_POST );
	exit;
}
if ( isset( $_GET["get_rows"] ) ) {
	header( "Content-Type: json/application" );
	$rows               = $LibraryBooks->get_book_stocks( $_POST );
	$rows["pagination"] = get_pagination_string( $rows["start"], $rows["end"], $rows["page"], $rows["pages"] );
	echo json_encode( $rows );
	exit;
}

$title = __( "Manage Library Books" );
include_once( __DIR__ . "/header.php" ); ?>
<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="modal fade" id="book_modal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
				<div class="modal-dialog modal-lg">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
							<h4 class="modal-title"><?php _e( "Save Book" ) ?></h4>
						</div>
						<div class="modal-body">
							<form class="form-horizontal validate" id="form1">
								<input type="hidden" name="id" id="id" value="0">
								<div class="form-body">
									<div class="form-group">
										<label class="col-md-6 control-label"><?php _e( "Book Name" ) ?></label>
										<div class="col-md-6">
											<input type="text" class="form-control" placeholder="<?php _e( "Type book name" ) ?>" name="book_name" id="book_name" required="required">
										</div>
									</div>
									<div class="form-group">
										<label class="col-md-6 control-label">
											<button title="<?php _e( "Add Department" ) ?>" id="add_dept_btn" type="button" class="btn btn-xs green">
												<i class="fa fa-plus"></i> Add
											</button>
											<?php _e( "Book Department" ) ?>
										</label>
										<div class="col-md-6">
											<?php $depts = $LibraryBooks->get_departments(); ?>
											<select name="book_department" class="form-control select2" id="book_department"
											        data-placeholder="<?php _e( "Type book department" ) ?>">
												<option value=""><?php _e( "Select Department" ) ?></option>
												<?php foreach ( $depts as $dept ) { ?>
													<option><?php echo $dept ?></option>
												<?php } ?>
											</select>
										</div>
									</div>
									<div class="form-group">
										<label class="col-md-6 control-label"><?php _e( "Book Quantity" ) ?></label>
										<div class="col-md-6">
											<input id="book_qty" type="number" min="0" class="form-control" placeholder="<?php _e( "Book Quantity" ) ?>" name="book_qty" required="required">
										</div>
									</div>
									<div class="form-group">
										<label class="col-md-6 control-label"><?php _e( "Active" ) ?></label>
										<div class="col-md-6">
											<select name="active" id="active" class="form-control">
												<option value="1"><?php _e( "Yes" ) ?></option>
												<option value="0"><?php _e( "No" ) ?></option>
											</select>
										</div>
									</div>
								</div>
							</form>
						</div>
						<div class="modal-footer">
							<div class="btn-group">
								<button type="button" class="btn btn-primary" onclick="$('#form1').trigger('submit')">
									<?php _e( "Save changes" ) ?>
								</button>
								<button type="button" class="btn default" data-dismiss="modal"><?php _e( "Cancel" ) ?></button>
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( "Library Books" ) ?>
						<small><?php _e( "Manage stock of library books" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<?php if ( \Admins\UserInfo::is_allowed( "library_assign_books" ) ) { ?>
								<a class="btn green white" href="<?php echo Urls::get_url( "library_assign_books" ) ?>">
									<i class="fa fa-book"></i> <?php _e( "Issue Books" ) ?>
								</a>
							<?php } ?>
							<button type="button" class="btn btn-primary" id="add_btn">
								<i class="fa fa-plus"></i> <?php _e( "Add Book" ) ?>
							</button>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#"><?php _e( "Library" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "library_books" ) ?>"><?php _e( "Library Books" ) ?></a>
						</li>
						<li id="loading" class="hidden"><i class="fa fa-spin fa-spinner"></i></li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<span>
						<?php _e( "Total Records" ) ?>:
						<span id="total_records"><i class="fa fa-spin fa-spinner"></i></span>
					</span>
					<span id="pagination"></span>
					<div style="width:200px;float: right">
						<input type="search" class="form-control input-sm" id="filter_search" placeholder="<?php _e( "Search" ) ?>">
					</div>
					<div style="clear: both;"></div>
					<table class="table table-bordered" id="table1">
						<thead>
						<tr class="heading">
							<th>
								<label class="href">
									<input type="checkbox" id="check"> <?php _e( "Book Name" ) ?>
								</label>
							</th>
							<th>
								<label>
									<?php _e( "Department" ) ?>
								</label>
							</th>
							<th>
								<label>
									<?php _e( "Qty" ) ?>
								</label>
							</th>
							<th>
								<label for=""><?php _e( "Assigned" ) ?></label>
							</th>
							<th>
								<label>
									<?php _e( "Available Qty" ) ?>
								</label>
							</th>
							<th><?php _e("Active") ?></th>
						</tr>
						</thead>
						<tbody></tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script>
	var Page = 1;
	<?php $rows = $LibraryBooks->get_book_stocks();
	$rows["pagination"] = get_pagination_string( $rows["start"], $rows["end"], $rows["page"], $rows["pages"] ); ?>
	var Rows = <?php echo json_encode( $rows ); ?>;
	$( function() {
		make_html();
	} );

	function make_html() {
		HTML = `
			${Rows.rows.map( (row, counter) =>`
				<tr class="${row.active==1 ? '' : 'inactive'}">
					<td>
						<input type="checkbox" value="${row.id}" name="ids[]" class="check">
						<a class="edit_link" data-id="${row.id}" title="<?php _e( "Edit" ) ?>" href='#'>${row.book_name}</a>
					</td>
					<td>${row.book_department}</td>
					<td>${row.book_qty}</td>
					<td>${row.book_qty - row.book_qty_available}</td>
					<td>${row.book_qty_available}</td>
					<td>${yesno( row.active )}</td>
				</tr>
			`)}
		`;

		$( "#table1 tbody" ).html( HTML );
		$( "input.check" ).uniform();
		$( "#check" ).prop( "checked", false ).uniform();
		$( "#total_records" ).text( Rows.total_records );
		$( "#pagination" ).html( " - <?php _e( "Pages" ) ?>: " + Rows.pagination );
		$( "#loading" ).addClass( "hidden" );
	}

	function load_rows() {
		$( "#loading" ).removeClass( "hidden" );
		k = "page=" + Page;
		if ( $.trim( $( "#filter_search" ).val() )!="" ) {
			k += "&search=" + $.trim( $( "#filter_search" ).val() );
		}
		$.post( "?get_rows", k, function( data ) {
			Rows = data;
			make_html();
		} );
	}

	/*setInterval( function () {
		k = "page=" + Page;
		$.post( "?get_rows",k, function ( data ) {
			Rows = data;
			make_html();
		} );
		} );
	}, 10000 );*/

	$( function() {
		$( document ).on( "click", ".btn_page", function( event ) {
			event.preventDefault();
			Page = Number( $( this ).text() );
			load_rows();
		} );
		$( document ).on( "click", "#btn_previous", function( event ) {
			event.preventDefault();
			Page--;
			load_rows();
		} );
		$( document ).on( "click", "#btn_next", function( event ) {
			event.preventDefault();
			Page++;
			load_rows();
		} );

		$( document ).on( "change", "#filter_search", function() {
			Page = 1;
			load_rows();
		} );
		$( document ).on( "click", "#add_btn", function( event ) {
			event.preventDefault();

			$( "#form1" ).trigger( "reset" );
			$( "#id" ).val( "0" );
			$( "#book_qty" ).val( "1" );
			$( "#book_modal" ).modal( "show" );
		} );
		$( document ).on( "submit", "#form1", function( event ) {
			event.preventDefault();

			k = $( "#form1" ).serialize();
			$( "#book_modal" ).modal( "hide" );
			$.post( "?save", k, function( data ) {
				if ( data=="OK" ) {
					load_rows();
					Success( "<?php _e( "Book saved in stock" ) ?>" );
				} else {
					Error( data );
				}
			} );
		} );
		$( document ).on( "click", "#add_dept_btn", function( event ) {
			event.preventDefault();

			var new_dept = window.prompt( "Type new department name" );
			if ( new_dept ) {
				IS = false;
				$( "#book_department option" ).each( function( i, v ) {
					if ( strtolower( $( v ).text() )==strtolower( new_dept ) ) {
						IS = true;
						val = $( v ).val();
						return false;
					}
				} );

				if ( !IS ) {
					$( "#book_department" ).append( `<option>${new_dept}</option>` );
					$( "#book_department" ).select2( "val", new_dept );
				} else {
					$( "#book_department" ).select2( "val", val );
				}
			}
		} );
		$( document ).on( "click", ".edit_link", function( event ) {
			event.preventDefault();
			id = $( this ).attr( "data-id" );

			$.each( Rows.rows, function( i, row ) {
				if ( row.id==id ) {
					$( "#id" ).val( row.id );
					$( "#book_name" ).val( row.book_name );
					$( "#book_department" ).select2( "val", row.book_department );
					$( "#book_qty" ).val( row.book_qty );
					$( "#active" ).val( row.active );

					$( "#book_modal" ).modal( "show" );
					return false;
				}
			} );

		} );
	} );
</script>
</body>
</html>