<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title = __( "Mark Sheet" );
if ( ! isset( $_GET["schedule_id"] ) ) {
	Urls::redirect( Urls::get_url( "test_schedules" ) );
}
$schedule_id = (int) $_GET["schedule_id"];
if ( $db->get_var( "SELECT COUNT(*) FROM `test_schedules` WHERE `id`=$schedule_id" ) == 0 ) {
	Urls::redirect( Urls::get_url( "test_schedules" ) );
}
include_once( __DIR__ . "/header.php" );
$s = new Student();
$b = new BatchClass();
?>

<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>

	<div class="modal fade" id="download-modal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
		<div class="modal-dialog">
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
					<h4 class="modal-title"><?php _e( "Download Options" ) ?></h4>
				</div>
				<div class="modal-body">
					<form id="download_form" name="download_form" action="<?php echo Urls::get_url( "download_mark_sheet" ) ?>">
						<input type="hidden" value="<?php echo $schedule_id ?>" name="schedule_id" />
						<div class="form-body">
							<div class="form-group">
								<label style="text-align: right;" class="col-md-4 control-label"><?php _e( "Attendance" ) ?>:</label>
								<div class="col-md-8">
									<select class="form-control" name="absent">
										<option value="-1"><?php _e( "Doesn't matter" ) ?></option>
										<option value="0"><?php _e( "Absent" ) ?></option>
										<option value="1"><?php _e( "Present" ) ?></option>
									</select>
								</div>
							</div>
							<div class="form-group">
								<label style="text-align: right;" class="col-md-4 control-label"><?php _e( "Test Result" ) ?>:</label>
								<div class="col-md-8">
									<select class="form-control" name="failed">
										<option value="-1"><?php _e( "Doesn't matter" ) ?></option>
										<option value="0"><?php _e( "Failed" ) ?></option>
										<option value="1"><?php _e( "Passed" ) ?></option>
									</select>
								</div>
							</div>
							<div class="form-group">
								<label class="col-md-4 control-label">&nbsp;</label>
								<div class="col-md-8">
									<label style="cursor: pointer;" class="form-control"><input type="checkbox" name="blank" /> <?php _e( "Blank sheet" ) ?>
									</label>
								</div>
							</div>
						</div>
					</form>
					<div class="clearfix"></div>
				</div>
				<div class="modal-footer">
					<div class="btn-group">
						<button type="button" class="btn blue" onclick="$('#download_form').trigger('submit')">
							<i class="fa fa-download"></i> <?php _e( "Download" ) ?>
						</button>
						<button type="button" class="btn default" data-dismiss="modal">
							<?php _e( "Close" ) ?>
						</button>
					</div>
				</div>
			</div>
		</div>
	</div>

	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( "Mark Sheet" ) ?>
						<small><?php _e( "Fill mark sheet" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "test_schedules" ) ?>"><?php _e( "Test Schedules" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#"><?php _e( "Mark Sheet" ) ?></a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<?php $sheet = $s->get_mark_sheet( $schedule_id );
					$sheet["passing_marks"] = isset($sheet["passing_marks"])?$sheet["passing_marks"]:'';
					?>

					<form method="post" onsubmit="return Save(this)">
						<input type="hidden" name="schedule_id" value="<?php echo $schedule_id ?>" />
						<table class="table table-bordered table-striped table-condensed flip-content">
							<tr>
								<th colspan="5" style="text-align: center;"><?php _e( "Test Session" ) ?> - <?php echo $b->get_class_batch( $sheet["class_id"] ) ?></th>
							</tr>
							<tr>
								<td style="text-align: right;"><?php _e( "Subject" ) ?>:</td>
								<td><?php echo $sheet["subject"] ?></td>
								<td style="text-align: right;"><?php _e( "Total Marks" ) ?>:</td>
								<td>
									<input name="total_marks" class="form-control" min="-1" step="0.1" type="number"
									       value="<?php echo $sheet["total_marks"] ?>" />
								</td>
								<td>
									<input name="week" class="form-control" type="text" value="<?php echo $sheet["week"] ?>">
								</td>
							</tr>
							<tr>
								<td style="text-align: right;"><?php _e( "Class" ) ?></td>
								<td><?php echo $sheet["class_name"] ?></td>
								<td style="text-align: right;"><?php _e( "Passing Marks" ) ?>:</td>
								<td>
									<input name="passing_marks" class="form-control" min="0" step="0.1" type="number"
									       placeholder="Passing marks"
									       value="<?php echo $sheet["passing_marks"] ?>" />
								</td>
								<td><?php _e( "Date" ) ?>: <?php echo \Dates::my_date( $sheet["test_date"] ) ?></td>
							</tr>
							<tr>
								<td style="text-align: right;"><?php _e( "Teacher" ) ?></td>
								<td colspan="4"><?php echo $sheet["teacher"] ?></td>
							</tr>
						</table>

						<div class="row">
							<div class="col-md-6 hidden-xs hidden-sm">
								<div class="row">
									<div class="col-md-8">
										<div class="heading">## <?php _e( "Name" ) ?></div>
									</div>
									<div class="col-md-4">
										<div class="heading"><?php _e( "Marks" ) ?></div>
									</div>
								</div>
							</div>
							<div class="col-md-6 hidden-xs hidden-sm">
								<div class="row">
									<div class="col-md-8">
										<div class="heading">## <?php _e( "Name" ) ?></div>
									</div>
									<div class="col-md-4">
										<div class="heading"><?php _e( "Marks" ) ?></div>
									</div>
								</div>
							</div>

							<?php
							for ( $x = 0; $x < count( $sheet["students"] ); $x ++ ) { ?>
								<div class="col-md-6 col-sm-6">
									<input type="hidden" name="students[<?php echo $x ?>][student_id]"
									       value="<?php echo $sheet["students"][ $x ]["student_id"] ?>">
									<div class="row">
										<div class="col-md-8 col-sm-6">
											<label for="ID<?php echo $x ?>" style="padding:4px;border:1px solid #e5e5e5;display: block;">
												<?php echo add_leading_zeros( $x + 1 ); ?>.
												<?php echo $sheet["students"][ $x ]["student_name"] ?>
											</label>
										</div>
										<div class="col-md-4 col-sm-6">
											<input name="students[<?php echo $x ?>][marks]" type="number" min="-1"
											       class="form-control input-sm" id="ID<?php echo $x ?>"
											       step="0.01" value="<?php echo $sheet["students"][ $x ]["marks"] ?>" placeholder="Marks">
										</div>
										<div class="col-xs-12 visible-xs" style="background-color: #d6d6d6; height:1px;margin:4px;"></div>
									</div>
								</div>
							<?php } ?>
						</div>
						<br>
						<div class="row">
							<div class="col-md-12 center">
								<div class="btn-group">
									<button class="btn btn-primary btn-sm"><?php _e( "Save Changes" ) ?></button>
									<button onclick="OpenDownload()" type="button" class="btn green btn-sm">
										<i class="fa fa-download"></i> <?php _e( "Download PDF" ) ?>
									</button>
								</div>
							</div>
						</div>
						<br>
						<div class="note note-info">
							<h4 class="block"><b>Note:</b> Please note following mark statuses</h4>
							<ul>
								<li><b>0</b> = Student is present but got 0 marks.</li>
								<li><i><b>Blank Field</b></i> = Student is absent.</li>
								<li><b>-1</b> = Student is present but not appeared in test/exam.</li>
							</ul>
						</div>
					</form>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="text/javascript">
	function Save( form ) {
		Block();
		$.post( "<?php echo Urls::get_url( "ajax", 0, "action=saveMarkSheet" ) ?>", $( form ).serialize(), function( data ) {
			UnBlock();
			if ( data=="OK" ) {
				Success( "Mark sheet saved successfully!" );
			} else {
				Error( data );
			}
		} );
		return false;
	}

	function OpenDownload() {
		$( "#download-modal" ).modal( "show" );
	}
</script>
</body>
<!-- END BODY -->
</html>