<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "manage_teachers" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$title = __("Other Employees");
include_once( __DIR__ . "/header.php" ); ?>

<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						<?php _e("Other Employees") ?>
						<small><?php _e("Manage other employees data here") ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e("Home") ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "otheremployees" ) ?>"><?php _e("Other Employees") ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php _e("Add Other Employees") ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<a href="#portlet-config" data-toggle="modal" class="config"></a>
								<a href="javascript:;" class="reload"></a>
								<a href="javascript:;" class="remove"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form action="#" class="form-horizontal form-bordered" onsubmit="return Save(this)">
								<input type="hidden" name="id" id="id" value="0">
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e("Name") ?></label>
										<div class="col-md-4">
											<input type="text" name="name" placeholder="<?php echo __("Employee name required") ?>" required="required" class="form-control input-xlarge" />
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e("Short Name") ?></label>
										<div class="col-md-4">
											<input type="text" name="short_name" placeholder="<?php echo __("Short name for employee") ?>" class="form-control input-xlarge" />
										</div>
									</div>

									<div class="form-group guardian_contact_detail">
										<label class="control-label col-md-3"><?php _e("National ID Card") ?>
										</label>
										<div class="col-md-9">
											<input type="text" class="form-control input-xlarge nic" name="nic" placeholder="<?php _e("Identity Card Number") ?>">
											<span class="help-block"></span>
										</div>
									</div>

									<div class="form-group">
										<label class="control-label col-md-3"><?php _e("Designation") ?></label>
										<div class="col-md-4">
											<input type="text" name="designation" placeholder="<?php _e("Designation name for employee") ?>" class="form-control input-xlarge" />
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e("Email address") ?></label>
										<div class="col-md-4">
											<input type="email" name="email" placeholder="<?php _e("Email address") ?>" class="form-control input-xlarge" />
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e("Cell Number") ?></label>
										<div class="col-md-4">
											<input type="text" name="cell" placeholder="<?php _e("Cell number required") ?>" required="required" class="form-control input-xlarge mobile">
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e("Date of Joining") ?></label>
										<div class="col-md-4">
											<input type="text" name="date_of_joining" placeholder="<?php _e("Date of joining") ?>" required="required" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>" class="form-control input-xlarge date-picker" />
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e("Address") ?></label>
										<div class="col-md-4">
											<input type="text" name="address" placeholder="<?php _e("Home Address") ?>" class="form-control input-xlarge" />
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e("Salary") ?></label>
										<div class="col-md-4">
											<input type="number" name="salary" placeholder="<?php _e("Salary") ?>" class="form-control input-xlarge" />
										</div>
									</div>
									<!--                            <div class="form-group">-->
									<!--                                <label class="control-label col-md-3">Document</label>-->
									<!--                                <div class="col-md-4">-->
									<!--                                    <input type="file" name="document" id="document" title="Document" class="form-control input-xlarge" />-->
									<!--                                </div>-->
									<!--                            </div>-->
								</div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="submit" class="btn blue"><?php _e("Submit") ?></button>
										<a onclick="return Cancel();" href="<?php echo Urls::get_url( "otheremployees" ) ?>" class="btn default"><?php _e("Cancel") ?></a>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="text/javascript">
	function Save( form ) {
		Block();
		$.post( '<?php echo DOMAIN_URL ?>includes/ajax.php?action=saveEmployess', $( form ).serialize(), function( data ) {
			UnBlock();
			if ( data=="OK" ) {
				Success( "<?php _e("Employees saved successfully!") ?>" );
				window.location.href = "<?php echo Urls::get_url( "otheremployees" ) ?>";
			} else {
				Error( data );
			}
		} );
		return false;
	}
</script>
</body>
<!-- END BODY -->
</html>