<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title = "Paid Fee";

$_GET["from"]       = isset( $_GET["from"] ) ? $_GET["from"] : '';
$_GET["to"]         = isset( $_GET["to"] ) ? $_GET["to"] : '';
$_GET["class_name"] = isset( $_GET["class_name"] ) ? $_GET["class_name"] : '';

include_once( __DIR__ . "/header.php" );
?>

<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						<?php _e("Fee") ?>
						<small><?php _e("List of paid fee") ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button class="btn blue" type="button" onclick="DownloadPDF()">
								<i class="fa fa-download"></i> <?php _e("Download PDF") ?>
							</button>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e("Home") ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php _e("Fee") ?>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php _e("List of paid fee") ?>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<a style="float: right;" href="#" id="filter_link" onclick2="Filter(this,'D')">&dArr; <?php _e("Filter Result") ?></a>
					<script>
						function Filter( s, t ) {
							if ( t=='D' ) {
								$( "#filterForm" ).slideDown( "slow" );
								$( s ).html( "&uArr; <?php echo __("Hide Filter") ?>" );
								$( s ).attr( "onclick", "Filter(this,'U')" );
							} else {
								$( "#filterForm" ).slideUp( "slow" );
								$( s ).html( "&dArr; <?php echo __("Filter Result") ?>" );
								$( s ).attr( "onclick", "Filter(this,'D')" );
							}
						}
					</script>
					<form class="form-horizontal form-bordered" name="filterForm" id="filterForm" style="display: none;">
						<div class="form-body">
							<div class="form-group">
								<label class="control-label col-md-3">Fee Paid Dates</label>
								<div class="col-md-4">
									<div class="input-group input-xlarge date-picker input-daterange" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>">
										<input value="<?php echo $_GET["from"] ?>" type="text" class="form-control" name="from" placeholder="<?php _e("From Date") ?>">
										<span class="input-group-addon">
											<?php _e("to") ?>
										</span>
										<input value="<?php echo $_GET["to"] ?>" type="text" class="form-control" name="to" placeholder="<?php _e("To Date") ?>">
									</div>
									<!-- /input-group -->
									<span class="help-block">
										<?php _e("Select date range") ?>
									</span>
								</div>
							</div>
							<div class="form-group">
								<label class="control-label col-md-3"><?php _e("Select Class") ?></label>
								<div class="col-md-4">
									<select name="class_name" class="form-control input-xlarge">
										<option value=""><?php _e("All Classes") ?></option>
										<?php $C = new BatchClass;
										$Cls     = $C->get_list();
										foreach ( $Cls as $Cl ): ?>
											<option <?php echo $_GET["class_name"] == $Cl["class_name"] ? "selected=selected" : "" ?>><?php echo $Cl["class_name"] ?></option>
										<?php endforeach; ?>
									</select>
								</div>
							</div>
							<div class="form-group">
								<div class="col-md-offset-3 col-md-9">
									<button type="submit" class="btn blue"><?php _e("Filter Result") ?></button>
									<a class="btn red" href="<?php echo Urls::get_url( "paid_fee" ) ?>"><?php _e("Clear Filter") ?></a>
								</div>
							</div>
						</div>
					</form>
					<table class="table table-bordered table-hover" id="sample_11">
						<thead>
						<tr class="heading">
							<th><?php _e("Student") ?></th>
							<th><?php _e("Fee Title") ?></th>
							<th><?php _e("Fee") ?></th>
							<th><?php _e("Dates") ?></th>
							<th><?php _e("Receipt") ?></th>
							<th>&nbsp;</th>
						</tr>
						</thead>
						<tbody>
						</tbody>
					</table>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="text/javascript">

	var TableAjax = function() {

		return {
			//main function to initiate the module
			init: function() {
				if ( !jQuery().dataTable ) {
					return;
				}

				// begin first table
				var $dataTable = $( '#sample_11' ).dataTable( {
					"sDom": "<'row'<'col-md-6 col-sm-12'l><'col-md-6 col-sm-12'f>r>t<'row'<'col-md-5 col-sm-12'i><'col-md-7 col-sm-12'p>>", //default layout without horizontal scroll(remove this setting to enable horizontal scroll for the table)
					"aLengthMenu": [
						[ 10, 20, 40, 60, 100 ],
						[ 10, 20, 40, 60, 100 ] // change per page values here
					],
					"bProcessing": true,
					"bServerSide": true,
					"sAjaxSource": "<?php echo DOMAIN_URL . "includes/old_ajax.php?action=getPaidFeesList&" . http_build_query( $_GET ) ?>",
					// set the initial value
					"iDisplayLength": 10,
					//                "sPaginationType": "bootstrap_full_number",
					"oLanguage": {
						"sProcessing": '<i class="fa fa-coffee"></i>&nbsp;<?php _e( "Please wait..." ) ?>',
						"sLengthMenu": "_MENU_ records",
						"oPaginate": {
							"sPrevious": "Prev",
							"sNext": "Next"
						}
					},
					"aoColumns": [
						{ "bSortable": true },
						{ "bSortable": true },
						{ "bSortable": true },
						{ "bSortable": true },
						{ "bSortable": true },
						{ "bSortable": false }
					],
					"aaSorting": [ [ 0, "desc" ] ]
				} );

				$( "#sample_11 tfoot input" ).on( 'keyup change', function() {
					table
						.column( $( this ).parent().index() + ':visible' )
						.search( this.value )
						.draw();
				} );

				jQuery( '#sample_11_wrapper .dataTables_filter input' ).addClass( "form-control input-medium" ); // modify table search input
				jQuery( '#sample_11_wrapper .dataTables_length select' ).addClass( "form-control input-small" ); // modify table per page dropdown
			}

		};

	}();

	TableAjax.init();

	function DownloadPDF() {
		var query = $( "#filterForm" ).serialize();
		query += "&search=" + jQuery( '#sample_11_wrapper .dataTables_filter input' ).val();
		query += "&_data=paid_fee";
		var oTable = $( '#sample_11' ).dataTable();
		/*var oData = oTable.fnPagingInfo();
		$.each(oData, function(k,v){
			alert(k + " = " + v);
		});*/
		var Sort = oTable.fnSettings().aaSorting;
		window.location.href = "<?php echo Urls::get_url( "download_pdf" ) ?>?" + query + "&sorts=" + Sort;
	}

	function Print( id ) {
		if ( id=="-1" ) {
			id = $( "#id" ).val();
		}
		window.open( "<?php echo Urls::get_url( "print_receipt" ) ?>?inline&id=" + id, "_blank", "width=300&height=100&location=no&menubar=no&resizable=no&status=no&titlebar=no&toolbar=no&top=200" );
	}

	$( function() {
		$( document ).on( "click", "#filter_link", function( event ) {
			event.preventDefault();

			if ( $( "#filterForm" ).is( ":visible" ) ) {
				$( "#filterForm" ).slideUp( "slow" );
				$( this ).html( "&dArr; Hide Filter" );
			} else {
				$( "#filterForm" ).slideDown( "slow" );
				$( this ).html( "&uArr; Show Filter" );
			}
		} );
	} );
</script>
</body>
<!-- END BODY -->
</html>