<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title = __( "Payment Report" );
include_once( __DIR__ . "/header.php" );
$BatchClass = new BatchClass();
$C = $BatchClass->get_list();
?>

<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>

	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __( "Payment Report" ) ?>
						<small><?php echo __( "Generate report" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<!--li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
							<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="#">Action</a>
								</li>
								<li>
									<a href="#">Another action</a>
								</li>
								<li>
									<a href="#">Something else here</a>
								</li>
								<li class="divider">
								</li>
								<li>
									<a href="#">Separated link</a>
								</li>
							</ul>
						</li-->
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php echo __( "Reporting" ) ?>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="payment_report.php"><?php _e( "Payment Report" ) ?></a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php echo __( "Generate Report" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<!--<a href="#portlet-config" data-toggle="modal" class="config"></a>-->
							</div>
						</div>
						<div class="portlet-body form">
							<form id="report_form" action="download_payment_report.php" class="form-horizontal form-bordered validate" onsubmit="return Form(2)">
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Select Class" ) ?></label>
										<div class="col-md-4">
											<select class="form-control input-xlarge" name="class_id">
												<option value="0">== <?php echo __( "All Classes" ) ?> ==</option>
												<?php foreach ( $C as $c ): ?>
												<option value="<?php echo $c["id"] ?>"><?php echo $c["class_name"] ?></option>
												<?php endforeach; ?>
											</select>
										</div>
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-md-3"><?php echo __( "Select Month" ) ?></label>
									<div class="col-md-4">
										<div class="input-group input-xlarge date-picker input-daterange" data-date-format="<?php echo \Dates::date_format1_for_js() ?>">
											<select name="month" class="form-control">
												<?php for ( $x = 1; $x <= 12; $x ++ ): ?>
												<?php $S = $x == date( "m" ) ? "selected=selected" : "" ?>
												<option <?php echo $S ?> value="<?php echo $x ?>"><?php echo \Dates::month_name( $x, true ) ?></option>
												<?php endfor ?>
											</select>
											<span class="input-group-addon">
												to
											</span>
											<select name="year" class="form-control">
												<?php for ( $x = 2014; $x <= Date( "Y" ); $x ++ ): ?>
												<?php $S = $x == date( "Y" ) ? "selected=selected" : "" ?>
												<option <?php echo $S ?> value="<?php echo $x ?>"><?php echo $x ?></option>
												<?php endfor ?>
											</select>
										</div>
										<!-- /input-group -->
										<span class="help-block">
											<?php echo __( "Select month" ) ?>
										</span>
									</div>
								</div>
								<div id="moresubjects"></div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="button" onclick="Form(1)" name="viewBtn" class="btn green"><?php echo __( "View Report" ) ?></button>
										<button type="submit" name="downBtn" class="btn blue"><?php echo __( "Download Report" ) ?></button>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script>
	function Form( btn ) {
		if ( btn=="1" ) {
			u = $( "#report_form" ).serialize() + "&viewBtn";
		} else {
			u = $( "#report_form" ).serialize();
			window.location.href = $( "#report_form" ).attr( "action" ) + "?" + u;
			return false;
		}

		u = $( "#report_form" ).attr( "action" ) + "?" + u;
		$.fancybox( {
			'title': "Class Payment Report",
			'href': u,
			'type': 'iframe',
			'width': '90%',
			'height': '90%',
		} );
	}
</script>
</body>
<!-- END BODY -->
</html>