<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title = "Attendance Report";
include_once( __DIR__ . "/header.php" );
$BatchClass = new BatchClass;
$C          = $BatchClass->get_list();
$b          = new Batch();
$B          = $b->get_active_batch();
//die("hi");
?>

<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						<?php _e("Report") ?>
						<small><?php _e("Attendance Report") ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e("Home") ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "report/attendance" ) ?>"><?php _e("Attendance Report") ?></a>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">

						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php _e("Generate Attendance Report") ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<a href="#portlet-config" data-toggle="modal" class="config"></a>
								<a href="javascript:;" class="reload"></a>
								<a href="javascript:;" class="remove"></a>
							</div>
						</div>

						<div class="portlet-body form">
							<form target="_ems" class="form-horizontal form-bordered" action="<?php echo Urls::get_url( "download_report_attendance" ) ?>">
								<input type="hidden" name="__type" value="common">
								<input type="hidden" name="batch_id" value="<?php echo $B["id"] ?>">
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e("Select Date") ?></label>
										<div class="col-md-9">
											<input required="required" class="form-control" name="date" value="<?php echo \Dates::mysql_date() ?>" type="date">
										</div>
									</div>
								</div>
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e("Attendance Status") ?></label>
										<div class="col-md-9">
											<select class="form-control select2" name="attendance">
												<option value="">== <?php echo __("Any") ?> ==</option>
												<option value="A"><?php _e("Absent") ?></option>
												<option value="P"><?php _e("Present") ?></option>
												<option value="L"><?php _e("Leave") ?></option>
											</select>
										</div>
									</div>
								</div>
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e("Select Classes") ?></label>
										<div class="col-md-9">
											<select class="form-control select2" name="class_id[]" multiple="multiple">
												<?php foreach ( $C as $c ): ?>
													<option value="<?php echo $c["id"] ?>"><?php echo $c["class_name"] ?></option>
												<?php endforeach; ?>
											</select>
										</div>
									</div>
								</div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<div class="btn-group">
											<button type="submit" name="viewBtn" class="btn green"><?php _e("View Report") ?></button>
											<button type="submit" name="smsBtn" class="btn red"><?php _e("SMS Absent Report") ?></button>
											<button type="submit" name="downBtn" class="btn blue"><?php _e("Download Report") ?></button>
										</div>
									</div>
								</div>

							</form>
						</div>

					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>

</body>
<!-- END BODY -->
</html>