<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title = "Attendance Sheet";
include_once( __DIR__ . "/header.php" );
$BatchClass = new BatchClass;
$C          = $BatchClass->get_list();
$b          = new Batch();
$B          = $b->get_active_batch();
?>

<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>

	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( "Attendance Sheet" ) ?>
						<small><?php _e( "Generate report" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#"><?php _e("Attendance Sheet") ?></a>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php _e("Generate Report") ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<a href="#portlet-config" data-toggle="modal" class="config"></a>
								<a href="javascript:;" class="reload"></a>
								<a href="javascript:;" class="remove"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form id="report_form" action="<?php echo Urls::get_url( "download_report_attendance_sheet" ) ?>" class="form-horizontal form-bordered" onsubmit="Form(2)">
								<input type="hidden" name="batch_id" name="batch_id" value="<?php echo $B["id"] ?>" />
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e("Select Class") ?></label>
										<div class="col-md-4">
											<select class="form-control input-xlarge select2" name="class_id">
												<?php foreach ( $C as $c ): ?>
													<option value="<?php echo $c["id"] ?>"><?php echo $c["class_name"] ?></option>
												<?php endforeach; ?>
											</select>
											<span class="help-block">
        										<?php _e("Select class") ?>
        									</span>
										</div>
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-md-3"><?php _e("Test/Exam Schedule Date Range") ?></label>
									<div class="col-md-4">
										<div class="input-group input-xlarge date-picker input-daterange" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>">
											<input value="<?php echo date( "01-m-Y" ) ?>" required="required" type="text" class="form-control" name="from" placeholder="From Date">
											<span class="input-group-addon">
												to
											</span>
											<input value="<?php echo date( $db->get_option( "date_format1" ) ) ?>" required="required" type="text" class="form-control" name="to" placeholder="To Date">
										</div>
										<!-- /input-group -->
										<span class="help-block">
											<?php _e("Select date range") ?>
										</span>
									</div>
								</div>
								<div id="moresubjects"></div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<div class="btn-group">
											<button type="button" onclick="Form(1)" name="viewBtn" class="btn green">
												<?php _e( "View Report" ) ?>
											</button>
											<button type="submit" name="downBtn" class="btn blue">
												<?php _e( "Download Report" ) ?>
											</button>
										</div>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script>
	function Form( btn ) {
		if ( btn=="1" ) {
			u = $( "#report_form" ).serialize() + "&viewBtn";
		} else {
			u = $( "#report_form" ).serialize();
			window.location.href = $( "#report_form" ).attr( "action" ) + "?" + u;
			return false;
		}

		u = $( "#report_form" ).attr( "action" ) + "?" + u;
		$.fancybox( {
			'title': "Attendance Sheet",
			'href': u,
			'type': 'iframe',
			'width': '90%',
			'height': '90%',
		} );
	}
</script>
</body>
<!-- END BODY -->
</html>