<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title = "Expense Report";
include_once( __DIR__ . "/header.php" );
$A = new Accounts;
?>

<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						Expense Report
						<small>Generate report</small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<!--li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
							<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="#">Action</a>
								</li>
								<li>
									<a href="#">Another action</a>
								</li>
								<li>
									<a href="#">Something else here</a>
								</li>
								<li class="divider">
								</li>
								<li>
									<a href="#">Separated link</a>
								</li>
							</ul>
						</li-->
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e( 'Home' ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php _e( 'Reporting' ) ?>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="report_expense.php"><?php _e( 'Cash Report' ) ?></a>
						</li>
					</ul>
				</div>
			</div>

			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php _e('Generate Report') ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<a href="#portlet-config" data-toggle="modal" class="config"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form id="report_form" action="<?php echo Urls::get_url( "download_expense_report" ) ?>" class="form-horizontal form-bordered" onsubmit="Form(2)">
								<div class="form-group">
									<label class="control-label col-md-3"><?php _e( 'Select Heads' ) ?></label>
									<div class="col-md-4">
										<select name="head[]" class="select2 input-xlarge" multiple="multiple"
										        placeholder="<?php _e( 'Select one or more account heads' ) ?>">
											<?php
											$rows = $A->get_account_heads( "orderby=head&pagesize=999999&order=asc" );
											foreach ( $rows["rows"] as $row ) {
												echo "<option>" . $row["head"] . "</option>\n";
											}
											?>
										</select>
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-md-3">Dates</label>
									<div class="col-md-4">
										<div class="input-group input-xlarge date-picker input-daterange" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>">
											<input value="<?php echo \Dates::my_date() ?>" required="required" type="text" class="form-control" name="from" placeholder="From Date">
											<span class="input-group-addon">
												to
											</span>
											<input value="<?php echo \Dates::my_date() ?>" required="required" type="text" class="form-control" name="to" placeholder="To Date">
										</div>
										<!-- /input-group -->
										<span class="help-block">
											Select date range
										</span>
									</div>
								</div>
								<div id="moresubjects"></div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<div class="btn-group">
											<button onclick="Form(1)" type="button" name="viewBtn" class="btn green"><?php _e( "View Report" ) ?></button>
											<button type="submit" name="downBtn" class="btn blue"><?php _e( "Download Report" ) ?></button>
										</div>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="text/javascript">
	function Form( btn ) {
		if ( btn=="1" ) {
			u = $( "#report_form" ).serialize() + "&viewBtn";
		} else {
			u = $( "#report_form" ).serialize();
			window.location.href = $( "#report_form" ).attr( "action" ) + "?" + u;
			return false;
		}

		u = $( "#report_form" ).attr( "action" ) + "?" + u;
		$.fancybox( {
			'title': "Expense Report",
			'href': u,
			'type': 'iframe',
			'width': '90%',
			'height': '90%',
		} );
	}
</script>
</body>
<!-- END BODY -->
</html>