<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title = __( "Students List" );
include_once( __DIR__ . "/header.php" );
$BatchClass = new BatchClass;
$C          = $BatchClass->get_list();
?>
<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						<?php _e("Students List Report") ?>
						<small><?php _e("Generate report") ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<!--li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
							<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="#">Action</a>
								</li>
								<li>
									<a href="#">Another action</a>
								</li>
								<li>
									<a href="#">Something else here</a>
								</li>
								<li class="divider">
								</li>
								<li>
									<a href="#">Separated link</a>
								</li>
							</ul>
						</li-->
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e("Home") ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#"><?php _e("Reporting") ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "report/students/list" ) ?>"><?php _e("Students List") ?></a>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php _e("Generate Report") ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<a href="#portlet-config" data-toggle="modal" class="config"></a>
								<a href="javascript:;" class="reload"></a>
								<a href="javascript:;" class="remove"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form target="_ems" action="<?php echo Urls::get_url( "download_report_students_list" ) ?>" class="form-horizontal form-bordered">
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e("Select Class") ?></label>
										<div class="col-md-4">
											<select class="form-control input-xlarge" name="class_id">
												<option value="0">=== <?php _e("All Classes") ?> ===</option>
												<?php foreach ( $C as $c ): ?>
													<option value="<?php echo $c["id"] ?>"><?php echo $c["class_name"] ?></option>
												<?php endforeach; ?>
											</select>
											<!--span class="help-block">
												Select class
											</span-->
										</div>
									</div>
								</div>
								<!--div class="form-group">
									<label class="control-label col-md-3">Order By</label>
									<div class="col-md-4">
										<div class="input-group input-xlarge date-picker input-daterange" data-date-format="dd-mm-yyyy">
											<select class="form-control" name="orderby">
												<option value="">==Default==</option>
												<option value="name">Student Name</option>
												<option value="total">Total Marks</option>
												<option selected="selected" value="percentage">Percentage</option>
											</select>
											<span class="input-group-addon">
												order
											</span>
											<select class="form-control" name="order">
												<option value="ASC">Ascending</option>
												<option selected="selected" value="DESC">Descending</option>
											</select>
										</div>
										<span class="help-block">
											Change order of records
										</span>
									</div>
								</div-->
								<div id="moresubjects"></div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="submit" name="viewBtn" class="btn green"><?php _e("View Report") ?></button>
										<button type="submit" name="downBtn" class="btn blue"><?php _e("Download Report") ?></button>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>

<?php include_once( __DIR__ . "/footer.php" ); ?>

</body>
</html>