var markjs_options = {
    "diacritics": true,
    "separateWordSearch": true,
    "className": "highlight highlighter"
};
var mytable = "";
var IsFormChanged = false;
$(function () {
    $(document).on('click', "a.change_lang_link", function (event) {
        event.preventDefault();
        var lang = $(this).attr('data-lang');
        Block();
        $.post(root_url + 'ajax.php?set_lang', { lang: lang }, function (data) {
            if (data == 'OK') {
                window.location.reload();
            }
            else {
                UnBlock();
                alert(data);
            }
        });
    });
    $('.date-picker').attr('autocomplete', 'off');
    $('span[role=status]').hide();
    if ($('#filters').length > 0) {
        $('#filters').append('<button class="btn btn-sm filters-btn light"><i class="fa fa-search"></i> Search Filters</button>');
    }
    $(document).on('click', '#filters .filters-btn', function () {
        if ($('#filters').css('left') == '-250px') {
            $('#filters').animate({
                'left': '0'
            });
        }
        else {
            $('#filters').animate({
                'left': '-250px'
            });
        }
    });
    $(document).on('click', '.page-content, div.page-sidebar', close_filters);
    $.ajax({
        "url": root_url + "ajax.php?user_info",
        "method": "post",
        "data": { file: filename() },
        error: function (e1, e2, e3) {
            alert('Menu loading error: ' + e3);
        }
    }).done(function (data) {
        if (!data.is_loggedin) {
            window.location.href = 'login.php?goto=' + urlencode(window.location.href);
            return false;
        }
        if (!data.is_loggedin && filename() != "reset-password.php") {
            window.location.href = 'login.php?goto=' + urlencode(window.location.href);
            return;
        }
        $("li#loading_li").remove();
        if (data.sidebar) {
            if (typeof tmpl != 'undefined' && $("#sidebar_tmpl").length > 0) {
                $("ul.page-sidebar-menu").append(tmpl("sidebar_tmpl", data.sidebar));
            }
            $("ul.page-sidebar-menu li").each(function () {
                var li = $(this);
                $(this).find("a").each(function () {
                    if ($(this).attr("href") == filename()) {
                        li.addClass("active")
                            .find('span.arrow').addClass("open");
                    }
                });
            });
        }
        $("#top_username").text(data.name);
        $("#MyPhoto").attr("src", data.photo_url);
        if (data.message_counter > 0) {
            $("span#top_message_counter").text(data.message_counter);
            $("p#message_notification_p").html('You have <span class="ucount2">' + data.message_counter + '</span> new messages');
            $("span#inbox_span").html('<span class="badge badge-danger ucount2">' + data.message_counter + '</span>');
        }
        else {
            $("p#message_notification_p").html("You don't have any new message");
        }
        $("#top_collect_fee_span").text(data.count_not_paid);
        var html = "";
        $.each(data.messages.rows, function (i, row) {
            html += "<li><a href='inbox.php?a=view&id=" + row.id + "'>" +
                '<span class="photo"><img src="' + ASSETS_URL + 'img/avatar.png"></span>' +
                '<span class="subject"><span class="from" ';
            if (row.viewed == 0) {
                html += 'style="font-weight: bold;"';
            }
            html += '>' + row.from_name + '</span><span class="time">' + row.sending_time + '</span></span>' +
                '<span class="message" ';
            if (row.viewed == 0) {
                html += 'style="font-weight: bold;"';
            }
            html += '>' +
                row.message.substr(0, 50).replace(/(<([^>]+)>)/ig, "") + '...' +
                "</a></li>";
        });
        $("ul#messages_ul").html(html);
    });
    $("form.validate").each(function () {
        $(this).validate({
            ignore: ":hidden:not(.summernote),.note-editable.panel-body"
        });
    });
    $('form.check_save').each(function () {
        $(this).areYouSure();
    });
    $("textarea.summernote").each(function () {
        $(this).summernote({
            height: '300px'
        });
    });
    $(document).on("change", ".phone, .mobile, .land_line", function (event) {
        var T = $(this);
        T.attr("readonly", true);
        $.post(root_url + "ajax/common.php?format_phone", { phone: $(this).val() }, function (data) {
            T.val(data);
            T.attr("readonly", false);
        });
    });
    $("table.table:not(.I)").each(function () {
        $(this).tablesaw();
    });
    jQuery.fn.exists = function () {
        return this.length > 0;
    };
    if (typeof inputmask != "undefined") {
        $(".nic").each(function () {
            $(this).inputmask("99999-9999999-9", {
                placeholder: " ",
                clearMaskOnLostFocus: true
            });
        });
    }
    $(".price").each(function () {
        $(this).inputmask('999,999,999', {
            numericInput: true
        });
    });
    $(document).on("click", "#check", function () {
        if ($(this).is(":checked")) {
            $(".check").prop("checked", true).uniform();
        }
        else {
            $(".check").prop("checked", false).uniform();
        }
    });
    $(document).on("click", ".check", function () {
        if ($(this).is(":checked")) {
            if ($(".check:checked").length == $(".check").length) {
                $("#check").prop("checked", true).uniform();
            }
        }
        else {
            $("#check").prop("checked", false).uniform();
        }
    });
    if ($("#show_on_top").length > 0) {
        $("#show_on_top").animate({ "left": "0px" }, "slow");
    }
    $(document).on("click", "#close_show_on_top_btn", function (event) {
        event.preventDefault();
        $("#show_on_top").animate({ "left": "-310px" }, "slow");
    });
    $(document).on("click", "#ignore_update_btn", function (event) {
        $("#close_show_on_top_btn").click();
        $.post(root_url + "?new_ajax&ignore_update", function (data) {
        });
    });
    $(document).on('change', '#mytable .group-checkable', function () {
        var set = $(this).attr("data-set");
        var checked = $(this).is(":checked");
        $(set).each(function () {
            if (checked) {
                $(this).prop("checked", true);
            }
            else {
                $(this).prop("checked", false);
            }
        });
        $.uniform.update(set);
    });
    $('#mytable_wrapper .dataTables_filter input').addClass("form-control input-small");
    $('#mytable_wrapper .dataTables_length select').addClass("form-control input-xsmall");
    $('#mytable_wrapper .dataTables_length select').each(function () {
        $(this).select2();
    });
    if ($('.datatable').length > 0) {
        var dataTable = $('.datatable').dataTable({
            "aLengthMenu": [
                [10, 20, 30, 40, 50, 100, -1],
                [10, 20, 30, 40, 50, 100, "All"]
            ],
            "iDisplayLength": 10,
            "aoColumnDefs": [
                {
                    'bSortable': false,
                    'aTargets': ['nosort']
                }
            ],
            "columnDefs": [
                {
                    "targets": 'nosort',
                    "orderable": false
                }
            ],
        });
    }
    if ($('.datatable2').length > 0) {
        var dataTable2 = $('.datatable2').dataTable({
            "aLengthMenu": [
                [10, 20, 30, 40, 50, 100, -1],
                [10, 20, 30, 40, 50, 100, "All"]
            ],
            "iDisplayLength": 10,
            "oLanguage": {
                "sLengthMenu": "_MENU_ records",
                "oPaginate": {
                    "sPrevious": "Previous Page",
                    "sNext": "Next Page"
                }
            },
            "aaSorting": []
        });
    }
    $('.select2').each(function () {
        $(this).select2();
    });
    $(".fancybox").each(function () {
        $(this).fancybox({
            fitToView: false,
            width: '90%',
            height: '90%',
            autoSize: false,
            closeClick: false,
            openEffect: 'none',
            closeEffect: 'none'
        });
    });
});
function Block() {
    $.blockUI({
        baseZ: 99999,
        css: {
            border: 'none',
            padding: '15px',
            backgroundColor: '#000000',
            '-webkit-border-radius': '10px',
            '-moz-border-radius': '10px',
            opacity: .2,
            color: '#fff'
        }
    });
}
function UnBlock() {
    $.unblockUI();
}
function is_email(mail) {
    if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(mail)) {
        return (true);
    }
    return (false);
}
function number_format(number, decimals, dec_point, thousands_sep) {
    number = (number + '').replace(/[^0-9+\-Ee.]/g, '');
    var n = !isFinite(+number) ? 0 : +number, prec = !isFinite(+decimals) ? 0 : Math.abs(decimals), sep = (typeof thousands_sep === 'undefined') ? ',' : thousands_sep, dec = (typeof dec_point === 'undefined') ? '.' : dec_point, s = '', toFixedFix = function (n, prec) {
        var k = Math.pow(10, prec);
        return '' + Math.round(n * k) / k;
    };
    s = (prec ? toFixedFix(n, prec) : '' + Math.round(n)).split('.');
    if (s[0].length > 3) {
        s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep);
    }
    if ((s[1] || '').length < prec) {
        s[1] = s[1] || '';
        s[1] += new Array(prec - s[1].length + 1).join('0');
    }
    return s.join(dec);
}
function is_numeric(mixed_var) {
    return (typeof mixed_var === 'number' || typeof mixed_var === 'string') && mixed_var !== '' && !isNaN(mixed_var);
}
function is_json(str) {
    str = $.trim(str);
    if (str == "") {
        return false;
    }
    try {
        JSON.parse(str);
    }
    catch (e) {
        return false;
    }
    return true;
}
function Success(msg, title, duration) {
    if (title === void 0) { title = 'Success'; }
    if (duration === void 0) { duration = 300; }
    toastr.options.closeButton = true;
    toastr.options.closeDuration = duration;
    toastr.success(msg, title);
}
function Error(msg, title, duration) {
    if (msg == "No en") {
        return false;
    }
    if (msg == "The string supplied did not seem to be a phone number") {
        return false;
    }
    toastr.options.closeButton = true;
    toastr.options.closeDuration = duration;
    toastr.error(msg, title);
}
function Warning(msg, title, duration) {
    if (title === void 0) { title = 'Warning'; }
    if (duration === void 0) { duration = 300; }
    toastr.options.closeButton = true;
    toastr.options.closeDuration = duration;
    toastr.warning(msg, title);
}
function Info(msg, title, duration) {
    if (title === void 0) { title = 'Info'; }
    if (duration === void 0) { duration = 300; }
    toastr.options.closeButton = true;
    toastr.options.closeDuration = duration;
    toastr.info(msg, title);
}
function json_encode(mixed_val) {
    var retVal, json = this.window.JSON;
    try {
        if (typeof json === 'object' && typeof json.stringify === 'function') {
            retVal = json.stringify(mixed_val);
            if (retVal === undefined) {
                throw new SyntaxError('json_encode');
            }
            return retVal;
        }
        var value = mixed_val;
        var quote = function (string) {
            var escapable = /[\\\"\u0000-\u001f\u007f-\u009f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;
            var meta = {
                '\b': '\\b',
                '\t': '\\t',
                '\n': '\\n',
                '\f': '\\f',
                '\r': '\\r',
                '"': '\\"',
                '\\': '\\\\'
            };
            escapable.lastIndex = 0;
            return escapable.test(string) ? '"' + string.replace(escapable, function (a) {
                var c = meta[a];
                return typeof c === 'string' ? c : '\\u' + ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
            }) + '"' : '"' + string + '"';
        };
        var str = function (key, holder) {
            var gap = '';
            var indent = '    ';
            var i = 0;
            var k = '';
            var v = '';
            var length = 0;
            var mind = gap;
            var partial = [];
            var value = holder[key];
            if (value && typeof value === 'object' && typeof value.toJSON === 'function') {
                value = value.toJSON(key);
            }
            switch (typeof value) {
                case 'string':
                    return quote(value);
                case 'number':
                    return isFinite(value) ? String(value) : 'null';
                case 'boolean':
                case 'null':
                    return String(value);
                case 'object':
                    if (!value) {
                        return 'null';
                    }
                    if ((this.PHPJS_Resource && value instanceof this.PHPJS_Resource) || (window.PHPJS_Resource && value instanceof window.PHPJS_Resource)) {
                        throw new SyntaxError('json_encode');
                    }
                    gap += indent;
                    partial = [];
                    if (Object.prototype.toString.apply(value) === '[object Array]') {
                        length = value.length;
                        for (i = 0; i < length; i += 1) {
                            partial[i] = str(i, value) || 'null';
                        }
                        v = partial.length === 0 ? '[]' : gap ? '[\n' + gap + partial.join(',\n' + gap) + '\n' + mind + ']' : '[' + partial.join(',') + ']';
                        gap = mind;
                        return v;
                    }
                    for (k in value) {
                        if (Object.hasOwnProperty.call(value, k)) {
                            v = str(k, value);
                            if (v) {
                                partial.push(quote(k) + (gap ? ': ' : ':') + v);
                            }
                        }
                    }
                    v = partial.length === 0 ? '{}' : gap ? '{\n' + gap + partial.join(',\n' + gap) + '\n' + mind + '}' : '{' + partial.join(',') + '}';
                    gap = mind;
                    return v;
                case 'undefined':
                case 'function':
                default:
                    throw new SyntaxError('json_encode');
            }
        };
        return str('', {
            '': value
        });
    }
    catch (err) {
        if (!(err instanceof SyntaxError)) {
            throw new Error('Unexpected error type in json_encode()');
        }
        this.php_js = this.php_js || {};
        this.php_js.last_error_json = 4;
        return null;
    }
}
function explode(delimiter, string, limit) {
    if (arguments.length < 2 || typeof delimiter === 'undefined' || typeof string === 'undefined') {
        return null;
    }
    if (delimiter === '' || delimiter === false || delimiter === null) {
        return false;
    }
    if (typeof delimiter === 'function' || typeof delimiter === 'object' || typeof string === 'function' || typeof string === 'object') {
        return { 0: '' };
    }
    if (delimiter === true) {
        delimiter = '1';
    }
    delimiter += '';
    string += '';
    var s = string.split(delimiter);
    if (typeof limit === 'undefined') {
        return s;
    }
    if (limit === 0) {
        limit = 1;
    }
    if (limit > 0) {
        if (limit >= s.length) {
            return s;
        }
        return s.slice(0, limit - 1).concat([s.slice(limit - 1).join(delimiter)]);
    }
    if (-limit >= s.length) {
        return [];
    }
    s.splice(s.length + limit);
    return s;
}
function date(format, timestamp) {
    var that = this;
    var jsdate, f;
    var txt_words = [
        'Sun', 'Mon', 'Tues', 'Wednes', 'Thurs', 'Fri', 'Satur',
        'January', 'February', 'March', 'April', 'May', 'June',
        'July', 'August', 'September', 'October', 'November', 'December'
    ];
    var formatChr = /\\?(.?)/gi;
    var formatChrCb = function (t, s) {
        return f[t] ? f[t]() : s;
    };
    var _pad = function (n, c) {
        n = String(n);
        while (n.length < c) {
            n = '0' + n;
        }
        return n;
    };
    f = {
        d: function () {
            return _pad(f.j(), 2);
        },
        D: function () {
            return f.l()
                .slice(0, 3);
        },
        j: function () {
            return jsdate.getDate();
        },
        l: function () {
            return txt_words[f.w()] + 'day';
        },
        N: function () {
            return f.w() || 7;
        },
        S: function () {
            var j = f.j();
            var i = j % 10;
            if (i <= 3 && parseInt((j % 100) / 10, 10) == 1) {
                i = 0;
            }
            return ['st', 'nd', 'rd'][i - 1] || 'th';
        },
        w: function () {
            return jsdate.getDay();
        },
        z: function () {
            var a = new Date(f.Y(), f.n() - 1, f.j());
            var b = new Date(f.Y(), 0, 1);
            return Math.round((a - b) / 864e5);
        },
        W: function () {
            var a = new Date(f.Y(), f.n() - 1, f.j() - f.N() + 3);
            var b = new Date(a.getFullYear(), 0, 4);
            return _pad(1 + Math.round((a - b) / 864e5 / 7), 2);
        },
        F: function () {
            return txt_words[6 + f.n()];
        },
        m: function () {
            return _pad(f.n(), 2);
        },
        M: function () {
            return f.F()
                .slice(0, 3);
        },
        n: function () {
            return jsdate.getMonth() + 1;
        },
        t: function () {
            return (new Date(f.Y(), f.n(), 0))
                .getDate();
        },
        L: function () {
            var j = f.Y();
            return j % 4 === 0 & j % 100 !== 0 | j % 400 === 0;
        },
        o: function () {
            var n = f.n();
            var W = f.W();
            var Y = f.Y();
            return Y + (n === 12 && W < 9 ? 1 : n === 1 && W > 9 ? -1 : 0);
        },
        Y: function () {
            return jsdate.getFullYear();
        },
        y: function () {
            return f.Y()
                .toString()
                .slice(-2);
        },
        a: function () {
            return jsdate.getHours() > 11 ? 'pm' : 'am';
        },
        A: function () {
            return f.a()
                .toUpperCase();
        },
        B: function () {
            var H = jsdate.getUTCHours() * 36e2;
            var i = jsdate.getUTCMinutes() * 60;
            var s = jsdate.getUTCSeconds();
            return _pad(Math.floor((H + i + s + 36e2) / 86.4) % 1e3, 3);
        },
        g: function () {
            return f.G() % 12 || 12;
        },
        G: function () {
            return jsdate.getHours();
        },
        h: function () {
            return _pad(f.g(), 2);
        },
        H: function () {
            return _pad(f.G(), 2);
        },
        i: function () {
            return _pad(jsdate.getMinutes(), 2);
        },
        s: function () {
            return _pad(jsdate.getSeconds(), 2);
        },
        u: function () {
            return _pad(jsdate.getMilliseconds() * 1000, 6);
        },
        e: function () {
            throw 'Not supported (see source code of date() for timezone on how to add support)';
        },
        I: function () {
            var a = new Date(f.Y(), 0);
            var c = Date.UTC(f.Y(), 0);
            var b = new Date(f.Y(), 6);
            var d = Date.UTC(f.Y(), 6);
            return ((a - c) !== (b - d)) ? 1 : 0;
        },
        O: function () {
            var tzo = jsdate.getTimezoneOffset();
            var a = Math.abs(tzo);
            return (tzo > 0 ? '-' : '+') + _pad(Math.floor(a / 60) * 100 + a % 60, 4);
        },
        P: function () {
            var O = f.O();
            return (O.substr(0, 3) + ':' + O.substr(3, 2));
        },
        T: function () {
            return 'UTC';
        },
        Z: function () {
            return -jsdate.getTimezoneOffset() * 60;
        },
        c: function () {
            return 'Y-m-d\\TH:i:sP'.replace(formatChr, formatChrCb);
        },
        r: function () {
            return 'D, d M Y H:i:s O'.replace(formatChr, formatChrCb);
        },
        U: function () {
            return jsdate / 1000 | 0;
        }
    };
    this.date = function (format, timestamp) {
        that = this;
        jsdate = (timestamp === undefined ? new Date() :
            (timestamp instanceof Date) ? new Date(timestamp) :
                new Date(timestamp * 1000));
        return format.replace(formatChr, formatChrCb);
    };
    return this.date(format, timestamp);
}
function strtolower(str) {
    return (str + '')
        .toLowerCase();
}
function basename(path, suffix) {
    var b = path;
    var lastChar = b.charAt(b.length - 1);
    if (lastChar === '/' || lastChar === '\\') {
        b = b.slice(0, -1);
    }
    b = b.replace(/^.*[/\\]/g, '');
    if (typeof suffix === 'string' && b.substr(b.length - suffix.length) === suffix) {
        b = b.substr(0, b.length - suffix.length);
    }
    return b;
}
function strtotime(text, now) {
    var parsed;
    var match;
    var today;
    var year;
    var date;
    var days;
    var ranges;
    var len;
    var times;
    var regex;
    var i;
    var fail = false;
    if (!text) {
        return fail;
    }
    text = text.replace(/^\s+|\s+$/g, '')
        .replace(/\s{2,}/g, ' ')
        .replace(/[\t\r\n]/g, '')
        .toLowerCase();
    var pattern = new RegExp([
        '^(\\d{1,4})',
        '([\\-\\.\\/:])',
        '(\\d{1,2})',
        '([\\-\\.\\/:])',
        '(\\d{1,4})',
        '(?:\\s(\\d{1,2}):(\\d{2})?:?(\\d{2})?)?',
        '(?:\\s([A-Z]+)?)?$'
    ].join(''));
    match = text.match(pattern);
    if (match && match[2] === match[4]) {
        if (match[1] > 1901) {
            switch (match[2]) {
                case '-':
                    if (match[3] > 12 || match[5] > 31) {
                        return fail;
                    }
                    return new Date(match[1], parseInt(match[3], 10) - 1, match[5], match[6] || 0, match[7] || 0, match[8] || 0, match[9] || 0) / 1000;
                case '.':
                    return fail;
                case '/':
                    if (match[3] > 12 || match[5] > 31) {
                        return fail;
                    }
                    return new Date(match[1], parseInt(match[3], 10) - 1, match[5], match[6] || 0, match[7] || 0, match[8] || 0, match[9] || 0) / 1000;
            }
        }
        else if (match[5] > 1901) {
            switch (match[2]) {
                case '-':
                    if (match[3] > 12 || match[1] > 31) {
                        return fail;
                    }
                    return new Date(match[5], parseInt(match[3], 10) - 1, match[1], match[6] || 0, match[7] || 0, match[8] || 0, match[9] || 0) / 1000;
                case '.':
                    if (match[3] > 12 || match[1] > 31) {
                        return fail;
                    }
                    return new Date(match[5], parseInt(match[3], 10) - 1, match[1], match[6] || 0, match[7] || 0, match[8] || 0, match[9] || 0) / 1000;
                case '/':
                    if (match[1] > 12 || match[3] > 31) {
                        return fail;
                    }
                    return new Date(match[5], parseInt(match[1], 10) - 1, match[3], match[6] || 0, match[7] || 0, match[8] || 0, match[9] || 0) / 1000;
            }
        }
        else {
            switch (match[2]) {
                case '-':
                    if (match[3] > 12 || match[5] > 31 || (match[1] < 70 && match[1] > 38)) {
                        return fail;
                    }
                    year = match[1] >= 0 && match[1] <= 38 ? +match[1] + 2000 : match[1];
                    return new Date(year, parseInt(match[3], 10) - 1, match[5], match[6] || 0, match[7] || 0, match[8] || 0, match[9] || 0) / 1000;
                case '.':
                    if (match[5] >= 70) {
                        if (match[3] > 12 || match[1] > 31) {
                            return fail;
                        }
                        return new Date(match[5], parseInt(match[3], 10) - 1, match[1], match[6] || 0, match[7] || 0, match[8] || 0, match[9] || 0) / 1000;
                    }
                    if (match[5] < 60 && !match[6]) {
                        if (match[1] > 23 || match[3] > 59) {
                            return fail;
                        }
                        today = new Date();
                        return new Date(today.getFullYear(), today.getMonth(), today.getDate(), match[1] || 0, match[3] || 0, match[5] || 0, match[9] || 0) / 1000;
                    }
                    return fail;
                case '/':
                    if (match[1] > 12 || match[3] > 31 || (match[5] < 70 && match[5] > 38)) {
                        return fail;
                    }
                    year = match[5] >= 0 && match[5] <= 38 ? +match[5] + 2000 : match[5];
                    return new Date(year, parseInt(match[1], 10) - 1, match[3], match[6] || 0, match[7] || 0, match[8] || 0, match[9] || 0) / 1000;
                case ':':
                    if (match[1] > 23 || match[3] > 59 || match[5] > 59) {
                        return fail;
                    }
                    today = new Date();
                    return new Date(today.getFullYear(), today.getMonth(), today.getDate(), match[1] || 0, match[3] || 0, match[5] || 0) / 1000;
            }
        }
    }
    if (text === 'now') {
        return now === null || isNaN(now)
            ? new Date().getTime() / 1000 | 0
            : now | 0;
    }
    if (!isNaN(parsed = Date.parse(text))) {
        return parsed / 1000 | 0;
    }
    pattern = new RegExp([
        '^([0-9]{4}-[0-9]{2}-[0-9]{2})',
        '[ t]',
        '([0-9]{2}:[0-9]{2}:[0-9]{2}(\\.[0-9]+)?)',
        '([\\+-][0-9]{2}(:[0-9]{2})?|z)'
    ].join(''));
    match = text.match(pattern);
    if (match) {
        if (match[4] === 'z') {
            match[4] = 'Z';
        }
        else if (match[4].match(/^([+-][0-9]{2})$/)) {
            match[4] = match[4] + ':00';
        }
        if (!isNaN(parsed = Date.parse(match[1] + 'T' + match[2] + match[4]))) {
            return parsed / 1000 | 0;
        }
    }
    date = now ? new Date(now * 1000) : new Date();
    days = {
        'sun': 0,
        'mon': 1,
        'tue': 2,
        'wed': 3,
        'thu': 4,
        'fri': 5,
        'sat': 6
    };
    ranges = {
        'yea': 'FullYear',
        'mon': 'Month',
        'day': 'Date',
        'hou': 'Hours',
        'min': 'Minutes',
        'sec': 'Seconds'
    };
    function lastNext(type, range, modifier) {
        var diff;
        var day = days[range];
        if (typeof day !== 'undefined') {
            diff = day - date.getDay();
            if (diff === 0) {
                diff = 7 * modifier;
            }
            else if (diff > 0 && type === 'last') {
                diff -= 7;
            }
            else if (diff < 0 && type === 'next') {
                diff += 7;
            }
            date.setDate(date.getDate() + diff);
        }
    }
    function process(val) {
        var splt = val.split(' ');
        var type = splt[0];
        var range = splt[1].substring(0, 3);
        var typeIsNumber = /\d+/.test(type);
        var ago = splt[2] === 'ago';
        var num = (type === 'last' ? -1 : 1) * (ago ? -1 : 1);
        if (typeIsNumber) {
            num *= parseInt(type, 10);
        }
        if (ranges.hasOwnProperty(range) && !splt[1].match(/^mon(day|\.)?$/i)) {
            return date['set' + ranges[range]](date['get' + ranges[range]]() + num);
        }
        if (range === 'wee') {
            return date.setDate(date.getDate() + (num * 7));
        }
        if (type === 'next' || type === 'last') {
            lastNext(type, range, num);
        }
        else if (!typeIsNumber) {
            return false;
        }
        return true;
    }
    times = '(years?|months?|weeks?|days?|hours?|minutes?|min|seconds?|sec' +
        '|sunday|sun\\.?|monday|mon\\.?|tuesday|tue\\.?|wednesday|wed\\.?' +
        '|thursday|thu\\.?|friday|fri\\.?|saturday|sat\\.?)';
    regex = '([+-]?\\d+\\s' + times + '|' + '(last|next)\\s' + times + ')(\\sago)?';
    match = text.match(new RegExp(regex, 'gi'));
    if (!match) {
        return fail;
    }
    for (i = 0, len = match.length; i < len; i++) {
        if (!process(match[i])) {
            return fail;
        }
    }
    return (date.getTime() / 1000);
}
function isset() {
    var a = arguments;
    var l = a.length;
    var i = 0;
    var undef;
    if (l === 0) {
        throw new Error('Empty isset');
    }
    while (i !== l) {
        if (a[i] === undef || a[i] === null) {
            return false;
        }
        i++;
    }
    return true;
}
function count(mixedVar, mode) {
    var key;
    var cnt = 0;
    if (mixedVar === null || typeof mixedVar === 'undefined') {
        return 0;
    }
    else if (mixedVar.constructor !== Array && mixedVar.constructor !== Object) {
        return 1;
    }
    if (mode === 'COUNT_RECURSIVE') {
        mode = 1;
    }
    if (mode !== 1) {
        mode = 0;
    }
    for (key in mixedVar) {
        if (mixedVar.hasOwnProperty(key)) {
            cnt++;
            if (mode === 1 && mixedVar[key] &&
                (mixedVar[key].constructor === Array ||
                    mixedVar[key].constructor === Object)) {
                cnt += count(mixedVar[key], 1);
            }
        }
    }
    return cnt;
}
function array_merge() {
    var args = Array.prototype.slice.call(arguments);
    var argl = args.length;
    var arg;
    var retObj = {};
    var k = '';
    var argil = 0;
    var j = 0;
    var i = 0;
    var ct = 0;
    var toStr = Object.prototype.toString;
    var retArr = true;
    for (i = 0; i < argl; i++) {
        if (toStr.call(args[i]) !== '[object Array]') {
            retArr = false;
            break;
        }
    }
    if (retArr) {
        retArr = [];
        for (i = 0; i < argl; i++) {
            retArr = retArr.concat(args[i]);
        }
        return retArr;
    }
    for (i = 0, ct = 0; i < argl; i++) {
        arg = args[i];
        if (toStr.call(arg) === '[object Array]') {
            for (j = 0, argil = arg.length; j < argil; j++) {
                retObj[ct++] = arg[j];
            }
        }
        else {
            for (k in arg) {
                if (arg.hasOwnProperty(k)) {
                    if (parseInt(k, 10) + '' === k) {
                        retObj[ct++] = arg[k];
                    }
                    else {
                        retObj[k] = arg[k];
                    }
                }
            }
        }
    }
    return retObj;
}
function empty(mixedVar) {
    var undef;
    var key;
    var i;
    var len;
    var emptyValues = [undef, null, false, 0, '', '0'];
    for (i = 0, len = emptyValues.length; i < len; i++) {
        if (mixedVar === emptyValues[i]) {
            return true;
        }
    }
    if (typeof mixedVar === 'object') {
        for (key in mixedVar) {
            if (mixedVar.hasOwnProperty(key)) {
                return false;
            }
        }
        return true;
    }
    return false;
}
function echo() {
    var args = Array.prototype.slice.call(arguments);
    return console.log(args.join(' '));
}
function print_r(array, returnVal) {
    var output = '';
    var padChar = ' ';
    var padVal = 4;
    var _repeatChar = function (len, padChar) {
        var str = '';
        for (var i = 0; i < len; i++) {
            str += padChar;
        }
        return str;
    };
    var _formatArray = function (obj, curDepth, padVal, padChar) {
        if (curDepth > 0) {
            curDepth++;
        }
        var basePad = _repeatChar(padVal * curDepth, padChar);
        var thickPad = _repeatChar(padVal * (curDepth + 1), padChar);
        var str = '';
        if (typeof obj === 'object' &&
            obj !== null &&
            obj.constructor) {
            str += 'Array\n' + basePad + '(\n';
            for (var key in obj) {
                if (Object.prototype.toString.call(obj[key]) === '[object Array]') {
                    str += thickPad;
                    str += '[';
                    str += key;
                    str += '] => ';
                    str += _formatArray(obj[key], curDepth + 1, padVal, padChar);
                }
                else {
                    str += thickPad;
                    str += '[';
                    str += key;
                    str += '] => ';
                    str += obj[key];
                    str += '\n';
                }
            }
            str += basePad + ')\n';
        }
        else if (obj === null || obj === undefined) {
            str = '';
        }
        else {
            str = obj.toString();
        }
        return str;
    };
    output = _formatArray(array, 0, padVal, padChar);
    if (returnVal !== true) {
        echo(output);
        return true;
    }
    return output;
}
function implode(glue, pieces) {
    var i = '';
    var retVal = '';
    var tGlue = '';
    if (arguments.length === 1) {
        pieces = glue;
        glue = '';
    }
    if (typeof pieces === 'object') {
        if (Object.prototype.toString.call(pieces) === '[object Array]') {
            return pieces.join(glue);
        }
        for (i in pieces) {
            retVal += tGlue + pieces[i];
            tGlue = glue;
        }
        return retVal;
    }
    return pieces;
}
var yesno = function (param) {
    if (param == 1 || param == true) {
        return "Yes";
    }
    else {
        return "No";
    }
};
function str_ireplace(search, replace, subject, countObj) {
    var i = 0;
    var j = 0;
    var temp = '';
    var repl = '';
    var sl = 0;
    var fl = 0;
    var f = '';
    var r = '';
    var s = '';
    var ra = '';
    var otemp = '';
    var oi = '';
    var ofjl = '';
    var os = subject;
    var osa = Object.prototype.toString.call(os) === '[object Array]';
    if (typeof (search) === 'object') {
        temp = search;
        search = [];
        for (i = 0; i < temp.length; i += 1) {
            search[i] = temp[i].toLowerCase();
        }
    }
    else {
        search = search.toLowerCase();
    }
    if (typeof (subject) === 'object') {
        temp = subject;
        subject = [];
        for (i = 0; i < temp.length; i += 1) {
            subject[i] = temp[i].toLowerCase();
        }
    }
    else {
        subject = subject.toLowerCase();
    }
    if (typeof (search) === 'object' && typeof (replace) === 'string') {
        temp = replace;
        replace = [];
        for (i = 0; i < search.length; i += 1) {
            replace[i] = temp;
        }
    }
    temp = '';
    f = [].concat(search);
    r = [].concat(replace);
    ra = Object.prototype.toString.call(r) === '[object Array]';
    s = subject;
    s = [].concat(s);
    os = [].concat(os);
    if (countObj) {
        countObj.value = 0;
    }
    for (i = 0, sl = s.length; i < sl; i++) {
        if (s[i] === '') {
            continue;
        }
        for (j = 0, fl = f.length; j < fl; j++) {
            temp = s[i] + '';
            repl = ra ? (r[j] !== undefined ? r[j] : '') : r[0];
            s[i] = (temp).split(f[j]).join(repl);
            otemp = os[i] + '';
            oi = temp.indexOf(f[j]);
            ofjl = f[j].length;
            if (oi >= 0) {
                os[i] = (otemp).split(otemp.substr(oi, ofjl)).join(repl);
            }
            if (countObj) {
                countObj.value += ((temp.split(f[j])).length - 1);
            }
        }
    }
    return osa ? os : os[0];
}
function str_replace(find, replace, str) {
    return str.replace(new RegExp(find, 'g'), replace);
}
var get_url_variables = function (keyParam) {
    if (location.search) {
        params = {};
        var parts = location.search.substring(1).split('&');
        for (var i = 0; i < parts.length; i++) {
            var nv = parts[i].split('=');
            if (!nv[0]) {
                continue;
            }
            if (typeof keyParam != 'undefined' && keyParam == nv[0]) {
                return nv[1];
            }
            params[nv[0]] = nv[1] || true;
        }
        return params;
    }
    else {
        return {};
    }
};
var remove_url_parameter = function (parameter, url, set_url) {
    if (!url) {
        url = window.location.href;
    }
    if (typeof set_url == "undefined") {
        set_url = true;
    }
    var urlparts = url.split('?');
    if (urlparts.length >= 2) {
        var prefix = encodeURIComponent(parameter);
        var pars = urlparts[1].split(/[&;]/g);
        for (var i = pars.length; i-- > 0;) {
            if (pars[i].lastIndexOf(prefix, 0) !== -1) {
                pars.splice(i, 1);
            }
        }
        url = urlparts[0] + '?' + pars.join('&');
        if (url.substr(-1) == "?") {
            url = url.substr(0, url.length - 1);
        }
        if (set_url) {
            set_new_url(url);
        }
        else {
            return url;
        }
    }
    else {
        if (url.substr(-1) == "?") {
            url = url.substr(0, url.length - 1);
        }
        if (set_url) {
            set_new_url(url);
        }
        else {
            return url;
        }
    }
};
var set_new_url = function ($new_url, title) {
    window.history.pushState({}, title, $new_url);
    if (title) {
        document.title = title;
    }
};
var urlencode = function (str) {
    str = (str + '')
        .toString();
    return encodeURIComponent(str)
        .replace(/!/g, '%21')
        .replace(/'/g, '%27')
        .replace(/\(/g, '%28')
        .replace(/\)/g, '%29')
        .replace(/\*/g, '%2A')
        .replace(/%20/g, '+');
};
var array_keys = function (input, searchValue, argStrict) {
    var search = typeof searchValue !== 'undefined';
    var tmpArr = [];
    var strict = !!argStrict;
    var include = true;
    var key = '';
    for (key in input) {
        if (input.hasOwnProperty(key)) {
            include = true;
            if (search) {
                if (strict && input[key] !== searchValue) {
                    include = false;
                }
                else if (input[key] !== searchValue) {
                    include = false;
                }
            }
            if (include) {
                tmpArr[tmpArr.length] = key;
            }
        }
    }
    return tmpArr;
};
var array_values = function (input) {
    var tmpArr = [];
    var key = '';
    for (key in input) {
        tmpArr[tmpArr.length] = input[key];
    }
    return tmpArr;
};
var strip_tags = function (string) {
    return string.replace(/(<([^>]+)>)/ig, "");
};
var filename = function () {
    var url = window.location.pathname;
    var lastUri = url.substring(url.lastIndexOf('/') + 1);
    if (lastUri.indexOf('?') != -1) {
        file = lastUri.substring(0, lastUri.indexOf('?'));
    }
    else {
        file = lastUri;
    }
    if (file == "") {
        file = "index.php";
    }
    return file;
};
var isInViewport = function (query_selector) {
    if ($(query_selector).length == 0) {
        return false;
    }
    var elem = document.querySelector(query_selector);
    var distance = elem.getBoundingClientRect();
    return (distance.top >= 0 &&
        distance.left >= 0 &&
        distance.bottom <= (window.innerHeight || document.documentElement.clientHeight) &&
        distance.right <= (window.innerWidth || document.documentElement.clientWidth));
};
$(function () {
    if ("Notification" in window) {
        if (typeof Notification === 'undefined') {
            return;
        }
        if (Notification.permission !== "granted") {
            Notification.requestPermission();
        }
        if (is_localhost) {
            var err_source = new EventSource(root_url + "ajax.php?error_notification");
            err_source.onmessage = function (event) {
                if (event.data == "OK") {
                    notifyMe("Error Notification", "New errors generated", root_url + "?errors_view");
                }
            };
            var logs_source = new EventSource(root_url + "ajax.php?logs_notification");
            logs_source.onmessage = function (event) {
                if (event.data == "OK") {
                    notifyMe("Debug Logs", "New logs generated", root_url + "?logs_view");
                }
            };
        }
    }
});
function notifyMe(title, message, url) {
    if (!Notification) {
        return;
    }
    url = url || root_url;
    if (Notification.permission !== "granted") {
        Notification.requestPermission();
    }
    else {
        var notification = new Notification(title, {
            icon: ASSETS_URL + 'img/logo-big.png',
            body: message,
        });
        notification.onclick = function () {
            if (url) {
                window.open(url);
            }
        };
    }
}
var close_filters = function () {
    $('#filters').animate({
        'left': '-250px'
    });
};
var open_filters = function () {
    $('#filters').animate({
        'left': '0'
    });
};
var download_pdf = function (url, filename) {
    url = urlencode(url);
    $('#pdf_form_footer').html('<input name="url" value="' + url + '">');
    filename = filename || 'download';
    $('#pdf_form_footer').append('<input name="filename" value="' + filename + '">');
    $('#pdf_form_footer').trigger('submit');
};
var my_date = function () {
    return date('d-M-Y');
};
function nl2br(str, isXhtml) {
    if (typeof str === 'undefined' || str === null) {
        return '';
    }
    var breakTag = (isXhtml || typeof isXhtml === 'undefined') ? '<br ' + '/>' : '<br>';
    return (str + '')
        .replace(/(\r\n|\n\r|\r|\n)/g, breakTag + '$1');
}
function round(value, precision, mode) {
    var m, f, isHalf, sgn;
    precision |= 0;
    m = Math.pow(10, precision);
    value *= m;
    sgn = (value > 0) | -(value < 0);
    isHalf = value % 1 === 0.5 * sgn;
    f = Math.floor(value);
    if (isHalf) {
        switch (mode) {
            case 'PHP_ROUND_HALF_DOWN':
                value = f + (sgn < 0);
                break;
            case 'PHP_ROUND_HALF_EVEN':
                value = f + (f % 2 * sgn);
                break;
            case 'PHP_ROUND_HALF_ODD':
                value = f + !(f % 2);
                break;
            default:
                value = f + (sgn > 0);
        }
    }
    return (isHalf ? value : Math.round(value)) / m;
}
//# sourceMappingURL=script.js.map