<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "administrator" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$title = "Sessions - " . System;
include_once( __DIR__ . "/header.php" );
$s = new Sessions();
$S = $s->get_list();
//get classes
$c     = new Classes();
$class = $c->get_list();

?>

<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<div class="modal fade" id="modal1" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
		<div class="modal-dialog">
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
					<h4 class="modal-title">Save Sessions</h4>
				</div>
				<div class="modal-body">
					<form class="form-horizontal" id="form1">
						<input type="submit" class="hidden" id="submit1">
						<input type="reset" class="hidden" id="reset1">
						<input type="hidden" name="id" value="0" id="id">
						<div class="form-body">

							<div class="form-group">
								<label class="col-md-3 control-label">Session Name</label>
								<div class="col-md-9">
									<input type="text" class="form-control" placeholder="Enter unique session name" name="session_name" id="session_name" required="required">
								</div>
							</div>

							<div class="form-group">
								<label class="control-label col-md-3">Class</label>
								<div class="col-md-9">
									<select class="form-control select2" id="classes" name="classes[]" multiple="multiple" style="width: 100%;">
										<?php foreach ( $class as $row ): ?>
											<option value="<?php echo $row["id"] ?>"><?php echo $row["name"] ?></option>
										<?php endforeach; ?>
									</select>
								</div>
							</div>

							<div class="form-group">
								<label class="col-md-3 control-label">Starting Date</label>
								<div class="col-md-9">
									<input id="start_date" type="text" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>" class="form-control form-control-inline date-picker" placeholder="Select session's starting date" name="start_date" required="required">
								</div>
							</div>

							<div class="form-group">
								<label class="col-md-3 control-label">Ending Date</label>
								<div class="col-md-9">
									<input id="end_date" type="text" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>" class="form-control form-control-inline date-picker" placeholder="Select session's ending date" name="end_date" required="required">
								</div>
							</div>

							<div class="form-group">
								<label class="col-md-3 control-label">Active Session</label>
								<div class="col-md-9">
									<select class="form-control" name="active" id="active">
										<option value="0">No</option>
										<option value="1">Yes</option>
									</select>
								</div>
							</div>

						</div>
					</form>
				</div>
				<div class="modal-footer">
					<button type="button" class="btn blue" onclick="$('#submit1').click();">Save Session</button>
					<button type="button" class="btn default" data-dismiss="modal">Close</button>
				</div>
			</div>
			<!-- /.modal-content -->
		</div>
		<!-- /.modal-dialog -->
	</div>

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						Batches/Years/Sessions
						<small>Manage sessions or years of school</small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
								<i class="fa fa-angle-down"></i>
							</button>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>">Home</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							Application
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							Batches/Years/Sessions
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-user"></i>Sessions
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
							</div>
						</div>
						<div class="portlet-body">
							<div class="table-toolbar">
								<div class="btn-group">
									<button type="button" class="btn green btn add">
										<i class="fa fa-plus"></i> Add Session
									</button>
								</div>
								<div class="btn-group pull-right">
									<button class="btn dropdown-toggle" data-toggle="dropdown">Tools
										<i class="fa fa-angle-down"></i>
									</button>
									<ul class="dropdown-menu pull-right">
										<li>
											<a href="#" class="add">Add Session</a>
										</li>
									</ul>
								</div>
							</div>
							<table class="table table-striped table-bordered table-hover datatable">
								<thead>
								<tr>
									<th>ID</th>
									<th>Session Name</th>
									<th>Session Dates</th>
									<th>Active</th>
									<th>Classes</th>
								</tr>
								</thead>
								<tbody>
								<?php if ( count( $S ) > 0 ): foreach ( $S as $row ): ?>
									<tr class="odd gradeX">
										<td><?php echo $row["id"] ?></td>
										<td>
											<a data-id="<?php echo $row["id"] ?>" class="edit" href="#"><?php echo $row["session_name"] ?></a>
										</td>
										<td><?php echo \Dates::my_date( $row["start_date"] ) ?> &gt; <?php echo \Dates::my_date( $row["end_date"] ) ?></td>
										<td><?php echo( $row["active"] ) ?></td>
										<td><?php echo count( explode( ',', $row['classes'] ) ); ?></td>
									</tr>
								<?php endforeach; endif; ?>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->
<?php include_once( __DIR__ . "/footer.php" ); ?>
<script type="text/javascript">
	$( function() {
		$( document ).on( "click", ".add", function( e ) {
			e.preventDefault();
			$( "#reset1" ).click();
			$( "#modal1" ).modal( 'show' );
		} );

		$( document ).on( "submit", "#form1", function( e ) {
			e.preventDefault();
			// alert ($("#form1").serialize()); return;
			$( "#modal1" ).modal( 'hide' );
			Block();
			$.post( "<?php echo DOMAIN_URL ?>includes/ajax.php?action=saveSession", $( "#form1" ).serialize(), function( data ) {
				if ( data=="OK" ) {
					Success( "Sessions saved successfully!" )
					window.location.href = "<?php echo Urls::get_url( "sessions" ); ?>";
				} else {
					UnBlock();
					Error( data );
					$( "#modal1" ).modal( 'show' );
				}
			} );
			return false;
		} );

		$( document ).on( "click", ".edit", function( e ) {
			e.preventDefault();
			id = $( this ).data( 'id' );
			Block();
			$.post( "<?php echo DOMAIN_URL ?>includes/ajax.php?action=getSession", { id: id }, function( data ) {
				UnBlock();
				console.log( data );
				// return;
				if ( is_json( data ) ) {
					data = JSON.parse( data );
					$( "#id" ).val( data.id );
					$( "#session_name" ).val( data.session_name );
					$( "#start_date" ).val( data.start_date );
					$( "#end_date" ).val( data.end_date );
					$( "#active" ).val( data.active );
					$( "#modal1" ).modal( 'show' );
					// get students
					if ( data.classes!=null ) {
						var arr2 = data.classes.split( ',' );
						$( "select#classes" ).select2( "destroy" );
						$( 'select#classes option' ).each( function() {
							var val = $( this ).val();
							for ( var i = 0; i<arr2.length; i++ ) {
								if ( arr2[ i ]==val ) {
									$( '#classes option[value="' + val + '"]' ).attr( "selected", "selected" );
								}
							}
						} );
						$( "select#classes" ).select2();
					}
				} else {
					Error( "Can't get data." );
				}
			} );
		} );
	} );

</script>
</body>
<!-- END BODY -->
</html>