<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "administrator" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$title = "Accounts Settings | " . System;
include_once( __DIR__ . "/header.php" );
$accounts = new Accounts;
?>
<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN SAMPLE PORTLET CONFIGURATION MODAL FORM-->
			<div class="modal fade" id="class-modal" tabindex="-1" role="dialog" aria-hidden="true">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
							<h4 class="modal-title"><?php _e( 'Head' ) ?></h4>
						</div>
						<div class="modal-body">
							<form name="form1" id="form1" onsubmit="return Save()" class="form1">
								<input type="submit" id="form1submit" style="display:none">
								<input type="hidden" name="id" id="id" value="0" />

								<label for="name"><?php _e( 'Type head' ) ?></label><br />
								<input class="col-md-12 form-control" title="<?php _e( 'Account head' ) ?>" type="text" name="head" id="head" required="required" placeholder="Account head" />
							</form>
							<br />
						</div>
						<div class="modal-footer">
							<button type="button" class="btn default" data-dismiss="modal"><?php _e( 'Close' ) ?></button>
							<button type="button" class="btn blue" onclick="SubmitForm1()"><?php _e( 'Save Changes' ) ?></button>
						</div>
					</div>
					<!-- /.modal-content -->
				</div>
				<!-- /.modal-dialog -->
			</div>

			<!-- END STYLE CUSTOMIZER -->
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						Account Settings
						<small>Manage account settings</small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
								<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="javascript:;" onclick="Add()"><i class="fa fa-plus"></i> Add Head</a>
								</li>
							</ul>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="index.php">Home</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							Account Settings
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">

					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								Heads List
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<!--a href="#portlet-config" data-toggle="modal" class="config"></a>
								<a href="javascript:;" class="reload"></a>
								<a href="javascript:;" class="remove"></a-->
							</div>
						</div>
						<div class="portlet-body">
							<table class="table table-striped table-bordered table-hover datatable">
								<thead>
								<tr>
									<th>ID</th>
									<th>Head</th>
									<th style="width: 50px;">&nbsp;</th>
								</tr>
								</thead>
								<tbody>
								<?php $rows = $accounts->get_account_heads( "pagesize=99999" );
								foreach ( $rows["rows"] as $row ): ?>
									<tr>
										<td><?php echo $row["id"] ?></td>
										<td>
											<a href="javascript:;" onclick="Edit(<?php echo $row["id"] ?>,this)"><?php echo $row["head"] ?></a>
										</td>
										<td>
											<button class="btn btn-xs red" onclick="Del(<?php echo $row["id"] ?>,this)">
												<i class="fa fa-trash"></i></button>
										</td>
									</tr>
								<?php endforeach; ?>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->
<?php include_once( __DIR__ . "/footer.php" ); ?>
<script>
	function Add() {
		document.form1.reset();
		$( "#id" ).val( 0 );
		$( "#head" ).val( "" );
		//$(".toggle")
		$( "#class-modal .modal-title" ).html( "Add Head" );
		$( "#class-modal" ).modal( "show" );
	}

	function Edit( id, t ) {
		$( "#id" ).val( id );
		v = $( t ).parent();
		$( "#head" ).val( v.text() );
		$( "#class-modal .modal-title" ).html( "Edit head" );
		$( "#class-modal" ).modal( "show" );
	}

	function SubmitForm1() {
		$( '#form1submit' ).click();
	}

	function Save() {
		if ( $( "#head" ).val()=="" ) {
			bootbox.alert( "Please type head." );
			$( "#head" ).select();
			return false;
		}

		//$("#ajax").modal("show");
		Block();
		$.post( "<?php echo ROOT_URL ?>includes/old_ajax.php?action=saveAccountHead", $( "#form1" ).serialize(), function( data ) {
			if ( data=="OK" ) {
				window.location.reload();
			} else {
				UnBlock();
				Error( data );
			}
		} );
		return false;
	}

	function Del( id, t ) {
		bootbox.confirm( "Are you sure you want to delete this entry?", function( result ) {
			if ( result==false ) {
				return;
			}
			Block();
			$.post( '<?php echo Urls::get_url( "ajax", 0, "action=delAccountHead" ) ?>', { id: id }, function( result ) {
				UnBlock();
				if ( result=="OK" ) {
					var row = $( t ).parent().parent();
					var row_id = dataTable.fnGetPosition( row[ 0 ] );
					dataTable.fnDeleteRow( row_id );
					Success( "Class removed successfully!" );
				} else {
					//bootbox.alert(result);
					Error( result );
				}
			} );
		} );
	}

	$( function() {
		$( "#name" ).keypress( function( e ) {
			if ( e.which=="13" ) {
				SubmitForm1();
			}
		} );
	} );
	$( function() {
		$( document ).bind( "keydown", "Ctrl+A", function() {
			Add();
			return false;
		} );
	} );
</script>

</body>
<!-- END BODY -->
</html>