<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title = __( "PDF Generation Settings" );
include_once( __DIR__ . "/header.php" ); ?>
<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="modal fade" id="portlet-config" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
							<h4 class="modal-title">Modal title</h4>
						</div>
						<div class="modal-body">
							Widget settings form goes here
						</div>
						<div class="modal-footer">
							<button type="button" class="btn blue">Save changes</button>
							<button type="button" class="btn default" data-dismiss="modal">Close</button>
						</div>
					</div>
					<!-- /.modal-content -->
				</div>
				<!-- /.modal-dialog -->
			</div>

			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( 'PDF Settings' ) ?>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button type="button" class="btn btn-primary" onclick="$('#settings_form').trigger('submit');">
								<i class="fa fa-save"></i> <?php _e( 'Save' ) ?>
							</button>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php _e( "Settings" ) ?>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="settings_pdf.php"><?php _e( "PDF Settings" ) ?></a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<form action="ajax/settings_pdf.php?save" method="post" class="form-horizontal" id="settings_form">
						<div class="form-body">
							<div class="row">
								<div class="col-md-6">
									<div class="form-group">
										<label for="pdf_page_orientation" class="control-label col-md-4"><?php _e( 'Page Orientation' ) ?></label>
										<div class="col-md-8">
											<select name="pdf_page_orientation" id="pdf_page_orientation" class="form-control">
												<option value="Portrait"><?php _e( 'Portrait' ) ?></option>
												<option <?php echo $db->get_option( 'pdf_page_orientation' ) == 'Landscape' ? 'selected' : '' ?> value="Landscape"><?php _e( 'Landscape' ) ?></option>
											</select>
											<span class="help-block">
												<?php _e( 'Find information about page orientation here' ) ?><br>
												<a target="_blank" href="https://en.wikipedia.org/wiki/Page_orientation">https://en.wikipedia.org/wiki/Page_orientation</a>
											</span>
										</div>
									</div>
								</div>
								<div class="col-md-6">
									<div class="form-group">
										<label for="pdf_page_size" class="control-label col-md-4"><?php _e( 'Page size' ) ?></label>
										<div class="col-md-8">
											<select name="pdf_page_size" id="pdf_page_size" class="form-control">
												<option value="A4"><?php _e( 'A4' ) ?></option>
												<option <?php echo $db->get_option( 'pdf_page_size' ) == 'Letter' ? 'selected' : '' ?> value="Letter"><?php _e( 'Letter' ) ?></option>
												<option <?php echo $db->get_option( 'pdf_page_size' ) == 'Legal' ? 'selected' : '' ?> value="Legal"><?php _e( 'Legal' ) ?></option>
												<option <?php echo $db->get_option( 'pdf_page_size' ) == 'Ledger' ? 'selected' : '' ?> value="Ledger"><?php _e( 'Ledger' ) ?></option>
												<option <?php echo $db->get_option( 'pdf_page_size' ) == 'Folio' ? 'selected' : '' ?> value="Folio"><?php _e( 'Folio' ) ?></option>
												<option <?php echo $db->get_option( 'pdf_page_size' ) == 'Executive' ? 'selected' : '' ?> value="Executive"><?php _e( 'Executive' ) ?></option>
												<option <?php echo $db->get_option( 'pdf_page_size' ) == 'DLE' ? 'selected' : '' ?> value="DLE"><?php _e( 'DLE' ) ?></option>
												<option <?php echo $db->get_option( 'pdf_page_size' ) == 'Comm10E' ? 'selected' : '' ?> value="Comm10E"><?php _e( 'Comm10E' ) ?></option>
												<option <?php echo $db->get_option( 'pdf_page_size' ) == 'C5E' ? 'selected' : '' ?> value="C5E"><?php _e( 'C5E' ) ?></option>
											</select>
											<span class="help-block">
												<?php _e( 'Find information about page sizes' ) ?><br>
												<a target="_blank" href="http://qt-project.org/doc/qt-4.8/qprinter.html#PaperSize-enum">http://qt-project.org/doc/qt-4.8/qprinter.html#PaperSize-enum</a>
											</span>
										</div>
									</div>
								</div>
							</div>
							<div class="row">
								<div class="col-md-6">
									<div class="form-group">
										<label for="pdf_page_numbers" class="control-label col-md-4"><?php _e( 'Show page numbers' ) ?></label>
										<div class="col-md-8">
											<select name="pdf_page_numbers" id="pdf_page_numbers" class="form-control">
												<option value="">== <?php _e( 'No' ) ?> ==</option>
												<option <?php echo $db->get_option( 'pdf_page_numbers' ) == 'footer-left' ? 'selected' : '' ?> value="footer-left"><?php _e( 'Show in footer left' ) ?></option>
												<option <?php echo $db->get_option( 'pdf_page_numbers' ) == 'footer-right' ? 'selected' : '' ?> value="footer-right"><?php _e( 'Show in footer right' ) ?></option>
												<option <?php echo $db->get_option( 'pdf_page_numbers' ) == 'footer-center' ? 'selected' : '' ?> value="footer-center"><?php _e( 'Show in footer center' ) ?></option>
												<option <?php echo $db->get_option( 'pdf_page_numbers' ) == 'header-left' ? 'selected' : '' ?> value="header-left"><?php _e( 'Show in header left' ) ?></option>
												<option <?php echo $db->get_option( 'pdf_page_numbers' ) == 'header-right' ? 'selected' : '' ?> value="header-right"><?php _e( 'Show in header right' ) ?></option>
												<option <?php echo $db->get_option( 'pdf_page_numbers' ) == 'header-center' ? 'selected' : '' ?> value="header-center"><?php _e( 'Show in header center' ) ?></option>
											</select>
											<span class="help-block">
												<?php _e( 'Show page numbers in PDF' ) ?>
											</span>
										</div>
									</div>
								</div>
								<div class="col-md-6">
									<div class="form-group">
										<label for="pdf_zoom" class="control-label col-md-4"><?php _e( 'Zoom' ) ?></label>
										<div class="col-md-8">
											<select name="pdf_zoom" id="pdf_zoom" class="form-control">
												<?php for ( $x = 1; $x <= 5; $x ++ ) { ?>
													<option <?php echo $db->get_option( 'pdf_zoom' ) == $x ? 'selected' : '' ?>><?php echo $x ?></option>
												<?php } ?>
											</select>
										</div>
									</div>
								</div>
							</div>
						</div>
						<div class="form-actions fluid">
							<div class="row">
								<div class="col-md-6">
									<div class="col-md-offset-4 col-md-8">
										<button type="submit" class="btn btn-primary"><?php _e( 'Save Settings' ) ?></button>
									</div>
								</div>
								<div class="col-md-6">
								</div>
							</div>
						</div>
					</form>
				</div>
			</div>
		</div>
	</div>
</div>

<?php include_once( __DIR__ . "/footer.php" ); ?>
<script src="<?php echo ASSETS_URL ?>script_js/settings_pdf.js?<?php echo md5_file( ASSETS_PATH . "script_js/settings_pdf.js" ) ?>"></script>
</body>
</html>