<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$SMS    = new SMS;
$Admins = new Admins;

if ( isset( $_GET["empty_sms_queue"] ) ) {
	$SMS->empty_sms_queue();
	exit;
}
if ( isset( $_GET["load_data"] ) ) {
	header( 'Content-Type: application/json' );
	$rows = $SMS->get_sms_queue();
	$HTML = "";

	if ( count( $rows ) == 0 ) {
		$HTML = "<tr><td style='text-align:center' colspan='8'>--<i>" . __( "No SMS" ) . "</i>--</td></tr>";
	}
	foreach ( $rows as $row ) {
		$HTML .= '<tr id="TR' . $row["id"] . '">
			<td>' . $row["to"] . '</td>
			<td>' . nl2br( $row["message"] ) . '</td>
			<td>' . $row["ip"] . '</td>
			<td>' . \Admins\UserInfo::get_admin( "username", $row["user_id"] ) . '</td>';
		if ( \Dates::empty_date( $row["added_time"] ) ) {
			$HTML .= '<td><i>' . __( "Time not logged" ) . '</i></td>';
		} else {
			$HTML .= '<td>' . human_time_difference2( $row["added_time"] ) . '</td>';
		}

		$HTML .= '<td>' . $row["error"] . '</td>
			<td style="text-align: right;">
				<button onclick="Del(' . $row["id"] . ')" class="btn red btn-xs">
					<i class="fa fa-trash-o"></i> Del
				</button>
			</td>
		</tr>';
	}
	echo json_encode( [ "html" => $HTML, "count" => __( "%1 queued SMS", $SMS->count_queued_sms() ) ] );
	exit;
	die;
}

if ( ! \Admins\UserInfo::is_allowed( "sms_section" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$title = "SMS Queue - Unset SMS";
include_once( __DIR__ . "/header.php" ); ?>

<?php if ( \General::is_offline() ) { ?>
	<!--	<link rel="stylesheet" type="text/css" href="--><?php //echo $_theme->url() ?><!--utils/countdown/jquery.countdown.css">-->
<?php } else { ?>
	<!--	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/jquery-countdown/2.0.2/jquery.countdown.min.css">-->
<?php } ?>

<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>

	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						SMS Queue
						<small>All un-sent SMS list</small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>">Home</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#">SMS</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "sms/queue" ) ?>">SMS Queue</a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<div class="note note-info">
						<!--<p style="width: 200px; float:right" id="nextRun"></p>-->
						<h4 class="block">
							<?php _e( "Note" ) ?>
						</h4>
						<p>
							<?php _e( "SMS Queue process after every 5 minutes." ) ?>
						</p>
					</div>
					<div class="btn-group">
						<span class="btn btn-sm green" id="counting"></span>
						<button id="empty_trash_btn" class="btn btn-sm red"><?php _e( "Empty Queue" ) ?></button>
					</div>
					<table class="table table-striped table-bordered table-hover" id="mytable">
						<thead>
						<tr class="heading">
							<th><?php _e( "Recipient" ) ?></th>
							<th><?php _e( "Message" ) ?></th>
							<th><?php _e( "IP Address" ) ?></th>
							<th><?php _e( "User" ) ?></th>
							<th><?php _e( "Time" ) ?></th>
							<th><?php _e( "Error (If)" ) ?></th>
							<th>&nbsp;</th>
						</tr>
						</thead>
						<tbody>
						<tr>
							<td class="center" colspan="8">
								<i class="fa fa-spin fa-spinner"></i> <?php _e( "Loading Data" ) ?> --
							</td>
						</tr>
						</tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>

<?php include_once( __DIR__ . "/footer.php" ); ?>
<?php if ( \General::is_offline() ) { ?>
	<!--	<script type="text/javascript" src="--><?php //echo $_theme->url() ?><!--utils/countdown/jquery.plugin.min.js"></script>-->
	<!--	<script type="text/javascript" src="--><?php //echo $_theme->url() ?><!--utils/countdown/jquery.countdown.min.js"></script>-->
<?php } else { ?>
	<!--	<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-countdown/2.0.2/jquery.plugin.min.js"></script>-->
	<!--	<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-countdown/2.0.2/jquery.countdown.min.js"></script>-->
<?php } ?>
<script type="text/javascript">
	function load_data() {
		$.post( "<?php echo Urls::get_url( "sms_queue", 0, "load_data" ) ?>", function( data ) {
			$( "#mytable tbody" ).html( data.html );
			$( "#counting" ).html( data.count );
			setTimeout( function() {
				load_data()
			}, 30000 );
		} );
	}

	function Del( id ) {
		if ( !confirm( "<?php _e( "Are you sure you want to delete this queues SMS?" ) ?>" ) ) {
			return false;
		}

		$( "#TR" + id ).remove();
		var T = $( "#counting" ).text();
		T = T.split( ' ' );
		T[ 0 ] = Number( T[ 0 ] ) - 1;
		$( "#counting" ).html( T.join( ' ' ) );

		$.post( '<?php echo Urls::get_url( "ajax", 0, "action=delSMSQueue" ) ?>', { id: id }, function( data ) {

		} );

		/*bootbox.confirm( "Are you sure you want to delete this SMS?", function( result ) {
			if ( result == false ) {
				return;
			}
			Block();

		} );*/
	}

	function liftOff() {
		window.location.href = "<?php echo Urls::get_url( "sms/queue" ) ?>";
	}

	function HightLight( periods ) {
		if ( $.countdown.periodsToSeconds( periods )===5 ) {
			$( this ).css( {
				"color": "#FF0000",
				"font-weight": "bold"
			} );
		}
	}

	$( function() {
		load_data();
		<?php $t = $db->get_option( "cron_5minutes", time() );
		if ( $t <= time() || empty( $t ) ) {
			$t = time() + 300;
		}
		$t += 2;
		?>
		/*var liftoffTime = new Date();
		liftoffTime.setDate( liftoffTime.getDate() );
		liftoffTime.setTime(<?php echo $t * 1000 ?>);
		$( "#nextRun" ).countdown( {
			until: liftoffTime,
			format: 'MS',
			description: '<br />SMS will sent after',
			onExpiry: liftOff,
			onTick: HightLight
		} );*/

		$( document ).on( "click", "#empty_trash_btn", function( event ) {
			event.preventDefault();

			if ( !confirm( "<?php _e( "Are you sure you want to remove all SMS from queue?" ) ?>" ) ) {
				return false;
			}

			$( "#mytable tbody" ).html( "<tr><td style='text-align:center' colspan='8'>--<i><?php _e( "No SMS" ) ?></i>--</td></tr>" );
			$.post( "<?php echo Urls::get_url( "sms_queue", 0, "empty_sms_queue" ) ?>", function() {

			} );
		} );
	} );
</script>
</body>
</html>