<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title              = "Student Monthly Report";
$_GET["student_id"] = isset( $_GET["student_id"] ) ? $_GET["student_id"] : 0;
include_once( __DIR__ . "/header.php" );
$BatchClass = new BatchClass;
$C          = $BatchClass->get_list();
$Subject    = new Subject;
$S          = $Subject->get_list( "orderby=subject" );
?>

<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						Student Weekly Report
						<small>Generate report</small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<!--li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
							<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="#">Action</a>
								</li>
								<li>
									<a href="#">Another action</a>
								</li>
								<li>
									<a href="#">Something else here</a>
								</li>
								<li class="divider">
								</li>
								<li>
									<a href="#">Separated link</a>
								</li>
							</ul>
						</li-->
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>">Home</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#">Reporting</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#">Student Weekly Report</a>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i>Generate Report
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<a href="#portlet-config" data-toggle="modal" class="config"></a>
								<a href="javascript:;" class="reload"></a>
								<a href="javascript:;" class="remove"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form target="_ems" action="<?php echo Urls::get_url( "download_student_weekly_report" ) ?>" class="form-horizontal form-bordered">
								<div class="form-group">
									<label class="control-label col-md-3">Select Student</label>
									<div class="col-md-4">
										<input autocomplete="off" value="<?php echo $_GET["student_id"] ?>" required="required" type="text" class="form-control input-xlarge" name="student_id" id="student_id" />
										<p class="help-block">
											Type student name, father name, roll or cell number.
										</p>
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-md-3">Test/Exam Schedule Date Range</label>
									<div class="col-md-4">
										<div class="input-group input-xlarge date-picker input-daterange" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>">
											<input value="<?php echo date( "01-m-Y" ) ?>" required="required" type="text" class="form-control" name="from" placeholder="From Date">
											<span class="input-group-addon">
												to
											</span>
											<input value="<?php echo \Dates::my_date() ?>" required="required" type="text" class="form-control" name="to" placeholder="To Date">
										</div>
										<!-- /input-group -->
										<span class="help-block">
											Select date range
										</span>
									</div>
								</div>
								<div id="moresubjects"></div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="submit" name="viewBtn" class="btn green">View Report</button>
										<button type="submit" name="smsBtn" class="btn yellow">Send SMS</button>
										<button type="submit" name="downBtn" class="btn blue">Download Report</button>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>
<script src="<?php echo ASSETS_URL ?>plugins/bootstrap/js/bootstrap2-typeahead.min.js" type="text/javascript"></script>

<script type="text/javascript">
	<?php
	//$Students = new Student
	$S = $Student->get_students();
	$array = array();
	foreach ( $S as $student ) {
		$f       = empty( $student["father_name"] ) ? $student["guardian_name"] : $student["father_name"];
		$c       = empty( $student["cell"] ) ? $student["guardian_cell"] : $student["cell"];
		$array[] = "{$student["id"]} - Name: {$student["name"]} - Father: {$f} - Roll: {$student["roll"]} - Cell: {$c}";
	}
	?>
	$( function() {
		$( "#student_id" ).typeahead( {
			source: <?php echo json_encode( $array ) ?>

		} );
	} );
</script>
</body>
<!-- END BODY -->
</html>