<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title              = __( "Student Payment Report" );
$_GET["student_id"] = isset( $_GET["student_id"] ) ? $_GET["student_id"] : 0;

include_once( __DIR__ . "/header.php" );

$BatchClass = new BatchClass;
$C          = $BatchClass->get_list();
$Subject    = new Subject;
$S          = $Subject->get_list( "orderby=subject" );
?>

<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>

	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __( "Student Payment Report" ) ?>
						<small><?php echo __( "Generate report" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<!--li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
							<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="#">Action</a>
								</li>
								<li>
									<a href="#">Another action</a>
								</li>
								<li>
									<a href="#">Something else here</a>
								</li>
								<li class="divider">
								</li>
								<li>
									<a href="#">Separated link</a>
								</li>
							</ul>
						</li-->
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php echo __( "Reporting" ) ?>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="student_payment_report.php">
								<?php _e( "Student Payment Report" ) ?>
							</a>
						</li>
					</ul>
				</div>
			</div>

			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php echo __( "Generate Report" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<!--<a href="#portlet-config" data-toggle="modal" class="config"></a>-->
							</div>
						</div>
						<div class="portlet-body form">
							<form target="_ems" action="<?php echo \Urls::get_url( "download_student_payment_report" ) ?>" class="form-horizontal form-bordered validate">
								<div class="form-group">
									<label class="control-label col-md-3"><?php echo __( "Select Student" ) ?></label>
									<div class="col-md-4">
										<input title="<?php echo strip_tags( __( "Select student please" ) ) ?>" value="<?php echo $_GET["student_id"] ?>" required="required" type="text" class="form-control input-xlarge" name="student_id" id="student_id" />
										<p class="help-block">
											<?php echo __( "Type student name, father name, roll or cell number." ) ?>
										</p>
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-md-3"><?php echo __( "Date Range" ) ?></label>
									<div class="col-md-4">
										<div class="input-group input-xlarge date-picker input-daterange" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>">
											<input value="<?php echo date( "01-m-Y" ) ?>" required="required" type="text" class="form-control" name="from" placeholder="<?php echo strip_tags( __( "From Date" ) ) ?>">
											<span class="input-group-addon">
												to
											</span>
											<input value="<?php echo \Dates::my_date() ?>" required="required" type="text" class="form-control" name="to" placeholder="<?php echo strip_tags( __( "To Date" ) ) ?>">
										</div>
										<span class="help-block">
											<?php echo __( "Select date range" ) ?>
										</span>
									</div>
								</div>
								<div id="moresubjects"></div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<div class="btn-group">
											<button type="submit" name="viewBtn" class="btn green"><?php echo __( "View Report" ) ?></button>
											<button type="submit" name="downBtn" class="btn blue"><?php echo __( "Download Report" ) ?></button>
										</div>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>

<?php include_once( __DIR__ . "/footer.php" ); ?>
<script src="<?php echo ASSETS_URL ?>plugins/bootstrap/js/bootstrap2-typeahead.min.js" type="text/javascript"></script>

<script type="text/javascript">
	<?php
	//$Students = new Student
	$S = $Student->get_students();
	$array = array();
	foreach ( $S as $student ) {
		$f       = empty( $student["father_name"] ) ? $student["guardian_name"] : $student["father_name"];
		$c       = empty( $student["cell"] ) ? $student["guardian_cell"] : $student["cell"];
		$array[] = "{$student["id"]} - Name: {$student["name"]} - Father: {$f} - Roll: {$student["roll"]} - Cell: {$c}";
	}
	?>
	$( function() {
		$( "#student_id" ).typeahead( {
			source: <?php echo json_encode( $array ) ?>
		} );
	} );
</script>
</body>
</html>