<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title              = __("Student Weekly Report");
$_GET["student_id"] = isset( $_GET["student_id"] ) ? $_GET["student_id"] : 0;
include_once( __DIR__ . "/header.php" );
$BatchClass = new BatchClass;
$C          = $BatchClass->get_list();
$Subject    = new Subject;
$S          = $Subject->get_list( "orderby=subject" );
?>

<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>

	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( "Student Weekly Report" ) ?>
						<small><?php _e( "Generate report" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<!--li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
							<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="#">Action</a>
								</li>
								<li>
									<a href="#">Another action</a>
								</li>
								<li>
									<a href="#">Something else here</a>
								</li>
								<li class="divider">
								</li>
								<li>
									<a href="#">Separated link</a>
								</li>
							</ul>
						</li-->
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e("Home") ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#"><?php _e( "Student Reports" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="student_weekly_report.php"><?php _e( "Weekly" ) ?></a>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i>
								<?php _e( "Generate Report" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form id="report_form" action="<?php echo Urls::get_url( "download_student_weekly_report" ) ?>" class="form-horizontal form-bordered" onsubmit="return Form(1);">
								<div class="form-group">
									<label class="control-label col-md-4"><?php _e( "Select Student" ) ?></label>
									<div class="col-md-8">
										<input autocomplete="off" value="<?php echo $_GET["student_id"] ?>" required="required"
										       placeholder="<?php _e( "Select Student" ) ?>"
										       type="text" class="form-control" name="student_id" id="student_id">
										<p class="help-block">
											<?php _e( "Type student name, father name, roll or cell number." ) ?>
										</p>
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-md-4">
										<?php _e( "Test/Exam Schedule Date Range" ) ?>
									</label>
									<div class="col-md-8">
										<div class="input-group">
											<input value="<?php echo date( "Y-m-01" ) ?>" required="required" type="date" class="form-control" name="from" placeholder="<?php _e("From Date") ?>">
											<span class="input-group-addon">
												<?php _e("to") ?>
											</span>
											<input value="<?php echo date( "Y-m-01" ) ?>" required="required" type="date" class="form-control" name="to" placeholder="<?php _e("To Date") ?>">
										</div>
									</div>
								</div>
								<div id="moresubjects"></div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<div class="btn-group">
											<button type="button" onclick="Form(1)" class="btn green"><?php _e( "View Report" ) ?></button>
											<button type="button" onclick="Form(2)" name="smsBtn" class="btn yellow"><?php _e( "Send SMS" ) ?></button>
											<button type="button" onclick="Form(3)" name="downBtn" class="btn blue"><?php _e( "Download Report" ) ?></button>
										</div>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>
<script src="<?php echo ASSETS_URL ?>plugins/bootstrap/js/bootstrap2-typeahead.min.js" type="text/javascript"></script>
<script src="<?php echo Urls::get_url( "students.js" ) ?>"></script>
<script src="<?php ?>"></script>
<script type="text/javascript">
	function Sub1( form ) {
		alert( $( form ).serialize() );
		return false;
	}

	$( function() {
		$( "#student_id" ).typeahead( {
			source: Students
		} );
	} );

	function Form( btn ) {
		if ( btn==1 ) {
			u = $( "#report_form" ).serialize() + "&viewBtn";
		} else if ( btn==2 ) {
			u = $( "#report_form" ).serialize() + "&smsBtn";
		} else {
			u = $( "#report_form" ).serialize();
			window.location.href = $( "#report_form" ).attr( "action" ) + "?" + u;
			return false;
		}

		u = $( "#report_form" ).attr( "action" ) + "?" + u;
		$.fancybox( {
			'title': "<?php _e("Weekly Report") ?>",
			'href': u,
			'type': 'iframe',
			'width': '90%',
			'height': '90%',
		} );
	}
</script>
</body>
</html>