<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "administrator" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$title = "Subjects | " . System;
include_once( __DIR__ . "/header.php" );
include_once( LIBRARY_PATH . "templates/panel/subjects.tpl" );
?>
<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row" id="topline" style="z-index:9999;background-color: #fff">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __( "Subjects" ) ?>
						<small>
							<?php echo __( "Manage subjects" ) ?>
						</small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button id="del_multi_btn" type="button" class="btn red">
								<i class="fa fa-trash"></i> <?php _e( 'Delete' ) ?></button>
							<button type="button" id="add_subject_btn" class="btn btn-primary">
								<i class="fa fa-plus"></i> <?php _e( 'Add Subject' ) ?></button>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e( 'Home' ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="subjects.php">
								<?php echo __( "Subjects" ) ?>
							</a>
						</li>
					</ul>
				</div>
			</div>

			<div class="modal fade" id="subjects-modal" tabindex="-1" role="dialog" aria-hidden="true">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
							<h4 class="modal-title"><?php echo __( 'Subjects' ) ?></h4>
						</div>
						<div class="modal-body">
							<form name="form1" id="form1" class="form1" method="post" action="ajax/subjects.php?save">
								<input type="hidden" name="id" id="id" value="0">
								<div class="form-group">
									<label for="subject" class="control-label"><?php echo __( "Type subject" ) ?></label>
									<input class="form-control" title="<?php _e( 'Subject' ) ?>" type="text" name="subject"
									       id="subject" required="required" placeholder="<?php _e( 'Subject' ) ?>">
								</div>
								<div class="form-group">
									<label for="short_name" class="control-label"><?php _e( 'Short name' ) ?></label>
									<input class="form-control" title="<?php _e( 'Short name' ) ?>" type="text" name="short_name"
									       id="short_name" required="required" placeholder="<?php _e( 'Short Name' ) ?>">
								</div>
							</form>
						</div>
						<div class="modal-footer">
							<div class="btn-group">
								<button type="button" class="btn default" data-dismiss="modal"><?php _e( 'Close' ) ?></button>
								<button type="button" class="btn btn-primary" onclick="$('#form1').trigger('submit')"><?php _e( 'Save' ) ?></button>
							</div>
						</div>
					</div>
					<!-- /.modal-content -->
				</div>
				<!-- /.modal-dialog -->
			</div>

			<div class="row" id="newForm">
				<div class="col-md-12">
					<div id="top_line">

					</div>
					<table class="table table-striped table-bordered table-hover">
						<thead>
						<tr class="heading">
							<th>
								<label class="href">
									<input type="checkbox" id="checkbox">
									<?php _e( 'Subject' ) ?>
								</label>
							</th>
							<th>Short Name</th>
							<th style="width: 40px;">&nbsp;</th>
						</tr>
						</thead>
						<tbody id="tbody1">
						<!--
						<?php
						/*						$rows = $s->get_list( "orderby=order_by&order=ASC" );
												foreach ( $rows as $row ): */ ?>
							<tr class="odd gradeX">
								<td>
									<input type="number" value="<?php /*echo $row["order_by"] */ ?>" title="Set order for subject" class="tooltips form-control input-small" onchange="SaveOrder(this,<?php /*echo $row["id"] */ ?>)" />
								</td>
								<td><?php /*echo $row["subject"] */ ?></td>
								<td>
									<input value="<?php /*echo $row["short_name"] */ ?>" title="Type for change short name" class="tooltips form-control input-small" maxlength="10" onchange="SaveShortName(this,<?php /*echo $row["id"] */ ?>)" />
								</td>
								<td>
									<a href="javascript:void()" title="Delete Subject" class="tooltips btn red btn-xs" onclick="Del(<?php /*echo $row["id"] */ ?>,this)"><i class="fa fa-minus" title="Delete Subject"></i></a>
								</td>
							</tr>
						<?php /*endforeach; */ ?>
						-->
						</tbody>
					</table>

				</div>
			</div>
		</div>
	</div>
</div>
<?php include_once( __DIR__ . "/footer.php" ); ?>

<script src="<?php echo ASSETS_URL ?>script_js/subjects.js?<?php echo md5_file( ASSETS_PATH . "script_js/subjects.js" ) ?>"></script>
</body>
</html>