<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "manage_teachers" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$id = (int) isset( $_GET["id"] ) ? $_GET["id"] : 0;
if ( $db->get_var( "SELECT COUNT(*) FROM `teachers` WHERE `id`=$id" ) == 0 ) {
	Urls::redirect( DOMAIN_URL . "teachers.php" );
}
$title = "Edit Teacher";
include_once( __DIR__ . "/header.php" );
$Teacher  = new Teacher;
$T        = $Teacher->get_teacher( $id );
$getData  = $Teacher->get_teachers_assign_classes( $id );
$classids = [];
if ( ! empty( $getData ) ) {
	foreach ( $getData as $a ) {
		$classids[] = $a["id"];
	}
}

$batch = new BatchClass;
if ( ! isset( $class_id ) ) {
	$class_id = 0;
}
if ( $class_id == 0 ) {
	$b    = $batch->get_active_batch();
	$data = [
		"id"            => 0,
		"class_name"    => "",
		"active"        => 1,
		"batch_id"      => $b["id"],
		"subjects"      => [],
		"fee"           => 0,
		"fine_id"       => 0,
		"fine_name"     => "-- No Fine --",
		"admission_fee" => "0",
	];
}
// get subject
$s        = new Subject;
$subjects = $s->get_list();
$Subs     = array();
foreach ( $subjects as $subject ) {
	if ( ! in_arrayi( $subject["subject"], $data["subjects"] ) ) {
		$Subs[] = $subject["subject"];
	}
}
// get all classes
$c        = new BatchClass();
$classes  = $c->get_list( "orderby=name&order=ASC" );
$Classes2 = array();
foreach ( $classes as $class ) {
	$Classes2[] = $class["class_name"];
}
if ( $data["class_name"] <> "" && ! in_array( $data["class_name"], $Classes2 ) ) {
	$Classes2[] = $data["class_name"];
}
?>
<style type="text/css">
	.extraField {
		margin-top: 20px;
	}

	.innerExtraField {
		margin-top: 10px;
	}

	.innerExtraField select {
		float: left;
	}

	#divcount {
		padding-bottom: 10px;
	}
</style>
<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->
	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<!-- BEGIN PAGE HEADER-->
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						<?php echo __( "Students" ) ?>
						<small><?php echo __( "Manage students data here" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="teachers.php"><?php echo __( "Teachers" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href=""><?php echo __( "Edit Teacher" ) ?></a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-user-circle"></i>
								Edit Teacher
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<!--<a href="#portlet-config" data-toggle="modal" class="config"></a>
								<a href="javascript:;" class="reload"></a>
								<a href="javascript:;" class="remove"></a>-->
							</div>
						</div>
						<div class="portlet-body form">
							<form action="<?php echo DOMAIN_URL ?>ajax/teacher.php?save" method="post" class="form-horizontal form-bordered validate" id="form1">
								<input type="hidden" name="id" value="<?php echo $id ?>" />
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Teacher Name" ) ?></label>
										<div class="col-md-9">
											<input value="<?php echo $T["name"] ?>" type="text" name="name"
											       title="<?php echo __( "Teacher name required" ) ?>" required="required"
											       class="form-control" placeholder="<?php echo __( "Teacher name required" ) ?>">
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Short Name" ) ?></label>
										<div class="col-md-9">
											<input value="<?php echo $T["short_name"] ?>" type="text" name="short_name"
											       title="<?php echo __( "Short name for teacher" ) ?>" class="form-control"
											       placeholder="<?php echo __( "Short name for teacher" ) ?>">
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Email address" ) ?></label>
										<div class="col-md-9">
											<input value="<?php echo $T["email"] ?>" type="email" name="email"
											       title="<?php echo __( "Email address required" ) ?>" required="required"
											       class="form-control" placeholder="<?php echo __( "Email address required" ) ?>">
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Cell Number" ) ?></label>
										<div class="col-md-9">
											<input value="<?php echo $T["cell"] ?>" type="text" name="cell"
											       title="<?php echo __( "Cell number required" ) ?>" required="required"
											       class="form-control" placeholder="<?php echo __( "Cell number required" ) ?>">
										</div>
									</div>
									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Date of Joining" ) ?></label>
										<div class="col-md-9">
											<input
												value="<?php echo \Dates::my_date( $T["date_of_joining"] ) ?>"
												type="text" name="date_of_joining" title="<?php echo __( "Date of joining" ) ?>"
												required="required" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>"
												class="form-control date-picker" placeholder="<?php echo __( "Date of joining" ) ?>">
										</div>
									</div>

									<div class="form-group">
										<label class="control-label col-md-3"><?php echo __( "Assigned Classes" ) ?></label>
										<div class="col-md-9">
											<select class="form-control select2" name="classes[]" id="classassign"
											        multiple="multiple">
												<?php $rows = $c->get_list( "batch_id=0&orderby=batch_id,class_name&order=desc" );
												foreach ( $rows as $row ) { ?>
													<option <?php if ( in_array( $row["id"], $classids ) ) {
														echo 'selected="selected"';
													} ?>
														value="<?php echo $row["id"] ?>"
														data-class_name="<?php echo $row["class_name"] ?>">
														<?php echo $row["batch_name"]; ?> &raquo;
														<?php echo $row["class_name"] ?>
														(<?php echo $row["students_count"] ?> <?php echo __( "Students" ) ?>)
													</option>
												<?php } ?>
											</select>
										</div>
									</div>
									<!--
									<div class="form-group">
										<label class="control-label col-md-3">
											<?php echo __( "Class Subjects Assign" ) ?>
										</label>
										<div class="col-md-9">
											<a class="row" id="addnewRow" style="cursor: pointer;">Add Subject</a>
											<br>

											<div id="load_subjects">
												<?php
									$getSubjects = $Teacher->get_teachers_assign_subjects( $id );
									if ( isset( $getSubjects ) ) {
										foreach ( $getSubjects as $k => $sub ) {
											$no = $k . time();
											?>

														<div id="divcount" class="divcount<?php echo $no ?>">

															<a style="cursor: pointer;padding-right: 2px;"
															   data-removeid="<?php echo $no ?>" class="removeSub">
																<i class="fa fa-times" aria-hidden="true"></i>
															</a>
															<select style="width: 44%;" class="form-control select2 class_assign_subject<?php echo $no ?>" data-loadsub="<?php echo $no ?>"
															        name="class_assign_subject[]"
															        id="class_assign_subject" style="width: 44%;">
																<?php foreach ( $rows as $row ) { ?>
																	<option <?php if ( $sub["classname"] == $row["name"] ) { ?> selected <?php } ?>
																		value="<?php echo $row["name"] ?>"><?php echo $row["name"] ?></option>
																<?php } ?>
															</select>

															<select class="form-control select2"
															        name="subject_assign[]"
															        id="subject_assign<?php echo $no ?>" style="width: 44%;">

																<?php foreach ( $rows as $row ) { ?>
																	<?php if ( $sub["classname"] == $row["name"] ) {
												if ( $row["subjects"] != "" ) {
													$subname = explode( ",", $row["subjects"] );
													foreach ( $subname as $s ) {
														if ( $sub["subjectname"] == $s ) {
															?>
																					<option selected value="<?php echo $s ?>"><?php echo $s ?></option>
																				<?php } else { ?>
																					<option value="<?php echo $s ?>"><?php echo $s ?></option>
																				<?php }
													}
												}
											}
											}
											?>
															</select>
														</div>

													<?php }
									} ?>

											</div>

										</div>
									</div>
										-->

									<div class="form-group">
										<label class="control-label col-md-3">
											<?php echo __( "Address" ) ?>
										</label>
										<div class="col-md-9">
											<input value="<?php echo $T["address"] ?>" type="text" name="address"
											       title="<?php echo __( "Home Address" ) ?>" class="form-control">
										</div>
									</div>

									<div class="form-group">
										<label class="control-label col-md-3">
											<?php echo __( "Salary" ) ?>
										</label>
										<div class="col-md-9">
											<input value="<?php echo $T["salary"] ?>" type="number" name="salary"
											       title="<?php echo __( "Salary" ) ?>" class="form-control">
										</div>
									</div>

								</div>

								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="submit" class="btn blue"><?php echo __( "Save" ) ?></button>
										<a href="teachers.php" class="btn default">
											<?php echo __( "Cancel" ) ?>
										</a>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="application/javascript">
	function Save( event ) {
		event.preventDefault();
		Block();

		$( '#form1' ).ajaxSubmit( {
			success: function( data ) {
				if ( data=="OK" ) {
					Success( "<?php echo __( "Teacher data updated successfully!" ) ?>" );
					$( '#form1' ).areYouSure( { 'silent': true } );
					window.location.href = "<?php echo DOMAIN_URL ?>teachers.php";
				} else {
					UnBlock();
					Error( data );
				}
			},
			error: function( e1, e2, e3 ) {
				UnBlock();
				Error( e3 );
			}
		} );

		return false;
	}

	$( function() {
		$( document ).on( "submit", "#form1", Save );
		$( document ).on( "click", ".removeSub", function( e ) {
			e.preventDefault();
			var removeid = $( this ).data( "removeid" );
			$( ".divcount" + removeid ).remove();
			$( ".removeSub" + removeid ).remove();
		} );

		$( document ).on( "change", "#class_assign_subject", function( e ) {
			Block();
			var classname = $( this ).val();
			var loadsub = $( this ).data( "loadsub" );
			$.post( "<?php echo Urls::get_url( "ajax", 0, "action=getClassSubjects" ) ?>", { class: classname }, function( data ) {
				if ( is_json( data ) ) {
					UnBlock();
					data = jQuery.parseJSON( data );
					$( "#subject_assign" + loadsub ).html( '' );
					$.each( data, function( k, v ) {
						$( "#subject_assign" + loadsub ).append( $( "<option></option>" ).attr( "value", v ).text( v ) );
					} );
				}
			} );
		} );

		$( document ).on( "click", "#addnewRow", function( e ) {
			e.preventDefault();
			Block();
			var random = Math.ceil( Math.random() * 8.8 );
			var $div = $( "#load_subjects #divcount" ).length + 1 + random;
			$( "select.class_assign_subject" + $div ).select2( "destroy" );
			$( "select.subject_assign" + $div ).select2( "destroy" );
			$( "#load_subjects" ).prepend( '<div id="divcount" class="divcount' + $div + '"><a style="cursor: pointer;padding-right: 2px;" data-removeid=' + $div + ' class="removeSub"><i class="fa fa-times" aria-hidden="true"></i></a><select class="form-control select2 class_assign_subject' + $div + '" data-loadsub="' + $div + '" id="class_assign_subject" name="class_assign_subject[]" style="width: 44%;"><option value="">-- Select Class --</option></select><select class="form-control select2" id="subject_assign' + $div + '" name="subject_assign[]" style="width: 44%;float: right;margin-right: 60px;" required="required"></select></div>' );
			$( "select.class_assign_subject" + $div ).select2( "val", '' );
			<?php foreach($rows as $row){?>
			var v = '<?php echo $row["class_name"]?>';
			$( "select.class_assign_subject" + $div ).append( $( "<option></option>" ).attr( "value", v ).text( v ) );
			<?php } ?>
			$( "select.class_assign_subject" + $div ).select2();
			$( "select.subject_assign" + $div ).select2();
			UnBlock();
		} );
	} );

</script>
</body>
<!-- END BODY -->
</html>