<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
if ( ! \Admins\UserInfo::is_allowed( "manage_teachers" ) ) {
	include_once( __DIR__ . "/no_access.php" );
}
$Teacher = new Teacher();

if ( isset( $_GET["change_password"] ) ) {
	echo $Teacher->change_password_by_admin( $_POST );
	exit;
}

$title = __("Teachers");
include_once( __DIR__ . "/header.php" ); ?>

<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>

	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php echo __( "Teachers" ) ?>
						<small><?php echo __( "Manage teachers data here" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								<?php echo __( "Actions" ) ?>
							</span>
								<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="add_teacher.php">
										<i class="fa fa-plus"></i> <?php echo __( "Add Teacher" ) ?>
									</a>
								</li>
							</ul>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<?php _e('Employees') ?>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="teachers.php"><?php echo __( "Teachers" ) ?></a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<?php
					$rows = $Teacher->get_teachers(); ?>
					<table class="table table-bordered table-striped custom_dt">
						<thead>
						<tr class="heading">
							<th><?php echo __( "ID" ) ?></th>
							<th><?php echo __( "Name" ) ?></th>
							<th><?php echo __( "Cell" ) ?></th>
							<th><?php echo __( "Email" ) ?></th>
							<th><?php echo __( "Address" ) ?></th>
							<th><?php echo __( "Joining Date" ) ?></th>
							<th><?php echo __( "Classes" ) ?></th>
						</tr>
						</thead>
						<tbody>
						<?php foreach ( $rows as $row ): ?>
							<tr data-id="<?php echo $row["id"] ?>">
								<td>
									<?php echo $row["id"] ?>
									<br>
									<a title="Change password" class="change_pass" href="#"><i class="fa fa-key"></i></a>
								</td>
								<td>
									<a href="<?php echo DOMAIN_URL ?>teacher.php?id=<?php echo $row["id"] ?>"><?php echo $row["name"] ?></a>
									<?php if ( ! empty( $row["short_name"] ) ) {
										echo " (" . $row["short_name"] . ")";
									} ?>
								</td>
								<td><?php echo $row["cell"] ?></td>
								<td><?php echo $row["email"] ?></td>
								<td><?php echo $row["address"] ?></td>
								<td><?php echo \Dates::my_date( $row["date_of_joining"] ) ?></td>
								<td>
									<?php $C = $Teacher->get_teachers_assign_classes( $row["id"] );
									$arr     = [];
									foreach ( $C as $class ) {
										$arr[] = $class["class_name"];
									}
									if ( count( $arr ) > 0 ) {
										echo "<ol><li>";
										echo implode( "</li><li>", $arr );
										echo "</li></ol>";
									}
									?>
								</td>
							</tr>
						<?php endforeach; ?>
						</tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script type="text/javascript">
	$( function() {
		dataTable2 = $( '.custom_dt' ).dataTable( {
			"aLengthMenu": [
				[ 10, 20, 30, 40, 50, 100, -1 ],
				[ 10, 20, 30, 40, 50, 100, "All" ] // change per page values here
			],
			// set the initial value
			"iDisplayLength": 10,
			"oLanguage": {
				"sLengthMenu": "_MENU_ records",
				"oPaginate": {
					"sPrevious": "Previous Page",
					"sNext": "Next Page"
				}
			},
			"aaSorting": [ [ 1, "asc" ] ],
			"aoColumns": [
				{ "bSortable": true },
				{ "bSortable": true },
				{ "bSortable": true },
				{ "bSortable": true },
				{ "bSortable": true },
				{ "bSortable": true },
				{ "bSortable": false }
			]
		} );
		$( document ).on( "click", ".change_pass", function( event ) {
			event.preventDefault();
			var id = $( this ).closest( "tr" ).attr( "data-id" );

			var new_password = window.prompt( "Type new password for this teacher user." );
			if ( new_password ) {
				Block();
				$.post( "<?php echo Urls::get_url( "teachers", 0, "change_password" ) ?>", {
					id: id,
					password: new_password
				}, function( data ) {
					UnBlock();
					if ( data=="OK" ) {
						Success( "<?php echo __( "Password changed successfully!" ) ?>" );
					} else {
						Error( data );
					}
				} );
			}
		} );
	} );
</script>
</body>
</html>