<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too... :)";
	exit;
}
$title  = __( "Time Table/Schedules" );

$Shifts = new TimeTable\Shifts();
$TimeTable = new \TimeTable\TimeTable();

$Classes = new BatchClass();
$Teacher = new Teacher();
$Subject = new Subject();
include_once( __DIR__ . "/header.php" );
include_once( LIBRARY_PATH . "templates/panel/time_table.tpl" );
?>
<div id="print_div" style="display: none">
	<div></div>
</div>
<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>

	<div class="modal fade" id="tt_modal" tabindex="-1" role="basic" aria-hidden="true">
		<div class="modal-dialog modal-full">
			<div class="modal-content">
				<form id="time_table_form">
					<div class="modal-header">
						<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
						<h4 class="modal-title"><?php _e( "Save Time Table" ) ?></h4>
					</div>
					<div class="modal-body">

					</div>
					<div class="modal-footer">
						<div class="btn-group">
							<button type="button" class="btn default" data-dismiss="modal"><?php _e("Close") ?></button>
							<button type="submit" class="btn blue"><?php _e("Save changes") ?></button>
						</div>
					</div>
				</form>
			</div>
		</div>
	</div>

	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( "Time Table" ) ?>
						<small><?php _e( "List of all time table/schedules" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li class="btn-group">
							<button type="button" class="btn green" id="manage_shifts_btn">
								<i class="fa fa-clock-o"></i> <?php _e( "Manage Shifts" ) ?>
							</button>
							<button type="button" class="btn btn-primary add_time_table_btn">
								<i class="fa fa-plus"></i> <?php _e( "Add Time Table" ) ?>
							</button>
						</li>
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php _e( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "time_table" ) ?>"><?php _e( "Time Table" ) ?></a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<table class="table table-bordered table-striped" dir="<?php echo $Trans->is_rtl()?'rtl':'' ?>">
						<thead>
						<tr class="heading">
							<th><?php _e("Classes") ?></th>
							<th><?php _e("Teachers") ?></th>
							<th><?php _e("Subjects") ?></th>
							<th style="width:30px"></th>
						</tr>
						</thead>
						<tbody id="tbody1">
							<tr><td colspan="5" style="text-align:center"><i class="fa fa-spin fa-spinner"></i> <?php _e("Loading") ?> ...</td></tr>
						</tbody>
					</table>
				</div>
			</div>
		</div>
	</div>
</div>

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script>
	var saved_sring = "<?php _e('Saved') ?>";
	var noshift_string = "<?php _e("No shifts are defined to use in time table, Do you want to add shifts?") ?>";
	var Page = 1;
	var Rows = <?php echo json_encode( $Shifts->get_shifts() ) ?>;
	var ajax_url = "<?php echo DOMAIN_URL ?>ajax/time_table.php";
	var shifts_count = <?php echo $Shifts->count_shifts() ?>;
	var Classes = <?php echo json_encode($Classes->get_list("active=1&batch_id=0&orderby=batch_id"), JSON_PRETTY_PRINT); ?>;
	var Teachers = <?php echo json_encode( $Teacher->get_teachers("active=1&mysql_cols=id,name") ); ?>;
	var Subjects = <?php echo json_encode( $Subject->get_list("mysql_cols=id,subject") ); ?>;
</script>

<script src="<?php echo ASSETS_URL ?>script_js/time_table.js?<?php echo md5_file( ASSETS_PATH . "script_js/time_table.js" ) ?>"></script>
</body>
</html>