<?php if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title = "Toppers Report";
include_once( __DIR__ . "/header.php" );
$BatchClass = new BatchClass;
$C          = $BatchClass->get_list();
?>

<div class="page-container">
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>

	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<h3 class="page-title">
						<?php _e( "Toppers Report" ) ?>
						<small><?php _e( "Generate report" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<!--li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
							<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="#">Action</a>
								</li>
								<li>
									<a href="#">Another action</a>
								</li>
								<li>
									<a href="#">Something else here</a>
								</li>
								<li class="divider">
								</li>
								<li>
									<a href="#">Separated link</a>
								</li>
							</ul>
						</li-->
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>">Home</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#">Reporting</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#">Toppers Report</a>
						</li>
					</ul>
				</div>
			</div>
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i> <?php _e( "Generate Report" ) ?>
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<a href="#portlet-config" data-toggle="modal" class="config"></a>
								<a href="javascript:;" class="reload"></a>
								<a href="javascript:;" class="remove"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form target="_ems" action="<?php echo Urls::get_url( "download_toppers_report" ) ?>" class="form-horizontal form-bordered">
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3">Type Percentage</label>
										<div class="col-md-4">
											<input type="number" step="0.01" min="1" required="required" value="80" class="form-control input-xlarge" name="percentage" id="percentage" />
										</div>
									</div>
								</div>
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e( "Select Class" ) ?></label>
										<div class="col-md-9">
											<select class="form-control select2" name="class_id">
												<option value="0">=== <?php _e( "All Classes" ) ?> ===</option>
												<?php foreach ( $C as $c ): ?>
													<option value="<?php echo $c["id"] ?>"><?php echo $c["class_name"] ?></option>
												<?php endforeach; ?>
											</select>
											<span class="help-block">
        										<?php _e( "Select class" ) ?>
        									</span>
										</div>
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-md-3"><?php _e( "Test/Exam Schedule Date Range" ) ?></label>
									<div class="col-md-9">
										<div class="input-group date-picker input-daterange" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>">
											<input value="<?php echo date( "01-m-Y" ) ?>" required="required" type="text" class="form-control" name="from" placeholder="From Date">
											<span class="input-group-addon">
												to
											</span>
											<input value="<?php echo date( $db->get_option( "date_format1" ) ) ?>" required="required" type="text" class="form-control" name="to" placeholder="To Date">
										</div>
										<!-- /input-group -->
										<span class="help-block">
											Select date range
										</span>
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-md-3"><?php _e( "Order By" ) ?></label>
									<div class="col-md-9">
										<div class="input-group date-picker input-daterange" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>">
											<select class="form-control" name="orderby">
												<option value="">==Default==</option>
												<option value="name"><?php _e( "Student Name" ) ?></option>
												<option value="total"><?php _e( "Total Marks" ) ?></option>
												<option selected="selected" value="percentage"><?php _e( "Percentage" ) ?></option>
											</select>
											<span class="input-group-addon">
												<?php _e( "order" ) ?>
											</span>
											<select class="form-control" name="order">
												<option value="ASC"><?php _e( "Ascending" ) ?></option>
												<option selected="selected" value="DESC"><?php _e( "Descending" ) ?></option>
											</select>
										</div>
										<span class="help-block">
											<?php _e( "Change order of records" ) ?>
										</span>
									</div>
								</div>
								<div id="moresubjects"></div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<button type="submit" name="viewBtn" class="btn green">View Report</button>
										<button type="submit" name="downBtn" class="btn blue">Download Report</button>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<!-- END PAGE CONTENT-->
		</div>
	</div>
	<!-- END CONTENT -->
</div>

<?php include_once( __DIR__ . "/footer.php" ); ?>

</body>
<!-- END BODY -->
</html>