<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$Translation = new Translation();

if ( isset( $_GET['downloadSampleStrings'] ) ) {
	$Translation->download_sample_strings();
	exit();
}

$title = __( "Manage Translations" );
include_once( __DIR__ . "/header.php" ); ?>

<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						<?php echo __( "Translations" ) ?>
						<small><?php echo __( "Manage translations" ) ?></small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>"><?php echo __( "Home" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="javascript:;"><?php echo __( "Settings" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "translations" ) ?>"><?php echo __( "Translations" ) ?></a>
							<i class="fa fa-angle-right"></i>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>

			<div class="row">
				<div class="col-md-12">
					<div class="center" style="margin-bottom: 10px;">
						<a href="?downloadSampleStrings" class="btn btn-primary"><i class="fa fa-download"></i> <?php _e( 'Download sample translation strings' ) ?>
						</a>
					</div>

					<?php $langs = $Trans->get_languages(); ?>
					<table class="table">
						<?php foreach ( $langs as $c => $lang ) { ?>
							<tr>
								<td>
									<?php echo $lang['label'] ?>
								</td>
								<td>
									<a href="<?php echo \Urls::get_file_url( $lang['lang_file'], true ) ?>">
										<?php _e( 'Download Language File' ) ?>
									</a>
								</td>
								<td>
									<a class="btn btn-primary upload_file_link" for="lang<?php echo $c ?>" href="#">
										<i class="fa fa-upload"></i>
										<?php _e( 'Upload Language File' ) ?>
									</a>
									<form id="formlang<?php echo $c ?>" style="display:none" method="post" action="<?php echo DOMAIN_URL ?>ajax/lang_file.php?upload">
										<input type="text" name="lang" value="<?php echo $c ?>">
										<input id="lang<?php echo $c ?>" class="file" type="file" name="lang<?php echo $c ?>" accept=".po">
									</form>
								</td>
							</tr>
						<?php } ?>
					</table>
					<?php //show_array($langs); ?>
				</div>
			</div>
		</div>
	</div>
	<!-- END CONTENT -->
</div>
<!-- END CONTAINER -->

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script>
	$( function() {
		$( document ).on( 'click', '.upload_file_link', function( e ) {
			e.preventDefault();
			let far = $( this ).attr( 'for' );
			$( '#' + far ).trigger( 'click' );
		} );
		$( document ).on( 'change', '.file', function( e ) {
			let id = 'form' + $( this ).attr( 'id' );

			$( '#' + id ).ajaxSubmit( {
				success: function( data ) {
					alert( data );
					$( '#' + id ).trigger( 'reset' );
				},
				error: function( e1, e2, e3 ) {
					Error( e3 );
					$( '#' + id ).trigger( 'reset' );
				}
			} );
		} )
	} )
</script>
</body>
<!-- END BODY -->
</html>