<?php
if ( ! defined( "ROOT_PATH" ) ) {
	echo "Hay! Don't cheat, We don't allow to view this file too. . :)";
	exit;
}
$title = "Weekly Evaulation Report";
include_once( __DIR__ . "/header.php" );
$BatchClass = new BatchClass;
$C          = $BatchClass->get_list();
?>

<!-- BEGIN CONTAINER -->
<div class="page-container">
	<!-- BEGIN SIDEBAR -->
	<?php include_once( __DIR__ . "/sidebar.php" ); ?>
	<!-- END SIDEBAR -->

	<!-- BEGIN CONTENT -->
	<div class="page-content-wrapper">
		<div class="page-content">
			<div class="row">
				<div class="col-md-12">
					<!-- BEGIN PAGE TITLE & BREADCRUMB-->
					<h3 class="page-title">
						Weekly Evaluation Report
						<small>Generate report</small>
					</h3>
					<ul class="page-breadcrumb breadcrumb">
						<!--li class="btn-group">
							<button type="button" class="btn blue dropdown-toggle" data-toggle="dropdown" data-hover="dropdown" data-delay="1000" data-close-others="true">
							<span>
								Actions
							</span>
							<i class="fa fa-angle-down"></i>
							</button>
							<ul class="dropdown-menu pull-right" role="menu">
								<li>
									<a href="#">Action</a>
								</li>
								<li>
									<a href="#">Another action</a>
								</li>
								<li>
									<a href="#">Something else here</a>
								</li>
								<li class="divider">
								</li>
								<li>
									<a href="#">Separated link</a>
								</li>
							</ul>
						</li-->
						<li>
							<i class="fa fa-home"></i>
							<a href="<?php echo DOMAIN_URL ?>">Home</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="#">Reports</a>
							<i class="fa fa-angle-right"></i>
						</li>
						<li>
							<a href="<?php echo Urls::get_url( "weekly_evaluation_report" ) ?>">Weekly Evaluation Report</a>
						</li>
					</ul>
					<!-- END PAGE TITLE & BREADCRUMB-->
				</div>
			</div>
			<!-- END PAGE HEADER-->
			<!-- BEGIN PAGE CONTENT-->
			<div class="row">
				<div class="col-md-12">
					<div class="portlet box blue">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-reorder"></i>Generate Report
							</div>
							<div class="tools">
								<a href="javascript:;" class="collapse"></a>
								<a href="#portlet-config" data-toggle="modal" class="config"></a>
								<a href="javascript:;" class="reload"></a>
								<a href="javascript:;" class="remove"></a>
							</div>
						</div>
						<div class="portlet-body form">
							<form target="_ems" id="form1" name="form1" action="<?php echo Urls::get_url( "download_weekly_evaluation_report" ) ?>" class="form-horizontal form-bordered">
								<div class="form-body">
									<div class="form-group">
										<label class="control-label col-md-3"><?php _e( "Select Class" ) ?></label>
										<div class="col-md-9">
											<select class="form-control select2" name="class_id">
												<?php foreach ( $C as $c ): ?>
													<option value="<?php echo $c["id"] ?>"><?php echo $c["class_name"] ?></option>
												<?php endforeach; ?>
											</select>
											<span class="help-block">
        										Select class
        									</span>
										</div>
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-md-3"><?php _e( "Test/Exam Schedule Date Range" ) ?></label>
									<div class="col-md-9">
										<div class="input-group">
											<input value="<?php echo date( "Y-m-01" ) ?>" required="required" type="date" class="form-control" name="from" placeholder="From Date">
											<span class="input-group-addon">
												<?php _e( "to" ) ?>
											</span>
											<input value="<?php echo date( "Y-m-06" ) ?>" required="required" type="date" class="form-control" name="to" placeholder="To Date">
										</div>
										<!-- /input-group -->
										<span class="help-block">
											<?php _e( "Select date range" ) ?>
										</span>
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-md-3"><?php _e( "Order By" ) ?></label>
									<div class="col-md-9">
										<div class="input-group date-picker input-daterange" data-date-format="<?php echo \Dates::date_format1_for_js(); ?>">
											<select class="form-control" name="orderby">
												<option value="">== <?php _e( "Default" ) ?> ==</option>
												<option value="name"><?php _e( "Student Name" ) ?></option>
												<option value="total"><?php _e( "Total Marks" ) ?></option>
												<option value="percentage"><?php _e( "Percentage" ) ?></option>
											</select>
											<span class="input-group-addon">
												<?php _e( "order" ) ?>
											</span>
											<select class="form-control" name="order">
												<option value="ASC"><?php _e( "Ascending" ) ?></option>
												<option value="DESC"><?php _e( "Descending" ) ?></option>
											</select>
										</div>
										<span class="help-block">
											<?php _e( "Change order of records" ) ?>
										</span>
									</div>
								</div>
								<div id="moresubjects"></div>
								<div class="form-actions fluid">
									<div class="col-md-offset-3 col-md-9">
										<div class="btn-group">
											<input type="submit" name="smsBtn" id="smsBtn" style="display: none;" />
											<button type="submit" name="viewBtn" class="btn green"><?php _e( "View Report" ) ?></button>
											<button type="button" onclick="SMS()" class="btn btn-info"><?php _e( "SMS Report" ) ?></button>
											<button type="submit" name="downBtn" class="btn blue"><?php _e( "Download Report" ) ?></button>
											<button type="submit" name="downBtn2" class="btn grey"><?php _e( "Download Empty Report" ) ?></button>
										</div>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>

<?php include_once( __DIR__ . "/footer.php" ); ?>

<script>
	function SMS() {
		bootbox.confirm( "Are you sure you want to send SMS report?<br>SMS messages will be queued in <a target='_blank' href='<?php echo Urls::get_url( "sms/queue" ) ?>'>SMS Queue</a>", function( result ) {
			if ( result==false ) {
				return;
			} else {
				$( "#smsBtn" ).click();
			}
		} );
	}
</script>
</body>
<!-- END BODY -->
</html>