/*! jQuery Mockjax
 * A Plugin providing simple and flexible mocking of ajax requests and responses
 * 
 * Version: 2.2.1
 * Home: https://github.com/jakerella/jquery-mockjax
 * Copyright (c) 2016 Jordan Kasper, formerly appendTo;
 * NOTE: This repository was taken over by Jordan Kasper (@jakerella) October, 2014
 * 
 * Dual licensed under the MIT or GPL licenses.
 * http://opensource.org/licenses/MIT OR http://www.gnu.org/licenses/gpl-2.0.html
 */
(function(a,b){if(typeof define==="function"&&define.amd&&define.amd.jQuery){define(["jquery"],function(c){return b(c,a)})}else{if(typeof exports==="object"){module.exports=b}else{return b(a.jQuery||a.$,a)}}}(this,function(h,m){var e=h.ajax,f=[],p=[],A=[],r=/=\?(&|$)/,u=(new Date()).getTime(),v=500;function q(E){if(m.DOMParser===undefined&&m.ActiveXObject){m.DOMParser=function(){};DOMParser.prototype.parseFromString=function(K){var J=new ActiveXObject("Microsoft.XMLDOM");J.async="false";J.loadXML(K);return J}}try{var G=(new DOMParser()).parseFromString(E,"text/xml");if(h.isXMLDoc(G)){var F=h("parsererror",G);if(F.length===1){throw new Error("Error: "+h(G).text())}}else{throw new Error("Unable to parse XML")}return G}catch(H){var I=(H.name===undefined?H:H.name+": "+H.message);h(document).trigger("xmlParseError",[I]);return undefined}}function i(E,F){D.debug(E,["Checking mock data against request data",E,F]);var G=true;if(h.isFunction(E)){return !!E(F)}if(typeof F==="string"){if(h.isFunction(E.test)){return E.test(F)}else{if(typeof E==="object"){F=g(F)}else{return E===F}}}h.each(E,function(H){if(F[H]===undefined){G=false;return G}else{if(typeof F[H]==="object"&&F[H]!==null){if(G&&h.isArray(F[H])){G=h.isArray(E[H])&&F[H].length===E[H].length}G=G&&i(E[H],F[H])}else{if(E[H]&&h.isFunction(E[H].test)){G=G&&E[H].test(F[H])}else{G=G&&(E[H]===F[H])}}}});return G}function g(L){var G,E,K,F,I={},J=String(L).split(/&/);for(G=0,E=J.length;G<E;++G){K=J[G];try{K=decodeURIComponent(K.replace(/\+/g," "));K=K.split(/=/)}catch(H){continue}if(I[K[0]]){if(!I[K[0]].splice){F=I[K[0]];I[K[0]]=[];I[K[0]].push(F)}I[K[0]].push(K[1])}else{I[K[0]]=K[1]}}D.debug(null,["Getting query params from string",L,I]);return I}function b(E,F){return E[F]===h.mockjaxSettings[F]}function y(F,I){if(h.isFunction(F)){return F(I)}if(h.isFunction(F.url.test)){if(!F.url.test(I.url)){return null}}else{var E=F.namespace||h.mockjaxSettings.namespace;if(!!E){var J=[E,F.url].join("/");J=J.replace(/(\/+)/g,"/");F.url=J}var H=F.url.indexOf("*");if(F.url!==I.url&&H===-1||!new RegExp(F.url.replace(/[-[\]{}()+?.,\\^$|#\s]/g,"\\$&").replace(/\*/g,".+")).test(I.url)){return null}}if(F.requestHeaders){if(I.headers===undefined){return null}else{var G=false;h.each(F.requestHeaders,function(L,M){var K=I.headers[L];if(K!==M){G=true;return false}});if(G){return null}}}if(F.data){if(!I.data||!i(F.data,I.data)){return null}}if(F&&F.type&&F.type.toLowerCase()!==I.type.toLowerCase()){return null}return F}function s(E){return typeof E==="number"&&E>=0}function B(G){if(h.isArray(G)&&G.length===2){var F=G[0];var E=G[1];if(s(F)&&s(E)){return Math.floor(Math.random()*(E-F))+F}}else{if(s(G)){return G}}return v}function j(F,H,E){D.debug(F,["Sending fake XHR request",F,H,E]);var G=(function(I){return function(){return(function(){this.status=F.status;this.statusText=F.statusText;this.readyState=1;var J=function(){this.readyState=4;var K;if(H.dataType==="json"&&(typeof F.responseText==="object")){this.responseText=JSON.stringify(F.responseText)}else{if(H.dataType==="xml"){if(typeof F.responseXML==="string"){this.responseXML=q(F.responseXML);this.responseText=F.responseXML}else{this.responseXML=F.responseXML}}else{if(typeof F.responseText==="object"&&F.responseText!==null){F.contentType="application/json";this.responseText=JSON.stringify(F.responseText)}else{this.responseText=F.responseText}}}if(typeof F.status==="number"||typeof F.status==="string"){this.status=F.status}if(typeof F.statusText==="string"){this.statusText=F.statusText}K=this.onload||this.onreadystatechange;if(h.isFunction(K)){if(F.isTimeout){this.status=-1}K.call(this,F.isTimeout?"timeout":undefined)}else{if(F.isTimeout){this.status=-1}}};if(h.isFunction(F.response)){if(F.response.length===2){F.response(E,function(){J.call(I)});return}else{F.response(E)}}J.call(I)}).apply(I)}})(this);if(F.proxy){D.info(F,["Retrieving proxy file: "+F.proxy,F]);e({global:false,url:F.proxy,type:F.proxyType,data:F.data,async:H.async,dataType:H.dataType==="script"?"text/plain":H.dataType,complete:function(I){F.responseXML=F.responseText=I.responseText;if(b(F,"status")){F.status=I.status}if(b(F,"statusText")){F.statusText=I.statusText}if(H.async===false){G()}else{this.responseTimer=setTimeout(G,B(F.responseTime))}}})}else{if(H.async===false){G()}else{this.responseTimer=setTimeout(G,B(F.responseTime))}}}function k(G,H,E,F){D.debug(G,["Creating new mock XHR object",G,H,E,F]);G=h.extend(true,{},h.mockjaxSettings,G);if(typeof G.headers==="undefined"){G.headers={}}if(typeof H.headers==="undefined"){H.headers={}}if(G.contentType){G.headers["content-type"]=G.contentType}return{status:G.status,statusText:G.statusText,readyState:1,open:function(){},send:function(){F.fired=true;j.call(this,G,H,E)},abort:function(){clearTimeout(this.responseTimer)},setRequestHeader:function(J,I){H.headers[J]=I},getResponseHeader:function(I){if(G.headers&&G.headers[I]){return G.headers[I]}else{if(I.toLowerCase()==="last-modified"){return G.lastModified||(new Date()).toString()}else{if(I.toLowerCase()==="etag"){return G.etag||""}else{if(I.toLowerCase()==="content-type"){return G.contentType||"text/plain"}}}}},getAllResponseHeaders:function(){var I="";if(G.contentType){G.headers["Content-Type"]=G.contentType}h.each(G.headers,function(K,J){I+=K+": "+J+"\n"});return I}}}function o(K,I,E){c(K);K.dataType="json";if(K.data&&r.test(K.data)||r.test(K.url)){w(K,I,E);var G=/^(\w+:)?\/\/([^\/?#]+)/,J=G.exec(K.url),H=J&&(J[1]&&J[1]!==location.protocol||J[2]!==location.host);K.dataType="script";if(K.type.toUpperCase()==="GET"&&H){var F=t(K,I,E);if(F){return F}else{return true}}}return null}function c(E){if(E.type.toUpperCase()==="GET"){if(!r.test(E.url)){E.url+=(/\?/.test(E.url)?"&":"?")+(E.jsonp||"callback")+"=?"}}else{if(!E.data||!r.test(E.data)){E.data=(E.data?E.data+"&":"")+(E.jsonp||"callback")+"=?"}}}function t(H,G,E){D.debug(G,["Performing JSONP request",G,H,E]);var F=E&&E.context||H,I=(h.Deferred)?(new h.Deferred()):null;if(G.response&&h.isFunction(G.response)){G.response(E)}else{if(typeof G.responseText==="object"){h.globalEval("("+JSON.stringify(G.responseText)+")")}else{if(G.proxy){D.info(G,["Performing JSONP proxy request: "+G.proxy,G]);e({global:false,url:G.proxy,type:G.proxyType,data:G.data,dataType:H.dataType==="script"?"text/plain":H.dataType,complete:function(J){h.globalEval("("+J.responseText+")");d(H,G,F,I)}});return I}else{h.globalEval("("+((typeof G.responseText==="string")?('"'+G.responseText+'"'):G.responseText)+")")}}}d(H,G,F,I);return I}function d(H,G,E,I){var F;setTimeout(function(){l(H,E,G);x(H,E);if(I){try{F=h.parseJSON(G.responseText)}catch(J){}I.resolveWith(E,[F||G.responseText]);D.log(G,["JSONP mock call complete",G,I])}},B(G.responseTime))}function w(H,G,E){var F=E&&E.context||H;var I=(typeof H.jsonpCallback==="string"&&H.jsonpCallback)||("jsonp"+u++);if(H.data){H.data=(H.data+"").replace(r,"="+I+"$1")}H.url=H.url.replace(r,"="+I+"$1");m[I]=m[I]||function(){l(H,F,G);x(H,F);m[I]=undefined;try{delete m[I]}catch(J){}};H.jsonpCallback=I}function l(G,E,F){if(G.success){G.success.call(E,F.responseText||"","success",{})}if(G.global){(G.context?h(G.context):h.event).trigger("ajaxSuccess",[{},G])}}function x(F,E){if(F.complete){F.complete.call(E,{statusText:"success",status:200},"success")}if(F.global){(F.context?h(F.context):h.event).trigger("ajaxComplete",[{},F])}if(F.global&&!--h.active){h.event.trigger("ajaxStop")}}function a(G,E){var K,J,I,H;D.debug(null,["Ajax call intercepted",G,E]);if(typeof G==="object"){E=G;G=undefined}else{E=E||{};E.url=G||E.url}J=h.ajaxSetup({},E);J.type=J.method=J.method||J.type;H=function(N,M){var L=E[N.toLowerCase()];return function(){if(h.isFunction(L)){L.apply(this,[].slice.call(arguments))}M["onAfter"+N]()}};for(var F=0;F<f.length;F++){if(!f[F]){continue}I=y(f[F],J);if(!I){D.debug(f[F],["Mock does not match request",G,J]);continue}if(h.mockjaxSettings.retainAjaxCalls){p.push(J)}D.info(I,["MOCK "+J.type.toUpperCase()+": "+J.url,h.ajaxSetup({},J)]);if(J.dataType&&J.dataType.toUpperCase()==="JSONP"){if((K=o(J,I,E))){return K}}E.crossDomain=false;I.cache=J.cache;I.timeout=J.timeout;I.global=J.global;if(I.isTimeout){if(I.responseTime>1){E.timeout=I.responseTime-1}else{I.responseTime=2;E.timeout=1}}if(h.isFunction(I.onAfterSuccess)){E.success=H("Success",I)}if(h.isFunction(I.onAfterError)){E.error=H("Error",I)}if(h.isFunction(I.onAfterComplete)){E.complete=H("Complete",I)}z(I,E);(function(N,O,L,M){K=e.call(h,h.extend(true,{},L,{xhr:function(){return k(N,O,L,M)}}))})(I,J,E,f[F]);return K}D.log(null,["No mock matched to request",G,E]);if(h.mockjaxSettings.retainAjaxCalls){A.push(E)}if(h.mockjaxSettings.throwUnmocked===true){throw new Error("AJAX not mocked: "+E.url)}else{return e.apply(h,[E])}}function z(H,F){if(!(H.url instanceof RegExp)){return}if(!H.hasOwnProperty("urlParams")){return}var E=H.url.exec(F.url);if(E.length===1){return}E.shift();var I=0,G=E.length,K=H.urlParams.length,L=Math.min(G,K),J={};for(I;I<L;I++){var M=H.urlParams[I];J[M]=E[I]}F.urlParams=J}function n(G){var I,E,J,H=[],F=G instanceof RegExp?function(K){return G.test(K)}:function(K){return G===K};for(I=0,E=f.length;I<E;I++){J=f[I];if(!F(J.url)){H.push(J)}else{D.log(J,["Clearing mock: "+(J&&J.url),J])}}return H}h.extend({ajax:a});var D={_log:function D(G,F,H){var E=h.mockjaxSettings.logging;if(G&&typeof G.logging!=="undefined"){E=G.logging}H=(H===0)?H:(H||C.LOG);F=(F.splice)?F:[F];if(E===false||E<H){return}if(h.mockjaxSettings.log){return h.mockjaxSettings.log(G,F[1]||F[0])}else{if(h.mockjaxSettings.logger&&h.mockjaxSettings.logger[h.mockjaxSettings.logLevelMethods[H]]){return h.mockjaxSettings.logger[h.mockjaxSettings.logLevelMethods[H]].apply(h.mockjaxSettings.logger,F)}}},debug:function(E,F){return D._log(E,F,C.DEBUG)},log:function(E,F){return D._log(E,F,C.LOG)},info:function(E,F){return D._log(E,F,C.INFO)},warn:function(E,F){return D._log(E,F,C.WARN)},error:function(E,F){return D._log(E,F,C.ERROR)}};var C={DEBUG:4,LOG:3,INFO:2,WARN:1,ERROR:0};h.mockjaxSettings={log:null,logger:m.console,logging:2,logLevelMethods:["error","warn","info","log","debug"],namespace:null,status:200,statusText:"OK",responseTime:v,isTimeout:false,throwUnmocked:false,retainAjaxCalls:true,contentType:"text/plain",response:"",responseText:"",responseXML:"",proxy:"",proxyType:"GET",lastModified:null,etag:"",headers:{etag:"IJF@H#@923uf8023hFO@I#H#","content-type":"text/plain"}};h.mockjax=function(F){if(h.isArray(F)){return h.map(F,function(G){return h.mockjax(G)})}var E=f.length;f[E]=F;D.log(F,["Created new mock handler",F]);return E};h.mockjax._logger=D;h.mockjax.clear=function(E){if(typeof E==="string"||E instanceof RegExp){f=n(E)}else{if(E||E===0){D.log(f[E],["Clearing mock: "+(f[E]&&f[E].url),f[E]]);f[E]=null}else{D.log(null,"Clearing all mocks");f=[]}}p=[];A=[]};h.mockjax.clearRetainedAjaxCalls=function(){p=[];A=[];D.debug(null,"Cleared retained ajax calls")};h.mockjax.handler=function(E){if(arguments.length===1){return f[E]}};h.mockjax.mockedAjaxCalls=function(){return p};h.mockjax.unfiredHandlers=function(){var G=[];for(var F=0,E=f.length;F<E;F++){var H=f[F];if(H!==null&&!H.fired){G.push(H)}}return G};h.mockjax.unmockedAjaxCalls=function(){return A};return h.mockjax}));