QUnit.module("placement");QUnit.test("elements() order",function(b){var a=$("#orderContainer"),c=$("#elementsOrder").validate({errorLabelContainer:a,wrap:"li"});b.deepEqual(c.elements().map(function(){return $(this).attr("id")}).get(),["order1","order2","order3","order4","order5","order6"],"elements must be in document order");c.form();b.deepEqual(a.children().map(function(){return $(this).attr("id")}).get(),["order1-error","order2-error","order3-error","order4-error","order5-error","order6-error"],"labels in error container must be in document order")});QUnit.test("error containers, simple",function(b){b.expect(14);var a=$("#simplecontainer"),c=$("#form").validate({errorLabelContainer:a,showErrors:function(){a.find("h3").html(jQuery.validator.format("There are {0} errors in your form.",this.size()));this.defaultShowErrors()}});c.prepareForm();b.ok(c.valid(),"form is valid");b.equal(a.find(".error:not(input)").length,0,"There should be no error labels");b.equal(a.find("h3").html(),"");c.prepareForm();c.errorList=[{message:"bar",element:{name:"foo"}},{message:"necessary",element:{name:"required"}}];b.ok(!c.valid(),"form is not valid after adding errors manually");c.showErrors();b.equal(a.find(".error:not(input)").length,2,"There should be two error labels");b.ok(a.is(":visible"),"Check that the container is visible");a.find(".error:not(input)").each(function(){b.ok($(this).is(":visible"),"Check that each label is visible")});b.equal(a.find("h3").html(),"There are 2 errors in your form.");c.prepareForm();b.ok(c.valid(),"form is valid after a reset");c.showErrors();b.equal(a.find(".error:not(input)").length,2,"There should still be two error labels");b.ok(a.is(":hidden"),"Check that the container is hidden");a.find(".error:not(input)").each(function(){b.ok($(this).is(":hidden"),"Check that each label is hidden")})});QUnit.test("error containers, with labelcontainer I",function(c){c.expect(16);var b=$("#container"),a=$("#labelcontainer"),d=$("#form").validate({errorContainer:b,errorLabelContainer:a,wrapper:"li"});c.ok(d.valid(),"form is valid");c.equal(b.find(".error:not(input)").length,0,"There should be no error labels in the container");c.equal(a.find(".error:not(input)").length,0,"There should be no error labels in the labelcontainer");c.equal(a.find("li").length,0,"There should be no lis labels in the labelcontainer");d.errorList=[{message:"bar",element:{name:"foo"}},{name:"required",message:"necessary",element:{name:"required"}}];c.ok(!d.valid(),"form is not valid after adding errors manually");d.showErrors();c.equal(b.find(".error:not(input)").length,0,"There should be no error label in the container");c.equal(a.find(".error:not(input)").length,2,"There should be two error labels in the labelcontainer");c.equal(a.find("li").length,2,"There should be two error lis in the labelcontainer");c.ok(b.is(":visible"),"Check that the container is visible");c.ok(a.is(":visible"),"Check that the labelcontainer is visible");a.find(".error:not(input)").each(function(){c.ok($(this).is(":visible"),"Check that each label is visible1");c.equal($(this).parent()[0].tagName.toLowerCase(),"li","Check that each label is wrapped in an li");c.ok($(this).parent("li").is(":visible"),"Check that each parent li is visible")})});QUnit.test("errorcontainer, show/hide only on submit",function(c){c.expect(14);var b=$("#container"),a=$("#labelcontainer"),d=$("#testForm1").bind("invalid-form.validate",function(){c.ok(true,"invalid-form event triggered called")}).validate({errorContainer:b,errorLabelContainer:a,showErrors:function(){b.html(jQuery.validator.format("There are {0} errors in your form.",this.numberOfInvalids()));c.ok(true,"showErrors called");this.defaultShowErrors()}});c.equal(b.html(),"","must be empty");c.equal(a.html(),"","must be empty");c.ok(!d.form(),"invalid form");c.equal(a.find(".error:not(input)").length,2);c.equal(b.html(),"There are 2 errors in your form.");c.ok(a.is(":visible"),"must be visible");c.ok(b.is(":visible"),"must be visible");$("#firstname").val("hix").keyup();$("#testForm1").triggerHandler("keyup",[jQuery.event.fix({type:"keyup",target:$("#firstname")[0]})]);c.equal(a.find(".error:visible").length,1);c.equal(b.html(),"There are 1 errors in your form.");$("#lastname").val("abc");c.ok(d.form(),"Form now valid, trigger showErrors but not invalid-form")});QUnit.test("test label used as error container",function(a){a.expect(8);var b=$("#testForm16"),c=$("#testForm16text");b.validate({errorPlacement:function(d,e){$("label[for='"+e.attr("id")+"']").append(d)},errorElement:"span"});a.ok(!c.valid());a.equal(c.next("label").contents().first().text(),"Field Label","container label isn't disrupted");a.hasError(c,"missing");a.ok(!c.attr("aria-describedby"),"field does not require aria-describedby attribute");c.val("foo");a.ok(c.valid());a.equal(c.next("label").contents().first().text(),"Field Label","container label isn't disrupted");a.ok(!c.attr("aria-describedby"),"field does not require aria-describedby attribute");a.noErrorFor(c)});QUnit.test("test error placed adjacent to descriptive label",function(a){a.expect(8);var b=$("#testForm16"),c=$("#testForm16text");b.validate({errorElement:"span"});a.ok(!c.valid());a.equal(b.find("label").length,1);a.equal(b.find("label").text(),"Field Label","container label isn't disrupted");a.hasError(c,"missing");c.val("foo");a.ok(c.valid());a.equal(b.find("label").length,1);a.equal(b.find("label").text(),"Field Label","container label isn't disrupted");a.noErrorFor(c)});QUnit.test("test descriptive label used alongside error label",function(a){a.expect(8);var b=$("#testForm16"),c=$("#testForm16text");b.validate({errorElement:"label"});a.ok(!c.valid());a.equal(b.find("label.title").length,1);a.equal(b.find("label.title").text(),"Field Label","container label isn't disrupted");a.hasError(c,"missing");c.val("foo");a.ok(c.valid());a.equal(b.find("label.title").length,1);a.equal(b.find("label.title").text(),"Field Label","container label isn't disrupted");a.noErrorFor(c)});QUnit.test("test custom errorElement",function(a){a.expect(4);var b=$("#userForm"),c=$("#username");b.validate({messages:{username:"missing"},errorElement:"label"});a.ok(!c.valid());a.hasError(c,"missing","Field should have error 'missing'");c.val("foo");a.ok(c.valid());a.noErrorFor(c,"Field should not have a visible error")});QUnit.test("test existing label used as error element",function(a){a.expect(4);var b=$("#testForm14"),c=$("#testForm14text");b.validate({errorElement:"label"});a.ok(!c.valid());a.hasError(c,"required");c.val("foo");a.ok(c.valid());a.noErrorFor(c)});QUnit.test("test existing non-label used as error element",function(a){a.expect(4);var b=$("#testForm15"),c=$("#testForm15text");b.validate({errorElement:"span"});a.ok(!c.valid());a.hasError(c,"required");c.val("foo");a.ok(c.valid());a.noErrorFor(c)});QUnit.test("test aria-describedby with input names contains CSS-selector meta-characters",function(a){var b=$("#testForm21"),c=$("#testForm21\\!\\#\\$\\%\\&\\'\\(\\)\\*\\+\\,\\.\\/\\:\\;\\<\\=\\>\\?\\@\\[\\\\\\]\\^\\`\\{\\|\\}\\~");a.equal(c.attr("aria-describedby"),undefined);b.validate({errorElement:"span",errorPlacement:function(){}});a.ok(!c.valid());a.equal(c.attr("aria-describedby"),"testForm21!#$%&'()*+,./:;<=>?@[\\]^`{|}~-error");c.val("some");c.trigger("keyup");c.val("something");c.trigger("keyup");a.equal(c.attr("aria-describedby"),"testForm21!#$%&'()*+,./:;<=>?@[\\]^`{|}~-error","`aria-describedby` should remain the same as before.");c.val("something something");c.trigger("keyup");a.ok(c.valid());a.equal(c.attr("aria-describedby"),"testForm21!#$%&'()*+,./:;<=>?@[\\]^`{|}~-error","`aria-describedby` should remain the same as before.")});QUnit.test("test existing non-error aria-describedby",function(a){a.expect(8);var b=$("#testForm17"),c=$("#testForm17text");a.equal(c.attr("aria-describedby"),"testForm17text-description");b.validate({errorElement:"span"});a.ok(!c.valid());a.equal(c.attr("aria-describedby"),"testForm17text-description testForm17text-error");a.hasError(c,"required");c.val("foo");a.ok(c.valid());a.noErrorFor(c);a.strictEqual($("#testForm17text-description").text(),"This is where you enter your data");a.strictEqual($("#testForm17text-error").text(),"","Error label is empty for valid field")});QUnit.test("test pre-assigned non-error aria-describedby",function(a){a.expect(7);var b=$("#testForm17"),c=$("#testForm17text");c.attr("aria-describedby","testForm17text-description testForm17text-error");b.validate({errorElement:"span"});a.ok(!c.valid());a.equal(c.attr("aria-describedby"),"testForm17text-description testForm17text-error");a.hasError(c,"required");c.val("foo");a.ok(c.valid());a.noErrorFor(c);a.strictEqual($("#testForm17text-description").text(),"This is where you enter your data");a.strictEqual($("#testForm17text-error").text(),"","Error label is empty for valid field")});QUnit.test("test id/name containing brackets",function(a){var b=$("#testForm18"),c=$("#testForm18\\[text\\]");b.validate({errorElement:"span"});b.valid();c.valid();a.hasError(c,"required")});QUnit.test("test id/name containing $",function(a){var b=$("#testForm19"),c=$("#testForm19\\$text");b.validate({errorElement:"span"});c.valid();a.hasError(c,"required")});QUnit.test("test id/name containing single quotes",function(a){var c=$("#testForm20").validate(),b=$("#testForm20\\[\\'textinput\\'\\]"),e=$("#testForm20\\[\\'checkboxinput\\'\\]"),d=$("#testForm20\\[\\'radioinput\\'\\]");c.form();a.equal(c.numberOfInvalids(),3,"There is three invalid elements");a.equal(c.invalidElements()[0],b[0],"The element should be invalid");a.equal(c.invalidElements()[1],e[0],"The text element should be invalid");a.equal(c.invalidElements()[2],d[0],"The text element should be invalid")});QUnit.test("#1632: Error hidden, but input error class not removed",function(b){var d=$("#testForm23").validate({rules:{box1:{required:{depends:function(){return !!$("#box2").val()}}},box2:{required:{depends:function(){return !!$("#box1").val()}}}}}),c=$("#box1"),a=$("#box2");c.val("something");d.form();b.equal(d.numberOfInvalids(),1,"There is only one invlid element");b.equal(d.invalidElements()[0],a[0],"The box2 element should be invalid");c.val("");d.form();b.equal(d.numberOfInvalids(),0,"There is no error");b.equal(a.hasClass("error"),false,"Box2 should not have an error class")});